/* ---------------------------------------------------------------------- //
    bolbas.h
// ---------------------------------------------------------------------- */

#define  WINAPI  __stdcall
#define  WINAPIV __cdecl

#define  LOCALF  static __stdcall
#define  LOCALFV static __cdecl

#ifdef __cplusplus
extern "C" {
#endif

// ---------------------------------------------------------------------- //

typedef __int8            I1B, _i08, _i8;
typedef unsigned __int8   U1B, _u08, _u8;
typedef __int16           I2B, _i16;
typedef unsigned __int16  U2B, _u16;
typedef __int32           I4B, _i32;
typedef unsigned __int32  U4B, _u32;
typedef __int64           I8B, _i64, INT64;
typedef unsigned __int64  U8B, _u64, UINT64;
typedef float             F4B, _f32;
typedef double            F8B, _f64;
typedef PVOID             P4B, _p32;

typedef const void * PCVOID;
typedef const int  * PCINT;
typedef const BYTE * PCBYTE;
typedef const WORD * PCWORD;
typedef const UINT * PCUINT;

#define  REAL  double

// ---------------------------------------------------------------------- //

#define  NELEM(a)  (sizeof(a) / sizeof(a[0]))

#define  MAKEUINT(l, h)  MAKELONG(l, h)

int  WINAPI sign(REAL d);
int  WINAPI iround(REAL d);

UINT WINAPI hash(PCSTR st, UINT hs);

UINT WINAPI nbound(UINT i, UINT n);

typedef struct {
  PVOID *ptr;
  int   len;
  int   cap;
  UINT  rsv;
} HMEM_;
typedef HMEM_ *HMEM;

PVOID WINAPI walloc(HMEM mb, UINT sz, BOOL clr);
PVOID WINAPI wrealloc(HMEM mb, PVOID pv, UINT sz);

BOOL WINAPI wfree(HMEM mb, PVOID pv);
void WINAPI wclear(HMEM mb);
BOOL WINAPI iswheap(HMEM mb, PVOID pv);

#define  MEMCAP  2048

PVOID WINAPI halloc(UINT sz, BOOL clr);
PVOID WINAPI hrealloc(PVOID pv, UINT sz);

BOOL WINAPI hfree(PVOID pv);
void WINAPI hclear(void);
BOOL WINAPI isheap(PVOID pv);

#define  TBUFSZ  8192
#define  UBUFSZ  262144
#define  MAXSTR  512

PVOID WINAPI talloc(UINT sz);
PVOID WINAPI ualloc(UINT sz);
PVOID WINAPI valloc(UINT sz);

// ---------------------------------------------------------------------- //

BOOL WINAPI isspc(int c);
BOOL WINAPI isctl(int c);
BOOL WINAPI isdig(int c);
BOOL WINAPI isodig(int c);
BOOL WINAPI isxdig(int c);
BOOL WINAPI isupr(int c);
BOOL WINAPI islwr(int c);
BOOL WINAPI isalp(int c);
BOOL WINAPI isalpx(int c);
BOOL WINAPI isaln(int c);
BOOL WINAPI isalnx(int c);
BOOL WINAPI isasc(int c);
BOOL WINAPI ishan(int c);
BOOL WINAPI isprn(int c);
BOOL WINAPI iszen1(int c);
BOOL WINAPI iszen2(int c);

BOOL WINAPI iszen(PCSTR st);

PSTR WINAPI spncpy(PSTR sd, PCSTR p1, PCSTR p2);
PSTR WINAPI strcpyn(PSTR sd, PCSTR ss, int n);
PSTR WINAPI strcpyx(PSTR sd, PCSTR ss, int n);

BOOL WINAPI nthzen1(PCSTR st, int n);
BOOL WINAPI nthyen(PCSTR st, int n);

PSTR WINAPI mbschr(PCSTR st, int c);
PSTR WINAPI mbsrchr(PCSTR st, int c);
UINT WINAPI mbslen(PCSTR st);

#define  STX_CASEINSENSITIVE   0x01
#define  STX_WIDTHINSENSITIVE  0x02

#define  STX_UPR  STX_CASEINSENSITIVE
#define  STX_ZEN  STX_WIDTHINSENSITIVE

PSTR WINAPI strfindx(PCSTR s1, PCSTR s2, int flg);

PSTR WINAPI strfind(PCSTR s1, PCSTR s2);
BOOL WINAPI strlfind(PCSTR s1, PCSTR s2);
BOOL WINAPI strrfind(PCSTR s1, PCSTR s2);
PSTR WINAPI strifind(PCSTR s1, PCSTR s2);
BOOL WINAPI strilfind(PCSTR s1, PCSTR s2);
BOOL WINAPI strirfind(PCSTR s1, PCSTR s2);
BOOL WINAPI strmatch(PCSTR s1, PCSTR s2);
int  WINAPI strcount(PCSTR s1, PCSTR s2);

PCSTR WINAPI tozen(PCSTR st);
PCSTR WINAPI tohan(PCSTR st);
PCSTR WINAPI toupr(PCSTR st);
PCSTR WINAPI tolwr(PCSTR st);
PCSTR WINAPI tohira(PCSTR st);
PCSTR WINAPI tokata(PCSTR st);
PCSTR WINAPI ltrim(PCSTR st);
PCSTR WINAPI rtrim(PCSTR st);
PCSTR WINAPI btrim(PCSTR st);
PCSTR WINAPI delspc(PCSTR st);
PCSTR WINAPI delctl(PCSTR st);
PCSTR WINAPI ctlspc(PCSTR st);
PCSTR WINAPI cipher(PCSTR st);
PCSTR WINAPI inscma(PCSTR st);
PCSTR WINAPI delcma(PCSTR st);

BOOL WINAPI strlike(PCSTR s1, PCSTR s2);
BOOL WINAPI strmlike(PCSTR s1, PCSTR s2);
BOOL WINAPI strllike(PCSTR s1, PCSTR s2);
BOOL WINAPI strrlike(PCSTR s1, PCSTR s2);

PCSTR WINAPI midstr(PCSTR st, int n1, int n2);
PCSTR WINAPI strrepl(PCSTR st, PCSTR s1, PCSTR s2);
PCSTR WINAPI strconc(PCSTR s1, PCSTR s2);

int  WINAPIV csprintf(PSTR st, PCSTR fmt, ...);
PCSTR WINAPIV format(PCSTR fmt, ...);
PCSTR WINAPIV cformat(PCSTR fmt, ...);

int  WINAPI ztoi(PCSTR st);
UINT WINAPI ztou(PCSTR st);
_i64 WINAPI ztoi64(PCSTR st);
_u64 WINAPI ztou64(PCSTR st);
REAL WINAPI ztof(PCSTR st);
int  WINAPI cztoi(PCSTR st);
UINT WINAPI cztou(PCSTR st);
_i64 WINAPI cztoi64(PCSTR st);
_u64 WINAPI cztou64(PCSTR st);
REAL WINAPI cztof(PCSTR st);

// ---------------------------------------------------------------------- //

BOOL WINAPI is_leap_year(int yr);
int  WINAPI days_of_month(int yr, int mo);

#define  DW_SUNDAY    0
#define  DW_MONDAY    1
#define  DW_TUESDAY   2
#define  DW_WEDNESDAY 3
#define  DW_THURSDAY  4
#define  DW_FRIDAY    5
#define  DW_SATURDAY  6

#define  DW_SUN  DW_SUNDAY
#define  DW_MON  DW_MONDAY
#define  DW_TUE  DW_TUESDAY
#define  DW_WED  DW_WEDNESDAY
#define  DW_THU  DW_THURSDAY
#define  DW_FRI  DW_FRIDAY
#define  DW_SAT  DW_SATURDAY

int  WINAPI day_of_week(int yr, int mo, int dy);

int  WINAPI date_serial(int yr, int mo, int dy);
int  WINAPI year(int sr);
int  WINAPI month(int sr);
int  WINAPI day(int sr);
int  WINAPI youbi(int sr);
int  WINAPI era_year(int sr);

int  WINAPI today(void);

#define  DD_YEAR   1
#define  DD_MONTH  2

#define  DD_YEA  DD_YEAR
#define  DD_MON  DD_MONTH

int  WINAPI date_diff(int s1, int s2, int sw);

int  WINAPI ztod(PCSTR st);
int  WINAPI ztod2(PCSTR st, int sr0);
int  WINAPI ztom(PCSTR st);

int  WINAPI dprintf(PSTR st, PCSTR fmt, int sr);
PCSTR WINAPI dformat(PCSTR fmt, int sr);

int  WINAPI time_serial(int hr, int mn, int sc);
int  WINAPI hour(int tm);
int  WINAPI minute(int tm);
int  WINAPI second(int tm);

int  WINAPI ztot(PCSTR st);

int  WINAPI tprintf(PSTR st, PCSTR fmt, int tm);
PCSTR WINAPI tformat(PCSTR fmt, int tm);

REAL WINAPI now(void);

REAL WINAPI ztodt(PCSTR st);

int  WINAPI dtprintf(PSTR st, PCSTR fmt, REAL dt);
PCSTR WINAPI dtformat(PCSTR fmt, REAL dt);

typedef struct {
  WORD  yr, mo, dw, dy;
  WORD  hr, mn, sc, ms;
} STMI;
typedef STMI * PSTMI;
typedef const STMI * PCSTMI;

void WINAPI get_system_time(PSTMI lp);
void WINAPI get_local_time(PSTMI lp);
UINT WINAPI get_tick_count(void);
void WINAPI wait_millisec(UINT ms);

typedef struct {
  DWORD ldt;
  DWORD hdt;
} FTMI;
typedef FTMI * PFTMI;
typedef const FTMI * PCFTMI;

int  WINAPI compare_file_time(PCFTMI ft1, PCFTMI ft2);
BOOL WINAPI file_time_to_system_time(PSTMI lp, PCFTMI ft);
BOOL WINAPI system_time_to_file_time(PFTMI ft, PCSTMI lp);

// ---------------------------------------------------------------------- //

#define  CHP_DIR   0x01
#define  CHP_NAME  0x02
#define  CHP_EXT   0x04

#define  CHP_NAM  CHP_NAME

int  WINAPI check_path(PCSTR nam);
PSTR WINAPI change_path(PSTR nam, PCSTR src, int flg);

//typedef PCVOID HANDLE;

//#define  GENERIC_READ   0x80000000
//#define  GENERIC_WRITE  0x40000000

//#define  CREATE_NEW     1
//#define  CREATE_ALWAYS  2
//#define  OPEN_EXISTING  3
//#define  OPEN_ALWAYS    4

#define  OP_READ       (GENERIC_READ|OPEN_EXISTING)
#define  OP_WRITE      (GENERIC_WRITE|CREATE_ALWAYS)
#define  OP_APPEND     (GENERIC_WRITE|OPEN_ALWAYS)
#define  OP_READWRITE  (GENERIC_READ|GENERIC_WRITE|OPEN_EXISTING)

#define  OP_RDO  OP_READ
#define  OP_WRI  OP_WRITE
#define  OP_APD  OP_APPEND
#define  OP_RDW  OP_READWRITE

HANDLE WINAPI open_file(PCSTR nam, UINT flg);
BOOL WINAPI close_file(HANDLE hf);

//#define  FILE_BEGIN     0
//#define  FILE_CURRENT   1
//#define  FILE_END       2

UINT WINAPI set_file_ptr(HANDLE hf, int ds, UINT md);
BOOL WINAPI set_end_of_file(HANDLE hf);

UINT WINAPI get_file_size(HANDLE hf);

BOOL WINAPI read_file(HANDLE hf, PVOID bf, UINT sz);
BOOL WINAPI write_file(HANDLE hf, PCVOID bf, UINT sz);

BOOL WINAPI read_line(HANDLE hf, PSTR bf, int sz);
BOOL WINAPI write_line(HANDLE hf, PCSTR bf);

typedef struct {
  DWORD atr;
  FTMI  cre;
  FTMI  acc;
  FTMI  wri;
  DWORD szh;
  DWORD szl;
  DWORD rs0;
  DWORD rs1;
  char  nam[260];
  char  alt[14];
  WORD  rs2;
} FFDI;
typedef FFDI * PFFDI;

HANDLE WINAPI find_first_file(PCSTR nam, PFFDI lp);
BOOL WINAPI find_next_file(HANDLE hf, PFFDI lp);
BOOL WINAPI find_close(HANDLE hf);

BOOL WINAPI path_exists(PCSTR dir);
BOOL WINAPI file_exists(PCSTR nam);

typedef struct {
  DWORD atr;
  FTMI  cre;
  FTMI  acc;
  FTMI  wri;
  DWORD szh;
  DWORD szl;
} FADI;
typedef FADI * PFADI;

BOOL WINAPI get_file_info(PCSTR nam, PFADI lp);
UINT WINAPI file_size(PCSTR nam);

BOOL WINAPI new_file(PCSTR nam);
BOOL WINAPI new_file_if_not_exists(PCSTR nam);
BOOL WINAPI move_file(PCSTR nam, PCSTR src);
BOOL WINAPI force_move_file(PCSTR nam, PCSTR src);
BOOL WINAPI copy_file(PCSTR nam, PCSTR src);
BOOL WINAPI delete_file(PCSTR nam);

BOOL WINAPI new_path(PCSTR dir);
BOOL WINAPI new_path_if_not_exists(PCSTR dir);
BOOL WINAPI move_file_to(PCSTR dir, PCSTR src);
BOOL WINAPI copy_file_to(PCSTR dir, PCSTR src);
void WINAPI get_working_path(PSTR dir, int sz);
BOOL WINAPI set_working_path(PCSTR dir);

void WINAPI get_user_name(PSTR nam, int sz);
void WINAPI get_computer_name(PSTR nam, int sz);

// ---------------------------------------------------------------------- //

typedef struct {
  PCSTR *ps;
  int   ni;
} ENMS;
typedef ENMS * PENMS;
typedef const ENMS * PCENMS;

PCSTR WINAPI enmstr(PCENMS ls, int va);
int  WINAPI srchenm(PCENMS ls, PCSTR st);

typedef struct {
  int   va;
  PCSTR st;
} CODI;
typedef CODI * PCODI;
typedef const CODI * PCCODI;

typedef struct {
  PCODI pv;
  int   ni;
} CODS;
typedef CODS * PCODS;
typedef const CODS * PCCODS;

PCSTR WINAPI codstr(PCCODS ls, int va);
int  WINAPI srchcod(PCCODS ls, PCSTR st);
int  WINAPI srchopr(PCCODS ls, PCSTR st);

// ---------------------------------------------------------------------- //

//typedef struct { int unused;} HWND_;
//typedef HWND_ * HWND;

enum {
  e_000, E_MEM, E_DAT, E_PAR, E_FIR, E_FIW, E_DIR, E_ALO, E_CAP, E_DLL, //  0-  9
  E_STK = 20,
         E_SEG, E_OPC, E_DIV, E_NUL, E_ORD, E_EXE, E_BCD, E_VER, E_PRO, // 20- 29
  E_NOA,                                                                // 30- 39
};

BOOL WINAPI register_error_descriptions(PCCODS ed);
PCSTR WINAPI error_description(int ec);
HWND WINAPI set_error_message_box_owner(HWND hwnd);
HWND WINAPI error_message_box_owner(void);
int  WINAPI set_error_message_index_base(int i);
int  WINAPI error_message_index_base(void);
void WINAPI set_error_log_file(PCSTR nam);
PCSTR WINAPI error_log_file(void);
int  WINAPI first_error(void);
int  WINAPI last_error(void);
void WINAPI reset_error(void);
BOOL WINAPI enable_error_reporting(void);
BOOL WINAPI disable_error_reporting(void);
BOOL WINAPI enable_error_logging(void);
BOOL WINAPI disable_error_logging(void);
PVOID WINAPI throw_error(PCSTR em, UINT er, PCSTR fn, UINT lo);

PSTR WINAPI error_reporting_message(PSTR msg, PCSTR em, UINT er, PCSTR fn, UINT lo);
PSTR WINAPI error_logging_message(PSTR msg, PCSTR em, UINT er, PCSTR fn, UINT lo);
BOOL WINAPI default_error_reporting(PCSTR em, UINT er, PCSTR fn, UINT lo);
BOOL WINAPI default_error_logging(PCSTR em, UINT er, PCSTR fn, UINT lo);

typedef BOOL (CALLBACK * FERR)(PCSTR em, UINT er, PCSTR fn, UINT lo);

void WINAPI override_error_handler(FERR fmsg, FERR flog);

#define  ierr(ec)               throw_error(MODNAM, MAKEUINT(ec, __LINE__), NULL, -1)
#define  ferr(ec, nam)          throw_error(MODNAM, MAKEUINT(ec, __LINE__), nam, -1)
#define  serr(ec, nam, ir, ic)  throw_error(MODNAM, MAKEUINT(ec, __LINE__), nam, MAKEUINT(ir, ic))

void WINAPI start_debug(BOOL rm);
void WINAPI stop_debug(void);
void WINAPI debug_reporting(PCSTR st);
void WINAPI debug_logging(PCSTR st);

#define  dmsg(st)  debug_reporting(st)
#define  dlog(st)  debug_logging(st)

// ---------------------------------------------------------------------- //

typedef struct {
  PVOID  ptr;
  int    len;
  int    cap;
  int    rsz;
} HBLK_;
typedef HBLK_ * HBLK;

HBLK WINAPI build_array(HBLK mb, PVOID pv, int len, int cap, int rsz);
HBLK WINAPI build_slice(HBLK mb, HBLK mx, int ir, int nr);
HBLK WINAPI set_array(HBLK mb, PVOID pv, int len);
HBLK WINAPI create_array(HBLK mb, PVOID pv, int len, int cap, int rsz);
void WINAPI delete_array(HBLK mb);

PVOID WINAPI iptr(HBLK mb, int ir);
BOOL WINAPI change_capacity(HBLK mb, int cap);
BOOL WINAPI add_item(HBLK mb, PCVOID pi);
PVOID WINAPI new_item(HBLK mb, PCVOID pi);
BOOL WINAPI remove_item(HBLK mb, PCVOID pi);

HBLK WINAPI CreateMemBlk(int cap, int rsz);
#define  CreateBinBlkX(cap, rsz)  CreateMemBlk(cap, rsz)
#define  CreateBinBlk(cap)  CreateMemBlk(cap, 1)
#define  CreateStrBlk(cap)  CreateBinBlk(cap)

void WINAPI DeleteMemBlk(HBLK mb);
#define  DeleteBinBlk(bb)  DeleteMemBlk(bb)
#define  DeleteStrBlk(sb)  DeleteBinBlk(sb)

HBLK WINAPI MakeMemBlk(PVOID pv, int cap, int rsz);
#define  MakeBinBlkX(pv, cap, rsz)  MakeMemBlk(pv, cap, rsz)
#define  MakeBinBlk(pv, cap)  MakeMemBlk(pv, cap, 1)
#define  MakeStrBlk(pv, cap)  MakeBinBlk(pv, cap)

HBLK WINAPI SelectBinBlk(HBLK bb);

PCVOID WINAPI stobin(PCVOID pv, int sz);

HBLK WINAPI SelectStrBlk(HBLK sb);

PCSTR WINAPI stostr(PCSTR st);
PCSTR WINAPI stoconc(PCSTR s1, PCSTR s2);

PCSTR WINAPI dirnam(PCSTR nam);
PCSTR WINAPI basnam(PCSTR nam);
PCSTR WINAPI basnamx(PCSTR nam);
PCSTR WINAPI adddir(PCSTR dir, PCSTR nam);
PCSTR WINAPI addext(PCSTR nam, PCSTR ext);

HBLK WINAPI CreateDArray(int cap, int rsz);
#define  DeleteDArray(mb)  DeleteMemBlk(mb)

int  WINAPI NItems(HBLK mb);
int  WINAPI ItemSize(HBLK mb);
PVOID WINAPI BPtr(HBLK mb);
#define  IPtr(mb, ir)  iptr(mb, ir)
PVOID WINAPI ItemPtr(HBLK mb, int ir);
BOOL WINAPI InsertItem(HBLK mb, int ir, PCVOID pi);
BOOL WINAPI InsertItems(HBLK mb, int ir, PCVOID pb, int nr);
BOOL WINAPI DeleteItem(HBLK mb, int ir);
BOOL WINAPI DeleteItems(HBLK mb, int ir, int nr);
#define  AddItem(mb, pi)  add_item(mb, pi)
#define  NewItem(mb, pi)  new_item(mb, pi)
#define  RemoveItem(mb, pi)  remove_item(mb, pi)
BOOL WINAPI AppendItems(HBLK mb, PCVOID pb, int nr);

typedef BOOL (CALLBACK * FSEL)(PCVOID pb, UINT pa);

int  WINAPI SearchItem(HBLK mb, int i0, FSEL fsel, UINT pa);
int  WINAPI CountItems(HBLK mb, FSEL fsel, UINT pa);
int  WINAPI SelectItems(HBLK mb, FSEL fsel, UINT pa);

typedef int  (CALLBACK * FSRT)(PCVOID p1, PCVOID p2, UINT pa);

void WINAPI SortItems(HBLK mb, FSRT fcmp, UINT pa);
void WINAPI RotateItemsLeft(HBLK mb, int ir, int nr);
void WINAPI RotateItemsRight(HBLK mb, int ir, int nr);
void WINAPI ReverseItems(HBLK mb, int ir, int nr);
void WINAPI MoveItemToFirst(HBLK mb, int ir);
void WINAPI MoveItemToLast(HBLK mb, int ir);

HBLK WINAPI CreateTXT(int cap);
#define  DeleteTXT(xb)  DeleteDArray(xb)
#define  UnloadTXT(xb)  DeleteTXT(xb)

HBLK WINAPI DuplicateTXT(HBLK xb);
HBLK WINAPI MakeTXT(PCSTR st);
HBLK WINAPI MoveTXT(HBLK xb, HBLK xx);
int  WINAPI CompareTXT(HBLK xb, HBLK xx);

HBLK WINAPI LoadTXT(HBLK xb, PCSTR nam);
BOOL WINAPI SaveTXT(HBLK xb, PCSTR nam);

UINT WINAPI RowExt(HBLK xb);
UINT WINAPI PtrRow(HBLK xb, PCSTR pc);
PSTR WINAPI RowPtr(HBLK xb, UINT rc);
int  WINAPI RowLen(HBLK xb, UINT rc);

UINT WINAPI CharPos(HBLK xb, UINT rc);
UINT WINAPI PrevPos(HBLK xb, UINT rc);
UINT WINAPI NextPos(HBLK xb, UINT rc);

PSTR WINAPI CopyStr(PSTR st, HBLK xb, UINT r1, UINT r2);
BOOL WINAPI InsertStr(HBLK xb, UINT rc, PCSTR st);
BOOL WINAPI DeleteStr(HBLK xb, UINT r1, UINT r2);
BOOL WINAPI AddStr(HBLK xb, PCSTR st);
UINT WINAPI SearchStr(HBLK xb, UINT r0, PCSTR st, int flg);
BOOL WINAPI ReplaceStr(HBLK xb, PCSTR s1, PCSTR s2);

// ---------------------------------------------------------------------- //

typedef REAL * PVEC;
typedef const REAL * PCVEC;

#define  VecCpyN(vr, vc, n)  ((PVEC)memcpy(vr, vc, (n) * sizeof(REAL)))
#define  VecTmpN(n)          ((PVEC)ualloc((n) * sizeof(REAL)))

typedef REAL * PMAT;
typedef const REAL * PCMAT;

#define  MatCpyN(mr, mt, n)  ((PMAT)memcpy(mr, mt, (n) * (n) * sizeof(REAL)))
#define  MatTmpN(n)          ((PMAT)ualloc((n) * (n) * sizeof(REAL)))

REAL WINAPI MatLudN(PMAT mr, PINT ip, PCMAT mt, int n);
BOOL WINAPI Equ1dNu(PVEC vr, PCMAT mt, PCVEC vc, int n);

// ---------------------------------------------------------------------- //

typedef int  (CALLBACK * FTKN)(PCSTR *pp, PBYTE bf, UINT pa);

typedef struct {
  FTKN  fspc;
  FTKN  fcns;
  FTKN  fstr;
  FTKN  fkwd;
  FTKN  fopr;
  UINT  pa;
} LEXI;
typedef LEXI * PLEXI;
typedef const LEXI * PCLEXI;

typedef struct { int unused;} HLEX_;
typedef HLEX_ * HLEX;

#define  LSTR  1027
#define  LTKN  32

HLEX WINAPI CreateParsEnv(PCLEXI li);
void WINAPI DeleteParsEnv(HLEX le);
HLEX WINAPI SelectParsEnv(HLEX le);

void WINAPI start(PCSTR pt);
void WINAPI restart(PCSTR pt);
PCSTR WINAPI bpos(void);
PCSTR WINAPI cpos(void);
PVOID WINAPI buf(void);

#define  TKN_ERR   0
#define  TKN_END   1
#define  TKN_U4B   6
#define  TKN_U8B   8
#define  TKN_F8B  10
#define  TKN_STR  11
#define  TKN_IDN  12
#define  TKN_OPR  32
#define  TKN_KWD  96

#define  TKN_U32  TKN_U4B
#define  TKN_U64  TKN_U8B
#define  TKN_F64  TKN_F8B

int  WINAPI token(void);
BOOL WINAPI token_is(int cd);
UINT WINAPI errpos(void);

// ---------------------------------------------------------------------- //

typedef void (CALLBACK * BFNC)(PBYTE sp);

void WINAPI fi_0(PBYTE sp);

typedef struct {
  BFNC  *fn;
  int   ni;
} BFNS;
typedef BFNS * PBFNS;
typedef const BFNS * PCBFNS;

BOOL WINAPI RegisterAPIs(PCBFNS bf);

typedef struct {
  int   ofs;
  WORD  asz;
  WORD  bsz;
} CFNI;
typedef CFNI * PCFNI;
typedef const CFNI * PCCFNI;

typedef struct {
  PCFNI fn;
  int   ni;
} CFNS;
typedef CFNS * PCFNS;
typedef const CFNS * PCCFNS;

typedef struct { int unused;} HEXE_;
typedef HEXE_ * HEXE;

HEXE WINAPI CreateExecEnv(int ssz, int dsz, int esz, PCBFNS bf, PCCFNS cf);
void WINAPI DeleteExecEnv(HEXE xe);

#define  REL_DAT  0x02000000
#define  REL_BSS  0x03000000
#define  REL_AUX  0x04000000

#define  FTP_BFN  0x20000000
#define  FTP_CFN  0x30000000

enum {
  end_v,    nop_v,    drp_i,    drp_d,    dup_i,    dup_d,    swp_i,    swp_d,   // 00-07
  swp_i_d,  swp_d_i,  jeq_i_0,  jne_i_0,  jan_i,    jor_i,    jmp_v,    psh_bs,  // 08-0F
  psh_c,    psh_b,    psh_s,    psh_w,    psh_i,    psh_l,    psh_f,    psh_d,   // 10-17
  psh_i_0,  psh_d_0,  psh_dw,   psh_du,   psh_ew,   psh_eu,   psh_fw,   psh_fu,  // 18-1F
  fch_c,    fch_b,    fch_s,    fch_w,    fch_i,    fch_l,    fch_f,    fch_d,   // 20-27
  bwn_i,    bwn_l,    bwa_i,    bwa_l,    bwo_i,    bwo_l,    bwx_i,    bwx_l,   // 28-2F
  poi_c,    poi_b,    poi_s,    poi_w,    poi_i,    poi_l,    poi_p,    cpy_p,   // 30-37
  add_i,    add_l,    add_d,    add_p_i,  add_i_p,  mul_i,    mul_l,    mul_d,   // 38-3F
  pod_c,    pod_b,    pod_s,    pod_w,    pod_i,    pod_l,    pod_p,    set_p_0, // 40-47
  sub_i,    sub_l,    sub_d,    sub_p_i,  sub_p,    div_i,    div_l,    div_d,   // 48-4F
  sto_c,    sto_s,    sto_i,    sto_l,    sto_f,    sto_d,    sto_c_v,  sto_s_v, // 50-57
  sto_i_v,  sto_l_v,  sto_f_v,  sto_d_v,  mod_i,    mod_l,    mkv_w,    mkv_u,   // 58-5F
  inc_c,    inc_s,    inc_i,    inc_l,    inc_p,    inc_c_v,  inc_s_v,  inc_i_v, // 60-67
  inc_l_v,  inc_p_v,  rsh_i,    rsh_u,    rsh_l,    rsh_g,    lsh_i,    lsh_l,   // 68-6F
  dec_c,    dec_s,    dec_i,    dec_l,    dec_p,    dec_c_v,  dec_s_v,  dec_i_v, // 70-77
  dec_l_v,  dec_p_v,  rsv7A,    rsv7B,    rsv7C,    rsv7D,    rsv7E,    rsv7F,   // 78-7F
  cfn_i,    cfn_d,    cfn_v,    bfn_i,    bfn_d,    bfn_v,    pfn_i,    pfn_d,   // 80-87
  pfn_v,    ret_i,    ret_d,    ret_v,    cmp_p,    neg_i,    neg_l,    neg_d,   // 88-8F
  cnv_i_c,  cnv_i_b,  cnv_i_s,  cnv_i_w,  cnv_i_l,  cnv_i_f,  cnv_i_d,  cnv_u_l, // 90-97
  cnv_u_d,  cnv_l_c,  cnv_l_b,  cnv_l_s,  cnv_l_w,  cnv_l_i,  cnv_l_u,  cnv_l_f, // 98-9F
  cnv_l_d,  cnv_g_d,  cnv_d_c,  cnv_d_b,  cnv_d_s,  cnv_d_w,  cnv_d_i,  cnv_d_u, // A0-A7
  cnv_d_l,  cnv_d_f,  cnv_si_l, cnv_si_d, cnv_su_l, cnv_su_d, cnv_sl_d, cnv_sg_d,// A8-AF
  lt_i,     lt_u,     lt_l,     lt_g,     lt_d,     lt_i_0,   lt_l_0,   lt_d_0,  // B0-B7
  le_i,     le_u,     le_l,     le_g,     le_d,     le_i_0,   le_l_0,   le_d_0,  // B8-BF
  gt_i,     gt_u,     gt_l,     gt_g,     gt_d,     gt_i_0,   gt_l_0,   gt_d_0,  // C0-C7
  ge_i,     ge_u,     ge_l,     ge_g,     ge_d,     ge_i_0,   ge_l_0,   ge_d_0,  // C8-CF
  eq_i,     eq_l,     eq_d,     eq_i_0,   eq_d_0,   ne_i,     ne_l,     ne_d,    // D0-D7
  ne_i_0,   ne_d_0,   ent_www,                                                   // D8-DA
};

typedef struct {
  PBYTE pb;
  int   sz;
} SEGS;
typedef SEGS * PSEGS;
typedef const SEGS * PCSEGS;

void WINAPI SetExecCS(HEXE xe, PCSEGS pc);
void WINAPI SetExecDS(HEXE xe, PCSEGS pd);
void WINAPI SetExecFS(HEXE xe, PCSEGS pf);

typedef struct {
  PINT  pi;
  int   ni;
} RELS;
typedef RELS * PRELS;
typedef const RELS * PCRELS;

void WINAPI RelocatePtr(HEXE xe, PCRELS pr);

void WINAPI CallExecX(PVOID pv, HEXE xe, int ofs, PCVOID arg, int asz, int bsz);
void WINAPI CallExecV(PVOID pv, HEXE xe, int ent, PCVOID arg, int asz);
void WINAPI CallExec(PVOID pv, HEXE xe, int ent, PCVOID arg);

#define  CT_I1B  0x01
#define  CT_U1B  0x02
#define  CT_I2B  0x03
#define  CT_U2B  0x04
#define  CT_I4B  0x05
#define  CT_U4B  0x06
#define  CT_I8B  0x07
#define  CT_U8B  0x08
#define  CT_F4B  0x09
#define  CT_F8B  0x0a

int  WINAPI oprval(int oc);
BYTE WINAPI oprsiz(int oc);

typedef struct {
  int   app;
  int   pro;
  int   ent;
  UINT  rsv;
  char  tit[32];
  char  dsc[64];
} BCDH;
typedef BCDH * PBCDH;

typedef struct { int unused;} HBCD_;
typedef HBCD_ * HBCD;

#define  DEFSSZ  65536

HBCD WINAPI CreateBCD(int app, int pro, int ent, int ssz, PCSEGS pc, PCSEGS pd, int esz, PCRELS pr);
void WINAPI DeleteBCD(HBCD hb);
BOOL WINAPI AttachBCD(HBCD hb);

HBCD WINAPI LoadBCD(PCSTR nam, int app, int pro, int ssz);
#define  UnloadBCD(hb)  DeleteBCD(hb)
BOOL WINAPI SaveBCD(PCSTR nam, HBCD hb, PCSTR tit, PCSTR dsc);

void WINAPI CallBCD(PVOID pv, HBCD hb, int ent, PCVOID arg);
void WINAPI ExecBCD(PVOID pv, HBCD hb, PCVOID arg);

// ---------------------------------------------------------------------- //

UINT WINAPI BOLBASVer(void);

BOOL WINAPI InitBOLBAS(UINT pa);
void WINAPI TermBOLBAS(void);

#ifdef __cplusplus
}
#endif

// ---------------------------------------------------------------------- //
