/* ---------------------------------------------------------------------- //
    boldbe.h
// ---------------------------------------------------------------------- */

#define  WINAPI  __stdcall
#define  WINAPIV __cdecl

#define  LOCALF  static __stdcall
#define  LOCALFV static __cdecl

#ifdef __cplusplus
extern "C" {
#endif

// ---------------------------------------------------------------------- //

PCVOID WINAPI I4BBox(int va);
PCVOID WINAPI I8BBox(_i64 va);
PCVOID WINAPI F4BBox(_f32 va);
PCVOID WINAPI F8BBox(REAL va);

#define  i32Box(va)  I4BBox(va)
#define  i64Box(va)  I8BBox(va)
#define  f32Box(va)  F4BBox(va)
#define  f64Box(va)  F8BBox(va)

#define  TID_I1B   1
#define  TID_U1B   2
#define  TID_I2B   3
#define  TID_U2B   4
#define  TID_I4B   5
#define  TID_U4B   6
#define  TID_I8B   7
#define  TID_U8B   8
#define  TID_F4B   9
#define  TID_F8B  10
#define  TID_STR  11
#define  TID_BIN  12
#define  TID_HEX  13
#define  TID_M4B  14
#define  TID_M8B  15
#define  TID_YMD  16
#define  TID_YMN  17
#define  TID_TIM  18
#define  TID_DTM  19
#define  TID_E1B  20
#define  TID_E2B  21
#define  TID_E4B  22
#define  TID_C1B  23
#define  TID_C2B  24
#define  TID_C4B  25
#define  TID_S1B  26
#define  TID_S2B  27
#define  TID_S4B  28
#define  TID_A1B  29
#define  TID_A2B  30
#define  TID_A4B  31
#define  TID_ASC  32
#define  TID_LIB  40

#define  TID_I08  TID_I1B
#define  TID_U08  TID_U1B
#define  TID_I16  TID_I2B
#define  TID_U16  TID_U2B
#define  TID_I32  TID_I4B
#define  TID_U32  TID_U4B
#define  TID_I64  TID_I8B
#define  TID_U64  TID_U8B
#define  TID_F32  TID_F4B
#define  TID_F64  TID_F8B
#define  TID_M32  TID_M4B
#define  TID_M64  TID_M8B
#define  TID_E08  TID_E1B
#define  TID_E16  TID_E2B
#define  TID_E32  TID_E4B
#define  TID_C08  TID_C1B
#define  TID_C16  TID_C2B
#define  TID_C32  TID_C4B
#define  TID_S08  TID_S1B
#define  TID_S16  TID_S2B
#define  TID_S32  TID_S4B
#define  TID_A08  TID_A1B
#define  TID_A16  TID_A2B
#define  TID_A32  TID_A4B

#define  TID_USER  64

#define  TID_USR  TID_USER

#define  STR(n)  MAKEUINT(TID_STR, n)
#define  BIN(n)  MAKEUINT(TID_BIN, n)
#define  ASC(n)  MAKEUINT(TID_ASC, n)

#define  CAL_BIT  0x80

#define  CAL(id)  ((id) | CAL_BIT)

#define  CAL_I1B  CAL(TID_I1B)
#define  CAL_U1B  CAL(TID_U1B)
#define  CAL_I2B  CAL(TID_I2B)
#define  CAL_U2B  CAL(TID_U2B)
#define  CAL_I4B  CAL(TID_I4B)
#define  CAL_U4B  CAL(TID_U4B)
#define  CAL_I8B  CAL(TID_I8B)
#define  CAL_U8B  CAL(TID_U8B)
#define  CAL_F4B  CAL(TID_F4B)
#define  CAL_F8B  CAL(TID_F8B)
#define  CAL_M4B  CAL(TID_M4B)
#define  CAL_M8B  CAL(TID_M8B)
#define  CAL_YMD  CAL(TID_YMD)
#define  CAL_YMN  CAL(TID_YMN)
#define  CAL_E1B  CAL(TID_E1B)
#define  CAL_E2B  CAL(TID_E2B)
#define  CAL_E4B  CAL(TID_E4B)
#define  CAL_C1B  CAL(TID_C1B)
#define  CAL_C2B  CAL(TID_C2B)
#define  CAL_C4B  CAL(TID_C4B)
#define  CAL_S1B  CAL(TID_S1B)
#define  CAL_S2B  CAL(TID_S2B)
#define  CAL_S4B  CAL(TID_S4B)
#define  CAL_A1B  CAL(TID_A1B)
#define  CAL_A2B  CAL(TID_A2B)
#define  CAL_A4B  CAL(TID_A4B)

#define  CAL_I32  CAL_I4B
#define  CAL_F64  CAL_F8B
#define  CAL_M32  CAL_M4B
#define  CAL_M64  CAL_M8B
#define  CAL_E32  CAL_E4B
#define  CAL_C32  CAL_C4B
#define  CAL_S32  CAL_S4B

#define  ITP(id, bt)  MAKEWORD(id, bt)

#define  WID_DEFAULT    0
#define  WID_HIDE       0
#define  WID_FORCEHIDE  255

#define  WID_DEF  WID_DEFAULT
#define  WID_HID  WID_HIDE
#define  WID_FRC  WID_FORCEHIDE

#define  ALN_DEFAULT    0
#define  ALN_LEFT       0
#define  ALN_CENTER     1
#define  ALN_RIGHT      2
#define  ALN_FORCELEFT  255

#define  ALN_DEF  ALN_DEFAULT
#define  ALN_LFT  ALN_LEFT
#define  ALN_CEN  ALN_CENTER
#define  ALN_RGT  ALN_RIGHT
#define  ALN_FRC  ALN_FORCELEFT

#define  ATR(wd, al)  MAKEWORD(wd, al)
#define  ALT(id, ic)  MAKEUINT(id, ic)
#define  RKY(id, ic)  MAKEUINT(id, ic)

typedef struct COLI * PCOLI;
typedef const struct COLI * PCCOLI;

typedef PVOID (CALLBACK * FSCN)(PVOID pv, PCSTR st, PCCOLI co);
typedef PSTR  (CALLBACK * FPRN)(PSTR st, PCVOID pv, PCCOLI co);
typedef int   (CALLBACK * FCMP)(PCVOID p1, PCVOID p2, PCCOLI co);
typedef UINT  (CALLBACK * FLST)(int im, PCCOLI co);

typedef struct {
  int   itp;
  int   atr;
  FSCN  fscn;
  FPRN  fprn;
  FCMP  fcmp;
  FLST  flst;
  UINT  pa0;
  UINT  pa1;
  UINT  pa2;
  int   flg;
} TYPI;
typedef TYPI * PTYPI;
typedef const TYPI * PCTYPI;

BOOL WINAPI RegisterColumnType(PCTYPI pe);

#define  CF_ALLOWCTL        0x00000001
#define  CF_DELCTL          0x00000002
#define  CF_LTRIM           0x00000004
#define  CF_RTRIM           0x00000008
#define  CF_DELSPC          0x00000010
#define  CF_HANKAKU         0x00000020
#define  CF_ZENKAKU         0x00000040
#define  CF_HIDEZERO        0x00000080
#define  CF_HIDECHAR        0x00000100
#define  CF_READONLY        0x00000200
#define  CF_DROPDOWNLIST    0x00000400
#define  CF_DROPDOWN        0x00000800
#define  CF_LINK            0x00001000
#define  CF_DISABLEEDITING  0x00002000
#define  CF_GRID1           0x00004000
#define  CF_GRID2           0x00008000
#define  CF_GRID3           0x00010000
#define  CF_PACK            0x00020000
#define  CF_PRIMARYKEY      0x00040000
#define  CF_REFERENCES      0x00080000
#define  CF_NOTZERO         0x00100000
#define  CF_UNIQUE          0x00200000
#define  CF_OVERRIDECALC    0x00400000
#define  CF_OVERRIDECHECK   0x00800000
#define  CF_OVERRIDESCAN    0x01000000
#define  CF_OVERRIDEPRINT   0x02000000
#define  CF_OVERRIDECOMPARE 0x04000000
#define  CF_OVERRIDELIST    0x08000000

#define  CF_ACT  CF_ALLOWCTL
#define  CF_DCT  CF_DELCTL
#define  CF_LTR  CF_LTRIM
#define  CF_RTR  CF_RTRIM
#define  CF_DSP  CF_DELSPC
#define  CF_HAN  CF_HANKAKU
#define  CF_ZEN  CF_ZENKAKU
#define  CF_HZR  CF_HIDEZERO
#define  CF_HCH  CF_HIDECHAR
#define  CF_RDO  CF_READONLY
#define  CF_DDL  CF_DROPDOWNLIST
#define  CF_DDN  CF_DROPDOWN
#define  CF_LNK  CF_LINK
#define  CF_DED  CF_DISABLEEDITING
#define  CF_GR1  CF_GRID1
#define  CF_GR2  CF_GRID2
#define  CF_GR3  CF_GRID3
#define  CF_PAC  CF_PACK
#define  CF_KEY  CF_PRIMARYKEY
#define  CF_REF  CF_REFERENCES
#define  CF_NZR  CF_NOTZERO
#define  CF_UNI  CF_UNIQUE
#define  CF_OCL  CF_OVERRIDECALC
#define  CF_OCK  CF_OVERRIDECHECK
#define  CF_OSC  CF_OVERRIDESCAN
#define  CF_OPR  CF_OVERRIDEPRINT
#define  CF_OCM  CF_OVERRIDECOMPARE
#define  CF_OLS  CF_OVERRIDELIST

typedef PVOID (CALLBACK * FCAL)(PVOID pv, PCVOID pb, PCCOLI co);
typedef BOOL  (CALLBACK * FCHK)(PCVOID pb, PCCOLI co);

typedef struct COLI {
  int   itp;
  int   atr;
  PCSTR nam;
  PCSTR tit;
  PCSTR dsc;
  int   flg;
  FCAL  fcal;
  FCHK  fchk;
  UINT  pa0;
  UINT  pa1;
  UINT  pa2;
  UINT  pa3;
} COLI;

typedef struct {
  PCOLI co;
  int   nc;
} COLS;
typedef COLS * PCOLS;
typedef const COLS * PCCOLS;

PVOID WINAPI ColumnScan(PVOID pv, PCSTR st, PCCOLI co);
PSTR WINAPI ColumnPrint(PSTR st, PCVOID pv, PCCOLI co);
UINT WINAPI ColumnList(int im, PCCOLI co);

PCVOID WINAPI VPtr(PCVOID pb, PCCOLI co);

BOOL WINAPI isidn(PCSTR st);

// ---------------------------------------------------------------------- //

typedef struct { int unused;} HTBL_;
typedef HTBL_ * HTBL;

HTBL WINAPI CHTBL(PCCOLI co);

#define  TF_READONLY        0x0001
#define  TF_FIXEDLEN        0x0002
#define  TF_IMPORT          0x0010
#define  TF_ENCRYPT         0x0020
#define  TF_DISABLETRIGGER  0x0040
#define  TF_NOALIGN         0x0080
#define  TF_STATIC          0x0100
#define  TF_STATICROWBUF    0x0200
#define  TF_VIEW            0x0400
#define  TF_TEMPORARY       0x0800
#define  TF_OVERRIDETRIGGER 0x1000

#define  TF_RDO  TF_READONLY
#define  TF_FIX  TF_FIXEDLEN
#define  TF_IMP  TF_IMPORT
#define  TF_CYP  TF_ENCRYPT
#define  TF_DTR  TF_DISABLETRIGGER
#define  TF_NOA  TF_NOALIGN
#define  TF_STA  TF_STATIC
#define  TF_STB  TF_STATICROWBUF
#define  TF_VIW  TF_VIEW
#define  TF_TMP  TF_TEMPORARY
#define  TF_OTR  TF_OVERRIDETRIGGER

typedef BOOL (CALLBACK * FTRG)(HTBL tb, int msg, int ir, PVOID pb);

typedef struct {
  PCSTR nam;
  int   fc;
  PCSTR arr;
  PCSTR cnd;
  PCSTR srt;
} VIWI;
typedef VIWI * PVIWI;
typedef const VIWI * PCVIWI;

typedef struct VIWS {
  PVIWI vi;
  int   ni;
} VIWS;
typedef VIWS * PVIWS;
typedef const VIWS * PCVIWS;

typedef struct {
  PCOLS cs;
  PVIWS vs;
  PCSTR nam;
  PCSTR tit;
  PCSTR dsc;
  int   flg;
  FTRG  ftrg;
  PCSTR imp;
  UINT  ext;
  UINT  rsz;
} TBLI;
typedef TBLI * PTBLI;
typedef const TBLI * PCTBLI;

HTBL WINAPI CreateTableX(PVOID pv, int len, int cap, PCTBLI ti);
HTBL WINAPI CreateTable(int cap, PCTBLI ti);
void WINAPI DeleteTable(HTBL tb);

int  WINAPI NTableKeys(HTBL tb);
int  WINAPI NTableRefs(HTBL tb, PINT pi);

HTBL WINAPI CreateCompatibleTable(HTBL tb, int cap);
BOOL WINAPI IsCompatible(HTBL tb, HTBL tx);
HTBL WINAPI DuplicateTable(HTBL tb);

int  WINAPI TableRowSize(HTBL tb);
int  WINAPI NTableRows(HTBL tb);

PVOID WINAPI TablePtr(HTBL tb);
PVOID WINAPI TableRow(HTBL tb, int ir);
int  WINAPI TableRowIndex(HTBL tb, PCVOID pb);

int  WINAPI TableCapacity(HTBL tb);
BOOL WINAPI ChangeTableCapacity(HTBL tb, int cap);

PCSTR WINAPI TableName(HTBL tb);
void WINAPI SetTableTitle(HTBL tb, PCSTR tit);
PCSTR WINAPI TableTitle(HTBL tb);

void WINAPI SetTableDescription(HTBL tb, PCSTR dsc);
PCSTR WINAPI TableDescription(HTBL tb);

void WINAPI SetTableFlags(HTBL tb, int flg);
int  WINAPI TableFlags(HTBL tb);

void WINAPI SetTableFileName(HTBL tb, PCSTR nam);
PCSTR WINAPI TableFileName(HTBL tb);

void WINAPI SetTableExtra(HTBL tb, UINT pa);
UINT WINAPI TableExtra(HTBL tb);

#define  TRGM_BEFOREUPDATEOF  1
#define  TRGM_AFTERUPDATEOF   2
#define  TRGM_BEFOREUPDATE    3
#define  TRGM_AFTERUPDATE     4
#define  TRGM_AFTERINSERT     6
#define  TRGM_BEFOREDELETE    7
#define  TRGM_CHECK           TRGM_BEFOREUPDATE
#define  TRGM_DEFAULT         TRGM_AFTERINSERT
#define  TRGM_UPDATERECORD   11
#define  TRGM_INSERTRECORD   12
#define  TRGM_DELETERECORD   13

BOOL WINAPI DefaultTableTrigger(HTBL tb, int msg, int ir, PVOID pb);
BOOL WINAPI TableTrigger(HTBL tb, int msg, int ir, PVOID pb);

BOOL WINAPI EnableTableTrigger(HTBL tb);
BOOL WINAPI DisableTableTrigger(HTBL tb);

int  WINAPI NTableColumns(HTBL tb);

PCCOLI WINAPI TableColumnInfo(HTBL tb, int ic);

void WINAPI SetTableColumnWidth(HTBL tb, int ic, int wd);
int  WINAPI TableColumnWidth(HTBL tb, int ic);

void WINAPI SetTableColumnTextAlign(HTBL tb, int ic, int al);
int  WINAPI TableColumnTextAlign(HTBL tb, int ic);

int  WINAPI TableColumnOffset(HTBL tb, int ic);
PCSTR WINAPI TableColumnName(HTBL tb, int ic);
int  WINAPI TableColumnIndex(HTBL tb, PCSTR nam);

void WINAPI SetTableColumnTitle(HTBL tb, int ic, PCSTR tit);
PCSTR WINAPI TableColumnTitle(HTBL tb, int ic);

void WINAPI SetTableColumnDescription(HTBL tb, int ic, PCSTR dsc);
PCSTR WINAPI TableColumnDescription(HTBL tb, int ic);

void WINAPI SetTableColumnFlags(HTBL tb, int ic, int flg);
int  WINAPI TableColumnFlags(HTBL tb, int ic);

void WINAPI SetTableColumnExtra(HTBL tb, int ic, UINT pa);
UINT WINAPI TableColumnExtra(HTBL tb, int ic);

BOOL WINAPI SetTableCellValue(HTBL tb, int ir, int ic, PCVOID pv);
PVOID WINAPI GetTableCellValue(PVOID pv, HTBL tb, int ir, int ic);
BOOL WINAPI ScanTableCellValue(HTBL tb, int ir, int ic, PCSTR st);
PSTR WINAPI PrintTableCellValue(PSTR st, HTBL tb, int ir, int ic);

BOOL WINAPI ClearTableRow(HTBL tb, int ir);
BOOL WINAPI ClearTableRows(HTBL tb, int ir, int nr);
BOOL WINAPI InsertTableRow(HTBL tb, int ir);
BOOL WINAPI InsertTableRows(HTBL tb, int ir, int nr);
BOOL WINAPI DeleteTableRow(HTBL tb, int ir);
BOOL WINAPI DeleteTableRows(HTBL tb, int ir, int nr);
BOOL WINAPI AddTableRow(HTBL tb);

PVOID WINAPI NewTableRow(HTBL tb);

HTBL WINAPI CopyTable(HTBL tb, HTBL tx);
HTBL WINAPI MergeTableX(HTBL tb, HTBL tx);

int  WINAPI CompareTable(HTBL tb, HTBL tx);

int  WINAPI SearchTableRowX(HTBL tb, int i0, FSEL fsel, UINT pa);
int  WINAPI CountTableRowsX(HTBL tb, FSEL fsel, UINT pa);
int  WINAPI SelectTableRowsX(HTBL tb, FSEL fsel, UINT pa);

HTBL WINAPI SelectCopyTableX(HTBL tb, HTBL tx, FSEL fsel, UINT pa);
HTBL WINAPI SelectMergeTableX(HTBL tb, HTBL tx, FSEL fsel, UINT pa);

typedef BOOL (CALLBACK * FAGG)(PCVOID pb, UINT pa);

int  WINAPI AggregateTableX(HTBL tb, FSEL fsel, UINT ps, FAGG fagg, UINT pa);

void WINAPI SortTableRowsX(HTBL tb, FSRT fcmp, UINT pa);

int  WINAPI SearchTableCellValue(HTBL tb, int i0, int ic, PCVOID pv);

#define  STX_CASEINSENSITIVE   0x01
#define  STX_WIDTHINSENSITIVE  0x02
#define  STX_SPACEINSENSITIVE  0x04
#define  STX_WHOLEWORDS        0x08
#define  STX_PREFIX            0x10
#define  STX_SUFFIX            0x20

#define  STX_UPR  STX_CASEINSENSITIVE
#define  STX_ZEN  STX_WIDTHINSENSITIVE
#define  STX_DSP  STX_SPACEINSENSITIVE
#define  STX_ALL  STX_WHOLEWORDS
#define  STX_LFT  STX_PREFIX
#define  STX_RGT  STX_SUFFIX

int  WINAPI SearchTableCellText(HTBL tb, int i0, int ic, PCSTR st, int flg);

int  WINAPI SearchAlt(HTBL tb, int ic, PCSTR st);

BOOL WINAPI CheckTable(HTBL tb);

BOOL WINAPI LoadBTB(HTBL tb);
BOOL WINAPI SaveBTB(HTBL tb);

BOOL WINAPI OpenBTB(HTBL tb);
BOOL WINAPI CloseBTB(HTBL tb, BOOL sv);

void WINAPI OverrideTableTrigger(HTBL tb, FTRG ftrg);

HTBL WINAPI CreateARRTable(int cap, HTBL tb);
BOOL WINAPI ScanARRTable(HTBL ta, PCSTR arr);
PSTR WINAPI PrintARRTable(PSTR arr, HTBL ta);
void WINAPI InsertARRTableRow(HTBL ta, int i1, int i2);
int  WINAPI DeleteARRTableRow(HTBL ta, int i1);

#define  VIWCAP 10

HTBL WINAPI CreateCNDTable(int cap, HTBL tb);
BOOL WINAPI ScanCNDTable(HTBL tc, PCSTR cnd);
PSTR WINAPI PrintCNDTable(PSTR cnd, HTBL tc);

HTBL WINAPI CreateSRTTable(int cap, HTBL tb);
BOOL WINAPI ScanSRTTable(HTBL ts, PCSTR srt);
PSTR WINAPI PrintSRTTable(PSTR srt, HTBL ts);

HTBL WINAPI CreateGRPTable(int cap, HTBL tb);
BOOL WINAPI ScanGRPTable(HTBL tg, PCSTR grp);
PSTR WINAPI PrintGRPTable(PSTR grp, HTBL tg);

// ---------------------------------------------------------------------- //

typedef struct { int unused;} HBUF_;
typedef HBUF_ * HBUF;

HBUF WINAPI CreateRowBufX(PVOID pv, PCTBLI ti);
HBUF WINAPI CreateRowBuf(HTBL tb);
void WINAPI DeleteRowBuf(HBUF rb);

HBUF WINAPI DuplicateRowBuf(HBUF rb);

HTBL WINAPI RowBufHTBL(HBUF rb);
PVOID WINAPI RowBufPtr(HBUF rb);

HBUF WINAPI MakeRowBuf(HTBL tb, PVOID pb);
HBUF WINAPI TableRowBuf(HTBL tb, int ir);
HBUF WINAPI NewTableRowBuf(HTBL tb);

BOOL WINAPI SetRowBufCellValue(HBUF rb, int ic, PCVOID pv);
PVOID WINAPI GetRowBufCellValue(PVOID pv, HBUF rb, int ic);
BOOL WINAPI ScanRowBufCellValue(HBUF rb, int ic, PCSTR st);
PSTR WINAPI PrintRowBufCellValue(PSTR st, HBUF rb, int ic);

BOOL WINAPI ClearRowBuf(HBUF rb);

HBUF WINAPI CopyRowBuf(HBUF rb, HBUF rx);
BOOL WINAPI SetTableRow(HTBL tb, int ir, HBUF rb);
HBUF WINAPI GetTableRow(HBUF rb, HTBL tb, int ir);
BOOL WINAPI SetNewTableRow(HTBL tb, HBUF rb);
HBUF WINAPI CopyValues(HBUF rb, HBUF rx);

HBUF WINAPI CopyKey(HBUF rb, HBUF rx);

int  WINAPI CompareRowBuf(HBUF rb, HBUF rx);

int  WINAPI SearchKey(HTBL tb, HBUF rb);

HTBL WINAPI MergeTable(HTBL tb, HTBL tx);

int  WINAPI UniqueKey(HTBL tb, int ic, UINT h0, UINT hs);

int  WINAPI SearchTableRow(HTBL tb, int i0, PCSTR cnd);
int  WINAPI CountTableRows(HTBL tb, PCSTR cnd);
int  WINAPI SelectTableRows(HTBL tb, PCSTR cnd);

HTBL WINAPI SelectCopyTable(HTBL tb, HTBL tx, PCSTR cnd);
HTBL WINAPI SelectMergeTable(HTBL tb, HTBL tx, PCSTR cnd);

#define  AGG_SUM  1
#define  AGG_AVG  2
#define  AGG_MAX  3
#define  AGG_MIN  4
#define  AGG_COU  5
#define  AGG_GRP 10

REAL WINAPI AggregateTable(HTBL tb, int ic, int sw, PCSTR cnd);

void WINAPI SortTableRows(HTBL tb, PCSTR srt);

HTBL WINAPI CreateSummaryV(HTBL tb, PCSTR grp, PCSTR cnd, PCSTR srt);

BOOL WINAPI IsConflict(HTBL tb, HTBL tx);
BOOL WINAPI IsDependent(HTBL tb, int i1, int i2, PCVOID p1, PCVOID p2);

typedef struct {
  char  nam[32];
  BYTE  ud;
  BYTE  us;
  WORD  fc;
  char  arr[510];
  char  cnd[320];
  char  srt[320];
} VIWE;
typedef VIWE * PVIWE;

HTBL WINAPI CreateVIWTable(int cap, PCVIWS vs);

PVIWI WINAPI SetVIWInfo(PVIWI vi, HBUF bv);
int  WINAPI SearchVIWTableRow(HTBL tv, HBUF bv);
int  WINAPI SearchVIWTableRowByName(HTBL tv, PCSTR nam);
void WINAPI SetLastVIW(HTBL tv, HBUF bv);
int  WINAPI GetLastVIW(HTBL tv);
void WINAPI CopyUserVIWTable(HTBL tv, HTBL tx);

// ---------------------------------------------------------------------- //

typedef struct { int unused;} HVIW_;
typedef HVIW_ * HVIW;

typedef struct {
  PINT  pi;
  int   ni;
} IDXS;
typedef IDXS * PIDXS;
typedef const IDXS * PCIDXS;

HVIW WINAPI CreateViewX(HTBL tb, PCIDXS pa, FSEL fsel, UINT ps, FSRT fcmp, UINT pc);
HVIW WINAPI CreateView(HTBL tb, PCSTR arr, PCSTR cnd, PCSTR srt);
void WINAPI DeleteView(HVIW vw);

HTBL WINAPI ViewHTBL(HVIW vw);

int  WINAPI NViewRows(HVIW vw);

PVOID WINAPI ViewRow(HVIW vw, int ir);
int  WINAPI ViewRowIndex(HVIW vw, int ir);

int  WINAPI NViewColumns(HVIW vw);

PCCOLI WINAPI ViewColumnInfo(HVIW vw, int ic);

void WINAPI SetViewColumnWidth(HVIW vw, int ic, int wd);
int  WINAPI ViewColumnWidth(HVIW vw, int ic);

#define  DEFCWID  5

int  WINAPI ViewColumnWidthF(HVIW vw, int ic);

void WINAPI SetViewColumnTextAlign(HVIW vw, int ic, int al);
int  WINAPI ViewColumnTextAlign(HVIW vw, int ic);
int  WINAPI ViewColumnTextAlignF(HVIW vw, int ic);

PCSTR WINAPI ViewColumnName(HVIW vw, int ic);
int  WINAPI ViewColumnIndex(HVIW vw, int ic);

void WINAPI SetViewColumnTitle(HVIW vw, int ic, PCSTR tit);
PCSTR WINAPI ViewColumnTitle(HVIW vw, int ic);

void WINAPI SetViewColumnDescription(HVIW vw, int ic, PCSTR dsc);
PCSTR WINAPI ViewColumnDescription(HVIW vw, int ic);
PCSTR WINAPI ViewColumnDescriptionR(HVIW vw, int ic);

void WINAPI SetViewColumnFlags(HVIW vw, int ic, int flg);
int  WINAPI ViewColumnFlags(HVIW vw, int ic);
int  WINAPI ViewColumnFlagsF(HVIW vw, int ic);

void WINAPI SetViewColumnExtra(HVIW vw, int ic, UINT pa);
UINT WINAPI ViewColumnExtra(HVIW vw, int ic);

BOOL WINAPI SetViewCellValue(HVIW vw, int ir, int ic, PCVOID pv);
PVOID WINAPI GetViewCellValue(PVOID pv, HVIW vw, int ir, int ic);
BOOL WINAPI ScanViewCellValue(HVIW vw, int ir, int ic, PCSTR st);
BOOL WINAPI ScanViewCellValueF(HVIW vw, int ir, int ic, PCSTR st);
PSTR WINAPI PrintViewCellValue(PSTR st, HVIW vw, int ir, int ic);

#define  PVF_ZEROBASEDINDEX  0x00
#define  PVF_ONEBASEDINDEX   0x01
#define  PVF_COLUMNNAME      0x00
#define  PVF_COLUMNTITLE     0x02
#define  PVF_COLUMNINDEX     0x04

#define  PVF_ZBI  PVF_ZEROBASEDINDEX
#define  PVF_OBI  PVF_ONEBASEDINDEX
#define  PVF_NAM  PVF_COLUMNNAME
#define  PVF_TIT  PVF_COLUMNTITLE
#define  PVF_IDX  PVF_COLUMNINDEX

PSTR WINAPI PrintViewCellValueF(PSTR st, HVIW vw, int ir, int ic, int flg);

BOOL WINAPI ClearViewRow(HVIW vw, int ir);
BOOL WINAPI ClearViewRows(HVIW vw, int ir, int nr);
BOOL WINAPI InsertViewRow(HVIW vw, int ir);
BOOL WINAPI InsertViewRows(HVIW vw, int ir, int nr);
BOOL WINAPI DeleteViewRow(HVIW vw, int ir);
BOOL WINAPI DeleteViewRows(HVIW vw, int ir, int nr);
BOOL WINAPI AddViewRow(HVIW vw);

PVOID WINAPI NewViewRow(HVIW vw);

void WINAPI ArrangeViewColumnsX(HVIW vw, PCIDXS pa);
int  WINAPI SearchViewRowX(HVIW vw, int i0, FSEL fsel, UINT pa);
int  WINAPI CountViewRowsX(HVIW vw, FSEL fsel, UINT pa);
int  WINAPI SelectViewRowsX(HVIW vw, FSEL fsel, UINT pa);
void WINAPI SortViewRowsX(HVIW vw, FSRT fcmp, UINT pa);

void WINAPI ArrangeViewColumns(HVIW vw, PCSTR arr);
int  WINAPI SearchViewRow(HVIW vw, int i0, PCSTR cnd);
int  WINAPI CountViewRows(HVIW vw, PCSTR cnd);
int  WINAPI SelectViewRows(HVIW vw, PCSTR cnd);
void WINAPI SortViewRows(HVIW vw, PCSTR srt);
void WINAPI SortTableRowsByView(HVIW vw);

HTBL WINAPI CreateSummary(HVIW vw, PCSTR grp);

int  WINAPI SearchViewCellValue(HVIW vw, int i0, int ic, PCVOID pv);
int  WINAPI SearchViewCellText(HVIW vw, int i0, int ic, PCSTR st, int flg);

#define  TSW_NAME   0
#define  TSW_NONE   1
#define  TSW_TITLE  2

#define  TSW_NAM  TSW_NAME
#define  TSW_NON  TSW_NONE
#define  TSW_TIT  TSW_TITLE

typedef struct {
  char  dlm;
  char  quo;
  WORD  tsw;
} CSVI;
typedef CSVI * PCSVI;
typedef const CSVI * PCCSVI;

BOOL WINAPI ReadCSV(HVIW vw, PCSTR nam, PCCSVI cv);
BOOL WINAPI WriteCSV(HVIW vw, PCSTR nam, PCCSVI cv);

BOOL WINAPI ReadINI(PVOID pb, PCTBLI ti);
BOOL WINAPI WriteINI(PVOID pb, PCTBLI ti);

BOOL WINAPI ReadATR(PVOID pb, PCTBLI ti, PCSTR st);

int  WINAPI RowBlkSize(HVIW vw, int nr);
void WINAPI CopyRowBlk(PVOID pv, HVIW vw, int i0, int nr);
BOOL WINAPI InsertRowBlk(HVIW vw, int i0, PCVOID pv);

// ---------------------------------------------------------------------- //

typedef struct {
  PCSTR nam;
  PCSTR tit;
  PCSTR dsc;
  PCSTR dir;
  REAL  tax;
  int   fym;
  int   nmf;
} SITI;
typedef SITI * PSITI;
typedef const SITI * PCSITI;

void WINAPI SetSiteVariables(PCSITI sv);

PCSTR WINAPI SiteName(void);
PCSTR WINAPI SiteTitle(void);
PCSTR WINAPI SiteDescription(void);
REAL WINAPI TaxRate(void);
int  WINAPI FYearMonth(void);
int  WINAPI NMonthFYear(void);

void WINAPI SetUserPath(PCSTR dir);
PCSTR WINAPI UserPath(void);

void WINAPI SetCurDate(int sr);
int  WINAPI CurDate(void);
int  WINAPI BFYear(void);
int  WINAPI EFYear(void);
int  WINAPI BMonth(void);
int  WINAPI EMonth(void);

// ---------------------------------------------------------------------- //

#define  IAPP  0x00024f42

#define  PRO_DEF  1
#define  PRO_OPR  2
#define  PRO_REP  3

PCSTR WINAPI BCDExt(int pro);
PCSTR WINAPI BCDMain(int pro);

typedef struct {
  int   pro;
  char  nam[16];
  char  tit[32];
  char  dsc[64];
} PROI;
typedef PROI * PPROI;
typedef const PROI * PCPROI;

HBLK WINAPI CreateTMP(PCPROI pi);
void WINAPI ScanProcInfo(PPROI pi, HBLK xb);

typedef struct {
  char  usr[32];
  char  pwd[32];
  int   lev;
} BSAI;
typedef BSAI * PBSAI;

HTBL WINAPI CreateBSATable(int cap, BOOL ld);

typedef struct {
  char  nam[16];
  char  tit[32];
  char  dsc[64];
} BSDI;
typedef BSDI * PBSDI;

HTBL WINAPI CreateBSDTable(int cap, int pro);

typedef struct {
  char  usr[32];
} BSUI;
typedef BSUI * PBSUI;

HTBL WINAPI CreateBSUTable(int cap, BOOL ld);

typedef BSDI BDDI;
typedef BDDI * PBDDI;
typedef const BDDI * PCBDDI;

HTBL WINAPI CreateBDDTable(int cap, BOOL ld);

typedef BSUI BDUI;
typedef BSUI * PBDUI;
typedef const BSUI * PCBDUI;

HTBL WINAPI CreateBDUTable(int cap, BOOL ld);

typedef struct {
  int   id;
  char  usr[32];
} LCKI;
typedef LCKI * PLCKI;

HTBL WINAPI CreateLCKTable(int cap, BOOL ld);

BOOL WINAPI LoginSite(PCSTR usr, PCSTR pwd);
void WINAPI LogoutSite(void);
void WINAPI ForceLogoutSite(PCSTR usr);

PCSTR WINAPI CurUser(void);
int  WINAPI CurAuth(void);

typedef struct {
  PTBLI ti;
  int   ni;
} TBLS;
typedef TBLS * PTBLS;
typedef const TBLS * PCTBLS;

typedef struct {
  PCTBLS ts;
  PCSTR nam;
  PCSTR tit;
  PCSTR dsc;
} BDBI;
typedef BDBI * PBDBI;
typedef const BDBI * PCBDBI;

BOOL WINAPI ConnectDBX(PCBDBI db);
BOOL WINAPI ConnectDB(PCSTR nam);
void WINAPI DisconnectDB(void);

PCSTR WINAPI CurDBName(void);
PCSTR WINAPI CurDBTitle(void);
PCSTR WINAPI CurDBDescription(void);
int  WINAPI CurDBStatus(void);

int  WINAPI NDBTables(void);
HTBL WINAPI DBTable(int id);
PCSTR WINAPI DBTableName(int id);
PCSTR WINAPI DBTableTitle(int id);
PCSTR WINAPI DBTableDescription(int id);
PCSTR WINAPI DBTableFileName(int id);
PVIWS WINAPI DBTableVIWS(int id);

int  WINAPI DBTableIndex(PCSTR nam);
HTBL WINAPI DBHTBL(PCSTR nam);

typedef struct { int unused;} HOPN_;
typedef HOPN_ * HOPN;

HOPN WINAPI CreateHOPN(HTBL tb, BOOL rw);
HOPN WINAPI OpenBSATable(BOOL rw);

#define  OM_READONLY   0x01
#define  OM_READWRITE  0x02
#define  OM_LOCK       0x04
#define  OM_INDIVIDUAL 0x10

#define  OM_RDO  OM_READONLY
#define  OM_RDW  OM_READWRITE
#define  OM_LCK  OM_LOCK
#define  OM_IND  OM_INDIVIDUAL

HOPN WINAPI OpenTableX(PCIDXS pt, int md);
#define  OpenTablesX(pt, md)  OpenTableX(pt, md)
HOPN WINAPI OpenTable(PCSTR tbs, int md);
#define  OpenTables(tbs, md)  OpenTable(tbs, md)
BOOL WINAPI SaveTable(HOPN op);
#define  SaveTables(op)  SaveTable(op)
BOOL WINAPI CloseTable(HOPN op, BOOL sv);
#define  CloseTables(op, sv)  CloseTable(op, sv)

HTBL WINAPI OHTBL(HOPN op);
int  WINAPI NOTables(HOPN op);
HTBL WINAPI OTable(HOPN op, int i);
BOOL WINAPI IsReadOnly(HOPN op);
BOOL WINAPI IsLocked(HOPN op);
BOOL WINAPI IsModified(HOPN op);

BOOL WINAPI NewDBFiles(void);
BOOL WINAPI BackupDBFiles(PCSTR dir);
BOOL WINAPI TrashDBFiles(PCSTR dir);

BOOL WINAPI CallCommandMain(PCSTR nam, HWND hwnd);
BOOL WINAPI LoadReportBCD(PCSTR nam);
void WINAPI UnloadReportBCD(void);
BOOL WINAPI CallReportMain(PVOID rp, int msg, int pg, UINT pa);

// ---------------------------------------------------------------------- //

UINT WINAPI BOLDBEVer(void);

BOOL WINAPI InitBOLDBE(UINT pa);
void WINAPI TermBOLDBE(void);

#ifdef __cplusplus
}
#endif

// ---------------------------------------------------------------------- //
