/* ---------------------------------------------------------------------- //
    houtei.c
// ---------------------------------------------------------------------- */

#define  MODNAM  PRGNAM
#define  MODVER  VI_VER

#include <windows.h>

#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma warning(disable:4996)

#include <bolbas.h>
#include <boldbe.h>
#include <bolfro.h>
#include <bolgui.h>
#include "houtei.h"

// ---------------------------------------------------------------------- //

void LOCALF cmd_prevpage(HWND hwnd)
{ // Oy[W
  int ip;

  ip = SendMessage(hwnd, PRCM_GETPAGE, 0, 0);
  if (ip > 0) SendMessage(hwnd, PRCM_SETPAGE, ip - 1, TRUE);
}

void LOCALF cmd_nextpage(HWND hwnd)
{ // y[W
  int ip, np;

  ip = SendMessage(hwnd, PRCM_GETPAGE, 0, 0);
  np = SendMessage(hwnd, PRCM_NPAGES, 0, 0);
  if (ip < np - 1) SendMessage(hwnd, PRCM_SETPAGE, ip + 1, TRUE);
}

  // gk{
static int  ZSCL[] = { 25, 50, 75, 100, 125, 150, 200, 300, 400 };

void LOCALF cmd_zoomin(HWND hwnd)
{ // g
  int i, s1, s2, xy, x0, y0;
  RECT rct;

  GetClientRect(hwnd, &rct);
  xy = SendMessage(hwnd, PRCM_GETORIGIN, 0, 0);
  s1 = SendMessage(hwnd, PRCM_GETSCALE, 0, 0);
  for (i = 0; i < NELEM(ZSCL) - 1; i++) {
    if (s1 < ZSCL[i]) break;
  }
  s2 = ZSCL[i];
  x0 = ((short)LOWORD(xy) + rct.rgt / 2) * s2 / s1 - rct.rgt / 2;
  y0 = ((short)HIWORD(xy) + rct.btm / 2) * s2 / s1 - rct.btm / 2;
  SendMessage(hwnd, PRCM_SETORIGIN, MAKEUINT(x0, y0), FALSE);
  SendMessage(hwnd, PRCM_SETSCALE, s2, TRUE);
}

void LOCALF cmd_zoomout(HWND hwnd)
{ // k
  int i, s1, s2, xy, x0, y0;
  RECT rct;

  GetClientRect(hwnd, &rct);
  xy = SendMessage(hwnd, PRCM_GETORIGIN, 0, 0);
  s1 = SendMessage(hwnd, PRCM_GETSCALE, 0, 0);
  for (i = NELEM(ZSCL) - 1; i > 0; i--) {
    if (s1 > ZSCL[i]) break;
  }
  s2 = ZSCL[i];
  x0 = ((short)LOWORD(xy) + rct.rgt / 2) * s2 / s1 - rct.rgt / 2;
  y0 = ((short)HIWORD(xy) + rct.btm / 2) * s2 / s1 - rct.btm / 2;
  SendMessage(hwnd, PRCM_SETORIGIN, MAKEUINT(x0, y0), FALSE);
  SendMessage(hwnd, PRCM_SETSCALE, s2, TRUE);
}

void LOCALF cmd_samescale(HWND hwnd)
{ // {\
  SendMessage(hwnd, PRCM_SETORIGIN, 0, FALSE);
  SendMessage(hwnd, PRCM_SETSCALE, 100, TRUE);
}

void LOCALF cmd_autoscale(HWND hwnd)
{ // S̕\
  int pw, ph, sc;
  RECT rct;

  GetClientRect(hwnd, &rct);
  pw = SendMessage(hwnd, PRCM_PAPERWIDTH, 0, 0);
  ph = SendMessage(hwnd, PRCM_PAPERHEIGHT, 0, 0);
  if (rct.rgt * ph < rct.btm * pw) {
    sc = rct.rgt * 100 / pw;
  } else {
    sc = rct.btm * 100 / ph;
  }
  if (sc > 100) sc = 100;
  SendMessage(hwnd, PRCM_SETSCALE, sc, TRUE);
}

void LOCALF cmd_invert(HWND hwnd)
{ // gk({\/S̕\ؑ)
  int sc;

  sc = SendMessage(hwnd, PRCM_GETSCALE, 0, 0);
  if (sc == 100) cmd_autoscale(hwnd);  else cmd_samescale(hwnd);
}

void LOCALF cmd_setprn(HWND hwnd)
{ // pݒ
  HREP rp;

  rp = (HREP)SendMessage(hwnd, PRCM_GETREPORT, 0, 0);
  PageSetup(hwnd, rp);
  SendMessage(hwnd, PRCM_SETREPORT, (WPARAM)rp, TRUE);
}

void LOCALF cmd_print(HWND hwnd)
{ // 
  HREP rp;

  rp = (HREP)SendMessage(hwnd, PRCM_GETREPORT, 0, 0);
  PrintReport(hwnd, rp);
}

LRESULT LOCALF PRN_command(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // R}h
  switch (LOWORD(wpa)) {
  case IDM_PREVPAGE:
    cmd_prevpage(hwnd); break;
  case IDM_NEXTPAGE:
    cmd_nextpage(hwnd); break;
  case IDM_ZOOMIN:
    cmd_zoomin(hwnd); break;
  case IDM_ZOOMOUT:
    cmd_zoomout(hwnd); break;
  case IDM_SAMESCALE:
    cmd_samescale(hwnd); break;
  case IDM_AUTOSCALE:
    cmd_autoscale(hwnd); break;
  case IDM_INVERT:
    cmd_invert(hwnd); break;
  case IDM_SETPRN:
    cmd_setprn(hwnd); break;
  case IDM_PRINT:
    cmd_print(hwnd); break;
  }
  return 0;
}

LRESULT LOCALF PRN_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // EBhEvV[W
  switch (umsg) {
  case WM_COMMAND:
    return PRN_command(hwnd, wpa, lpa);
  case WM_DESTROY:
    DeleteReport((HREP)SendMessage(hwnd, PRCM_GETREPORT, 0, 0)); break;
  }
  return DefBOLPRNProc(hwnd, umsg, wpa, lpa);
}

#define  APPS_PREVPAGEAVAILABLE    0x00000010
#define  APPS_NEXTPAGEAVAILABLE    0x00000020
#define  APPS_LOWERLIMITSCALE      0x00000040
#define  APPS_UPPERLIMITSCALE      0x00000080
#define  APPS_SKIPPAGESETUP        0x00000100

#define  APPS_PVP  APPS_PREVPAGEAVAILABLE
#define  APPS_NXP  APPS_NEXTPAGEAVAILABLE
#define  APPS_LSC  APPS_LOWERLIMITSCALE
#define  APPS_USC  APPS_UPPERLIMITSCALE
#define  APPS_SKP  APPS_SKIPPAGESETUP

static char PRN_PAG[32];
static char PRN_SCL[32];

int  LOCALF PRN_appstatus(HWND hwnd)
{ // vr[EBhȄԂ̎擾
  int ip, np, sc, sta = 0;
  HREP rp;

  rp = (HREP)SendMessage(hwnd, PRCM_GETREPORT, 0, 0);
  ip = SendMessage(hwnd, PRCM_GETPAGE, 0, 0);
  np = SendMessage(hwnd, PRCM_NPAGES, 0, 0);
  if (ip > 0) sta |= APPS_PVP;
  if (ip < np - 1) sta |= APPS_NXP;
  if (PageSetupInfo(rp)->adj & RSW_SKP) sta |= APPS_SKP;
  sprintf(PRN_PAG, "%3d / %d", ip + 1, np);
  sc = SendMessage(hwnd, PRCM_GETSCALE, 0, 0);
  if (sc <= ZSCL[0]) sta |= APPS_LSC;  else if (sc >= ZSCL[NELEM(ZSCL) - 1]) sta |= APPS_USC;
  sprintf(PRN_SCL, "%3d ", sc);
  return sta;
}

HWND LOCALF CreatePrintPreviewX(HWND hwnd, PREPI ri, WNDPROC prc)
{ // vr[EBhE̍쐬
  HWND hprn;
  HREP rp;
  static CREI cri = { "BOLPRN", wsCHV, "vr[", IDPRN, };

  if (IsWindow(hprn = GetDlgItem(hwnd, IDPRN))) SendMessage(hwnd, FRMM_DESTROYCHILD, (WPARAM)hprn, 0);
  rp = CreateReport(ri); if (!rp) return NULL;
  if (!ReportSetup(hwnd, rp)) goto _L1;
  if (!PageSetup(hwnd, rp)) goto _L1;
  cri.pa = (UINT)rp;
  hprn = (HWND)SendMessage(hwnd, FRMM_CREATECHILD, (WPARAM)&cri, (LPARAM)prc); if (!hprn) goto _L1;
  return hprn;

 _L1:
  DeleteReport(rp);
  return NULL;
}

HWND LOCALF CreatePrintPreview(HWND hwnd, PREPI ri)
{ // vr[EBhE̍쐬
  return CreatePrintPreviewX(hwnd, ri, PRN_WndProc);
}

// ---------------------------------------------------------------------- //

static MNUI POPMI[] = {
  { mfP,  0,             ""                        }, // POP0
  { mf_,  IDM_CUT,       "؂(&T)\tCtrl+X"    },
  { mf_,  IDM_COPY,      "Rs[(&C)\tCtrl+C"      },
  { mf_,  IDM_PASTE,     "\t(&P)\tCtrl+V"    },
  { mf_,  0,             ""                        },
  { mf_,  IDM_CLEAR,     "NA(&A)\tDel"         },
  { mf_,  0,             ""                        },
  { mfE,  IDM_OPENLINK,  "NJ(&O)"        },
  { mfP,  0,             ""                        }, // POP1
  { mf_,  IDM_CUT,       "؂(&T)\tCtrl+X"    },
  { mf_,  IDM_COPY,      "Rs[(&C)\tCtrl+C"      },
  { mf_,  IDM_PASTE,     "\t(&P)\tCtrl+V"    },
  { mf_,  0,             ""                        },
  { mfE,  IDM_CLEAR,     "NA(&A)\tDel"         },
  { mfP,  0,             ""                        }, // POP2
  { mf_,  IDM_CUT,       "؂(&T)\tCtrl+X"    },
  { mf_,  IDM_COPY,      "Rs[(&C)\tCtrl+C"      },
  { mf_,  IDM_PASTE,     "\t(&P)\tCtrl+V"    },
  { mf_,  0,             ""                        },
  { mf_,  IDM_INSERT,    "}(&I)\tCtrl+E"        },
  { mf_,  IDM_DELETE,    "폜(&D)\tCtrl+D"        },
  { mfE,  IDM_CLEAR,     "NA(&A)\tDel"         },
  { mfPE, 0,             ""                        }, // POP3
  { mf_,  IDM_ARRANGE,   "\(&A)..."         },
  { mf_,  IDM_FILTER,    "i荞(&F)..."         },
  { mfE,  IDM_SORT,      "בւ(&S)..."         },
};
static MNUS POPMS = { POPMI, NELEM(POPMI) };

static HMENU hmnuPop, hmnuPo0, hmnuPo1, hmnuPo2, hmnuPo3;

void LOCALF InitPopupMenus(void)
{ // |bvAbvj[ݒ
  hmnuPop = CreateMenuBar(&POPMS);
  hmnuPo0 = GetSubMenu(hmnuPop, 0);
  hmnuPo1 = GetSubMenu(hmnuPop, 1);
  hmnuPo2 = GetSubMenu(hmnuPop, 2);
  hmnuPo3 = GetSubMenu(hmnuPop, 3);
}

void LOCALF TermPopupMenus(void)
{ // |bvAbvj[폜
  DestroyMenu(hmnuPop);
}

BOOL LOCALF LoadUserVIW(HTBL tvu)
{ // [U[`\`ZbgǍ
  int re = FALSE;
  char bak[512];

  get_working_path(bak, sizeof(bak));
  set_working_path(UserPath());
  if (file_exists(TableFileName(tvu))) {
    re = LoadBTB(tvu);
  }
  set_working_path(bak);
  return re;
}

BOOL LOCALF SaveUserVIW(HTBL tvu)
{ // [U[`\`Zbgۑ
  int sw, re = FALSE;
  char bak[512];

  get_working_path(bak, sizeof(bak));
  set_working_path(UserPath());
  sw = disable_error_reporting();
  if (file_exists(TableFileName(tvu)) || NTableRows(tvu) > 0) {
    re = SaveBTB(tvu);
  }
  if (sw) enable_error_reporting();
  set_working_path(bak);
  return re;
}

  // \EBhEݒ
typedef struct {
  HOPN  op;
  int   flg;
  PCSTR tit;
  PCVIWS vs;
  int   iv0;
} TBWI;
typedef TBWI * PTBWI;

  // \EBhE
typedef struct {
  HOPN  op;   // -+
  int   flg;  //  |
  PCSTR tit;  //  |
  PCVIWS vs;  //  |= TBWI
  int   iv0;  // -+
  HWND  hprn;
  HWND  hsum;
  HTBL  tvs;
  HTBL  tvu;
  HTBL  tv;
  HBUF  bv;
  HTBL  tg;
  HTBL  tsm;
} TBWE;
typedef TBWE * PTBWE;

PCSTR LOCALF defface(void);
int  LOCALF defptsz(void);
int  LOCALF optflg(void);
HWND LOCALF CreateTableWindow(HWND hwnd, int id, PTBWI wi);

LRESULT LOCALF TBL_settable(HWND hwnd, PTBWI wi)
{ // \ݒ
  PTBWE we;
  int ir, re;
  HTBL tb;
  VIWI viw;

  we = halloc(sizeof(TBWE), TRUE); if (!we) return (LRESULT)ierr(E_MEM);
  SetWindowLong(hwnd, sizeof(LONG), (LONG)we);
  *(TBWI *)we = *wi;
  we->flg |= optflg();
  if (IsReadOnly(we->op)) we->flg |= (TBCS_DED|TBCS_DSE);
  SendMessage(hwnd, TBCM_SETMODE, we->flg, FALSE);
  tb = OHTBL(we->op);
  re = DefBOLTBLProc(hwnd, TBCM_SETTABLE, (WPARAM)tb, TRUE);
  if (!(we->flg & TBCS_DCV)) {
    if (we->vs) {
      we->tvs = CreateVIWTable(0, we->vs); if (!we->tvs) return re;
    }
    we->tvu = CreateVIWTable(32, NULL); if (!we->tvu) return re;
    SetTableFileName(we->tvu, addext(TableName(tb), ".VIW"));
    we->tv = CreateVIWTable(32, NULL); if (!we->tv) return re;
    we->bv = CreateRowBuf(we->tv); if (!we->bv) return re;
    LoadUserVIW(we->tvu);
    if (we->tvs) CopyTable(we->tv, we->tvs);
    MergeTable(we->tv, we->tvu);
    if (we->tvs && we->iv0 >= 0 && we->iv0 < NTableRows(we->tvs)) {
      GetTableRow(we->bv, we->tv, we->iv0);
    } else if ((ir = GetLastVIW(we->tv)) >= 0) {
      GetTableRow(we->bv, we->tv, ir);
    } else if (we->tvs && NTableRows(we->tvs) > 0) {
      GetTableRow(we->bv, we->tv, 0);
    }
    SendMessage(hwnd, TBCM_CHANGEVIEW, (WPARAM)SetVIWInfo(&viw, we->bv), TRUE);
  }
  return re;
}

LRESULT LOCALF TBL_trackpopup(HWND hwnd, PCPOSI lc)
{ // |bvAbvj[
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  int s0, s1, s2, sta;
  HVIW vw;
  HMENU hmnu;
  RBLK r;
  POINT pnt;
  char bf[512];

  s0 = SendMessage(hwnd, TBCM_GETSEL, (WPARAM)&r, 0);
  sta = AppStatus(hFRM(hwnd));
  if (lc->ir >= 0 && lc->ic >= 0 && !(s0 && lc->ir >= r.r1 && lc->ir <= r.r2)) {
    vw = (HVIW)SendMessage(hwnd, TBCM_GETVIEW, 0, 0);
    PrintViewCellValueF(bf, vw, lc->ir, lc->ic, 0);
    if ((ViewColumnFlagsF(vw, lc->ic) & CF_LNK) && bf[0] != '\0') {
      hmnu = hmnuPo0;
    } else {
      hmnu = hmnuPo1;
    }
    s1 = (!(we->flg & TBCS_DED));
    s2 = (s1 && (sta & APPS_CFT));
    EnableMenuItem(hmnu, IDM_CUT,    s1? mf_: mfG);
    EnableMenuItem(hmnu, IDM_PASTE,  s2? mf_: mfG);
    EnableMenuItem(hmnu, IDM_CLEAR,  s1? mf_: mfG);
  } else if (lc->ir >= 0) {
    hmnu = hmnuPo2;
    s1 = (!(we->flg & (TBCS_DED|TBCS_DSE)));
    s2 = (s1 && (sta & APPS_CFB));
    EnableMenuItem(hmnu, IDM_CUT,    s1? mf_: mfG);
    EnableMenuItem(hmnu, IDM_PASTE,  s2? mf_: mfG);
    EnableMenuItem(hmnu, IDM_INSERT, s1? mf_: mfG);
    EnableMenuItem(hmnu, IDM_DELETE, s1? mf_: mfG);
    EnableMenuItem(hmnu, IDM_CLEAR,  s1? mf_: mfG);
  } else { // lc->ic < 0
    hmnu = hmnuPo3;
  }
  GetCursorPos(&pnt);
  TrackPopupMenuEx(hmnu, TPM_RIGHTBUTTON, pnt.x, pnt.y, hwnd, NULL);
  return 0;
}

void LOCALF cmd_save(HWND hwnd)
{ // ㏑ۑ
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  int re;

  if (SendMessage(hwnd, TBCM_GETMODE, 0, 0) & TBCS_DED) return;
  BusyMsg(hFRM(hwnd), "...");
  reset_error();
  re = CheckTable(OHTBL(we->op));
  EndBusy(hFRM(hwnd));
  if (!re) {
    ErrorBox(hFRM(hwnd), "G[܂B\nۑ̓LZ܂B", NULL); return;
  }
  BusyMsg(hFRM(hwnd), "ۑ...");
  reset_error();
  re = SaveTable(we->op);
  if (re) SendMessage(hwnd, TBCM_UPDATE, FALSE, TRUE);
  EndBusy(hFRM(hwnd));
  if (!re) {
    ErrorBox(hFRM(hwnd), format("'%s'̕ۑɎs܂B", WindowText(hwnd)), NULL);
  }
}

void LOCALF cmd_import(HWND hwnd)
{ // eLXg捞
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  int re;
  HVIW vw;
  char nam[512], bak[512];
  static OFNS ofn = { "eLXgt@C (*.txt)\0*.txt\0ׂẴt@C (*.*)\0*.*\0", 1, NULL, OFN_HIDEREADONLY };
  static CSVI csi = { '\t', 0, TSW_NAM };

  if (SendMessage(hwnd, TBCM_GETMODE, 0, 0) & TBCS_DED) return;
  get_working_path(bak, sizeof(bak));
  (ofn.nam = nam)[0] = '\0';
  re = OpenFileDlgBox(hwnd, &ofn);
  set_working_path(bak);
  if (!re) return;
  if (!CSVInfoDlgBox(hwnd, &csi)) return;
  vw = (HVIW)SendMessage(hwnd, TBCM_GETVIEW, 0, 0);
  BusyMsg(hFRM(hwnd), "Ǎ...");
  reset_error();
  re = ReadCSV(vw, nam, &csi);
  if (re) SendMessage(hwnd, TBCM_UPDATE, FALSE, TRUE);
  EndBusy(hFRM(hwnd));
  if (!re) {
    ErrorBox(hFRM(hwnd), format("'%s'̓ǍɎs܂B", WindowText(hwnd)), NULL);
  }
}

void LOCALF cmd_export(HWND hwnd)
{ // eLXgo
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  int re;
  HVIW vw;
  char nam[512], bak[512];
  static OFNS ofn = { "eLXgt@C (*.txt)\0*.txt\0ׂẴt@C (*.*)\0*.*\0", 1, NULL, OFN_HIDEREADONLY };
  static CSVI csi = { '\t', 0, TSW_NAM };

  get_working_path(bak, sizeof(bak));
  (ofn.nam = nam)[0] = '\0';
  re = SaveFileDlgBox(hwnd, &ofn);
  set_working_path(bak);
  if (!re) return;
  if (file_exists(nam)) {
    if (YesNoBox(hFRM(hwnd), format("'%s'͊ɑ݂܂B㏑܂H", nam), NULL) != IDYES) return;
  }
  if (!CSVInfoDlgBox(hwnd, &csi)) return;
  vw = (HVIW)SendMessage(hwnd, TBCM_GETVIEW, 0, 0);
  BusyMsg(hFRM(hwnd), "o...");
  reset_error();
  re = WriteCSV(vw, nam, &csi);
  if (re) SendMessage(hwnd, TBCM_UPDATE, FALSE, TRUE);
  EndBusy(hFRM(hwnd));
  if (!re) {
    ErrorBox(hFRM(hwnd), format("'%s'̏oɎs܂B", WindowText(hwnd)), NULL);
  }
}

  // \`
typedef struct {
  int   ns;
  REAL  *cw;
  REAL  dcw, drh, daw;
} TBLP;

BOOL LOCALF frepTBL(HREP rp, int msg, int pg, UINT pa)
{ // \̕`
  int i, j, nr, nc, br, md, op, zr;
  HVIW vw;
  TBLP *px;
  CELL cel;
  GRID grd;
  WHSZ siz;
  char bf[512];

  vw = (HVIW)SendMessage((HWND)pa, TBCM_GETVIEW, 0, 0);
  if (msg == REPM_CREATE) {
    nc = NTableColumns(ViewHTBL(vw));
    px = halloc(sizeof(TBLP) + nc * sizeof(REAL), TRUE); if (!px) return FALSE;
    px->cw = (PVOID)((PBYTE)px + sizeof(TBLP));
    SetReportExtra(rp, (UINT)px);
    return TRUE;
  }
  px = (TBLP *)ReportExtra(rp);
  nr = NViewRows(vw);
  nc = NViewColumns(vw);
  md = SendMessage((HWND)pa, TBCM_GETMODE, 0, 0);
  op = ((md & TBCS_UCN)? PVF_NAM: (md & TBCS_UCI)? PVF_IDX: PVF_TIT) | ((md & TBCS_ZBI)? PVF_ZBI: PVF_OBI);
  zr = (md & TBCS_HCH)? 0: 1;
  if (msg == REPM_SETUP) {
    SetTextFont(rp, defface(), PT2MM(defptsz()), 0, 0);
    AveCharSize(&siz, rp);
    px->dcw = siz.w;
    px->drh = siz.h * 1.2;
    px->daw = 0.0;
    for (j = 0; j < nc; j++) {
      px->cw[j] = px->dcw * ((REAL)ViewColumnWidthF(vw, j) + 0.5);
      px->daw += px->cw[j];
    }
    SetReqBodyWidth(rp, px->daw, 0);
    SetCellMargin(rp, px->dcw / 3, 0.0);
  } else if (msg == REPM_PAGESETUP) {
    px->ns = (int)(BodyHeight(rp) / px->drh) - zr;
    SetNPages(rp, ((nr - 1) / px->ns) + 1);
  } else if (msg == REPM_DRAWPAGE) {
    SetTextFont(rp, defface(), PT2MM(defptsz()), 0, 0);
    HeaderCell(&cel, rp);
    CellText(rp, &cel, ReportTitle(rp), DT_LFT);
    CellText(rp, &cel, dformat("yyyy/mm/dd", ReportDate(rp)), DT_RGT);
    SetGrid1(&grd, BodyLeft(rp), BodyTop(rp), nc, px->ns + zr, px->cw, px->drh);
    br = (pg - 1) * px->ns;
    for (i = -zr; i < px->ns; i++) {
      for (j = 0; j < nc; j++) {
        if (px->cw[j] == 0.0) continue;
        PrintViewCellValueF(bf, vw, (i >= 0)? br + i: -1, j, op);
        GridCellText(rp, &grd, i + zr, j, RST_R_M, bf, DT_AUT|((i >= 0)? ViewColumnTextAlignF(vw, j): DT_CEN));
      }
    }
    FooterCell(&cel, rp);
    CellText(rp, &cel, format("- %d -", pg), DT_CEN);
  } else if (msg == REPM_DESTROY) {
    hfree(px);
  }
  return TRUE;
}

void LOCALF cmd_printtbl(HWND hwnd)
{ // \
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  static REPI rpi = { NULL, PSZ_A4P, frepTBL, 0 };

  if (IsWindow(we->hprn)) SendMessage(we->hprn, WM_CLOSE, 0, 0);
  rpi.tit = TableTitle(OHTBL(we->op));
  rpi.pa = (UINT)hwnd;
  we->hprn = CreatePrintPreview(hFRM(hwnd), &rpi);
}

void LOCALF cmd_search(HWND hwnd, BOOL sw)
{ // 񌟍
  static STXP stx;

  if (sw == 0) {
    if (!SearchTextDlgBox(hwnd, &stx, 1)) return;
  }
  SendMessage(hwnd, TBCM_SEARCH + sw, (WPARAM)stx.str, stx.flg);
}

  // \`
typedef struct {
  char  nam[32];
} VNMP;

BOOL LOCALF VNM_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // \`_CAOvV[W
  VNMP *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (VNMP *)lpa));
    SetESTR(hdlg, 101, pa->nam);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (VNMP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, pa->nam, sizeof(pa->nam) - 1);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

BOOL LOCALF GetVNM(HWND hwnd, VNMP *pa, BOOL sw)
{ // \`
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 48,  8,  -1, "@O(&N):" },
    { C_ESTR|wsT,  56,  8, 48, 12, 101, "" },
    { C_BDEF|wsGT, 54, 60, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 106, 60, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 160, 80, NULL };

  dlg.tit = (sw == 0)? "\`o^": "OύX";
  return DlgBoxInput(hwnd, &dlg, VNM_DlgProc, (LPARAM)pa) == IDOK;
}

  // \`ݒ
typedef struct {
  HTBL  tv;
  HBUF  bv;
} VIWP;

#define  IDREG  22
#define  IDCHG  23
#define  IDDEL  24

BOOL LOCALF VIW_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // \`ݒ_CAOvV[W
  int ir, ix, sw, ud = 0;
  VIWP *pa;
  VNMP dat;
  static TBCI tci = { 10, "nam, ud", NULL, NULL, TTF_ADJ, 1, 0 };

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (VIWP *)lpa));
    if ((ir = SearchVIWTableRow(pa->tv, pa->bv)) < 0) {
      SetRowBufCellValue(pa->bv, 0, "o^");
      SetRowBufCellValue(pa->bv, 1, i32Box(1));
      SetNewTableRow(pa->tv, pa->bv);
      ir = NTableRows(pa->tv) - 1;
    }
    SetTSEL(hdlg, 101, ir, pa->tv, &tci);
    sw = (strcmp(TableRow(pa->tv, ir), "o^") != 0);
    GetTableCellValue(&ud, pa->tv, ir, 1);
    EnableDlgItem(hdlg, IDREG, ud && !sw);
    EnableDlgItem(hdlg, IDCHG, ud && sw);
    EnableDlgItem(hdlg, IDDEL, ud && sw);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (VIWP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case MAKEUINT(101, APPN_SELCHANGE): _L1:
      if (NTableRows(pa->tv) > 0) {
        ir = GetTSEL(hdlg, 101);
        sw = (strcmp(TableRow(pa->tv, ir), "o^") != 0);
        GetTableCellValue(&ud, pa->tv, ir, 1);
      } else ud = sw = 0;
      EnableDlgItem(hdlg, IDREG, ud && !sw);
      EnableDlgItem(hdlg, IDCHG, ud && sw);
      EnableDlgItem(hdlg, IDDEL, ud && sw);
     _L2: RedrawWindow(GetDlgItem(hdlg, 101), NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW);
      SendDlgItemMessage(hdlg, IDREG, BM_SETSTYLE, bsP, TRUE);
      SendDlgItemMessage(hdlg, IDCHG, BM_SETSTYLE, bsP, TRUE);
      SendDlgItemMessage(hdlg, IDDEL, BM_SETSTYLE, bsP, TRUE);
      SendDlgItemMessage(hdlg, IDOK,  BM_SETSTYLE, bsD, TRUE);
      SetFocus(GetDlgItem(hdlg, 101));
      break;
    case IDREG:
    case IDCHG:
      if (NTableRows(pa->tv) > 0) {
        ir = GetTSEL(hdlg, 101);
        sw = (strcmp(GetTableCellValue(dat.nam, pa->tv, ir, 0), "o^") != 0);
        if (sw == 0) dat.nam[0] = '\0';
        if (GetVNM(hdlg, &dat, sw)) {
          if (dat.nam[0] == '\0') { ErrorBox(hdlg, "OKvłB", NULL); break;}
          ix = SearchVIWTableRowByName(pa->tv, dat.nam);
          if (ix >= 0) { ErrorBox(hdlg, "ɂ閼OłB", NULL); break;}
          SetTableCellValue(pa->tv, ir, 0, dat.nam);
          SetTSEL(hdlg, 101, ir, pa->tv, &tci); goto _L1;
        }
      }
      goto _L2;
    case IDDEL:
      if (NTableRows(pa->tv) > 0) {
        ir = GetTSEL(hdlg, 101);
        DeleteTableRow(pa->tv, ir);
        SetTSEL(hdlg, 101, ir, pa->tv, &tci); goto _L1;
      }
      goto _L2;
    case MAKEUINT(101, APPN_LBUTTONDBLCLK): wpa = IDOK;
    case IDOK:
      if (NTableRows(pa->tv) > 0) {
        ir = GetTSEL(hdlg, 101);
        GetTableRow(pa->bv, pa->tv, ir);
      }
      // fall through
    case IDCANCEL:
      if ((ir = SearchVIWTableRowByName(pa->tv, "o^")) >= 0) {
        DeleteTableRow(pa->tv, ir);
      }
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_view(HWND hwnd)
{ // \`
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  VIWI viw;
  VIWP par;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8,  8, 32,  8,  -1, "\`" },
    { C_TSEL|wsT,   8, 18,156,116, 101, "" },
    { C_BPSH|wsGT,170, 18, 48, 14, IDREG, "o^(&R)" },
    { C_BPSH|wsT, 170, 36, 48, 14, IDCHG, "OύX(&C)" },
    { C_BPSH|wsT, 170, 54, 48, 14, IDDEL, "폜(&D)" },
    { C_BDEF|wsGT,118,156, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 170,156, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 224, 176, "\`" };

  if (we->flg & TBCS_DCV) return;
  par.tv = DuplicateTable(we->tv);  if (!par.tv) return;
  par.bv = DuplicateRowBuf(we->bv); if (!par.bv) goto _L2;
  if (DlgBoxInput(hwnd, &dlg, VIW_DlgProc, (LPARAM)&par) == IDCANCEL) goto _L1;
  CopyTable(we->tv, par.tv);
  CopyRowBuf(we->bv, par.bv);
  SendMessage(hwnd, TBCM_CHANGEVIEW, (WPARAM)SetVIWInfo(&viw, we->bv), TRUE);
 _L1: DeleteRowBuf(par.bv);
 _L2: DeleteTable(par.tv);
}

void LOCALF SetLTIT(HWND hdlg, int id, int ir, HTBL ta, BOOL sw)
{ // ږXg쐬
  int i, i0, ni;
  PCINT vi;
  HTBL tb;

  vi = (PCINT)TablePtr(ta);
  tb = (HTBL)TableColumnExtra(ta, 0);
  if (sw == 0) {
    i0 = 0; ni = NTableRows(ta);
  } else {
    i0 = NTableRows(ta); ni = TableCapacity(ta) - i0;
  }
  SendDlgItemMessage(hdlg, id, WM_SETREDRAW, FALSE, 0);
  SendDlgItemMessage(hdlg, id, LB_RESETCONTENT, 0, 0);
  for (i = 0; i < ni; i++) {
    SendDlgItemMessage(hdlg, id, LB_ADDSTRING, 0, (LPARAM)TableColumnTitle(tb, vi[i0 + i]));
  }
  SendDlgItemMessage(hdlg, id, LB_ADDSTRING, 0, (LPARAM)"");
  SendDlgItemMessage(hdlg, id, LB_SETCURSEL, ir, 0);
  SendDlgItemMessage(hdlg, id, WM_SETREDRAW, TRUE, 0);
  InvalidateRect(GetDlgItem(hdlg, id), NULL, TRUE);
}

  // \ڐݒ
typedef struct {
  HTBL  ta;
  PSTR  arr;
  PWORD pf;
} VIW0P;

BOOL LOCALF VIW0_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // \ڃ_CAOvV[W
  int i1, i2, fc;
  VIW0P *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (VIW0P *)lpa));
    ScanARRTable(pa->ta, pa->arr);
    SetLTIT(hdlg, 101, 0, pa->ta, 0);
    SetLTIT(hdlg, 102, 0, pa->ta, 1);
    SetEINT(hdlg, 105, *pa->pf);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (VIW0P *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case 103:
      if ((i2 = GetLSEL(hdlg, 102)) < TableCapacity(pa->ta) - NTableRows(pa->ta)) {
        InsertARRTableRow(pa->ta, i1 = GetLSEL(hdlg, 101), i2);
        i1++;
        goto _L1;
      }
      break;
    case 104:
      if ((i1 = GetLSEL(hdlg, 101)) < NTableRows(pa->ta)) {
        i2 = DeleteARRTableRow(pa->ta, i1);
       _L1:
        SetLTIT(hdlg, 101, i1, pa->ta, 0);
        SetLTIT(hdlg, 102, i2, pa->ta, 1);
      }
      break;
    case IDPSH+1:
    case IDPSH+2:
    case IDOK:
      PrintARRTable(pa->arr, pa->ta);
      fc = GetEINT(hdlg, 105); if (fc >= 0 && fc < NTableRows(pa->ta)) *pa->pf = (WORD)fc;
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

LRESULT LOCALF VIW1_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // i荞ݏ\̃EBhEvV[W
  switch (umsg) {
  case TBCM_ASKCELLFORMAT:
    if (((POSI *)wpa)->ir == VIWCAP - 1 && ((POSI *)wpa)->ic > 0) {
      return DC_INR|DC_DED|DC_RHD;
    }
    break;
  }
  return DefBOLTBLProc(hwnd, umsg, wpa, lpa);
}

  // i荞ݏݒ
typedef struct {
  HTBL  tc;
  PSTR  cnd;
} VIW1P;

BOOL LOCALF VIW1_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // i荞݃_CAOvV[W
  VIW1P *pa;
  POSI c;
  static TBCI tci = { 0, "lx, ic, cm, wk", NULL, NULL, TTF_ADJ, 3, 0 };

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (VIW1P *)lpa));
    SubclassWindow(GetDlgItem(hdlg, 101), VIW1_WndProc);
    ScanCNDTable(pa->tc, pa->cnd);
    SetTTBL(hdlg, 101, pa->tc, &tci);
    c.ir = 0; c.ic = 1;
    SendDlgItemMessage(hdlg, 101, TBCM_SETCUR, (WPARAM)&c, FALSE);
    PrintCNDTable(pa->cnd, pa->tc);
    SetSSTR(hdlg, 102, pa->cnd);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (VIW1P *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case MAKEUINT(101, APPN_CHANGE):
      RedrawWindow(GetDlgItem(hdlg, 101), NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW);
      PrintCNDTable(pa->cnd, pa->tc);
      SetSSTR(hdlg, 102, pa->cnd);
      break;
    case IDPSH:
    case IDPSH+2:
    case IDOK:
      PrintCNDTable(pa->cnd, pa->tc);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

LRESULT LOCALF VIW2_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // בւ\̃EBhEvV[W
  switch (umsg) {
  case TBCM_ASKCELLFORMAT:
    if (((POSI *)wpa)->ic < 0) {
      return (((POSI *)wpa)->ir < 0)? DC_CHD|DC_RHD|DC_CEN: DC_INR|DC_RHD|DC_RGT;
    }
    break;
  case TBCM_GETCELLTEXT:
    if (((POSI *)wpa)->ic < 0) {
      if (((POSI *)wpa)->ir < 0) {
        sprintf((PSTR)lpa, "D揇");
      } else {
        sprintf((PSTR)lpa, "%d ", ((POSI *)wpa)->ir + 1);
      }
      return 0;
    }
    break;
  }
  return DefBOLTBLProc(hwnd, umsg, wpa, lpa);
}

  // בւݒ
typedef struct {
  HTBL  ts;
  PSTR  srt;
} VIW2P;

BOOL LOCALF VIW2_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // בւ_CAOvV[W
  VIW2P *pa;
  static TBCI tci = { 0, NULL, NULL, NULL, TTF_ADJ|TTF_HDW, 1, 8 };

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (VIW2P *)lpa));
    SubclassWindow(GetDlgItem(hdlg, 101), VIW2_WndProc);
    ScanSRTTable(pa->ts, pa->srt);
    SetTTBL(hdlg, 101, pa->ts, &tci);
    PrintSRTTable(pa->srt, pa->ts);
    SetSSTR(hdlg, 102, pa->srt);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (VIW2P *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case MAKEUINT(101, APPN_CHANGE):
      RedrawWindow(GetDlgItem(hdlg, 101), NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW);
      PrintSRTTable(pa->srt, pa->ts);
      SetSSTR(hdlg, 102, pa->srt);
      break;
    case IDPSH:
    case IDPSH+1:
    case IDOK:
      PrintSRTTable(pa->srt, pa->ts);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_arrange(HWND hwnd, int ip)
{ // \ځ^i荞݁^בւ
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  HTBL tb;
  VIWI viw;
  VIWE dat;
  // \
  static VIW0P par0;
  static DLGI dit0[] = {
    { C_BGRP|wsG,   6,  0, 48, 18,  -1, "" },
    { C_SCEN|wsG,   8,  6, 44,  8,  -1, "\" },
    { C_BPSH|wsG,  58,  3, 48, 14, IDPSH+1, "i荞" },
    { C_BPSH|wsG, 110,  3, 48, 14, IDPSH+2, "בւ" },
    { C_SLFT|wsG,   8, 30, 80,  8,  -1, "\(^Cg)" },
    { C_LSEL|wsT,   8, 40, 80,124, 101, "" },
    { C_SLFT|wsG, 152, 30, 80,  8,  -1, "\" },
    { C_LSEL|wsT, 152, 40, 80,124, 102, "" },
    { C_BPSH|wsGT, 96, 64, 48, 14, 103, "ǉ(&A)" },
    { C_BPSH|wsT,  96, 82, 48, 14, 104, "O(&D)" },
    { C_SLFT|wsG,   8,169, 48,  8,  -1, "Œ(&F):" },
    { C_ENUM|wsT,  56,167, 24, 12, 105, "" },
    { C_BDEF|wsGT,134,204, 48, 14, IDOK, "OK"   },
    { C_BPSH|wsT, 186,204, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg0 = { dit0, NELEM(dit0), 0, 0, 240, 224, "\`" };
  // i荞
  static VIW1P par1;
  static DLGI dit1[] = {
    { C_BPSH|wsG,   6,  3, 48, 14, IDPSH, "\" },
    { C_BGRP|wsG,  58,  0, 48, 18,  -1, "" },
    { C_SCEN|wsG,  60,  6, 44,  8,  -1, "i荞" },
    { C_BPSH|wsG, 110,  3, 48, 14, IDPSH+2, "בւ" },
    { C_SLFT|wsG,   8, 30, 48,  8,  -1, "i荞ݏ" },
    { C_TTBX|wsGT,  8, 40,224,116, 101, "" },
    { C_BGRP|wsG,   6,156,228, 32,  -1, "i荞ݏ" },
    { C_SMUL|wsG,  12,166,216, 18, 102, "" },
    { C_BDEF|wsGT,134,204, 48, 14, IDOK, "OK"   },
    { C_BPSH|wsT, 186,204, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg1 = { dit1, NELEM(dit1), 0, 0, 240, 224, "\`" };
  // בւ
  static VIW2P par2;
  static DLGI dit2[] = {
    { C_BPSH|wsG,   6,  3, 48, 14, IDPSH, "\" },
    { C_BPSH|wsG,  58,  3, 48, 14, IDPSH+1, "i荞" },
    { C_BGRP|wsG, 110,  0, 48, 18,  -1, "" },
    { C_SCEN|wsG, 112,  6, 44,  8,  -1, "בւ" },
    { C_SLFT|wsG,   8, 30, 48,  8,  -1, "בւ" },
    { C_TTBF|wsGT,  8, 40,224,116, 101, "" },
    { C_BGRP|wsG,   6,156,228, 32,  -1, "בւ" },
    { C_SMUL|wsG,  12,166,216, 18, 102, "" },
    { C_BDEF|wsGT,134,204, 48, 14, IDOK, "OK"   },
    { C_BPSH|wsT, 186,204, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg2 = { dit2, NELEM(dit2), 0, 0, 240, 224, "\`" };
  // vpeBV[g
  static PSHI psp[] = {
    { &dlg0, VIW0_DlgProc, (LPARAM)&par0, sizeof(par0) },
    { &dlg1, VIW1_DlgProc, (LPARAM)&par1, sizeof(par1) },
    { &dlg2, VIW2_DlgProc, (LPARAM)&par2, sizeof(par2) },
  };
  static PSHS psh = { psp, NELEM(psp) };

  if (we->flg & TBCS_DCV) return;
  tb = OHTBL(we->op);
  dat = *(VIWE *)RowBufPtr(we->bv);
  par0.ta = CreateARRTable(0, tb); if (!par0.ta) return;
  par0.arr = dat.arr;
  par0.pf = &dat.fc;
  par1.tc = CreateCNDTable(VIWCAP, tb); if (!par1.tc) goto _L3;
  par1.cnd = dat.cnd;
  par2.ts = CreateSRTTable(VIWCAP, tb); if (!par2.ts) goto _L2;
  par2.srt = dat.srt;
  if (PropSheetInput(hwnd, &psh, ip) == IDCANCEL) goto _L1;
  *(VIWE *)RowBufPtr(we->bv) = dat;
  SendMessage(hwnd, TBCM_CHANGEVIEW, (WPARAM)SetVIWInfo(&viw, we->bv), TRUE);
 _L1: DeleteTable(par0.ta);
 _L2: DeleteTable(par1.tc);
 _L3: DeleteTable(par2.ts);
}

void LOCALF cmd_viewa(HWND hwnd, BOOL sw)
{ // Sڕ\^\`
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  VIWI viw;

  if (we->flg & TBCS_DCV) return;
  SetRowBufCellValue(we->bv, 3, i32Box(0));
  SetRowBufCellValue(we->bv, 4, sw? "": "*");
  SetRowBufCellValue(we->bv, 5, "");
  if (sw) SetRowBufCellValue(we->bv, 6, "");
  SendMessage(hwnd, TBCM_CHANGEVIEW, (WPARAM)SetVIWInfo(&viw, we->bv), TRUE);
}

static CODI diHRH[] = {
  { TBCS_HRH, "\Ȃ" }, { 0, "sCfbNX" }
};
static CODS dsHRH = { diHRH, NELEM(diHRH) };

static CODI diHCH[] = {
  { TBCS_HCH, "\Ȃ" }, { TBCS_UCI, "CfbNX" }, { TBCS_UCN, "" }, { 0, "^Cg" }
};
static CODS dsHCH = { diHCH, NELEM(diHCH) };

  // \IvV
typedef struct {
  char  face[32];
  int   ptsz;
  int   tbcs;
} VOPP;

BOOL LOCALF setvopt_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // \IvVݒ_CAOvV[W
  VOPP *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (VOPP *)lpa));
    SetESTR(hdlg, 101, pa->face);
    SetEINT(hdlg, 102, pa->ptsz);
    SetCCOD(hdlg, 103, pa->tbcs & TBCS_HRH, &dsHRH);
    SetCCOD(hdlg, 104, pa->tbcs & (TBCS_HCH|TBCS_UCI|TBCS_UCN), &dsHCH);
    SetBFLG(hdlg, 105, pa->tbcs & TBCS_EMD);
    SetBFLG(hdlg, 106, pa->tbcs & TBCS_DDD);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (VOPP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, pa->face, sizeof(pa->face) - 1);
      if (pa->face[0] == '\0') strcpyx(pa->face, DEFFACE, sizeof(pa->face) - 1);
      pa->ptsz = GetEINT(hdlg, 102); if (pa->ptsz < 6 || pa->ptsz > 30) pa->ptsz = DEFPTSZ;
      pa->tbcs = (pa->tbcs &~TBCS_HRH) | GetCCOD(hdlg, 103, &dsHRH);
      pa->tbcs = (pa->tbcs &~(TBCS_HCH|TBCS_UCI|TBCS_UCN)) | GetCCOD(hdlg, 104, &dsHCH);
      if (GetBFLG(hdlg, 105)) pa->tbcs |= TBCS_EMD;  else pa->tbcs &=~TBCS_EMD;
      if (GetBFLG(hdlg, 106)) pa->tbcs |= TBCS_DDD;  else pa->tbcs &=~TBCS_DDD;
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_setvopt(HWND hwnd)
{ // \IvV
  VOPP par;
  HFONT hfnt;
  LOGFONT lof;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 48,  8,  -1, "tHg(&F):" },
    { C_ESTR|wsT,  56,  8, 66, 12, 101, "" },
    { C_ENUM|wsT, 128,  8, 24, 12, 102, "" },
    { C_SLFT|wsG, 155, 10, 16,  8,  -1, "pt" },
    { C_SLFT|wsG,   8, 26, 48,  8,  -1, "so(&R):" },
    { C_CSEL|wsT,  56, 24, 58,128, 103, "" },
    { C_SLFT|wsG,   8, 42, 48,  8,  -1, "񌩏o(&C):" },
    { C_CSEL|wsT,  56, 40, 58,128, 104, "" },
    { C_BFLG|wsGT,  8, 60,120, 10, 105, "EnterL[ŉɈړ(&D)" },
    { C_BFLG|wsGT,  8, 74,128, 10, 106, "hbv_EXggpȂ(&L)" },
    { C_BDEF|wsGT, 86,124, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 138,124, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 192, 144, "\IvV" };

  hfnt = (HFONT)SendMessage(hwnd, WM_GETFONT, 0, 0);
  GetObject(hfnt, sizeof(LOGFONT), &lof);
  strcpyn(par.face, lof.lfFaceName, sizeof(par.face) - 1);
  par.ptsz = iround(abs(lof.lfHeight) * PTPI / DEFDPI);
  par.tbcs = SendMessage(hwnd, TBCM_GETMODE, 0, 0);
  if (DlgBoxInput(hwnd, &dlg, setvopt_DlgProc, (LPARAM)&par) == IDCANCEL) return;
  SendMessage(hwnd, TBCM_SETMODE, par.tbcs, FALSE);
  hfnt = CreateFontIndirect(SetLOGFONT(&lof, par.face, PT2DOTS(par.ptsz), 0));
  SendMessage(hwnd, WM_SETFONT, (WPARAM)hfnt, TRUE);
  DeleteObject(hfnt);
}

  // Wv\쐬
typedef struct {
  HTBL  tg;
  char  grp[512];
} SUMP;

BOOL LOCALF SUM_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // Wv\쐬_CAOvV[W
  SUMP *pa;
  static TBCI tci = { 0, "ic, sw, tit, fmt", NULL, NULL, TTF_ADJ, 3, 0 };

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (SUMP *)lpa));
    ScanGRPTable(pa->tg, pa->grp);
    SetTTBL(hdlg, 101, pa->tg, &tci);
    PrintGRPTable(pa->grp, pa->tg);
    SetSSTR(hdlg, 102, pa->grp);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (SUMP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case MAKEUINT(101, APPN_CHANGE):
      RedrawWindow(GetDlgItem(hdlg, 101), NULL, NULL, RDW_INVALIDATE|RDW_UPDATENOW);
      PrintGRPTable(pa->grp, pa->tg);
      SetSSTR(hdlg, 102, pa->grp);
      break;
    case IDOK:
      PrintGRPTable(pa->grp, pa->tg);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_summary(HWND hwnd)
{ // Wv
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  HWND hsum;
  HVIW vw;
  TBWI tbw = { NULL, TBCS_DED|TBCS_DSE, NULL, NULL, 0 };
  static SUMP par;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8,  8, 48,  8,  -1, "Wv" },
    { C_TTBX|wsGT,  8, 18,272,116, 101, "" },
    { C_BGRP|wsG,   6,134,276, 32,  -1, "WvڃXg" },
    { C_SMUL|wsG,  12,144,256, 18, 102, "" },
    { C_BDEF|wsGT,182,188, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 234,188, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 288, 208, "Wv\쐬" };

  if (WindowID(hwnd) == IDSUM) {
    PostMessage(hFRM(hwnd), WM_COMMAND, IDM_SUMMARY, 0);
    SendMessage(hwnd, WM_CLOSE, 0, 0); return;
  }
  vw = (HVIW)SendMessage(hwnd, TBCM_GETVIEW, 0, 0);
  if (!we->tg) {
    we->tg = CreateGRPTable(VIWCAP, ViewHTBL(vw)); if (!we->tg) return;
    par.tg = we->tg;
    par.grp[0] = '\0';
  } else {
    par.tg = we->tg;
    PrintGRPTable(par.grp, par.tg);
  }
  if (DlgBoxInput(hwnd, &dlg, SUM_DlgProc, (LPARAM)&par) == IDCANCEL) return;
  if (IsWindow(hsum = GetDlgItem(hFRM(hwnd), IDSUM))) SendMessage(hFRM(hwnd), FRMM_DESTROYCHILD, (WPARAM)hsum, 0);
  if (we->tsm) { DeleteTable(we->tsm); we->tsm = NULL;}
  we->tsm = CreateSummary(vw, par.grp); if (!we->tsm) return;
  tbw.op = CreateHOPN(we->tsm, FALSE); if (!tbw.op) return;
  we->hsum = CreateTableWindow(hFRM(hwnd), IDSUM, &tbw);
}

void LOCALF cmd_check(HWND hwnd)
{ // `FbN
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  int re;

  if (we->flg & TBCS_DED) return;
  BusyMsg(hFRM(hwnd), "...");
  reset_error();
  re = CheckTable(OHTBL(we->op));
  EndBusy(hFRM(hwnd));
  OkBox(hFRM(hwnd), re? "G[͌܂łB": "G[܂B", NULL);
}

void LOCALF cmd_edit(HWND hwnd)
{ // sҏW
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  HBUF rb;

  if (we->flg & TBCS_DER) {
    SendMessage(hwnd, TBCM_MOVECUR, MVC_HOM, TRUE);
    SendMessage(hwnd, TBCM_EDITCELL, 0, 0); return;
  }
  rb = CreateRowBuf(OHTBL(we->op)); if (!rb) return;
  SendMessage(hwnd, TBCM_GETCURROW, (WPARAM)rb, 0);
  SendMessage(hwnd, TBCM_MOVECUR, MVC_SEL, TRUE);
  if (EditRowDlgBox(hwnd, rb, WindowText(hwnd))) {
    SendMessage(hwnd, TBCM_SETCURROW, (WPARAM)rb, 0);
  } else {
    SendMessage(hwnd, TBCM_SETSEL, FALSE, TRUE);
  }
  DeleteRowBuf(rb);
}

void LOCALF cmd_addedit(HWND hwnd)
{ // sǉĕҏW
  SendMessage(hwnd, TBCM_MOVECUR, MVC_BTM, TRUE);
  SendMessage(hwnd, WM_COMMAND, IDM_EDIT, 0);
}

void LOCALF cmd_insertedit(HWND hwnd)
{ // s}ĕҏW
  if (!SendMessage(hwnd, TBCM_GETSEL, 0, 0)) {
    SendMessage(hwnd, TBCM_MOVECUR, MVC_SEL, TRUE);
  }
  SendMessage(hwnd, TBCM_INSERT, 0, 0);
  SendMessage(hwnd, WM_COMMAND, IDM_EDIT, 0);
}

void LOCALF cmd_seldelete(HWND hwnd)
{ // s폜
  if (SendMessage(hwnd, TBCM_GETSEL, 0, 0)) {
    SendMessage(hwnd, TBCM_DELETE, 0, 0); return;
  }
  SendMessage(hwnd, TBCM_MOVECUR, MVC_SEL, TRUE);
  if (YesNoBox(hFRM(hwnd), "̍s폜܂H", NULL) == IDYES) {
    SendMessage(hwnd, TBCM_DELETE, 0, 0);
  } else {
    SendMessage(hwnd, TBCM_SETSEL, FALSE, TRUE);
  }
}

void LOCALF cmd_psort(HWND hwnd)
{ // Iɕבւ
  HVIW vw;

  if (YesNoBox(hFRM(hwnd), "݂̕\Ńf[^𕨗Iɕבւ܂B낵łH", NULL) != IDYES) return;
  vw = (HVIW)SendMessage(hwnd, TBCM_GETVIEW, 0, 0);
  BusyMsg(hFRM(hwnd), "...");
  SortTableRowsByView(vw);
  SendMessage(hwnd, TBCM_UPDATE, FALSE, TRUE);
  EndBusy(hFRM(hwnd));
}

LRESULT LOCALF TBL_command(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // R}h
  switch (LOWORD(wpa)) {
  case IDM_SAVE:
    cmd_save(hwnd); break;
  case IDM_IMPORT:
    cmd_import(hwnd); break;
  case IDM_EXPORT:
    cmd_export(hwnd); break;
  case IDM_PRINT:
    cmd_printtbl(hwnd); break;
  case IDM_CUT:
    SendMessage(hwnd, TBCM_CUT, 0, 0); break;
  case IDM_COPY:
    SendMessage(hwnd, TBCM_COPY, 0, 0); break;
  case IDM_PASTE:
    SendMessage(hwnd, TBCM_PASTE, 0, 0); break;
  case IDM_CLEAR:
    SendMessage(hwnd, TBCM_CLEAR, 0, 0); break;
  case IDM_INSERT:
    SendMessage(hwnd, TBCM_INSERT, 0, 0); break;
  case IDM_DELETE:
    SendMessage(hwnd, TBCM_DELETE, 0, 0); break;
  case IDM_OPENLINK:
    SendMessage(hwnd, TBCM_OPENLINK, 0, 0); break;
  case IDM_SEARCH:
    cmd_search(hwnd, 0); break;
  case IDM_NSEARCH:
    cmd_search(hwnd, 1); break;
  case IDM_VIEW:
    cmd_view(hwnd); break;
  case IDM_ARRANGE:
    cmd_arrange(hwnd, 0); break;
  case IDM_FILTER:
    cmd_arrange(hwnd, 1); break;
  case IDM_SORT:
    cmd_arrange(hwnd, 2); break;
  case IDM_VIEWA:
    cmd_viewa(hwnd, 0); break;
  case IDM_VIEWB:
    cmd_viewa(hwnd, 1); break;
  case IDM_SETVOPT:
    cmd_setvopt(hwnd); break;
  case IDM_SUMMARY:
    cmd_summary(hwnd); break;
  case IDM_CHECK:
    cmd_check(hwnd); break;
  case IDM_EDIT:
    cmd_edit(hwnd); break;
  case IDM_ADDEDIT:
    cmd_addedit(hwnd); break;
  case IDM_INSERTEDIT:
    cmd_insertedit(hwnd); break;
  case IDM_SELDELETE:
    cmd_seldelete(hwnd); break;
  case IDM_PSORT:
    cmd_psort(hwnd); break;
  }
  return 0;
}

LRESULT LOCALF TBL_close(HWND hwnd)
{ // \EBhE
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));
  int sv, re;

  sv = !(SendMessage(hwnd, TBCM_GETMODE, 0, 0) & TBCS_DED) && IsModified(we->op);
  if (sv) {
    re = YesNoCanBox(hFRM(hwnd), format("'%s'͕ύXĂ܂Bۑ܂H", WindowText(hwnd)), NULL);
    switch (re) {
    case IDYES: sv = TRUE;  break;
    case IDNO:  sv = FALSE; break;
    default: return 0;
    }
  }
  if (sv) {
    BusyMsg(hFRM(hwnd), "...");
    reset_error();
    re = CheckTable(OHTBL(we->op));
    EndBusy(hFRM(hwnd));
    if (!re) {
      ErrorBox(hFRM(hwnd), "G[܂B\nۑ̓LZ܂B", NULL);
      return 0;
    }
  }
  BusyMsg(hFRM(hwnd), sv? "ۑ...": "");
  reset_error();
  re = CloseTable(we->op, sv);
  EndBusy(hFRM(hwnd));
  if (sv && !re) {
    ErrorBox(hFRM(hwnd), format("'%s'̕ۑɎs܂B", TableFileName(OHTBL(we->op))), NULL);
  }
  return DefBOLTBLProc(hwnd, WM_CLOSE, 0, 0);
}

LRESULT LOCALF TBL_destroy(HWND hwnd)
{ // \EBhEI
  PTBWE we = (PTBWE)GetWindowLong(hwnd, sizeof(LONG));

  if (IsWindow(we->hprn)) SendMessage(hFRM(hwnd), FRMM_DESTROYCHILD, (WPARAM)we->hprn, 0);
  if (IsWindow(we->hsum)) SendMessage(hFRM(hwnd), FRMM_DESTROYCHILD, (WPARAM)we->hsum, 0);
  if (!(we->flg & TBCS_DCV)) {
    SetLastVIW(we->tv, we->bv);
    CopyUserVIWTable(we->tvu, we->tv);
    SaveUserVIW(we->tvu);
    DeleteRowBuf(we->bv);
    DeleteTable(we->tv);
    DeleteTable(we->tvu);
    DeleteTable(we->tvs);
  }
  DeleteTable(we->tg);
  DeleteTable(we->tsm);
  hfree(we);
  return DefBOLTBLProc(hwnd, WM_DESTROY, 0, 0);
}

LRESULT LOCALF TBL_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // EBhEvV[W
  switch (umsg) {
  case TBCM_SETTABLE:
    return TBL_settable(hwnd, (PTBWI)wpa);
  case TBCM_TRACKPOPUP:
    return TBL_trackpopup(hwnd, (PCPOSI)wpa);
  case WM_COMMAND:
    return TBL_command(hwnd, wpa, lpa);
  case WM_CLOSE:
    return TBL_close(hwnd);
  case WM_DESTROY:
    return TBL_destroy(hwnd);
  }
  return DefBOLTBLProc(hwnd, umsg, wpa, lpa);
}

int  LOCALF TBL_appstatus(HWND hwnd)
{ // \EBhȄԂ̎擾
  int fmt, sta = 0;
  POSI c;
  char bf[512];

  SendMessage(hwnd, TBCM_GETCUR, (WPARAM)&c, 0);
  fmt = SendMessage(hwnd, TBCM_GETCELLFORMAT, (WPARAM)&c, 0);
  if (fmt & DC_LNK) {
    SendMessage(hwnd, TBCM_GETCELLTEXT, (WPARAM)&c, (LPARAM)bf);
    if (bf[0] != '\0') sta |= APPS_LNK;
  }
  return sta;
}

HWND LOCALF CreateTableWindowX(HWND hwnd, int id, PTBWI wi, WNDPROC prc)
{ // \EBhE̍쐬
  static CREI cri = { "BOLTBL", wsCHV, };

  cri.tit = wi->tit? wi->tit: TableTitle(OHTBL(wi->op));
  cri.id = id? id: SendMessage(hwnd, FRMM_GETNEWID, IDPRN + 1, 0);
  cri.pa = (UINT)wi;
  return (HWND)SendMessage(hwnd, FRMM_CREATECHILD, (WPARAM)&cri, (LPARAM)prc);
}

HWND LOCALF CreateTableWindow(HWND hwnd, int id, PTBWI wi)
{ // \EBhE̍쐬
  return CreateTableWindowX(hwnd, id, wi, TBL_WndProc);
}

// ---------------------------------------------------------------------- //

int  LOCALF INDcd(PCSTR bf)
{ // lԍ̃`FbNfBWbg
  int i, s = 0;

  for (i = 1; i < 12; i++) {
    s += (bf[11 - i] - '0') * ((i <= 6)? i + 1: i - 5);
  }
  return (s % 11 > 1)? 11 - (s % 11): 0;
}

BOOL LOCALF IsIND(REAL d)
{ // lԍ
  int i;
  char bf[32];

  sprintf(bf, "%012.0f", d);
  for (i = 0; i < 12; i++) {
    if (bf[i] < '0' || bf[i] > '9') return FALSE;
  }
  if (bf[12] != '\0') return FALSE;
  return (bf[11] - '0') == INDcd(bf);
}

int  LOCALF CORcd(PCSTR bf)
{ // @lԍ̃`FbNfBWbg
  int i, s = 0;

  for (i = 0; i < 12; i++) {
    s += (bf[12 - i] - '0') * ((i % 2) + 1);
  }
  return 9 - (s % 9);
}

BOOL LOCALF IsCOR(REAL d)
{ // @lԍ
  int i;
  char bf[32];

  sprintf(bf, "%012.0f", d);
  for (i = 0; i < 13; i++) {
    if (bf[i] < '0' || bf[i] > '9') return FALSE;
  }
  if (bf[13] != '\0') return FALSE;
  return (bf[0] - '0') == CORcd(bf);
}

  // f[^͕\
typedef struct {
  WORD  ser;
  BYTE  suf;
  BYTE  atr;
  char  zip[12];
  char  adr[64];
  char  nam[64];
  char  kan[64];
  char  tel[16];
  REAL  pin;
  char  acc[32];
  char  det[48];
  int   fee;
  int   unp;
  int   tax;
  int   unc;
  char  rem[64];
  char  mem[64];
  int   reg;
  char  usr[32];
  BYTE  rsv[20];
} HOUD;
typedef HOUD * PHOUD;
typedef const HOUD * PCHOUD;

#define  idHOU  0
#define  tbHOU  DBTable(idHOU)

PVOID LOCALF fdefSER(PVOID pv, PCVOID pb, PCCOLI co)
{ // AԊl
  WORD max = 0;
  PCHOUD pc, pe;

  for (pc = TablePtr(tbHOU), pe = pc + NTableRows(tbHOU); pc < pe; pc++) {
    if (pc->ser > max) max = pc->ser;
  }
  *(WORD *)pv = (WORD)(max + 1);
  return pv;
}

PVOID LOCALF fdefSUF(PVOID pv, PCVOID pb, PCCOLI co)
{ // }Ԋl
  *(BYTE *)pv = 1; return pv;
}

static PCSTR SATR[] = { "", "l", "@l", "ǉ" };
static ENMS esATR = { SATR, NELEM(SATR) };

PVOID LOCALF fdefREG(PVOID pv, PCVOID pb, PCCOLI co)
{ // o^l
  *(int *)pv = CurDate(); return pv;
}

PVOID LOCALF fdefUSR(PVOID pv, PCVOID pb, PCCOLI co)
{ // o^Ҋl
  return ColumnScan(pv, CurUser(), co);
}

static COLI ciHOU[] = {
  { TID_U2B,  0, "ser", "A", "A@", CF_KEY, fdefSER, },
  { TID_U1B,  0, "suf", "}", "}@", CF_KEY|CF_PAC, fdefSUF, },
  { TID_E1B,  0, "atr", "", "@", CF_DDL, NULL, NULL, (UINT)&esATR, },
  { ASC(12),  8, "zip", "X֔ԍ",     },
  { STR(64),  0, "adr", "Z(ݒn)", },
  { STR(64), 25, "nam", "()",   },
  { STR(64), 25, "kan", "ӂ肪",     },
  { ASC(16), 12, "tel", "dbԍ",     },
  { TID_F8B, 13, "pin", "l(@l)ԍ", NULL, CF_HZR|CF_GR2, NULL, NULL, (UINT)"%012.0f", },
  { STR(32), 16, "acc", "敪", "@", },
  { STR(48), 20, "det", "ז", "ׁ@", },
  { TID_M4B, 12, "fee", "xz",     NULL, CF_HZR, },
  { TID_M4B, 12, "unp", "z",     NULL, CF_HZR|CF_GR2, },
  { TID_M4B, 12, "tax", "򒥎Ŋz", NULL, CF_HZR, },
  { TID_M4B, 12, "unc", "Ŋz",   NULL, CF_HZR|CF_GR2, },
  { STR(64),  0, "rem", "Ev", "E@v", },
  { STR(64),  0, "mem", "", "@", },
  { TID_YMD,  0, "reg", "o^",       NULL, 0, fdefREG, },
  { STR(32), 16, "usr", "o^",       NULL, CF_PAC, fdefUSR, },
  { BIN(20),  0, "rsv", "|",           },
};
static COLS csHOU = { ciHOU, NELEM(ciHOU) };
static VIWI viHOU[] = {
  { "x(ȗ)", 0, "ser, suf, atr, adr, nam, pin, acc, det, fee, tax", "", "" },
  { "x(ڍ)", 0, "ser, suf, atr, adr, nam, pin, acc, det, fee, unp, tax, unc, rem", "", "" },
  { "x",     0, "ser, suf, atr, zip, adr, nam", "", "" },
  { "S",         0, "ser, suf, atr, zip, adr, nam, kan, tel, pin, acc, det, fee, unp, tax, unc, rem, mem, reg, usr", "", "" },
};
static VIWS vsHOU = { viHOU, NELEM(viHOU) };

static PCSTR SOPR[] = { "Open", "Update", "Insert", "Delete", "Print(1)", "Print(2)" };

#define  LFILE  "HOULOG.LOG"

void LOCALF oprlog(int opr, int ser, int suf)
{ // 샍Oo
  HANDLE hf;
  char *pt, bf[256];

  pt = bf;
  pt += sprintf(pt, "%s %s %s", dtformat("yyyy/mm/dd hh:mm:ss", now()), SOPR[opr], CurUser());
  if (opr >= 1 && opr <= 3) pt += sprintf(pt, " %d-%d", ser, suf);
  hf = open_file(LFILE, OP_APD); if (!hf) return;
  set_file_ptr(hf, 0, FILE_END);
  write_line(hf, bf);
  close_file(hf);
}

BOOL LOCALF ftrgHOU(HTBL tb, int msg, int ir, PHOUD pb)
{ // f[^͕\엚
  switch (msg) {
  case TRGM_UPDATERECORD:
  case TRGM_INSERTRECORD:
  case TRGM_DELETERECORD:
    oprlog(msg - TRGM_UPDATERECORD + 1, pb->ser, pb->suf);
    break;
  }
  return DefaultTableTrigger(tb, msg, ir, pb);
}

static PCSTR EDSC[] = {
  "",
  "Z",         // 1
  "ݒn",       // 2
  "",         // 3
  "̖",         // 4
  "lԍ",     // 5
  "@lԍ",     // 6
  "lԍs",     // 7
  "@lԍs",     // 8
  "敪",         // 9
  "xz",     //10
};

int  LOCALF echkHOU(PCHOUD pc)
{ // G[R[h
  if (pc->atr == 1 || pc->atr == 2) {
    if (pc->adr[0] == '\0') return 1 + (pc->atr == 2);
    if (pc->nam[0] == '\0') return 3 + (pc->atr == 2);
    if (pc->pin == 0.0)     return 5 + (pc->atr == 2);
  }
  if (pc->atr == 1 && !IsIND(pc->pin)) return 7;
  if (pc->atr == 2 && !IsCOR(pc->pin)) return 8;
  if (pc->atr != 0) {
    if (pc->acc[0] == '\0' && (pc->fee != 0 || pc->tax != 0)) return 9;
    if (pc->acc[0] != '\0' && pc->fee == 0) return 10;
  }
  return 0;
}

static TBLI tiHOU[] = {
  { &csHOU, &vsHOU, "HOUDAT", "f[^͕\", NULL, TF_CYP, (FTRG)ftrgHOU, NULL, 0, sizeof(HOUD) },
};
static TBLS tsHOU = { tiHOU, NELEM(tiHOU) };

#define  PRGTIT  "x쐬"
#define  PRGDSC  "}Cio[Ŏx쐬"
#define  PRGVER  "Version "VI_STR

static BDBI dbHOU = { &tsHOU, PRGNAM, PRGTIT, PRGDSC };

// ---------------------------------------------------------------------- //

  // Cj[
static MNUI BOLMI[] = {
  { mfP,  0,             "t@C(&F)"            }, // 0 t@C
  { mf_,  IDM_OMENU1,    "j[(&M)"            },
  { mf_,  0,             ""                        },
  { mf_,  IDM_OPEN,      "f[^͕\(&O)\tCtrl+O" },
  { mf_,  IDM_CLOSE,     "(&C)\tCtrl+F4"     },
  { mf_,  IDM_SAVE,      "㏑ۑ(&S)\tCtrl+S"    },
  { mf_,  0,             ""                        },
  { mf_,  IDM_IMPORT,    "eLXg捞(&I)..."     },
  { mf_,  IDM_EXPORT,    "eLXgo(&E)..."     },
  { mf_,  0,             ""                        },
  { mf_,  IDM_PRINT,     "(&P)...\tCtrl+P"     },
  { mf_,  0,             ""                        },
  { mfE,  IDM_EXIT,      "I(&X)"                },
  { mfP,  0,             "ҏW(&E)"                }, // 1 ҏW
  { mf_,  IDM_CUT,       "؂(&T)\tCtrl+X"    },
  { mf_,  IDM_COPY,      "Rs[(&C)\tCtrl+C"      },
  { mf_,  IDM_PASTE,     "\t(&P)\tCtrl+V"    },
  { mf_,  0,             ""                        },
  { mf_,  IDM_CLEAR,     "NA(&A)"              },
  { mf_,  IDM_INSERT,    "}(&I)\tCtrl+E"        },
  { mf_,  IDM_DELETE,    "폜(&D)\tCtrl+D"        },
  { mf_,  0,             ""                        },
  { mf_,  IDM_SEARCH,    "(&F)...\tCtrl+F"     },
  { mfE,  IDM_NSEARCH,   "(&N)\tF3"        },
  { mfP,  0,             "\(&V)"                }, // 2 \  VIW_POS
  { mf_,  IDM_VIEW,      "\`(&V)...\tF5"     },
  { mf_,  0,             ""                        },
  { mf_,  IDM_ARRANGE,   "\(&A)..."         },
  { mf_,  IDM_FILTER,    "i荞(&F)..."         },
  { mf_,  IDM_SORT,      "בւ(&S)..."         },
  { mf_,  0,             ""                        },
  { mf_,  IDM_VIEWA,     "Sڕ\(&W)\tF10"     },
  { mf_,  IDM_VIEWB,     "\`(&B)\tShift+F10" },
  { mf_,  0,             ""                        },
  { mfE,  IDM_SETVOPT,   "\IvV(&O)..."   },
  { mfP,  0,             "f[^(&D)"              }, // 3 f[^
  { mf_,  IDM_SUMMARY,   "Wv(&S)..."             },
  { mf_,  0,             ""                        },
  { mf_,  IDM_CHECK,     "`FbN(&C)\tShift+F5"  },
  { mf_,  0,             ""                        },
  { mf_,  IDM_EDIT,      "sҏW(&E)\tF8"          },
  { mf_,  IDM_ADDEDIT,   "sǉ(&A)\tShift+F7"    },
  { mf_,  IDM_INSERTEDIT,"s}(&I)\tF9"          },
  { mf_,  IDM_SELDELETE, "s폜(&D)\tShift+F9"    },
  { mf_,  0,             ""                        },
  { mfE,  IDM_PSORT,     "Iɕבւ(&P)"    },
  { mfP,  0,             "(&P)"                }, // 4 
  { mf_,  IDM_CHECK1,    "f[^`FbN(&C)"      },
  { mf_,  IDM_REPORT1,   "x(&R)..."     },
  { mf_,  IDM_REPORT2,   "x(&E)..."   },
  { mf_,  0,             ""                        },
  { mf_,  IDM_INFO1,     "엚mF(&I)"        },
  { mf_,  0,             ""                        },
  { mf_,  IDM_SITEWHO,   "OC(&S)"        },
  { mf_,  0,             ""                        },
  { mf_,  IDM_SETUSR,    "[U[Ǘ(&U)"        },
  { mf_,  IDM_UNLOCK,    "bN(&L)..."       },
  { mfE,  IDM_BACKUP,    "obNAbv(&B)..."     },
  { mfP,  0,             "c[(&T)"              }, // 5 c[
  { mf_,  IDM_SETENV,    "{ݒ(&E)..."         },
  { mf_,  0,             ""                        },
  { mf_,  IDM_CSVOUT,    "opbruo(&C)..." },
  { mf_,  0,             ""                        },
  { mfE,  IDM_SETOPT,    "IvVݒ(&O)..."   },
  { mfP,  0,             "EBhE(&W)"          }, // 6 EBhE  WIN_POS
  { mf_,  IDM_PREVWINDOW,"ÕEBhE(&P)\tShift+Ctrl+F6" },
  { mf_,  IDM_NEXTWINDOW,"̃EBhE(&N)\tCtrl+F6" },
  { mf_,  0,             ""                        },
  { mf_,  IDM_MAXIMIZE,  "PƂŕ\(&M)"          },
  { mf_,  IDM_TILE,      "Eɕׂĕ\(&T)"    },
  { mfE,  IDM_HTILE,     "㉺ɕׂĕ\(&H)"    },
  { mfPE, 0,             "wv(&H)"              }, // 7 wv
  { mf_,  IDM_MANUAL,    "}jA(&M)\tF1"      },
  { mf_,  0,             ""                        },
  { mfE,  IDM_ABOUT,     "o[W(&A)"      },
};
static MNUS BOLMS = { BOLMI, NELEM(BOLMI) };

#define  VIW_POS  2
#define  WIN_POS  6

static MNUI PRNMI[] = {
  { mfP,  0,             "\(&V)"                }, // \(PRN)
  { mf_,  IDM_PREVPAGE,  "Oy[W(&P)\tCtrl+Alt+P" },
  { mf_,  IDM_NEXTPAGE,  "y[W(&N)\tCtrl+Alt+N" },
  { mf_,  0,             ""                        },
  { mf_,  IDM_SETPRN,    "pݒ(&S)\tCtrl+Alt+S" },
  { mf_,  0,             ""                        },
  { mf_,  IDM_ZOOMIN,    "g(&Z)\tCtrl+;"        },
  { mf_,  IDM_ZOOMOUT,   "k(&O)\tCtrl+-"        },
  { mf_,  0,             ""                        },
  { mf_,  IDM_SAMESCALE, "{\(&S)\tCtrl+1"    },
  { mfE,  IDM_AUTOSCALE, "S̕\(&A)\tCtrl+0"    },
};
static MNUS PRNMS = { PRNMI, NELEM(PRNMI) };

  // c[o[
static TOBI BOLTI[] = {
  { tbfB,      IDM_PREVWINDOW, "ÕEBhE" }, //  0
  { tbfB,      IDM_NEXTWINDOW, "̃EBhE" },
  { tbfV,      0,              ""               },
  { tbfL(192), IDBAS,          ""               },
  { tbfB,      IDM_CLOSE,      ""         },
  { tbfV,      0,              ""               },
  { tbfB,      IDM_SETENV,     "{ݒ"       },
  { tbfB,      IDM_OPEN,       "f[^͕\"   },
  { tbfB,      IDM_SAVE,       "㏑ۑ"       },
  { tbfB,      IDM_PRINT,      ""           },
  { tbfV,      0,              ""               },
  { tbfB,      IDM_CUT,        "؂"       }, // 11  CUT_IDX
  { tbfB,      IDM_COPY,       "Rs["         },
  { tbfB,      IDM_PASTE,      "\t"       },
  { tbfB,      IDM_SEARCH,     ""           },
  { tbfV,      0,              ""               },
  { tbfB,      IDM_VIEW,       "\`"       },
  { tbfB,      IDM_ARRANGE,    "\"       },
  { tbfB,      IDM_FILTER,     "i荞"       },
  { tbfB,      IDM_SORT,       "בւ"       },
  { tbfV,      0,              ""               },
  { tbfB,      IDM_SUMMARY,    "Wv"           },
  { tbfB,      IDM_CHECK,      "`FbN"       },
  { tbfB,      IDM_EDIT,       "sҏW"         },
  { tbfB,      IDM_ADDEDIT,    "sǉ"         },
  { tbfB,      IDM_INSERTEDIT, "s}"         },
  { tbfB,      IDM_SELDELETE,  "s폜"         },
  { tbfV,      0,              ""               },
};
static TOBS BOLTS = { BOLTI, NELEM(BOLTI) };

#define  CUT_IDX 11

static TOBI PRNVW[] = {
  { tbfB,      IDM_PREVPAGE,   "Oy[W"       },
  { tbfB,      IDM_NEXTPAGE,   "y[W"       },
  { tbfL(54),  IDPAG,          ""               },
  { tbfB,      IDM_SETPRN,     "pݒ"       },
  { tbfV,      0,              ""               },
  { tbfB,      IDM_ZOOMIN,     "g"           },
  { tbfB,      IDM_ZOOMOUT,    "k"           },
  { tbfL(42),  IDSCL,          ""               },
  { tbfB,      IDM_SAMESCALE,  "{\"       },
  { tbfB,      IDM_AUTOSCALE,  "S̕\"       },
  { tbfV,      0,              ""               },
};
static TOBI PRNTI[CUT_IDX + NELEM(PRNVW)];
static TOBS PRNTS = { PRNTI, NELEM(PRNTI) };

void LOCALF PrepToolBar(void)
{ // c[o[ݒ
  int i;

  for (i = 0; i < NELEM(PRNTI); i++) {
    PRNTI[i] = (i < CUT_IDX)? BOLTI[i]: PRNVW[i - CUT_IDX];
  }
}

static TOBI BOLSI[] = {
  { tbfL(512), IDBAS, "" },
};
static TOBS BOLSS = { BOLSI, NELEM(BOLSI) };

  // Jnj[
static MNDI BOLDI[] = {
  { mf_,  IDM_OPEN,      "f[^͕\",    BID_TABLE   }, //  0
  { mf_,  IDM_CHECK1,    "f[^`FbN",  BID_TEXT    },
  { mf_,  IDM_REPORT1,   "x",    BID_REPORT  },
  { mf_,  IDM_REPORT2,   "x",  BID_REPORT  },
  { mf_,  IDM_SETENV,    "{ݒ",        BID_INPUT   },
  { mf_,  IDM_SETOPT,    "IvVݒ",  BID_SYSTEM  },
  { mf_,  IDJMP + 1,     "VXeǗ",    BID_SYSTEM  },
  { mf_,  IDM_EXIT,      "I@@",        BID_EXIT    },
  { mf_,  IDM_SETUSR,    "[U[Ǘ",    BID_TABLE   }, //  1
  { mf_,  IDM_INFO1,     "엚mF",    BID_TEXT    },
  { mf_,  IDM_SITEWHO,   "OC",    BID_SYSTEM  },
  { mf_,  IDM_UNLOCK,    "bN",      BID_SYSTEM  },
  { mf_,  IDM_BACKUP,    "obNAbv",    BID_SYSTEM  },
  { mf_,  0,             "",                0           },
  { mf_,  0,             "",                0           },
  { mf_,  IDJMP,         "߁@@",        BID_BACK    },
};
static MNDS BOLDS = { BOLDI, NELEM(BOLDI), 0, 0, NULL, NULL };

  // ݒ
typedef struct {
  char  stit[64];
  char  padr[64];
  char  pnam[64];
  char  ptel[16];
  REAL  ppin;
  char  num1[16];
  char  num2[16];
  char  snum[8];
  char  udir[512];
} ENVD;

static COLI ciENV[] = {
  { STR(64),  0, "SlipTit", "[HOUENV]", }, // 0
  { STR(64),  0, "PayrAdr", },
  { STR(64),  0, "PayrNam", },
  { STR(16),  0, "PayrTel", },
  { TID_F8B,  0, "PayrPIN", NULL, NULL, CF_HZR, NULL, NULL, (UINT)"%012.0f" }, // 4
  { STR(16),  0, "RefNum1", },
  { STR(16),  0, "RefNum2", },
  { STR(8),   0, "SlipNum", },
  { STR(512), 0, "UserDir", },
};
#define  ciPPIN  ciENV[4]
static COLS csENV = { ciENV, NELEM(ciENV) };
static TBLI tiENV = { &csENV, NULL, "HOUENV", NULL, NULL, 0, NULL, "HOUENV.INI", 0, sizeof(ENVD) };

ENVD EnvDat;

void LOCALF setenv(void)
{ // ݒ
  SITI var;

  var.nam = PRGNAM;
  var.tit = PRGTIT;
  var.dsc = PRGDSC;
  var.tax = 0.0;
  var.fym = 0;
  var.nmf = 0;
  var.dir = EnvDat.udir;
  SetSiteVariables(&var);
}

void LOCALF LoadENV(void)
{ // ݒǍ
  strcpyx(EnvDat.stit, "ߘaTN@VAA_yя܋̎x", sizeof(EnvDat.stit) - 1);
  strcpyx(EnvDat.snum, "309", sizeof(EnvDat.snum) - 1);
  strcpyx(EnvDat.udir, UserPath(), sizeof(EnvDat.udir) - 1);
  if (file_exists(tiENV.imp)) {
    ReadINI(&EnvDat, &tiENV);
  }
  setenv();
}

void LOCALF SaveENV(void)
{ // ݒ菑o
  setenv();
  WriteINI(&EnvDat, &tiENV);
}

#define  UOPT_ALI  0x0001
#define  UOPT_UMD  0x0002
#define  UOPT_ACN  0x0004
#define  UOPT_AOP  0x0008
#define  UOPT_ELG  0x0010

#define  BGRC_PTR  RGB(208,255,224)
#define  BGRC_IDX  RGB(208,208,208)
#define  BGRC_OLD  RGB(255,224,208)

  // ݒ
typedef struct {
  WPOS  wpo;
  char  face[32]; // -+
  int   ptsz;     //  |
  int   tbcs;     //  |
  int   cptr;     //  |
  int   cidx;     //  |
  int   uopt;     //  |
  char  unam[32]; //  |= OPTP
  char  upwd[32]; // -+
  char  bdir[512];
} INID;

static COLI ciINI[] = {
  { TID_I4B,  0, "WinPosX", "["PRGNAM"]", }, // 0
  { TID_I4B,  0, "WinPosY", },
  { TID_I4B,  0, "WinSizW", },
  { TID_I4B,  0, "WinSizH", },
  { TID_I4B,  0, "WinMaxm", },
  { STR(32),  0, "TblFont", },
  { TID_I4B,  0, "TblFSiz", },
  { TID_I4B,  0, "TblStyl", },
  { TID_HEX,  0, "CPtrCol", }, // 8
  { TID_HEX,  0, "CIdxCol", }, // 9
  { TID_I4B,  0, "UserOpt", },
  { STR(32),  0, "UserNam", },
  { STR(32),  0, "UserPwd", NULL, NULL, CF_HCH, },
  { STR(512), 0, "BackDir", },
};
#define  ciCPTR  ciINI[8]
#define  ciCIDX  ciINI[9]
static COLS csINI = { ciINI, NELEM(ciINI) };
static TBLI tiINI = { &csINI, NULL, "HOUINI", NULL, NULL, 0, NULL, PRGNAM".INI", 0, sizeof(INID) };

static INID IniDat = {
  { 0, 0, 1200, 730, FALSE },
  DEFFACE, DEFPTSZ,
  0,
  BGRC_PTR, BGRC_IDX,
  UOPT_UMD,
  "", "",
  "",
};

PCSTR LOCALF defface(void) { return IniDat.face;}
int  LOCALF defptsz(void)  { return IniDat.ptsz;}
int  LOCALF optflg(void)   { return IniDat.tbcs;}

void LOCALF LoadINI(void)
{ // t@CǍ
  LOGFONT lof;
  char bak[512];

  get_working_path(bak, sizeof(bak));
  set_working_path(UserPath());
  if (file_exists(tiINI.imp)) {
    ReadINI(&IniDat, &tiINI);
  }
  set_working_path(bak);
  SetAppFont(FID_DEF, CreateFontIndirect(SetLOGFONT(&lof, IniDat.face, PT2DOTS(IniDat.ptsz), 0)));
  SetAppColor(CID_PTR, IniDat.cptr); if (IniDat.cidx == BGRC_OLD) IniDat.cidx = BGRC_IDX;
  SetAppColor(CID_IDX, IniDat.cidx);
  if (IniDat.uopt & UOPT_ELG) enable_error_logging();  else disable_error_logging();
}

void LOCALF SaveINI(void)
{ // t@Co
  int sw;
  char bak[512];

  if (!(IniDat.uopt & UOPT_ALI)) IniDat.upwd[0] = '\0';
  get_working_path(bak, sizeof(bak));
  set_working_path(UserPath());
  sw = disable_error_reporting();
  WriteINI(&IniDat, &tiINI);
  if (sw) enable_error_reporting();
  set_working_path(bak);
}

int LOCALF AppStatusX(HWND hwnd)
{ // Ԃ̎擾
  int sta;

  sta = AppStatus(hwnd);
  switch (sta & APPS_ACT) {
  case APPS_PRN: sta |= PRN_appstatus((HWND)SendMessage(hwnd, FRMM_GETACTIVE, 0, 0)); break;
  case APPS_TBL: sta |= TBL_appstatus((HWND)SendMessage(hwnd, FRMM_GETACTIVE, 0, 0)); break;
  }
  return sta;
}

#define  sta_ACT  ((sta & APPS_ACT) != 0)
#define  sta_NON  ((sta & APPS_ACT) == 0)
#define  sta_PRN  ((sta & APPS_ACT) == APPS_PRN)
#define  sta_TBL  ((sta & APPS_ACT) == APPS_TBL)
#define  sta_EDI  ((sta & APPS_DED) == 0)
#define  sta_SEL  ((sta & APPS_SEL) != 0)
#define  sta_MUL  ((sta & APPS_MUL) != 0)
#define  sta_CFT  ((sta & APPS_CFT) != 0)
#define  sta_CFB  ((sta & APPS_CFB) != 0)
#define  sta_PVP  ((sta & APPS_PVP) != 0)
#define  sta_NXP  ((sta & APPS_NXP) != 0)
#define  sta_SKP  ((sta & APPS_SKP) != 0)
#define  sta_LSC  ((sta & APPS_LSC) != 0)
#define  sta_USC  ((sta & APPS_USC) != 0)
#define  sta_LNK  ((sta & APPS_LNK) != 0)

BOOL LOCALF Enabled(int id, int sta)
{ // R}hgp\ǂ̔
  switch (id) {
  case IDM_OMENU:
  case IDM_OMENU1:
  case IDM_OPEN:
  case IDM_CHECK1:
  case IDM_REPORT1:
  case IDM_REPORT2:
  case IDM_INFO1:
  case IDM_CSVOUT:
  case IDM_SETOPT:
    return sta_NON;
  case IDM_CLOSE:
  case IDM_PRINT:
    return sta_ACT;
  case IDM_SAVE:
  case IDM_CHECK:
    return sta_TBL && sta_EDI && CurAuth() >= 2;
  case IDM_PASTE:
    return (sta_TBL && ((sta_CFB && sta_SEL) || sta_CFT)) && sta_EDI && CurAuth() >= 2;
  case IDM_IMPORT:
  case IDM_CLEAR:
  case IDM_EDIT:
  case IDM_ADDEDIT:
  case IDM_INSERTEDIT:
  case IDM_SELDELETE:
  case IDM_PSORT:
  case IDM_CUT:
    return sta_TBL && sta_EDI && CurAuth() >= 2;
  case IDM_EXPORT:
  case IDM_VIEW:
  case IDM_ARRANGE:
  case IDM_FILTER:
  case IDM_SORT:
  case IDM_VIEWA:
  case IDM_VIEWB:
  case IDM_SETVOPT:
  case IDM_SUMMARY:
  case IDM_COPY:
    return sta_TBL;
  case IDM_INSERT:
  case IDM_DELETE:
    return sta_TBL && sta_SEL && sta_EDI && CurAuth() >= 2;
  case IDM_OPENLINK:
    return sta_TBL && sta_LNK;
  case IDM_SEARCH:
  case IDM_NSEARCH:
    return sta_TBL && !sta_SEL;
  case IDM_UNLOCK:
  case IDM_BACKUP:
  case IDM_SETENV:
    return sta_NON && CurAuth() >= 3;
  case IDM_SETUSR:
    return sta_NON && CurAuth() == 4;
  case IDM_PREVWINDOW:
  case IDM_NEXTWINDOW:
  case IDM_MAXIMIZE:
  case IDM_TILE:
  case IDM_HTILE:
    return sta_MUL;
  case IDM_PREVPAGE:
    return sta_PRN && sta_PVP;
  case IDM_NEXTPAGE:
    return sta_PRN && sta_NXP;
  case IDM_SETPRN:
    return sta_PRN && !sta_SKP;
  case IDM_ZOOMIN:
    return sta_PRN && !sta_USC;
  case IDM_ZOOMOUT:
    return sta_PRN && !sta_LSC;
  case IDM_SAMESCALE:
  case IDM_AUTOSCALE:
  case IDM_INVERT:
    return sta_PRN;
  }
  return TRUE;
}

PMNUS LOCALF viwpop(int sta)
{ // \j[
  int i, i1, i2, j;
  static MNUI VMI[24];
  static MNUS VMS = { VMI, 0 };

  switch (sta & APPS_ACT) {
  case APPS_PRN: return &PRNMS;
  }
  MenuSlice(&i1, &i2, &BOLMS, VIW_POS);
  for (i = i1, j = 0; i < i2 && j < NELEM(VMI); i++, j++) {
    VMI[j] = BOLMI[i];
  }
  VMI[j-1].flg |= mfE;
  VMS.ni = j;
  return &VMS;
}

PMNUS LOCALF winpop(HWND hwnd)
{ // EBhEj[
  int i, i1, i2, j, j0, nc;
  HWND hchi;
  static MNUI WMI[24], WM0 = { mf_, 0, "" };
  static MNUS WMS = { WMI, 0 };

  MenuSlice(&i1, &i2, &BOLMS, WIN_POS);
  for (i = i1, j = 0; i < i2 && j < NELEM(WMI); i++, j++) {
    WMI[j] = BOLMI[i];
  }
  WMI[j-1].flg |= mfE;
  nc = SendMessage(hwnd, FRMM_GETNCHILDREN, 0, 0);
  if (nc > 0) {
    WMI[j-1].flg &=~mfE;
    WMI[j++] = WM0;
    j0 = j;
    for (i = nc - 1; i >= 0 && j < NELEM(WMI); i--, j++) {
      WMI[j].flg = (i == nc - 1)? mfC: mf_;
      hchi = (HWND)SendMessage(hwnd, FRMM_GETCHILD, i, 0);
      WMI[j].idm = IDM_WINDOW0 + j - j0;
      WMI[j].txt = basnam(WindowText(hchi));
    }
    WMI[j-1].flg |= mfE;
  }
  WMS.ni = j;
  return &WMS;
}

void LOCALF enummenuitems(HMENU hmnu, int sta)
{ // j[ڐݒ
  int i, n, id;
  HMENU hsub;

  n = GetMenuItemCount(hmnu);
  for (i = 0; i < n; i++) {
    id = GetMenuItemID(hmnu, i);
    if (id == -1 && !!(hsub = GetSubMenu(hmnu, i))) enummenuitems(hsub, sta);
    else if (id > 0) EnableMenuItem(hmnu, id, Enabled(id, sta)? mf_: mfG);
  }
}

LRESULT LOCALF FRM_initmenu(HWND hwnd, HMENU hmnu)
{ // j[ݒ
  int sta;

  sta = AppStatusX(hwnd);
  ChangeMenuBar(hmnu, VIW_POS, viwpop(sta));
  ChangeMenuBar(hmnu, WIN_POS, winpop(hwnd));
  DrawMenuBar(hwnd);
  enummenuitems(hmnu, sta);
  return 0;
}

LRESULT LOCALF FRM_inittool(HWND hwnd)
{ // c[o[ݒ
  int i, id, ni, sta;
  HWND hact, htob;
  PTOBS ts;
  static PTOBS bk;

  htob = GetDlgItem(hwnd, IDTOB); if (!htob) return 0;
  hact = (HWND)SendMessage(hwnd, FRMM_GETACTIVE, 0, 0);
  sta = AppStatusX(hwnd);
  switch (sta & APPS_ACT) {
  case APPS_PRN: ts = &PRNTS; break;
  default:       ts = &BOLTS; break;
  }
  if (ts != bk) {
    SendMessage(htob, TOBM_RESETITEMS, (WPARAM)ts, TRUE);
    bk = ts;
  }
  SetDlgItemText(htob, IDBAS, hact? basnam(WindowText(hact)): dformat("yyyy N m  d ", CurDate()));
  ni = SendMessage(htob, TOBM_GETNITEMS, 0, 0);
  for (i = 0; i < ni; i++) {
    if ((id = ((PTOBI)SendMessage(htob, TOBM_GETITEMINFO, i, 0))->idm) > 0) {
      EnableWindow(GetDlgItem(htob, id), Enabled(id, sta));
    }
  }
  switch (sta & APPS_ACT) {
  case APPS_PRN:
    SetDlgItemText(htob, IDPAG, PRN_PAG);
    SetDlgItemText(htob, IDSCL, PRN_SCL);
    break;
  }
  for (i = 0; i < BOLDS.ni; i++) {
    if ((id = BOLDS.mi[i].idm) > 0) {
      BOLDS.mi[i].flg = Enabled(id, sta)? mf_: mfG;
    }
  }
  return 0;
}

  // [U[ƃpX[h
typedef struct {
  char  usr[32];
  char  pwd[32];
} PWDP;

BOOL LOCALF getpwd_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // [U[mF_CAOvV[W
  PWDP *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (PWDP *)lpa));
    SetESTR(hdlg, 101, pa->usr);
    SetFocus(GetDlgItem(hdlg, (pa->usr[0] == '\0')? 101: 102));
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return FALSE;
  case WM_COMMAND:
    pa = (PWDP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, pa->usr, sizeof(pa->usr) - 1);
      GetESTR(hdlg, 102, pa->pwd, sizeof(pa->pwd) - 1);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

BOOL LOCALF GetPwd(HWND hwnd, PWDP *pa)
{ // [U[ƃpX[h擾
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 40,  8,  -1, "[U[:" },
    { C_ESTR|wsT,  48,  8,100, 12, 101, "" },
    { C_SLFT|wsG,   8, 26, 40,  8,  -1, "pX[h:" },
    { C_EPWD|wsT,  48, 24,100, 12, 102, "" },
    { C_BDEF|wsGT, 54, 60, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 106, 60, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 160, 80, "[U[mF" };

  return DlgBoxInput(hwnd, &dlg, getpwd_DlgProc, (LPARAM)pa) == IDOK;
}

BOOL LOCALF alreadyloggedin(PCSTR usr)
{ // ɃOCĂ
  int i, ni, re = FALSE;
  HTBL tb;

  if (file_size(PRGNAM".BSU") == 0) return FALSE;
  tb = CreateBSUTable(32, TRUE); if (!tb) return FALSE;
  ni = NTableRows(tb);
  for (i = 0; i < ni; i++) {
    if (stricmp(usr, TableRow(tb, i)) == 0) { re = TRUE; break;}
  }
  DeleteTable(tb);
  return re;
}

void LOCALF cmd_login(HWND hwnd)
{ // OC
  int re;
  static PCSTR alertstr =
    "̃[U[ɃOCĂ܂B\n"
    "vOdɋNĂȂmFĂB\n"
    "dNĂꍇAu~vł̃vOI邩\n"
    "ɋNIĂuĎsvős܂B\n"
    "dNĂȂꍇAuvősč\܂B";

  if (!(IniDat.uopt & UOPT_ALI)) {
   _L0: IniDat.upwd[0] = '\0';
    re = GetPwd(hwnd, (PWDP *)&IniDat.unam);
    if (!re) { SendMessage(hwnd, WM_CLOSE, 0, 0); return;}
  }
 _L1:
  reset_error();
  if (alreadyloggedin(IniDat.unam)) {
    re = AlertBox(hwnd, alertstr, NULL);
    switch (re) {
    default: SendMessage(hwnd, WM_CLOSE, 0, 0); return;
    case IDRETRY: goto _L1;
    case IDIGNORE: break;
    }
  }
  re = LoginSite(IniDat.unam, IniDat.upwd);
  if (!re) {
    ErrorBox(hwnd, "OCɎs܂B", NULL);
    IniDat.uopt &=~UOPT_ALI;
    goto _L0;
  }
  re = ConnectDBX(&dbHOU);
  if (!re) {
    ErrorBox(hwnd, "f[^x[Xւ̐ڑɎs܂B", NULL);
    SendMessage(hwnd, WM_CLOSE, 0, 0); return;
  }
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

PCSTR LOCALF sitewhostr(void)
{ // TCgւ̃OC󋵁At@C̃bN
  int i, ni;
  PSTR pt;
  PLCKI pc;
  HTBL tb;
  static char msg[512];

  *(pt = msg) = '\0';
  if (file_size(PRGNAM".BSU") == 0) goto _L1;
  tb = CreateBSUTable(32, TRUE); if (!tb) goto _L1;
  ni = NTableRows(tb);
  for (i = 0; i < ni; i++) {
    if (pt - msg < 450) {
      pt += sprintf(pt, (i == 0)? "'%s'": "A'%s'", TableRow(tb, i));
    }
  }
  if (ni > 0) pt += sprintf(pt, "OCłB");
  DeleteTable(tb);
  if (file_size(PRGNAM".LCK") == 0) goto _L1;
  tb = CreateLCKTable(32, TRUE); if (!tb) goto _L1;
  ni = NTableRows(tb);
  for (i = 0; i < ni; i++) {
    if (pt - msg < 450) {
      pc = TableRow(tb, i);
      pt += sprintf(pt, (i == 0)? "'%s''%s'": "A'%s''%s'", DBTableFileName(pc->id), pc->usr);
    }
  }
  if (ni > 0) pt += sprintf(pt, "bNĂ܂B");
  DeleteTable(tb); _L1:
  return msg;
}

void LOCALF cmd_omenu(HWND hwnd, BOOL sw)
{ // Jnj[
  int re;

  if (AppStatus(hwnd) & APPS_ACT) return;
  if (!sw && !(IniDat.uopt & UOPT_UMD)) return;
 _L0:
  BOLDS.msg2 = sitewhostr();
  re = MenuDlgBox(hwnd, &BOLDS, PRGTIT);
  if (re == IDREFRESH) { LoadENV(); goto _L0;}  else if (re == IDCANCEL) return;
  if (re == IDMANUAL) re = IDM_MANUAL;
  PostMessage(hwnd, WM_COMMAND, re, 0);
}

void LOCALF cmd_open(HWND hwnd)
{ // f[^͕\J
  HWND hchi;
  TBWI tbw = { NULL, 0, DBTableTitle(idHOU), &vsHOU, -1 };

  if (!!(hchi = (HWND)SendMessage(hwnd, FRMM_GETCHILDBYNAME, (WPARAM)tbw.tit, 0))) {
    ErrorBox(hwnd, "̃t@CɊJĂ܂B", NULL);
    SendMessage(hwnd, FRMM_ACTIVATE, (WPARAM)hchi, 0);
    return;
  }
  BusyMsg(hwnd, "Ǎ...");
  reset_error();
  tbw.op = OpenTable(tiHOU[idHOU].nam, (CurAuth() >= 2)? OM_RDW: OM_RDO);
  EndBusy(hwnd);
  if (!tbw.op) {
    ErrorBox(hwnd, format("'%s'̓ǍɎs܂B", tbw.tit), NULL);
    PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
    return;
  }
  hchi = CreateTableWindow(hwnd, 0, &tbw); if (!hchi) return;
  oprlog(0, 0, 0);
}

BOOL LOCALF errout(PCSTR nam)
{ // G[|[go
  int ec, cn = 0;
  HANDLE hf;
  PCHOUD pb, pe;

  hf = open_file(nam, OP_WRI); if (!hf) return (BOOL)ferr(E_FIW, nam);
  for (pb = TablePtr(tbHOU), pe = pb + NTableRows(tbHOU); pb < pe; pb++) {
    if ((ec = echkHOU(pb)) != 0) {
      write_line(hf, format("%s %3d-%d %s", tiHOU[idHOU].tit, pb->ser, pb->suf, EDSC[ec]));
      cn++;
    }
  }
  close_file(hf);
  return cn == 0;
}

void LOCALF cmd_check1(HWND hwnd)
{ // f[^`FbN
  int re = FALSE;
  HOPN op;
  PCSTR nam;

  if (YesNoBox(hwnd, "f[^`FbNs܂B낵łH", NULL) != IDYES) goto _L2;
  nam = adddir(UserPath(), "HOUERR.TXT");
  BusyMsg(hwnd, "...");
  reset_error();
  op = OpenTable(tiHOU[idHOU].nam, OM_RDO); if (!op) goto _L1;
  re = errout(nam);
  CloseTable(op, FALSE);
 _L1: EndBusy(hwnd);
  if (re) {
    OkBox(hwnd, "G[͌܂łB", NULL);
  } else if (YesNoBox(hwnd, "G[܂BG[|[g\܂H", NULL) == IDYES) {
    ShellExecute(NULL, "open", nam, NULL, NULL, SW_SHOWDEFAULT);
  }
 _L2:
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

BOOL LOCALF getD01_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // xݒ_CAOvV[W
  PINT pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (PINT)lpa));
    SetEINT(hdlg, 101,  *pa & 0x000f);
    SetEINT(hdlg, 102, (*pa & 0x00f0) >> 4);
    SetEINT(hdlg, 103, (*pa & 0x0f00) >> 8);
    SetEINT(hdlg, 104, (*pa & 0xf000) >>12);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (PINT)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      *pa = ((GetEINT(hdlg, 104) & 0x0f) <<12) | ((GetEINT(hdlg, 103) & 0x0f) << 8)
          | ((GetEINT(hdlg, 102) & 0x0f) << 4) |  (GetEINT(hdlg, 101) & 0x0f);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

BOOL LOCALF GetD01(HWND hwnd, PINT pa)
{ // xݒ
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 88,  8,  -1, "l^op(ԍL)(&I):" },
    { C_ENUM|wsT,  96,  8, 24, 12, 101, "" },
    { C_SLFT|wsG, 121, 10,  8,  8,  -1, "" },
    { C_SLFT|wsG,   8, 26, 88,  8,  -1, "l^tp(ԍ)(&N):" },
    { C_ENUM|wsT,  96, 24, 24, 12, 102, "" },
    { C_SLFT|wsG, 121, 26,  8,  8,  -1, "" },
    { C_SLFT|wsG,   8, 42, 88,  8,  -1, "@l^op(ԍL)(&C):" },
    { C_ENUM|wsT,  96, 40, 24, 12, 103, "" },
    { C_SLFT|wsG, 121, 42,  8,  8,  -1, "" },
    { C_SLFT|wsG,   8, 58, 88,  8,  -1, "@l^tp(ԍ)(&O):" },
    { C_ENUM|wsT,  96, 56, 24, 12, 104, "" },
    { C_SLFT|wsG, 121, 58,  8,  8,  -1, "" },
    { C_BDEF|wsGT,102,124, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 154,124, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 208, 144, "x" };

  return DlgBoxInput(hwnd, &dlg, getD01_DlgProc, (UINT)pa) == IDOK;
}

void LOCALF GridText(HREP rp, PCGRID gr, int ir, int ic, PCSTR st, int fmt)
{ // ̕`
  CELL cel; CellText(rp, GridCell(&cel, gr, ir, ic), st, fmt);
}

void LOCALF PaddText(HREP rp, PCGRID gr, int ir, int ic, REAL lm, REAL tm, REAL rm, REAL bm, PCSTR st, int fmt)
{ // ̕`
  CELL cel; CellText(rp, ReshapeCell(GridCell(&cel, gr, ir, ic), lm, tm, rm, bm), st, fmt);
}

PCSTR LOCALF PINdig(REAL d, int n)
{ // nڐ
  int m;
  char bf[32];
  static char dg[2];

  sprintf(bf, "%012.0f", d);
  m = strlen(bf);
  dg[0] = (n >= 0 && n <= 12 && n >= 13 - m)? bf[n - (13 - m)]: '\0';
  return dg;
}

void LOCALF PrintSlip(HREP rp, PCHOUD ph, int nk, BOOL sw)
{ // 
  int i, j, k, rst;
  CELL cel;
  GRID grd;
  static REAL cw0[] = { 10.0, 14.0, 102.0 };
  static REAL cw1[] = { 26.0, 35.0, 32.5, 32.5 };
  static REAL cw3[] = { 33.0, 46.5, 46.5 };

  SetCell(&cel, 12.0, 4.5, 138.0, 11.0);
  SetTextFont(rp, "lr ", 3.7, 0, 0);
  CellText(rp, &cel, EnvDat.stit, DT_CEN);

  SetGrid1(&grd, 12.0, 11.0, NELEM(cw0), 2, cw0, 7.7);
  for (i = 0; i <  grd.nr; i++) {
    for (j = 0; j < grd.nc; j++) {
      rst = RST((j == 0)? lstB: 0, (i == 0)? lstB: 0, (j == grd.nc-1)? lstB: lstR, (i == grd.nr-1)? lstB: (i == 0 && j == 0)? 0: lstR);
      DrawGridCell(rp, &grd, i, j, rst);
    }
  }
  SetTextFont(rp, NULL, 2.4, 0, 0);
  PaddText(rp, &grd, 0, 0, 0.0, 5.0, 0.0, 0.5, "x  ", DT_CEN);
  PaddText(rp, &grd, 1, 0, 0.0, 0.5, 0.0, 5.0, "󂯂", DT_CEN);
  SetTextFont(rp, NULL, 2.4, 0, 0);
  PaddText(rp, &grd, 0, 1, 0.0, 1.3, 0.0, 4.2, "Z()", DT_CEN);
  PaddText(rp, &grd, 0, 1, 0.0, 4.2, 0.0, 1.3, "͏ݒn", DT_CEN);
  PaddText(rp, &grd, 1, 1, 0.0, 1.3, 0.0, 4.2, "  ", DT_CEN);
  PaddText(rp, &grd, 1, 1, 0.0, 4.2, 0.0, 1.3, "@@@", DT_CEN);
  SetTextFont(rp, NULL, 3.7, 0, 0);
  PaddText(rp, &grd, 0, 2, 2.0, 0.0, 2.0, 0.0, ph->adr, DT_AUT);
  PaddText(rp, &grd, 1, 2, 2.0, 0.0,47.0, 0.0, ph->nam, DT_AUT);
  SetLineStyle(rp, lstR);
  DrawLine(rp, 93.0, 18.7, 93.0, 26.4);
  DrawLine(rp, 93.0, 21.7, 138.0, 21.7);
  SetLineStyle(rp, lstD);
  for (j = 1; j < 13; j++) {
    DrawLine(rp, 93.0 + j * 45.0/13, 21.7, 93.0 + j * 45.0/13, 26.4);
  }
  SetCell(&cel, 93.0, 18.7, 138.0, 21.7);
  SetTextFont(rp, NULL, 2.4, 0, 0);
  CellText(rp, &cel, "lԍ͖@lԍ", DT_CEN);
  if (sw) {
    SetTextStyle(rp, 2.6, 2.6, 0.0, NULL);
    for (j = 0; j < 13; j++) {
      SetCell(&cel, 93.0 + j * 45.0/13, 21.7, 93.0 + (j + 1) * 45.0/13, 26.4);
      CellText(rp, &cel, PINdig(ph->pin, j), DT_CEN);
    }
  }

  SetGrid1(&grd, 12.0, 26.4, NELEM(cw1), 7, cw1, 5.7);
  for (i = 0; i < grd.nr; i++) {
    for (j = 0; j < grd.nc; j++) {
      rst = RST((j == 0)? lstB: 0, 0, (j == grd.nc-1)? lstB: lstR, (i == grd.nr-1)? lstB: lstR);
      DrawGridCell(rp, &grd, i, j, rst);
    }
  }
  SetLineStyle(rp, lstD);
  DrawLine(rp, 84.0, 32.1, 84.0, 66.3);
  DrawLine(rp, 94.5, 32.1, 94.5, 66.3);
  DrawLine(rp,116.5, 32.1,116.5, 66.3);
  DrawLine(rp,127.0, 32.1,127.0, 66.3);
  SetTextFont(rp, NULL, 2.6, 0, 0);
  GridText(rp, &grd, 0, 0, "@@@", DT_CEN);
  GridText(rp, &grd, 0, 1, "ׁ@@@@", DT_CEN);
  GridText(rp, &grd, 0, 2, "x@@@z", DT_CEN);
  GridText(rp, &grd, 0, 3, "     z", DT_CEN);
  for (k = 0; k < nk; k++) {
    SetTextFont(rp, NULL, 2.6, 0, 0);
    PaddText(rp, &grd, 1 + k, 0, 1.0, 0.0, 1.0, 0.0, (ph + k)->acc, DT_AUT);
    PaddText(rp, &grd, 1 + k, 1, 1.0, 0.0, 1.0, 0.0, (ph + k)->det, DT_AUT);
    if ((ph + k)->unp == 0) {
      SetTextStyle(rp, 2.6, 2.6, 0.0, NULL);
      PaddText(rp, &grd, 1 + k, 2, 1.0, 0.0, 2.0, 0.0, cformat("%d", (ph + k)->fee), DT_RGT);
    } else {
      SetTextFont(rp, NULL, 2.2, 0, 0);
      PaddText(rp, &grd, 1 + k, 2, 1.0, 0.0, 2.0, 2.8, "", DT_LFT);
      SetTextStyle(rp, 2.6, 2.6, 0.0, NULL);
      PaddText(rp, &grd, 1 + k, 2, 1.0, 0.0, 2.0, 2.8, cformat("%d", (ph + k)->unp), DT_RGT);
      PaddText(rp, &grd, 1 + k, 2, 1.0, 2.8, 2.0, 0.0, cformat("%d", (ph + k)->fee), DT_RGT);
    }
    if ((ph + k)->unc == 0) {
      SetTextStyle(rp, 2.6, 2.6, 0.0, NULL);
      PaddText(rp, &grd, 1 + k, 3, 1.0, 0.0, 2.0, 0.0, cformat("%d", (ph + k)->tax), DT_RGT);
    } else {
      SetTextFont(rp, NULL, 2.2, 0, 0);
      PaddText(rp, &grd, 1 + k, 3, 1.0, 0.0, 2.0, 2.8, "", DT_LFT);
      SetTextStyle(rp, 2.6, 2.6, 0.0, NULL);
      PaddText(rp, &grd, 1 + k, 3, 1.0, 0.0, 2.0, 2.8, cformat("%d", (ph + k)->unc), DT_RGT);
      PaddText(rp, &grd, 1 + k, 3, 1.0, 2.8, 2.0, 0.0, cformat("%d", (ph + k)->tax), DT_RGT);
    }
  }

  SetGrid0(&grd, 12.0, 66.3, 1, 1, 126.0, 9.5);
  rst = RST(lstB, 0, lstB, lstB);
  DrawGridCell(rp, &grd, 0, 0, rst);
  SetTextFont(rp, NULL, 2.4, 0, 0);
  PaddText(rp, &grd, 0, 0, 0.0, 0.0, 118.0, 6.5, "(Ev)", DT_CEN);
  SetTextFont(rp, NULL, 2.6, 0, 0);
  PaddText(rp, &grd, 0, 0, 8.0, 0.0, 1.0, 0.0, ph->rem, DT_AUT);

  SetGrid1(&grd, 12.0, 75.8, NELEM(cw0), 2, cw0, 7.7);
  for (i = 0; i < grd.nr; i++) {
    for (j = 0; j < grd.nc; j++) {
      rst = RST((j == 0)? lstB: 0, 0, (j == grd.nc-1)? lstB: lstR, (i == grd.nr-1)? lstB: (i == 0 && j == 0)? 0: lstR);
      DrawGridCell(rp, &grd, i, j, rst);
    }
  }
  SetTextFont(rp, NULL, 2.4, 0, 0);
  PaddText(rp, &grd, 0, 0, 0.0, 6.6, 0.0,-1.1, "x  ", DT_CEN);
  SetTextFont(rp, NULL, 2.4, 0, 0);
  PaddText(rp, &grd, 0, 1, 0.0, 1.3, 0.0, 4.2, "Z()", DT_CEN);
  PaddText(rp, &grd, 0, 1, 0.0, 4.2, 0.0, 1.3, "͏ݒn", DT_CEN);
  PaddText(rp, &grd, 1, 1, 0.0, 1.3, 0.0, 4.2, "  ", DT_CEN);
  PaddText(rp, &grd, 1, 1, 0.0, 4.2, 0.0, 1.3, "@@@", DT_CEN);
  SetTextFont(rp, NULL, 2.4, 0, 0);
  PaddText(rp, &grd, 1, 2, 27.0, 4.7, 67.0, 0.0, "(db)", DT_CEN);
  SetTextFont(rp, NULL, 3.7, 0, 0);
  PaddText(rp, &grd, 0, 2, 2.0, 0.0, 2.0, 0.0, EnvDat.padr, DT_AUT);
  PaddText(rp, &grd, 1, 2, 2.0, 0.0,47.0, 2.0, EnvDat.pnam, DT_AUT);
  SetTextFont(rp, NULL, 2.6, 0, 0);
  PaddText(rp, &grd, 1, 2, 36.0, 4.7, 0.0, 0.0, EnvDat.ptel, DT_LFT);
  SetLineStyle(rp, lstR);
  DrawLine(rp, 93.0, 83.5, 93.0, 91.2);
  DrawLine(rp, 93.0, 86.5, 138.0, 86.5);
  SetLineStyle(rp, lstD);
  for (j = 1; j < 13; j++) {
    DrawLine(rp, 93.0 + j * 45.0/13, 86.5, 93.0 + j * 45.0/13, 91.2);
  }
  SetCell(&cel, 93.0, 83.5, 138.0, 86.5);
  SetTextFont(rp, NULL, 2.4, 0, 0);
  CellText(rp, &cel, "lԍ͖@lԍ", DT_CEN);
  if (sw) {
    SetTextStyle(rp, 2.6, 2.6, 0.0, NULL);
    for (j = 0; j < 13; j++) {
      SetCell(&cel, 93.0 + j * 45.0/13, 86.5, 93.0 + (j + 1) * 45.0/13, 91.2);
      CellText(rp, &cel, PINdig(EnvDat.ppin, j), DT_CEN);
    }
  }

  SetGrid1(&grd, 12.0, 92.0, NELEM(cw3), 1, cw3, 4.6);
  for (i = 0; i < grd.nr; i++) {
    for (j = 0; j < grd.nc; j++) {
      rst = RST((j == 0)? lstB: 0, (i == 0)? lstB: 0, (j == grd.nc-1)? lstB: lstR, (i == grd.nr-1)? lstB: lstR);
      DrawGridCell(rp, &grd, i, j, rst);
    }
  }
  SetTextFont(rp, NULL, 2.6, 0, 0);
  GridText(rp, &grd, 0, 0, "@@@@", DT_CEN);
  GridText(rp, &grd, 0, 1, " @", DT_LFT);
  GridText(rp, &grd, 0, 2, " A", DT_LFT);
  SetTextFont(rp, NULL, 3.7, 0, 0);
  PaddText(rp, &grd, 0, 1,10.0, 0.0, 0.0, 0.0, EnvDat.num1, DT_LFT);
  PaddText(rp, &grd, 0, 2,10.0, 0.0, 0.0, 0.0, EnvDat.num2, DT_LFT);

  SetCell(&cel, 12.0, 96.6, 138.0, 99.8);
  SetTextFont(rp, NULL, 2.6, 0, 0);
  CellText(rp, &cel, EnvDat.snum, DT_RGT);

  SetLineStyle(rp, lstD);
  DrawLine(rp, 0.0, 105.0, 148.5, 105.0);
  DrawLine(rp, 148.5, 0.0, 148.5, 105.0);
}

BOOL LOCALF frepD01(HREP rp, int msg, int pg, PINT pa)
{ // x
  int j, k;
  static int i, n, n1a, n1b, n2a, n2b, nb, nr;
  static HOPN op;
  static PCHOUD dh;

  if (msg == REPM_CREATE) {
    op = OpenTable(tiHOU[idHOU].nam, OM_RDO); if (!op) return FALSE;
    dh = TablePtr(OHTBL(op)); nr = NTableRows(OHTBL(op));
  } else if (msg == REPM_SETUP) {
    if (!GetD01(hWND(rp), pa)) return FALSE;
    n1a =  *pa & 0x000f;
    n1b = (*pa & 0x00f0) >> 4;
    n2a = (*pa & 0x0f00) >> 8;
    n2b = (*pa & 0xf000) >>12;
    n = 0;
    for (i = 0; i < nr; i++) {
      switch (dh[i].atr) {
      case 1: n += (n1a + n1b); break;
      case 2: n += (n2a + n2b); break;
      }
    }
    SetReqBodyWidth(rp, 0.0, RSW_SKP);
    SetNPages(rp, (n + 3) / 4);
  } else if (msg == REPM_STARTPRINT) {
    i = n = 0;
  } else if (msg == REPM_DRAWPAGE || msg == REPM_SKIPPAGE) {
    for (j = 0; j < 4; j++) {
      if (n == 0) { _L0:
        while (i < nr && dh[i].atr != 1 && dh[i].atr != 2) i++;
        if (i >= nr) break;
        switch (dh[i].atr) {
        case 1: n = n1a + n1b; nb = n1b; break;
        case 2: n = n2a + n2b; nb = n2b; break;
        }
        if (n == 0) { i++; goto _L0;}
      }
      SetOrigin(rp, (j % 2) * 148.5, (j / 2) * 105.0);
      k = 1;
      while (i + k < nr && dh[i + k].atr == 3) k++;
      PrintSlip(rp, &dh[i], k, n > nb);
      n--;
      if (n == 0) i++;
    }
  } else if (msg == REPM_DESTROY) {
    CloseTable(op, FALSE);
  }
  return TRUE;
}

static PCSTR SHON[] = { "Ȃ", "l", "䒆", "a" };
static ENMS esHON = { SHON, NELEM(SHON) };

BOOL LOCALF getD02_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // xݒ_CAOvV[W
  PINT pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (PINT)lpa));
    SetEINT(hdlg, 101,  *pa & 0x000f);
    SetCSEL(hdlg, 102, (*pa & 0x00f0) >> 4, &esHON);
    SetEINT(hdlg, 103, (*pa & 0x0f00) >> 8);
    SetCSEL(hdlg, 104, (*pa & 0xf000) >>12, &esHON);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (PINT)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      *pa = ((GetCSEL(hdlg, 104) & 0x0f) <<12) | ((GetEINT(hdlg, 103) & 0x0f) << 8)
          | ((GetCSEL(hdlg, 102) & 0x0f) << 4) |  (GetEINT(hdlg, 101) & 0x0f);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

BOOL LOCALF GetD02(HWND hwnd, PINT pa)
{ // xݒ
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 32,  8,  -1, "l(&I):" },
    { C_ENUM|wsT,  40,  8, 24, 12, 101, "" },
    { C_SLFT|wsG,  65, 10,  8,  8,  -1, "" },
    { C_SLFT|wsG,  88, 10, 32,  8,  -1, "h(&N):" },
    { C_CSEL|wsT, 120,  8, 32, 64, 102, "" },
    { C_SLFT|wsG,   8, 26, 32,  8,  -1, "@l(&C):" },
    { C_ENUM|wsT,  40, 24, 24, 12, 103, "" },
    { C_SLFT|wsG,  65, 26,  8,  8,  -1, "" },
    { C_SLFT|wsG,  88, 26, 32,  8,  -1, "h(&O):" },
    { C_CSEL|wsT, 120, 24, 32, 64, 104, "" },
    { C_BDEF|wsGT,102,124, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 154,124, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 208, 144, "x" };

  return DlgBoxInput(hwnd, &dlg, getD02_DlgProc, (UINT)pa) == IDOK;
}

void LOCALF PrintLabel(HREP rp, PCHOUD ph, int h)
{ // x
  PSTR pt;
  CELL cel;
  char bf[256];

  SetTextFont(rp, NULL, 4.0, 0, 0);
  SetCell(&cel, 6.0, 6.0, 80.0, 11.0);
  CellText(rp, &cel, ph->zip, DT_LFT);
  SetTextFont(rp, NULL, 4.0, 0, 0);
  sprintf(bf, "%s", strrepl(ph->adr, "@", " "));
  if (!!(pt = strfind(bf, " "))) *pt = '\0';
  SetCell(&cel, 6.0, 12.0, 80.0, 17.0);
  CellText(rp, &cel, bf, DT_AUT);
  SetCell(&cel, 10.0, 18.0, 80.0, 23.0);
  if (pt) CellText(rp, &cel, pt + 1, DT_AUT);
  SetCell(&cel, 14.0, 28.0, 80.0, 33.0);
  sprintf(bf, "%s@%s", ph->nam,  (h > 0 && h < NELEM(SHON))? SHON[h]: "");
  CellText(rp, &cel, bf, DT_AUT);
}

BOOL LOCALF frepD02(HREP rp, int msg, int pg, PINT pa)
{ // x
  int j;
  HTBL tb;
  static int i, n, n1, h1, n2, h2, h, nr;
  static HOPN op;
  static PCHOUD dh;

  if (msg == REPM_CREATE) {
    op = OpenTable(tiHOU[idHOU].nam, OM_RDO); if (!op) return FALSE;
    tb = OHTBL(op);
    dh = TablePtr(tb); nr = NTableRows(tb);
  } else if (msg == REPM_SETUP) {
    if (!GetD02(hWND(rp), pa)) return FALSE;
    n1 =  *pa & 0x000f;
    h1 = (*pa & 0x00f0) >> 4;
    n2 = (*pa & 0x0f00) >> 8;
    h2 = (*pa & 0xf000) >>12;
    n = 0;
    for (i = 0; i < nr; i++) {
      switch (dh[i].atr) {
      case 1: n += n1; break;
      case 2: n += n2; break;
      }
    }
    SetReqBodyWidth(rp, 0.0, RSW_SKP);
    SetNPages(rp, (n + 11) / 12);
  } else if (msg == REPM_STARTPRINT) {
    i = n = 0;
  } else if (msg == REPM_DRAWPAGE || msg == REPM_SKIPPAGE) {
    for (j = 0; j < 12; j++) {
      if (n == 0) { _L0:
        while (i < nr && dh[i].atr != 1 && dh[i].atr != 2) i++;
        if (i >= nr) break;
        switch (dh[i].atr) {
        case 1: n = n1; h = h1; break;
        case 2: n = n2; h = h2; break;
        }
        if (n == 0) { i++; goto _L0;}
      }
      SetOrigin(rp, 19.0 + (j % 2) * 87.0, 21.0 + (j / 2) * 42.3);
      PrintLabel(rp, &dh[i], h);
      n--;
      if (n == 0) i++;
    }
  } else if (msg == REPM_DESTROY) {
    CloseTable(op, FALSE);
  }
  return TRUE;
}

void LOCALF cmd_report(HWND hwnd, int id)
{ // [ވ
  HWND hprn;
  static int par01 = 0x1111;
  static int par02 = 0x2111;
  static REPI rpi[] = {                                           // id
    { "x",         PSZ_A4L, (FREP)frepD01, (UINT)&par01 }, //  1
    { "x",       PSZ_A4P, (FREP)frepD02, (UINT)&par02 }, //  2
  };

  oprlog(4 + id - 1, 0, 0);
  hprn = CreatePrintPreview(hwnd, &rpi[id - 1]);
  if (!hprn) PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

void LOCALF cmd_info1(HWND hwnd)
{ // 엚\
  ShellExecute(NULL, "open", LFILE, NULL, NULL, SW_SHOWDEFAULT);
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

BOOL LOCALF who_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // OC󋵓_CAOvV[W
  switch (umsg) {
  case WM_INITDIALOG:
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    switch (wpa) {
    case IDOK:
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_who(HWND hwnd)
{ // TCgւ̃OC󋵁At@C̃bN󋵂\
  static DLGI dit[] = {
    { C_SMUL|wsG,   8,  8,192, 80,  -1, NULL },
    { C_BDEF|wsGT,154,108, 48, 14, IDOK, "OK" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 208, 128, "OC" };

  dit[0].txt = sitewhostr();
  DlgBoxInput(hwnd, &dlg, who_DlgProc, (LPARAM)NULL);
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

void LOCALF cmd_setusr(HWND hwnd)
{ // [U[Ǘ\J
  HWND hchi;
  TBWI tbw = { NULL, 0, NULL, NULL, 0 };

  if (!!(hchi = (HWND)SendMessage(hwnd, FRMM_GETCHILDBYNAME, (WPARAM)tbw.tit, 0))) {
    ErrorBox(hwnd, "̃t@CɊJĂ܂B", NULL);
    SendMessage(hwnd, FRMM_ACTIVATE, (WPARAM)hchi, 0);
    return;
  }
  BusyMsg(hwnd, "Ǎ...");
  reset_error();
  tbw.op = OpenBSATable(OM_RDW);
  EndBusy(hwnd);
  if (!tbw.op) {
    ErrorBox(hwnd, format("'%s'̓ǍɎs܂B", tbw.tit), NULL);
    PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
    return;
  }
  CreateTableWindow(hwnd, 0, &tbw);
}

HBLK LOCALF CreateEnmBlk(HTBL tb, int ic)
{ // 񃊃Xg̍쐬
  int i, ni, ofs;
  PENMS ls;

  ni = NTableRows(tb) + 1;
  ls = (PENMS)CreateMemBlk(ni, sizeof(PCSTR)); if (!ls) return NULL;
  ls->ps[0] = "";
  ofs = TableColumnOffset(tb, ic);
  for (i = 1; i < ni; i++) {
    ls->ps[i] = (PCSTR)((PBYTE)TableRow(tb, i - 1) + ofs);
  }
  ls->ni = ni;
  return (HBLK)ls;
}

  // bN
typedef struct {
  HBLK  ls;
  int   va;
} UNLP;

BOOL LOCALF unlock_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // bN_CAOvV[W
  UNLP *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (UNLP *)lpa));
    SetCSEL(hdlg, 101, pa->va, (PCENMS)pa->ls);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (UNLP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      pa->va = GetCSEL(hdlg, 101);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_unlock(HWND hwnd)
{ // t@C̃bN([U[̋OAEg)
  int re;
  HTBL tb;
  UNLP par;
  char usr[32];
  static DLGI dit[] = {
    { C_SMUL|wsG,   8,  8,144, 24,  -1, "[U[IɃOAEg\nt@C̃bNԂ܂B" },
    { C_SLFT|wsG,   8, 42, 40,  8,  -1, "[U[:" },
    { C_CSEL|wsT,  48, 40,100,128, 101, "" },
    { C_BDEF|wsGT, 54,108, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 106,108, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 160, 128, "bN" };

  if (file_size(PRGNAM".BSU") == 0) goto _L1;
  tb = CreateBSUTable(32, TRUE); if (!tb) return;
  par.ls = CreateEnmBlk(tb, 0); if (!par.ls) { DeleteTable(tb); return;}
  par.va = 0;
  re = (DlgBoxInput(hwnd, &dlg, unlock_DlgProc, (LPARAM)&par) == IDOK);
  strcpyn(usr, enmstr((PENMS)par.ls, par.va), sizeof(usr) - 1); if (usr[0] == '\0') re = FALSE;
  DeleteBinBlk(par.ls);
  DeleteTable(tb);
  if (!re) goto _L1;
  if (strcmp(usr, CurUser()) == 0) {
    if (YesNoBox(hwnd, "gOAEgivOIj܂H", NULL) == IDYES) {
      ForceLogoutSite(usr);
      PostMessage(hwnd, WM_COMMAND, IDM_EXIT, 0); return;
    }
    goto _L1;
  }
  ForceLogoutSite(usr);
  OkBox(hwnd, format("'%s'OAEg܂B", usr), NULL);
 _L1:
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

BOOL LOCALF backup_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // obNAbv_CAOvV[W
  switch (umsg) {
  case WM_INITDIALOG:
    SetESTR(hdlg, 101, IniDat.bdir);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, IniDat.bdir, sizeof(IniDat.bdir) - 1);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_backup(HWND hwnd)
{ // obNAbv
  int re;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8,  8,100,  8,  -1, "obNAbvtH_(&B):" },
    { C_ESTR|wsT,   8, 18,226, 12, 101, "" },
    { C_BDEF|wsGT,134,108, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 186,108, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 240, 128, "obNAbv" };

 _L0:
  re = (DlgBoxInput(hwnd, &dlg, backup_DlgProc, 0) == IDOK);
  if (re && IniDat.bdir[0] == '\0') {
    ErrorBox(hwnd, "obNAbvtH_KvłB", NULL); goto _L0;
  }
  if (!re) goto _L1;
  BusyMsg(hwnd, "...");
  reset_error();
  re = copy_file_to(IniDat.bdir, DBTableFileName(idHOU));
  EndBusy(hwnd);
  ResultBox(hwnd, "obNAbv", NULL, re);
 _L1:
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

BOOL LOCALF setenv_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // {ݒ_CAOvV[W
  ENVD *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (ENVD *)lpa));
    SetESTR(hdlg, 101, pa->stit);
    SetESTR(hdlg, 102, pa->padr);
    SetESTR(hdlg, 103, pa->pnam);
    SetESTR(hdlg, 104, pa->ptel);
    SetEITM(hdlg, 105, &pa->ppin, &ciPPIN);
    SetESTR(hdlg, 106, pa->num1);
    SetESTR(hdlg, 107, pa->num2);
    SetESTR(hdlg, 108, pa->snum);
    SetESTR(hdlg, 109, pa->udir);
    SetFocus(GetDlgItem(hdlg, 102));
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return FALSE;
  case WM_COMMAND:
    pa = (ENVD *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, pa->stit, sizeof(pa->stit) - 1);
      GetESTR(hdlg, 102, pa->padr, sizeof(pa->padr) - 1);
      GetESTR(hdlg, 103, pa->pnam, sizeof(pa->pnam) - 1);
      GetESTR(hdlg, 104, pa->ptel, sizeof(pa->ptel) - 1);
      GetEITM(hdlg, 105, &pa->ppin, &ciPPIN);
      GetESTR(hdlg, 106, pa->num1, sizeof(pa->num1) - 1);
      GetESTR(hdlg, 107, pa->num2, sizeof(pa->num2) - 1);
      GetESTR(hdlg, 108, pa->snum, sizeof(pa->snum) - 1);
      GetESTR(hdlg, 109, pa->udir, sizeof(pa->udir) - 2);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_setenv(HWND hwnd)
{ // {ݒ
  ENVD par;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 60,  8,  -1, "[^Cg(&T):" },
    { C_ESTR|wsT,  56,  8,178, 12, 101, "" },
    { C_SLFT|wsG,   8, 26, 60,  8,  -1, "xҏZ(&A):" },
    { C_ESTR|wsT,  56, 24,178, 12, 102, "" },
    { C_SLFT|wsG,   8, 42, 60,  8,  -1, "xҖ(&N):" },
    { C_ESTR|wsT,  56, 40,140, 12, 103, "" },
    { C_SLFT|wsG,   8, 58, 60,  8,  -1, "xғdb(&P):" },
    { C_ESTR|wsT,  56, 56, 56, 12, 104, "" },
    { C_SLFT|wsG,   8, 74, 60,  8,  -1, "xҔԍ(&I):" },
    { C_ENUM|wsT,  56, 72, 64, 12, 105, "" },
    { C_SLFT|wsG,   8, 90, 60,  8,  -1, "(P)(&1):" },
    { C_ESTR|wsT,  56, 88, 56, 12, 106, "" },
    { C_SLFT|wsG,   8,106, 60,  8,  -1, "(Q)(&2):" },
    { C_ESTR|wsT,  56,104, 56, 12, 107, "" },
    { C_SLFT|wsG,   8,122, 60,  8,  -1, "[ԍ(&S):" },
    { C_ESTR|wsT,  56,120, 32, 12, 108, "" },
    { C_SLFT|wsG,   8,138, 60,  8,  -1, "[U[tH_(&U):" },
    { C_ESTR|wsT,   8,148,226, 12, 109, "" },
    { C_BDEF|wsGT,134,172, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 186,172, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 240, 192, "{ݒ" };

  par = EnvDat;
  if (DlgBoxInput(hwnd, &dlg, setenv_DlgProc, (LPARAM)&par) == IDCANCEL) goto _L1;
  EnvDat = par;
  SaveENV();
 _L1:
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

BOOL LOCALF csvout(PCSTR nam)
{ // opbruo
  int i, yr, re = FALSE;
  HTBL tb;
  HOPN op;
  HANDLE hf;
  PCHOUD pc, pe, pr;
  char *pt, bf[1024];

  op = OpenTable(tiHOU[idHOU].nam, OM_RDO); if (!op) return FALSE;
  hf = open_file(nam, OP_WRI); if (!hf) { ferr(E_FIW, nam); goto _L1;}
  tb = OHTBL(op);
  yr = era_year(ztod(EnvDat.stit)); if (yr == 0) yr = era_year(CurDate()) - (month(CurDate()) < 6);
  for (pc = TablePtr(tb), pe = pc + NTableRows(tb); pc < pe; pc++) {
    if (pc->atr != 1 && pc->atr != 2) continue;
    pt = bf;
    pt += sprintf(pt, "%s,", EnvDat.snum); //  1
    pt += sprintf(pt, "%s,", EnvDat.num1); //  2
    pt += sprintf(pt, ",");                //  3
    pt += sprintf(pt, "%s,", EnvDat.padr); //  4
    pt += sprintf(pt, "%s,", EnvDat.pnam); //  5
    pt += sprintf(pt, "%s,", EnvDat.ptel); //  6
    pt += sprintf(pt, "%s,", EnvDat.num2); //  7
    pt += sprintf(pt, ",");                //  8
    pt += sprintf(pt, ",");                //  9
    pt += sprintf(pt, ",");                // 10
    pt += sprintf(pt, "%02d,", yr);        // 11
    pt += sprintf(pt, "%s,", pc->adr);     // 12
    pt += sprintf(pt, "%d,", 0);           // 13
    pt += sprintf(pt, "%s,", pc->nam);     // 14
    pt += sprintf(pt, "%s,", pc->acc);     // 15
    pt += sprintf(pt, "%s,", pc->det);     // 16
    pt += sprintf(pt, "%d,", pc->fee);     // 17
    pt += sprintf(pt, "%d,", pc->unp);     // 18
    pt += sprintf(pt, "%d,", pc->tax);     // 19
    pt += sprintf(pt, "%d,", pc->unc);     // 20
    for (i = 1; i < 6 && (pr = &pc[i])->atr == 3; i++) {
      pt += sprintf(pt, "%s,", pr->acc);
      pt += sprintf(pt, "%s,", pr->det);
      pt += sprintf(pt, "%d,", pr->fee);
      pt += sprintf(pt, "%d,", pr->unp);
      pt += sprintf(pt, "%d,", pr->tax);
      pt += sprintf(pt, "%d,", pr->unc);
    }
    for ( ; i < 6; i++) {
      pt += sprintf(pt, ",,,,,,");
    }
    pt += sprintf(pt, "%s,", pc->rem);
    pt += sprintf(pt, "%013.0f,", EnvDat.ppin);
    pt += sprintf(pt, "%013.0f", pc->pin);
    write_line(hf, bf);
  }
  re = close_file(hf);
 _L1:
  CloseTable(op, FALSE);
  return re;
}

typedef struct {
  char  nam[512];
} CSVP;

BOOL LOCALF csvout_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // opbruo_CAOvV[W
  CSVP *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (CSVP *)lpa));
    SetESTR(hdlg, 101, pa->nam);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (CSVP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, pa->nam, sizeof(pa->nam) - 1);
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_csvout(HWND hwnd)
{ // opbruo
  int re;
  static CSVP dat;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8,  8,100,  8,  -1, "o̓t@C(&O):" },
    { C_ESTR|wsT,   8, 18,226, 12, 101, "" },
    { C_BDEF|wsGT,134,108, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 186,108, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 240, 128, "opbruo" };

  if (dat.nam[0] == '\0') strcpy(dat.nam, "309dat01.txt");
  if (DlgBoxInput(hwnd, &dlg, csvout_DlgProc, (LPARAM)&dat) == IDCANCEL) goto _L1;
  if (file_exists(dat.nam)) {
    if (YesNoBox(hwnd, format("'%s'͊ɑ݂܂B㏑܂H", dat.nam), NULL) != IDYES) goto _L1;
  }
  BusyMsg(hwnd, "o...");
  reset_error();
  re = csvout(dat.nam);
  EndBusy(hwnd);
  if (!re) {
    ErrorBox(hwnd, format("'%s'̏oɎs܂B", dat.nam), NULL);
  }
 _L1:
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

  // IvVݒ
typedef struct {
  char  face[32];
  int   ptsz;
  int   tbcs;
  int   cptr;
  int   cidx;
  int   uopt;
  char  unam[32];
  char  upwd[32];
} OPTP;

BOOL LOCALF setopt_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // IvVݒ_CAOvV[W
  OPTP *pa;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (OPTP *)lpa));
    SetESTR(hdlg, 101, pa->face);
    SetEINT(hdlg, 102, pa->ptsz);
    SetCCOD(hdlg, 103, pa->tbcs & TBCS_HRH, &dsHRH);
    SetCCOD(hdlg, 104, pa->tbcs & (TBCS_HCH|TBCS_UCI|TBCS_UCN), &dsHCH);
    SetEITM(hdlg, 105, &pa->cptr, &ciCPTR);
    SetEITM(hdlg, 106, &pa->cidx, &ciCIDX);
    SetBFLG(hdlg, 107, pa->tbcs & TBCS_EMD);
    SetBFLG(hdlg, 108, pa->tbcs & TBCS_ZBI);
    SetBFLG(hdlg, 109, pa->tbcs & TBCS_DDD);
    SetBFLG(hdlg, 110, pa->tbcs & TBCS_DER);
    SetBFLG(hdlg, 111, pa->uopt & UOPT_ALI);
    SetSSTR(hdlg, 113, pa->unam);
    SetBFLG(hdlg, 114, pa->uopt & UOPT_UMD);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (OPTP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case IDOK:
      GetESTR(hdlg, 101, pa->face, sizeof(pa->face) - 1);
      if (pa->face[0] == '\0') strcpyx(pa->face, DEFFACE, sizeof(pa->face) - 1);
      pa->ptsz = GetEINT(hdlg, 102); if (pa->ptsz < 6 || pa->ptsz > 30) pa->ptsz = DEFPTSZ;
      pa->tbcs = (pa->tbcs &~TBCS_HRH) | GetCCOD(hdlg, 103, &dsHRH);
      pa->tbcs = (pa->tbcs &~(TBCS_HCH|TBCS_UCI|TBCS_UCN)) | GetCCOD(hdlg, 104, &dsHCH);
      GetEITM(hdlg, 105, &pa->cptr, &ciCPTR); if (pa->cptr == 0) pa->cptr = BGRC_PTR;
      GetEITM(hdlg, 106, &pa->cidx, &ciCIDX); if (pa->cidx == 0) pa->cidx = BGRC_IDX;
      if (GetBFLG(hdlg, 107)) pa->tbcs |= TBCS_EMD;  else pa->tbcs &=~TBCS_EMD;
      if (GetBFLG(hdlg, 108)) pa->tbcs |= TBCS_ZBI;  else pa->tbcs &=~TBCS_ZBI;
      if (GetBFLG(hdlg, 109)) pa->tbcs |= TBCS_DDD;  else pa->tbcs &=~TBCS_DDD;
      if (GetBFLG(hdlg, 110)) pa->tbcs |= TBCS_DER;  else pa->tbcs &=~TBCS_DER;
      if (GetBFLG(hdlg, 111)) pa->uopt |= UOPT_ALI;  else pa->uopt &=~UOPT_ALI;
      if (GetBFLG(hdlg, 114)) pa->uopt |= UOPT_UMD;  else pa->uopt &=~UOPT_UMD;
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_setopt(HWND hwnd)
{ // IvVݒ
  OPTP par;
  LOGFONT lof;
  static DLGI dit[] = {
    { C_SLFT|wsG,   8, 10, 48,  8,  -1, "tHg(&F):" },
    { C_ESTR|wsT,  56,  8, 66, 12, 101, "" },
    { C_ENUM|wsT, 128,  8, 24, 12, 102, "" },
    { C_SLFT|wsG, 155, 10, 16,  8,  -1, "pt" },
    { C_SLFT|wsG,   8, 26, 48,  8,  -1, "so(&R):" },
    { C_CSEL|wsT,  56, 24, 58,128, 103, "" },
    { C_SLFT|wsG,   8, 42, 48,  8,  -1, "񌩏o(&C):" },
    { C_CSEL|wsT,  56, 40, 58,128, 104, "" },
    { C_SLFT|wsG, 128, 26, 60,  8,  -1, "Z|C^F(&P):" },
    { C_ENUM|wsT, 188, 24, 40, 12, 105, "" },
    { C_SLFT|wsG, 128, 42, 60,  8,  -1, "onCCg(&H):" },
    { C_ENUM|wsT, 188, 40, 40, 12, 106, "" },
    { C_BFLG|wsGT,  8, 60,120, 10, 107, "EnterL[ŉɈړ(&D)" },
    { C_BFLG|wsGT,  8, 74,120, 10, 108, "CfbNX0n߂(&Z)" },
    { C_BFLG|wsGT,128, 60,128, 10, 109, "hbv_EXggpȂ(&L)" },
    { C_BFLG|wsGT,128, 74,128, 10, 110, "_CAO{bNXgpȂ(&E)" },
    { C_BFLG|wsGT,  8, 92,120, 10, 111, "IɃOC(&A)" },
    { C_SLFT|wsG, 128, 93, 44,  8, 112, "[U[:" },
    { C_SLFT|wsG, 172, 93, 84,  8, 113, "" },
    { C_BFLG|wsGT,  8,106,120, 10, 114, "Jnj[gp(&M)" },
    { C_BDEF|wsGT,150,172, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 202,172, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 256, 192, "IvVݒ" };

  par = *(OPTP *)&IniDat.face;
  if (DlgBoxInput(hwnd, &dlg, setopt_DlgProc, (LPARAM)&par) == IDCANCEL) goto _L1;
  reset_error();
  if (par.ptsz != IniDat.ptsz || strcmp(par.face, IniDat.face) != 0) {
    SetAppFont(FID_DEF, CreateFontIndirect(SetLOGFONT(&lof, par.face, PT2DOTS(par.ptsz), 0)));
  }
  set_error_message_index_base((par.tbcs & TBCS_ZBI) == 0);
  SetAppColor(CID_PTR, par.cptr);
  SetAppColor(CID_IDX, par.cidx);
  if (par.uopt & UOPT_ELG) enable_error_logging();  else disable_error_logging();
  *(OPTP *)&IniDat.face = par;
 _L1:
  PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
}

void LOCALF cmd_tile(HWND hwnd, int sw)
{ // E(㉺)ɕׂĕ\
  int flg;

  flg = SendMessage(hwnd, FRMM_GETFLAGS, 0, 0);
  flg &=~(FRMS_TIL|FRMS_HRZ|FRMS_RGT);
  switch (sw) {
  case 0: flg |= (FRMS_TIL|FRMS_VRT); break;
  case 1: flg |= (FRMS_TIL|FRMS_HRZ); break;
  }
  SendMessage(hwnd, FRMM_SETFLAGS, flg, 0);
  SendMessage(hwnd, FRMM_ARRANGE, OPR_TILE, 0);
}

void LOCALF cmd_window(HWND hwnd, int id)
{ // ANeBuEBhEI
  int nc;
  HWND hchi;

  nc = SendMessage(hwnd, FRMM_GETNCHILDREN, 0, 0);
  hchi = (HWND)SendMessage(hwnd, FRMM_GETCHILD, nc - 1 - id, 0);
  SendMessage(hwnd, FRMM_ARRANGE, OPR_ACTIVATE, (LPARAM)hchi);
}

void LOCALF cmd_manual(HWND hwnd)
{ // }jAJ
  ShellExecute(NULL, "open", PRGNAM".PDF", NULL, NULL, SW_SHOWDEFAULT);
}

static HBITMAP hbmpMain;

BOOL LOCALF about_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // o[W_CAOvV[W
  PCBYTE vr;
  UINT ver;

  switch (umsg) {
  case WM_INITDIALOG:
    SendDlgItemMessage(hdlg, 101, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM)hbmpMain);
    ver = BOLBASVer(); vr = (PBYTE)&ver;
    SetSSTR(hdlg, 102, format("Version %d.%d.%d", vr[0], vr[1], vr[2]));
    ver = BOLDBEVer(); vr = (PBYTE)&ver;
    SetSSTR(hdlg, 103, format("Version %d.%d.%d", vr[0], vr[1], vr[2]));
    ver = BOLFROVer(); vr = (PBYTE)&ver;
    SetSSTR(hdlg, 104, format("Version %d.%d.%d", vr[0], vr[1], vr[2]));
    ver = BOLGUIVer(); vr = (PBYTE)&ver;
    SetSSTR(hdlg, 105, format("Version %d.%d.%d", vr[0], vr[1], vr[2]));
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    switch (wpa) {
    case IDOK:
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

void LOCALF cmd_about(HWND hwnd)
{ // o[W
  static DLGI dit[] = {
    { C_SBMP|wsG,   8, 10, 80, 80,101, ""       },
    { C_SLFT|wsG, 112, 12, 32,  8, -1, "BOLBAS" },
    { C_SLFT|wsG, 144, 12, 56,  8,102, ""       },
    { C_SLFT|wsG, 112, 24, 32,  8, -1, "BOLDBE" },
    { C_SLFT|wsG, 144, 24, 56,  8,103, ""       },
    { C_SLFT|wsG, 112, 36, 32,  8, -1, "BOLFRO" },
    { C_SLFT|wsG, 144, 36, 56,  8,104, ""       },
    { C_SLFT|wsG, 112, 48, 32,  8, -1, "BOLGUI" },
    { C_SLFT|wsG, 144, 48, 56,  8,105, ""       },
    { C_SLFT|wsG,   8, 96, 96,  8, -1, PRGDSC   },
    { C_SLFT|wsG, 112, 96, 32,  8, -1, PRGNAM   },
    { C_SLFT|wsG, 144, 96, 56,  8, -1, PRGVER   },
    { C_SLFT|wsG,   8,126,144,  8, -1, VI_CPY   },
    { C_BDEF|wsGT,154,124, 48, 14, IDOK, "OK"   },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 208, 144, "o[W" };

  DlgBoxInput(hwnd, &dlg, about_DlgProc, (LPARAM)NULL);
}

LRESULT LOCALF FRM_command(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // R}h
  HWND hact, hchi;

  switch (LOWORD(wpa)) {
  case IDM_LOGIN:
    cmd_login(hwnd); break;
  case IDM_OMENU:
    cmd_omenu(hwnd, 0); break;
  case IDM_OMENU1:
    cmd_omenu(hwnd, 1); break;
  case IDM_OPEN:
    cmd_open(hwnd); break;
  case IDM_CLOSE:
    SendMessage((HWND)SendMessage(hwnd, FRMM_GETACTIVE, 0, 0), WM_CLOSE, 0, 0); break;
  case IDM_EXIT:
    SendMessage(hwnd, WM_CLOSE, 0, 0); return 0;
  case IDM_CHECK1:
    cmd_check1(hwnd); break;
  case IDM_REPORT1:
  case IDM_REPORT2:
    cmd_report(hwnd, LOWORD(wpa) - IDM_REPORT1 + 1); break;
  case IDM_INFO1:
    cmd_info1(hwnd); break;
  case IDM_SITEWHO:
    cmd_who(hwnd); break;
  case IDM_SETUSR:
    cmd_setusr(hwnd); break;
  case IDM_UNLOCK:
    cmd_unlock(hwnd); break;
  case IDM_BACKUP:
    cmd_backup(hwnd); break;
  case IDM_SETENV:
    cmd_setenv(hwnd); break;
  case IDM_CSVOUT:
    cmd_csvout(hwnd); break;
  case IDM_SETOPT:
    cmd_setopt(hwnd); break;
  case IDM_PREVWINDOW:
    SendMessage(hwnd, FRMM_ARRANGE, OPR_ACTIVATE, 0); break;
  case IDM_NEXTWINDOW:
    SendMessage(hwnd, FRMM_ARRANGE, OPR_ACTIVATE, SendMessage(hwnd, FRMM_GETCHILD, 0, 0)); break;
  case IDM_MAXIMIZE:
    cmd_tile(hwnd, -1); break;
  case IDM_TILE:
    cmd_tile(hwnd, 0); break;
  case IDM_HTILE:
    cmd_tile(hwnd, 1); break;
  case IDM_WINDOW0:
  case IDM_WINDOW1:
  case IDM_WINDOW2:
  case IDM_WINDOW3:
  case IDM_WINDOW4:
  case IDM_WINDOW5:
  case IDM_WINDOW6:
  case IDM_WINDOW7:
  case IDM_WINDOW8:
  case IDM_WINDOW9:
  case IDM_WINDOWA:
  case IDM_WINDOWB:
  case IDM_WINDOWC:
  case IDM_WINDOWD:
  case IDM_WINDOWE:
  case IDM_WINDOWF:
    cmd_window(hwnd, LOWORD(wpa) - IDM_WINDOW0); break;
  case IDM_MANUAL:
    cmd_manual(hwnd); break;
  case IDM_ABOUT:
    cmd_about(hwnd); break;
  default:
    hact = (HWND)SendMessage(hwnd, FRMM_GETACTIVE, 0, 0);
    if (LOWORD(wpa) >= IDPRN && LOWORD(wpa) < IDM_LOGIN) {
      switch (HIWORD(wpa)) {
      case APPN_SETFOCUS:
        break;
      case APPN_LBUTTONDOWN:
      case APPN_RBUTTONDOWN:
        if ((hchi = GetDlgItem(hwnd, LOWORD(wpa))) != hact) {
          SendMessage(hwnd, FRMM_ACTIVATE, (WPARAM)hchi, 0);
        }
        return 0;
      case APPN_SELCHANGE:
        break;
      default:
        return 0;
      }
    } else if (hact) {
      SendMessage(hact, WM_COMMAND, wpa, lpa);
    }
    break;
  }
  SendMessage(hwnd, FRMM_INITTOOL, 0, 0);
  return 0;
}

LRESULT LOCALF FRM_close(HWND hwnd)
{ // t[EBhE
  HWND bact, hact;

  bact = NULL;
  while (!!(hact = (HWND)SendMessage(hwnd, FRMM_GETACTIVE, 0, 0))) {
    if (hact == bact) return 0;
    SendMessage(hact, WM_CLOSE, 0, 0);
    bact = hact;
  }
  SendMessage(hwnd, FRMM_GETPLACEMENT, (WPARAM)&IniDat.wpo, 0);
  return DefBOLFRMProc(hwnd, WM_CLOSE, 0, 0);
}

LRESULT LOCALF FRM_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // CEBhEvV[W
  switch (umsg) {
  case WM_INITMENU:
    return FRM_initmenu(hwnd, (HMENU)wpa);
  case FRMM_INITTOOL:
    return FRM_inittool(hwnd);
  case FRMM_DESTROYCHILD:
    DefBOLFRMProc(hwnd, umsg, wpa, lpa);
    if (!SendMessage(hwnd, FRMM_GETACTIVE, 0, 0)) PostMessage(hwnd, WM_COMMAND, IDM_OMENU, 0);
    return 0;
  case WM_COMMAND:
    return FRM_command(hwnd, wpa, lpa);
  case WM_CLOSE:
    return FRM_close(hwnd);
  }
  return DefBOLFRMProc(hwnd, umsg, wpa, lpa);
}

typedef struct {
  int   idm;
  int   bid;
} ICOI;
  // R}hƃrbg}bv̑Ή\
static ICOI ICI[] = {
  { IDM_OPEN,       BID_OPEN    },
  { IDM_CLOSE,      BID_CLOSE   },
  { IDM_SAVE,       BID_SAVE    },
  { IDM_PRINT,      BID_PRINT   },
  { IDM_CUT,        BID_CUT     },
  { IDM_COPY,       BID_COPY    },
  { IDM_PASTE,      BID_PASTE   },
  { IDM_SEARCH,     BID_SEARCH  },
  { IDM_VIEW,       BID_VIEW    },
  { IDM_ARRANGE,    BID_ARRANGE },
  { IDM_FILTER,     BID_FILTER  },
  { IDM_SORT,       BID_SORT    },
  { IDM_SUMMARY,    BID_SUMMARY },
  { IDM_CHECK,      BID_CHECK   },
  { IDM_EDIT,       BID_EDIT    },
  { IDM_ADDEDIT,    BID_ADD     },
  { IDM_INSERTEDIT, BID_INSERT  },
  { IDM_SELDELETE,  BID_DELETE  },
  { IDM_SETENV,     BID_NEW     },
  { IDM_PREVWINDOW, BID_PREVWIN },
  { IDM_NEXTWINDOW, BID_NEXTWIN },
  { IDM_PREVPAGE,   BID_PREV    },
  { IDM_NEXTPAGE,   BID_NEXT    },
  { IDM_SETPRN,     BID_SETUP   },
  { IDM_ZOOMIN,     BID_ZOOMIN  },
  { IDM_ZOOMOUT,    BID_ZOOMOUT },
  { IDM_SAMESCALE,  BID_SAME    },
  { IDM_AUTOSCALE,  BID_WHOLE   },
};

BOOL LOCALF InitHOUTEI(UINT pa)
{ // Jn
  int i;

  InitBOLBAS(0);
  InitBOLDBE(0);
  InitBOLFRO(0);
  InitBOLGUI(0);
  for (i = 0; i < NELEM(ICI); i++) {
    SetMenuItemDDB(ICI[i].idm, AppDDB(ICI[i].bid));
  }
  InitPopupMenus();
  PrepToolBar();
  return TRUE;
}

void LOCALF TermHOUTEI(void)
{ // I
  LogoutSite();
  TermPopupMenus();
  TermBOLGUI();
  TermBOLFRO();
  TermBOLDBE();
  TermBOLBAS();
}

int  WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR lpszCmdLine, int nCmdShow)
{ // C֐
  HWND hwnd;
  MSG msg;
  HACCEL haccMain;
  HICON hicoMain;
  static FRMI fin = { PRGTIT, &IniDat.wpo, &BOLMS, IDTOB, &BOLTS, IDSTB, &BOLSS };

  InitHOUTEI(0);
  LoadENV();
  if (lpszCmdLine[0] != '\0') SetUserPath(lpszCmdLine);
  new_path_if_not_exists(UserPath());
  set_error_log_file(adddir(UserPath(), PRGNAM".LOG"));
//  start_debug(TRUE);
  LoadINI();

  haccMain = LoadAccelerators(hInstance, PRGNAM"ACC");
  hicoMain = LoadIcon(hInstance, PRGNAM"ICO");
  hbmpMain = LoadBitmap(hInstance, PRGNAM"BMP");
  hwnd = CreateBOLFRMWindow(hInstance, &fin); if (!hwnd) return 0;
  SubclassWindow(hwnd, FRM_WndProc);
  SendMessage(hwnd, WM_SETICON, ICON_BIG, (LPARAM)hicoMain);
  ShowWindow(hwnd, (IniDat.wpo.mx && nCmdShow == SW_SHOWNORMAL)? SW_SHOWMAXIMIZED: SW_SHOWDEFAULT);
  UpdateWindow(hwnd);
  PostMessage(hwnd, WM_COMMAND, IDM_LOGIN, 0);

  while (GetMessage(&msg, NULL, 0, 0)) {
    if (!TranslateAccelerator(hwnd, haccMain, &msg)) {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }

  SaveINI();
//  stop_debug();
  TermHOUTEI();

  return msg.wParam;
}

// ---------------------------------------------------------------------- //
