/* ---------------------------------------------------------------------- //
    bolbas.c
// ---------------------------------------------------------------------- */

#define  MODNAM  "BOLBAS"
#define  MODVER   2,0,0,0

#include <windows.h>

#define  _USE_MATH_DEFINES
#include <math.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma warning(disable:4996)

#include "bolbas.h"

// ---------------------------------------------------------------------- //

int  WINAPI sign(REAL d)
{ // double̐̔
  return (d > 0.0)? 1: (d < 0.0)? -1: 0;
}

int  WINAPI iround(REAL d)
{ // doubleľܓintɕϊ
  return (d >= 0.0)? (int)(d + 0.5): (int)(d - 0.5);
}

UINT WINAPI hash(PCSTR st, UINT hs)
{ // ̃nbVl
  UINT v;

  for (v = 0; *st != '\0'; st++) {
    v = ((v << 8) + *st) % hs;
  }
  return v;
}

UINT WINAPI nbound(UINT i, UINT n)
{ // nPʂɐ؂グ
  return ((i + n - 1) / n) * n;
}

BOOL LOCALF add_vptr(HMEM mb, PVOID pv)
{ // |C^̒ǉ
  if (mb->len + 1 >= mb->cap) return (BOOL)ierr(E_CAP);
  mb->ptr[mb->len++] = pv;
  return TRUE;
}

int  LOCALF search_vptr(HMEM mb, PVOID pv)
{ // |C^̃T[`(t)
  int i;

  for (i = mb->len - 1; i >= 0; i--) {
    if (mb->ptr[i] == pv) return i;
  }
  return -1;
}

BOOL LOCALF remove_vptr(HMEM mb, PVOID pv)
{ // |C^̍폜
  int i;

  i = search_vptr(mb, pv); if (i < 0) return FALSE;
  if (i + 1 < mb->len) {
    memmove(&mb->ptr[i], &mb->ptr[i + 1], (mb->len - i - 1) * sizeof(PVOID));
  }
  mb->len--;
  return TRUE;
}

HANDLE LOCALF wheap(HMEM mb)
{ // q[v
  return (mb->rsv <= 8)? GetProcessHeap(): (HANDLE)mb->rsv;
}

PVOID WINAPI walloc(HMEM mb, UINT sz, BOOL clr)
{ // q[v̊蓖
  PVOID pv;

  pv = HeapAlloc(wheap(mb), clr? HEAP_ZERO_MEMORY: 0, sz);
  if (pv) add_vptr(mb, pv);
  return pv;
}

PVOID WINAPI wrealloc(HMEM mb, PVOID pv, UINT sz)
{ // q[v̍Ċ蓖
  PVOID pr;

  if (!pv) return walloc(mb, sz, 0);
  pr = HeapReAlloc(wheap(mb), 0, pv, sz);
  if (pr) { remove_vptr(mb, pv); add_vptr(mb, pr);}
  return pr;
}

BOOL WINAPI wfree(HMEM mb, PVOID pv)
{ // q[v̉
  int re;

  if (!iswheap(mb, pv)) return FALSE;
  re = HeapFree(wheap(mb), 0, pv);
  if (re) remove_vptr(mb, pv);
  return re;
}

void WINAPI wclear(HMEM mb)
{ // q[v̑S
  int i;

  for (i = mb->len - 1; i >= 0; i--) {
    HeapFree(wheap(mb), 0, mb->ptr[i]);
  }
  mb->len = 0;
}

BOOL WINAPI iswheap(HMEM mb, PVOID pv)
{ // q[vɊ蓖Ăꂽ|C^
  return search_vptr(mb, pv) >= 0;
}

  // q[vǗ
static PVOID MEM[MEMCAP];
static HMEM_ blkMEM = { MEM, 0, MEMCAP, sizeof(PVOID) };

PVOID WINAPI halloc(UINT sz, BOOL clr)
{ // q[v̊蓖
  return walloc(&blkMEM, sz, clr);
}

PVOID WINAPI hrealloc(PVOID pv, UINT sz)
{ // q[v̍Ċ蓖
  return wrealloc(&blkMEM, pv, sz);
}

BOOL WINAPI hfree(PVOID pv)
{ // q[v̉
  return wfree(&blkMEM, pv);
}

void WINAPI hclear(void)
{ // q[v̑S
  wclear(&blkMEM);
}

BOOL WINAPI isheap(PVOID pv)
{ // q[vɊ蓖Ăꂽ|C^
  return iswheap(&blkMEM, pv);
}

  // zobt@(񑀍p)
static BYTE TBUF[TBUFSZ], *pTB = TBUF;

PVOID WINAPI talloc(UINT sz)
{ // ꎞIȃ̊蓖
  PVOID pt;

  if (sz > MAXSTR) ierr(E_CAP);
  sz = nbound(sz, 8);
  if ((pTB - TBUF) + sz > TBUFSZ) pTB = TBUF;
  pt = pTB; pTB += sz;
  return pt;
}

  // zobt@(ėp)
static BYTE UBUF[UBUFSZ], *pUB = UBUF;

PVOID WINAPI ualloc(UINT sz)
{ // ꎞIȃ̊蓖
  PVOID pt;

  if (sz > UBUFSZ) ierr(E_CAP);
  sz = nbound(sz, 8);
  if ((pUB - UBUF) + sz > UBUFSZ) pUB = UBUF;
  pt = pUB; pUB += sz;
  return pt;
}

PVOID WINAPI valloc(UINT sz)
{ // ꎞIȃ̊蓖([NA)
  return memset(ualloc(sz), 0, (sz < UBUFSZ)? sz: UBUFSZ);
}

// ---------------------------------------------------------------------- //

#define  CHR_SPC   0x0001
#define  CHR_CTL   0x0002
#define  CHR_SYM   0x0004
#define  CHR_DIG   0x0008
#define  CHR_ODIG  0x0010
#define  CHR_XDIG  0x0020
#define  CHR_UPR   0x0040
#define  CHR_LWR   0x0080
#define  CHR_ASC   0x0100
#define  CHR_HAN   0x0200
#define  CHR_ZEN1  0x0400
#define  CHR_ZEN2  0x0800
#define  CHR_DAK1  0x1000
#define  CHR_DAK2  0x2000
#define  CHR_UND   0x4000

  // 
static WORD CHC[256] = {
  0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, // 00-07
  0x0002, 0x0003, 0x0003, 0x0003, 0x0003, 0x0003, 0x0002, 0x0002, // 08-0F
  0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, // 10-17
  0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, 0x0002, // 18-1F
  0x0101, 0x0104, 0x0100, 0x0104, 0x0104, 0x0104, 0x0104, 0x0100, // 20-27
  0x0104, 0x0104, 0x0104, 0x0104, 0x0104, 0x0104, 0x0104, 0x0104, // 28-2F
  0x0138, 0x0138, 0x0138, 0x0138, 0x0138, 0x0138, 0x0138, 0x0138, // 30-37
  0x0128, 0x0128, 0x0104, 0x0104, 0x0104, 0x0104, 0x0104, 0x0104, // 38-3F
  0x0904, 0x0960, 0x0960, 0x0960, 0x0960, 0x0960, 0x0960, 0x0940, // 40-47
  0x0940, 0x0940, 0x0940, 0x0940, 0x0940, 0x0940, 0x0940, 0x0940, // 48-4F
  0x0940, 0x0940, 0x0940, 0x0940, 0x0940, 0x0940, 0x0940, 0x0940, // 50-57
  0x0940, 0x0940, 0x0940, 0x0904, 0x0900, 0x0904, 0x0904, 0x4900, // 58-5F
  0x0904, 0x09a0, 0x09a0, 0x09a0, 0x09a0, 0x09a0, 0x09a0, 0x0980, // 60-67
  0x0980, 0x0980, 0x0980, 0x0980, 0x0980, 0x0980, 0x0980, 0x0980, // 68-6F
  0x0980, 0x0980, 0x0980, 0x0980, 0x0980, 0x0980, 0x0980, 0x0980, // 70-77
  0x0980, 0x0980, 0x0980, 0x0900, 0x0900, 0x0900, 0x0900, 0x0002, // 78-7F
  0x0800, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // 80-87
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // 88-8F
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // 90-97
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // 98-9F
  0x0800, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, // A0-A7
  0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, // A8-AF
  0x0a00, 0x0a00, 0x0a00, 0x1a00, 0x0a00, 0x0a00, 0x1a00, 0x1a00, // B0-B7
  0x1a00, 0x1a00, 0x1a00, 0x1a00, 0x1a00, 0x1a00, 0x1a00, 0x1a00, // B8-BF
  0x1a00, 0x1a00, 0x1a00, 0x1a00, 0x1a00, 0x0a00, 0x0a00, 0x0a00, // C0-C7
  0x0a00, 0x0a00, 0x3a00, 0x3a00, 0x3a00, 0x3a00, 0x3a00, 0x0a00, // C8-CF
  0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, // D0-D7
  0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, 0x0a00, // D8-DF
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // E0-E7
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // E8-EF
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, // F0-F7
  0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0c00, 0x0000, 0x0000, 0x0000, // F8-FF
};

BOOL WINAPI isspc(int c)
{ // 󔒕
  return !!(CHC[(BYTE)c] & CHR_SPC);
}

BOOL WINAPI isctl(int c)
{ // 䕶
  return !!(CHC[(BYTE)c] & CHR_CTL);
}

BOOL WINAPI isdig(int c)
{ // 10i
  return !!(CHC[(BYTE)c] & CHR_DIG);
}

BOOL WINAPI isodig(int c)
{ // 8i
  return !!(CHC[(BYTE)c] & CHR_ODIG);
}

BOOL WINAPI isxdig(int c)
{ // 16i
  return !!(CHC[(BYTE)c] & CHR_XDIG);
}

BOOL WINAPI isupr(int c)
{ // p啶
  return !!(CHC[(BYTE)c] & CHR_UPR);
}

BOOL WINAPI islwr(int c)
{ // p
  return !!(CHC[(BYTE)c] & CHR_LWR);
}

BOOL WINAPI isalp(int c)
{ // p
  return !!(CHC[(BYTE)c] & (CHR_UPR|CHR_LWR));
}

BOOL WINAPI isalpx(int c)
{ // pAA_[o[
  return !!(CHC[(BYTE)c] & (CHR_UPR|CHR_LWR|CHR_UND));
}

BOOL WINAPI isaln(int c)
{ // pA
  return !!(CHC[(BYTE)c] & (CHR_UPR|CHR_LWR|CHR_DIG));
}

BOOL WINAPI isalnx(int c)
{ // pAAA_[o[
  return !!(CHC[(BYTE)c] & (CHR_UPR|CHR_LWR|CHR_DIG|CHR_UND));
}

BOOL WINAPI isasc(int c)
{ // \\ASCII
  return !!(CHC[(BYTE)c] & CHR_ASC);
}

BOOL WINAPI ishan(int c)
{ // pJi
  return !!(CHC[(BYTE)c] & CHR_HAN);
}

BOOL WINAPI isprn(int c)
{ // \\
  return !!(CHC[(BYTE)c] & (CHR_ASC|CHR_HAN));
}

BOOL WINAPI iszen1(int c)
{ // Sp̑1oCg
  return !!(CHC[(BYTE)c] & CHR_ZEN1);
}

BOOL WINAPI iszen2(int c)
{ // Sp̑2oCg
  return !!(CHC[(BYTE)c] & CHR_ZEN2);
}

BOOL WINAPI iszen(PCSTR st)
{ // |C^SpwĂ邩ǂ̔
  return iszen1(*st) && iszen2(*(st+1));
}

BOOL LOCALF isdak1(int c)
{ // ɂȂ锼pJi
  return !!(CHC[(BYTE)c] & CHR_DAK1);
}

BOOL LOCALF isdak2(int c)
{ // ɂȂ锼pJi
  return !!(CHC[(BYTE)c] & CHR_DAK2);
}

BOOL LOCALF isdak(PCSTR st)
{ // |C^pJȋAwĂ邩ǂ̔
  return isdak1(*st) && (BYTE)*(st+1) == 0xde || isdak2(*st) && (BYTE)*(st+1) == 0xdf;
}

BOOL LOCALF isret(PCSTR st)
{ // |C^swĂ邩ǂ̔
  return *st == '\r' && *(st+1) == '\n';
}

PSTR WINAPI spncpy(PSTR sd, PCSTR p1, PCSTR p2)
{ // p1p2̒O܂ŃRs[
  PSTR pt = sd;

  while (p1 < p2) *pt++ = *p1++;
  *pt = '\0';
  return sd;
}

PSTR WINAPI strcpyn(PSTR sd, PCSTR ss, int n)
{ // w蒷܂ŕRs[
  PSTR pt = sd;

  while (*ss != '\0') {
    if (iszen(ss)) {
      if (pt - sd < n - 1) *((PWORD)pt)++ = *((PWORD)ss)++;  else break;
    } else {
      if (pt - sd < n) *pt++ = *ss++;  else break;
    }
  }
  *pt = '\0';
  return sd;
}

PSTR WINAPI strcpyx(PSTR sd, PCSTR ss, int n)
{ // w蒷܂ŕRs[(c̓kŖ߂)
  PSTR pt = sd;

  while (*ss != '\0') {
    if (iszen(ss)) {
      if (pt - sd < n - 1) *((PWORD)pt)++ = *((PWORD)ss)++;  else break;
    } else {
      if (pt - sd < n) *pt++ = *ss++;  else break;
    }
  }
  do *pt++ = '\0'; while (pt - sd <= n);
  return sd;
}

BOOL WINAPI nthzen1(PCSTR st, int n)
{ // 񒆂̎woCgSp̑1oCgڂǂ̔
  int k;

  for (k = 0; n >= 0 && iszen1(st[n]); n--) k = 1 - k;
  return k;
}

BOOL WINAPI nthyen(PCSTR st, int n)
{ // 񒆂̎woCgp~Lǂ̔
  return st[n] == '\\' && !nthzen1(st, n - 1);
}

#define  ISBYTE(c)  (((c) & 0xffffff00) == 0 || ((c) & 0xffffff80) == 0xffffff80)
#define  ISWORD(c)  (((c) & 0xffff0000) == 0 || ((c) & 0xffff8000) == 0xffff8000)

#define  SWAP2B(c)  MAKEWORD(HIBYTE(c), LOBYTE(c))

PSTR WINAPI mbschr(PCSTR st, int c)
{ // ŏɌw蕶ւ̃|C^(strchȓSpΉ)
  if (c == 0) {
    return (PSTR)(st + strlen(st));
  } else if (ISBYTE(c)) {
    while (*st != '\0') {
      if (iszen(st)) {
        ((PWORD)st)++;
      } else {
        if ((BYTE)*st == (BYTE)c) return (PSTR)st;
        st++;
      }
    }
  } else if (ISWORD(c)) {
    c = SWAP2B(c);
    while (*st != '\0') {
      if (iszen(st)) {
        if (*(PWORD)st == (WORD)c) return (PSTR)st;
        ((PWORD)st)++;
      } else {
        st++;
      }
    }
  }
  return NULL;
}

PSTR WINAPI mbsrchr(PCSTR st, int c)
{ // ŌɌw蕶ւ̃|C^(strrchȓSpΉ)
  PCSTR pt = NULL;

  if (c == 0) {
    return (PSTR)(st + strlen(st));
  } else if (ISBYTE(c)) {
    while (*st != '\0') {
      if (iszen(st)) {
        ((PWORD)st)++;
      } else {
        if ((BYTE)*st == (BYTE)c) pt = st;
        st++;
      }
    }
  } else if (ISWORD(c)) {
    c = SWAP2B(c);
    while (*st != '\0') {
      if (iszen(st)) {
        if (*(PWORD)st == (WORD)c) pt = st;
        ((PWORD)st)++;
      } else {
        st++;
      }
    }
  }
  return (PSTR)pt;
}

UINT WINAPI mbslen(PCSTR st)
{ // 
  int n = 0;

  while (*st != '\0') {
    n++;
    if (iszen(st)) ((PWORD)st)++;  else st++;
  }
  return n;
}

int  LOCALF u2l(int c)
{ // 啶
  return isupr(c)? c + ('a' - 'A'): c;
}

int  LOCALF z2h(int c);

typedef BOOL (CALLBACK * FMAT)(int c1, int c2);

BOOL LOCALF fmat0(int c1, int c2)
{ // ̈v
  return c1 == c2;
}

BOOL LOCALF fmat1(int c1, int c2)
{ // 啶ƏʂȂ
  return c1 == c2 || u2l(c1) == c2 || c1 == u2l(c2);
}

BOOL LOCALF fmat2(int c1, int c2)
{ // SpƔpʂȂ
  return c1 == c2 || z2h(c1) == c2 || c1 == z2h(c2);
}

BOOL LOCALF fmat3(int c1, int c2)
{ // 啶ƏASpƔpʂȂ
  return c1 == c2 || u2l(z2h(c1)) == c2 || c1 == u2l(z2h(c2));
}

int  LOCALF strmatchx(PCSTR s1, PCSTR s2, int flg)
{ // ̏ƍ
  int c1, c2;
  PCSTR pt = s1;
  FMAT fmat;

  switch (flg) {
  default: fmat = fmat0; break;
  case STX_UPR: fmat = fmat1; break;
  case STX_ZEN: fmat = fmat2; break;
  case STX_UPR|STX_ZEN: fmat = fmat3; break;
  }
  while (*s2 != '\0') {
    switch (iszen(s1) * 2 + iszen(s2)) {
    case 0: c1 = (BYTE)*s1++; c2 = (BYTE)*s2++; break;
    case 1: c1 = isdak(s1)? *((PWORD)s1)++: (BYTE)*s1++; c2 = *((PWORD)s2)++; break;
    case 2: c1 = *((PWORD)s1)++; c2 = isdak(s2)? *((PWORD)s2)++: (BYTE)*s2++; break;
    case 3: c1 = *((PWORD)s1)++; c2 = *((PWORD)s2)++; break;
    }
    if (!fmat(c1, c2)) return 0;
  }
  return s1 - pt;
}

PSTR WINAPI strfindx(PCSTR s1, PCSTR s2, int flg)
{ // ̌
  while (*s1 != '\0') {
    if (strmatchx(s1, s2, flg)) return (PSTR)s1;
    if (iszen(s1)) ((PWORD)s1)++;  else s1++;
  }
  return NULL;
}

PSTR WINAPI strfind(PCSTR s1, PCSTR s2)
{ // ̌
  return strfindx(s1, s2, 0);
}

BOOL WINAPI strlfind(PCSTR s1, PCSTR s2)
{ // ̑Ov
  return !strncmp(s1, s2, strlen(s2));
}

BOOL WINAPI strrfind(PCSTR s1, PCSTR s2)
{ // ̌v
  int w = strlen(s1) - strlen(s2);

  return w >= 0 && !strcmp(s1 + w, s2) && !nthzen1(s1, w - 1);
}

PSTR WINAPI strifind(PCSTR s1, PCSTR s2)
{ // 啶ƏʂȂ̌
  return strfindx(s1, s2, STX_UPR);
}

BOOL WINAPI strilfind(PCSTR s1, PCSTR s2)
{ // 啶ƏʂȂ̑Ov
  return !strnicmp(s1, s2, strlen(s2));
}

BOOL WINAPI strirfind(PCSTR s1, PCSTR s2)
{ // 啶ƏʂȂ̌v
  int w = strlen(s1) - strlen(s2);

  return w >= 0 && !stricmp(s1 + w, s2);
}

BOOL WINAPI strmatch(PCSTR s1, PCSTR s2)
{ // ̃p^[ƍ
  while (*s2 != '\0') {
    switch (iszen(s1) * 2 + iszen(s2)) {
    case 0:
      switch (*s2) {
      case '#': if (!isdig(*s1)) return FALSE;  else break;
      case '$': if (!isalp(*s1)) return FALSE;  else break;
      case '%': if (!isaln(*s1)) return FALSE;  else break;
      case '*': if (!isasc(*s1)) return FALSE;  else break;
      case '~': return TRUE;
      default: if (*s1 != *s2) return FALSE;  else break;
      }
      s1++; s2++; break;
    case 1:
    case 2:
      return FALSE;
    case 3:
      if (*((PWORD)s1)++ != *((PWORD)s2)++) return FALSE;
      break;
    }
  }
  return *s1 == '\0';
}

int  WINAPI strcount(PCSTR s1, PCSTR s2)
{ // ̃JEg
  int n = 0, w;
  PSTR pt;

  w = strlen(s2); if (w <= 0) return 0;
  while (!!(pt = strfind(s1, s2))) {
    n++;
    s1 = pt + w;
  }
  return n;
}

typedef struct {
  BYTE  a;
  BYTE  s;
  WORD  z;
} HZCI;
  // p̑Spϊ
static HZCI HZC[] = {
  { ' ',  0, 0x4081 }, { '!',  0, 0x4981 }, { '"',  0, 0x6881 }, { '#',  0, 0x9481 },
  { '$',  0, 0x9081 }, { '%',  0, 0x9381 }, { '&',  0, 0x9581 }, {0x27,  0, 0x6681 },
  { '(',  0, 0x6981 }, { ')',  0, 0x6a81 }, { '*',  0, 0x9681 }, { '+',  0, 0x7b81 },
  { ',',  0, 0x4381 }, { '-',  0, 0x7c81 }, { '.',  0, 0x4481 }, { '/',  0, 0x5e81 },
  { '0',  0, 0x4f82 }, { '1',  0, 0x5082 }, { '2',  0, 0x5182 }, { '3',  0, 0x5282 },
  { '4',  0, 0x5382 }, { '5',  0, 0x5482 }, { '6',  0, 0x5582 }, { '7',  0, 0x5682 },
  { '8',  0, 0x5782 }, { '9',  0, 0x5882 }, { ':',  0, 0x4681 }, { ';',  0, 0x4781 },
  { '<',  0, 0x8381 }, { '=',  0, 0x8181 }, { '>',  0, 0x8481 }, { '?',  0, 0x4881 },
  { '@',  0, 0x9781 }, { 'A',  0, 0x6082 }, { 'B',  0, 0x6182 }, { 'C',  0, 0x6282 },
  { 'D',  0, 0x6382 }, { 'E',  0, 0x6482 }, { 'F',  0, 0x6582 }, { 'G',  0, 0x6682 },
  { 'H',  0, 0x6782 }, { 'I',  0, 0x6882 }, { 'J',  0, 0x6982 }, { 'K',  0, 0x6a82 },
  { 'L',  0, 0x6b82 }, { 'M',  0, 0x6c82 }, { 'N',  0, 0x6d82 }, { 'O',  0, 0x6e82 },
  { 'P',  0, 0x6f82 }, { 'Q',  0, 0x7082 }, { 'R',  0, 0x7182 }, { 'S',  0, 0x7282 },
  { 'T',  0, 0x7382 }, { 'U',  0, 0x7482 }, { 'V',  0, 0x7582 }, { 'W',  0, 0x7682 },
  { 'X',  0, 0x7782 }, { 'Y',  0, 0x7882 }, { 'Z',  0, 0x7982 }, { '[',  0, 0x6d81 },
  {0x5c,  0, 0x8f81 }, { ']',  0, 0x6e81 }, { '^',  0, 0x4f81 }, { '_',  0, 0x5181 },
  { '`',  0, 0x4d81 }, { 'a',  0, 0x8182 }, { 'b',  0, 0x8282 }, { 'c',  0, 0x8382 },
  { 'd',  0, 0x8482 }, { 'e',  0, 0x8582 }, { 'f',  0, 0x8682 }, { 'g',  0, 0x8782 },
  { 'h',  0, 0x8882 }, { 'i',  0, 0x8982 }, { 'j',  0, 0x8a82 }, { 'k',  0, 0x8b82 },
  { 'l',  0, 0x8c82 }, { 'm',  0, 0x8d82 }, { 'n',  0, 0x8e82 }, { 'o',  0, 0x8f82 },
  { 'p',  0, 0x9082 }, { 'q',  0, 0x9182 }, { 'r',  0, 0x9282 }, { 's',  0, 0x9382 },
  { 't',  0, 0x9482 }, { 'u',  0, 0x9582 }, { 'v',  0, 0x9682 }, { 'w',  0, 0x9782 },
  { 'x',  0, 0x9882 }, { 'y',  0, 0x9982 }, { 'z',  0, 0x9a82 }, { '{',  0, 0x6f81 },
  { '|',  0, 0x6281 }, { '}',  0, 0x7081 }, { '~',  0, 0x5081 }, { '','', 0x9483 },
  { '',  0, 0x4281 }, { '',  0, 0x7581 }, { '',  0, 0x7681 }, { '',  0, 0x4181 },
  { '',  0, 0x4581 }, { '',  0, 0x9283 }, { '',  0, 0x4083 }, { '',  0, 0x4283 },
  { '',  0, 0x4483 }, { '',  0, 0x4683 }, { '',  0, 0x4883 }, { '',  0, 0x8383 },
  { '',  0, 0x8583 }, { '',  0, 0x8783 }, { '',  0, 0x6283 }, { '',  0, 0x5b81 },
  { '',  0, 0x4183 }, { '',  0, 0x4383 }, { '',  0, 0x4583 }, { '',  0, 0x4783 },
  { '',  0, 0x4983 }, { '',  0, 0x4a83 }, { '','', 0x4b83 }, { '',  0, 0x4c83 },
  { '','', 0x4d83 }, { '',  0, 0x4e83 }, { '','', 0x4f83 }, { '',  0, 0x5083 },
  { '','', 0x5183 }, { '',  0, 0x5283 }, { '','', 0x5383 }, { '',  0, 0x5483 },
  { '','', 0x5583 }, { '',  0, 0x5683 }, { '','', 0x5783 }, { '',  0, 0x5883 },
  { '','', 0x5983 }, { '',  0, 0x5a83 }, { '','', 0x5b83 }, { '',  0, 0x5c83 },
  { '','', 0x5d83 }, { '',  0, 0x5e83 }, { '','', 0x5f83 }, { '',  0, 0x6083 },
  { '','', 0x6183 }, { '',  0, 0x6383 }, { '','', 0x6483 }, { '',  0, 0x6583 },
  { '','', 0x6683 }, { '',  0, 0x6783 }, { '','', 0x6883 }, { '',  0, 0x6983 },
  { '',  0, 0x6a83 }, { '',  0, 0x6b83 }, { '',  0, 0x6c83 }, { '',  0, 0x6d83 },
  { '',  0, 0x6e83 }, { '','', 0x6f83 }, { '','', 0x7083 }, { '',  0, 0x7183 },
  { '','', 0x7283 }, { '','', 0x7383 }, { '',  0, 0x7483 }, { '','', 0x7583 },
  { '','', 0x7683 }, { '',  0, 0x7783 }, { '','', 0x7883 }, { '','', 0x7983 },
  { '',  0, 0x7a83 }, { '','', 0x7b83 }, { '','', 0x7c83 }, { '',  0, 0x7d83 },
  { '',  0, 0x7e83 }, { '',  0, 0x8083 }, { '',  0, 0x8183 }, { '',  0, 0x8283 },
  { '',  0, 0x8483 }, { '',  0, 0x8683 }, { '',  0, 0x8883 }, { '',  0, 0x8983 },
  { '',  0, 0x8a83 }, { '',  0, 0x8b83 }, { '',  0, 0x8c83 }, { '',  0, 0x8d83 },
  { '',  0, 0x8f83 }, { '',  0, 0x9383 }, { '',  0, 0x4a81 }, { '',  0, 0x4b81 },
};

int  LOCALF h2z(int c)
{ // pSp
  int i;

  for (i = 0; i < NELEM(HZC); i++) {
    if (*(PWORD)&HZC[i].a == (WORD)c) return HZC[i].z;
  }
  return c;
}

int  LOCALF z2h(int c)
{ // Spp
  int i;

  for (i = 0; i < NELEM(HZC); i++) {
    if (HZC[i].z == (WORD)c) return *(PWORD)&HZC[i].a;
  }
  return c;
}

PSTR LOCALF tozen_b(PCSTR st, PSTR bf)
{ // 񒆂̔pΉSpɕϊ
  int c, d;
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      *((PWORD)pt)++ = *((PWORD)st)++;
    } else if (isdak(st)) {
      *((PWORD)pt)++ = h2z(*((PWORD)st)++);
    } else {
      if ((d = h2z(c = (BYTE)*st++)) != c) *((PWORD)pt)++ = d;  else *pt++ = c;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF tohan_b(PCSTR st, PSTR bf)
{ // 񒆂(p\)SpΉ锼pɕϊ
  int d;
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      if ((d = z2h(*((PWORD)st)++)) & 0xff00) *((PWORD)pt)++ = d;  else *pt++ = d;
    } else {
      *pt++ = *st++;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF toupr_b(PCSTR st, PSTR bf)
{ // 񒆂̉pp啶ɕϊ
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      *((PWORD)pt)++ = *((PWORD)st)++;
    } else if (islwr(*st)) {
      *pt++ = *st++ - ('a' - 'A');
    } else {
      *pt++ = *st++;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF tolwr_b(PCSTR st, PSTR bf)
{ // 񒆂̉p啶pɕϊ
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      *((PWORD)pt)++ = *((PWORD)st)++;
    } else if (isupr(*st)) {
      *pt++ = *st++ + ('a' - 'A');
    } else {
      *pt++ = *st++;
    }
  }
  *pt = '\0';
  return bf;
}

int  LOCALF k2h(int c)
{ // SpJ^JiSpЂ炪
  int d = SWAP2B(c);

  if (d >= 0x8340 && d <= 0x837e) { d -= (0x8340 - 0x829f); return SWAP2B(d);}
  if (d >= 0x8380 && d <= 0x8393) { d -= (0x8380 - 0x82de); return SWAP2B(d);}
  return c;
}

int  LOCALF h2k(int c)
{ // SpЂ炪ȁSpJ^Ji
  int d = SWAP2B(c);

  if (d >= 0x829f && d <= 0x82dd) { d += (0x8340 - 0x829f); return SWAP2B(d);}
  if (d >= 0x82de && d <= 0x82f1) { d += (0x8380 - 0x82de); return SWAP2B(d);}
  return c;
}

PSTR LOCALF tohira_b(PCSTR st, PSTR bf)
{ // 񒆂̑SpJ^JiSpЂ炪Ȃɕϊ
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      *((PWORD)pt)++ = k2h(*((PWORD)st)++);
    } else {
      *pt++ = *st++;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF tokata_b(PCSTR st, PSTR bf)
{ // 񒆂̑SpЂ炪ȂSpJ^Jiɕϊ
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      *((PWORD)pt)++ = h2k(*((PWORD)st)++);
    } else {
      *pt++ = *st++;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF ltrim_b(PCSTR st, PSTR bf)
{ // 񍶑̋󔒍폜
  while (isspc(*st)) st++;
  return strcpy(bf, st);
}

PSTR LOCALF rtrim_b(PCSTR st, PSTR bf)
{ // E̋󔒍폜
  PCSTR ps = st + strlen(st);

  while (ps > st && isspc(*(ps-1))) ps--;
  return spncpy(bf, st, ps);
}

PSTR LOCALF btrim_b(PCSTR st, PSTR bf)
{ // 񗼑̋󔒍폜
  PCSTR ps;

  while (isspc(*st)) st++;
  ps = st + strlen(st);
  while (ps > st && isspc(*(ps-1))) ps--;
  return spncpy(bf, st, ps);
}

PSTR LOCALF delspc_b(PCSTR st, PSTR bf)
{ // 񒆂̋󔒍폜
  PSTR pt = bf;

  while (*st != '\0') {
    if (isspc(*st)) st++;  else *pt++ = *st++;
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF delctl_b(PCSTR st, PSTR bf)
{ // 񒆂̐䕶폜
  PSTR pt = bf;

  while (*st != '\0') {
    if (isctl(*st)) st++;  else *pt++ = *st++;
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF ctlspc_b(PCSTR st, PSTR bf)
{ // 񒆂̐䕶󔒂ɕϊ
  PSTR pt = bf;

  while (*st != '\0') {
    if (isctl(*st)) { *pt++ = ' '; st++;}  else *pt++ = *st++;
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF cipher_b(PCSTR st, PSTR bf)
{ // Í
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) {
      *pt++ = *st++;
      if ((BYTE)*st >= 0x40 && (BYTE)*st <= 0x7e) {
        *pt++ = (0x40 + 0x7e) - *st++;
      } else if ((BYTE)*st >= 0x80 && (BYTE)*st <= 0xfc) {
        *pt++ = (0x80 + 0xfc) - *st++;
      } else {
        *pt++ = *st++;
      }
    } else if ((BYTE)*st >= 0x21 && (BYTE)*st <= 0x7e) {
      *pt++ = (0x21 + 0x7e) - *st++;
    } else if ((BYTE)*st >= 0xa1 && (BYTE)*st <= 0xde) {
      *pt++ = (0xa1 + 0xde) - *st++;
    } else {
      *pt++ = *st++;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF inscma_b(PCSTR st, PSTR bf)
{ // l3R}t
  int k = 0;
  PSTR pt = bf;

  while (*st != '\0' && !isdig(*st) && *st != '.') *pt++ = *st++;
  while (isdig(st[k])) k++;
  while (k > 0) {
    *pt++ = *st++;
    if (k > 3 && k % 3 == 1) *pt++ = ',';
    k--;
  }
  while ((*pt++ = *st++) != '\0') ;
  return bf;
}

PSTR LOCALF delcma_b(PCSTR st, PSTR bf)
{ // l3R}폜
  PSTR pt = bf;

  while (*st != '\0' && !isdig(*st) && *st != '.') *pt++ = *st++;
  for (;;) {
    if (*st == ',') st++;  else if (isdig(*st)) *pt++ = *st++;  else break;
  }
  while ((*pt++ = *st++) != '\0') ;
  return bf;
}

PCSTR WINAPI tozen(PCSTR st)
{ // pSpɕϊ
  return tozen_b(st, talloc(strlen(st) * 2 + 1));
}

PCSTR WINAPI tohan(PCSTR st)
{ // Sp(\Ȃ)pɕϊ
  return tohan_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI toupr(PCSTR st)
{ // pp啶ɕϊ
  return toupr_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI tolwr(PCSTR st)
{ // p啶pɕϊ
  return tolwr_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI tohira(PCSTR st)
{ // SpJ^JiSpЂ炪Ȃɕϊ
  return tohira_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI tokata(PCSTR st)
{ // SpЂ炪ȂSpJ^Jiɕϊ
  return tokata_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI ltrim(PCSTR st)
{ // 񍶑̋󔒍폜
  return ltrim_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI rtrim(PCSTR st)
{ // E̋󔒍폜
  return rtrim_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI btrim(PCSTR st)
{ // 񗼑̋󔒍폜
  return btrim_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI delspc(PCSTR st)
{ // 񒆂̋󔒍폜
  return delspc_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI delctl(PCSTR st)
{ // 񒆂̐䕶폜
  return delctl_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI ctlspc(PCSTR st)
{ // 񒆂̐䕶󔒂ɕϊ
  return ctlspc_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI cipher(PCSTR st)
{ // Í
  return cipher_b(st, talloc(strlen(st) + 1));
}

PCSTR WINAPI inscma(PCSTR st)
{ // l3R}t
  return inscma_b(st, talloc(strlen(st) + strlen(st) / 3 + 1));
}

PCSTR WINAPI delcma(PCSTR st)
{ // l3R}폜
  return delcma_b(st, talloc(strlen(st) + 1));
}

BOOL WINAPI strlike(PCSTR s1, PCSTR s2)
{ // ̞B
  return !strcmp(delspc(tohan(toupr(s1))), delspc(tohan(toupr(s2))));
}

BOOL WINAPI strmlike(PCSTR s1, PCSTR s2)
{ // ̞B
  return !!strfind(delspc(tohan(toupr(s1))), delspc(tohan(toupr(s2))));
}

BOOL WINAPI strllike(PCSTR s1, PCSTR s2)
{ // ̑OvB
  return strlfind(delspc(tohan(toupr(s1))), delspc(tohan(toupr(s2))));
}

BOOL WINAPI strrlike(PCSTR s1, PCSTR s2)
{ // ̌vB
  return strrfind(delspc(tohan(toupr(s1))), delspc(tohan(toupr(s2))));
}

PSTR LOCALF midstr_b(PCSTR st, int n1, int n2, PSTR bf)
{ // n1ڂn2̕o
  int n;
  PSTR pt = bf;

  for (n = 0; *st != '\0'; n++) {
    if (n >= n1 && n < n1 + n2) {
      if (iszen(st)) *((PWORD)pt)++ = *((PWORD)st)++;  else *pt++ = *st++;
    } else {
      if (iszen(st)) ((PWORD)st)++;  else st++;
    }
  }
  *pt = '\0';
  return bf;
}

PSTR LOCALF strrepl_b(PCSTR st, PCSTR s1, PCSTR s2, PSTR bf)
{ // ̒u(s1s2)
  int i, w;
  PSTR pt = bf, ps;

  w = strlen(s1); if (w <= 0) return strcpy(bf, st);
  while (!!(ps = strfind(st, s1))) {
    while (st < ps) *pt++ = *st++;
    for (i = 0; s2[i] != '\0'; i++) *pt++ = s2[i];
    st += w;
  }
  while ((*pt++ = *st++) != '\0') ;
  return bf;
}

PCSTR WINAPI midstr(PCSTR st, int n1, int n2)
{ // n1ڂn2̕o
  return midstr_b(st, n1, n2, talloc(strlen(st) + 1));
}

PCSTR WINAPI strrepl(PCSTR st, PCSTR s1, PCSTR s2)
{ // ̒u(s1s2)
  return strrepl_b(st, s1, s2, talloc(strlen(st) + strcount(st, s1) * (strlen(s2) - strlen(s1)) + 1));
}

PCSTR WINAPI strconc(PCSTR s1, PCSTR s2)
{ // ̘A
  return strcat(strcpy(talloc(strlen(s1) + strlen(s2) + 1), s1), s2);
}

int  WINAPIV csprintf(PSTR st, PCSTR fmt, ...)
{ // sprintf̌ʂ3R}t
  va_list ap;
  char bf[512];

  va_start(ap, fmt);
  vsprintf(bf, fmt, ap);
  va_end(ap);
  return strlen(inscma_b(bf, st));
}

PCSTR WINAPIV format(PCSTR fmt, ...)
{ // lĕɕϊ
  va_list ap;
  char bf[512];

  va_start(ap, fmt);
  vsprintf(bf, fmt, ap);
  va_end(ap);
  return strcpy(talloc(strlen(bf) + 1), bf);
}

PCSTR WINAPIV cformat(PCSTR fmt, ...)
{ // lĕɕϊ(l3R}t)
  va_list ap;
  char bf[512];

  va_start(ap, fmt);
  vsprintf(bf, fmt, ap);
  va_end(ap);
  return inscma_b(bf, talloc(strlen(bf) * 4 / 3 + 1));
}

int  WINAPI ztoi(PCSTR st)
{ // intɕϊ(SpΉ)
  return atoi(tohan(st));
}

UINT WINAPI ztou(PCSTR st)
{ // UINTɕϊ(SpΉ)
  return strtoul(tohan(st), NULL, 10);
}

I8B WINAPI ztoi64(PCSTR st)
{ // INT64ɕϊ(SpΉ)
  return _atoi64(tohan(st));
}

U8B WINAPI ztou64(PCSTR st)
{ // UINT64ɕϊ(SpΉ)
  return _strtoui64(tohan(st), NULL, 10);
}

REAL WINAPI ztof(PCSTR st)
{ // doubleɕϊ(SpΉ)
  return atof(tohan(st));
}

int  WINAPI cztoi(PCSTR st)
{ // 3R}폜ĕintɕϊ(SpΉ)
  return atoi(delcma(tohan(st)));
}

UINT WINAPI cztou(PCSTR st)
{ // 3R}폜ĕUINTɕϊ(SpΉ)
  return strtoul(delcma(tohan(st)), NULL, 10);
}

I8B WINAPI cztoi64(PCSTR st)
{ // 3R}폜ĕINT64ɕϊ(SpΉ)
  return _atoi64(delcma(tohan(st)));
}

U8B WINAPI cztou64(PCSTR st)
{ // 3R}폜ĕUINT64ɕϊ(SpΉ)
  return _strtoui64(delcma(tohan(st)), NULL, 10);
}

REAL WINAPI cztof(PCSTR st)
{ // 3R}폜ĕdoubleɕϊ(SpΉ)
  return atof(delcma(tohan(st)));
}

// ---------------------------------------------------------------------- //

BOOL WINAPI is_leap_year(int yr)
{ // 邤N
  return yr % 4 == 0 && (yr % 100 != 0 || yr % 400 == 0);
}

int  WINAPI days_of_month(int yr, int mo)
{ // ̓
  switch (mo) {
  case 2: return 28 + is_leap_year(yr);
  case 4: case 6: case 9: case 11: return 30;
  default: return 31;
  }
}

int  WINAPI day_of_week(int yr, int mo, int dy)
{ // j
  if (mo < 3) { mo += 12; yr--;}
  return (yr + yr / 4 - yr / 100 + yr / 400 + (13 * mo + 8) / 5 + dy) % 7;
}

int  WINAPI date_serial(int yr, int mo, int dy)
{ // tVAl
  static int nds[12] = {  0, 31, 59, 90,120,151,181,212,243,273,304,334 };

  while (mo < 1)  { mo += 12; yr--;}
  while (mo > 12) { mo -= 12; yr++;}
  return (yr - 1900) * 365 + (yr - 1901) / 4 - (yr - 1901) / 100 + (yr - 1601) / 400 + 1 + nds[mo-1]
       + (mo > 2 && is_leap_year(yr)) + dy;
}

#define  D36525(i)  (int)((i) / 365.25 + 0.0001)

int  WINAPI year(int sr)
{ // tVAl̔N
  if (sr <= 73415)
    return 1900 + D36525(sr - 1);
  else if (sr < 182988)
    return 1900 + D36525(sr + (sr - 73415) / 36524);
  else
    return 1900 + D36525(sr + (sr - 73415) / 36524 - (sr - 36891) / 146097);
}

int  LOCALF ymn(int sr, int yr)
{ // tVAľ
  int i;

  for (i = 1; i < 12; i++) {
    if (sr < date_serial(yr, i+1, 1)) break;
  }
  return i;
}

int  WINAPI month(int sr)
{ // tVAľ
  return ymn(sr, year(sr));
}

int  WINAPI day(int sr)
{ // tVAl̓
  int yr = year(sr); return sr - date_serial(yr, ymn(sr, yr), 0);
}

int  WINAPI youbi(int sr)
{ // tVAl̗j
  return day_of_week(year(sr), month(sr), day(sr));
}

typedef struct {
  PCSTR ge;
  PCSTR gs;
  BYTE  cu;
  BYTE  cl;
  WORD  y0;
  int   sr;
} ERAI;
  // N
static ERAI ERA[] = {
  { "", "", 'M', 'm', 1867,     0 }, // 0 (1900/01/01`)
  { "吳", "", 'T', 't', 1911,  4595 }, // 1 (1912/07/30`)
  { "a", "", 'S', 's', 1925,  9856 }, // 2 (1926/12/25`)
  { "", "", 'H', 'h', 1988, 32516 }, // 3 (1989/01/08`)
  { "ߘa", "", 'R', 'r', 2018, 43586 }, // 4 (2019/05/01`)
};

int  LOCALF era(int sr)
{ // tVAl̔N
  int i;

  for (i = NELEM(ERA) - 1; i > 0; i--) {
    if (sr >= ERA[i].sr) return i;
  }
  return 0;
}

int  WINAPI era_year(int sr)
{ // tVAl̔N̔N
  return year(sr) - ERA[era(sr)].y0;
}

int  WINAPI today(void)
{ // ̓tVAl
  STMI stm;

  get_local_time(&stm);
  return date_serial(stm.yr, stm.mo, stm.dy);
}

int  WINAPI date_diff(int s1, int s2, int sw)
{ // tVAl̍
  int y1, y2, m1, m2, d1, d2;

  if (s1 > s2) return -date_diff(s2, s1, sw);
  y1 = year(s1); m1 = month(s1); d1 = day(s1);
  y2 = year(s2); m2 = month(s2); d2 = day(s2);
  switch (sw) {
  case DD_YEA: return (y2 - y1) - (m1 > m2 || (m1 == m2 && d1 > d2));
  case DD_MON: return (y2 - y1) * 12 + (m2 - m1) - (d1 > d2);
  default:     return s2 - s1;
  }
}

int  WINAPI ztod(PCSTR st)
{ // tVAlɕϊ
  return ztod2(st, 0);
}

int  WINAPI ztod2(PCSTR st, int sr0)
{ // tVAlɕϊ
  int i, ne, yr, mo, dy, y0, m0;
  char bf[512], wk[512];

  st = tohan_b(st, bf);
  while (isspc(*st)) st++;
  if (isdig(*st)) {
    ne = -1;
  } else if (*st != '\0') {
    for (i = NELEM(ERA) - 1; i >= 0; i--) {
      if (*st == ERA[i].cu || *st == ERA[i].cl) { ne = i; st++; break;}
      if (*(PWORD)st == *(PWORD)ERA[i].ge) { ne = i; st += 2; break;}
    }
    if (i < 0) return 0;
    while (*st != '\0' && !isdig(*st)) st++;
    if (*st == '\0') return 0;
  } else return 0;
  i = 0;
  do wk[i++] = *st++; while (isdig(*st));
  wk[i] = '\0';
  yr = atoi(wk);
  while (*st != '\0' && !isdig(*st)) st++;
  if (*st == '\0') { mo = 0; goto _L1;}
  i = 0;
  do wk[i++] = *st++; while (isdig(*st));
  wk[i] = '\0';
  mo = atoi(wk);
  while (*st != '\0' && !isdig(*st)) st++;
  if (*st == '\0') { dy = 0; goto _L1;}
  i = 0;
  do wk[i++] = *st++; while (isdig(*st));
  wk[i] = '\0';
  dy = atoi(wk);
 _L1:
  if (sr0 != 0) {
    y0 = year(sr0); m0 = month(sr0);
    if (mo == 0) {
      dy = yr; mo = m0; yr = y0;
    } else if (dy == 0) {
      dy = mo; mo = yr; yr = y0;
      if      (mo > m0 + 5) yr--;
      else if (mo < m0 - 5) yr++;
    }
  } else {
    if (mo == 0) mo = dy = 1;
    else if (dy == 0) dy = 1;
  }
  if (ne == -1) {
    if (yr < 65) yr += 2000;  else if (yr < 100) yr += 1900;
  } else {
    yr += ERA[ne].y0;
  }
  if (yr < 1901 || yr > 9999 || mo < 1 || mo > 12 || dy < 1 || dy > days_of_month(yr, mo)) return 0;
  return date_serial(yr, mo, dy);
}

int  WINAPI ztom(PCSTR st)
{ // tVAl(N)ɕϊ
  int sr;

  return (!!(sr = ztod(st)))? date_serial(year(sr), month(sr), 1): 0;
}

int  WINAPI dprintf(PSTR st, PCSTR fmt, int sr)
{ // tVAlĕɕϊ
  int yr, mo, ne;
  PSTR pt;
  PCSTR pc;

  if (sr == 0) { st[0] = '\0'; return 0;}
  yr = year(sr);
  mo = ymn(sr, yr);
  ne = era(sr);
  pt = st;
  pc = fmt;
  while (*pc != '\0') {
    if (*pc == 'y') { pc++;
      if (*pc == 'y') { pc++;
        if (*pc == 'y') { pc++;
          if (*pc == 'y') { pc++; _LY:
            pt += sprintf(pt, "%4d", yr); // yyyy
          } else goto _LY; // yyy
        } else {
          pt += sprintf(pt, "%02d", yr%100); // yy
        }
      } else goto _LY; // y
    } else if (*pc == 'g') { pc++;
      if (*pc == 'g') { pc++;
        if (*pc == 'g') { pc++;
          pt += sprintf(pt, "%s", ERA[ne].ge);  // ggg
        } else {
          pt += sprintf(pt, "%s", ERA[ne].gs);  // gg
        }
      } else {
        pt += sprintf(pt, "%c", ERA[ne].cu); // g
      }
    } else if (*pc == 'e') { pc++;
      if (*pc == 'e') { pc++;
        pt += sprintf(pt, "%02d", yr - ERA[ne].y0); // ee
      } else {
        pt += sprintf(pt, "%d", yr - ERA[ne].y0);   // e
      }
    } else if (*pc == 'm') { pc++;
      if (*pc == 'm') { pc++;
        pt += sprintf(pt, "%02d", mo); // mm
      } else {
        pt += sprintf(pt, "%d", mo);   // m
      }
    } else if (*pc == 'd') { pc++;
      if (*pc == 'd') { pc++;
        pt += sprintf(pt, "%02d", sr - date_serial(yr, mo, 0)); // dd
      } else {
        pt += sprintf(pt, "%d", sr - date_serial(yr, mo, 0));   // d
      }
    } else {
      if (iszen(pc)) *((PWORD)pt)++ = *((PWORD)pc)++;  else *pt++ = *pc++;
    }
  }
  *pt = '\0';
  return pt - st;
}

PCSTR WINAPI dformat(PCSTR fmt, int sr)
{ // tVAlĕɕϊ
  char bf[512];

  dprintf(bf, fmt, sr); return strcpy(talloc(strlen(bf) + 1), bf);
}

int  WINAPI time_serial(int hr, int mn, int sc)
{ // (b)
  return hr * 3600 + mn * 60 + sc;
}

int  WINAPI hour(int tm)
{ // 
  return tm / 3600;
}

int  WINAPI minute(int tm)
{ // 
  return abs((tm % 3600) / 60);
}

int  WINAPI second(int tm)
{ // b
  return abs(tm % 60);
}

int  WINAPI ztot(PCSTR st)
{ // (b)ɕϊ
  int i, hr, mn, sc, n1, n2;
  char bf[512], wk[512];

  st = tohan_b(st, bf);
  while (isspc(*st)) st++;
  if (!isdig(*st)) return 0;
  i = 0;
  do wk[i++] = *st++; while (isdig(*st));
  wk[i] = '\0'; n1 = i;
  hr = atoi(wk);
  while (*st != '\0' && !isdig(*st)) st++;
  if (*st == '\0') { n2 = 0; goto _L1;}
  i = 0;
  do wk[i++] = *st++; while (isdig(*st));
  wk[i] = '\0'; n2 = i;
  mn = atoi(wk);
  while (*st != '\0' && !isdig(*st)) st++;
  if (*st == '\0') { sc = 0; goto _L2;}
  i = 0;
  do wk[i++] = *st++; while (isdig(*st));
  wk[i] = '\0';
  sc = atoi(wk);
  if (n2 == 0) { _L1:
    if (n1 >= 5) {
      sc = hr % 100; mn = hr % 10000; hr = hr / 10000;
    } else if (n1 >= 3) {
      sc = 0; mn = hr % 100; hr = hr / 100;
    } else {
      sc = 0; mn = hr; hr = 0;
    }
  }
 _L2:
  if (mn < 0 || mn > 59 || sc < 0 || sc > 59) return 0;
  return time_serial(hr, mn, sc);
}

int  WINAPI tprintf(PSTR st, PCSTR fmt, int tm)
{ // (b)ĕɕϊ
  int hr, mn, sc;
  PSTR pt;
  PCSTR pc;

  hr = hour(tm);
  mn = minute(tm);
  sc = second(tm);
  pt = st;
  pc = fmt;
  while (*pc != '\0') {
    if (*pc == 'h') { pc++;
      if (*pc == 'h') { pc++;
        pt += sprintf(pt, "%02d", hr); // hh
      } else {
        pt += sprintf(pt, "%d", hr);   // h
      }
    } else if (*pc == 'm') { pc++;
      if (*pc == 'm') { pc++;
        pt += sprintf(pt, "%02d", mn); // mm
      } else {
        pt += sprintf(pt, "%d", mn);   // m
      }
    } else if (*pc == 's') { pc++;
      if (*pc == 's') { pc++;
        pt += sprintf(pt, "%02d", sc); // ss
      } else {
        pt += sprintf(pt, "%d", sc);   // s
      }
    } else {
      if (iszen(pc)) *((PWORD)pt)++ = *((PWORD)pc)++;  else *pt++ = *pc++;
    }
  }
  *pt = '\0';
  return pt - st;
}

PCSTR WINAPI tformat(PCSTR fmt, int tm)
{ // (b)ĕɕϊ
  char bf[512];

  tprintf(bf, fmt, tm); return strcpy(talloc(strlen(bf) + 1), bf);
}

REAL WINAPI now(void)
{ // ݂̓t
  STMI stm;

  get_local_time(&stm);
  return (REAL)date_serial(stm.yr, stm.mo, stm.dy)
      + ((REAL)time_serial(stm.hr, stm.mn, stm.sc) / 86400.0);
}

REAL WINAPI ztodt(PCSTR st)
{ // tɕϊ
  int sr, tm;
  PSTR pt;

  while (isspc(*st)) st++;
  sr = ztod(st);
  if (!!(pt = strchr(st, ' '))) {
    tm = ztot(pt);
  } else {
    tm = 0;
  }
  return (REAL)sr + ((REAL)tm / 86400.0);
}

int  WINAPI dtprintf(PSTR st, PCSTR fmt, REAL dt)
{ // tĕɕϊ
  PSTR pt;
  char fm1[512], fm2[512];

  if (!!(pt = strchr(fmt, ' '))) {
    spncpy(fm1, fmt, pt);
    strcpy(fm2, pt + 1);
  } else {
    strcpy(fm1, fmt);
    fm2[0] = '\0';
  }
  pt = st;
  pt += dprintf(pt, fm1, (int)dt);
  pt += sprintf(pt, " ");
  pt += tprintf(pt, fm2, (int)((dt - (int)dt) * 86400.0));
  return pt - st;
}

PCSTR WINAPI dtformat(PCSTR fmt, REAL dt)
{ // tĕɕϊ
  char bf[512];

  dtprintf(bf, fmt, dt); return strcpy(talloc(strlen(bf) + 1), bf);
}

void WINAPI get_system_time(PSTMI lp)
{ // VXe̎擾
  GetSystemTime((LPSYSTEMTIME)lp);
}

void WINAPI get_local_time(PSTMI lp)
{ // ݓ̎擾
  GetLocalTime((LPSYSTEMTIME)lp);
}

UINT WINAPI get_tick_count(void)
{ // oߎԂ̎擾
  return GetTickCount();
}

void WINAPI wait_millisec(UINT ms)
{ // ms~b҂
  Sleep(ms);
}

int  WINAPI compare_file_time(PCFTMI ft1, PCFTMI ft2)
{ // t@C̔r
  return CompareFileTime((const FILETIME *)ft1, (const FILETIME *)ft2);
}

BOOL WINAPI file_time_to_system_time(PSTMI lp, PCFTMI ft)
{ // t@CVXeɕϊ
  return FileTimeToSystemTime((const FILETIME *)ft, (LPSYSTEMTIME)lp);
}

BOOL WINAPI system_time_to_file_time(PFTMI ft, PCSTMI lp)
{ // VXet@Cɕϊ
  return SystemTimeToFileTime((const SYSTEMTIME *)lp, (LPFILETIME)ft);
}

// ---------------------------------------------------------------------- //

#define  PS_DRV  0x10
#define  PS_DIR  0x08
#define  PS_NAM  0x04
#define  PS_EXT  0x02
#define  PS_WLD  0x01

int  LOCALF pnsplit(PCSTR pn, PSTR dr, PSTR di, PSTR nm, PSTR ex)
{ // pX̕
  int flg;
  PCSTR p1, p2, p3, p4;

  if (!pn) return 0;
  flg = 0;
  p4 = pn + strlen(pn);
  if (pn[0] != '\0' && pn[1] == ':') {
    flg |= PS_DRV;
    p1 = pn + 2;
  } else {
    p1 = pn;
  }
  if (!!(p2 = mbsrchr(p1, '\\'))) {
    flg |= PS_DIR;
    p2++;
  } else {
    p2 = p1;
  }
  if (!!(p3 = mbsrchr(p2, '.'))) {
    flg |= PS_EXT;
  } else {
    p3 = p4;
  }
  if (p2 < p3) {
    flg |= PS_NAM;
  }
  if (strchr(p2, '*') || strchr(p2, '?')) {
    flg |= PS_WLD;
  }
  if (dr) spncpy(dr, pn, p1);
  if (di) spncpy(di, p1, p2);
  if (nm) spncpy(nm, p2, p3);
  if (ex) spncpy(ex, p3, p4);
  return flg;
}

void LOCALF pnmerge(PSTR pn, PCSTR dr, PCSTR di, PCSTR nm, PCSTR ex)
{ // pX̕
  int i;

  if (!pn) return;
  i = 0;
  if (dr && *dr != '\0') {
    pn[i++] = *dr; pn[i++] = ':';
  }
  if (di && *di != '\0') {
    while (*di != '\0') pn[i++] = *di++;
    if (!nthyen(pn, i-1)) pn[i++] = '\\';
  }
  if (nm && *nm != '\0') {
    while (*nm != '\0') pn[i++] = *nm++;
  }
  if (ex && *ex != '\0') {
    if (*ex != '.') pn[i++] = '.';
    while (*ex != '\0') pn[i++] = *ex++;
  }
  pn[i] = '\0';
}

int  WINAPI check_path(PCSTR nam)
{ // t@Cvf̌
  int flg;

  flg = pnsplit(nam, NULL, NULL, NULL, NULL);
  return (!!(flg & (PS_DRV|PS_DIR))) * CHP_DIR + (!!(flg & PS_NAM)) * CHP_NAM + (!!(flg & PS_EXT)) * CHP_EXT;
}

PSTR WINAPI change_path(PSTR nam, PCSTR src, int flg)
{ // t@Cvf̕ύX
  char dr[4], di[512], nm[256], ex[256];

  if (flg & CHP_DIR) {
    pnsplit(nam, NULL, NULL, nm, ex);
    if (src) {
      pnsplit(src, dr, di, NULL, NULL);
      pnmerge(nam, dr, di, nm, ex);
    } else pnmerge(nam, NULL, NULL, nm, ex);
  }
  if (flg & CHP_NAM) {
    pnsplit(nam, dr, di, NULL, ex);
    if (src) {
      pnsplit(src, NULL, NULL, nm, NULL);
      pnmerge(nam, dr, di, nm, ex);
    } else pnmerge(nam, dr, di, NULL, NULL);
  }
  if (flg & CHP_EXT) {
    pnsplit(nam, dr, di, nm, NULL);
    if (src) {
      pnsplit(src, NULL, NULL, NULL, ex);
      pnmerge(nam, dr, di, nm, ex);
    } else pnmerge(nam, dr, di, nm, NULL);
  }
  return nam;
}

HANDLE WINAPI open_file(PCSTR nam, UINT flg)
{ // t@CJ
  HANDLE hf;

  hf = CreateFile(nam, flg & 0xf0000000, 0, NULL, flg & 0x0f, 0, NULL);
  return (hf == INVALID_HANDLE_VALUE)? NULL: hf;
}

BOOL WINAPI close_file(HANDLE hf)
{ // t@C
  return CloseHandle(hf);
}

UINT WINAPI set_file_ptr(HANDLE hf, int ds, UINT md)
{ // t@C|C^ړ
  return SetFilePointer(hf, ds, NULL, md);
}

BOOL WINAPI set_end_of_file(HANDLE hf)
{ // ݈ʒut@C̏Iɂ
  return SetEndOfFile(hf);
}

UINT WINAPI get_file_size(HANDLE hf)
{ // t@CTCY
  return GetFileSize(hf, NULL);
}

BOOL WINAPI read_file(HANDLE hf, PVOID bf, UINT sz)
{ // t@CǍ
  UINT cb; return ReadFile(hf, bf, sz, &cb, NULL) && (cb == sz);
}

BOOL WINAPI write_file(HANDLE hf, PCVOID bf, UINT sz)
{ // t@Co
  UINT cb; return WriteFile(hf, bf, sz, &cb, NULL) && (cb == sz);
}

BOOL WINAPI read_line(HANDLE hf, PSTR bf, int sz)
{ // eLXgs̓Ǎ
  int i, re = FALSE;
  char c;

  for (i = 0; read_file(hf, &c, 1); i++) {
    if (c == '\r') {
      if (read_file(hf, &c, 1)) {
        if (c != '\n') set_file_ptr(hf, -1, FILE_CURRENT);
      }
      re = TRUE; break;
    } else if (c == '\n') {
      re = TRUE; break;
    } else if (i + 1 >= sz) {
      break;
    }
    bf[i] = c;
  }
  bf[i] = '\0';
  return re;
}

BOOL WINAPI write_line(HANDLE hf, PCSTR bf)
{ // eLXgs̏o
  if (!write_file(hf, bf, strlen(bf))) return FALSE;
  if (!write_file(hf, "\r\n", 2)) return FALSE;
  return TRUE;
}

HANDLE WINAPI find_first_file(PCSTR nam, PFFDI lp)
{ // t@Č
  HANDLE hf;

  hf = FindFirstFile(nam, (LPWIN32_FIND_DATA)lp);
  return (hf == INVALID_HANDLE_VALUE)? NULL: hf;
}

BOOL WINAPI find_next_file(HANDLE hf, PFFDI lp)
{ // t@Č
  return FindNextFile(hf, (LPWIN32_FIND_DATA)lp);
}

BOOL WINAPI find_close(HANDLE hf)
{ // nh
  return FindClose(hf);
}

PCSTR LOCALF puncdir(PCSTR nam)
{ // fBNǧ\t
  int n;
  PSTR bf;

  bf = strcpy(talloc((n = strlen(nam)) + 2), nam);
  if (n > 0 && !nthyen(bf, n-1)) {
    bf[n] = '\\'; bf[n+1] = '\0';
  }
  return bf;
}

PCSTR LOCALF trimdir(PCSTR nam)
{ // fBNǧ\폜
  int n;
  PSTR bf;

  bf = strcpy(talloc((n = strlen(nam)) + 1), nam);
  if (n > 0 && nthyen(bf, n-1)) {
    bf[n-1] = '\0';
  }
  return bf;
}

BOOL WINAPI path_exists(PCSTR dir)
{ // fBNg݂
  HANDLE hf;
  FFDI ffd;

  hf = find_first_file(trimdir(dir), &ffd); if (!hf) return FALSE;
  find_close(hf);
  return !!(ffd.atr & FILE_ATTRIBUTE_DIRECTORY);
}

BOOL WINAPI file_exists(PCSTR nam)
{ // t@C݂
  HANDLE hf;
  FFDI ffd;

  hf = find_first_file(nam, &ffd); if (!hf) return FALSE;
  find_close(hf);
  return (ffd.atr & FILE_ATTRIBUTE_DIRECTORY) == 0;
}

BOOL WINAPI get_file_info(PCSTR nam, PFADI lp)
{ // t@C̎擾
  return GetFileAttributesEx(nam, GetFileExInfoStandard, (LPWIN32_FILE_ATTRIBUTE_DATA)lp);
}

UINT WINAPI file_size(PCSTR nam)
{ // t@CTCY
  FADI fad;

  return get_file_info(nam, &fad)? fad.szl: 0;
}

BOOL WINAPI new_file(PCSTR nam)
{ // ̃t@C쐬
  HANDLE hf;

  hf = open_file(nam, OP_WRI); if (!hf) return FALSE;
  return close_file(hf);
}

BOOL WINAPI new_file_if_not_exists(PCSTR nam)
{ // t@C݂ȂƂ̃t@C쐬
  return file_exists(nam)? TRUE: new_file(nam);
}

BOOL WINAPI move_file(PCSTR nam, PCSTR src)
{ // t@C̕tւ
  if (!file_exists(src) && file_exists(nam)) return FALSE;
  return MoveFile(src, nam);
}

BOOL WINAPI force_move_file(PCSTR nam, PCSTR src)
{ // t@C̈ړ
  if (!file_exists(src) && !strcmp(nam, src)) return FALSE;
  if (file_exists(nam)) DeleteFile(nam);
  return MoveFile(src, nam);
}

BOOL WINAPI copy_file(PCSTR nam, PCSTR src)
{ // t@C̃Rs[
  return CopyFile(src, nam, FALSE);
}

BOOL WINAPI delete_file(PCSTR nam)
{ // t@C̍폜
  return DeleteFile(nam);
}

BOOL WINAPI new_path(PCSTR dir)
{ // fBNg̍쐬
  return CreateDirectory(trimdir(dir), NULL);
}

BOOL WINAPI new_path_if_not_exists(PCSTR dir)
{ // fBNg݂ȂƂ쐬
  return path_exists(dir)? TRUE: new_path(dir);
}

BOOL WINAPI move_file_to(PCSTR dir, PCSTR src)
{ // t@CwfBNgɈړ
  char nam[768];

  if (strlen(src) > 511) return (BOOL)ierr(E_CAP);
  if (!file_exists(src)) return FALSE;
  change_path(strcpy(nam, src), puncdir(dir), CHP_DIR);
  return force_move_file(nam, src);
}

BOOL WINAPI copy_file_to(PCSTR dir, PCSTR src)
{ // t@CwfBNgɃRs[
  char nam[768];

  if (strlen(src) > 511) return (BOOL)ierr(E_CAP);
  if (!file_exists(src)) return FALSE;
  change_path(strcpy(nam, src), puncdir(dir), CHP_DIR);
  return copy_file(nam, src);
}

void WINAPI get_working_path(PSTR dir, int sz)
{ // JgfBNg̎擾
  dir[0] = '\0'; GetCurrentDirectory(sz - 1, dir); strcpy(dir, puncdir(dir));
}

BOOL WINAPI set_working_path(PCSTR dir)
{ // JgfBNg̐ݒ
  return SetCurrentDirectory(dir);
}

void WINAPI get_user_name(PSTR nam, int sz)
{ // [U[̎擾
  nam[0] = '\0'; GetUserName(nam, &sz);
}

void WINAPI get_computer_name(PSTR nam, int sz)
{ // Rs[^̎擾
  nam[0] = '\0'; GetComputerName(nam, &sz);
}

// ---------------------------------------------------------------------- //

PCSTR WINAPI enmstr(PCENMS ls, int va)
{ // R[hԍ𕶎ɕϊ
  return (va >= 0 && va < ls->ni)? ls->ps[va]: "";
}

int  WINAPI srchenm(PCENMS ls, PCSTR st)
{ // R[hԍɕϊ
  int i;

  for (i = 0; i < ls->ni; i++) {
    if (!strcmp(ls->ps[i], st)) return i;
  }
  i = ztoi(st);
  return (i >= 0 && i < ls->ni)? i: 0;
}

PCSTR WINAPI codstr(PCCODS ls, int va)
{ // R[hԍ𕶎ɕϊ
  PCCODI pc, pe;

  for (pc = ls->pv, pe = pc + ls->ni; pc < pe; pc++) {
    if (pc->va == va) return pc->st;
  }
  return "";
}

int  WINAPI srchcod(PCCODS ls, PCSTR st)
{ // R[hԍɕϊ
  int va;
  PCCODI pc, pe;

  for (pc = ls->pv, pe = pc + ls->ni; pc < pe; pc++) {
    if (!strcmp(pc->st, st)) return pc->va;
  }
  va = ztoi(st); if (va == 0) return 0;
  for (pc = ls->pv, pe = pc + ls->ni; pc < pe; pc++) {
    if (pc->va == va) return va;
  }
  return 0;
}

int  WINAPI srchopr(PCCODS ls, PCSTR st)
{ // ZqA؎q̃T[`
  int f, n, m;
  PCCODI pc, pe;

  f = -1; m = 0;
  for (pc = ls->pv, pe = pc + ls->ni; pc < pe; pc++) {
    n = strlen(pc->st);
    if (!strncmp(pc->st, st, n) && n > m) {
      m = n;
      f = pc->va;
    }
  }
  return f;
}

// ---------------------------------------------------------------------- //

  // G[bZ[W
static CODI eeBAS[256] = {
  { E_MEM, "AP[gG[" },
  { E_DAT, "sȃf[^" },
  { E_PAR, "sȃp[^" },
  { E_FIR, "t@CǍG[" },
  { E_FIW, "t@CoG[" },
  { E_DIR, "tH_쐬łȂ" },
  { E_ALO, "f[^i[悪mۂĂȂ" },
  { E_CAP, "f[^i[̗eʐ𒴂" },
  { E_DLL, "CȕɎs" },
  { E_STK, "X^bNI[o[t[" },
  { E_SEG, "ZOe[Vᔽ" },
  { E_OPC, "sȃIyR[h" },
  { E_DIV, "[ZG[" },
  { E_NUL, "k|C^Q" },
  { E_ORD, "sȊ֐|C^" },
  { E_EXE, "sȃoCgR[hsG[" },
  { E_BCD, "oCgR[ht@Cs" },
  { E_VER, "oCgR[ht@Cs(݊̂Ȃo[W)" },
  { E_PRO, "oCgR[ht@Cs(قȂvV[W)" },
  { E_NOA, "oCgR[h[hĂȂ" },
};
static CODS emBAS = { eeBAS, NELEM(eeBAS) };

BOOL WINAPI register_error_descriptions(PCCODS ed)
{ // G[bZ[Wo^
  PCCODI pc, pe;

  for (pc = emBAS.pv, pe = pc + emBAS.ni; pc < pe && pc->va != 0; pc++) ;
  if (pe - pc < ed->ni) return FALSE;
  memcpy((PVOID)pc, ed->pv, ed->ni * sizeof(CODI));
  return TRUE;
}

PCSTR WINAPI error_description(int ec)
{ // G[bZ[W
  PCCODI pc, pe;

  for (pc = emBAS.pv, pe = pc + emBAS.ni; pc < pe && pc->va != 0; pc++) {
    if (pc->va == ec) return pc->st;
  }
  return "";
}

  // G[
static HWND hERR = NULL;
static int  iBAS = 1;
static BOOL EMSG = TRUE;
static BOOL ELOG = FALSE;
static int  EFST = 0;
static int  ELST = 0;
static char ELFN[512] = "ERRLOG.LOG";
  // G[nh
static FERR errmsg = default_error_reporting;
static FERR errlog = default_error_logging;

HWND WINAPI set_error_message_box_owner(HWND hwnd)
{ // G[bZ[W{bNX̃I[i[EBhEݒ
  HWND bk = hERR; hERR = hwnd; return bk;
}

HWND WINAPI error_message_box_owner(void)
{ // G[bZ[W{bNX̃I[i[EBhE
  return hERR;
}

int  WINAPI set_error_message_index_base(int i)
{ // CfbNXx[X̐ݒ
  int bk = iBAS; iBAS = i; return bk;
}

int  WINAPI error_message_index_base(void)
{ // CfbNXx[X
  return iBAS;
}

void WINAPI set_error_log_file(PCSTR nam)
{ // G[Ot@Cݒ
  if (nam && strlen(nam) < sizeof(ELFN)) strcpy(ELFN, nam);
}

PCSTR WINAPI error_log_file(void)
{ // G[Ot@C
  return ELFN;
}

int  WINAPI first_error(void)
{ // ŏ̃G[
  return EFST;
}

int  WINAPI last_error(void)
{ // Ō̃G[
  return ELST;
}

void WINAPI reset_error(void)
{ // G[̃NA
  EMSG = TRUE;
  EFST = ELST = 0;
}

BOOL WINAPI enable_error_reporting(void)
{ // G[\
  int bk = EMSG; EMSG = TRUE; return bk;
}

BOOL WINAPI disable_error_reporting(void)
{ // G[\}~
  int bk = EMSG; EMSG = FALSE; return bk;
}

BOOL WINAPI enable_error_logging(void)
{ // G[Ocݒ
  int bk = ELOG; ELOG = TRUE; return bk;
}

BOOL WINAPI disable_error_logging(void)
{ // G[OcȂݒ
  int bk = ELOG; ELOG = FALSE; return bk;
}

PVOID WINAPI throw_error(PCSTR em, UINT er, PCSTR fn, UINT lo)
{ // G[
  if (EMSG) EMSG = errmsg(em, er, fn, lo);
  if (ELOG) errlog(em, er, fn, lo);
  if (EFST == 0) EFST = LOWORD(er);
  ELST = LOWORD(er);
  return NULL;
}

PSTR WINAPI error_reporting_message(PSTR msg, PCSTR em, UINT er, PCSTR fn, UINT lo)
{ // G[bZ[W
  PSTR pt, st;

  pt = msg;
  if (em) {
    pt += sprintf(pt, "G[R[h: %d   (%s  %d)   ", LOWORD(er), em, HIWORD(er));
  } else {
    pt += sprintf(pt, "G[R[h: %d              ", LOWORD(er));
  }
  pt += sprintf(pt, "\n%s   ", error_description(LOWORD(er)));
  if (fn) {
    if (!!(st = mbsrchr(fn, '\\'))) fn = st + 1;
    pt += sprintf(pt, "\nt@C: %s   ", fn);
  }
  if (LOWORD(lo) != (WORD)-1) pt += sprintf(pt, "\ns: %d   ", LOWORD(lo) + iBAS);
  if (HIWORD(lo) != (WORD)-1) pt += sprintf(pt, "\n: %d   ", HIWORD(lo) + iBAS);
  return msg;
}

PSTR WINAPI error_logging_message(PSTR msg, PCSTR em, UINT er, PCSTR fn, UINT lo)
{ // G[O
  PSTR pt, st;

  pt = msg;
  pt += dtprintf(pt, "yyyy/mm/dd hh:mm:ss", now());
  if (em) {
    pt += sprintf(pt, " Error:%d (%s %d)", LOWORD(er), em, HIWORD(er));
  } else {
    pt += sprintf(pt, " Error:%d", LOWORD(er));
  }
  if (fn) {
    if (!!(st = mbsrchr(fn, '\\'))) fn = st + 1;
    pt += sprintf(pt, " File"":%s", basnam(fn));
  }
  if (LOWORD(lo) != (WORD)-1) pt += sprintf(pt, " Row:%d",    LOWORD(lo));
  if (HIWORD(lo) != (WORD)-1) pt += sprintf(pt, " Column:%d", HIWORD(lo));
  return msg;
}

BOOL WINAPI default_error_reporting(PCSTR em, UINT er, PCSTR fn, UINT lo)
{ // G[bZ[W\
  char msg[512];

  return MessageBox(hERR, error_reporting_message(msg, em, er, fn, lo), NULL, MB_ICONERROR|MB_OKCANCEL) == IDOK;
}

BOOL WINAPI default_error_logging(PCSTR em, UINT er, PCSTR fn, UINT lo)
{ // G[Oo
  HANDLE hf;
  char msg[512];

  hf = open_file(ELFN, OP_APD); if (!hf) return FALSE;
  set_file_ptr(hf, 0, FILE_END);
  write_line(hf, error_logging_message(msg, em, er, fn, lo));
  close_file(hf);
  return TRUE;
}

void WINAPI override_error_handler(FERR fmsg, FERR flog)
{ // G[nh̓o^
  errmsg = fmsg? fmsg: default_error_reporting;
  errlog = flog? flog: default_error_logging;
}

void WINAPI start_debug(BOOL rm)
{ // fobOJn
  if (rm) delete_file(ELFN);
  EMSG = ELOG = TRUE;
}

void WINAPI stop_debug(void)
{ // fobOI
  EMSG = ELOG = FALSE;
}

void WINAPI debug_reporting(PCSTR st)
{ // fobOp
  if (EMSG) MessageBox(NULL, st, NULL, MB_OK);
}

void WINAPI debug_logging(PCSTR st)
{ // fobOp
  HANDLE hf;

  if (ELOG) {
    hf = open_file(ELFN, OP_APD); if (!hf) return;
    set_file_ptr(hf, 0, FILE_END);
    write_line(hf, st); // write_file(hf, st, strlen(st));
    close_file(hf);
  }
}

// ---------------------------------------------------------------------- //

int  LOCALF roundup(int cap, int sz)
{ // ővf̐؂グ
  int n;

  for (n = 32; n < 65536; n *= 2) {
    if (cap < n) return n;  else if (n * sz >= 65536) break;
  }
  return nbound(cap, n);
}

HBLK WINAPI build_array(HBLK mb, PVOID pv, int len, int cap, int rsz)
{ // ubN\
  mb->ptr = pv;
  mb->len = len;
  mb->cap = cap;
  mb->rsz = rsz;
  return mb;
}

HBLK WINAPI build_slice(HBLK mb, HBLK mx, int ir, int nr)
{ // ͈
  mb->ptr = iptr(mx, ir);
  mb->len = nr;
  mb->cap = nr;
  mb->rsz = mx->rsz;
  return mb;
}

HBLK WINAPI set_array(HBLK mb, PVOID pv, int len)
{ // z̐ݒ
  mb->ptr = pv;
  mb->len = len;
  return mb;
}

HBLK WINAPI create_array(HBLK mb, PVOID pv, int len, int cap, int rsz)
{ // z̍쐬
  if (!mb) {
    mb = halloc(sizeof(HBLK_), FALSE); if (!mb) return ierr(E_MEM);
  }
  if (!pv) {
    cap = roundup(cap, rsz);
    pv = halloc(cap * rsz, FALSE); if (!pv) { hfree(mb); return ierr(E_MEM);}
  }
  return build_array(mb, pv, len, cap, rsz);
}

void WINAPI delete_array(HBLK mb)
{ // z̍폜
  if (!mb) return;
  hfree(mb->ptr);
  hfree(mb);
}

PVOID WINAPI iptr(HBLK mb, int ir)
{ // vf̃AhX
  return (PBYTE)mb->ptr + ir * mb->rsz;
}

BOOL WINAPI change_capacity(HBLK mb, int cap)
{ // ővf̕ύX
  PVOID pv;

  if (!isheap(mb->ptr)) return (BOOL)ierr(E_CAP);
  pv = hrealloc(mb->ptr, cap * mb->rsz); if (!pv) return (BOOL)ierr(E_MEM);
  mb->ptr = pv;
  mb->cap = cap;
  return TRUE;
}

BOOL LOCALF insert_items(HBLK mb, int ir, PCVOID pb, int nr)
{ // ͈͂̑}
  if (nr <= 0) return FALSE;
  if (mb->len + nr > mb->cap) {
    if (!change_capacity(mb, roundup(mb->cap + nr, mb->rsz))) return FALSE;
  }
  if (ir < mb->len) {
    memmove(iptr(mb, ir + nr), iptr(mb, ir), (mb->len - ir) * mb->rsz);
  }
  if (!pb) {
    memset(iptr(mb, ir), 0, nr * mb->rsz);
  } else {
    memcpy(iptr(mb, ir), pb, nr * mb->rsz);
  }
  mb->len += nr;
  return TRUE;
}

BOOL LOCALF delete_items(HBLK mb, int ir, int nr)
{ // ͈͂̍폜
  if (nr <= 0 || mb->len <= 0) return FALSE;
  if (ir + nr < mb->len) {
    memmove(iptr(mb, ir), iptr(mb, ir + nr), (mb->len - ir - nr) * mb->rsz);
  }
  mb->len -= nr;
  return TRUE;
}

BOOL WINAPI add_item(HBLK mb, PCVOID pi)
{ // vf̒ǉ
  return insert_items(mb, mb->len, pi, 1);
}

PVOID WINAPI new_item(HBLK mb, PCVOID pi)
{ // ǉvf
  return add_item(mb, pi)? iptr(mb, mb->len - 1): valloc(mb->rsz);
}

BOOL LOCALF append_items(HBLK mb, PCVOID pb, int nr)
{ // vf̒ǉ
  return insert_items(mb, mb->len, pb, nr);
}

int  LOCALF search_item(HBLK mb, PCVOID pi)
{ // vf̃T[`(t)
  int i;

  for (i = mb->len - 1; i >= 0; i--) {
    if (!memcmp(iptr(mb, i), pi, mb->rsz)) return i;
  }
  return -1;
}

BOOL WINAPI remove_item(HBLK mb, PCVOID pi)
{ // vf̍폜
  int ir;

  ir = search_item(mb, pi); if (ir < 0) return FALSE;
  return delete_items(mb, ir, 1);
}

void LOCALF rotate_items_left(HBLK mb)
{ // ]
  PVOID wk = ualloc(mb->rsz);

  if (mb->len <= 1) return;
  memcpy(wk, mb->ptr, mb->rsz);
  memmove(mb->ptr, iptr(mb, 1), (mb->len - 1) * mb->rsz);
  memcpy(iptr(mb, mb->len - 1), wk, mb->rsz);
}

void LOCALF rotate_items_right(HBLK mb)
{ // E]
  PVOID wk = ualloc(mb->rsz);

  if (mb->len <= 1) return;
  memcpy(wk, iptr(mb, mb->len - 1), mb->rsz);
  memmove(iptr(mb, 1), mb->ptr, (mb->len - 1) * mb->rsz);
  memcpy(mb->ptr, wk, mb->rsz);
}

void LOCALF reverse_items(HBLK mb)
{ // tבւ
  int i;
  PVOID wk = ualloc(mb->rsz);

  for (i = 0; i < mb->len / 2; i++) {
    memcpy(wk, iptr(mb, i), mb->rsz);
    memcpy(iptr(mb, i), iptr(mb, mb->len - 1 - i), mb->rsz);
    memcpy(iptr(mb, mb->len - 1 - i), wk, mb->rsz);
  }
}

HBLK WINAPI CreateMemBlk(int cap, int rsz)
{ // ÓIz̍쐬
  HBLK mb;

  if (rsz < 1 || rsz > 65536) return ierr(E_PAR);
  mb = halloc(sizeof(HBLK_) + cap * rsz, FALSE); if (!mb) return ierr(E_MEM);
  return build_array(mb, (PBYTE)mb + sizeof(HBLK_), 0, cap, rsz);
}

void WINAPI DeleteMemBlk(HBLK mb)
{ // ÓIz̍폜
  delete_array(mb);
}

HBLK WINAPI MakeMemBlk(PVOID pv, int cap, int rsz)
{ // ÓIz̈̐ݒ
  if (rsz < 1 || rsz > 65536) { ierr(E_PAR); return pv;}
  return build_array(pv, (PBYTE)pv + sizeof(HBLK_), 0, cap, rsz);
}

  // ݂̃oCgi[
static HBLK BB;

HBLK WINAPI SelectBinBlk(HBLK bb)
{ // oCgi[̑I
  HBLK bk = BB; BB = bb; return bk;
}

PCVOID WINAPI stobin(PCVOID pv, int sz)
{ // oCg̊i[
  PVOID pr;

  if (!BB) return ierr(E_ALO);
  pr = iptr(BB, BB->len);
  append_items(BB, pv, sz);
  return pr;
}

  // ݂̕i[
static HBLK SB;

HBLK WINAPI SelectStrBlk(HBLK sb)
{ // i[̑I
  HBLK bk = SB; SB = sb; return bk;
}

PCSTR WINAPI stostr(PCSTR st)
{ // ̊i[
  PSTR pt, pe;

  if (!SB) return ierr(E_ALO);
  for (pt = SB->ptr, pe = pt + SB->len; pt < pe; pt += (strlen(pt) + 1)) {
    if (!strcmp(pt, st)) return pt;
  }
  append_items(SB, st, strlen(st) + 1);
  return pt;
}

PCSTR WINAPI stoconc(PCSTR s1, PCSTR s2)
{ // ̘A
  return stostr(strconc(s1, s2));
}

PCSTR WINAPI dirnam(PCSTR nam)
{ // fBNg̒o
  return stostr(change_path(strcpy(talloc(strlen(nam) + 1), nam), NULL, CHP_NAM|CHP_EXT));
}

PCSTR WINAPI basnam(PCSTR nam)
{ // fBNgO
  return stostr(change_path(strcpy(talloc(strlen(nam) + 1), nam), NULL, CHP_DIR));
}

PCSTR WINAPI basnamx(PCSTR nam)
{ // fBNgƊgqO
  return stostr(change_path(strcpy(talloc(strlen(nam) + 1), nam), NULL, CHP_DIR|CHP_EXT));
}

PCSTR WINAPI adddir(PCSTR dir, PCSTR nam)
{ // fBNg̒ǉ
  return stoconc(puncdir(dir), nam);
}

PCSTR WINAPI addext(PCSTR nam, PCSTR ext)
{ // gq̒ǉ
  int sw = 1;
  PCSTR st;

  for (st = ext; *st != '\0'; st++) {
    if (*st != '.' && !isupr(*st)) { sw = 0; break;}
  }
  return stoconc(sw? toupr(nam): nam, ext);
}

HBLK WINAPI CreateDArray(int cap, int rsz)
{ // Iz̍쐬
  if (rsz < 1 || rsz > 65536) return ierr(E_PAR);
  return create_array(NULL, NULL, 0, cap, rsz);
}

int  WINAPI NItems(HBLK mb)
{ // vf
  return mb->len;
}

int  WINAPI ItemSize(HBLK mb)
{ // vf̃TCY
  return mb->rsz;
}

PVOID WINAPI BPtr(HBLK mb)
{ // 擪vf̃AhX
  return mb->ptr;
}

PVOID WINAPI ItemPtr(HBLK mb, int ir)
{ // vf̃AhX
  if (ir < 0 || ir >= mb->len) { ierr(E_PAR); return valloc(mb->rsz);}
  return iptr(mb, ir);
}

BOOL WINAPI InsertItem(HBLK mb, int ir, PCVOID pi)
{ // vf̑}
  if (ir < 0 || ir > mb->len) return (BOOL)ierr(E_PAR);
  return insert_items(mb, ir, pi, 1);
}

BOOL WINAPI InsertItems(HBLK mb, int ir, PCVOID pb, int nr)
{ // ͈͂̑}
  if (ir < 0 || ir > mb->len || nr < 0) return (BOOL)ierr(E_PAR);
  return insert_items(mb, ir, pb, nr);
}

BOOL WINAPI DeleteItem(HBLK mb, int ir)
{ // vf̍폜
  if (ir < 0 || ir > mb->len) return (BOOL)ierr(E_PAR);
  if (ir == mb->len) return TRUE;
  return delete_items(mb, ir, 1);
}

BOOL WINAPI DeleteItems(HBLK mb, int ir, int nr)
{ // ͈͂̍폜
  if (ir < 0 || ir > mb->len || nr < 0) return (BOOL)ierr(E_PAR);
  if (ir == mb->len) return TRUE;
  if (ir + nr > mb->len) nr = mb->len - ir;
  return delete_items(mb, ir, nr);
}

BOOL WINAPI AppendItems(HBLK mb, PCVOID pb, int nr)
{ // vf̒ǉ
  if (nr < 0) return (BOOL)ierr(E_PAR);
  return append_items(mb, pb, nr);
}

int  WINAPI SearchItem(HBLK mb, int i0, FSEL fsel, UINT pa)
{ // T[`
  int i;

  if (!fsel || i0 < 0 || i0 > mb->len) { ierr(E_PAR); return -1;}
  for (i = i0; i < mb->len; i++) {
    if (fsel(iptr(mb, i), pa)) return i;
  }
  return -1;
}

int  WINAPI CountItems(HBLK mb, FSEL fsel, UINT pa)
{ // JEg
  int i, n;

  if (!fsel) return mb->len;
  for (n = i = 0; i < mb->len; i++) {
    if (fsel(iptr(mb, i), pa)) n++;
  }
  return n;
}

int  WINAPI SelectItems(HBLK mb, FSEL fsel, UINT pa)
{ // i荞
  int i, n;

  if (!fsel) return mb->len;
  for (n = i = 0; i < mb->len; i++) {
    if (fsel(iptr(mb, i), pa)) {
      if (i > n) memcpy(iptr(mb, n), iptr(mb, i), mb->rsz);
      n++;
    }
  }
  return mb->len = n;
}

void WINAPI SortItems(HBLK mb, FSRT fcmp, UINT pa)
{ // בւ
  int g, i, j, s;
  PVOID wk = ualloc(mb->rsz);

  if (!fcmp || mb->len <= 1) return;
  g = mb->len;
  do {
    g = g * 10 / 13;
    switch (g) {
    case 0: g = 1; break;
    case 9: case 10: g = 11; break;
    }
    s = 0;
    for (i = 0, j = g; j < mb->len; i++, j++) {
      if (fcmp(iptr(mb, i), iptr(mb, j), pa) > 0) {
        memcpy(wk, iptr(mb, i), mb->rsz);
        memcpy(iptr(mb, i), iptr(mb, j), mb->rsz);
        memcpy(iptr(mb, j), wk, mb->rsz);
        s = 1;
      }
    }
  } while (s != 0 || g > 1);
}

void WINAPI RotateItemsLeft(HBLK mb, int ir, int nr)
{ // ͈͂̍]
  HBLK_ blk;

  if (ir < 0 || ir >= mb->len || nr < 0) { ierr(E_PAR); return;}
  rotate_items_left(build_slice(&blk, mb, ir, nr));
}

void WINAPI RotateItemsRight(HBLK mb, int ir, int nr)
{ // ͈͂̉E]
  HBLK_ blk;

  if (ir < 0 || ir >= mb->len || nr < 0) { ierr(E_PAR); return;}
  rotate_items_right(build_slice(&blk, mb, ir, nr));
}

void WINAPI ReverseItems(HBLK mb, int ir, int nr)
{ // ͈͂̋tבւ
  HBLK_ blk;

  if (ir < 0 || ir >= mb->len || nr < 0) { ierr(E_PAR); return;}
  reverse_items(build_slice(&blk, mb, ir, nr));
}

void WINAPI MoveItemToFirst(HBLK mb, int ir)
{ // vf擪Ɉړ
  HBLK_ blk;

  if (ir < 0 || ir >= mb->len) { ierr(E_PAR); return;}
  rotate_items_right(build_slice(&blk, mb, 0, ir + 1));
}

void WINAPI MoveItemToLast(HBLK mb, int ir)
{ // vf𖖔Ɉړ
  HBLK_ blk;

  if (ir < 0 || ir >= mb->len) { ierr(E_PAR); return;}
  rotate_items_left(build_slice(&blk, mb, ir, mb->len - ir));
}

HBLK WINAPI CreateTXT(int cap)
{ // eLXgubN̍쐬
  HBLK xb;

  xb = create_array(NULL, NULL, 0, cap, 1); if (!xb) return NULL;
  add_item(xb, NULL);
  return xb;
}

HBLK WINAPI DuplicateTXT(HBLK xb)
{ // eLXgubN̕
  HBLK xx;

  if (xb->rsz != 1) return ierr(E_PAR);
  xx = create_array(NULL, NULL, 0, xb->cap, 1); if (!xx) return NULL;
  append_items(xx, xb->ptr, xb->len);
  return xx;
}

HBLK WINAPI MakeTXT(PCSTR st)
{ // ̊蓖
  int len = strlen(st);

  return build_array(ualloc(sizeof(HBLK_)), (PVOID)st, len + 1, len + 1, 1);
}

HBLK WINAPI MoveTXT(HBLK xb, HBLK xx)
{ // eLXgubN̈ړ
  hfree(xb->ptr);
  *(HBLK_ *)xb = *(HBLK_ *)xx;
  hfree(xx);
  return xb;
}

int  WINAPI CompareTXT(HBLK xb, HBLK xx)
{ // eLXgubN̔r
  return strcmp(xb->ptr, xx->ptr);
}

HBLK WINAPI LoadTXT(HBLK xb, PCSTR nam)
{ // eLXgt@CǍ
  int sz;
  PSTR st;
  HANDLE hf;
  HBLK xx;

  sz = file_size(nam);
  xx = CreateTXT(sz + 1); if (!xx) return NULL;
  hf = open_file(nam, OP_RDO); if (!hf) { ferr(E_FIR, nam); goto _L2;}
  st = (PSTR)xx->ptr;
  if (!read_file(hf, st, sz)) { ferr(E_FIR, nam); goto _L1;}
  st[sz] = '\0'; if (strlen(st) != sz) { ferr(E_DAT, nam); goto _L1;}
  xx->len = sz + 1;
  close_file(hf);
  return xb? MoveTXT(xb, xx): xx;

 _L1: close_file(hf);
 _L2: DeleteTXT(xx);
  return NULL;
}

BOOL WINAPI SaveTXT(HBLK xb, PCSTR nam)
{ // eLXgt@Co
  int re;
  PSTR st;
  HANDLE hf;

  hf = open_file(nam, OP_WRI); if (!hf) return (BOOL)ferr(E_FIW, nam);
  st = (PSTR)xb->ptr;
  re = write_file(hf, st, strlen(st)); if (!re) ferr(E_FIW, nam);
  close_file(hf);
  return re;
}

UINT WINAPI RowExt(HBLK xb)
{ // sƍő包
  int ir, ic, xc;
  PSTR pt;

  for (ir = ic = xc = 0, pt = (PSTR)xb->ptr; *pt != '\0'; pt++) {
    if (isret(pt)) {
      if (ic > xc) xc = ic;
      ir++; ic = 0; pt++;
    } else {
      ic++;
    }
  }
  if (ic > 0) {
    if (ic > xc) xc = ic;
    ir++;
  }
  return MAKEUINT(ir, xc);
}

UINT WINAPI PtrRow(HBLK xb, PCSTR pc)
{ // ʒu
  int ir, ic;
  PSTR pt;

  for (ir = ic = 0, pt = (PSTR)xb->ptr; *pt != '\0' && pt < pc; pt++) {
    if (isret(pt)) {
      ir++; ic = 0; pt++;
    } else {
      ic++;
    }
  }
  return MAKEUINT(ir, ic);
}

PSTR WINAPI RowPtr(HBLK xb, UINT rc)
{ // s̃AhX
  int ir, ic;
  PSTR pt;

  for (ir = ic = 0, pt = (PSTR)xb->ptr; *pt != '\0'; pt++) {
    if (MAKEUINT(ir, ic) == rc) return pt;
    if (isret(pt)) {
      if (ir == LOWORD(rc)) return pt;
      ir++; ic = 0; pt++;
    } else {
      ic++;
    }
  }
  return pt;
}

int  WINAPI RowLen(HBLK xb, UINT rc)
{ // š
  int ic;
  PSTR pt;

  for (ic = 0, pt = RowPtr(xb, rc); *pt != '\0'; pt++) {
    if (isret(pt)) return ic;
    ic++;
  }
  return ic;
}

UINT WINAPI CharPos(HBLK xb, UINT rc)
{ // ʒuSp̑2oCgڂȂ1oCgڂɕ␳
  int ir, ic;

  ir = LOWORD(rc); ic = HIWORD(rc);
  if (ic < RowLen(xb, ir) && nthzen1(RowPtr(xb, ir), ic - 1)) {
    rc = MAKEUINT(ir, ic - 1);
  }
  return rc;
}

UINT WINAPI PrevPos(HBLK xb, UINT rc)
{ // O̕ʒu
  int ir, ic;

  rc = CharPos(xb, rc); if (rc == 0) return rc;
  ir = LOWORD(rc); ic = HIWORD(rc);
  if (ic == 0) return MAKEUINT(ir - 1, RowLen(xb, ir - 1));
  return CharPos(xb, MAKEUINT(ir, ic - 1));
}

UINT WINAPI NextPos(HBLK xb, UINT rc)
{ // ̕ʒu
  int ir, ic;
  PSTR pt;

  pt = RowPtr(xb, rc = CharPos(xb, rc)); if (*pt == '\0') return rc;
  ir = LOWORD(rc); ic = HIWORD(rc);
  if (isret(pt)) return MAKEUINT(ir + 1, 0);
  return MAKEUINT(ir, ic + 1 + iszen1(*pt));
}

PSTR WINAPI CopyStr(PSTR st, HBLK xb, UINT r1, UINT r2)
{ // ̃Rs[
  return spncpy(st, RowPtr(xb, r1), RowPtr(xb, r2));
}

BOOL WINAPI InsertStr(HBLK xb, UINT rc, PCSTR st)
{ // ̑}
  return insert_items(xb, RowPtr(xb, rc) - (PSTR)xb->ptr, st, strlen(st));
}

BOOL WINAPI DeleteStr(HBLK xb, UINT r1, UINT r2)
{ // ̍폜
  PSTR p1, p2;

  p1 = RowPtr(xb, r1); p2 = RowPtr(xb, r2); if (p1 >= p2) return FALSE;
  return delete_items(xb, p1 - (PSTR)xb->ptr, p2 - p1);
}

BOOL WINAPI AddStr(HBLK xb, PCSTR st)
{ // ̒ǉ
  return insert_items(xb, xb->len - 1, st, strlen(st));
}

UINT WINAPI SearchStr(HBLK xb, UINT r0, PCSTR st, int flg)
{ // ̌
  PSTR pt;

  pt = strfindx(RowPtr(xb, r0), st, flg);
  return pt? PtrRow(xb, pt): (UINT)-1;
}

BOOL WINAPI ReplaceStr(HBLK xb, PCSTR s1, PCSTR s2)
{ // ̒u(s1s2)
  int cap;
  HBLK xx;

  cap = xb->len + strcount((PSTR)xb->ptr, s1) * (strlen(s2) - strlen(s1));
  xx = CreateTXT(cap); if (!xx) return FALSE;
  strrepl_b((PCSTR)xb->ptr, s1, s2, (PSTR)xx->ptr);
  MoveTXT(xb, xx);
  return TRUE;
}

// ---------------------------------------------------------------------- //

REAL WINAPI MatLudN(PMAT mr, PINT ip, PCMAT mt, int n)
{ // LU
  int i, j, k;
  REAL d, t, u, *vw;

  if (mr != mt) MatCpyN(mr, mt, n);
  vw = VecTmpN(n);
  for (i = 0; i < n; i++) {
    ip[i] = i;
    u = 0.0;
    for (j = 0; j < n; j++) {
      if ((t = fabs(mr[i * n + j])) > u) u = t;
    }
    if (u == 0.0) return 0.0;
    vw[i] = u;
  }
  d = 1.0;
  for (i = 0; i < n; i++) {
    u = -1.0;
    for (j = i; j < n; j++) {
      if ((t = fabs(mr[ip[j] * n + i]) / vw[ip[j]]) > u) { u = t; k = j;}
    }
    if (k != i) {
      j = ip[k]; ip[k] = ip[i]; ip[i] = j;
      d = -d;
    }
    u = mr[ip[i] * n + i];
    if (u == 0.0) return 0.0;
    d *= u;
    for (j = i+1; j < n; j++) {
      t = (mr[ip[j] * n + i] /= u);
      for (k = i+1; k < n; k++) {
        mr[ip[j] * n + k] -= t * mr[ip[i] * n + k];
      }
    }
  }
  return d;
}

BOOL WINAPI Equ1dNu(PVEC vr, PCMAT mt, PCVEC vc, int n)
{ // nA1
  int i, j, *ip;
  REAL d, t, *mw;

  mw = MatTmpN(n);
  ip = ualloc(n * sizeof(int));
  d = MatLudN(mw, ip, mt, n);
  if (d == 0.0) return FALSE;
  for (i = 0; i < n; i++) {
    t = vc[ip[i]];
    for (j = 0; j < i; j++) {
      t -= mw[ip[i] * n + j] * vr[j];
    }
    vr[i] = t;
  }
  for (i = n-1; i >= 0; i--) {
    t = vr[i];
    for (j = i+1; j < n; j++) {
      t -= mw[ip[i] * n + j] * vr[j];
    }
    vr[i] = t / mw[ip[i] * n + i];
  }
  return TRUE;
}

// ---------------------------------------------------------------------- //

  // ͏
typedef struct {
  PCSTR pt;
  PCSTR pb;
  PBYTE bf;
  UINT  rsv;
  FTKN  ftkn[5];
  UINT  pa;
} LEXE;
typedef LEXE * PLEXE;

int  LOCALF ftknDMY(PCSTR *pp, PBYTE bf, UINT pa)
{ // _~[
  return 0;
}

HLEX WINAPI CreateParsEnv(PCLEXI li)
{ // ͏̍쐬
  PLEXE le;

  le = halloc(sizeof(LEXE) + LSTR + 1, FALSE); if (!le) return ierr(E_MEM);
  le->bf = (PBYTE)le + sizeof(LEXE);
  le->ftkn[0] = li->fspc? li->fspc: ftknDMY;
  le->ftkn[1] = li->fcns? li->fcns: ftknDMY;
  le->ftkn[2] = li->fstr? li->fstr: ftknDMY;
  le->ftkn[3] = li->fkwd? li->fkwd: ftknDMY;
  le->ftkn[4] = li->fopr? li->fopr: ftknDMY;
  le->pa = li->pa;
  return (HLEX)le;
}

void WINAPI DeleteParsEnv(HLEX le)
{ // ͏̍폜
  hfree(le);
}

  // ݂̎͏
static PLEXE LE;

HLEX WINAPI SelectParsEnv(HLEX le)
{ // ͏̑I
  PLEXE bk = LE; LE = (PLEXE)le; return (HLEX)bk;
}

void WINAPI start(PCSTR pt)
{ // Jnʒu̐ݒ
  if (!LE) { ierr(E_ALO); return;}
  LE->pt = LE->pb = pt;
}

void WINAPI restart(PCSTR pt)
{ // ݈ʒu̍Đݒ
  if (!LE) { ierr(E_ALO); return;}
  LE->pt = pt;
}

PCSTR WINAPI bpos(void)
{ // Jnʒu
  return LE? LE->pb: ierr(E_ALO);
}

PCSTR WINAPI cpos(void)
{ // ݈ʒu
  return LE? LE->pt: ierr(E_ALO);
}

PVOID WINAPI buf(void)
{ // Ǎobt@
  return LE? LE->bf: ierr(E_ALO);
}

int  WINAPI token(void)
{ // g[N
  int i, cd;

  if (!LE) return (int)ierr(E_ALO);
  if (*LE->pt == '\0') return TKN_END;
  for (i = 0; i < NELEM(LE->ftkn); i++) {
    cd = LE->ftkn[i](&LE->pt, LE->bf, LE->pa); if (cd) break;
    if (*LE->pt == '\0') return TKN_END;
  }
  return cd;
}

BOOL WINAPI token_is(int cd)
{ // g[N(ǂ)
  int re;
  PCSTR bk;

  if (!LE) return (BOOL)ierr(E_ALO);
  bk = LE->pt;
  re = (token() == cd);
  if (!re) LE->pt = bk;
  return re;
}

UINT WINAPI errpos(void)
{ // G[ʒu
  if (!LE) return (UINT)ierr(E_ALO);
  return PtrRow(MakeTXT(LE->pb), LE->pt);
}

// ---------------------------------------------------------------------- //

int  LOCALF fmtasz(PCSTR fmt)
{ // printf񂩂ψŜ̃TCY߂
  int sz = 0;
  PCSTR pt = fmt;

  while (*pt != '\0') {
    if (*pt == '%') {
      pt++; if (*pt == '%') continue;
      pt += strspn(pt, " #+-0");
      if (*pt == '*') { pt++; sz += 4;}  else pt += strspn(pt, "0123456789");
      if (*pt == '.') {
        pt++;
        if (*pt == '*') { pt++; sz += 4;}  else pt += strspn(pt, "0123456789");
      }
      if (*pt == 'l') {
        pt++; if (*pt == 'l') { pt++; sz += 4;}
      } else if (*pt == 'h' || *pt == 'L') {
        pt++;
      }
      switch (*pt++) {
      case 'c': case 'd': case 'i': case 'n': case 'o':
      case 'p': case 's': case 'u': case 'x': case 'X':
        sz += 4; break;
      case 'e': case 'E': case 'f': case 'g': case 'G':
        sz += 8; break;
      }
    } else if (iszen(pt)) {
      pt += 2;
    } else {
      pt++;
    }
  }
  return sz;
}

void WINAPI fi_0(PBYTE sp)
{ // _~[
}

void LOCALF fi_sqrt(PBYTE sp)
{ // sqrt
  *(F8B *)sp = sqrt(*(F8B *)sp);
}

void LOCALF fi_sin(PBYTE sp)
{ // sin
  *(F8B *)sp = sin(*(F8B *)sp);
}

void LOCALF fi_cos(PBYTE sp)
{ // cos
  *(F8B *)sp = cos(*(F8B *)sp);
}

void LOCALF fi_tan(PBYTE sp)
{ // tan
  *(F8B *)sp = tan(*(F8B *)sp);
}

void LOCALF fi_asin(PBYTE sp)
{ // asin
  *(F8B *)sp = asin(*(F8B *)sp);
}

void LOCALF fi_acos(PBYTE sp)
{ // acos
  *(F8B *)sp = acos(*(F8B *)sp);
}

void LOCALF fi_atan(PBYTE sp)
{ // atan
  *(F8B *)sp = atan(*(F8B *)sp);
}

void LOCALF fi_atan2(PBYTE sp)
{ // atan2
  *(F8B *)(sp + 8) = atan2(*(F8B *)sp, *(F8B *)(sp + 8));
}

void LOCALF fi_exp(PBYTE sp)
{ // exp
  *(F8B *)sp = exp(*(F8B *)sp);
}

void LOCALF fi_pow(PBYTE sp)
{ // pow
  *(F8B *)(sp + 8) = pow(*(F8B *)sp, *(F8B *)(sp + 8));
}

void LOCALF fi_log(PBYTE sp)
{ // log
  *(F8B *)sp = log(*(F8B *)sp);
}

void LOCALF fi_log10(PBYTE sp)
{ // log10
  *(F8B *)sp = log10(*(F8B *)sp);
}

void LOCALF fi_ceil(PBYTE sp)
{ // ceil
  *(F8B *)sp = ceil(*(F8B *)sp);
}

void LOCALF fi_floor(PBYTE sp)
{ // floor
  *(F8B *)sp = floor(*(F8B *)sp);
}

void LOCALF fi_fabs(PBYTE sp)
{ // fabs
  *(F8B *)sp = fabs(*(F8B *)sp);
}

void LOCALF fi_abs(PBYTE sp)
{ // abs
  *(I4B *)sp = abs(*(I4B *)sp);
}

void LOCALF fi_atoi(PBYTE sp)
{ // atoi
  *(I4B *)sp = atoi(*(P4B *)sp);
}

void LOCALF fi_atof(PBYTE sp)
{ // atof
  *(F8B *)(sp - 4) = atof(*(P4B *)sp);
}

void LOCALF fi_rand(PBYTE sp)
{ // rand
  *(I4B *)(sp - 4) = rand();
}

void LOCALF fi_srand(PBYTE sp)
{ // srand
  srand(*(U4B *)sp);
}

void LOCALF fi_calloc(PBYTE sp)
{ // calloc
  *(P4B *)(sp + 4) = halloc(*(U4B *)sp * *(U4B *)(sp + 4), TRUE);
}

void LOCALF fi_malloc(PBYTE sp)
{ // malloc
  *(P4B *)sp = halloc(*(U4B *)sp, FALSE);
}

void LOCALF fi_free(PBYTE sp)
{ // free
  hfree(*(P4B *)sp);
}

void LOCALF fi_memchr(PBYTE sp)
{ // memchr
  *(P4B *)(sp + 8)= memchr(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_memcmp(PBYTE sp)
{ // memcmp
  *(I4B *)(sp + 8) = memcmp(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_memcpy(PBYTE sp)
{ // memcpy
  *(P4B *)(sp + 8) = memcpy(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_memmove(PBYTE sp)
{ // memmove
  *(P4B *)(sp + 8) = memmove(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_memset(PBYTE sp)
{ // memset
  *(P4B *)(sp + 8) = memset(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_strchr(PBYTE sp)
{ // strchr
  *(P4B *)(sp + 4) = strchr(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_strcmp(PBYTE sp)
{ // strcmp
  *(I4B *)(sp + 4) = strcmp(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_stricmp(PBYTE sp)
{ // stricmp
  *(I4B *)(sp + 4) = stricmp(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strncmp(PBYTE sp)
{ // strncmp
  *(I4B *)(sp + 8) = strncmp(*(P4B *)sp, *(P4B *)(sp + 4), *(U4B *)(sp + 8));
}

void LOCALF fi_strnicmp(PBYTE sp)
{ // strnicmp
  *(I4B *)(sp + 8) = strnicmp(*(P4B *)sp, *(P4B *)(sp + 4), *(U4B *)(sp + 8));
}

void LOCALF fi_strcpy(PBYTE sp)
{ // strcpy
  *(P4B *)(sp + 4) = strcpy(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strcat(PBYTE sp)
{ // strcat
  *(P4B *)(sp + 4) = strcat(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strlen(PBYTE sp)
{ // strlen
  *(U4B *)sp = strlen(*(P4B *)sp);
}

void LOCALF fi_strspn(PBYTE sp)
{ // strspn
  *(U4B *)(sp + 4) = strspn(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strtoul(PBYTE sp)
{ // strtoul
  *(U4B *)(sp + 8) = strtoul(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_sprintf(PBYTE sp)
{ // sprintf
  int sz, re;
  va_list ap;

  sz = fmtasz(*(P4B *)(sp + 4));
  va_start(ap, *(P4B *)(sp + 4));
  re = vsprintf(*(P4B *)sp, *(P4B *)(sp + 4), ap);
  va_end(ap);
  *(I4B *)(sp + 4 + sz) = re;
}

void LOCALF fi_atoi64(PBYTE sp)
{ // _atoi64
  *(I8B *)(sp - 4) = _atoi64(*(P4B *)sp);
}

void LOCALF fi_strtoui64(PBYTE sp)
{ // _strtoui64
  *(U8B *)(sp + 4) = _strtoui64(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_sign(PBYTE sp)
{ // sign
  *(I4B *)(sp + 4) = sign(*(F8B *)sp);
}

void LOCALF fi_iround(PBYTE sp)
{ // iround
  *(I4B *)(sp + 4) = iround(*(F8B *)sp);
}

void LOCALF fi_hash(PBYTE sp)
{ // hash
  *(U4B *)(sp + 4) = hash(*(P4B *)sp, *(U4B *)(sp + 4));
}

void LOCALF fi_nbound(PBYTE sp)
{ // nbound
  *(U4B *)(sp + 4) = nbound(*(U4B *)sp, *(U4B *)(sp + 4));
}

void LOCALF fi_halloc(PBYTE sp)
{ // halloc
  *(P4B *)(sp + 4) = halloc(*(U4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_hrealloc(PBYTE sp)
{ // hrealloc
  *(P4B *)(sp + 4) = hrealloc(*(P4B *)sp, *(U4B *)(sp + 4));
}

void LOCALF fi_hfree(PBYTE sp)
{ // hfree
  hfree(*(P4B *)sp);
}

void LOCALF fi_talloc(PBYTE sp)
{ // talloc
  *(P4B *)sp = talloc(*(U4B *)sp);
}

void LOCALF fi_ualloc(PBYTE sp)
{ // ualloc
  *(P4B *)sp = ualloc(*(U4B *)sp);
}

void LOCALF fi_isspc(PBYTE sp)
{ // isspc
  *(I4B *)sp = isspc(*(I4B *)sp);
}

void LOCALF fi_isctl(PBYTE sp)
{ // isctl
  *(I4B *)sp = isctl(*(I4B *)sp);
}

void LOCALF fi_isdig(PBYTE sp)
{ // isdig
  *(I4B *)sp = isdig(*(I4B *)sp);
}

void LOCALF fi_isodig(PBYTE sp)
{ // isodig
  *(I4B *)sp = isodig(*(I4B *)sp);
}

void LOCALF fi_isxdig(PBYTE sp)
{ // isxdig
  *(I4B *)sp = isxdig(*(I4B *)sp);
}

void LOCALF fi_isupr(PBYTE sp)
{ // isupr
  *(I4B *)sp = isupr(*(I4B *)sp);
}

void LOCALF fi_islwr(PBYTE sp)
{ // islwr
  *(I4B *)sp = islwr(*(I4B *)sp);
}

void LOCALF fi_isalp(PBYTE sp)
{ // isalp
  *(I4B *)sp = isalp(*(I4B *)sp);
}

void LOCALF fi_isalpx(PBYTE sp)
{ // isalpx
  *(I4B *)sp = isalpx(*(I4B *)sp);
}

void LOCALF fi_isaln(PBYTE sp)
{ // isaln
  *(I4B *)sp = isaln(*(I4B *)sp);
}

void LOCALF fi_isalnx(PBYTE sp)
{ // isalnx
  *(I4B *)sp = isalnx(*(I4B *)sp);
}

void LOCALF fi_isasc(PBYTE sp)
{ // isasc
  *(I4B *)sp = isasc(*(I4B *)sp);
}

void LOCALF fi_ishan(PBYTE sp)
{ // ishan
  *(I4B *)sp = ishan(*(I4B *)sp);
}

void LOCALF fi_isprn(PBYTE sp)
{ // isprn
  *(I4B *)sp = isprn(*(I4B *)sp);
}

void LOCALF fi_iszen1(PBYTE sp)
{ // iszen1
  *(I4B *)sp = iszen1(*(I4B *)sp);
}

void LOCALF fi_iszen2(PBYTE sp)
{ // iszen2
  *(I4B *)sp = iszen2(*(I4B *)sp);
}

void LOCALF fi_iszen(PBYTE sp)
{ // iszen
  *(I4B *)sp = iszen(*(P4B *)sp);
}

void LOCALF fi_spncpy(PBYTE sp)
{ // spncpy
  *(P4B *)(sp + 8) = spncpy(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_strcpyn(PBYTE sp)
{ // strcpyn
  *(P4B *)(sp + 8) = strcpyn(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_strcpyx(PBYTE sp)
{ // strcpyx
  *(P4B *)(sp + 8) = strcpyx(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_nthzen1(PBYTE sp)
{ // nthzen1
  *(I4B *)(sp + 4) = nthzen1(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_nthyen(PBYTE sp)
{ // nthyen
  *(I4B *)(sp + 4) = nthyen(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_mbschr(PBYTE sp)
{ // mbschr
  *(P4B *)(sp + 4) = mbschr(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_mbsrchr(PBYTE sp)
{ // mbsrchr
  *(P4B *)(sp + 4) = mbsrchr(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_mbslen(PBYTE sp)
{ // mbslen
  *(U4B *)sp = mbslen(*(P4B *)sp);
}

void LOCALF fi_strfind(PBYTE sp)
{ // strfind
  *(P4B *)(sp + 4) = (P4B)strfind(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strlfind(PBYTE sp)
{ // strlfind
  *(I4B *)(sp + 4) = strlfind(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strrfind(PBYTE sp)
{ // strrfind
  *(I4B *)(sp + 4) = strrfind(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strifind(PBYTE sp)
{ // strifind
  *(P4B *)(sp + 4) = (P4B)strifind(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strilfind(PBYTE sp)
{ // strilfind
  *(I4B *)(sp + 4) = strilfind(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strirfind(PBYTE sp)
{ // strirfind
  *(I4B *)(sp + 4) = strirfind(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strmatch(PBYTE sp)
{ // strmatch
  *(I4B *)(sp + 4) = strmatch(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strcount(PBYTE sp)
{ // strcount
  *(I4B *)(sp + 4) = strcount(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_tozen(PBYTE sp)
{ // tozen
  *(P4B *)sp = (P4B)tozen(*(P4B *)sp);
}

void LOCALF fi_tohan(PBYTE sp)
{ // tohan
  *(P4B *)sp = (P4B)tohan(*(P4B *)sp);
}

void LOCALF fi_toupr(PBYTE sp)
{ // toupr
  *(P4B *)sp = (P4B)toupr(*(P4B *)sp);
}

void LOCALF fi_tolwr(PBYTE sp)
{ // tolwr
  *(P4B *)sp = (P4B)tolwr(*(P4B *)sp);
}

void LOCALF fi_tohira(PBYTE sp)
{ // tohira
  *(P4B *)sp = (P4B)tohira(*(P4B *)sp);
}

void LOCALF fi_tokata(PBYTE sp)
{ // tokata
  *(P4B *)sp = (P4B)tokata(*(P4B *)sp);
}

void LOCALF fi_ltrim(PBYTE sp)
{ // ltrim
  *(P4B *)sp = (P4B)ltrim(*(P4B *)sp);
}

void LOCALF fi_rtrim(PBYTE sp)
{ // rtrim
  *(P4B *)sp = (P4B)rtrim(*(P4B *)sp);
}

void LOCALF fi_btrim(PBYTE sp)
{ // btrim
  *(P4B *)sp = (P4B)btrim(*(P4B *)sp);
}

void LOCALF fi_delspc(PBYTE sp)
{ // delspc
  *(P4B *)sp = (P4B)delspc(*(P4B *)sp);
}

void LOCALF fi_delctl(PBYTE sp)
{ // delctl
  *(P4B *)sp = (P4B)delctl(*(P4B *)sp);
}

void LOCALF fi_ctlspc(PBYTE sp)
{ // ctlspc
  *(P4B *)sp = (P4B)ctlspc(*(P4B *)sp);
}

void LOCALF fi_cipher(PBYTE sp)
{ // cipher
  *(P4B *)sp = (P4B)cipher(*(P4B *)sp);
}

void LOCALF fi_inscma(PBYTE sp)
{ // inscma
  *(P4B *)sp = (P4B)inscma(*(P4B *)sp);
}

void LOCALF fi_delcma(PBYTE sp)
{ // delcma
  *(P4B *)sp = (P4B)delcma(*(P4B *)sp);
}

void LOCALF fi_strlike(PBYTE sp)
{ // strlike
  *(I4B *)(sp + 4) = strlike(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strmlike(PBYTE sp)
{ // strmlike
  *(I4B *)(sp + 4) = strmlike(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strllike(PBYTE sp)
{ // strllike
  *(I4B *)(sp + 4) = strllike(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_strrlike(PBYTE sp)
{ // strrlike
  *(I4B *)(sp + 4) = strrlike(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_midstr(PBYTE sp)
{ // midstr
  *(P4B *)(sp + 8) = (P4B)midstr(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_strrepl(PBYTE sp)
{ // strrepl
  *(P4B *)(sp + 8) = (P4B)strrepl(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_strconc(PBYTE sp)
{ // strconc
  *(P4B *)(sp + 4) = (P4B)strconc(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_csprintf(PBYTE sp)
{ // csprintf
  int sz;
  va_list ap;
  char bf[512];

  sz = fmtasz(*(P4B *)(sp + 4));
  va_start(ap, *(P4B *)(sp + 4));
  vsprintf(bf, *(P4B *)(sp + 4), ap);
  va_end(ap);
  *(I4B *)(sp + 4 + sz) = strlen(inscma_b(bf, *(P4B *)sp));
}

void LOCALF fi_format(PBYTE sp)
{ // format
  int sz;
  va_list ap;
  char bf[512];

  sz = fmtasz(*(P4B *)sp);
  va_start(ap, *(P4B *)sp);
  vsprintf(bf, *(P4B *)sp, ap);
  va_end(ap);
  *(P4B *)(sp + sz) = (P4B)strcpy(talloc(strlen(bf) + 1), bf);
}

void LOCALF fi_cformat(PBYTE sp)
{ // cformat
  int sz;
  va_list ap;
  char bf[512];

  sz = fmtasz(*(P4B *)sp);
  va_start(ap, *(P4B *)sp);
  vsprintf(bf, *(P4B *)sp, ap);
  va_end(ap);
  *(P4B *)(sp + sz) = (P4B)inscma_b(bf, talloc(strlen(bf) * 4 / 3 + 1));
}

void LOCALF fi_ztoi(PBYTE sp)
{ // ztoi
  *(I4B *)sp = ztoi(*(P4B *)sp);
}

void LOCALF fi_ztou(PBYTE sp)
{ // ztou
  *(U4B *)sp = ztou(*(P4B *)sp);
}

void LOCALF fi_ztoi64(PBYTE sp)
{ // ztoi64
  *(I8B *)(sp - 4) = ztoi64(*(P4B *)sp);
}

void LOCALF fi_ztou64(PBYTE sp)
{ // ztou64
  *(U8B *)(sp - 4) = ztou64(*(P4B *)sp);
}

void LOCALF fi_ztof(PBYTE sp)
{ // ztof
  *(F8B *)(sp - 4) = ztof(*(P4B *)sp);
}

void LOCALF fi_cztoi(PBYTE sp)
{ // cztoi
  *(I4B *)sp = cztoi(*(P4B *)sp);
}

void LOCALF fi_cztou(PBYTE sp)
{ // cztou
  *(U4B *)sp = cztou(*(P4B *)sp);
}

void LOCALF fi_cztoi64(PBYTE sp)
{ // cztoi64
  *(I8B *)(sp - 4) = cztoi64(*(P4B *)sp);
}

void LOCALF fi_cztou64(PBYTE sp)
{ // cztou64
  *(U8B *)(sp - 4) = cztou64(*(P4B *)sp);
}

void LOCALF fi_cztof(PBYTE sp)
{ // cztof
  *(F8B *)(sp - 4) = cztof(*(P4B *)sp);
}

void LOCALF fi_is_leap_year(PBYTE sp)
{ // is_leap_year
  *(I4B *)sp = is_leap_year(*(I4B *)sp);
}

void LOCALF fi_days_of_month(PBYTE sp)
{ // days_of_month
  *(I4B *)(sp + 4) = days_of_month(*(I4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_day_of_week(PBYTE sp)
{ // day_of_week
  *(I4B *)(sp + 8) = day_of_week(*(I4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_date_serial(PBYTE sp)
{ // date_serial
  *(I4B *)(sp + 8) = date_serial(*(I4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_year(PBYTE sp)
{ // year
  *(I4B *)sp = year(*(I4B *)sp);
}

void LOCALF fi_month(PBYTE sp)
{ // month
  *(I4B *)sp = month(*(I4B *)sp);
}

void LOCALF fi_day(PBYTE sp)
{ // day
  *(I4B *)sp = day(*(I4B *)sp);
}

void LOCALF fi_youbi(PBYTE sp)
{ // youbi
  *(I4B *)sp = youbi(*(I4B *)sp);
}

void LOCALF fi_era_year(PBYTE sp)
{ // era_year
  *(I4B *)sp = era_year(*(I4B *)sp);
}

void LOCALF fi_today(PBYTE sp)
{ // today
  *(I4B *)(sp - 4) = today();
}

void LOCALF fi_date_diff(PBYTE sp)
{ // date_diff
  *(I4B *)(sp + 8) = date_diff(*(I4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ztod(PBYTE sp)
{ // ztod
  *(I4B *)sp = ztod(*(P4B *)sp);
}

void LOCALF fi_ztod2(PBYTE sp)
{ // ztod2
  *(I4B *)(sp + 4) = ztod2(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ztom(PBYTE sp)
{ // ztom
  *(I4B *)sp = ztom(*(P4B *)sp);
}

void LOCALF fi_dprintf(PBYTE sp)
{ // dprintf
  *(I4B *)(sp + 8) = dprintf(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_dformat(PBYTE sp)
{ // dformat
  *(P4B *)(sp + 4) = (P4B)dformat(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_time_serial(PBYTE sp)
{ // time_serial
  *(I4B *)(sp + 8) = time_serial(*(I4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_hour(PBYTE sp)
{ // hour
  *(I4B *)sp = hour(*(I4B *)sp);
}

void LOCALF fi_minute(PBYTE sp)
{ // minute
  *(I4B *)sp = minute(*(I4B *)sp);
}

void LOCALF fi_second(PBYTE sp)
{ // second
  *(I4B *)sp = second(*(I4B *)sp);
}

void LOCALF fi_ztot(PBYTE sp)
{ // ztot
  *(I4B *)sp = ztot(*(P4B *)sp);
}

void LOCALF fi_tprintf(PBYTE sp)
{ // tprintf
  *(I4B *)(sp + 8) = tprintf(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_tformat(PBYTE sp)
{ // tformat
  *(P4B *)(sp + 4) = (P4B)tformat(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_now(PBYTE sp)
{ // now
  *(F8B *)(sp - 8) = now();
}

void LOCALF fi_ztodt(PBYTE sp)
{ // ztodt
  *(F8B *)(sp - 4) = ztodt(*(P4B *)sp);
}

void LOCALF fi_dtprintf(PBYTE sp)
{ // dtprintf
  *(I4B *)(sp + 12) = dtprintf(*(P4B *)sp, *(P4B *)(sp + 4), *(F8B *)(sp + 8));
}

void LOCALF fi_dtformat(PBYTE sp)
{ // dtformat
  *(P4B *)(sp + 8) = (P4B)dtformat(*(P4B *)sp, *(F8B *)(sp + 4));
}

void LOCALF fi_get_system_time(PBYTE sp)
{ // get_system_time
  get_system_time(*(P4B *)sp);
}

void LOCALF fi_get_local_time(PBYTE sp)
{ // get_local_time
  get_local_time(*(P4B *)sp);
}

void LOCALF fi_get_tick_count(PBYTE sp)
{ // get_tick_count
  *(U4B *)(sp - 4) = get_tick_count();
}

void LOCALF fi_wait_millisec(PBYTE sp)
{ // wait_millisec
  wait_millisec(*(I4B *)sp);
}

void LOCALF fi_compare_file_time(PBYTE sp)
{ // compare_file_time
  *(I4B *)(sp + 4) = compare_file_time(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_file_time_to_system_time(PBYTE sp)
{ // file_time_to_system_time
  *(I4B *)(sp + 4) = file_time_to_system_time(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_system_time_to_file_time(PBYTE sp)
{ // system_time_to_file_time
  *(I4B *)(sp + 4) = system_time_to_file_time(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_check_path(PBYTE sp)
{ // check_path
  *(I4B *)sp = check_path(*(P4B *)sp);
}

void LOCALF fi_change_path(PBYTE sp)
{ // change_path
  *(P4B *)(sp + 8) = change_path(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_open_file(PBYTE sp)
{ // open_file
  *(P4B *)(sp + 4) = open_file(*(P4B *)sp, *(U4B *)(sp + 4));
}

void LOCALF fi_close_file(PBYTE sp)
{ // close_file
  *(I4B *)sp = close_file(*(P4B *)sp);
}

void LOCALF fi_set_file_ptr(PBYTE sp)
{ // set_file_ptr
  *(U4B *)(sp + 8) = set_file_ptr(*(P4B *)sp, *(I4B *)(sp + 4), *(U4B *)(sp + 8));
}

void LOCALF fi_set_end_of_file(PBYTE sp)
{ // set_end_of_file
  *(I4B *)sp = set_end_of_file(*(P4B *)sp);
}

void LOCALF fi_get_file_size(PBYTE sp)
{ // get_file_size
  *(U4B *)sp = get_file_size(*(P4B *)sp);
}

void LOCALF fi_read_file(PBYTE sp)
{ // read_file
  *(I4B *)(sp + 8) = read_file(*(P4B *)sp, *(P4B *)(sp + 4), *(U4B *)(sp + 8));
}

void LOCALF fi_write_file(PBYTE sp)
{ // write_file
  *(I4B *)(sp + 8) = write_file(*(P4B *)sp, *(P4B *)(sp + 4), *(U4B *)(sp + 8));
}

void LOCALF fi_read_line(PBYTE sp)
{ // read_line
  *(I4B *)(sp + 8) = read_line(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_write_line(PBYTE sp)
{ // write_line
  *(I4B *)(sp + 4) = write_line(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_find_first_file(PBYTE sp)
{ // find_first_file
  *(P4B *)(sp + 4) = find_first_file(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_find_next_file(PBYTE sp)
{ // find_next_file
  *(I4B *)(sp + 4) = find_next_file(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_find_close(PBYTE sp)
{ // find_close
  *(I4B *)sp = find_close(*(P4B *)sp);
}

void LOCALF fi_path_exists(PBYTE sp)
{ // path_exists
  *(I4B *)sp = path_exists(*(P4B *)sp);
}

void LOCALF fi_file_exists(PBYTE sp)
{ // file_exists
  *(I4B *)sp = file_exists(*(P4B *)sp);
}

void LOCALF fi_get_file_info(PBYTE sp)
{ // get_file_info
  *(I4B *)(sp + 4) = get_file_info(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_file_size(PBYTE sp)
{ // file_size
  *(U4B *)sp = file_size(*(P4B *)sp);
}

void LOCALF fi_new_file(PBYTE sp)
{ // new_file
  *(I4B *)sp = new_file(*(P4B *)sp);
}

void LOCALF fi_new_file_if_not_exists(PBYTE sp)
{ // new_file_if_not_exists
  *(I4B *)sp = new_file_if_not_exists(*(P4B *)sp);
}

void LOCALF fi_move_file(PBYTE sp)
{ // move_file
  *(I4B *)(sp + 4) = move_file(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_force_move_file(PBYTE sp)
{ // force_move_file
  *(I4B *)(sp + 4) = force_move_file(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_copy_file(PBYTE sp)
{ // copy_file
  *(I4B *)(sp + 4) = copy_file(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_delete_file(PBYTE sp)
{ // delete_file
  *(I4B *)sp = delete_file(*(P4B *)sp);
}

void LOCALF fi_new_path(PBYTE sp)
{ // new_path
  *(I4B *)sp = new_path(*(P4B *)sp);
}

void LOCALF fi_new_path_if_not_exists(PBYTE sp)
{ // new_path_if_not_exists
  *(I4B *)sp = new_path_if_not_exists(*(P4B *)sp);
}

void LOCALF fi_move_file_to(PBYTE sp)
{ // move_file_to
  *(I4B *)(sp + 4) = move_file_to(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_copy_file_to(PBYTE sp)
{ // copy_file_to
  *(I4B *)(sp + 4) = copy_file_to(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_get_working_path(PBYTE sp)
{ // get_working_path
  get_working_path(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_set_working_path(PBYTE sp)
{ // set_working_path
  *(I4B *)sp = set_working_path(*(P4B *)sp);
}

void LOCALF fi_get_user_name(PBYTE sp)
{ // get_user_name
  get_user_name(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_get_computer_name(PBYTE sp)
{ // get_computer_name
  get_computer_name(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_enmstr(PBYTE sp)
{ // enmstr
  *(P4B *)(sp + 4) = (P4B)enmstr(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_srchenm(PBYTE sp)
{ // srchenm
  *(I4B *)(sp + 4) = srchenm(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_codstr(PBYTE sp)
{ // codstr
  *(P4B *)(sp + 4) = (P4B)codstr(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_srchcod(PBYTE sp)
{ // srchcod
  *(I4B *)(sp + 4) = srchcod(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_register_error_dsc(PBYTE sp)
{ // register_error_descriptions
  *(I4B *)sp = register_error_descriptions(*(P4B *)sp);
}

void LOCALF fi_error_dsc(PBYTE sp)
{ // error_description
  *(P4B *)sp = (P4B)error_description(*(I4B *)sp);
}

void LOCALF fi_set_error_msg_index_base(PBYTE sp)
{ // set_error_message_index_base
  *(I4B *)sp = set_error_message_index_base(*(I4B *)sp);
}

void LOCALF fi_error_msg_index_base(PBYTE sp)
{ // error_message_index_base
  *(I4B *)(sp - 4) = error_message_index_base();
}

void LOCALF fi_set_error_log_file(PBYTE sp)
{ // set_error_log_file
  set_error_log_file(*(P4B *)sp);
}

void LOCALF fi_error_log_file(PBYTE sp)
{ // error_log_file
  *(P4B *)(sp - 4) = (P4B)error_log_file();
}

void LOCALF fi_first_error(PBYTE sp)
{ // first_error
  *(I4B *)(sp - 4) = first_error();
}

void LOCALF fi_last_error(PBYTE sp)
{ // last_error
  *(I4B *)(sp - 4) = last_error();
}

void LOCALF fi_reset_error(PBYTE sp)
{ // reset_error
  reset_error();
}

void LOCALF fi_enable_error_rep(PBYTE sp)
{ // enable_error_reporting
  *(I4B *)(sp - 4) = enable_error_reporting();
}

void LOCALF fi_disable_error_rep(PBYTE sp)
{ // disable_error_reporting
  *(I4B *)(sp - 4) = disable_error_reporting();
}

void LOCALF fi_enable_error_log(PBYTE sp)
{ // enable_error_logging
  *(I4B *)(sp - 4) = enable_error_logging();
}

void LOCALF fi_disable_error_log(PBYTE sp)
{ // disable_error_logging
  *(I4B *)(sp - 4) = disable_error_logging();
}

void LOCALF fi_ierr(PBYTE sp)
{ // ierr
  *(P4B *)sp = throw_error(NULL, *(I4B *)sp, NULL, -1);
}

void LOCALF fi_ferr(PBYTE sp)
{ // ferr
  *(P4B *)(sp + 4) = throw_error(NULL, *(I4B *)sp, *(P4B *)(sp + 4), -1);
}

void LOCALF fi_serr(PBYTE sp)
{ // serr
  *(P4B *)(sp + 12) = throw_error(NULL, *(I4B *)sp, *(P4B *)(sp + 4), MAKEUINT(*(I4B *)(sp + 8), *(I4B *)(sp + 12)));
}

static BFNC fiBAS[1024] = {
  // 000-031
  fi_0,                        fi_sqrt,                     fi_sin,                      fi_cos,
  fi_tan,                      fi_asin,                     fi_acos,                     fi_atan,
  fi_atan2,                    fi_exp,                      fi_pow,                      fi_log,
  fi_log10,                    fi_ceil,                     fi_floor,                    fi_fabs,
  fi_abs,                      fi_atoi,                     fi_atof,                     fi_rand,
  fi_srand,                    fi_calloc,                   fi_malloc,                   fi_hrealloc,
  fi_free,                     fi_memchr,                   fi_memcmp,                   fi_memcpy,
  fi_memmove,                  fi_memset,                   fi_strchr,                   fi_strcmp,
  // 032-063
  fi_stricmp,                  fi_strncmp,                  fi_strnicmp,                 fi_strcpy,
  fi_strcat,                   fi_strlen,                   fi_strspn,                   fi_strtoul,
  fi_sprintf,                  fi_atoi64,                   fi_strtoui64,                fi_0, /* 043 */
  fi_sign,                     fi_iround,                   fi_hash,                     fi_nbound,
  fi_halloc,                   fi_hrealloc,                 fi_hfree,                    fi_talloc,
  fi_ualloc,                   fi_isspc,                    fi_isctl,                    fi_isdig,
  fi_isodig,                   fi_isxdig,                   fi_isupr,                    fi_islwr,
  fi_isalp,                    fi_isalpx,                   fi_isaln,                    fi_isalnx,
  // 064-095
  fi_isasc,                    fi_ishan,                    fi_isprn,                    fi_iszen1,
  fi_iszen2,                   fi_iszen,                    fi_spncpy,                   fi_strcpyn,
  fi_strcpyx,                  fi_nthzen1,                  fi_nthyen,                   fi_mbschr,
  fi_mbsrchr,                  fi_mbslen,                   fi_strfind,                  fi_strlfind,
  fi_strrfind,                 fi_strifind,                 fi_strilfind,                fi_strirfind,
  fi_strmatch,                 fi_strcount,                 fi_tozen,                    fi_tohan,
  fi_toupr,                    fi_tolwr,                    fi_tohira,                   fi_tokata,
  fi_ltrim,                    fi_rtrim,                    fi_btrim,                    fi_delspc,
  // 096-127
  fi_delctl,                   fi_ctlspc,                   fi_cipher,                   fi_inscma,
  fi_delcma,                   fi_strlike,                  fi_strmlike,                 fi_strllike,
  fi_strrlike,                 fi_midstr,                   fi_strrepl,                  fi_strconc,
  fi_csprintf,                 fi_format,                   fi_cformat,                  fi_ztoi,
  fi_ztou,                     fi_ztoi64,                   fi_ztou64,                   fi_ztof,
  fi_cztoi,                    fi_cztou,                    fi_cztoi64,                  fi_cztou64,
  fi_cztof,                    fi_is_leap_year,             fi_days_of_month,            fi_day_of_week,
  fi_date_serial,              fi_year,                     fi_month,                    fi_day,
  // 128-159
  fi_youbi,                    fi_era_year,                 fi_today,                    fi_date_diff,
  fi_ztod,                     fi_ztod2,                    fi_ztom,                     fi_dprintf,
  fi_dformat,                  fi_time_serial,              fi_hour,                     fi_minute,
  fi_second,                   fi_ztot,                     fi_tprintf,                  fi_tformat,
  fi_now,                      fi_ztodt,                    fi_dtprintf,                 fi_dtformat,
  fi_get_system_time,          fi_get_local_time,           fi_get_tick_count,           fi_wait_millisec,
  fi_compare_file_time,        fi_file_time_to_system_time, fi_system_time_to_file_time, fi_check_path,
  fi_change_path,              fi_open_file,                fi_close_file,               fi_set_file_ptr,
  // 160-191
  fi_set_end_of_file,          fi_get_file_size,            fi_read_file,                fi_write_file,
  fi_read_line,                fi_write_line,               fi_find_first_file,          fi_find_next_file,
  fi_find_close,               fi_path_exists,              fi_file_exists,              fi_get_file_info,
  fi_file_size,                fi_new_file,                 fi_new_file_if_not_exists,   fi_move_file,
  fi_force_move_file,          fi_copy_file,                fi_delete_file,              fi_new_path,
  fi_new_path_if_not_exists,   fi_move_file_to,             fi_copy_file_to,             fi_get_working_path,
  fi_set_working_path,         fi_get_user_name,            fi_get_computer_name,        fi_enmstr,
  fi_srchenm,                  fi_codstr,                   fi_srchcod,                  fi_register_error_dsc,
  // 192-219
  fi_error_dsc,                fi_set_error_msg_index_base, fi_error_msg_index_base,     fi_set_error_log_file,
  fi_error_log_file,           fi_first_error,              fi_last_error,               fi_reset_error,
  fi_enable_error_rep,         fi_disable_error_rep,        fi_enable_error_log,         fi_disable_error_log,
  fi_ierr,                     fi_ferr,                     fi_serr,                     fi_0, /* 207 */
  fi_0, /* 208 */              fi_0, /* 209 */              fi_0, /* 210 */              fi_0, /* 211 */
  fi_0, /* 212 */              fi_0, /* 213 */              fi_0, /* 214 */              fi_0, /* 215 */
  fi_0, /* 216 */              fi_0, /* 217 */              fi_0, /* 218 */              fi_0, /* 219 */
};
static BFNS fsBAS = { fiBAS, NELEM(fiBAS) };

BOOL WINAPI RegisterAPIs(PCBFNS bf)
{ // rgC֐̓o^
  int i;

  for (i = 0; i < fsBAS.ni; i++) {
    if (!fsBAS.fn[i]) break;
  }
  if (bf->ni >= fsBAS.ni - i) return (BOOL)ierr(E_CAP);
  memcpy(&fsBAS.fn[i], bf->fn, bf->ni * sizeof(BFNC));
  return TRUE;
}

  // oCgR[hs
typedef struct {
  PBYTE sp;
  PBYTE bp;
  PBYTE ss;
  PBYTE se;
  PBYTE cs;
  PBYTE ce;
  PBYTE ds;
  PBYTE de;
  PBYTE es;
  PBYTE ee;
  PBYTE fs;
  PBYTE fe;
  PCBFNS bf;
  PCCFNS cf;
} EXEE;
typedef EXEE * PEXEE;

HEXE WINAPI CreateExecEnv(int ssz, int dsz, int esz, PCBFNS bf, PCCFNS cf)
{ // oCgR[hs̍쐬
  PEXEE xe;

  ssz = (ssz + 7) &~7; if (ssz == 0) return ierr(E_PAR);
  dsz = (dsz + 7) &~7;
  esz = (esz + 7) &~7;
  xe = halloc(sizeof(EXEE) + 8 + dsz + 8 + esz + 8 + ssz + 8, TRUE); if (!xe) return ierr(E_MEM);
  xe->ds = (PBYTE)xe + sizeof(EXEE) + 8;
  xe->de = xe->ds + dsz;
  xe->es = xe->de + 8;
  xe->ee = xe->es + esz;
  xe->ss = xe->ee + 8;
  xe->se = xe->ss + ssz;
  xe->sp = xe->bp = xe->se;
  xe->bf = bf;
  xe->cf = cf;
  return (HEXE)xe;
}

void WINAPI DeleteExecEnv(HEXE xe)
{ // oCgR[hs̍폜
  hfree(xe);
}

void WINAPI SetExecCS(HEXE xe, PCSEGS pc)
{ // R[hZOg̐ݒ
  ((PEXEE)xe)->cs = pc->pb;
  ((PEXEE)xe)->ce = pc->pb + pc->sz;
}

void WINAPI SetExecDS(HEXE xe, PCSEGS pd)
{ // f[^ZOg̐ݒ(l])
  memcpy(((PEXEE)xe)->ds, pd->pb, pd->sz);
}

void WINAPI SetExecFS(HEXE xe, PCSEGS pf)
{ // gf[^ZOg̐ݒ
  ((PEXEE)xe)->fs = pf->pb;
  ((PEXEE)xe)->fe = pf->pb + pf->sz;
}

void WINAPI RelocatePtr(HEXE xe, PCRELS pr)
{ // |C^l̏
  PINT pi, pe;
  PBYTE pt;

  for (pi = pr->pi, pe = pi + pr->ni; pi < pe; pi++) {
    pt = ((PEXEE)xe)->ds + *pi;
    switch (*(U4B *)pt & 0xff000000) {
    case REL_DAT: *(P4B *)pt = ((PEXEE)xe)->ds + (*(U4B *)pt & 0x00ffffff); break;
    case REL_BSS: *(P4B *)pt = ((PEXEE)xe)->es + (*(U4B *)pt & 0x00ffffff); break;
    case REL_AUX: *(P4B *)pt = ((PEXEE)xe)->fs + (*(U4B *)pt & 0x00ffffff); break;
    default: ierr(E_BCD);
    }
  }
}

PCVOID LOCALF CallExecM(HEXE xe, int ofs, int asz, int bsz)
{ // oCgR[hs}V
  I4B ix; U4B ux; P4B ad;
  I8B lx; F8B fx;
  PBYTE cp, sp, bp;
  PCFNI fn;

  if (asz % 4) ierr(E_EXE);
  if (bsz % 4) ierr(E_EXE);
  cp = ((PEXEE)xe)->cs + ofs;
  sp = (bp = ((PEXEE)xe)->sp) - bsz;
  for (;;) {
    switch (*cp++) {
    case nop_v:
      break;
    case drp_i:
      sp += 4; break;
    case drp_d:
      sp += 8; break;
    case dup_i:
      *(I4B *)(sp - 4) = *(I4B *)sp; sp -= 4; break;
    case dup_d:
      *(F8B *)(sp - 8) = *(F8B *)sp; sp -= 8; break;
    case swp_i:
      ix = *(I4B *)sp; *(I4B *)sp = *(I4B *)(sp + 4); *(I4B *)(sp + 4) = ix; break;
    case swp_d:
      fx = *(F8B *)sp; *(F8B *)sp = *(F8B *)(sp + 8); *(F8B *)(sp + 8) = fx; break;
    case swp_i_d:
      fx = *(F8B *)sp; *(I4B *)sp = *(I4B *)(sp + 8); *(F8B *)(sp + 4) = fx; break;
    case swp_d_i:
      fx = *(F8B *)(sp + 4); *(I4B *)(sp + 8) = *(I4B *)sp; *(F8B *)sp = fx; break;
    case jeq_i_0:
      if (*(I4B *)sp == 0) cp += (2 + *(I2B *)cp);  else cp += 2;
      sp += 4; break;
    case jne_i_0:
      if (*(I4B *)sp != 0) cp += (2 + *(I2B *)cp);  else cp += 2;
      sp += 4; break;
    case jan_i:
      if (*(I4B *)sp == 0) cp += (2 + *(I2B *)cp);  else { sp += 4; cp += 2;}
      break;
    case jor_i:
      if (*(I4B *)sp != 0) cp += (2 + *(I2B *)cp);  else { sp += 4; cp += 2;}
      break;
    case jmp_v:
     cp += (2 + *(I2B *)cp); break;
    case psh_bs:
      if (bp - *(I2B *)cp <= ((PEXEE)xe)->ss || bp - *(I2B *)cp > ((PEXEE)xe)->se) { ierr(E_STK); goto _L1;}
      *(P4B *)(sp -= 4) = bp - *(I2B *)cp; cp += 2; break;
    case psh_c:
      *(I4B *)(sp -= 4) = *(I1B *)cp; cp++; break;
    case psh_b:
      *(I4B *)(sp -= 4) = *(U1B *)cp; cp++; break;
    case psh_s:
      *(I4B *)(sp -= 4) = *(I2B *)cp; cp += 2; break;
    case psh_w:
      *(I4B *)(sp -= 4) = *(U2B *)cp; cp += 2; break;
    case psh_i:
      *(I4B *)(sp -= 4) = *(I4B *)cp; cp += 4; break;
    case psh_l:
      *(I8B *)(sp -= 8) = *(I8B *)cp; cp += 8; break;
    case psh_f:
      *(F8B *)(sp -= 8) = *(F4B *)cp; cp += 4; break;
    case psh_d:
      *(F8B *)(sp -= 8) = *(F8B *)cp; cp += 8; break;
    case psh_i_0:
      *(I4B *)(sp -= 4) = 0; break;
    case psh_d_0:
      *(F8B *)(sp -= 8) = 0.0; break;
    case psh_dw:
      if (((PEXEE)xe)->ds + *(U2B *)cp >= ((PEXEE)xe)->de) { ierr(E_SEG); goto _L1;}
      *(P4B *)(sp -= 4) = ((PEXEE)xe)->ds + *(U2B *)cp; cp += 2; break;
    case psh_du:
      if (((PEXEE)xe)->ds + *(U4B *)cp >= ((PEXEE)xe)->de) { ierr(E_SEG); goto _L1;}
      *(P4B *)(sp -= 4) = ((PEXEE)xe)->ds + *(U4B *)cp; cp += 4; break;
    case psh_ew:
      if (((PEXEE)xe)->es + *(U2B *)cp >= ((PEXEE)xe)->ee) { ierr(E_SEG); goto _L1;}
      *(P4B *)(sp -= 4) = ((PEXEE)xe)->es + *(U2B *)cp; cp += 2; break;
    case psh_eu:
      if (((PEXEE)xe)->es + *(U4B *)cp >= ((PEXEE)xe)->ee) { ierr(E_SEG); goto _L1;}
      *(P4B *)(sp -= 4) = ((PEXEE)xe)->es + *(U4B *)cp; cp += 4; break;
    case psh_fw:
      if (((PEXEE)xe)->fs + *(U2B *)cp >= ((PEXEE)xe)->fe) { ierr(E_SEG); goto _L1;}
      *(P4B *)(sp -= 4) = ((PEXEE)xe)->fs + *(U2B *)cp; cp += 2; break;
    case psh_fu:
      if (((PEXEE)xe)->fs + *(U4B *)cp >= ((PEXEE)xe)->fe) { ierr(E_SEG); goto _L1;}
      *(P4B *)(sp -= 4) = ((PEXEE)xe)->fs + *(U4B *)cp; cp += 4; break;
    case fch_c:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I1B *)*(P4B *)sp; break;
    case fch_b:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(U1B *)*(P4B *)sp; break;
    case fch_s:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I2B *)*(P4B *)sp; break;
    case fch_w:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(U2B *)*(P4B *)sp; break;
    case fch_i:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I4B *)*(P4B *)sp; break;
    case fch_l:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I8B *)(sp - 4) = *(I8B *)*(P4B *)sp; sp -= 4; break;
    case fch_f:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(F8B *)(sp - 4) = *(F4B *)*(P4B *)sp; sp -= 4; break;
    case fch_d:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(F8B *)(sp - 4) = *(F8B *)*(P4B *)sp; sp -= 4; break;
    case bwn_i:
      *(I4B *)sp = ~(*(I4B *)sp); break;
    case bwn_l:
      *(I8B *)sp = ~(*(I8B *)sp); break;
    case bwa_i:
      *(I4B *)(sp + 4) &= *(I4B *)sp; sp += 4; break;
    case bwa_l:
      *(I8B *)(sp + 8) &= *(I8B *)sp; sp += 8; break;
    case bwo_i:
      *(I4B *)(sp + 4) |= *(I4B *)sp; sp += 4; break;
    case bwo_l:
      *(I8B *)(sp + 8) |= *(I8B *)sp; sp += 8; break;
    case bwx_i:
      *(I4B *)(sp + 4) ^= *(I4B *)sp; sp += 4; break;
    case bwx_l:
      *(I8B *)(sp + 8) ^= *(I8B *)sp; sp += 8; break;
    case poi_c:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I1B *)ad; (*(I1B *)ad)++; break;
    case poi_b:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(U1B *)ad; (*(U1B *)ad)++; break;
    case poi_s:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I2B *)ad; (*(I2B *)ad)++; break;
    case poi_w:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(U2B *)ad; (*(U2B *)ad)++; break;
    case poi_i:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I4B *)ad; (*(I4B *)ad)++; break;
    case poi_l:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I8B *)(sp - 4) = *(I8B *)ad; (*(I8B *)ad)++; sp -= 4; break;
    case poi_p:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(P4B *)sp = *(P4B *)ad; (I1B *)*(P4B *)ad += *(U2B *)cp; cp += 2; break;
    case cpy_p:
      if (!*(P4B *)(sp + 4) || !*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(P4B *)(sp + 4) = memcpy(*(P4B *)(sp + 4), *(P4B *)sp, *(U2B *)cp); sp += 4; cp += 2; break;
    case add_i:
      *(I4B *)(sp + 4) += *(I4B *)sp; sp += 4; break;
    case add_l:
      *(I8B *)(sp + 8) += *(I8B *)sp; sp += 8; break;
    case add_d:
      *(F8B *)(sp + 8) += *(F8B *)sp; sp += 8; break;
    case add_p_i:
      (I1B *)*(P4B *)(sp + 4) += (*(I4B *)sp * *(U2B *)cp); sp += 4; cp += 2; break;
    case add_i_p:
      *(P4B *)(sp + 4) = (I1B *)*(P4B *)sp + (*(I4B *)(sp + 4) * *(U2B *)cp); sp += 4; cp += 2; break;
    case mul_i:
      *(I4B *)(sp + 4) *= *(I4B *)sp; sp += 4; break;
    case mul_l:
      *(I8B *)(sp + 8) *= *(I8B *)sp; sp += 8; break;
    case mul_d:
      *(F8B *)(sp + 8) *= *(F8B *)sp; sp += 8; break;
    case pod_c:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I1B *)ad; (*(I1B *)ad)--; break;
    case pod_b:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(U1B *)ad; (*(U1B *)ad)--; break;
    case pod_s:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I2B *)ad; (*(I2B *)ad)--; break;
    case pod_w:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(U2B *)ad; (*(U2B *)ad)--; break;
    case pod_i:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I4B *)sp = *(I4B *)ad; (*(I4B *)ad)--; break;
    case pod_l:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(I8B *)(sp - 4) = *(I8B *)ad; (*(I8B *)ad)--; sp -= 4; break;
    case pod_p:
      ad = *(P4B *)sp;
      if (!ad) { ierr(E_NUL); goto _L1;}
      *(P4B *)sp = *(P4B *)ad; (I1B *)*(P4B *)ad -= *(U2B *)cp; cp += 2; break;
    case set_p_0:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(P4B *)sp = memset(*(P4B *)sp, 0, *(U2B *)cp); cp += 2; break;
    case sub_i:
      *(I4B *)(sp + 4) -= *(I4B *)sp; sp += 4; break;
    case sub_l:
      *(I8B *)(sp + 8) -= *(I8B *)sp; sp += 8; break;
    case sub_d:
      *(F8B *)(sp + 8) -= *(F8B *)sp; sp += 8; break;
    case sub_p_i:
      (I1B *)*(P4B *)(sp + 4) -= (*(I4B *)sp * *(U2B *)cp); sp += 4; cp += 2; break;
    case sub_p:
      *(I4B *)(sp + 4) = ((I1B *)*(P4B *)(sp + 4) - (I1B *)*(P4B *)sp) / *(U2B *)cp; sp += 4; cp += 2; break;
    case div_i:
      if (*(I4B *)sp == 0) { ierr(E_DIV); goto _L1;}
      *(I4B *)(sp + 4) /= *(I4B *)sp; sp += 4; break;
    case div_l:
      if (*(I8B *)sp == 0LL) { ierr(E_DIV); goto _L1;}
      *(I8B *)(sp + 8) /= *(I8B *)sp; sp += 8; break;
    case div_d:
      if (*(F8B *)sp == 0.0) { ierr(E_DIV); goto _L1;}
      *(F8B *)(sp + 8) /= *(F8B *)sp; sp += 8; break;
    case sto_c:
      if (!*(P4B *)(sp + 4)) { ierr(E_NUL); goto _L1;}
      *(I1B *)*(P4B *)(sp + 4) = (I1B)*(I4B *)sp; sp += 4; break;
    case sto_s:
      if (!*(P4B *)(sp + 4)) { ierr(E_NUL); goto _L1;}
      *(I2B *)*(P4B *)(sp + 4) = (I2B)*(I4B *)sp; sp += 4; break;
    case sto_i:
      if (!*(P4B *)(sp + 4)) { ierr(E_NUL); goto _L1;}
      *(I4B *)*(P4B *)(sp + 4) = *(I4B *)sp; sp += 4; break;
    case sto_l:
      if (!*(P4B *)(sp + 8)) { ierr(E_NUL); goto _L1;}
      *(I8B *)*(P4B *)(sp + 8) = *(I8B *)sp; sp += 8; break;
    case sto_f:
      if (!*(P4B *)(sp + 8)) { ierr(E_NUL); goto _L1;}
      *(F4B *)*(P4B *)(sp + 8) = (F4B)*(F8B *)sp; sp += 8; break;
    case sto_d:
      if (!*(P4B *)(sp + 8)) { ierr(E_NUL); goto _L1;}
      *(F8B *)*(P4B *)(sp + 8) = *(F8B *)sp; sp += 8; break;
    case sto_c_v:
      if (!*(P4B *)(sp + 4)) { ierr(E_NUL); goto _L1;}
      *(I1B *)*(P4B *)(sp + 4) = (I1B)*(I4B *)sp; sp += 8; break;
    case sto_s_v:
      if (!*(P4B *)(sp + 4)) { ierr(E_NUL); goto _L1;}
      *(I2B *)*(P4B *)(sp + 4) = (I2B)*(I4B *)sp; sp += 8; break;
    case sto_i_v:
      if (!*(P4B *)(sp + 4)) { ierr(E_NUL); goto _L1;}
      *(I4B *)*(P4B *)(sp + 4) = *(I4B *)sp; sp += 8; break;
    case sto_l_v:
      if (!*(P4B *)(sp + 8)) { ierr(E_NUL); goto _L1;}
      *(I8B *)*(P4B *)(sp + 8) = *(I8B *)sp; sp += 12; break;
    case sto_f_v:
      if (!*(P4B *)(sp + 8)) { ierr(E_NUL); goto _L1;}
      *(F4B *)*(P4B *)(sp + 8) = (F4B)*(F8B *)sp; sp += 12; break;
    case sto_d_v:
      if (!*(P4B *)(sp + 8)) { ierr(E_NUL); goto _L1;}
      *(F8B *)*(P4B *)(sp + 8) = *(F8B *)sp; sp += 12; break;
    case mod_i:
      if (*(I4B *)sp == 0) { ierr(E_DIV); goto _L1;}
      *(I4B *)(sp + 4) %= *(I4B *)sp; sp += 4; break;
    case mod_l:
      if (*(I8B *)sp == 0LL) { ierr(E_DIV); goto _L1;}
      *(I8B *)(sp + 8) %= *(I8B *)sp; sp += 8;  break;
    case mkv_w:
      *(U4B *)(sp + 4) = MAKEWORD(*(U4B *)(sp + 4), *(U4B *)sp); sp += 4; break;
    case mkv_u:
      *(U4B *)(sp + 4) = MAKEUINT(*(U4B *)(sp + 4), *(U4B *)sp); sp += 4; break;
    case inc_c:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I1B *)*(P4B *)sp); break;
    case inc_s:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I2B *)*(P4B *)sp); break;
    case inc_i:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I4B *)*(P4B *)sp); break;
    case inc_l:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I8B *)*(P4B *)sp); break;
    case inc_p:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      (I1B *)*(P4B *)*(P4B *)sp += *(U2B *)cp; cp += 2; break;
    case inc_c_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I1B *)*(P4B *)sp); sp += 4; break;
    case inc_s_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I2B *)*(P4B *)sp); sp += 4; break;
    case inc_i_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I4B *)*(P4B *)sp); sp += 4; break;
    case inc_l_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      ++(*(I8B *)*(P4B *)sp); sp += 4; break;
    case inc_p_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      (I1B *)*(P4B *)*(P4B *)sp += *(U2B *)cp; sp += 4; cp += 2; break;
    case rsh_i:
      *(I4B *)(sp + 4) >>= *(I4B *)sp; sp += 4; break;
    case rsh_u:
      *(U4B *)(sp + 4) >>= *(U4B *)sp; sp += 4; break;
    case rsh_l:
      *(I8B *)(sp + 8) >>= *(I4B *)sp; sp += 4; break;
    case rsh_g:
      *(U8B *)(sp + 8) >>= *(U4B *)sp; sp += 4; break;
    case lsh_i:
      *(I4B *)(sp + 4) <<= *(I4B *)sp; sp += 4; break;
    case lsh_l:
      *(I8B *)(sp + 8) <<= *(I4B *)sp; sp += 4; break;
    case dec_c:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I1B *)*(P4B *)sp); break;
    case dec_s:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I2B *)*(P4B *)sp); break;
    case dec_i:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I4B *)*(P4B *)sp); break;
    case dec_l:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I8B *)*(P4B *)sp); break;
    case dec_p:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      (I1B *)*(P4B *)*(P4B *)sp -= *(U2B *)cp; cp += 2; break;
    case dec_c_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I1B *)*(P4B *)sp); sp += 4; break;
    case dec_s_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I2B *)*(P4B *)sp); sp += 4; break;
    case dec_i_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I4B *)*(P4B *)sp); sp += 4; break;
    case dec_l_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      --(*(I8B *)*(P4B *)sp); sp += 4; break;
    case dec_p_v:
      if (!*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      (I1B *)*(P4B *)*(P4B *)sp -= *(U2B *)cp; sp += 4; cp += 2; break;
    case cfn_i:
      ix = *(U2B *)(cp + 2); ((PEXEE)xe)->sp = sp;
      fn = &((PEXEE)xe)->cf->fn[*(U2B *)cp]; CallExecM(xe, fn->ofs, ix, fn->bsz);
      sp += (ix - 4); cp += 4; break;
    case cfn_d:
      ix = *(U2B *)(cp + 2); ((PEXEE)xe)->sp = sp;
      fn = &((PEXEE)xe)->cf->fn[*(U2B *)cp]; CallExecM(xe, fn->ofs, ix, fn->bsz);
      sp += (ix - 8); cp += 4; break;
    case cfn_v:
      ix = *(U2B *)(cp + 2); ((PEXEE)xe)->sp = sp;
      fn = &((PEXEE)xe)->cf->fn[*(U2B *)cp]; CallExecM(xe, fn->ofs, ix, fn->bsz);
      sp += ix; cp += 4; break;
    case bfn_i:
      ix = *(U2B *)(cp + 2); ((PEXEE)xe)->sp = sp;
      ((PEXEE)xe)->bf->fn[*(U2B *)cp](sp);
      sp += (ix - 4); cp += 4; break;
    case bfn_d:
      ix = *(U2B *)(cp + 2); ((PEXEE)xe)->sp = sp;
      ((PEXEE)xe)->bf->fn[*(U2B *)cp](sp);
      sp += (ix - 8); cp += 4; break;
    case bfn_v:
      ix = *(U2B *)(cp + 2); ((PEXEE)xe)->sp = sp;
      ((PEXEE)xe)->bf->fn[*(U2B *)cp](sp);
      sp += ix; cp += 4; break;
    case pfn_i:
      ix = *(U2B *)cp; ux = *(U4B *)(sp + ix); ((PEXEE)xe)->sp = sp;
      switch (ux & 0xffff0000) {
      case FTP_BFN: ((PEXEE)xe)->bf->fn[(U2B)ux](sp); break;
      case FTP_CFN: fn = &((PEXEE)xe)->cf->fn[(U2B)ux]; CallExecM(xe, fn->ofs, ix, fn->bsz); break;
      default: ierr(E_ORD); goto _L1;
      }
      *(I4B *)(sp + ix) = *(I4B *)(sp + ix - 4);
      sp += ix; cp += 2; break;
    case pfn_d:
      ix = *(U2B *)cp; ux = *(U4B *)(sp + ix); ((PEXEE)xe)->sp = sp;
      switch (ux & 0xffff0000) {
      case FTP_BFN: ((PEXEE)xe)->bf->fn[(U2B)ux](sp); break;
      case FTP_CFN: fn = &((PEXEE)xe)->cf->fn[(U2B)ux]; CallExecM(xe, fn->ofs, ix, fn->bsz); break;
      default: ierr(E_ORD); goto _L1;
      }
      *(F8B *)(sp + ix - 4) = *(F8B *)(sp + ix - 8);
      sp += (ix - 4); cp += 2; break;
    case pfn_v:
      ix = *(U2B *)cp; ux = *(U4B *)(sp + ix); ((PEXEE)xe)->sp = sp;
      switch (ux & 0xffff0000) {
      case FTP_BFN: ((PEXEE)xe)->bf->fn[(U2B)ux](sp); break;
      case FTP_CFN: fn = &((PEXEE)xe)->cf->fn[(U2B)ux]; CallExecM(xe, fn->ofs, ix, fn->bsz); break;
      default: ierr(E_ORD); goto _L1;
      }
      sp += (ix + 4); cp += 2; break;
    case ret_i:
      ad = bp + asz - 4; *(I4B *)ad = *(I4B *)sp; sp = ad; goto _L1;
    case ret_d:
      ad = bp + asz - 8; *(F8B *)ad = *(F8B *)sp; sp = ad; goto _L1;
    case ret_v:
      sp = bp + asz; goto _L1;
    case cmp_p:
      if (!*(P4B *)(sp + 4) || !*(P4B *)sp) { ierr(E_NUL); goto _L1;}
      *(I4B *)(sp + 4) = memcmp(*(P4B *)(sp + 4), *(P4B *)sp, *(U2B *)cp); sp += 4; cp += 2; break;
    case neg_i:
      *(I4B *)sp = -(*(I4B *)sp); break;
    case neg_l:
      *(I8B *)sp = -(*(I8B *)sp); break;
    case neg_d:
      *(F8B *)sp = -(*(F8B *)sp); break;
    case cnv_i_c:
      *(I4B *)sp = (I1B)*(I4B *)sp; break;
    case cnv_i_b:
      *(I4B *)sp = (U1B)*(I4B *)sp; break;
    case cnv_i_s:
      *(I4B *)sp = (I2B)*(I4B *)sp; break;
    case cnv_i_w:
      *(I4B *)sp = (U2B)*(I4B *)sp; break;
    case cnv_i_l:
      *(I8B *)(sp - 4) = (I8B)*(I4B *)sp; sp -= 4; break;
    case cnv_i_f:
      *(F8B *)(sp - 4) = (F4B)*(I4B *)sp; sp -= 4; break;
    case cnv_i_d:
      *(F8B *)(sp - 4) = (F8B)*(I4B *)sp; sp -= 4; break;
    case cnv_u_l:
      *(I8B *)(sp - 4) = (I8B)*(U4B *)sp; sp -= 4; break;
    case cnv_u_d:
      *(F8B *)(sp - 4) = (F8B)*(U4B *)sp; sp -= 4; break;
    case cnv_l_c:
      *(I4B *)(sp + 4) = (I1B)*(I8B *)sp; sp += 4; break;
    case cnv_l_b:
      *(I4B *)(sp + 4) = (U1B)*(I8B *)sp; sp += 4; break;
    case cnv_l_s:
      *(I4B *)(sp + 4) = (I2B)*(I8B *)sp; sp += 4; break;
    case cnv_l_w:
      *(I4B *)(sp + 4) = (U2B)*(I8B *)sp; sp += 4; break;
    case cnv_l_i:
      *(I4B *)(sp + 4) = (I4B)*(I8B *)sp; sp += 4; break;
    case cnv_l_u:
      *(U4B *)(sp + 4) = (U4B)*(I8B *)sp; sp += 4; break;
    case cnv_l_f:
      *(F8B *)sp = (F4B)*(I8B *)sp; break;
    case cnv_l_d:
      *(F8B *)sp = (F8B)*(I8B *)sp; break;
    case cnv_g_d:
      *(F8B *)sp = (F8B)*(U8B *)sp; break;
    case cnv_d_c:
      *(I4B *)(sp + 4) = (I1B)*(F8B *)sp; sp += 4; break;
    case cnv_d_b:
      *(I4B *)(sp + 4) = (U1B)*(F8B *)sp; sp += 4; break;
    case cnv_d_s:
      *(I4B *)(sp + 4) = (I2B)*(F8B *)sp; sp += 4; break;
    case cnv_d_w:
      *(I4B *)(sp + 4) = (U2B)*(F8B *)sp; sp += 4; break;
    case cnv_d_i:
      *(I4B *)(sp + 4) = (I4B)*(F8B *)sp; sp += 4; break;
    case cnv_d_u:
      *(U4B *)(sp + 4) = (U4B)*(F8B *)sp; sp += 4; break;
    case cnv_d_l:
      *(I8B *)sp = (I8B)*(F8B *)sp; break;
    case cnv_d_f:
      *(F8B *)sp = (F4B)*(F8B *)sp; break;
    case cnv_si_l:
      lx = *(I8B *)sp; *(I8B *)(sp + 4) = (I8B)*(I4B *)(sp + 8); *(I8B *)(sp -= 4) = lx; break;
    case cnv_si_d:
      lx = *(I8B *)sp; *(F8B *)(sp + 4) = (F8B)*(I4B *)(sp + 8); *(I8B *)(sp -= 4) = lx; break;
    case cnv_su_l:
      lx = *(I8B *)sp; *(I8B *)(sp + 4) = (I8B)*(U4B *)(sp + 8); *(I8B *)(sp -= 4) = lx; break;
    case cnv_su_d:
      lx = *(I8B *)sp; *(F8B *)(sp + 4) = (F8B)*(U4B *)(sp + 8); *(I8B *)(sp -= 4) = lx; break;
    case cnv_sl_d:
      *(F8B *)(sp + 8) = (F8B)*(I8B *)(sp + 8); break;
    case cnv_sg_d:
      *(F8B *)(sp + 8) = (F8B)*(U8B *)(sp + 8); break;
    case lt_i:
      *(I4B *)(sp + 4) = (*(I4B *)(sp + 4) < *(I4B *)sp); sp += 4; break;
    case lt_u:
      *(I4B *)(sp + 4) = (*(U4B *)(sp + 4) < *(U4B *)sp); sp += 4; break;
    case lt_l:
      *(I4B *)(sp +12) = (*(I8B *)(sp + 8) < *(I8B *)sp); sp +=12; break;
    case lt_g:
      *(I4B *)(sp +12) = (*(U8B *)(sp + 8) < *(U8B *)sp); sp +=12; break;
    case lt_d:
      *(I4B *)(sp +12) = (*(F8B *)(sp + 8) < *(F8B *)sp); sp +=12; break;
    case lt_i_0:
      *(I4B *)sp = (*(I4B *)sp < 0); break;
    case lt_l_0:
      *(I4B *)(sp + 4) = (*(I8B *)sp < 0LL); sp += 4; break;
    case lt_d_0:
      *(I4B *)(sp + 4) = (*(F8B *)sp < 0.0); sp += 4; break;
    case le_i:
      *(I4B *)(sp + 4) = (*(I4B *)(sp + 4) <= *(I4B *)sp); sp += 4; break;
    case le_u:
      *(I4B *)(sp + 4) = (*(U4B *)(sp + 4) <= *(U4B *)sp); sp += 4; break;
    case le_l:
      *(I4B *)(sp +12) = (*(I8B *)(sp + 8) <= *(I8B *)sp); sp +=12; break;
    case le_g:
      *(I4B *)(sp +12) = (*(U8B *)(sp + 8) <= *(U8B *)sp); sp +=12; break;
    case le_d:
      *(I4B *)(sp +12) = (*(F8B *)(sp + 8) <= *(F8B *)sp); sp +=12; break;
    case le_i_0:
      *(I4B *)sp = (*(I4B *)sp <= 0); break;
    case le_l_0:
      *(I4B *)(sp + 4) = (*(I8B *)sp <= 0LL); sp += 4; break;
    case le_d_0:
      *(I4B *)(sp + 4) = (*(F8B *)sp <= 0.0); sp += 4; break;
    case gt_i:
      *(I4B *)(sp + 4) = (*(I4B *)(sp + 4) > *(I4B *)sp); sp += 4; break;
    case gt_u:
      *(I4B *)(sp + 4) = (*(U4B *)(sp + 4) > *(U4B *)sp); sp += 4; break;
    case gt_l:
      *(I4B *)(sp +12) = (*(I8B *)(sp + 8) > *(I8B *)sp); sp +=12; break;
    case gt_g:
      *(I4B *)(sp +12) = (*(U8B *)(sp + 8) > *(U8B *)sp); sp +=12; break;
    case gt_d:
      *(I4B *)(sp +12) = (*(F8B *)(sp + 8) > *(F8B *)sp); sp +=12; break;
    case gt_i_0:
      *(I4B *)sp = (*(I4B *)sp > 0); break;
    case gt_l_0:
      *(I4B *)(sp + 4) = (*(I8B *)sp > 0LL); sp += 4; break;
    case gt_d_0:
      *(I4B *)(sp + 4) = (*(F8B *)sp > 0.0); sp += 4; break;
    case ge_i:
      *(I4B *)(sp + 4) = (*(I4B *)(sp + 4) >= *(I4B *)sp); sp += 4; break;
    case ge_u:
      *(I4B *)(sp + 4) = (*(U4B *)(sp + 4) >= *(U4B *)sp); sp += 4; break;
    case ge_l:
      *(I4B *)(sp +12) = (*(I8B *)(sp + 8) >= *(I8B *)sp); sp +=12; break;
    case ge_g:
      *(I4B *)(sp +12) = (*(U8B *)(sp + 8) >= *(U8B *)sp); sp +=12; break;
    case ge_d:
      *(I4B *)(sp +12) = (*(F8B *)(sp + 8) >= *(F8B *)sp); sp +=12; break;
    case ge_i_0:
      *(I4B *)sp = (*(I4B *)sp >= 0); break;
    case ge_l_0:
      *(I4B *)(sp + 4) = (*(I8B *)sp >= 0LL); sp += 4; break;
    case ge_d_0:
      *(I4B *)(sp + 4) = (*(F8B *)sp >= 0.0); sp += 4; break;
    case eq_i:
      *(I4B *)(sp + 4) = (*(I4B *)(sp + 4) == *(I4B *)sp); sp += 4; break;
    case eq_l:
      *(I4B *)(sp +12) = (*(I8B *)(sp + 8) == *(I8B *)sp); sp +=12; break;
    case eq_d:
      *(I4B *)(sp +12) = (*(F8B *)(sp + 8) == *(F8B *)sp); sp +=12; break;
    case eq_i_0:
      *(I4B *)sp = (*(I4B *)sp == 0); break;
    case eq_d_0:
      *(I4B *)(sp + 4) = (*(F8B *)sp == 0.0); sp += 4; break;
    case ne_i:
      *(I4B *)(sp + 4) = (*(I4B *)(sp + 4) != *(I4B *)sp); sp += 4; break;
    case ne_l:
      *(I4B *)(sp +12) = (*(I8B *)(sp + 8) != *(I8B *)sp); sp +=12; break;
    case ne_d:
      *(I4B *)(sp +12) = (*(F8B *)(sp + 8) != *(F8B *)sp); sp +=12; break;
    case ne_i_0:
      *(I4B *)sp = (*(I4B *)sp != 0); break;
    case ne_d_0:
      *(I4B *)(sp + 4) = (*(F8B *)sp != 0.0); sp += 4; break;
    default:
      ierr(E_OPC); goto _L1;
    }
    if (sp <= ((PEXEE)xe)->ss || sp > ((PEXEE)xe)->se) { ierr(E_STK); goto _L1;}
    if (cp < ((PEXEE)xe)->cs || cp >= ((PEXEE)xe)->ce) { ierr(E_SEG); goto _L1;}
  }
 _L1: ((PEXEE)xe)->sp = sp;
  return sp;
}

void WINAPI CallExecX(PVOID pv, HEXE xe, int ofs, PCVOID arg, int asz, int bsz)
{ // ItZbgwŃ[U[`֐Ăяo
  PBYTE bp;

  bp = ((PEXEE)xe)->bp = ((PEXEE)xe)->sp;
  if (asz) memcpy(((PEXEE)xe)->sp -= asz, arg, asz);
  CallExecM(xe, ofs, asz, bsz);
  switch (bp - ((PEXEE)xe)->sp) {
  case 0: return;
  case 4: *(I4B *)pv = *(I4B *)((PEXEE)xe)->sp; break;
  case 8: *(F8B *)pv = *(F8B *)((PEXEE)xe)->sp; break;
  default: ierr(E_EXE); break;
  }
  ((PEXEE)xe)->sp = bp;
}

void WINAPI CallExecV(PVOID pv, HEXE xe, int ent, PCVOID arg, int asz)
{ // wŃ[U[`֐Ăяo(ψ)
  PCFNI fn = &((PEXEE)xe)->cf->fn[(U2B)ent]; CallExecX(pv, xe, fn->ofs, arg, asz, fn->bsz);
}

void WINAPI CallExec(PVOID pv, HEXE xe, int ent, PCVOID arg)
{ // wŃ[U[`֐Ăяo(Œ)
  PCFNI fn = &((PEXEE)xe)->cf->fn[(U2B)ent]; CallExecX(pv, xe, fn->ofs, arg, fn->asz, fn->bsz);
}

static int  OIE[] = {
  MAKEUINT(jeq_i_0, 0x0003), MAKEUINT(jne_i_0, 0x0003), MAKEUINT(jan_i,   0x0003), MAKEUINT(jor_i,   0x0003),
  MAKEUINT(jmp_v,   0x0003), MAKEUINT(psh_bs,  0x0003), MAKEUINT(psh_c,   0x0001), MAKEUINT(psh_b,   0x0002),
  MAKEUINT(psh_s,   0x0003), MAKEUINT(psh_w,   0x0004), MAKEUINT(psh_i,   0x0005), MAKEUINT(psh_l,   0x0007),
  MAKEUINT(psh_f,   0x0009), MAKEUINT(psh_d,   0x000a), MAKEUINT(psh_dw,  0x0004), MAKEUINT(psh_du,  0x0006),
  MAKEUINT(psh_ew,  0x0004), MAKEUINT(psh_eu,  0x0006), MAKEUINT(psh_fw,  0x0004), MAKEUINT(psh_fu,  0x0006),
  MAKEUINT(poi_p,   0x0004), MAKEUINT(cpy_p,   0x0004), MAKEUINT(add_p_i, 0x0004), MAKEUINT(add_i_p, 0x0004),
  MAKEUINT(pod_p,   0x0004), MAKEUINT(set_p_0, 0x0004), MAKEUINT(sub_p_i, 0x0004), MAKEUINT(sub_p,   0x0004),
  MAKEUINT(inc_p,   0x0004), MAKEUINT(inc_p_v, 0x0004), MAKEUINT(dec_p,   0x0004), MAKEUINT(dec_p_v, 0x0004),
  MAKEUINT(cfn_i,   0x0044), MAKEUINT(cfn_d,   0x0044), MAKEUINT(cfn_v,   0x0044), MAKEUINT(bfn_i,   0x0044),
  MAKEUINT(bfn_d,   0x0044), MAKEUINT(bfn_v,   0x0044), MAKEUINT(pfn_i,   0x0004), MAKEUINT(pfn_d,   0x0004),
  MAKEUINT(pfn_v,   0x0004), MAKEUINT(cmp_p,   0x0004), MAKEUINT(ent_www, 0x0444),
};

int  WINAPI oprval(int oc)
{ // Iyh
  PINT pc;

  for (pc = OIE; pc < OIE + NELEM(OIE); pc++) {
    if (LOWORD(*pc) == oc) return HIWORD(*pc);
  }
  return 0;
}

static BYTE OSZ[256] = {
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 2, 2,
  1, 1, 2, 2, 4, 8, 4, 8, 0, 0, 2, 4, 2, 4, 2, 4,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 2, 2, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 2, 2, 0, 0, 0, 2, 2, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0,
  4, 4, 4, 4, 4, 4, 2, 2, 2, 0, 0, 0, 2, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6,
};

BYTE WINAPI oprsiz(int oc)
{ // Iyh
  return OSZ[oc];
}

int  LOCALF maxord(PCSEGS pc)
{ // ̍ől
  int oc, mx = 0;
  PCBYTE cp, ce;

  for (cp = pc->pb, ce = cp + pc->sz; cp < ce && (oc = *cp++) != end_v; cp += oprsiz(oc)) {
    if (oc == ent_www) {
      if (*(U2B *)cp > mx) mx = *(U2B *)cp;
    }
  }
  return mx;
}

void LOCALF SetCFNS(PCFNS cf, PCSEGS pc)
{ // ֐e[uڂ̐ݒ
  int oc;
  PCBYTE cp, ce;
  PCFNI fn;

  for (cp = pc->pb, ce = cp + pc->sz; cp < ce && (oc = *cp++) != end_v; cp += oprsiz(oc)) {
    if (oc == ent_www) {
      fn = &cf->fn[*(U2B *)cp];
      fn->ofs = (cp - pc->pb) + oprsiz(oc);
      fn->asz = *(U2B *)(cp + 2);
      fn->bsz = *(U2B *)(cp + 4);
    }
  }
}

#define  SEG_COD  1
#define  SEG_DAT  2
#define  SEG_BSS  3
#define  SEG_REL  4

  // oCgR[hZOgwb_
typedef struct {
  int   seg;
  int   len;
} SEGH;

  // oCgR[h
typedef struct {
  int   app;
  int   pro;
  int   ent;
  int   ssz;
  HEXE  xe;
  PSEGS pc;
  PSEGS pd;
  int   esz;
  PRELS pr;
  PCFNS cf;
} BCDE;
typedef BCDE * PBCDE;

HBCD WINAPI CreateBCD(int app, int pro, int ent, int ssz, PCSEGS pc, PCSEGS pd, int esz, PCRELS pr)
{ // oCgR[h쐬
  PBCDE bc;

  bc = halloc(sizeof(BCDE) + 2 * sizeof(SEGS) + sizeof(RELS) + sizeof(CFNS), TRUE); if (!bc) return ierr(E_MEM);
  bc->app = app;
  bc->pro = pro;
  bc->ent = ent;
  bc->ssz = ssz? ssz: DEFSSZ;
  bc->pc = (PVOID)((PBYTE)bc + sizeof(BCDE));
  bc->pd = (PVOID)((PBYTE)bc->pc + sizeof(SEGS));
  bc->esz = esz;
  bc->pr = (PVOID)((PBYTE)bc->pd + sizeof(SEGS));
  bc->cf = (PVOID)((PBYTE)bc->pr + sizeof(RELS));
  if (pc && (bc->pc->sz = pc->sz) > 0) {
    bc->pc->pb = halloc(pc->sz, FALSE); if (!bc->pc->pb) { ierr(E_MEM); goto _L3;}
    memcpy(bc->pc->pb, pc->pb, pc->sz);
  } else if (pc) { ierr(E_DAT); goto _L3;}
  if (pd && (bc->pd->sz = pd->sz) > 0) {
    bc->pd->pb = halloc(pd->sz, FALSE); if (!bc->pd->pb) { ierr(E_MEM); goto _L2;}
    memcpy(bc->pd->pb, pd->pb, pd->sz);
  }
  if (pr && (bc->pr->ni = pr->ni) > 0) {
    bc->pr->pi = halloc(pr->ni * sizeof(int), FALSE); if (!bc->pr->pi) { ierr(E_MEM); goto _L1;}
    memcpy(bc->pr->pi, pr->pi, pr->ni * sizeof(int));
  }
  return (HBCD)bc;

 _L1: hfree(bc->pd->pb);
 _L2: hfree(bc->pc->pb);
 _L3: hfree(bc);
  return NULL;
}

void WINAPI DeleteBCD(HBCD hb)
{ // oCgR[h̍폜
  PBCDE bc = (PBCDE)hb;

  if (!bc) return;
  DeleteExecEnv(bc->xe);
  hfree(bc->cf->fn);
  hfree(bc->pr->pi);
  hfree(bc->pd->pb);
  hfree(bc->pc->pb);
  hfree(bc);
}

BOOL WINAPI AttachBCD(HBCD hb)
{ // oCgR[hs\ɂ
  PBCDE bc = (PBCDE)hb;

  bc->cf->ni = maxord(bc->pc) + 1;
  bc->cf->fn = halloc(bc->cf->ni * sizeof(CFNI), TRUE); if (!bc->cf->fn) return (BOOL)ierr(E_MEM);
  SetCFNS(bc->cf, bc->pc);
  bc->xe = CreateExecEnv(bc->ssz, bc->pd->sz, bc->esz, &fsBAS, bc->cf); if (!bc->xe) goto _L1;
  SetExecCS(bc->xe, bc->pc);
  SetExecDS(bc->xe, bc->pd);
  RelocatePtr(bc->xe, bc->pr);
  return TRUE;

 _L1: hfree(bc->cf->fn);
  return FALSE;
}

HBCD WINAPI LoadBCD(PCSTR nam, int app, int pro, int ssz)
{ // oCgR[ht@CǍ
  PBCDE bc;
  HANDLE hf;
  BCDH bhd;
  SEGH shd;

  bc = (PBCDE)CreateBCD(0, 0, 0, ssz, NULL, NULL, 0, NULL); if (!bc) return NULL;
  hf = open_file(nam, OP_RDO); if (!hf) { ferr(E_FIR, nam); goto _L5;}
  if (!read_file(hf, &bhd, sizeof(BCDH))) { ferr(E_FIR, nam); goto _L4;}
  if (app != 0 && LOWORD(bhd.app) != LOWORD(app)) { ierr(E_BCD); goto _L4;}
  if (app != 0 && HIWORD(bhd.app) != HIWORD(app)) { ierr(E_VER); goto _L4;}
  if (pro != 0 && bhd.pro != pro) { ierr(E_PRO); goto _L4;}
  bc->app = bhd.app;
  bc->pro = bhd.pro;
  bc->ent = bhd.ent;
  if (!read_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIR, nam); goto _L4;}
  if (shd.seg != SEG_COD) { ierr(E_BCD); goto _L4;}
  if ((bc->pc->sz = shd.len) > 0) {
    bc->pc->pb = halloc(shd.len, FALSE); if (!bc->pc->pb) { ierr(E_MEM); goto _L4;}
    if (!read_file(hf, bc->pc->pb, shd.len)) { ferr(E_FIR, nam); goto _L3;}
  } else { ierr(E_BCD); goto _L4;}
  if (!read_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIR, nam); goto _L3;}
  if (shd.seg != SEG_DAT) { ierr(E_BCD); goto _L3;}
  if ((bc->pd->sz = shd.len) > 0) {
    bc->pd->pb = halloc(shd.len, FALSE); if (!bc->pd->pb) { ierr(E_MEM); goto _L3;}
    if (!read_file(hf, bc->pd->pb, shd.len)) { ferr(E_FIR, nam); goto _L2;}
  }
  if (!read_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIR, nam); goto _L2;}
  if (shd.seg != SEG_BSS) { ierr(E_BCD); goto _L2;}
  bc->esz = shd.len;
  if (!read_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIR, nam); goto _L2;}
  if (shd.seg != SEG_REL) { ierr(E_BCD); goto _L2;}
  if ((bc->pr->ni = shd.len) > 0) {
    bc->pr->pi = halloc(shd.len * sizeof(int), FALSE); if (!bc->pr->pi) { ierr(E_MEM); goto _L2;}
    if (!read_file(hf, bc->pr->pi, shd.len * sizeof(int))) { ferr(E_FIR, nam); goto _L1;}
  }
  if (!AttachBCD((HBCD)bc)) goto _L1;
  close_file(hf);
  return (HBCD)bc;

 _L1: hfree(bc->pr->pi);
 _L2: hfree(bc->pd->pb);
 _L3: hfree(bc->pc->pb);
 _L4: close_file(hf);
 _L5: hfree(bc);
  return NULL;
}

BOOL WINAPI SaveBCD(PCSTR nam, HBCD hb, PCSTR tit, PCSTR dsc)
{ // oCgR[ht@Co
  int re = FALSE;
  PBCDE bc = (PBCDE)hb;
  HANDLE hf;
  BCDH bhd;
  SEGH shd;

  hf = open_file(nam, OP_WRI); if (!hf) return (BOOL)ferr(E_FIW, nam);
  bhd.app = bc->app;
  bhd.pro = bc->pro;
  bhd.ent = bc->ent;
  strcpyx(bhd.tit, tit? tit: basnamx(nam), sizeof(bhd.tit) - 1);
  strcpyx(bhd.dsc, dsc? dsc: "", sizeof(bhd.dsc) - 1);
  if (!write_file(hf, &bhd, sizeof(BCDH))) { ferr(E_FIW, nam); goto _L1;}
  shd.seg = SEG_COD;
  shd.len = bc->pc->sz;
  if (!write_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIW, nam); goto _L1;}
  if (shd.len > 0) {
    if (!write_file(hf, bc->pc->pb, shd.len)) { ferr(E_FIW, nam); goto _L1;}
  }
  shd.seg = SEG_DAT;
  shd.len = bc->pd->sz;
  if (!write_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIW, nam); goto _L1;}
  if (shd.len > 0) {
    if (!write_file(hf, bc->pd->pb, shd.len)) { ferr(E_FIW, nam); goto _L1;}
  }
  shd.seg = SEG_BSS;
  shd.len = bc->esz;
  if (!write_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIW, nam); goto _L1;}
  shd.seg = SEG_REL;
  shd.len = bc->pr->ni;
  if (!write_file(hf, &shd, sizeof(SEGH))) { ferr(E_FIW, nam); goto _L1;}
  if (shd.len > 0) {
    if (!write_file(hf, bc->pr->pi, shd.len * sizeof(int))) { ferr(E_FIW, nam); goto _L1;}
  }
  re = TRUE;
 _L1: close_file(hf);
  return re;
}

void WINAPI CallBCD(PVOID pv, HBCD hb, int ent, PCVOID arg)
{ // oCgR[h̎s
  CallExec(pv, ((PBCDE)hb)->xe, ent, arg);
}

void WINAPI ExecBCD(PVOID pv, HBCD hb, PCVOID arg)
{ // oCgR[h̎s
  CallExec(pv, ((PBCDE)hb)->xe, ((PBCDE)hb)->ent, arg);
}

// ---------------------------------------------------------------------- //

UINT WINAPI BOLBASVer(void)
{ // o[W
  static BYTE ver[4] = { MODVER }; return *(PUINT)ver;
}

static HBLK ASB;

BOOL WINAPI InitBOLBAS(UINT pa)
{ // Jn
  ASB = CreateStrBlk(65536); if (!ASB) return FALSE;
  SelectStrBlk(ASB);
  return TRUE;
}

void WINAPI TermBOLBAS(void)
{ // I
  DeleteStrBlk(ASB);
}

// ---------------------------------------------------------------------- //
