/* ---------------------------------------------------------------------- //
    boldbe.c
// ---------------------------------------------------------------------- */

#define  MODNAM  "BOLDBE"
#define  MODVER   2,0,0,0

#include <windows.h>

#define  _USE_MATH_DEFINES
#include <math.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma warning(disable:4996)

#include <bolbas.h>
#include "boldbe.h"

// ---------------------------------------------------------------------- //

enum {
  E_STA = 40,
         E_RDO, E_FIX, E_CAL, E_CMP, E_IRO, E_ICO, E_ITB, e_048, E_NIN, // 40- 49
  E_NOL, E_DUL, E_BSA, E_BSD, E_RDW, E_DBN, E_DBT, E_DBD, e_058, E_NOC, // 50- 59
  E_DUC, e_061, e_062, E_LCK, E_ORO, E_ORW, E_CNF, E_NZR, E_UNI, E_CHK, // 60- 69
  E_KEY, E_REF, E_NUS, E_NPW, E_MIS, E_TBN, E_TBT, E_TBD, E_CON, E_COT, // 70- 79
  E_COD, E_NTP, E_NFC, E_NEN, E_NCO, E_NSE, E_ALN, E_RSZ, E_NKY, E_NRF, // 80- 89
  E_CSZ, E_CKY, E_RKY, E_NUN,                                           // 90- 99
};
  // G[bZ[W
static CODI eeDBE[] = {
  { E_STA, "ÓIȕ\̗eʂ͕ύXłȂ" },
  { E_RDO, "ǎp̕\͕ҏWłȂ" },
  { E_FIX, "Œ蒷̕\͍sҏWłȂ" },
  { E_CAL, "vZڂɂ͒lݒłȂ" },
  { E_CMP, "^̕\łȂ" },
  { E_IRO, "sCfbNXs" },
  { E_ICO, "CfbNXs" },
  { E_ITB, "\CfbNXs" },
  { E_NIN, "̌^̍ڂɂ̓L[l̎̔ԂwłȂ" },
  { E_NOL, "TCgɃOCĂȂ" },
  { E_DUL, "TCgɓdɃOC悤Ƃ" },
  { E_BSA, "̋@\s錠(TCgǗҌ)Ȃ" },
  { E_BSD, "̋@\s錠(caǗҌ)Ȃ" },
  { E_RDW, "̋@\s錠(ҏW[U[)Ȃ" },
  { E_DBN, "cas" },
  { E_DBT, "ca^Cg" },
  { E_DBD, "ca" },
  { E_NOC, "caɐڑĂȂ" },
  { E_DUC, "caɓdɐڑ悤Ƃ" },
  { E_LCK, "̃[U[ɃbNĂ\bN悤Ƃ" },
  { E_ORO, "ǎp̕\ҏW[hŊJƂ" },
  { E_ORW, "ҏW[hŊJĂ\ēxҏW[hŊJƂ" },
  { E_CNF, "̃[U[̕ҏWeƋ" },
  { E_NZR, "[ᔽ" },
  { E_UNI, "Ӑᔽ" },
  { E_CHK, "`FbNᔽ" },
  { E_KEY, "L[ᔽ" },
  { E_REF, "OL[ᔽ" },
  { E_NUS, "[U[Kv" },
  { E_NPW, "pX[hKv" },
  { E_MIS, "\`񂪂Ȃ" },
  { E_TBN, "\s" },
  { E_TBT, "\^Cg" },
  { E_TBD, "\" },
  { E_CON, "񖼂s" },
  { E_COT, "^Cg" },
  { E_COD, "" },
  { E_NTP, "^񂪂Ȃ" },
  { E_NFC, "vZڂFCALR[obN֐ւ̃|C^Ȃ" },
  { E_NEN, "񋓌^ENMS\̂ւ̃|C^Ȃ" },
  { E_NCO, "R[h^CODS\̂ւ̃|C^Ȃ" },
  { E_NSE, "W^ENMS\̂ւ̃|C^Ȃ" },
  { E_ALN, "ACgᔽ" },
  { E_RSZ, "sTCY\̃TCYƈvȂ" },
  { E_NKY, "L[ڂ`ĂȂ" },
  { E_NRF, "OL[ڂ`ĂȂ" },
  { E_CSZ, "OQƍڂ̃TCYQƐ̍ڂ̃TCYƈvȂ" },
  { E_CKY, "vZڂ͎L[ɂłȂ" },
  { E_RKY, "OL[̎QƐ悪L[ڂłȂ" },
  { E_NUN, "OL[̎QƐ̎L[PL[łȂ" },
};
static CODS emDBE = { eeDBE, NELEM(eeDBE) };

PCVOID WINAPI I4BBox(int va)
{ // intlintւ̃|C^ɕϊ
  PVOID pv = ualloc(4); *(I4B *)pv = va; return pv;
}

PCVOID WINAPI I8BBox(_i64 va)
{ // INT64lINT64ւ̃|C^ɕϊ
  PVOID pv = ualloc(8); *(I8B *)pv = va; return pv;
}

PCVOID WINAPI F4BBox(_f32 va)
{ // floatlfloatւ̃|C^ɕϊ
  PVOID pv = ualloc(4); *(F4B *)pv = va; return pv;
}

PCVOID WINAPI F8BBox(REAL va)
{ // doubleldoubleւ̃|C^ɕϊ
  PVOID pv = ualloc(8); *(F8B *)pv = va; return pv;
}

#define  TID(co)  ((PBYTE)&(co)->itp)[0]
#define  BTP(co)  ((PBYTE)&(co)->itp)[1]
#define  SIZ(co)  ((PWORD)&(co)->itp)[1]
#define  WID(co)  ((PBYTE)&(co)->atr)[0]
#define  ALN(co)  ((PBYTE)&(co)->atr)[1]
#define  OFS(co)  ((PWORD)&(co)->atr)[1]
#define  FMT(co)  ((PCSTR)(co)->pa0)
#define  LST(co)  ((PENMS)(co)->pa0)
#define  COD(co)  ((PCODS)(co)->pa0)
#define  ATI(co)  ((PWORD)&(co)->pa0)[0]
#define  ACI(co)  ((PWORD)&(co)->pa0)[1]
#define  RTI(co)  ((PWORD)&(co)->pa1)[0]
#define  RCI(co)  ((PWORD)&(co)->pa1)[1]
#define  COX(co)  ((co)->pa2)
#define  CTB(co)  ((HTBL)(co)->pa3)

#define  TIDOF(co)  (TID(co) &~CAL_BIT)
#define  ISCAL(co)  (!!(TID(co) & CAL_BIT))

int  LOCALF btpsiz(int bt)
{ // TCY
  static BYTE osz[] = { 0, 1, 1, 2, 2, 4, 4, 8, 8, 4, 8 };

  return (bt >= 0 && bt <= TID_F8B)? osz[bt]: 0;
}

int  LOCALF btpaln(int bt)
{ // oCgACg
  return (bt <= TID_F8B)? btpsiz(bt): 1;
}

BOOL LOCALF iszero(PCBYTE pv, int sz)
{ // l
  int i;

  for (i = 0; i < sz; i++) {
    if (pv[i] != 0) return FALSE;
  }
  return TRUE;
}

int  LOCALF defwidENM(PCENMS ls)
{ // 񒷂̍ől
  int i, ln, wd = 0;

  for (i = 0; i < ls->ni; i++) {
    if ((ln = strlen(ls->ps[i])) > wd) wd = ln;
  }
  return wd;
}

int  LOCALF defwidCOD(PCCODS ls)
{ // 񒷂̍ől
  int ln, wd = 0;
  PCCODI pc, pe;

  for (pc = ls->pv, pe = pc + ls->ni; pc < pe; pc++) {
    if ((ln = strlen(pc->st)) > wd) wd = ln;
  }
  return wd;
}

int  LOCALF scnvalSET(PCSTR st, PCENMS ls)
{ // 񂩂tOl𐶐
  int i, va = 0;

  for (i = 0; i < ls->ni; i++) {
    if (ls->ps[i][0] != '\0' && strfind(st, ls->ps[i])) va |= (1 << i);
  }
  return va;
}

PSTR LOCALF prnvalSET(PSTR st, int va, PCENMS ls)
{ // tOl當𐶐
  int i;

  st[0] = '\0';
  for (i = 0; i < ls->ni; i++) {
    if (va & (1 << i)) strcat(st, ls->ps[i]);
  }
  return st;
}

int  LOCALF defwidSET(PCENMS ls)
{ // 񒷂̍v
  int i, wd = 0;

  for (i = 0; i < ls->ni; i++) {
    wd += strlen(ls->ps[i]);
  }
  return wd;
}

PCCOLI LOCALF TableColumnInfoX(HTBL tb, int ic);
PVOID LOCALF GetTableCellValueX(PVOID pv, HTBL tb, int ir, int ic);
PSTR LOCALF PrintTableCellValueX(PSTR st, HTBL tb, int ir, int ic);

int  LOCALF scnvalALT(PCSTR st, int id, int ic, int ix, int ik)
{ // OL[lɕϊ
  int ir, va;
  HTBL tb = DBTable(id);

  if (id != ix) ik = RCI(TableColumnInfoX(DBTable(ix), ik));
  if ((ir = SearchAlt(tb, ic, st)) >= 0) {
    va = 0; GetTableCellValueX(&va, tb, ir, ik); return va;
  }
  va = ztoi(st); if (va == 0) return 0;
  if (SearchTableCellValue(tb, 0, ik, &va) >= 0) return va;
  return 0;
}

PSTR LOCALF prnvalALT(PSTR st, int va, int id, int ic, int ix, int ik)
{ // OL[l𕶎ɕϊ
  int ir;
  HTBL tb = DBTable(id);

  if (id != ix) ik = RCI(TableColumnInfoX(DBTable(ix), ik));
  if ((ir = SearchTableCellValue(tb, 0, ik, &va)) >= 0) {
    PrintTableCellValueX(st, tb, ir, ic);
  } else st[0] = '\0';
  return st;
}

typedef BOOL (CALLBACK * FEXT)(int c);

PSTR LOCALF extchr_b(PCSTR st, PSTR bf, FEXT fchr)
{ // w蕶̂ݎo
  PSTR pt = bf;

  while (*st != '\0') {
    if (iszen(st)) st += 2;
    else if (fchr(*st)) *pt++ = *st++;
    else st++;
  }
  *pt = '\0';
  return bf;
}

PCSTR LOCALF extchr(PCSTR st, FEXT fchr)
{ // w蕶̂ݎo
  return extchr_b(st, talloc(strlen(st) + 1), fchr);
}

  // 

PVOID LOCALF fscnNOP(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  return pv;
}

PSTR LOCALF fprnNOP(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  st[0] = '\0'; return st;
}

int  LOCALF fcmpNOP(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (p1 > p2)? 1: (p1 < p2)? -1: 0;
}

UINT LOCALF flstNOP(int im, PCCOLI co)
{ // Xg
  return (im < 0)? 0: (UINT)"";
}

  // (char)

PVOID LOCALF fscnI1B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(I1B *)pv = (I1B)cztoi(st); return pv;
}

PSTR LOCALF fprnI1B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), (I4B)*(I1B *)pv); return st;
}

int  LOCALF fcmpI1B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return *(I1B *)p1 - *(I1B *)p2;
}

  // (BYTE)

PVOID LOCALF fscnU1B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U1B *)pv = (U1B)cztoi(st); return pv;
}

PSTR LOCALF fprnU1B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), (I4B)*(U1B *)pv); return st;
}

int  LOCALF fcmpU1B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return *(U1B *)p1 - *(U1B *)p2;
}

  // (short)

PVOID LOCALF fscnI2B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(I2B *)pv = (I2B)cztoi(st); return pv;
}

PSTR LOCALF fprnI2B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), (I4B)*(I2B *)pv); return st;
}

int  LOCALF fcmpI2B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return *(I2B *)p1 - *(I2B *)p2;
}

  // (WORD)

PVOID LOCALF fscnU2B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U2B *)pv = (U2B)cztoi(st); return pv;
}

PSTR LOCALF fprnU2B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), (I4B)*(U2B *)pv); return st;
}

int  LOCALF fcmpU2B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return *(U2B *)p1 - *(U2B *)p2;
}

  // (int)

PVOID LOCALF fscnI4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(I4B *)pv = cztoi(st); return pv;
}

PSTR LOCALF fprnI4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), *(I4B *)pv); return st;
}

int  LOCALF fcmpI4B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (*(I4B *)p1 > *(I4B *)p2)? 1: (*(I4B *)p1 < *(I4B *)p2)? -1: 0;
}

  // (UINT)

PVOID LOCALF fscnU4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = cztou(st); return pv;
}

PSTR LOCALF fprnU4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), *(U4B *)pv); return st;
}

int  LOCALF fcmpU4B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (*(U4B *)p1 > *(U4B *)p2)? 1: (*(U4B *)p1 < *(U4B *)p2)? -1: 0;
}

  // (INT64)

PVOID LOCALF fscnI8B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(I8B *)pv = cztoi64(st); return pv;
}

PSTR LOCALF fprnI8B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), *(I8B *)pv); return st;
}

int  LOCALF fcmpI8B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (*(I8B *)p1 > *(I8B *)p2)? 1: (*(I8B *)p1 < *(I8B *)p2)? -1: 0;
}

  // (UINT64)

PVOID LOCALF fscnU8B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U8B *)pv = cztou64(st); return pv;
}

PSTR LOCALF fprnU8B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), *(U8B *)pv); return st;
}

int  LOCALF fcmpU8B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (*(U8B *)p1 > *(U8B *)p2)? 1: (*(U8B *)p1 < *(U8B *)p2)? -1: 0;
}

  // (float)

PVOID LOCALF fscnF4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(F4B *)pv = (F4B)cztof(st); return pv;
}

PSTR LOCALF fprnF4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), (F8B)*(F4B *)pv); return st;
}

int  LOCALF fcmpF4B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (*(F4B *)p1 > *(F4B *)p2)? 1: (*(F4B *)p1 < *(F4B *)p2)? -1: 0;
}

  // (double)

PVOID LOCALF fscnF8B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(F8B *)pv = cztof(st); return pv;
}

PSTR LOCALF fprnF8B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  sprintf(st, FMT(co), *(F8B *)pv); return st;
}

int  LOCALF fcmpF8B(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return (*(F8B *)p1 > *(F8B *)p2)? 1: (*(F8B *)p1 < *(F8B *)p2)? -1: 0;
}

  // (char[n])

PVOID LOCALF fscnSTR(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ

  if (co->flg & CF_HCH) st = cipher(st);
  if (co->flg & CF_ACT) ;
  else if (co->flg & CF_DCT) st = delctl(st);
  else st = ctlspc(st);
  if (co->flg & CF_HAN) st = tohan(st);
  if (co->flg & CF_DSP) {
    st = delspc(st);
  } else if (co->flg & CF_LTR) {
    if (co->flg & CF_RTR) st = btrim(st);  else st = ltrim(st);
  } else if (co->flg & CF_RTR) {
    st = rtrim(st);
  }
  if (co->flg & CF_ZEN) st = tozen(st);
  strcpyx(pv, st, SIZ(co) - 1);
  return pv;
}

PSTR LOCALF fprnSTR(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, pv);
}

int  LOCALF fcmpSTR(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return strcmp(p1, p2);
}

  // oCg(BYTE[n])

int  LOCALF fcmpBIN(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  return memcmp(p1, p2, SIZ(co));
}

  // 16i(UINT)

PVOID LOCALF fscnHEX(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  if (*st == '0' && (*(st+1) == 'X' || *(st+1) == 'x')) st += 2;
  *(U4B *)pv = strtoul(tohan(st), NULL, 16); return pv;
}

  // ʉ݌^(int)

PSTR LOCALF fprnM4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  csprintf(st, FMT(co), *(I4B *)pv); return st;
}

  // ʉ݌^(double)

PSTR LOCALF fprnM8B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  csprintf(st, FMT(co), *(F8B *)pv); return st;
}

  // t^(UINT)

PVOID LOCALF fscnYMD(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = ztod2(st, today()); return pv;
}

PSTR LOCALF fprnYMD(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  dprintf(st, FMT(co), *(U4B *)pv); return st;
}

  // N^(UINT)

PVOID LOCALF fscnYMN(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = ztom(st); return pv;
}

PSTR LOCALF fprnYMN(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  dprintf(st, FMT(co), *(U4B *)pv); return st;
}

  // ^(UINT)

PVOID LOCALF fscnTIM(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = ztot(st); return pv;
}

PSTR LOCALF fprnTIM(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  tprintf(st, FMT(co), *(U4B *)pv); return st;
}

  // t^(double)

PVOID LOCALF fscnDTM(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(F8B *)pv = ztodt(st); return pv;
}

PSTR LOCALF fprnDTM(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  dtprintf(st, FMT(co), *(F8B *)pv); return st;
}

  // 񋓌^(BYTE)

PVOID LOCALF fscnE1B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U1B *)pv = (U1B)srchenm(LST(co), st); return pv;
}

PSTR LOCALF fprnE1B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, enmstr(LST(co), *(U1B *)pv));
}

UINT LOCALF flstE1B(int im, PCCOLI co)
{ // Xg
  return (im < 0)? LST(co)->ni: (im < LST(co)->ni)? (UINT)LST(co)->ps[im]: (UINT)"";
}

  // 񋓌^(WORD)

PVOID LOCALF fscnE2B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U2B *)pv = (U2B)srchenm(LST(co), st); return pv;
}

PSTR LOCALF fprnE2B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, enmstr(LST(co), *(U2B *)pv));
}

  // 񋓌^(UINT)

PVOID LOCALF fscnE4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = (U4B)srchenm(LST(co), st); return pv;
}

PSTR LOCALF fprnE4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, enmstr(LST(co), *(U4B *)pv));
}

  // R[h^(BYTE)

PVOID LOCALF fscnC1B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U1B *)pv = (U1B)srchcod(COD(co), st); return pv;
}

PSTR LOCALF fprnC1B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, codstr(COD(co), *(U1B *)pv));
}

UINT LOCALF flstC1B(int im, PCCOLI co)
{ // Xg
  return (im < 0)? COD(co)->ni: (im < COD(co)->ni)? (UINT)COD(co)->pv[im].st: (UINT)"";
}

  // R[h^(WORD)

PVOID LOCALF fscnC2B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U2B *)pv = (U2B)srchcod(COD(co), st); return pv;
}

PSTR LOCALF fprnC2B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, codstr(COD(co), *(U2B *)pv));
}

  // R[h^(UINT)

PVOID LOCALF fscnC4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = (U4B)srchcod(COD(co), st); return pv;
}

PSTR LOCALF fprnC4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return strcpy(st, codstr(COD(co), *(U4B *)pv));
}

  // W^(BYTE)

PVOID LOCALF fscnS1B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U1B *)pv = (U1B)scnvalSET(st, LST(co)); return pv;
}

PSTR LOCALF fprnS1B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return prnvalSET(st, *(U1B *)pv, LST(co));
}

  // W^(WORD)

PVOID LOCALF fscnS2B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U2B *)pv = (U2B)scnvalSET(st, LST(co)); return pv;
}

PSTR LOCALF fprnS2B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return prnvalSET(st, *(U2B *)pv, LST(co));
}

  // W^(UINT)

PVOID LOCALF fscnS4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = (U4B)scnvalSET(st, LST(co)); return pv;
}

PSTR LOCALF fprnS4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return prnvalSET(st, *(U4B *)pv, LST(co));
}

  // փL[(BYTE)

PVOID LOCALF fscnA1B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U1B *)pv = (U1B)scnvalALT(st, ATI(co), ACI(co), RTI(co), RCI(co)); return pv;
}

PSTR LOCALF fprnA1B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return prnvalALT(st, *(U1B *)pv, ATI(co), ACI(co), RTI(co), RCI(co));
}

UINT LOCALF flstA1B(int im, PCCOLI co)
{ // Xg
  HTBL tb = DBTable(ATI(co)); int ln = NTableRows(tb);
  char bf[512];

  return (im < 0)? ln + 1: (im < ln)? (UINT)stostr(PrintTableCellValueX(bf, tb, im, ACI(co))): (UINT)"";
}

  // փL[(WORD)

PVOID LOCALF fscnA2B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U2B *)pv = (U2B)scnvalALT(st, ATI(co), ACI(co), RTI(co), RCI(co)); return pv;
}

PSTR LOCALF fprnA2B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return prnvalALT(st, *(U2B *)pv, ATI(co), ACI(co), RTI(co), RCI(co));
}

  // փL[(UINT)

PVOID LOCALF fscnA4B(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  *(U4B *)pv = (U4B)scnvalALT(st, ATI(co), ACI(co), RTI(co), RCI(co)); return pv;
}

PSTR LOCALF fprnA4B(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  return prnvalALT(st, *(U4B *)pv, ATI(co), ACI(co), RTI(co), RCI(co));
}

  // ascii(char[n])

PVOID LOCALF fscnASC(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  return strcpyx(pv, extchr(tohan(st), isasc), SIZ(co) - 1);
}

#define  NUM(n)  ATR((n), ALN_RGT)

  // f[^^
static TYPI TIE[128] = {
  { 0,                     0,       fscnNOP, fprnNOP, fcmpNOP, flstNOP, },               //  0
  { ITP(TID_I1B, TID_I1B), NUM( 4), fscnI1B, fprnI1B, fcmpI1B, flstNOP, (UINT)"%d",},    //  1
  { ITP(TID_U1B, TID_U1B), NUM( 4), fscnU1B, fprnU1B, fcmpU1B, flstNOP, (UINT)"%d", },   //  2
  { ITP(TID_I2B, TID_I2B), NUM( 6), fscnI2B, fprnI2B, fcmpI2B, flstNOP, (UINT)"%d", },   //  3
  { ITP(TID_U2B, TID_U2B), NUM( 6), fscnU2B, fprnU2B, fcmpU2B, flstNOP, (UINT)"%d", },   //  4
  { ITP(TID_I4B, TID_I4B), NUM(11), fscnI4B, fprnI4B, fcmpI4B, flstNOP, (UINT)"%d", },   //  5
  { ITP(TID_U4B, TID_U4B), NUM(11), fscnU4B, fprnU4B, fcmpU4B, flstNOP, (UINT)"%u", },   //  6
  { ITP(TID_I8B, TID_I8B), NUM(13), fscnI8B, fprnI8B, fcmpI8B, flstNOP, (UINT)"%lld", }, //  7
  { ITP(TID_U8B, TID_U8B), NUM(13), fscnU8B, fprnU8B, fcmpU8B, flstNOP, (UINT)"%llu", }, //  8
  { ITP(TID_F4B, TID_F4B), NUM(11), fscnF4B, fprnF4B, fcmpF4B, flstNOP, (UINT)"%.6G", }, //  9
  { ITP(TID_F8B, TID_F8B), NUM(11), fscnF8B, fprnF8B, fcmpF8B, flstNOP, (UINT)"%.15G", },// 10
  { ITP(TID_STR, TID_STR), 0,       fscnSTR, fprnSTR, fcmpSTR, flstNOP, },               // 11
  { ITP(TID_BIN, TID_BIN), 0,       fscnNOP, fprnNOP, fcmpBIN, flstNOP, },               // 12
  { ITP(TID_HEX, TID_U4B), NUM( 8), fscnHEX, fprnU4B, fcmpU4B, flstNOP, (UINT)"%X", },   // 13
  { ITP(TID_M4B, TID_I4B), NUM(13), fscnI4B, fprnM4B, fcmpI4B, flstNOP, (UINT)"%d", },   // 14
  { ITP(TID_M8B, TID_F8B), NUM(13), fscnF8B, fprnM8B, fcmpF8B, flstNOP, (UINT)"%.0f", }, // 15
  { ITP(TID_YMD, TID_U4B), 0,       fscnYMD, fprnYMD, fcmpU4B, flstNOP, (UINT)"yyyy/mm/dd", },
  { ITP(TID_YMN, TID_U4B), 0,       fscnYMN, fprnYMN, fcmpU4B, flstNOP, (UINT)"yyyy/mm", },
  { ITP(TID_TIM, TID_U4B), 0,       fscnTIM, fprnTIM, fcmpU4B, flstNOP, (UINT)"hh:mm:ss", },
  { ITP(TID_DTM, TID_F8B), 0,       fscnDTM, fprnDTM, fcmpF8B, flstNOP, (UINT)"yyyy/mm/dd hh:mm:ss", },
  { ITP(TID_E1B, TID_U1B), 0,       fscnE1B, fprnE1B, fcmpU1B, flstE1B, },               // 20
  { ITP(TID_E2B, TID_U2B), 0,       fscnE2B, fprnE2B, fcmpU2B, flstE1B, },               // 21
  { ITP(TID_E4B, TID_U4B), 0,       fscnE4B, fprnE4B, fcmpU4B, flstE1B, },
  { ITP(TID_C1B, TID_U1B), 0,       fscnC1B, fprnC1B, fcmpU1B, flstC1B, },
  { ITP(TID_C2B, TID_U2B), 0,       fscnC2B, fprnC2B, fcmpU2B, flstC1B, },
  { ITP(TID_C4B, TID_U4B), 0,       fscnC4B, fprnC4B, fcmpU4B, flstC1B, },               // 25
  { ITP(TID_S1B, TID_U1B), 0,       fscnS1B, fprnS1B, fcmpU1B, flstNOP, },
  { ITP(TID_S2B, TID_U2B), 0,       fscnS2B, fprnS2B, fcmpU2B, flstNOP, },
  { ITP(TID_S4B, TID_U4B), 0,       fscnS4B, fprnS4B, fcmpU4B, flstNOP, },
  { ITP(TID_A1B, TID_U1B), 0,       fscnA1B, fprnA1B, fcmpU1B, flstA1B, },
  { ITP(TID_A2B, TID_U2B), 0,       fscnA2B, fprnA2B, fcmpU2B, flstA1B, },               // 30
  { ITP(TID_A4B, TID_U4B), 0,       fscnA4B, fprnA4B, fcmpU4B, flstA1B, },
  { ITP(TID_ASC, TID_STR), 0,       fscnASC, fprnSTR, fcmpSTR, flstNOP, },
};

  // oCgR[h
static HBCD hbCur, hbAct;
static HBCD hbMain;
static HBCD hbAddIn;

PVOID LOCALF tp_fscn(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  BYTE ar[12], rv[4];

  if (TIE[TIDOF(co)].flg & CF_OSC) {
    *(P4B *)ar = pv; *(P4B *)(ar + 4) = (P4B)st; *(P4B *)(ar + 8) = (P4B)co;
    CallBCD(rv, hbCur, (int)TIE[TIDOF(co)].fscn, ar);
    return pv;
  }
  return TIE[TIDOF(co)].fscn(pv, st, co);
}

PSTR LOCALF tp_fprn(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  BYTE ar[12], rv[4];

  if (TIE[TIDOF(co)].flg & CF_OPR) {
    *(P4B *)ar = st; *(P4B *)(ar + 4) = (P4B)pv; *(P4B *)(ar + 8) = (P4B)co;
    CallBCD(rv, hbCur, (int)TIE[TIDOF(co)].fprn, ar);
    return st;
  }
  return TIE[TIDOF(co)].fprn(st, pv, co);
}

int  LOCALF tp_fcmp(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  BYTE ar[12], rv[4];

  if (TIE[TIDOF(co)].flg & CF_OCM) {
    *(P4B *)ar = (P4B)p1; *(P4B *)(ar + 4) = (P4B)p2; *(P4B *)(ar + 8) = (P4B)co;
    CallBCD(rv, hbCur, (int)TIE[TIDOF(co)].fcmp, ar);
    return *(I4B *)rv;
  }
  return TIE[TIDOF(co)].fcmp(p1, p2, co);
}

UINT LOCALF tp_flst(int im, PCCOLI co)
{ // Xg
  BYTE ar[8], rv[4];

  if (TIE[TIDOF(co)].flg & CF_OLS) {
    *(I4B *)ar = im; *(P4B *)(ar + 4) = (P4B)co;
    CallBCD(rv, hbCur, (int)TIE[TIDOF(co)].flst, ar);
    return *(U4B *)rv;
  }
  return TIE[TIDOF(co)].flst(im, co);
}

PVOID LOCALF co_fcal(PVOID pv, PCVOID pb, PCCOLI co)
{ // vZ
  BYTE ar[12], rv[4];

  if (co->flg & CF_OCL) {
    *(P4B *)ar = pv; *(P4B *)(ar + 4) = (P4B)pb; *(P4B *)(ar + 8) = (P4B)co;
    CallBCD(rv, hbCur, (int)co->fcal, ar);
    return pv;
  }
  return co->fcal(pv, pb, co);
}

BOOL LOCALF co_fchk(PCVOID pb, PCCOLI co)
{ // `FbN
  BYTE ar[8], rv[4];

  if (co->flg & CF_OCK) {
    *(P4B *)ar = (P4B)pb; *(P4B *)(ar + 4) = (P4B)co;
    CallBCD(rv, hbCur, (int)co->fchk, ar);
    return *(I4B *)rv;
  }
  return co->fchk(pb, co);
}

PVOID LOCALF scnval(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  if (ISCAL(co)) return pv;
  return tp_fscn(pv, st, co);
}

PVOID LOCALF cscnval(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ(vZڂɂKp)
  return tp_fscn(pv, st, co);
}

void LOCALF setval(PBYTE pb, PCVOID pv, PCCOLI co)
{ // l̐ݒ
  if (BTP(co) == TID_STR) {
    strcpyx(pb + OFS(co), pv, SIZ(co) - 1); return;
  }
  memcpy(pb + OFS(co), pv, SIZ(co));
}

PVOID LOCALF getval(PVOID pv, PCVOID pb, PCCOLI co)
{ // l̎擾
  if (ISCAL(co)) return co_fcal(pv, pb, co);
  return memcpy(pv, (PBYTE)pb + OFS(co), SIZ(co));
}

PSTR LOCALF prnval(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  BYTE rv[512];

  if (ISCAL(co)) pv = co_fcal(rv, pv, co);
  if ((co->flg & CF_HZR) && iszero(pv, SIZ(co))) { st[0] = '\0'; return st;}
  if ((co->flg & CF_HCH) && BTP(co) == TID_STR) return strcpy(st, cipher((PSTR)pv));
  return tp_fprn(st, pv, co);
}

PSTR LOCALF cprnval(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo(vZڂɂKp)
  COLI coe;

  if (ISCAL(co)) { coe = *co; TID(&coe) = TIDOF(co); co = &coe;}
  return tp_fprn(st, pv, co);
}

PSTR LOCALF vprnval(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo()
  switch (TIDOF(co)) {
  case TID_HEX: sprintf(st, "0x%X", *(U4B *)pv); break;
  case TID_YMD:
  case TID_YMN: dprintf(st, "'yyyy/mm/dd'", *(U4B *)pv); break;
  case TID_TIM: tprintf(st, "'hh:mm:ss'", *(U4B *)pv); break;
  case TID_DTM: dtprintf(st, "'yyyy/mm/dd hh:mm:ss'", *(F8B *)pv); break;
  default:
    switch (BTP(co)) {
    case TID_I1B: sprintf(st, "%d", (I4B)*(I1B *)pv); break;
    case TID_U1B: sprintf(st, "%d", (I4B)*(U1B *)pv); break;
    case TID_I2B: sprintf(st, "%d", (I4B)*(I2B *)pv); break;
    case TID_U2B: sprintf(st, "%d", (I4B)*(U2B *)pv); break;
    case TID_I4B: sprintf(st, "%d", *(I4B *)pv); break;
    case TID_U4B: sprintf(st, "%u", *(U4B *)pv); break;
    case TID_I8B: sprintf(st, "%lldLL", *(I8B *)pv); break;
    case TID_U8B: sprintf(st, "%lluLL", *(U8B *)pv); break;
    case TID_F4B: sprintf(st, "%.6G", (F8B)*(F4B *)pv); break;
    case TID_F8B: sprintf(st, "%.15G", *(F8B *)pv); break;
    case TID_STR: sprintf(st, "'%s'", (PCSTR)pv); break;
    default: st[0] = '\0'; break;
    }
    break;
  }
  if (st[0] == '\0') sprintf(st, "''");
  return st;
}

PVOID LOCALF clrval(PVOID pv, PCVOID pb, PCCOLI co)
{ // 
  if (ISCAL(co)) return pv;
  return co->fcal? co_fcal(pv, pb, co): memset(pv, 0, SIZ(co));
}

int  LOCALF cmpval(PCVOID p1, PCVOID p2, PCCOLI co)
{ // r
  BYTE r1[512], r2[512];

  if (ISCAL(co)) { p1 = co_fcal(r1, p1, co); p2 = co_fcal(r2, p2, co);}
  return tp_fcmp(p1, p2, co);
}

int  LOCALF wcmpval(PCVOID pv, PCVOID wk, PCCOLI co)
{ // r
  BYTE bf[512];

  if (ISCAL(co)) pv = co_fcal(bf, pv, co);
  return tp_fcmp(pv, wk, co);
}

BOOL LOCALF wmlkval(PCVOID pv, PCVOID wk, PCCOLI co)
{ // ܂
  BYTE rv[512];

  if (ISCAL(co)) pv = co_fcal(rv, pv, co);
  switch (BTP(co)) {
  case TID_I1B: case TID_U1B:
    return (*(U1B *)pv & *(U1B *)wk) == *(U1B *)wk;
  case TID_I2B: case TID_U2B:
    return (*(U2B *)pv & *(U2B *)wk) == *(U2B *)wk;
  case TID_I4B: case TID_U4B:
    return (*(U4B *)pv & *(U4B *)wk) == *(U4B *)wk;
  case TID_I8B: case TID_U8B:
    return (*(U8B *)pv & *(U8B *)wk) == *(U8B *)wk;
  case TID_STR:
    return strmlike((PCSTR)pv, (PCSTR)wk);
  }
  return FALSE;
}

PVOID LOCALF cpyval(PVOID p1, PCCOLI c1, PCVOID p2, PCCOLI c2)
{ // l̃Rs[
  char bf[512];

  if (ISCAL(c1)) return p1;
  if (TID(c1) == TID(c2)) {
    memcpy(p1, p2, SIZ(c1));
  } else {
    scnval(p1, prnval(bf, p2, c2), c1);
  }
  return p1;
}

BOOL LOCALF chkval(PCVOID pb, PCCOLI co)
{ // `FbN
  if (ISCAL(co)) return TRUE;
  return co->fchk? co_fchk(pb, co): TRUE;
}

int  LOCALF defwid(PCCOLI co)
{ // \
  int ln, wd;

  switch (TIDOF(co)) {
  case TID_STR: case TID_ASC:
    wd = (int)(128.0 * (1.0 - 127.0 / (SIZ(co) + 127.0))); break;
  case TID_BIN:
    return 0;
  case TID_YMD:
    wd = FMT(co)? strlen(FMT(co)): 10; break;
  case TID_YMN:
    wd = FMT(co)? strlen(FMT(co)): 7; break;
  case TID_TIM:
    wd = FMT(co)? strlen(FMT(co)): 8; break;
  case TID_DTM:
    wd = 18; break;
  case TID_E1B: case TID_E2B: case TID_E4B:
    wd = defwidENM(LST(co)); break;
  case TID_C1B: case TID_C2B: case TID_C4B:
    wd = defwidCOD(COD(co)); break;
  case TID_S1B: case TID_S2B: case TID_S4B:
    wd = defwidSET(LST(co)); break;
  case TID_A1B: case TID_A2B: case TID_A4B:
    wd = TableColumnWidth(DBTable(ATI(co)), ACI(co)); break;
  default:
    wd = WID(&TIE[TIDOF(co)]); break;
  }
  if ((ln = strlen(co->tit)) > wd) wd = ln;
  return wd;
}

int  LOCALF defaln(PCCOLI co)
{ // ̕R[h
  return ALN(&TIE[TIDOF(co)]);
}

int  LOCALF colsiz(PCCOLI co)
{ // TCY
  PCCOLI cx = (PCCOLI)&TIE[TIDOF(co)];

  return (BTP(cx) == TID_STR || BTP(cx) == TID_BIN)? SIZ(co): btpsiz(BTP(cx));
}

BOOL LOCALF chkenm(PCENMS ls)
{ // ENMS\̂̃`FbN
  int i;

  if (!ls->ps) return FALSE;
  for (i = 0; i < ls->ni; i++) {
    if (!ls->ps[i]) return FALSE;
  }
  return TRUE;
}

BOOL LOCALF chkcod(PCCODS ls)
{ // CODS\̂̃`FbN
  PCCODI pc, pe;

  if (!ls->pv) return FALSE;
  for (pc = ls->pv, pe = pc + ls->ni; pc < pe; pc++) {
    if (!pc->st) return FALSE;
  }
  return TRUE;
}

BOOL LOCALF setcol(PCOLI co, PCCOLI pc, int i)
{ // ̐ݒ
  *co = *pc;
  co->itp = TIE[TIDOF(co)].itp | (ISCAL(pc)? CAL_BIT: 0);
  SIZ(co) = colsiz(pc);
  if (!co->nam || co->nam[0] == '\0') co->nam = stostr(format("_%03d", i + 1));
  else if (strlen(co->nam) >= 16 || !isidn(co->nam)) return (BOOL)ierr(E_CON);
  if (!co->tit || co->tit[0] == '\0') co->tit = co->nam;
  else if (strlen(co->tit) >= 32) return (BOOL)ierr(E_COT);
  if (!co->dsc || co->dsc[0] == '\0') co->dsc = co->tit;
  else if (strlen(co->dsc) >= 64) return (BOOL)ierr(E_COD);
  if (TIDOF(co) == 0) return (BOOL)ierr(E_NTP);
  if (ISCAL(co) && !(co->flg & CF_REF) && !co->fcal) return (BOOL)ierr(E_NFC);
  if (co->pa0 == 0) co->pa0 = TIE[TIDOF(co)].pa0;
  if (co->pa1 == 0) co->pa1 = TIE[TIDOF(co)].pa1;
  if (co->pa2 == 0) co->pa2 = TIE[TIDOF(co)].pa2;
  switch (TIDOF(co)) {
  case TID_E1B: case TID_E2B: case TID_E4B:
    if (!LST(co)) return (BOOL)ierr(E_NEN);
    if (!chkenm(LST(co))) return (BOOL)ierr(E_DAT);
    break;
  case TID_C1B: case TID_C2B: case TID_C4B:
    if (!COD(co)) return (BOOL)ierr(E_NCO);
    if (!chkcod(COD(co))) return (BOOL)ierr(E_DAT);
    break;
  case TID_S1B: case TID_S2B: case TID_S4B:
    if (!LST(co)) return (BOOL)ierr(E_NSE);
    if (!chkenm(LST(co))) return (BOOL)ierr(E_DAT);
    break;
  }
  if (WID(co) == 0) WID(co) = defwid(co);  else if (WID(co) == WID_FRC) WID(co) = WID_HID;
  if (ALN(co) == 0) ALN(co) = defaln(co);  else if (ALN(co) == ALN_FRC) ALN(co) = ALN_LFT;
  if (ISCAL(co) || WID(co) == WID_HID) co->flg |= CF_DED;
  return TRUE;
}

BOOL WINAPI RegisterColumnType(PCTYPI tp)
{ // ^̓o^
  int id, bt, flg;

  id = TID(tp); if (id <= 0 || id >= NELEM(TIE)) return (BOOL)ierr(E_DAT);
  bt = BTP(tp); if (bt <= 0 || bt >= NELEM(TIE) || TIE[bt].itp == 0) return (BOOL)ierr(E_DAT);
  TIE[id] = *tp;
  flg = TIE[bt].flg;
  if (TIE[id].fscn) flg &=~CF_OSC;  else TIE[id].fscn = TIE[bt].fscn;
  if (TIE[id].fprn) flg &=~CF_OPR;  else TIE[id].fprn = TIE[bt].fprn;
  if (TIE[id].fcmp) flg &=~CF_OCM;  else TIE[id].fcmp = TIE[bt].fcmp;
  if (TIE[id].flst) flg &=~CF_OLS;  else TIE[id].flst = TIE[bt].flst;
  TIE[id].flg = flg;
  if (bt > TID_BIN) bt = BTP(&TIE[bt]);
  BTP(&TIE[id]) = bt;
  return TRUE;
}

BOOL LOCALF RegisterColumnTypeB(PCTYPI tp)
{ // ^̓o^
  int id, bt, flg;

  id = TID(tp); if (id <= 0 || id >= NELEM(TIE)) return (BOOL)ierr(E_DAT);
  bt = BTP(tp); if (bt <= 0 || bt >= NELEM(TIE) || TIE[bt].itp == 0) return (BOOL)ierr(E_DAT);
  TIE[id] = *tp;
  flg = TIE[bt].flg;
  if (TIE[id].fscn) flg |= CF_OSC;  else TIE[id].fscn = TIE[bt].fscn;
  if (TIE[id].fprn) flg |= CF_OPR;  else TIE[id].fprn = TIE[bt].fprn;
  if (TIE[id].fcmp) flg |= CF_OCM;  else TIE[id].fcmp = TIE[bt].fcmp;
  if (TIE[id].flst) flg |= CF_OLS;  else TIE[id].flst = TIE[bt].flst;
  TIE[id].flg = flg;
  if (bt > TID_BIN) bt = BTP(&TIE[bt]);
  BTP(&TIE[id]) = bt;
  return TRUE;
}

PVOID WINAPI ColumnScan(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  COLI coe;

  if (!setcol(&coe, co, 0)) return pv;
  return scnval(pv, st, &coe);
}

PSTR WINAPI ColumnPrint(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  COLI coe;

  if (!setcol(&coe, co, 0) || ISCAL(co)) return st;
  return prnval(st, pv, &coe);
}

UINT WINAPI ColumnList(int im, PCCOLI co)
{ // Xg
  return tp_flst(im, co);
}

PCVOID WINAPI VPtr(PCVOID pb, PCCOLI co)
{ // ڂ̃AhX
  return (PBYTE)pb + OFS(co);
}

int  LOCALF fspcBOL(PCSTR *pp, PBYTE bf, UINT pa)
{ // 
  PCSTR pt = *pp;

  while (isspc(*pt)) pt++;
  *pp = pt;
  return 0;
}

int  LOCALF fcnsBOL(PCSTR *pp, PBYTE bf, UINT pa)
{ // 萔
  int b, f, cd;
  PCSTR pb, pt = *pp, px;

  b = 10; f = 0;
  if (*pt == '.' && isdig(*(pt+1))) {
    goto _L1;
  } else if (*pt == '0' && (*(pt+1) == 'X' || *(pt+1) == 'x')) {
    pt += 2;
    pb = pt;
    while (isxdig(*pt)) pt++;
    if (pt == pb) return 0;
    b = 16;
  } else if (isdig(*pt)) {
    pb = pt;
    do pt++; while (isdig(*pt));
    if (*pt == '.') {
     _L1:
      do pt++; while (isdig(*pt));
      f = 2;
    }
    if (*pt == 'E' || *pt == 'e') {
      pt++;
      if (*pt == '+' || *pt == '-') pt++;
      px = pt;
      while (isdig(*pt)) pt++;
      if (pt == px) return 0;
      f = 2;
    }
  } else return 0;
  if (f == 0) {
    if (*pt == 'L' || *pt == 'l') {
      pt++;
      if (*pt == 'L' || *pt == 'l') {
        pt++;
        f = 1;
      }
    }
  }
  if (pt - pb > LTKN) return 0;
  spncpy(bf, pb, pt);
  switch (f) {
  case 0:
    *(U4B *)bf = strtoul(bf, NULL, b);
    cd = TKN_U4B; break;
  case 1:
    *(U8B *)bf = _strtoui64(bf, NULL, b);
    cd = TKN_U8B; break;
  default: // f == 2
    *(F8B *)bf = atof(bf);
    cd = TKN_F8B; break;
  }
  *pp = pt;
  return cd;
}

int  LOCALF fstrBOL(PCSTR *pp, PBYTE bf, UINT pa)
{ // 
  int b;
  PCSTR pb, pt = *pp;

  if (*pt == '\'' || *pt == '\"') b = *pt++;  else return 0;
  pb = pt;
  while (*pt != b) {
    if (isprn(*pt)) pt++;
    else if (iszen(pt)) pt += 2;
    else return 0;
  }
  if (pt - pb > LSTR) return 0;
  spncpy(bf, pb, pt);
  pt++;
  *pp = pt;
  return TKN_STR;
}

enum {
  BKW_LAN = TKN_KWD,
           BKW_LOR, BKW_MLK, BKW_NML, BKW_DSN, BKW_ZRL, BKW_ZRF, BKW_PAL, BKW_PAF, BKW_SUM,
  BKW_AVG, BKW_MAX, BKW_MIN, BKW_COU, BKW_GRP, BKW_AS_, BKW_DEC, BKW_CMA,
};
  // L[[h
static CODI diBKW[] = {
  { BKW_LAN, "and"       }, { BKW_LOR, "or"        }, { BKW_MLK, "mlike"     }, { BKW_NML, "notmlike"  },
  { BKW_DSN, "desc"      }, { BKW_ZRL, "zerolast"  }, { BKW_ZRF, "zerofirst" }, { BKW_PAL, "parenlast" },
  { BKW_PAF, "parenfirst"}, { BKW_SUM, "sum"       }, { BKW_AVG, "avg"       }, { BKW_MAX, "max"       },
  { BKW_MIN, "min"       }, { BKW_COU, "count"     }, { BKW_GRP, "groupby"   }, { BKW_AS_, "as"        },
  { BKW_DEC, "dec"       }, { BKW_CMA, "cdec"      },
};
static CODS dsBKW = { diBKW, NELEM(diBKW) };

int  LOCALF fkwdBOL(PCSTR *pp, PBYTE bf, UINT pa)
{ // L[[hAʎq
  int cd;
  PCSTR pt = *pp;

  if (isalpx(*pt)) pt++;  else return 0;
  for (;;) {
    if (isalnx(*pt)) pt++;  else break;
  }
  if (pt - *pp > LTKN) return 0;
  spncpy(bf, *pp, pt);
  cd = srchcod(&dsBKW, bf); if (cd < TKN_KWD) cd = TKN_IDN;
  *pp = pt;
  return cd;
}

enum {
  BOP_LPA = TKN_OPR,
           BOP_RPA, BOP_CMA, BOP_MNS, BOP_AST, BOP_LEQ, BOP_LNE, BOP_LLT, BOP_LLE, BOP_LGT,
  BOP_LGE,
};
  // ZqA؎q
static CODI diBOP[] = {
  { BOP_LPA, "("  }, { BOP_RPA, ")"  }, { BOP_CMA, ","  }, { BOP_MNS, "-"  }, { BOP_AST, "*"  },
  { BOP_LEQ, "="  }, { BOP_LNE, "<>" }, { BOP_LLT, "<"  }, { BOP_LLE, "<=" }, { BOP_LGT, ">"  },
  { BOP_LGE, ">=" }, { BOP_LEQ, "==" }, { BOP_LNE, "!=" }, { BKW_LAN, "&&" }, { BKW_LOR, "||" },
};
static CODS dsBOP = { diBOP, NELEM(diBOP) };

int  LOCALF foprBOL(PCSTR *pp, PBYTE bf, UINT pa)
{ // ZqA؎q
  int cd;
  PCSTR pt = *pp;

  cd = srchopr(&dsBOP, pt); if (cd < 0) return 0;
  pt += strlen(codstr(&dsBOP, cd));
  *pp = pt;
  return cd;
}

static LEXI liBOL = { fspcBOL, fcnsBOL, fstrBOL, fkwdBOL, foprBOL, 0 };

BOOL WINAPI isidn(PCSTR st)
{ // ʎq
  start(st); return token_is(TKN_IDN) && !strcmp(buf(), st);
}

// ---------------------------------------------------------------------- //

HTBL WINAPI CHTBL(PCCOLI co)
{ // \nh
  return CTB(co);
}

#define  SetCOLS(cs, co, nc)  (PCOLS)set_array((HBLK)(cs), co, nc)
#define  SetIDXS(pt, pi, ni)  (PIDXS)set_array((HBLK)(pt), pi, ni)

  // \
typedef struct {
  HBLK  mb;
  PCOLS cs;
  PIDXS vr;
  PIDXS vc;
  HTBL  otb;
  PCSTR nam;
  PCSTR tit;
  PCSTR dsc;
  int   flg;
  FTRG  ftrg;
  PCSTR imp;
  UINT  ext;
} TBLE;
typedef TBLE * PTBLE;

#define  MBK(tb)  (((PTBLE)tb)->mb)
#define  PTR(tb)  ((PBYTE)((PTBLE)tb)->mb->ptr)
#define  LEN(tb)  (((PTBLE)tb)->mb->len)
#define  CAP(tb)  (((PTBLE)tb)->mb->cap)
#define  RSZ(tb)  (((PTBLE)tb)->mb->rsz)
#define  COS(tb)  (((PTBLE)tb)->cs)
#define  COL(tb)  (((PTBLE)tb)->cs->co)
#define  NCO(tb)  (((PTBLE)tb)->cs->nc)
#define  VIR(vw)  (((PTBLE)vw)->vr->pi)
#define  VNR(vw)  (((PTBLE)vw)->vr->ni)
#define  VIC(vw)  (((PTBLE)vw)->vc->pi)
#define  VNC(vw)  (((PTBLE)vw)->vc->ni)
#define  OTB(tb)  (((PTBLE)tb)->otb)
#define  NAM(tb)  (((PTBLE)tb)->nam)
#define  TIT(tb)  (((PTBLE)tb)->tit)
#define  DSC(tb)  (((PTBLE)tb)->dsc)
#define  FLG(tb)  (((PTBLE)tb)->flg)
#define  TRG(tb)  (((PTBLE)tb)->ftrg)
#define  FNM(tb)  (((PTBLE)tb)->imp)
#define  TBX(tb)  (((PTBLE)tb)->ext)

#define  ROW(tb, ir)  ((PBYTE)IPtr(MBK(tb), ir))

#define  UCAP  256

PVOID LOCALF fcalREF(PVOID pv, PCVOID pb, PCCOLI co)
{ // r[
  int ir;
  HTBL tx;
  HBUF rx;

  tx = DBTable(RTI(co));
  memset(pv, 0, SIZ(co));
  rx = CreateRowBuf(tx); if (!rx) return pv;
  CopyKey(rx, MakeRowBuf(CTB(co), (PVOID)pb));
  ir = SearchKey(tx, rx);
  DeleteRowBuf(rx);
  if (ir >= 0) {
    GetTableCellValueX(pv, tx, ir, RCI(co));
  }
  return pv;
}

HTBL WINAPI CreateTableX(PVOID pv, int len, int cap, PCTBLI ti)
{ // \̍쐬
  int i, ofs, mem, aln, flg;
  PTBLE tb;
  HBLK mb;
  PCOLS cx;
  PCOLI co;

  if (cap <= 0) cap = UCAP;
  if (len > cap) cap = len;
  tb = halloc(sizeof(TBLE) + sizeof(HBLK_) + sizeof(COLS) + ti->cs->nc * sizeof(COLI), FALSE); if (!tb) return ierr(E_MEM);
  mb = (PVOID)((PBYTE)tb + sizeof(TBLE));
  cx = (PVOID)((PBYTE)mb + sizeof(HBLK_));
  co = (PVOID)((PBYTE)cx + sizeof(COLS));
  flg = ti->flg;
  ofs = 0;
  mem = 1;
  for (i = 0; i < ti->cs->nc; i++) {
    if (!setcol(&co[i], &ti->cs->co[i], i)) { hfree(tb); return NULL;}
    if (ISCAL(&co[i])) {
      OFS(&co[i]) = 0;
      if (co[i].flg & CF_REF) {
        if (!co[i].fcal) co[i].fcal = fcalREF;
      }
    } else {
      OFS(&co[i]) = ofs;
      aln = btpaln(BTP(&co[i]));
      if (ofs % aln != 0 && !(flg & TF_NOA)) { hfree(tb); return ierr(E_ALN);}
      if (aln > mem) mem = aln;
      ofs += SIZ(&co[i]);
    }
    CTB(&co[i]) = (HTBL)tb;
  }
  if (ofs % mem != 0 && !(flg & TF_NOA)) { hfree(tb); return ierr(E_ALN);}
  if (ti->rsz != 0 && ofs != ti->rsz) { hfree(tb); return ierr(E_RSZ);}
  if (flg & TF_IMP) flg |= TF_RDO;
  if (!pv) {
    pv = halloc(cap * ofs, FALSE); if (!pv) { hfree(tb); return ierr(E_MEM);}
  } else {
    flg |= TF_STA;
  }
  tb->mb = build_array(mb, pv, len, cap, ofs);
  tb->cs = SetCOLS(cx, co, ti->cs->nc);
  tb->vr = tb->vc = NULL;
  tb->otb = NULL;
  tb->nam = ti->nam? ti->nam: "NONAME";
  tb->tit = ti->tit? ti->tit: tb->nam;
  tb->dsc = ti->dsc? ti->dsc: tb->tit;
  tb->flg = flg;
  tb->ftrg= ti->ftrg;
  tb->imp = ti->imp? stostr(ti->imp): addext(tb->nam, (tb->flg & TF_CYP)? ".BTC": ".BTB");
  tb->ext = ti->ext;
  return (HTBL)tb;
}

HTBL LOCALF CreateTableXB(PVOID pv, int len, int cap, PCTBLI ti)
{ // \̍쐬
  int i, nc;
  HTBL tb;
  PCOLI co;

  tb = CreateTableX(pv, len, cap, ti); if (!tb) return NULL;
  nc = NCO(tb); co = COL(tb);
  for (i = 0; i < nc; i++) {
    if (co[i].fcal && co[i].fcal != fcalREF) co[i].flg |= CF_OCL;
    if (co[i].fchk) co[i].flg |= CF_OCK;
  }
  if (TRG(tb)) FLG(tb) |= TF_OTR;
  return tb;
}

HTBL WINAPI CreateTable(int cap, PCTBLI ti)
{ // \̍쐬
  return CreateTableX(NULL, 0, cap, ti);
}

HTBL LOCALF CreateTableB(int cap, PCTBLI ti)
{ // \̍쐬
  return CreateTableXB(NULL, 0, cap, ti);
}

void WINAPI DeleteTable(HTBL tb)
{ // \̍폜
  if (!tb) return;
  if (!(FLG(tb) & (TF_STA|TF_STB|TF_VIW))) hfree(PTR(tb));
  if (FLG(tb) & TF_VIW) hfree(VIR(tb));
  if (FLG(tb) & TF_TMP) return;
  hfree(tb);
}

int  WINAPI NTableKeys(HTBL tb)
{ // L[̐
  int i, n, nc = NCO(tb);
  PCCOLI co = COL(tb);

  for (n = i = 0; i < nc; i++) {
    if (co[i].flg & CF_KEY) n++;
  }
  return n;
}

int  WINAPI NTableRefs(HTBL tb, PINT pi)
{ // OL[񍀖ڂ̐
  int i, n, nc = NCO(tb);
  PCCOLI co = COL(tb);

  for (n = i = 0; i < nc; i++) {
    if (!ISCAL(&co[i]) && (co[i].flg & CF_REF)) {
      if (pi) pi[n] = RTI(&co[i]);
      n++;
    }
  }
  return n;
}

HTBL WINAPI CreateCompatibleTable(HTBL tb, int cap)
{ // ^\̍쐬
  PVOID pv;
  PTBLE tc;
  HBLK mb;

  if (cap <= 0) cap = UCAP;
  tc = halloc(sizeof(TBLE) + sizeof(HBLK_), FALSE); if (!tc) return ierr(E_MEM);
  mb = (PVOID)((PBYTE)tc + sizeof(TBLE));
  pv = halloc(cap * RSZ(tb), FALSE); if (!pv) { hfree(tc); return ierr(E_MEM);}
  *tc = *(TBLE *)tb;
  tc->mb = build_array(mb, pv, 0, cap, RSZ(tb));
  tc->flg = FLG(tb) &~(TF_STA|TF_STB|TF_VIW);
  return (HTBL)tc;
}

BOOL WINAPI IsCompatible(HTBL tb, HTBL tx)
{ // \^
  int i, j, of1, of2, ni, nj;
  PCCOLS cs = COS(tb), cx = COS(tx);

  if (cs == cx) return TRUE;
  ni = of1 = 0;
  for (i = 0; i < cs->nc; i++) {
    if (ISCAL(&cs->co[i])) continue;
    ni++;
    of2 = 0;
    for (j = 0; j < cx->nc; j++) {
      if (ISCAL(&cx->co[j])) continue;
      if (of1 == of2 && cs->co[i].itp == cx->co[j].itp && !strcmp(cs->co[i].nam, cx->co[j].nam)) goto _L1;
      of2 += SIZ(&cx->co[j]);
    }
    return FALSE;
   _L1:
    of1 += SIZ(&cs->co[i]);
  }
  nj = 0;
  for (j = 0; j < cx->nc; j++) {
    if (ISCAL(&cx->co[j])) continue;
    nj++;
  }
  return ni == nj;
}

HTBL WINAPI DuplicateTable(HTBL tb)
{ // \̕
  HTBL tc;

  tc = CreateCompatibleTable(tb, CAP(tb)); if (!tc) return NULL;
  memcpy(PTR(tc), PTR(tb), LEN(tb) * RSZ(tb));
  LEN(tc) = LEN(tb);
  return tc;
}

int  WINAPI TableRowSize(HTBL tb)
{ // s̃TCY
  return RSZ(tb);
}

int  WINAPI NTableRows(HTBL tb)
{ // s
  return LEN(tb);
}

PVOID WINAPI TablePtr(HTBL tb)
{ // \f[^̐擪AhX
  return PTR(tb);
}

PVOID WINAPI TableRow(HTBL tb, int ir)
{ // s̃AhX
  if (ir < 0 || ir >= LEN(tb)) { ierr(E_IRO); return valloc(RSZ(tb));}
  return ROW(tb, ir);
}

int  WINAPI TableRowIndex(HTBL tb, PCVOID pb)
{ // s̃AhXsCfbNX߂
  return ((PBYTE)pb - PTR(tb)) / RSZ(tb);
}

int  WINAPI TableCapacity(HTBL tb)
{ // ős
  return CAP(tb);
}

BOOL LOCALF ChangeTableCapacityX(HTBL tb, int cap)
{ // ős̕ύX
  HBLK_ blk;

  if (cap <= 0 || cap < LEN(tb)) return (BOOL)ierr(E_PAR);
  if (FLG(tb) & TF_STA) return (BOOL)ierr(E_STA);
  cap = nbound(cap, UCAP);
  if (FLG(tb) & TF_VIW) {
    if (!change_capacity(build_array(&blk, VIR(tb), VNR(tb), CAP(tb), sizeof(int)), cap)) return FALSE;
    VIR(tb) = blk.ptr;
  }
  return change_capacity(MBK(tb), cap);
}

BOOL WINAPI ChangeTableCapacity(HTBL tb, int cap)
{ // ős̕ύX
  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(tb) & TF_FIX) return (BOOL)ierr(E_FIX);
  return ChangeTableCapacityX(tb, cap);
}

PCSTR WINAPI TableName(HTBL tb)
{ // \
  return NAM(tb);
}

void WINAPI SetTableTitle(HTBL tb, PCSTR tit)
{ // \^Cg̐ݒ
  TIT(tb) = tit? tit: NAM(tb);
}

PCSTR WINAPI TableTitle(HTBL tb)
{ // \^Cg
  return TIT(tb);
}

void WINAPI SetTableDescription(HTBL tb, PCSTR dsc)
{ // \̐ݒ
  DSC(tb) = dsc? dsc: TIT(tb);
}

PCSTR WINAPI TableDescription(HTBL tb)
{ // \
  return DSC(tb);
}

void WINAPI SetTableFlags(HTBL tb, int flg)
{ // \̐ݒ
  FLG(tb) = flg;
}

int  WINAPI TableFlags(HTBL tb)
{ // \
  return FLG(tb);
}

void WINAPI SetTableFileName(HTBL tb, PCSTR nam)
{ // \t@C̐ݒ
  FNM(tb) = nam? stostr(nam): addext(NAM(tb), (FLG(tb) & TF_CYP)? ".BTC": ".BTB");
}

PCSTR WINAPI TableFileName(HTBL tb)
{ // \t@C
  return FNM(tb);
}

void WINAPI SetTableExtra(HTBL tb, UINT pa)
{ // \̕t̐ݒ
  TBX(tb) = pa;
}

UINT WINAPI TableExtra(HTBL tb)
{ // \̕t
  return TBX(tb);
}

int  LOCALF srchval(HTBL tb, int ir, PCVOID pb, PCCOLI co)
{ // Ӑ`FbN
  int sz = RSZ(tb);
  PCBYTE pc, pi, pe;

  for (pc = PTR(tb), pi = pc + ir * sz, pe = pc + LEN(tb) * sz; pc < pe; pc += sz) {
    if (!memcmp(pc + OFS(co), (PBYTE)pb + OFS(co), SIZ(co)) && pc != pi) return (pc - PTR(tb)) / sz;
  }
  return -1;
}

int  LOCALF srchkey(HTBL tb, int ir, PCVOID pb)
{ // L[̈Ӑ`FbN
  int i, sz = RSZ(tb), nc = NCO(tb);
  PCBYTE pc, pi, pe;
  PCCOLI co = COL(tb);

  for (pc = PTR(tb), pi = pc + ir * sz, pe = pc + LEN(tb) * sz; pc < pe; pc += sz) {
    for (i = 0; i < nc; i++) {
      if (co[i].flg & CF_KEY) {
        if (memcmp(pc + OFS(&co[i]), (PBYTE)pb + OFS(&co[i]), SIZ(&co[i]))) goto _LC;
      }
    }
    if (pc != pi) return (pc - PTR(tb)) / sz;
   _LC:;
  }
  return -1;
}

int  LOCALF srchref(HTBL tb, int id, PCVOID pb)
{ // OL[ɂT[`
  int ir;
  HTBL tx;
  HBUF rx;

  tx = DBTable(id);
  rx = CreateRowBuf(tx); if (!rx) return -1;
  CopyKey(rx, MakeRowBuf(tb, (PVOID)pb));
  ir = SearchKey(tx, rx);
  DeleteRowBuf(rx);
  return ir;
}

BOOL LOCALF zeroref(HTBL tb, int id, PCVOID pb)
{ // OL[ɋl
  int i, nc = NCO(tb);
  PCCOLI co = COL(tb);

  for (i = 0; i < nc; i++) {
    if (!ISCAL(&co[i]) && (co[i].flg & CF_REF) && RTI(&co[i]) == id) {
      if (iszero((PBYTE)pb + OFS(&co[i]), SIZ(&co[i]))) return TRUE;
    }
  }
  return FALSE;
}

#define  terr(ec, ir, ic)  serr(ec, TableName(tb), ir, ic)

BOOL WINAPI DefaultTableTrigger(HTBL tb, int msg, int ir, PVOID pb)
{ // ̃gK֐
  int i, nc, nt, id[64];
  PCCOLI co;

  switch (LOWORD(msg)) {
  case TRGM_BEFOREUPDATEOF:
    i = HIWORD(msg);
    co = &COL(tb)[HIWORD(msg)];
    if (!chkval(pb, co)) return (BOOL)terr(E_CHK, ir, i);
    if (co->flg & CF_NZR) {
      if (iszero((PBYTE)pb + OFS(co), SIZ(co))) return (BOOL)terr(E_NZR, ir, i);
    }
    if (co->flg & CF_UNI) {
      if (srchval(tb, ir, pb, co) >= 0) return (BOOL)terr(E_UNI, ir, i);
    }
    if (co->flg & CF_KEY && NTableKeys(tb) == 1) {
      if (srchkey(tb, ir, pb) >= 0) return (BOOL)terr(E_KEY, ir, i);
    }
    if (!ISCAL(co) && co->flg & CF_REF) {
      if (srchref(tb, RTI(co), pb) < 0 && !zeroref(tb, RTI(co), pb)) return (BOOL)terr(E_REF, ir, i);
    }
    break;
  case TRGM_BEFOREUPDATE:
    nc = NCO(tb); co = COL(tb);
    for (i = 0; i < nc; i++) {
      if (!chkval(pb, &co[i])) return (BOOL)terr(E_CHK, ir, i);
      if (co[i].flg & CF_NZR) {
        if (iszero((PBYTE)pb + OFS(&co[i]), SIZ(&co[i]))) return (BOOL)terr(E_NZR, ir, i);
      }
      if (co[i].flg & CF_UNI) {
        if (srchval(tb, ir, pb, &co[i]) >= 0) return (BOOL)terr(E_UNI, ir, i);
      }
    }
    if (NTableKeys(tb)) {
      if (srchkey(tb, ir, pb) >= 0) return (BOOL)terr(E_KEY, ir, -1);
    }
    if ((nt = NTableRefs(tb, id)) > 0) {
      for (i = 0; i < nt; i++) {
        if (srchref(tb, id[i], pb) < 0 && !zeroref(tb, id[i], pb)) return (BOOL)terr(E_REF, ir, -1);
      }
    }
    break;
  case TRGM_DEFAULT:
    nc = NCO(tb); co = COL(tb);
    for (i = 0; i < nc; i++) {
      clrval((PBYTE)pb + OFS(&co[i]), pb, &co[i]);
    }
    break;
  }
  return TRUE;
}

BOOL LOCALF tb_ftrg(HTBL tb, int msg, int ir, PVOID pb)
{ // gK֐Ăяo
  BYTE ar[16], rv[4];

  if (FLG(tb) & TF_OTR) {
    *(P4B *)ar = tb; *(I4B *)(ar + 4) = msg; *(I4B *)(ar + 8) = ir; *(P4B *)(ar + 12) = pb;
    CallBCD(rv, hbCur, (int)TRG(tb), ar);
    return *(I4B *)rv;
  }
  return TRG(tb)(tb, msg, ir, pb);
}

BOOL WINAPI TableTrigger(HTBL tb, int msg, int ir, PVOID pb)
{ // gK֐Ăяo
  switch (msg) {
  case TRGM_DEFAULT:
    memset(pb, 0, RSZ(tb)); break;
  }
  if (FLG(tb) & TF_DTR) return TRUE;
  if (TRG(tb)) return tb_ftrg(tb, msg, ir, pb);
  return DefaultTableTrigger(tb, msg, ir, pb);
}

BOOL WINAPI EnableTableTrigger(HTBL tb)
{ // gKL
  int bk = !(FLG(tb) & TF_DTR); FLG(tb) &=~TF_DTR; return bk;
}

BOOL WINAPI DisableTableTrigger(HTBL tb)
{ // gK
  int bk = !(FLG(tb) & TF_DTR); FLG(tb) |= TF_DTR; return bk;
}

int  WINAPI NTableColumns(HTBL tb)
{ // 
  return NCO(tb);
}

PCCOLI LOCALF TableColumnInfoX(HTBL tb, int ic)
{ // 
  return &COL(tb)[ic];
}

PCCOLI WINAPI TableColumnInfo(HTBL tb, int ic)
{ // 
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return valloc(sizeof(COLI));}
  return &COL(tb)[ic];
}

void WINAPI SetTableColumnWidth(HTBL tb, int ic, int wd)
{ // 񕝂̐ݒ
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return;}
  WID(&COL(tb)[ic]) = (BYTE)wd;
}

int  WINAPI TableColumnWidth(HTBL tb, int ic)
{ // 
  if (ic < 0 || ic >= NCO(tb)) return (int)ierr(E_ICO);
  return WID(&COL(tb)[ic]);
}

void WINAPI SetTableColumnTextAlign(HTBL tb, int ic, int al)
{ // ̕R[h̐ݒ
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return;}
  ALN(&COL(tb)[ic]) = (BYTE)al;
}

int  WINAPI TableColumnTextAlign(HTBL tb, int ic)
{ // ̕R[h
  if (ic < 0 || ic >= NCO(tb)) return (int)ierr(E_ICO);
  return ALN(&COL(tb)[ic]);
}

int  WINAPI TableColumnOffset(HTBL tb, int ic)
{ // ̃ItZbg
  if (ic < 0 || ic >= NCO(tb)) return (int)ierr(E_ICO);
  return OFS(&COL(tb)[ic]);
}

PCSTR WINAPI TableColumnName(HTBL tb, int ic)
{ // 
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return "";}
  return COL(tb)[ic].nam;
}

int  WINAPI TableColumnIndex(HTBL tb, PCSTR nam)
{ // 񖼂CfbNX߂
  int i, nc = NCO(tb);
  PCCOLI co = COL(tb);

  for (i = 0; i < nc; i++) {
    if (!strcmp(co[i].nam, nam)) return i;
  }
  return -1;
}

void WINAPI SetTableColumnTitle(HTBL tb, int ic, PCSTR tit)
{ // ^Cg̐ݒ
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return;}
  COL(tb)[ic].tit = tit? tit: COL(tb)[ic].nam;
}

PCSTR WINAPI TableColumnTitle(HTBL tb, int ic)
{ // ^Cg
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return "";}
  return COL(tb)[ic].tit;
}

void WINAPI SetTableColumnDescription(HTBL tb, int ic, PCSTR dsc)
{ // ̐ݒ
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return;}
  COL(tb)[ic].dsc = dsc? dsc: COL(tb)[ic].tit;
}

PCSTR WINAPI TableColumnDescription(HTBL tb, int ic)
{ // 
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return "";}
  return COL(tb)[ic].dsc;
}

void WINAPI SetTableColumnFlags(HTBL tb, int ic, int flg)
{ // 񑮐̐ݒ
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return;}
  COL(tb)[ic].flg = flg;
}

int  WINAPI TableColumnFlags(HTBL tb, int ic)
{ // 񑮐
  if (ic < 0 || ic >= NCO(tb)) return (int)ierr(E_ICO);
  return COL(tb)[ic].flg;
}

void WINAPI SetTableColumnExtra(HTBL tb, int ic, UINT pa)
{ // ̕t̐ݒ
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return;}
  COX(&COL(tb)[ic]) = pa;
}

UINT WINAPI TableColumnExtra(HTBL tb, int ic)
{ // ̕t
  if (ic < 0 || ic >= NCO(tb)) return (UINT)ierr(E_ICO);
  return COX(&COL(tb)[ic]);
}

BOOL LOCALF SetTableCellValueX(HTBL tb, int ir, int ic, PCVOID pv)
{ // l̐ݒ
  PVOID pb, bk;

  memcpy(bk = ualloc(RSZ(tb)), pb = ROW(tb, ir), RSZ(tb));
  setval(pb, pv, &COL(tb)[ic]);
  if (!TableTrigger(tb, MAKEUINT(TRGM_BEFOREUPDATEOF, ic), ir, pb)) {
    memcpy(pb, bk, RSZ(tb)); return FALSE;
  }
  TableTrigger(tb, MAKEUINT(TRGM_AFTERUPDATEOF, ic), ir, pb);
  return TRUE;
}

BOOL WINAPI SetTableCellValue(HTBL tb, int ir, int ic, PCVOID pv)
{ // l̐ݒ
  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ir < 0 || ir >= LEN(tb)) return (BOOL)ierr(E_IRO);
  if (ic < 0 || ic >= NCO(tb)) return (BOOL)ierr(E_ICO);
  if (ISCAL(&COL(tb)[ic])) return (BOOL)ierr(E_CAL);
  return SetTableCellValueX(tb, ir, ic, pv);
}

PVOID LOCALF GetTableCellValueX(PVOID pv, HTBL tb, int ir, int ic)
{ // l̎擾
  return getval(pv, ROW(tb, ir), &COL(tb)[ic]);
}

PVOID WINAPI GetTableCellValue(PVOID pv, HTBL tb, int ir, int ic)
{ // l̎擾
  if (ir < 0 || ir >= LEN(tb)) { ierr(E_IRO); return pv;}
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return pv;}
  return getval(pv, ROW(tb, ir), &COL(tb)[ic]);
}

BOOL LOCALF ScanTableCellValueX(HTBL tb, int ir, int ic, PCSTR st)
{ // 񂩂Ǎ
  BYTE pv[512];

  scnval(pv, st, &COL(tb)[ic]);
  return SetTableCellValueX(tb, ir, ic, pv);
}

BOOL WINAPI ScanTableCellValue(HTBL tb, int ir, int ic, PCSTR st)
{ // 񂩂Ǎ
  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ir < 0 || ir >= LEN(tb)) return (BOOL)ierr(E_IRO);
  if (ic < 0 || ic >= NCO(tb)) return (BOOL)ierr(E_ICO);
  if (ISCAL(&COL(tb)[ic])) return (BOOL)ierr(E_CAL);
  return ScanTableCellValueX(tb, ir, ic, st);
}

PSTR LOCALF PrintTableCellValueX(PSTR st, HTBL tb, int ir, int ic)
{ // ɏo
  return prnval(st, ROW(tb, ir) + OFS(&COL(tb)[ic]), &COL(tb)[ic]);
}

PSTR WINAPI PrintTableCellValue(PSTR st, HTBL tb, int ir, int ic)
{ // ɏo
  if (ir < 0 || ir >= LEN(tb)) { ierr(E_IRO); st[0] = '\0'; return st;}
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); st[0] = '\0'; return st;}
  return prnval(st, ROW(tb, ir) + OFS(&COL(tb)[ic]), &COL(tb)[ic]);
}

BOOL WINAPI ClearTableRow(HTBL tb, int ir)
{ // s̃NA
  return ClearTableRows(tb, ir, 1);
}

BOOL WINAPI ClearTableRows(HTBL tb, int ir, int nr)
{ // ͈͂̃NA
  int i, ln = LEN(tb), sz = RSZ(tb), re = TRUE;
  PVOID pb, bk;

  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ir < 0 || ir > ln || nr < 0) return (BOOL)ierr(E_IRO);
  if (ir + nr > ln) nr = ln - ir;
  bk = ualloc(sz);
  for (i = ir; i < ir + nr; i++) {
    memcpy(bk, pb = ROW(tb, i), sz);
    TableTrigger(tb, TRGM_DEFAULT, i, pb);
    if (!TableTrigger(tb, TRGM_BEFOREUPDATE, i, pb)) {
      memcpy(pb, bk, sz); re = FALSE;
    } else {
      TableTrigger(tb, TRGM_AFTERUPDATE, i, pb);
    }
  }
  return re;
}

#define  InsertTableRowX(tb, ir)  InsertTableRowsX(tb, ir, 1)

BOOL LOCALF InsertTableRowsX(HTBL tb, int ir, int nr)
{ // ͈͂̑}
  int i, ln = LEN(tb);

  if (ln + nr > CAP(tb)) {
    if (!ChangeTableCapacityX(tb, ln + nr)) return FALSE;
  }
  if (ir < ln) {
    memmove(ROW(tb, ir + nr), ROW(tb, ir), (ln - ir) * RSZ(tb));
  }
  LEN(tb) += nr;
  for (i = ir; i < ir + nr; i++) {
    TableTrigger(tb, TRGM_DEFAULT, i, ROW(tb, i));
  }
  return TRUE;
}

BOOL WINAPI InsertTableRow(HTBL tb, int ir)
{ // s̑}
  return InsertTableRows(tb, ir, 1);
}

BOOL WINAPI InsertTableRows(HTBL tb, int ir, int nr)
{ // ͈͂̑}
  int ln = LEN(tb);

  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(tb) & TF_FIX) return (BOOL)ierr(E_FIX);
  if (ir < 0 || ir > ln || nr < 0) return (BOOL)ierr(E_IRO);
  return InsertTableRowsX(tb, ir, nr);
}

#define  DeleteTableRowX(tb, ir)  DeleteTableRowsX(tb, ir, 1);

void LOCALF DeleteTableRowsX(HTBL tb, int ir, int nr)
{ // ͈͂̍폜
  int ln = LEN(tb);

  if (ir + nr < ln) {
    memmove(ROW(tb, ir), ROW(tb, ir + nr), (ln - ir - nr) * RSZ(tb));
  }
  LEN(tb) -= nr;
}

BOOL WINAPI DeleteTableRow(HTBL tb, int ir)
{ // s̍폜
  return DeleteTableRows(tb, ir, 1);
}

BOOL WINAPI DeleteTableRows(HTBL tb, int ir, int nr)
{ // ͈͂̍폜
  int i, ln = LEN(tb);

  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(tb) & TF_FIX) return (BOOL)ierr(E_FIX);
  if (ir < 0 || ir > ln || nr < 0) return (BOOL)ierr(E_IRO);
  if (ir == ln) return TRUE;
  if (ir + nr > ln) nr = ln - ir;
  for (i = ir; i < ir + nr; i++) {
    if (!TableTrigger(tb, TRGM_BEFOREDELETE, i, ROW(tb, i))) return FALSE;
  }
  DeleteTableRowsX(tb, ir, nr);
  return TRUE;
}

BOOL LOCALF AddTableRowX(HTBL tb)
{ // s̒ǉ
  return InsertTableRowX(tb, LEN(tb));
}

BOOL WINAPI AddTableRow(HTBL tb)
{ // s̒ǉ
  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(tb) & TF_FIX) return (BOOL)ierr(E_FIX);
  return AddTableRowX(tb);
}

PVOID LOCALF NewTableRowX(HTBL tb)
{ // ǉs
  return AddTableRowX(tb)? ROW(tb, LEN(tb) - 1): valloc(RSZ(tb));
}

PVOID WINAPI NewTableRow(HTBL tb)
{ // ǉs
  return AddTableRow(tb)? ROW(tb, LEN(tb) - 1): valloc(RSZ(tb));
}

HTBL WINAPI CopyTable(HTBL tb, HTBL tx)
{ // \̃Rs[
  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX && LEN(tb) != LEN(tx)) { ierr(E_FIX); return tb;}
  if (LEN(tx) > CAP(tb)) {
    if (!ChangeTableCapacityX(tb, LEN(tx))) return tb;
  }
  memcpy(PTR(tb), PTR(tx), LEN(tx) * RSZ(tx));
  LEN(tb) = LEN(tx);
  return tb;
}

HTBL WINAPI MergeTableX(HTBL tb, HTBL tx)
{ // \̃}[W
  int i, sz = RSZ(tb), lx = LEN(tx);

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return tb;}
  for (i = 0; i < lx; i++) {
    memcpy(NewTableRowX(tb), ROW(tx, i), sz);
  }
  return tb;
}

int  WINAPI CompareTable(HTBL tb, HTBL tx)
{ // \̔r
  int s1 = LEN(tb) * RSZ(tb), s2 = LEN(tx) * RSZ(tx);

  return (s1 == s2)? memcmp(PTR(tb), PTR(tx), s1): s1 - s2;
}

BOOL LOCALF fselBCD(int ent, PCVOID pb, UINT pa)
{ // I֐
  BYTE ar[8], rv[4];

  *(P4B *)ar = (P4B)pb; *(U4B *)(ar + 4) = pa;
  CallBCD(rv, hbAct, ent, ar);
  return *(I4B *)rv;
}

int  WINAPI SearchTableRowX(HTBL tb, int i0, FSEL fsel, UINT pa)
{ // T[`
  int i, ln = LEN(tb);

  if (i0 < 0 || i0 > ln) { ierr(E_IRO); return -1;}
  if (!fsel) return i0;
  for (i = i0; i < ln; i++) {
    if (fsel(ROW(tb, i), pa)) return i;
  }
  return -1;
}

int  LOCALF SearchTableRowXB(HTBL tb, int i0, FSEL fsel, UINT pa)
{ // T[`
  int i, ln = LEN(tb);

  if (i0 < 0 || i0 > ln) { ierr(E_IRO); return -1;}
  if (!fsel) return i0;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return i0;}
  for (i = i0; i < ln; i++) {
    if (fselBCD((int)fsel, ROW(tb, i), pa)) return i;
  }
  return -1;
}

int  WINAPI CountTableRowsX(HTBL tb, FSEL fsel, UINT pa)
{ // JEg
  int i, n, ln = LEN(tb);

  if (!fsel) return ln;
  for (n = i = 0; i < ln; i++) {
    if (fsel(ROW(tb, i), pa)) n++;
  }
  return n;
}

int  LOCALF CountTableRowsXB(HTBL tb, FSEL fsel, UINT pa)
{ // JEg
  int i, n, ln = LEN(tb);

  if (!fsel) return ln;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return ln;}
  for (n = i = 0; i < ln; i++) {
    if (fselBCD((int)fsel, ROW(tb, i), pa)) n++;
  }
  return n;
}

int  WINAPI SelectTableRowsX(HTBL tb, FSEL fsel, UINT pa)
{ // i荞
  int i, n, ln = LEN(tb), sz = RSZ(tb);

  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return ln;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return ln;}
  if (!fsel) return ln;
  for (n = i = 0; i < ln; i++) {
    if (fsel(ROW(tb, i), pa)) {
      if (i > n) memcpy(ROW(tb, n), ROW(tb, i), sz);
      n++;
    }
  }
  return LEN(tb) = n;
}

int  LOCALF SelectTableRowsXB(HTBL tb, FSEL fsel, UINT pa)
{ // i荞
  int i, n, ln = LEN(tb), sz = RSZ(tb);

  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return ln;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return ln;}
  if (!fsel) return ln;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return ln;}
  for (n = i = 0; i < ln; i++) {
    if (fselBCD((int)fsel, ROW(tb, i), pa)) {
      if (i > n) memcpy(ROW(tb, n), ROW(tb, i), sz);
      n++;
    }
  }
  return LEN(tb) = n;
}

int  LOCALF InvSelectTableRowsX(HTBL tb, FSEL fsel, UINT pa)
{ // i荞(])
  int i, n, ln = LEN(tb), sz = RSZ(tb);

  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return ln;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return ln;}
  if (!fsel) return LEN(tb) = 0;
  for (n = i = 0; i < ln; i++) {
    if (!fsel(ROW(tb, i), pa)) {
      if (i > n) memcpy(ROW(tb, n), ROW(tb, i), sz);
      n++;
    }
  }
  return LEN(tb) = n;
}

int  LOCALF InvSelectTableRowsXB(HTBL tb, FSEL fsel, UINT pa)
{ // i荞(])
  int i, n, ln = LEN(tb), sz = RSZ(tb);

  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return ln;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return ln;}
  if (!fsel) return ln;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return ln;}
  for (n = i = 0; i < ln; i++) {
    if (!fselBCD((int)fsel, ROW(tb, i), pa)) {
      if (i > n) memcpy(ROW(tb, n), ROW(tb, i), sz);
      n++;
    }
  }
  return LEN(tb) = n;
}

HTBL WINAPI SelectCopyTableX(HTBL tb, HTBL tx, FSEL fsel, UINT pa)
{ // i荞݃Rs[
  int i, sz = RSZ(tb), lx = LEN(tx);

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return tb;}
  if (!fsel) return CopyTable(tb, tx);
  LEN(tb) = 0;
  for (i = 0; i < lx; i++) {
    if (fsel(ROW(tx, i), pa)) {
      memcpy(NewTableRowX(tb), ROW(tx, i), sz);
    }
  }
  return tb;
}

HTBL LOCALF SelectCopyTableXB(HTBL tb, HTBL tx, FSEL fsel, UINT pa)
{ // i荞݃Rs[
  int i, sz = RSZ(tb), lx = LEN(tx);

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return tb;}
  if (!fsel) return CopyTable(tb, tx);
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return CopyTable(tb, tx);}
  LEN(tb) = 0;
  for (i = 0; i < lx; i++) {
    if (fselBCD((int)fsel, ROW(tx, i), pa)) {
      memcpy(NewTableRowX(tb), ROW(tx, i), sz);
    }
  }
  return tb;
}

HTBL WINAPI SelectMergeTableX(HTBL tb, HTBL tx, FSEL fsel, UINT pa)
{ // i荞݃}[W(u)
  int i, sz = RSZ(tb), lx = LEN(tx);

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return tb;}
  if (!fsel) return CopyTable(tb, tx);
  InvSelectTableRowsX(tb, fsel, pa);
  for (i = 0; i < lx; i++) {
    if (fsel(ROW(tx, i), pa)) {
      memcpy(NewTableRowX(tb), ROW(tx, i), sz);
    }
  }
  return tb;
}

HTBL LOCALF SelectMergeTableXB(HTBL tb, HTBL tx, FSEL fsel, UINT pa)
{ // i荞݃}[W(u)
  int i, sz = RSZ(tb), lx = LEN(tx);

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return tb;}
  if (!fsel || InvSelectTableRowsXB(tb, fsel, pa) == LEN(tb)) return CopyTable(tb, tx);
  for (i = 0; i < lx; i++) {
    if (fselBCD((int)fsel, ROW(tx, i), pa)) {
      memcpy(NewTableRowX(tb), ROW(tx, i), sz);
    }
  }
  return tb;
}

int  WINAPI AggregateTableX(HTBL tb, FSEL fsel, UINT ps, FAGG fagg, UINT pa)
{ // Wv
  int i, n, ln = LEN(tb);

  switch (!!fsel * 2 + !!fagg) {
  case 0:
    n = ln;
    break;
  case 1:
    for (n = i = 0; i < ln; i++) {
      if (fagg(ROW(tb, i), pa)) n++;
    }
    break;
  case 2:
    for (n = i = 0; i < ln; i++) {
      if (fsel(ROW(tb, i), ps)) n++;
    }
    break;
  case 3:
    for (n = i = 0; i < ln; i++) {
      if (fsel(ROW(tb, i), ps) && fagg(ROW(tb, i), pa)) n++;
    }
    break;
  }
  return n;
}

int  LOCALF AggregateTableXB(HTBL tb, FSEL fsel, UINT ps, FAGG fagg, UINT pa)
{ // Wv
  int i, n, ln = LEN(tb);

  if (!fsel && !fagg) return ln;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return ln;}
  switch (!!fsel * 2 + !!fagg) {
  case 1:
    for (n = i = 0; i < ln; i++) {
      if (fselBCD((int)fagg, ROW(tb, i), pa)) n++;
    }
    break;
  case 2:
    for (n = i = 0; i < ln; i++) {
      if (fselBCD((int)fsel, ROW(tb, i), ps)) n++;
    }
    break;
  case 3:
    for (n = i = 0; i < ln; i++) {
      if (fselBCD((int)fsel, ROW(tb, i), ps) && fselBCD((int)fagg, ROW(tb, i), pa)) n++;
    }
    break;
  }
  return n;
}

int  LOCALF fcmpBCD(int ent, PCVOID p1, PCVOID p2, UINT pa)
{ // r֐
  BYTE ar[12], rv[4];

  *(P4B *)ar = (P4B)p1; *(P4B *)(ar + 4) = (P4B)p2; *(U4B *)(ar + 8) = pa;
  CallBCD(rv, hbAct, ent, ar);
  return *(I4B *)rv;
}

void WINAPI SortTableRowsX(HTBL tb, FSRT fcmp, UINT pa)
{ // בւ
  int g, i, j, s, ln = LEN(tb), sz = RSZ(tb);
  PVOID bf;

  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return;}
  if (!fcmp || ln <= 1) return;
  bf = ualloc(sz);
  g = ln;
  do {
    switch (g = g * 10 / 13) {
    case 0: g = 1; break;
    case 9: case 10: g = 11; break;
    }
    s = 0;
    for (i = 0, j = g; j < ln; i++, j++) {
      if (fcmp(ROW(tb, i), ROW(tb, j), pa) > 0) {
        memcpy(bf, ROW(tb, i), sz);
        memcpy(ROW(tb, i), ROW(tb, j), sz);
        memcpy(ROW(tb, j), bf, sz);
        s = 1;
      }
    }
  } while (s != 0 || g > 1);
}

void LOCALF SortTableRowsXB(HTBL tb, FSRT fcmp, UINT pa)
{ // בւ
  int g, i, j, s, ln = LEN(tb), sz = RSZ(tb);
  PVOID bf;

  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return;}
  if (!fcmp || ln <= 1) return;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return;}
  bf = ualloc(sz);
  g = ln;
  do {
    switch (g = g * 10 / 13) {
    case 0: g = 1; break;
    case 9: case 10: g = 11; break;
    }
    s = 0;
    for (i = 0, j = g; j < ln; i++, j++) {
      if (fcmpBCD((int)fcmp, ROW(tb, i), ROW(tb, j), pa) > 0) {
        memcpy(bf, ROW(tb, i), sz);
        memcpy(ROW(tb, i), ROW(tb, j), sz);
        memcpy(ROW(tb, j), bf, sz);
        s = 1;
      }
    }
  } while (s != 0 || g > 1);
}

int  WINAPI SearchTableCellValue(HTBL tb, int i0, int ic, PCVOID pv)
{ // l̃T[`
  int i, ln = LEN(tb);
  PCCOLI co;
  BYTE rv[512];

  if (i0 < 0 || i0 > ln) { ierr(E_IRO); return -1;}
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return -1;}
  co = &COL(tb)[ic];
  for (i = i0; i < ln; i++) {
    if (!memcmp(getval(rv, ROW(tb, i), co), pv, SIZ(co))) return i;
  }
  return -1;
}

typedef BOOL (CALLBACK * FSTX)(PCSTR s1, PCSTR s2);

BOOL LOCALF fstx0(PCSTR s1, PCSTR s2) { return !strfind(s1, s2);}
BOOL LOCALF fstx1(PCSTR s1, PCSTR s2) { return !strfind(toupr(s1), s2);}
BOOL LOCALF fstx2(PCSTR s1, PCSTR s2) { return !strfind(tohan(s1), s2);}
BOOL LOCALF fstx3(PCSTR s1, PCSTR s2) { return !strfind(tohan(toupr(s1)), s2);}
BOOL LOCALF fstx4(PCSTR s1, PCSTR s2) { return !strfind(delspc(s1), s2);}
BOOL LOCALF fstx5(PCSTR s1, PCSTR s2) { return !strfind(delspc(toupr(s1)), s2);}
BOOL LOCALF fstx6(PCSTR s1, PCSTR s2) { return !strfind(delspc(tohan(s1)), s2);}
BOOL LOCALF fstx7(PCSTR s1, PCSTR s2) { return !strfind(delspc(tohan(toupr(s1))), s2);}
BOOL LOCALF fstx8(PCSTR s1, PCSTR s2) { return !!strcmp(s1, s2);}
BOOL LOCALF fstx9(PCSTR s1, PCSTR s2) { return !!stricmp(s1, s2);}
BOOL LOCALF fstxA(PCSTR s1, PCSTR s2) { return !!strcmp(tohan(s1), s2);}
BOOL LOCALF fstxB(PCSTR s1, PCSTR s2) { return !!stricmp(tohan(s1), s2);}
BOOL LOCALF fstxC(PCSTR s1, PCSTR s2) { return !!strcmp(delspc(s1), s2);}
BOOL LOCALF fstxD(PCSTR s1, PCSTR s2) { return !!stricmp(delspc(s1), s2);}
BOOL LOCALF fstxE(PCSTR s1, PCSTR s2) { return !!strcmp(delspc(tohan(s1)), s2);}
BOOL LOCALF fstxF(PCSTR s1, PCSTR s2) { return !!stricmp(delspc(tohan(s1)), s2);}
BOOL LOCALF fstxG(PCSTR s1, PCSTR s2) { return !strlfind(s1, s2);}
BOOL LOCALF fstxH(PCSTR s1, PCSTR s2) { return !strlfind(toupr(s1), s2);}
BOOL LOCALF fstxI(PCSTR s1, PCSTR s2) { return !strlfind(tohan(s1), s2);}
BOOL LOCALF fstxJ(PCSTR s1, PCSTR s2) { return !strlfind(tohan(toupr(s1)), s2);}
BOOL LOCALF fstxK(PCSTR s1, PCSTR s2) { return !strlfind(delspc(s1), s2);}
BOOL LOCALF fstxL(PCSTR s1, PCSTR s2) { return !strlfind(delspc(toupr(s1)), s2);}
BOOL LOCALF fstxM(PCSTR s1, PCSTR s2) { return !strlfind(delspc(tohan(s1)), s2);}
BOOL LOCALF fstxN(PCSTR s1, PCSTR s2) { return !strlfind(delspc(tohan(toupr(s1))), s2);}
BOOL LOCALF fstxO(PCSTR s1, PCSTR s2) { return !strrfind(s1, s2);}
BOOL LOCALF fstxP(PCSTR s1, PCSTR s2) { return !strrfind(toupr(s1), s2);}
BOOL LOCALF fstxQ(PCSTR s1, PCSTR s2) { return !strrfind(tohan(s1), s2);}
BOOL LOCALF fstxR(PCSTR s1, PCSTR s2) { return !strrfind(tohan(toupr(s1)), s2);}
BOOL LOCALF fstxS(PCSTR s1, PCSTR s2) { return !strrfind(delspc(s1), s2);}
BOOL LOCALF fstxT(PCSTR s1, PCSTR s2) { return !strrfind(delspc(toupr(s1)), s2);}
BOOL LOCALF fstxU(PCSTR s1, PCSTR s2) { return !strrfind(delspc(tohan(s1)), s2);}
BOOL LOCALF fstxV(PCSTR s1, PCSTR s2) { return !strrfind(delspc(tohan(toupr(s1))), s2);}

void LOCALF stxprep(FSTX *pf, PSTR wk, PCSTR *ps, int flg)
{ // ̃T[`O
  switch (flg) {
  default: *pf = fstx0; break;
  case  1: *pf = fstx1; *ps = strcpy(wk, toupr(*ps)); break;         // UPR
  case  2: *pf = fstx2; *ps = strcpy(wk, tohan(*ps)); break;         // ZEN
  case  3: *pf = fstx3; *ps = strcpy(wk, tohan(toupr(*ps))); break;  // ZEN|UPR
  case  4: *pf = fstx4; *ps = strcpy(wk, delspc(*ps)); break;        // DSP
  case  5: *pf = fstx5; *ps = strcpy(wk, delspc(toupr(*ps))); break; // DSP|UPR
  case  6: *pf = fstx6; *ps = strcpy(wk, delspc(tohan(*ps))); break; // DSP|ZEN
  case  7: *pf = fstx7; *ps = strcpy(wk, delspc(tohan(toupr(*ps)))); break; // DSP|ZEN|UPR
  case  8: *pf = fstx8; break;                                       // ALL
  case  9: *pf = fstx9; break;                                       // ALL|UPR
  case 10: *pf = fstxA; *ps = strcpy(wk, tohan(*ps)); break;         // ALL|ZEN
  case 11: *pf = fstxB; *ps = strcpy(wk, tohan(*ps)); break;         // ALL|ZEN|UPR
  case 12: *pf = fstxC; *ps = strcpy(wk, delspc(*ps)); break;        // ALL|DSP
  case 13: *pf = fstxD; *ps = strcpy(wk, delspc(*ps)); break;        // ALL|DSP|UPR
  case 14: *pf = fstxE; *ps = strcpy(wk, delspc(tohan(*ps))); break; // ALL|DSP|ZEN
  case 15: *pf = fstxF; *ps = strcpy(wk, delspc(tohan(*ps))); break; // ALL|DSP|ZEN|UPR
  case 16: *pf = fstxG; break;                                       // LFT
  case 17: *pf = fstxH; *ps = strcpy(wk, toupr(*ps)); break;         // LFT|UPR
  case 18: *pf = fstxI; *ps = strcpy(wk, tohan(*ps)); break;         // LFT|ZEN
  case 19: *pf = fstxJ; *ps = strcpy(wk, tohan(toupr(*ps))); break;  // LFT|ZEN|UPR
  case 20: *pf = fstxK; *ps = strcpy(wk, delspc(*ps)); break;        // LFT|DSP
  case 21: *pf = fstxL; *ps = strcpy(wk, delspc(toupr(*ps))); break; // LFT|DSP|UPR
  case 22: *pf = fstxM; *ps = strcpy(wk, delspc(tohan(*ps))); break; // LFT|DSP|ZEN
  case 23: *pf = fstxN; *ps = strcpy(wk, delspc(tohan(toupr(*ps)))); break; // LFT|DSP|ZEN|UPR
  case 24: *pf = fstxO; break;                                       // RGT
  case 25: *pf = fstxP; *ps = strcpy(wk, toupr(*ps)); break;         // RGT|UPR
  case 26: *pf = fstxQ; *ps = strcpy(wk, tohan(*ps)); break;         // RGT|ZEN
  case 27: *pf = fstxR; *ps = strcpy(wk, tohan(toupr(*ps))); break;  // RGT|ZEN|UPR
  case 28: *pf = fstxS; *ps = strcpy(wk, delspc(*ps)); break;        // RGT|DSP
  case 29: *pf = fstxT; *ps = strcpy(wk, delspc(toupr(*ps))); break; // RGT|DSP|UPR
  case 30: *pf = fstxU; *ps = strcpy(wk, delspc(tohan(*ps))); break; // RGT|DSP|ZEN
  case 31: *pf = fstxV; *ps = strcpy(wk, delspc(tohan(toupr(*ps)))); break; // RGT|DSP|ZEN|UPR
  }
}

int  WINAPI SearchTableCellText(HTBL tb, int i0, int ic, PCSTR st, int flg)
{ // ̃T[`
  int i, ln = LEN(tb);
  PCCOLI co;
  FSTX fstx;
  char bf[512], wk[512];

  if (i0 < 0 || i0 > ln) { ierr(E_IRO); return -1;}
  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return -1;}
  co = &COL(tb)[ic];
  stxprep(&fstx, wk, &st, flg);
  for (i = i0; i < ln; i++) {
    if (fstx(prnval(bf, ROW(tb, i) + OFS(co), co), st) == 0) return i;
  }
  return -1;
}

int  WINAPI SearchAlt(HTBL tb, int ic, PCSTR st)
{ // 㗝L[ɂT[`
  int ir, ln = LEN(tb);

  ir = SearchTableCellText(tb, 0, ic, st, STX_UPR|STX_ZEN|STX_DSP|STX_ALL);
  if (ir >= 0) {
    if (ir < ln - 1 && SearchTableCellText(tb, ir + 1, ic, st, STX_UPR|STX_ZEN|STX_DSP|STX_ALL) >= 0) return -1;
  } else {
    ir = SearchTableCellText(tb, 0, ic, st, STX_UPR|STX_ZEN|STX_DSP);
    if (ir >= 0) {
      if (ir < ln - 1 && SearchTableCellText(tb, ir + 1, ic, st, STX_UPR|STX_ZEN|STX_DSP) >= 0) return -1;
    }
  }
  return ir;
}

BOOL WINAPI CheckTable(HTBL tb)
{ // \f[^̃`FbN
  int i, n, ln = LEN(tb);

  for (n = i = 0; i < ln; i++) {
    if (!TableTrigger(tb, TRGM_BEFOREUPDATE, i, ROW(tb, i))) n++;
  }
  return n == 0;
}

#define  NTRY  5
#define  ITRY  1000

BOOL LOCALF loadplane(HTBL tb)
{ // Ǎ
  int ln, sz, nt = NTRY, re = FALSE;
  HANDLE hf;

 _L0:
  hf = open_file(FNM(tb), OP_RDO);
  if (!hf) {
    if (--nt > 0) { wait_millisec(ITRY); goto _L0;}  else return (BOOL)ferr(E_FIR, FNM(tb));
  }
  sz = get_file_size(hf); if (sz == INVALID_FILE_SIZE) { ferr(E_FIR, FNM(tb)); goto _L1;}
  if ((ln = sz / RSZ(tb)) > CAP(tb)) {
    if (!ChangeTableCapacityX(tb, ln)) goto _L1;
  }
  sz = ln * RSZ(tb);
  if (!read_file(hf, PTR(tb), sz)) { ferr(E_FIR, FNM(tb)); goto _L1;}
  LEN(tb) = ln;
  re = TRUE;
 _L1: close_file(hf);
  return re;
}

BOOL LOCALF saveplane(HTBL tb)
{ // ۑ
  int sz, nt = NTRY, re = FALSE;
  HANDLE hf;

 _L0:
  hf = open_file(FNM(tb), OP_WRI);
  if (!hf) {
    if (--nt > 0) { wait_millisec(ITRY); goto _L0;}  else return (BOOL)ferr(E_FIW, FNM(tb));
  }
  sz = LEN(tb) * RSZ(tb);
  if (!write_file(hf, PTR(tb), sz)) { ferr(E_FIW, FNM(tb)); goto _L1;}
  re = TRUE;
 _L1: close_file(hf);
  return re;
}

  // 
static BYTE RND[256] = {
  0xe1, 0x76, 0x08, 0x70, 0xb2, 0x10, 0xd7, 0xef, 0x2f, 0x66, 0x32, 0x8b, 0x18, 0x38, 0xd8, 0x03,
  0x2c, 0x45, 0x8b, 0x17, 0x2d, 0x4f, 0x0a, 0x86, 0xda, 0x15, 0x15, 0x12, 0xf3, 0x57, 0x6b, 0x7a,
  0x37, 0xd4, 0xce, 0x7e, 0x68, 0x4e, 0xfd, 0xdd, 0x45, 0x84, 0xb8, 0x59, 0x8e, 0x36, 0xbe, 0xb1,
  0x02, 0x23, 0xd1, 0xa5, 0x63, 0x0d, 0xb0, 0xf4, 0x70, 0xb3, 0x1b, 0x60, 0xe9, 0xd5, 0xd1, 0xa8,
  0x8d, 0x32, 0x94, 0x8c, 0x1e, 0x8c, 0x23, 0xcb, 0x5b, 0xa2, 0x3e, 0x27, 0x04, 0x34, 0xa4, 0x5f,
  0xd8, 0x01, 0x17, 0x33, 0x99, 0xcb, 0x56, 0x62, 0x06, 0x51, 0x21, 0xae, 0xdf, 0x53, 0x37, 0xd6,
  0xe3, 0x90, 0x5a, 0x9a, 0xd4, 0xca, 0x49, 0xb9, 0x71, 0xc0, 0xc4, 0xf5, 0x7a, 0x32, 0x8a, 0x0d,
  0xae, 0xdf, 0x5d, 0xc1, 0xcf, 0x89, 0xfc, 0xd0, 0x9c, 0xef, 0x27, 0xfc, 0xd5, 0xd1, 0x9d, 0x04,
  0x39, 0xee, 0x20, 0xa8, 0x8a, 0x08, 0x6f, 0xa7, 0x87, 0xde, 0x4a, 0xc3, 0xf0, 0x30, 0x70, 0xbb,
  0x84, 0xbd, 0xa3, 0x4f, 0x05, 0x47, 0xa2, 0x3e, 0x32, 0x8d, 0x2d, 0x4a, 0xcb, 0x4f, 0x03, 0x32,
  0x8f, 0x4c, 0xe6, 0xb6, 0x40, 0x46, 0x95, 0x95, 0x9d, 0xfc, 0xd0, 0x91, 0x66, 0x2e, 0x56, 0x69,
  0x5a, 0x9b, 0xe9, 0xdd, 0x3b, 0x05, 0x48, 0xac, 0xc8, 0x2b, 0x33, 0x98, 0xc1, 0xcd, 0x69, 0x60,
  0xe5, 0xaa, 0xac, 0xc4, 0xf6, 0x84, 0xbb, 0x83, 0xb3, 0x1a, 0x56, 0x5f, 0xdc, 0x2c, 0x3c, 0x17,
  0x30, 0x79, 0x2f, 0x6b, 0x71, 0xc3, 0xee, 0x1a, 0x5e, 0xc9, 0x39, 0xe6, 0xb7, 0x4b, 0xcf, 0x8e,
  0x3b, 0x08, 0x72, 0xd2, 0xac, 0xc2, 0xe1, 0x71, 0xc9, 0x38, 0xdc, 0x2d, 0x52, 0x2a, 0x22, 0xc5,
  0x06, 0x57, 0x75, 0xf9, 0xa7, 0x81, 0x94, 0x88, 0xf4, 0x67, 0x3f, 0x34, 0xad, 0xc9, 0x35, 0xbc,
};

void LOCALF encrypt(PBYTE pb, int sz)
{ // Í
  int i;

  for (i = 0; i < sz; i++) {
    pb[i] ^= RND[i % 256];
  }
}

BOOL LOCALF loadcrypt(HTBL tb)
{ // ēǍ
  int re;

  re = loadplane(tb);
  if (re) encrypt(PTR(tb), LEN(tb) * RSZ(tb));
  return re;
}

BOOL LOCALF savecrypt(HTBL tb)
{ // Íĕۑ
  int re;

  encrypt(PTR(tb), LEN(tb) * RSZ(tb));
  re = saveplane(tb);
  encrypt(PTR(tb), LEN(tb) * RSZ(tb));
  return re;
}

BOOL WINAPI LoadBTB(HTBL tb)
{ // Ǎ
  int re;

  if (FLG(tb) & TF_CYP) {
    re = loadcrypt(tb);
  } else {
    re = loadplane(tb);
  }
  return re;
}

BOOL WINAPI SaveBTB(HTBL tb)
{ // ۑ
  int re;

  if (FLG(tb) & TF_CYP) {
    re = savecrypt(tb);
  } else {
    re = saveplane(tb);
  }
  return re;
}

BOOL WINAPI OpenBTB(HTBL tb)
{ // J
  int ln, sz, nt = NTRY;
  HANDLE hf;

 _L0:
  hf = open_file(FNM(tb), OP_RDW);
  if (!hf) {
    if (--nt > 0) { wait_millisec(ITRY); goto _L0;}  else return FALSE;
  }
  sz = get_file_size(hf); if (sz == INVALID_FILE_SIZE) goto _L1;
  if ((ln = sz / RSZ(tb)) > CAP(tb)) {
    if (!ChangeTableCapacityX(tb, ln)) goto _L1;
  }
  sz = ln * RSZ(tb);
  read_file(hf, PTR(tb), sz);
  LEN(tb) = ln;
  OTB(tb) = (HTBL)hf;
  return TRUE;

 _L1:
  close_file(hf);
  return FALSE;
}

BOOL WINAPI CloseBTB(HTBL tb, BOOL sv)
{ // 
  HANDLE hf = (HANDLE)OTB(tb);

  if (!hf) return FALSE;
  if (sv) {
    set_file_ptr(hf, 0, FILE_BEGIN);
    write_file(hf, PTR(tb), LEN(tb) * RSZ(tb));
    set_end_of_file(hf);
  }
  OTB(tb) = NULL;
  close_file(hf);
  return TRUE;
}

void WINAPI OverrideTableTrigger(HTBL tb, FTRG ftrg)
{ // gK֐̍ւ
  TRG(tb) = ftrg; FLG(tb) &=~TF_OTR;
}

#define  TID_ICO  (TID_LIB + 1)

PVOID LOCALF fscnICO(PINT pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  int i, nx = NCO(COX(co));
  PCCOLI cx = COL(COX(co));

  *pv = -1;
  for (i = 0; i < nx; i++) {
    if (strcmp(cx[i].tit, st) == 0) { *pv = i; break;}
  }
  return pv;
}

PSTR LOCALF fprnICO(PSTR st, PCINT pv, PCCOLI co)
{ // ɏo
  int nx = NCO(COX(co));
  PCCOLI cx = COL(COX(co));

  return strcpy(st, (*pv >= 0 && *pv < nx)? cx[*pv].tit: "");
}

UINT LOCALF flstICO(int im, PCCOLI co)
{ // Xg
  int nx = NCO(COX(co));
  PCCOLI cx = COL(COX(co));

  return (im < 0)? nx + 1: (im == 0)? (UINT)"(Ȃ)": (im <= nx)? (UINT)cx[im-1].tit: (UINT)"";
}

static TYPI tpICO = { ITP(TID_ICO, TID_I4B), 0, fscnICO, fprnICO, NULL, flstICO, };

static COLI ciARR[] = {
  { TID_ICO, 16, "ic",  "^Cg",   NULL, CF_DDL, },
};
static COLS csARR = { ciARR, NELEM(ciARR) };
static TBLI tiARR = { &csARR, NULL, "BOLARR", NULL, NULL, 0, NULL, NULL, 0, sizeof(int) };

HTBL WINAPI CreateARRTable(int cap, HTBL tb)
{ // CfbNXXg̍쐬
  HTBL ta;

  if (cap < NCO(tb)) cap = NCO(tb);
  ta = CreateTable(cap, &tiARR); if (!ta) return NULL;
  SetTableColumnExtra(ta, 0, (UINT)tb);
  return ta;
}

BOOL LOCALF scnarr(PIDXS pa, HTBL tb, PCSTR st)
{ // 񖼃XgǍ
  int i, n, ic, nc = NCO(tb);
  PCCOLI co = COL(tb);

  n = 0;
  start(st);
  switch (token()) {
  case TKN_END:
    for (i = 0; i < nc; i++) {
      if (WID(&co[i]) && !ISCAL(&co[i])) pa->pi[n++] = i;
    }
    break;
  case BOP_AST:
    for (i = 0; i < nc; i++) {
      pa->pi[n++] = i;
    }
    break;
  case TKN_IDN:
    goto _L2;
  }
  goto _L4;
 _L1:
  if (token_is(TKN_IDN)) {
   _L2:
    if ((ic = TableColumnIndex(tb, buf())) >= 0) {
      for (i = 0; i < n; i++) {
        if (pa->pi[i] == ic) goto _L3;
      }
      pa->pi[n++] = ic;
    }
   _L3:
    if (token_is(BOP_CMA)) goto _L1;
  }
 _L4:
  pa->ni = n;
  return n > 0;
}

BOOL WINAPI ScanARRTable(HTBL ta, PCSTR arr)
{ // 񖼃XgǍ
  int i, j, k, nc, nv, re;
  PINT vi;
  HTBL tb = (HTBL)COX(&COL(ta)[0]);

  if (!arr) arr = "";
  re = scnarr((PIDXS)MBK(ta), tb, arr);
  nc = NCO(tb);
  vi = (PINT)PTR(ta);
  k = nv = LEN(ta);
  for (i = 0; i < nc; i++) {
    for (j = 0; j < nv; j++) {
      if (vi[j] == i) goto _LC;
    }
    vi[k++] = i;
   _LC:;
  }
  return re;
}

PSTR WINAPI PrintARRTable(PSTR arr, HTBL ta)
{ // 񖼃Xgo
  int i, ni = LEN(ta);
  PSTR pt;
  PCINT vi = (PINT)PTR(ta);
  PCCOLI cx = COL(COX(&COL(ta)[0]));

  *(pt = arr) = '\0';
  for (i = 0; i < ni; i++) {
    pt += sprintf(pt, "%s", cx[vi[i]].nam);
    if (i < ni - 1) pt += sprintf(pt, ", ");
  }
  return arr;
}

void WINAPI InsertARRTableRow(HTBL ta, int i1, int i2)
{ // ڂ̒ǉ
  int ic, ni = LEN(ta), nc = NCO(COX(&COL(ta)[0]));
  PINT vi = (PINT)PTR(ta);

  if (i1 < 0 || i1 > ni || i2 < 0 || i2 >= nc - ni) { ierr(E_IRO); return;}
  ic = vi[ni + i2];
  memmove(vi + i1 + 1, vi + i1, (ni + i2 - i1) * sizeof(int));
  vi[i1] = ic;
  LEN(ta)++;
}

int  WINAPI DeleteARRTableRow(HTBL ta, int i1)
{ // ڂ̏O
  int k, ic, ni = LEN(ta), nc = NCO(COX(&COL(ta)[0]));
  PINT vi = (PINT)PTR(ta);

  if (i1 < 0 || i1 >= ni) return (int)ierr(E_IRO);
  ic = vi[i1];
  for (k = ni; k < nc && vi[k] < ic; k++) ;
  memmove(vi + i1, vi + i1 + 1, (k - 1 - i1) * sizeof(int));
  vi[k-1] = ic;
  LEN(ta)--;
  return k - ni;
}

  // i荞ݏ
typedef struct {
  BYTE  rp;
  BYTE  lo;
  BYTE  lp;
  BYTE  cm;
  int   ic;
  char  wk[504];
} CNDE;
typedef CNDE * PCNDE;
typedef const CNDE * PCCNDE;
  // i荞ݏ
typedef struct {
  PCNDE ce;
  int   ni;
} CNDM;
typedef CNDM * PCNDM;
typedef const CNDM * PCCNDM;

#define  TID_LOP  MAKEUINT(TID_LIB + 2, 3)

PVOID LOCALF fscnLOP(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  ((PCNDE)pv)->rp = strfind(st, ")))")? 3: strfind(st, "))")? 2: strfind(st, ")")? 1: 0;
  ((PCNDE)pv)->lo = strfind(st, "and")? 1: strfind(st, "or")? 2: 0;
  ((PCNDE)pv)->lp = strfind(st, "(((")? 3: strfind(st, "((")? 2: strfind(st, "(")? 1: 0;
  return pv;
}

PSTR LOCALF fprnLOP(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  int i, rp = ((PCCNDE)pv)->rp, lo = ((PCCNDE)pv)->lo, lp = ((PCCNDE)pv)->lp;
  PSTR pt;

  *(pt = st) = '\0';
  for (i = 0; i < rp; i++) pt += sprintf(pt, ")");
  if (rp == 0 && lo != 0) pt += sprintf(pt, " ");
  if (lo == 1) pt += sprintf(pt, "and");  else if (lo == 2) pt += sprintf(pt, "or");
  for (i = 0; i < lp; i++) pt += sprintf(pt, "(");
  if (lp == 0 && lo != 0) pt += sprintf(pt, " ");
  return st;
}

static PCSTR SLOP[] = {
  "", " and ", " or ", "(", ")", " and(", ")and ", ")and(", "((", "))",
  " and((", "))and ", ")and((", "))and(", "))and((", "(((", ")))"
};

UINT LOCALF flstLOP(int im, PCCOLI co)
{ // Xg
  return (im < 0)? NELEM(SLOP): (im < NELEM(SLOP))? (UINT)SLOP[im]: (UINT)"";
}

void LOCALF fixcnd(HTBL tc)
{ // i荞ݏ̐`
  int i, f, n, ln = LEN(tc);
  PCNDE pb;

  f = 1;
  for (n = i = 0; i < ln; i++) {
    pb = (PCNDE)ROW(tc, i);
    if (i == ln - 1) {
      pb->lo = pb->lp = 0; pb->ic = -1;
    } else if (i == ln - 2) {
      pb->lp = 0;
    }
    if (f) {
      if (pb->ic >= 0) {
        if (pb->rp > n) { pb->rp = n; n = 0;}  else n -= pb->rp;
        if (i > 0) {
          if (pb->lo == 0) pb->lo = 1;
        } else pb->lo = 0;
        if (pb->cm == 0) pb->cm = 1;
        n += pb->lp;
      } else {
        if (pb->lo == 0) pb->rp = n;  else (pb + 1)->rp = n - pb->lp;
        pb->cm = 0; pb->ic = -1; memset(pb->wk, 0, sizeof(pb->wk));
        f = 0;
      }
    } else {
      pb->rp = pb->lo = pb->lp = pb->cm = 0; pb->ic = -1; memset(pb->wk, 0, sizeof(pb->wk));
    }
  }
}

BOOL LOCALF ftrgCND(HTBL tb, int msg, int ir, PCNDE pb)
{ // i荞ݏgK֐
  switch (msg) {
  case TRGM_DEFAULT:
    pb->ic = -1;
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 0):
    if (pb->ic >= 0) fixcnd(tb);  else if (ir > 0 && (pb - 1)->ic < 0) memset(pb, 0, 3);
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 1):
    if (pb->ic >= 0) fixcnd(tb);  else pb->cm = 0;
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 2):
    memset(pb->wk, 0, sizeof(pb->wk)); fixcnd(tb);
    return TRUE;
  }
  return DefaultTableTrigger(tb, msg, ir, (PVOID)pb);
}

static TYPI tpLOP = { ITP(TID_LOP, TID_BIN), 0, fscnLOP, fprnLOP, NULL, flstLOP, };

static PCSTR BCMP[] = { "", "=", "<>", "<", "<=", ">", ">=", "mlike", "notmlike" };
static PCSTR SCMP[] = { "", "", "", "", "", "", "", "܂", "܂܂Ȃ" };
static ENMS esCMP = { SCMP, NELEM(SCMP) };

#define  C8  ATR(8, ALN_CEN)
#define  C6  ATR(6, ALN_CEN)

static COLI ciCND[] = {
  { TID_LOP, C8, "lx",  "and/or",       NULL, CF_DDL, },
  { TID_E1B, C6, "cm",  "r",         NULL, CF_DDL, NULL, NULL, (UINT)&esCMP, },
  { TID_ICO, 16, "ic",  "^Cg",   NULL, CF_DDL, },
  { STR(504),22, "wk",  "l",           },
};
static COLS csCND = { ciCND, NELEM(ciCND) };
static TBLI tiCND = { &csCND, NULL, "BOLCND", NULL, NULL, 0, (FTRG)ftrgCND, NULL, 0, sizeof(CNDE) };

HTBL WINAPI CreateCNDTable(int cap, HTBL tb)
{ // i荞ݏ̍쐬
  HTBL tc;

  tc = CreateTable(cap, &tiCND); if (!tc) return NULL;
  SetTableColumnExtra(tc, 2, (UINT)tb);
  return tc;
}

int  LOCALF sicnv(PCSTR ss)
{ // 𐮐ɕϊ
  if      (strmatch(ss, "####/##/##")) return ztod(ss);
  else if (strmatch(ss, "##:##:##"))   return ztot(ss);
  else return cztoi(ss);
}

REAL LOCALF sfcnv(PCSTR ss)
{ // ɕϊ
  if (strmatch(ss, "####/##/## ##:##:##")) return ztodt(ss);
  else return cztof(ss);
}

BOOL LOCALF scncnd(PCNDM pc, HTBL tb, PCSTR st)
{ // i荞ݏǍ
  int n, ic, sg;
  PCCOLI co;
  BYTE wk[8];

  n = 0;
  memset(&pc->ce[0], 0, sizeof(CNDE));
  pc->ce[0].ic = -1;
  start(st);
  if (token_is(TKN_END)) goto _L3;
 _L1:
  switch (token()) {
  case BOP_LPA: pc->ce[n].lp++; goto _L1;
  case TKN_IDN: break;
  default: goto _L3;
  }
  if ((ic = TableColumnIndex(tb, buf())) >= 0) {
    pc->ce[n].ic = ic;
    co = &COL(tb)[ic];
  } else goto _L3;
  switch (token()) {
  case BOP_LEQ: pc->ce[n].cm = 1; break;
  case BOP_LNE: pc->ce[n].cm = 2; break;
  case BOP_LLT: pc->ce[n].cm = 3; break;
  case BOP_LLE: pc->ce[n].cm = 4; break;
  case BOP_LGT: pc->ce[n].cm = 5; break;
  case BOP_LGE: pc->ce[n].cm = 6; break;
  case BKW_MLK: pc->ce[n].cm = 7; break;
  case BKW_NML: pc->ce[n].cm = 8; break;
  default: goto _L3;
  }
  if (BTP(co) <= TID_F8B) {
    sg = 1;
    if (token_is(BOP_MNS)) sg = -1;
  }
  switch (BTP(co)) {
  case TID_I1B: case TID_U1B:
  case TID_I2B: case TID_U2B:
  case TID_I4B:
    switch (token()) {
    case TKN_U4B: *(I4B *)wk = *(U4B *)buf() * sg; break;
    default: goto _L3;
    }
    cprnval(pc->ce[n].wk, wk, co); break;
  case TID_U4B:
    switch (token()) {
    case TKN_U4B: *(U4B *)wk = *(U4B *)buf() * sg; break;
    case TKN_STR: *(U4B *)wk = sicnv(buf()); break;
    default: goto _L3;
    }
    cprnval(pc->ce[n].wk, wk, co); break;
  case TID_I8B: case TID_U8B:
    switch (token()) {
    case TKN_U4B: *(U8B *)wk = *(U4B *)buf() * sg; break;
    case TKN_U8B: *(U8B *)wk = *(U8B *)buf() * sg; break;
    default: goto _L3;
    }
    cprnval(pc->ce[n].wk, wk, co); break;
  case TID_F4B:
    switch (token()) {
    case TKN_U4B: *(F4B *)wk = (F4B)(*(U4B *)buf() * sg); break;
    case TKN_F8B: *(F4B *)wk = (F4B)(*(F8B *)buf() * sg); break;
    default: goto _L3;
    }
    cprnval(pc->ce[n].wk, wk, co); break;
  case TID_F8B:
    switch (token()) {
    case TKN_U4B: *(F8B *)wk = *(U4B *)buf() * sg; break;
    case TKN_F8B: *(F8B *)wk = *(F8B *)buf() * sg; break;
    case TKN_STR: *(F8B *)wk = sfcnv(buf()); break;
    default: goto _L3;
    }
    cprnval(pc->ce[n].wk, wk, co); break;
  default: // TID_STR, TID_BIN
    switch (token()) {
    case TKN_STR: break;
    default: goto _L3;
    }
    cprnval(pc->ce[n].wk, buf(), co); break;
  }
  n++;
  memset(&pc->ce[n], 0, sizeof(CNDE));
  pc->ce[n].ic = -1;
 _L2:
  switch (token()) {
  case BOP_RPA: pc->ce[n].rp++; goto _L2;
  case TKN_END: goto _L3;
  case BKW_LAN: pc->ce[n].lo = 1; break;
  case BKW_LOR: pc->ce[n].lo = 2; break;
  default: goto _L3;
  }
  goto _L1;
 _L3:
  pc->ni = n;
  return n > 0;
}

BOOL WINAPI ScanCNDTable(HTBL tc, PCSTR cnd)
{ // i荞ݏǍ
  int re;
  HTBL tb = (HTBL)COX(&COL(tc)[2]);

  if (!cnd) cnd = "";
  LEN(tc) = 0;
  InsertTableRows(tc, 0, CAP(tc));
  re = scncnd((PCNDM)MBK(tc), tb, cnd);
  LEN(tc) = CAP(tc);
  fixcnd(tc);
  return re;
}

PSTR WINAPI PrintCNDTable(PSTR cnd, HTBL tc)
{ // i荞ݏo
  int i, ni = LEN(tc);
  PSTR pt;
  PCCOLI cx = COL(COX(&COL(tc)[2]));
  CNDE dat;
  char bf[512];

  fixcnd(tc);
  *(pt = cnd) = '\0';
  for (i = 0; i < ni; i++) {
    dat = *(PCCNDE)ROW(tc, i);
    if (dat.ic < 0) { dat.lo = dat.lp = 0;}
    pt += strlen(prnval(pt, &dat.rp, &COL(tc)[0])); if (dat.ic < 0) break;
    pt += sprintf(pt, "%s", cx[dat.ic].nam);
    pt += sprintf(pt, " %s ", BCMP[dat.cm]);
    pt += strlen(vprnval(pt, cscnval(bf, dat.wk, &cx[dat.ic]), &cx[dat.ic]));
  }
  return cnd;
}

#define  SRT_ASN  0x00
#define  SRT_DSN  0x01
#define  SRT_ZRL  0x02
#define  SRT_ZRF  0x04
#define  SRT_PAL  0x08
#define  SRT_PAF  0x10

  // בւ
typedef struct {
  int   ic;
  int   flg;
} SRTE;
typedef SRTE * PSRTE;
typedef const SRTE * PCSRTE;
  // בւ
typedef struct {
  PSRTE se;
  int   ni;
} SRTM;
typedef SRTM * PSRTM;
typedef const SRTM * PCSRTM;

void LOCALF fixsrt(HTBL ts)
{ // בւ̐`
  int i, f, ln = LEN(ts);
  PSRTE pb;

  f = 1;
  for (i = 0; i < ln; i++) {
    pb = (PSRTE)ROW(ts, i);
    if (f) {
      if (pb->ic >= 0) {
        if (pb->flg == -1) pb->flg = 0;
      } else {
        pb->flg = -1;
        f = 0;
      }
    } else {
      pb->ic = pb->flg = -1;
    }
  }
}

BOOL LOCALF ftrgSRT(HTBL tb, int msg, int ir, PSRTE pb)
{ // בւgK֐
  switch (msg) {
  case TRGM_DEFAULT:
    pb->ic = pb->flg = -1;
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 0):
    fixsrt(tb);
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 1):
    if (pb->ic >= 0) fixsrt(tb);  else pb->flg = -1;
    return TRUE;
  }
  return DefaultTableTrigger(tb, msg, ir, (PVOID)pb);
}

static CODI diVOP[] = {
  { -1,                      "" },
  {  0,                      "" },
  { SRT_DSN,                 "~" },
  { SRT_ZRL,                 "A󗓂͍Ō" },
  { SRT_DSN|SRT_ZRF,         "~A󗓂͍ŏ" },
  { SRT_PAL,                 "Aʂ͍Ō" },
  { SRT_DSN|SRT_PAF,         "~Aʂ͍ŏ"  },
  { SRT_ZRL|SRT_PAL,         "A󗓂Ɗʂ͍Ō" },
  { SRT_DSN|SRT_ZRF|SRT_PAF, "~A󗓂Ɗʂ͍ŏ" },
};
static CODS dsVOP = { diVOP, NELEM(diVOP) };

static COLI ciSRT[] = {
  { TID_ICO, 16, "ic",  "^Cg",   NULL, CF_DDL, },
  { TID_C4B, 28, "flg", "בւ", NULL, CF_DDL, NULL, NULL, (UINT)&dsVOP, },
};
static COLS csSRT = { ciSRT, NELEM(ciSRT) };
static TBLI tiSRT = { &csSRT, NULL, "BOLSRT", NULL, NULL, 0, (FTRG)ftrgSRT, NULL, 0, sizeof(SRTE) };

HTBL WINAPI CreateSRTTable(int cap, HTBL tb)
{ // בւ̍쐬
  HTBL ts;

  ts = CreateTable(cap, &tiSRT); if (!ts) return NULL;
  SetTableColumnExtra(ts, 0, (UINT)tb);
  return ts;
}

BOOL LOCALF scnsrt(PSRTM ps, HTBL tb, PCSTR st)
{ // בւǍ
  int n, ic;

  n = 0;
  start(st);
  if (token_is(TKN_END)) goto _L2;
 _L1:
  if (token_is(TKN_IDN)) {
    if ((ic = TableColumnIndex(tb, buf())) >= 0) {
      ps->se[n].ic = ic;
      ps->se[n].flg = 0;
    } else goto _L2;
  } else goto _L2;
  if (token_is(BKW_DSN)) {
    ps->se[n].flg |= SRT_DSN;
    if (token_is(BKW_ZRF)) ps->se[n].flg |= SRT_ZRF;
    if (token_is(BKW_PAF)) ps->se[n].flg |= SRT_PAF;
  } else {
    if (token_is(BKW_ZRL)) ps->se[n].flg |= SRT_ZRL;
    if (token_is(BKW_PAL)) ps->se[n].flg |= SRT_PAL;
  }
  n++;
  switch (token()) {
  case TKN_END: goto _L2;
  case BOP_CMA: break;
  default: goto _L2;
  }
  goto _L1;
 _L2:
  ps->ni = n;
  return n > 0;
}

BOOL WINAPI ScanSRTTable(HTBL ts, PCSTR srt)
{ // בւǍ
  int re;
  HTBL tb = (HTBL)COX(&COL(ts)[0]);

  if (!srt) srt = "";
  LEN(ts) = 0;
  InsertTableRows(ts, 0, CAP(ts));
  re = scnsrt((PSRTM)MBK(ts), tb, srt);
  LEN(ts) = CAP(ts);
  fixsrt(ts);
  return re;
}

PSTR WINAPI PrintSRTTable(PSTR srt, HTBL ts)
{ // בւo
  int i, ni = LEN(ts);
  PSTR pt;
  PCSRTE pb;
  PCCOLI cx = COL(COX(&COL(ts)[0]));

  fixsrt(ts);
  *(pt = srt) = '\0';
  for (i = 0; i < ni; i++) {
    pb = (PCSRTE)ROW(ts, i); if (pb->ic < 0) break;
    pt += sprintf(pt, "%s", cx[pb->ic].nam);
    if (pb->flg & SRT_DSN) pt += sprintf(pt, " %s", "desc");
    if (pb->flg & SRT_ZRL) pt += sprintf(pt, " %s", "zerolast");
    if (pb->flg & SRT_ZRF) pt += sprintf(pt, " %s", "zerofirst");
    if (pb->flg & SRT_PAL) pt += sprintf(pt, " %s", "parenlast");
    if (pb->flg & SRT_PAF) pt += sprintf(pt, " %s", "parenfirst");
    if (i < ni - 1 && (pb + 1)->ic >= 0) pt += sprintf(pt, ", ");
  }
  return srt;
}

#define  FMT_DEC  1
#define  FMT_CMA  2

  // Wv
typedef struct {
  int   ic;
  BYTE  sw;
  BYTE  sb, wd, sc;
  char  unt[24];
  char  tit[32];
} GRPE;
typedef GRPE * PGRPE;
typedef const GRPE * PCGRPE;
  // WvڃXg
typedef struct {
  PGRPE ge;
  int   ni;
} GRPM;
typedef GRPM * PGRPM;
typedef const GRPM * PCGRPM;

static CODI diAGG[] = {
  { 0,       "" },
  { AGG_SUM, "v" },
  { AGG_AVG, "" },
  { AGG_MAX, "ől" },
  { AGG_MIN, "ŏl" },
  { AGG_COU, "" },
  { AGG_GRP, "WvP" },
};
static CODS dsAGG = { diAGG, NELEM(diAGG) };

#define  TID_FMT  MAKEUINT(TID_LIB + 3, offsetof(GRPE, tit) - offsetof(GRPE, sb))

BOOL LOCALF scndec(PBYTE pv)
{ // ֏Ǎ
  BYTE sb, wd, sc, unt[24];

  memset(pv, 0, offsetof(GRPE, tit) - offsetof(GRPE, sb));
  if      (token_is(BKW_DEC)) sb = FMT_DEC;
  else if (token_is(BKW_CMA)) sb = FMT_CMA;
  else return FALSE;
  wd = sc = 0; unt[0] = '\0';
  if (!token_is(BOP_LPA)) goto _L3;
  if (token_is(TKN_U4B)) {
    wd = (BYTE)*(U4B *)buf(); if (wd > 30) wd = 30;
  } else goto _L1;
  if (!token_is(BOP_CMA)) goto _L2;
  if (token_is(TKN_U4B)) {
    sc = (BYTE)*(U4B *)buf(); if (sc > 15) sc = 15;
  } else goto _L1;
  if (!token_is(BOP_CMA)) goto _L2;
 _L1:
  if (token_is(TKN_STR)) {
    if (strlen(buf()) < sizeof(unt)) strcpy(unt, buf());  else return FALSE;
  } else return FALSE;
 _L2:
  if (!token_is(BOP_RPA)) return FALSE;
 _L3:
  pv[0] = sb; pv[1] = wd; pv[2] = sc;
  strcpyx(&pv[3], unt, sizeof(unt) - 1);
  return TRUE;
}

PCSTR LOCALF decfmt(int id, PCGRPE pb)
{ // 
  char bf[32];

  switch (id) {
  case TID_I4B: strcpy(bf, "%d"); break;
  case TID_U4B: strcpy(bf, "%u"); break;
  case TID_I8B: strcpy(bf, "%lld"); break;
  case TID_U8B: strcpy(bf, "%llu"); break;
  case TID_F8B: strcpy(bf, pb->sc? format("%%.%df", pb->sc): "%.15G"); break;
  case TID_M4B: strcpy(bf, "%d"); break;
  case TID_M8B: strcpy(bf, pb->sc? format("%%.%df", pb->sc): "%.0f"); break;
  default: bf[0] = '\0'; break;
  }
  if (pb->unt[0] != '\0') {
    strcat(bf, strrepl(pb->unt, "%", "%%"));
  }
  return stostr(bf);
}

PVOID LOCALF fscnFMT(PVOID pv, PCSTR st, PCCOLI co)
{ // 񂩂Ǎ
  start(st);
  scndec(pv);
  return pv;
}

PSTR LOCALF fprnFMT(PSTR st, PCVOID pv, PCCOLI co)
{ // ɏo
  BYTE wd, sc;
  PSTR pt;
  PCSTR unt;

  *(pt = st) = '\0';
  switch (((PBYTE)pv)[0]) {
  case FMT_DEC: pt += sprintf(pt, "dec"); break;
  case FMT_CMA: pt += sprintf(pt, "cdec"); break;
  default: return st;
  }
  wd = ((PBYTE)pv)[1]; sc = ((PBYTE)pv)[2];
  unt = (PCSTR)&((PBYTE)pv)[3];
  if (wd > 0 || sc > 0 || unt[0] != '\0') {
    pt += sprintf(pt, "(");
    if (wd > 0 || sc > 0) {
      pt += sprintf(pt, "%d", (int)wd);
      if (sc > 0 || unt[0] != '\0') pt += sprintf(pt, ", ");
    }
    if (sc > 0) {
      pt += sprintf(pt, "%d", (int)sc);
      if (unt[0] != '\0') pt += sprintf(pt, ", ");
    }
    if (unt[0] != '\0') {
      pt += sprintf(pt, "'%s'", unt);
    }
    pt += sprintf(pt, ")");
  }
  return st;
}

void LOCALF fixgrp(HTBL tg)
{ // WvڃXg̐`
  int i, f, ln = LEN(tg);
  PGRPE pb;

  f = 1;
  for (i = 0; i < ln; i++) {
    pb = (PGRPE)ROW(tg, i);
    if (f) {
      if (pb->ic >= 0) {
        if (pb->sw < AGG_SUM || pb->sw > AGG_COU) {
          memset(&pb->sb, 0, offsetof(GRPE, tit) - offsetof(GRPE, sb));
        }
      } else {
        memset(&pb->sw, 0, sizeof(GRPE) - offsetof(GRPE, sw));
        f = 0;
      }
    } else {
      pb->ic = -1; memset(&pb->sw, 0, sizeof(GRPE) - offsetof(GRPE, sw));
    }
  }
}

BOOL LOCALF ftrgGRP(HTBL tb, int msg, int ir, PGRPE pb)
{ // WvڃXggK֐
  switch (msg) {
  case TRGM_DEFAULT:
    pb->ic = -1;
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 0):
    fixgrp(tb);
    return TRUE;
  case MAKEUINT(TRGM_AFTERUPDATEOF, 1):
  case MAKEUINT(TRGM_AFTERUPDATEOF, 2):
  case MAKEUINT(TRGM_AFTERUPDATEOF, 3):
    if (pb->ic >= 0) fixgrp(tb);  else memset(&pb->sw, 0, sizeof(GRPE) - offsetof(GRPE, sw));
    return TRUE;
  }
  return DefaultTableTrigger(tb, msg, ir, (PVOID)pb);
}

static TYPI tpFMT = { ITP(TID_FMT, TID_BIN), 0, fscnFMT, fprnFMT, };

static COLI ciGRP[] = {
  { TID_ICO, 16, "ic",  "^Cg",   NULL, CF_DDL, },
  { TID_C1B,  8, "sw",  "Wv@",     NULL, CF_DDL, NULL, NULL, (UINT)&dsAGG, },
  { TID_FMT, 22, "fmt", "֏",     },
  { STR(32), 16, "tit", "փ^Cg", },
};
static COLS csGRP = { ciGRP, NELEM(ciGRP) };
static TBLI tiGRP = { &csGRP, NULL, "BOLGRP", NULL, NULL, 0, (FTRG)ftrgGRP, NULL, 0, sizeof(GRPE) };

HTBL WINAPI CreateGRPTable(int cap, HTBL tb)
{ // WvڃXg̍쐬
  HTBL tg;

  tg = CreateTable(cap, &tiGRP); if (!tg) return NULL;
  SetTableColumnExtra(tg, 0, (UINT)tb);
  return tg;
}

BOOL LOCALF scngrp(PGRPM pg, HTBL tb, PCSTR st)
{ // WvڃXgǍ
  int n, ic, sw;

  n = 0;
  start(st);
  if (token_is(TKN_END)) goto _L5;
 _L1:
  switch (token()) {
  case BKW_SUM: sw = AGG_SUM; goto _L2;
  case BKW_AVG: sw = AGG_AVG; goto _L2;
  case BKW_MAX: sw = AGG_MAX; goto _L2;
  case BKW_MIN: sw = AGG_MIN; goto _L2;
  case BKW_COU: sw = AGG_COU; _L2:
    if (!token_is(BOP_LPA)) goto _L5;
    if (!token_is(TKN_IDN)) goto _L5;
    if ((ic = TableColumnIndex(tb, buf())) >= 0) {
      if (!token_is(BOP_RPA)) goto _L5;
    } else goto _L5;
    goto _L4;
  case BKW_GRP: sw = AGG_GRP;
    if (!token_is(TKN_IDN)) goto _L5;
    goto _L3;
  case TKN_IDN: sw = 0; _L3:
    if ((ic = TableColumnIndex(tb, buf())) >= 0) {
     _L4:
      pg->ge[n].ic = ic;
      pg->ge[n].sw = sw;
      memset(&pg->ge[n].sb, 0, offsetof(GRPE, tit) - offsetof(GRPE, sb));
    } else goto _L5;
    break;
  default:
    goto _L5;
  }
  if (token_is(BKW_AS_)) {
    if (!token_is(TKN_STR)) goto _L5;
    strcpyx(pg->ge[n].tit, buf(), sizeof(pg->ge->tit) - 1);
  }
  scndec(&pg->ge[n].sb);
  n++;
  switch (token()) {
  case TKN_END: goto _L5;
  case BOP_CMA: break;
  default: goto _L5;
  }
  goto _L1;
 _L5:
  pg->ni = n;
  return n > 0;
}

BOOL WINAPI ScanGRPTable(HTBL tg, PCSTR grp)
{ // WvڃXgǍ
  int re;
  HTBL tb = (HTBL)COX(&COL(tg)[0]);

  if (!grp) grp = "";
  LEN(tg) = 0;
  InsertTableRows(tg, 0, CAP(tg));
  re = scngrp((PGRPM)MBK(tg), tb, grp);
  LEN(tg) = CAP(tg);
  fixgrp(tg);
  return re;
}

PSTR WINAPI PrintGRPTable(PSTR grp, HTBL tg)
{ // WvڃXgo
  int i, ni = LEN(tg);
  PSTR pt;
  PCGRPE pb;
  PCCOLI cx = COL(COX(&COL(tg)[0]));
  char bf[64];

  fixgrp(tg);
  *(pt = grp) = '\0';
  for (i = 0; i < ni; i++) {
    pb = (PCGRPE)ROW(tg, i); if (pb->ic < 0) break;
    switch (pb->sw) {
    case AGG_SUM: pt += sprintf(pt, "%s(", "sum"); break;
    case AGG_AVG: pt += sprintf(pt, "%s(", "avg"); break;
    case AGG_MAX: pt += sprintf(pt, "%s(", "max"); break;
    case AGG_MIN: pt += sprintf(pt, "%s(", "min"); break;
    case AGG_COU: pt += sprintf(pt, "%s(", "count"); break;
    case AGG_GRP: pt += sprintf(pt, "%s ", "groupby"); break;
    }
    pt += sprintf(pt, "%s", cx[pb->ic].nam);
    if (pb->sw >= AGG_SUM && pb->sw <= AGG_COU) pt += sprintf(pt, ")");
    if (pb->tit[0] != '\0') pt += sprintf(pt, " as '%s'", pb->tit);
    if (pb->sb) pt += sprintf(pt, " %s", fprnFMT(bf, &pb->sb, NULL));
    if (i < ni - 1 && (pb + 1)->ic >= 0) pt += sprintf(pt, ", ");
  }
  return grp;
}

  // i荞ݏ͏
typedef struct {
  int   ir;
  int   ic;
  PCBYTE pb;
  PCCNDM pc;
  PCVOID bf;
  HTBL  tb;
} PRSB;

static PRSB BPB;

void LOCALF b_start(PCVOID pb, HTBL tc)
{ // ͊Jn
  BPB.ir = 0;
  BPB.ic = 0;
  BPB.pb = (PBYTE)pb;
  BPB.pc = (PCCNDM)MBK(tc);
  BPB.bf = "";
  BPB.tb = (HTBL)COX(&COL(tc)[2]);
}

int  LOCALF b_len(int i)
{ // s̒
  PCCNDE pb = &BPB.pc->ce[i]; return pb->rp + (pb->ic >= 0) * ((i > 0) + pb->lp + 3);
}

#define  TKN_ICO  24
#define  TKN_BIN  25

int  LOCALF b_token(void)
{ // g[N
  int i, j, cd = TKN_ERR;
  PCCNDE pb;

  i = BPB.ir; j = BPB.ic;
  if (i >= BPB.pc->ni || j >= b_len(i)) return TKN_END;
  pb = &BPB.pc->ce[i];
  if (j < pb->rp) {
    cd = BOP_RPA;
  } else if (i > 0 && j == pb->rp) {
    switch (pb->lo) {
    case 1: cd = BKW_LAN; break;
    case 2: cd = BKW_LOR; break;
    }
  } else if (j >= pb->rp && j < pb->rp + (i > 0) + pb->lp) {
    cd = BOP_LPA;
  } else if (j == pb->rp + (i > 0) + pb->lp) {
    BPB.bf = &pb->ic;
    cd = TKN_ICO;
  } else if (j == pb->rp + (i > 0) + pb->lp + 1) {
    BPB.bf = pb->wk;
    cd = TKN_BIN;
  } else if (j == pb->rp + (i > 0) + pb->lp + 2) {
    switch (pb->cm) {
    case 1: cd = BOP_LEQ; break;
    case 2: cd = BOP_LNE; break;
    case 3: cd = BOP_LLT; break;
    case 4: cd = BOP_LLE; break;
    case 5: cd = BOP_LGT; break;
    case 6: cd = BOP_LGE; break;
    case 7: cd = BKW_MLK; break;
    case 8: cd = BKW_NML; break;
    }
  }
  if (cd != TKN_ERR) {
    j++; if (j >= b_len(i)) { i++; j = 0;}
    BPB.ir = i; BPB.ic = j;
  }
  return cd;
}

BOOL LOCALF b_token_is(int cd)
{ // g[N(ǂ)
  int i, j, re;

  i = BPB.ir; j = BPB.ic;
  re = (b_token() == cd);
  if (!re) { BPB.ir = i; BPB.ic = j;}
  return re;
}

BOOL LOCALF b_lor_expr(void);

BOOL LOCALF b_cmp_expr(void)
{ // r
  int ic, re = TRUE;
  PCCOLI co;
  BYTE bf[512];

  switch (b_token()) {
  case TKN_ICO:
    ic = *(PINT)BPB.bf;
    co = &COL(BPB.tb)[ic];
    if (!b_token_is(TKN_BIN)) break;
    cscnval(bf, BPB.bf, co);
    switch (b_token()) {
    case BOP_LEQ: re = wcmpval(BPB.pb + OFS(co), bf, co) == 0; break;
    case BOP_LNE: re = wcmpval(BPB.pb + OFS(co), bf, co) != 0; break;
    case BOP_LLT: re = wcmpval(BPB.pb + OFS(co), bf, co) < 0; break;
    case BOP_LLE: re = wcmpval(BPB.pb + OFS(co), bf, co) <= 0; break;
    case BOP_LGT: re = wcmpval(BPB.pb + OFS(co), bf, co) > 0; break;
    case BOP_LGE: re = wcmpval(BPB.pb + OFS(co), bf, co) >= 0; break;
    case BKW_MLK: re = wmlkval(BPB.pb + OFS(co), bf, co) != 0; break;
    case BKW_NML: re = wmlkval(BPB.pb + OFS(co), bf, co) == 0; break;
    }
    break;
  case BOP_LPA:
    re = b_lor_expr();
    if (!b_token_is(BOP_RPA)) break;
    break;
  }
  return re;
}

BOOL LOCALF b_lan_expr(void)
{ // _IAND
  if (!b_cmp_expr()) return FALSE;
  while (b_token_is(BKW_LAN)) {
    if (!b_cmp_expr()) return FALSE;
  }
  return TRUE;
}

BOOL LOCALF b_lor_expr(void)
{ // _IOR
  if (b_lan_expr()) return TRUE;
  while (b_token_is(BKW_LOR)) {
    if (b_lan_expr()) return TRUE;
  }
  return FALSE;
}

BOOL LOCALF fselCND(PCVOID pb, UINT tc)
{ // i荞ݏɂI֐
  b_start(pb, (HTBL)tc); return b_lor_expr();
}

  // Wvpf[^
typedef struct {
  PCCOLI co;
  I4B   iv;
  I8B   lv;
  F8B   dv;
  int   cn;
} AGGP;

BOOL LOCALF faggSUM(PCVOID pb, AGGP *pa)
{ // v֐
  PCVOID pv;
  PCCOLI co = pa->co;
  BYTE rv[512];

  pv = (PBYTE)pb + OFS(co);
  if (ISCAL(co)) pv = co_fcal(rv, pb, co);
  if (iszero(pv, SIZ(co))) return FALSE;
  switch (BTP(co)) {
  case TID_I1B: pa->dv += (F8B)*(I1B *)pv; break;
  case TID_U1B: pa->dv += (F8B)*(U1B *)pv; break;
  case TID_I2B: pa->dv += (F8B)*(I2B *)pv; break;
  case TID_U2B: pa->dv += (F8B)*(U2B *)pv; break;
  case TID_I4B: pa->dv += (F8B)*(I4B *)pv; break;
  case TID_U4B: pa->dv += (F8B)*(U4B *)pv; break;
  case TID_I8B: pa->dv += (F8B)*(I8B *)pv; break;
  case TID_U8B: pa->dv += (F8B)*(U8B *)pv; break;
  case TID_F4B: pa->dv += (F8B)*(F4B *)pv; break;
  case TID_F8B: pa->dv += *(F8B *)pv; break;
  }
  pa->cn++;
  return TRUE;
}

BOOL LOCALF faggMAX(PCVOID pb, AGGP *pa)
{ // ől֐
  PCVOID pv;
  PCCOLI co = pa->co;
  I4B iv; I8B lv; F8B dv;
  BYTE rv[512];

  pv = (PBYTE)pb + OFS(co);
  if (ISCAL(co)) pv = co_fcal(rv, pb, co);
  if (iszero(pv, SIZ(co))) return FALSE;
  switch (BTP(co)) {
  case TID_I1B: iv = (I4B)*(I1B *)pv; goto _L1;
  case TID_U1B: iv = (I4B)*(U1B *)pv; goto _L1;
  case TID_I2B: iv = (I4B)*(I2B *)pv; goto _L1;
  case TID_U2B: iv = (I4B)*(U2B *)pv; goto _L1;
  case TID_I4B: iv = *(I4B *)pv; _L1:
    if (pa->cn == 0 || iv > pa->iv) pa->iv = iv;
    break;
  case TID_U4B: iv = *(U4B *)pv;
    if (pa->cn == 0 || (U4B)iv > (U4B)pa->iv) pa->iv = iv;
    break;
  case TID_I8B: lv = *(I8B *)pv;
    if (pa->cn == 0 || lv > pa->lv) pa->lv = lv;
    break;
  case TID_U8B: lv = *(U8B *)pv;
    if (pa->cn == 0 || (U8B)lv > (U8B)pa->lv) pa->lv = lv;
    break;
  case TID_F4B: dv = (F8B)*(F4B *)pv; goto _L2;
  case TID_F8B: dv = *(F8B *)pv; _L2:
    if (pa->cn == 0 || dv > pa->dv) pa->dv = dv;
    break;
  }
  pa->cn++;
  return TRUE;
}

BOOL LOCALF faggMIN(PCVOID pb, AGGP *pa)
{ // ŏl֐
  PCVOID pv;
  PCCOLI co = pa->co;
  I4B iv; I8B lv; F8B dv;
  BYTE rv[512];

  pv = (PBYTE)pb + OFS(co);
  if (ISCAL(co)) pv = co_fcal(rv, pb, co);
  if (iszero(pv, SIZ(co))) return FALSE;
  switch (BTP(co)) {
  case TID_I1B: iv = (I4B)*(I1B *)pv; goto _L1;
  case TID_U1B: iv = (I4B)*(U1B *)pv; goto _L1;
  case TID_I2B: iv = (I4B)*(I2B *)pv; goto _L1;
  case TID_U2B: iv = (I4B)*(U2B *)pv; goto _L1;
  case TID_I4B: iv = *(I4B *)pv; _L1:
    if (pa->cn == 0 || iv < pa->iv) pa->iv = iv;
    break;
  case TID_U4B: iv = *(U4B *)pv;
    if (pa->cn == 0 || (U4B)iv < (U4B)pa->iv) pa->iv = iv;
    break;
  case TID_I8B: lv = *(I8B *)pv;
    if (pa->cn == 0 || lv < pa->lv) pa->lv = lv;
    break;
  case TID_U8B: lv = *(U8B *)pv;
    if (pa->cn == 0 || (U8B)lv < (U8B)pa->lv) pa->lv = lv;
    break;
  case TID_F4B: dv = (F8B)*(F4B *)pv; goto _L2;
  case TID_F8B: dv = *(F8B *)pv; _L2:
    if (pa->cn == 0 || dv < pa->dv) pa->dv = dv;
    break;
  }
  pa->cn++;
  return TRUE;
}

BOOL LOCALF faggCOU(PCVOID pb, AGGP *pa)
{ // Wv֐
  PCVOID pv;
  PCCOLI co = pa->co;
  BYTE rv[512];

  pv = (PBYTE)pb + OFS(co);
  if (ISCAL(co)) pv = co_fcal(rv, pb, co);
  if (iszero(pv, SIZ(co))) return FALSE;
  pa->cn++;
  return TRUE;
}

int  LOCALF xcmpval(PCVOID p1, PCVOID p2, PCCOLI co, int flg)
{ // r
  int re;
  BYTE r1[512], r2[512];

  if (ISCAL(co)) { p1 = co_fcal(r1, p1, co); p2 = co_fcal(r2, p2, co);}
  if (flg & (SRT_ZRL|SRT_ZRF)) {
    re = iszero(p1, SIZ(co)) - iszero(p2, SIZ(co));
    if (flg & SRT_ZRF) re = -re;
    if (re) return re;
  }
  if ((flg & (SRT_PAL|SRT_PAF)) && BTP(co) == TID_STR) {
    re = (((PCSTR)p1)[0] == '(') - (((PCSTR)p2)[0] == '(');
    if (flg & SRT_PAF) re = -re;
    if (re) return re;
  }
  re = tp_fcmp(p1, p2, co);
  if (flg & SRT_DSN) re = -re;
  return re;
}

int  LOCALF fcmpSRT(PCVOID p1, PCVOID p2, UINT ts)
{ // בւr֐
  int i, re, ni = LEN(ts);
  HTBL tb = (HTBL)COX(&COL(ts)[0]);
  PCCOLI co;
  PCSRTE pb;

  for (i = 0; i < ni; i++) {
    pb = (PCSRTE)ROW(ts, i); if (pb->ic < 0) break;
    co = &COL(tb)[pb->ic];
    re = xcmpval((PBYTE)p1 + OFS(co), (PBYTE)p2 + OFS(co), co, pb->flg);
    if (re) return re;
  }
  return 0;
}

// ---------------------------------------------------------------------- //

HBUF WINAPI CreateRowBufX(PVOID pv, PCTBLI ti)
{ // sobt@̍쐬
  HTBL rb;

  rb = CreateTableX(pv, 0, 1, ti); if (!rb) return NULL;
  if (!pv) memset(PTR(rb), 0, RSZ(rb));
  LEN(rb) = 1;
  FLG(rb) |= TF_FIX;
  OTB(rb) = rb;
  return (HBUF)rb;
}

HBUF LOCALF CreateRowBufXB(PVOID pv, PCTBLI ti)
{ // sobt@̍쐬
  HBUF rb;

  rb = CreateRowBufX(pv, ti); if (!rb) return NULL;
  if (TRG(rb)) FLG(rb) |= TF_OTR;
  return rb;
}

HBUF WINAPI CreateRowBuf(HTBL tb)
{ // sobt@̍쐬
  PVOID pv;
  PTBLE rb;
  HBLK mb;

  rb = halloc(sizeof(TBLE) + sizeof(HBLK_) + RSZ(tb), FALSE); if (!rb) return ierr(E_MEM);
  mb = (PVOID)((PBYTE)rb + sizeof(TBLE));
  pv = (PVOID)((PBYTE)mb + sizeof(HBLK_));
  memset(pv, 0, RSZ(tb));
  *rb = *(TBLE *)tb;
  rb->mb = build_array(mb, pv, 1, 1, RSZ(tb));
  rb->otb = tb;
  rb->flg = (FLG(tb) | (TF_FIX|TF_STB)) &~TF_VIW;
  return (HBUF)rb;
}

void WINAPI DeleteRowBuf(HBUF rb)
{ // sobt@̍폜
  DeleteTable((HTBL)rb);
}

HBUF WINAPI DuplicateRowBuf(HBUF rb)
{ // sobt@̕
  HBUF rd;

  rd = CreateRowBuf(OTB(rb)); if (!rd) return NULL;
  memcpy(PTR(rd), PTR(rb), RSZ(rb));
  return rd;
}

HTBL WINAPI RowBufHTBL(HBUF rb)
{ // ̕\
  return OTB(rb);
}

PVOID WINAPI RowBufPtr(HBUF rb)
{ // obt@̃AhX
  return PTR(rb);
}

HBUF WINAPI MakeRowBuf(HTBL tb, PVOID pb)
{ // sAhXꎞIɍsobt@ƂĈ
  PTBLE rb;
  HBLK mb;

  rb = ualloc(sizeof(TBLE) + sizeof(HBLK_));
  mb = (PVOID)((PBYTE)rb + sizeof(TBLE));
  *rb = *(TBLE *)tb;
  rb->mb = build_array(mb, pb, 1, 1, RSZ(tb));
  rb->otb = tb;
  rb->flg = FLG(tb) | (TF_FIX|TF_STB|TF_TMP);
  return (HBUF)rb;
}

HBUF WINAPI TableRowBuf(HTBL tb, int ir)
{ // \̍sꎞIɍsobt@ƂĈ
  return MakeRowBuf(tb, TableRow(tb, ir));
}

HBUF WINAPI NewTableRowBuf(HTBL tb)
{ // ǉsꎞIɍsobt@ƂĈ
  return MakeRowBuf(tb, NewTableRow(tb));
}

void LOCALF SetRowBufCellValueX(HBUF rb, int ic, PCVOID pv)
{ // l̐ݒ
  setval(PTR(rb), pv, &COL(rb)[ic]);
}

BOOL WINAPI SetRowBufCellValue(HBUF rb, int ic, PCVOID pv)
{ // l̐ݒ
  if (FLG(rb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ic < 0 || ic >= NCO(rb)) return (BOOL)ierr(E_ICO);
  if (ISCAL(&COL(rb)[ic])) return (BOOL)ierr(E_CAL);
  setval(PTR(rb), pv, &COL(rb)[ic]);
  return TRUE;
}

PVOID LOCALF GetRowBufCellValueX(PVOID pv, HBUF rb, int ic)
{ // l̎擾
  return getval(pv, PTR(rb), &COL(rb)[ic]);
}

PVOID WINAPI GetRowBufCellValue(PVOID pv, HBUF rb, int ic)
{ // l̎擾
  if (ic < 0 || ic >= NCO(rb)) { ierr(E_ICO); return pv;}
  return getval(pv, PTR(rb), &COL(rb)[ic]);
}

void LOCALF ScanRowBufCellValueX(HBUF rb, int ic, PCSTR st)
{ // 񂩂Ǎ
  BYTE pv[512];

  scnval(pv, st, &COL(rb)[ic]);
  setval(PTR(rb), pv, &COL(rb)[ic]);
}

BOOL WINAPI ScanRowBufCellValue(HBUF rb, int ic, PCSTR st)
{ // 񂩂Ǎ
  if (FLG(rb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ic < 0 || ic >= NCO(rb)) return (BOOL)ierr(E_ICO);
  if (ISCAL(&COL(rb)[ic])) return (BOOL)ierr(E_CAL);
  ScanRowBufCellValueX(rb, ic, st);
  return TRUE;
}

PSTR LOCALF PrintRowBufCellValueX(PSTR st, HBUF rb, int ic)
{ // ɏo
  return prnval(st, PTR(rb) + OFS(&COL(rb)[ic]), &COL(rb)[ic]);
}

PSTR WINAPI PrintRowBufCellValue(PSTR st, HBUF rb, int ic)
{ // ɏo
  if (ic < 0 || ic >= NCO(rb)) { ierr(E_ICO); st[0] = '\0'; return st;}
  return prnval(st, PTR(rb) + OFS(&COL(rb)[ic]), &COL(rb)[ic]);
}

void LOCALF ClearRowBufX(HBUF rb)
{ // sobt@̃NA
  TableTrigger((HTBL)rb, TRGM_DEFAULT, 0, PTR(rb));
}

BOOL WINAPI ClearRowBuf(HBUF rb)
{ // sobt@̃NA
  if (FLG(rb) & TF_RDO) return (BOOL)ierr(E_RDO);
  ClearRowBufX(rb);
  return TRUE;
}

HBUF LOCALF CopyRowBufX(HBUF rb, HBUF rx)
{ // sobt@sobt@ւ̃Rs[
  memcpy(PTR(rb), PTR(rx), RSZ(rx)); return rb;
}

HBUF WINAPI CopyRowBuf(HBUF rb, HBUF rx)
{ // sobt@sobt@ւ̃Rs[
  if (!IsCompatible((HTBL)rb, (HTBL)rx)) { ierr(E_CMP); return rb;}
  if (FLG(rb) & TF_RDO) { ierr(E_RDO); return rb;}
  return CopyRowBufX(rb, rx);
}

BOOL LOCALF SetTableRowX(HTBL tb, int ir, HBUF rb)
{ // s̐ݒ
  int sz = RSZ(tb);
  PVOID pb, bk;

  memcpy(bk = ualloc(sz), pb = ROW(tb, ir), sz);
  memcpy(pb, PTR(rb), sz);
  if (!TableTrigger(tb, TRGM_BEFOREUPDATE, ir, pb)) {
    memcpy(pb, bk, sz); return FALSE;
  }
  TableTrigger(tb, TRGM_AFTERUPDATE, ir, pb);
  return TRUE;
}

BOOL WINAPI SetTableRow(HTBL tb, int ir, HBUF rb)
{ // s̐ݒ
  if (!IsCompatible(tb, (HTBL)rb)) return (BOOL)ierr(E_CMP);
  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  return SetTableRowX(tb, ir, rb);
}

HBUF LOCALF GetTableRowX(HBUF rb, HTBL tb, int ir)
{ // s̎擾
  memcpy(PTR(rb), ROW(tb, ir), RSZ(tb)); return rb;
}

HBUF WINAPI GetTableRow(HBUF rb, HTBL tb, int ir)
{ // s̎擾
  if (!IsCompatible((HTBL)rb, tb)) { ierr(E_CMP); return rb;}
  if (FLG(rb) & TF_RDO) { ierr(E_RDO); return rb;}
  return GetTableRowX(rb, tb, ir);
}

BOOL LOCALF SetNewTableRowX(HTBL tb, HBUF rb)
{ // s̒ǉ
  return AddTableRowX(tb)? SetTableRowX(tb, LEN(tb) - 1, rb): FALSE;
}

BOOL WINAPI SetNewTableRow(HTBL tb, HBUF rb)
{ // s̒ǉ
  if (!IsCompatible(tb, (HTBL)rb)) return (BOOL)ierr(E_CMP);
  if (FLG(tb) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(tb) & TF_FIX) return (BOOL)ierr(E_FIX);
  return SetNewTableRowX(tb, rb);
}

HBUF WINAPI CopyValues(HBUF rb, HBUF rx)
{ // l̃Rs[
  int i, j, nx = NCO(rx);
  PCCOLI co = COL(rb), cx = COL(rx);

  if (FLG(rb) & TF_RDO) { ierr(E_RDO); return rb;}
  for (i = 0; i < nx; i++) {
    if ((j = TableColumnIndex((HTBL)rb, cx[i].nam)) >= 0) {
      if (!ISCAL(&co[j])) cpyval(PTR(rb) + OFS(&co[j]), &co[j], PTR(rx) + OFS(&cx[i]), &cx[i]);
    }
  }
  return rb;
}

HBUF WINAPI CopyKey(HBUF rb, HBUF rx)
{ // OL[̃Rs[
  int i, nx = NCO(rx);
  PCCOLI co = COL(rb), cx = COL(rx);

  if (FLG(rb) & TF_RDO) { ierr(E_RDO); return rb;}
  for (i = 0; i < nx; i++) {
    if (!ISCAL(&cx[i]) && (cx[i].flg & CF_REF) && DBTable(RTI(&cx[i])) == OTB(rb)) {
      memcpy(PTR(rb) + OFS(&co[RCI(&cx[i])]), PTR(rx) + OFS(&cx[i]), SIZ(&cx[i]));
    }
  }
  return rb;
}

int  WINAPI CompareRowBuf(HBUF rb, HBUF rx)
{ // sobt@̔r
  return (RSZ(rb) == RSZ(rx))? memcmp(PTR(rb), PTR(rx), RSZ(rx)): RSZ(rb) - RSZ(rx);
}

int  WINAPI SearchKey(HTBL tb, HBUF rb)
{ // L[ɂT[`
  int i, sz = RSZ(tb), nc = NCO(tb);
  PCBYTE pc, pe, bf = PTR(rb);
  PCCOLI co = COL(tb);

  if (!IsCompatible(tb, (HTBL)rb)) { ierr(E_CMP); return -1;}
  if (NTableKeys(tb) == 0) return -1;
  for (pc = PTR(tb), pe = pc + LEN(tb) * sz; pc < pe; pc += sz) {
    for (i = 0; i < nc; i++) {
      if (co[i].flg & CF_KEY) {
        if (memcmp(pc + OFS(&co[i]), bf + OFS(&co[i]), SIZ(&co[i]))) goto _LC;
      }
    }
    return (pc - PTR(tb)) / sz;
   _LC:;
  }
  return -1;
}

HTBL WINAPI MergeTable(HTBL tb, HTBL tx)
{ // \̃}[W
  int i, j, sz = RSZ(tb), lx = LEN(tx);
  HBUF rb;

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return tb;}
  if (FLG(tb) & TF_RDO) { ierr(E_RDO); return tb;}
  if (FLG(tb) & TF_FIX) { ierr(E_FIX); return tb;}
  rb = CreateRowBuf(tb); if (!rb) return tb;
  for (i = 0; i < lx; i++) {
    GetTableRowX(rb, tx, i);
    if ((j = SearchKey(tb, rb)) >= 0) {
      memcpy(ROW(tb, j), ROW(tx, i), sz);
    } else {
      memcpy(NewTableRowX(tb), ROW(tx, i), sz);
    }
  }
  DeleteRowBuf(rb);
  return tb;
}

int  WINAPI UniqueKey(HTBL tb, int ic, UINT h0, UINT hs)
{ // L[l̎̔
  int i, ln = LEN(tb);
  UINT va, v0;
  PCCOLI co;

  if (ic < 0 || ic >= NCO(tb)) return (int)ierr(E_ICO);
  co = &COL(tb)[ic];
  if (BTP(co) > TID_U4B) return (int)ierr(E_NIN);
  if (hs <= h0 + 1) return (int)ierr(E_PAR);
  va = v0 = h0 + hash(format("%s%d", CurUser(), get_tick_count()), hs - h0);
 _L1:
  for (i = 0; i < ln; i++) {
    if (!memcmp(ROW(tb, i) + OFS(co), &va, SIZ(co))) {
      va++;
      if (va == hs) va = h0;
      if (va == v0) return 0;
      goto _L1;
    }
  }
  return va;
}

int  WINAPI SearchTableRow(HTBL tb, int i0, PCSTR cnd)
{ // i荞ݏɂT[`
  int re;
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, tb); if (!tc) return -1;
  ScanCNDTable(tc, cnd);
  re = SearchTableRowX(tb, i0, fselCND, (UINT)tc);
  DeleteTable(tc);
  return re;
}

int  WINAPI CountTableRows(HTBL tb, PCSTR cnd)
{ // i荞ݏɂJEg
  int re;
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, tb); if (!tc) return 0;
  ScanCNDTable(tc, cnd);
  re = CountTableRowsX(tb, fselCND, (UINT)tc);
  DeleteTable(tc);
  return re;
}

int  WINAPI SelectTableRows(HTBL tb, PCSTR cnd)
{ // i荞ݏɂi荞
  int re;
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, tb); if (!tc) return LEN(tb);
  ScanCNDTable(tc, cnd);
  re = SelectTableRowsX(tb, fselCND, (UINT)tc);
  DeleteTable(tc);
  return re;
}

HTBL WINAPI SelectCopyTable(HTBL tb, HTBL tx, PCSTR cnd)
{ // i荞݃Rs[
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, tb); if (!tc) return tb;
  ScanCNDTable(tc, cnd);
  SelectCopyTableX(tb, tx, fselCND, (UINT)tc);
  DeleteTable(tc);
  return tb;
}

HTBL WINAPI SelectMergeTable(HTBL tb, HTBL tx, PCSTR cnd)
{ // i荞݃}[W(u)
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, tb); if (!tc) return tb;
  ScanCNDTable(tc, cnd);
  SelectMergeTableX(tb, tx, fselCND, (UINT)tc);
  DeleteTable(tc);
  return tb;
}

REAL WINAPI AggregateTable(HTBL tb, int ic, int sw, PCSTR cnd)
{ // Wv
  HTBL tc;
  FAGG fagg;
  F8B dv;
  AGGP apa;

  if (ic < 0 || ic >= NCO(tb)) { ierr(E_ICO); return 0.0;}
  tc = CreateCNDTable(VIWCAP, tb); if (!tc) return 0.0;
  memset(&apa, 0, sizeof(AGGP));
  ScanCNDTable(tc, cnd);
  apa.co = &COL(tb)[ic];
  switch (sw) {
  case AGG_SUM:
  case AGG_AVG: fagg = (FAGG)faggSUM; break;
  case AGG_MAX: fagg = (FAGG)faggMAX; break;
  case AGG_MIN: fagg = (FAGG)faggMIN; break;
  default:      fagg = (FAGG)faggCOU; break;
  }
  AggregateTableX(tb, fselCND, (UINT)tc, fagg, (UINT)&apa);
  switch (sw) {
  case AGG_SUM: dv = apa.dv; break;
  case AGG_AVG: dv = (apa.cn > 0)? apa.dv / apa.cn: 0.0; break;
  case AGG_MAX:
  case AGG_MIN:
    switch (BTP(apa.co)) {
    case TID_I1B: case TID_U1B:
    case TID_I2B: case TID_U2B:
    case TID_I4B: case TID_U4B: dv = (F8B)apa.iv; break;
    case TID_I8B: case TID_U8B: dv = (F8B)apa.lv; break;
    case TID_F4B: case TID_F8B: dv = apa.dv; break;
    }
    break;
  default: dv = (F8B)apa.cn; break;
  }
  DeleteTable(tc);
  return dv;
}

void WINAPI SortTableRows(HTBL tb, PCSTR srt)
{ // בւ
  HTBL ts;

  ts = CreateSRTTable(VIWCAP, tb); if (!ts) return;
  ScanSRTTable(ts, srt);
  SortTableRowsX(tb, fcmpSRT, (UINT)ts);
  DeleteTable(ts);
}

HTBL WINAPI CreateSummaryV(HTBL tb, PCSTR grp, PCSTR cnd, PCSTR srt)
{ // Wv\̍쐬
  HTBL tr;
  HVIW vw;

  vw = CreateView(tb, "*", cnd, srt); if (!vw) return NULL;
  tr = CreateSummary(vw, grp);
  DeleteView(vw);
  return tr;
}

#define  OPR_UPDATE  1
#define  OPR_INSERT  2
#define  OPR_DELETE  3

HTBL LOCALF CreateDIFTable(HTBL tb, HTBL tx)
{ // \̍쐬
  int i, j, ln = LEN(tb), lx = LEN(tx), nc = NCO(tb);
  PCCOLI co = COL(tb);
  PBYTE pb;
  HTBL df;
  HBUF rb;
  static TBLI tbi;
  static COLI cx[] = { { TID_I4B,  0, "_opr", }, { TID_I4B,  0, "_dmy", } };

  if (!IsCompatible(tb, tx)) return ierr(E_CMP);
  tbi.cs = halloc(sizeof(COLS) + (nc + 2) * sizeof(COLI), FALSE); if (!tbi.cs) return ierr(E_MEM);
  tbi.cs->co = (PVOID)((PBYTE)tbi.cs + sizeof(COLS));
  tbi.cs->nc = nc + 2;
  tbi.cs->co[0] = cx[0];
  tbi.cs->co[1] = cx[1];
  for (i = 0; i < nc; i++) {
    tbi.cs->co[2 + i] = co[i];
  }
  rb = CreateRowBuf(tb); if (!rb) { df = NULL; goto _L2;}
  df = CreateTable(0, &tbi); if (!df) goto _L1;
  if (CompareTable(tb, tx) == 0) goto _L1;
  for (i = 0; i < ln; i++) {
    GetTableRowX(rb, tb, i);
    if ((j = SearchKey(tx, rb)) >= 0) {
      if (CompareRowBuf(rb, TableRowBuf(tx, j))) {
        *(PINT)(pb = NewTableRowX(df)) = OPR_UPDATE;
        memcpy(pb + 2 * sizeof(int), PTR(rb), RSZ(rb));
      }
    } else {
      *(PINT)(pb = NewTableRowX(df)) = OPR_INSERT;
      memcpy(pb + 2 * sizeof(int), PTR(rb), RSZ(rb));
    }
  }
  for (i = 0; i < lx; i++) {
    GetTableRowX(rb, tx, i);
    if ((j = SearchKey(tb, rb)) < 0) {
      *(PINT)(pb = NewTableRowX(df)) = OPR_DELETE;
      memcpy(pb + 2 * sizeof(int), PTR(rb), RSZ(rb));
    }
  }
 _L1: DeleteRowBuf(rb);
 _L2: hfree(tbi.cs);
  return df;
}

HTBL LOCALF MergeDIFTable(HTBL tb, HTBL df)
{ // \ƍ\̃}[W
  int i, j, ln = LEN(df);
  HBUF rb;

  rb = CreateRowBuf(tb); if (!rb) return tb;
  for (i = 0; i < ln; i++) {
    memcpy(PTR(rb), ROW(df, i) + 2 * sizeof(int), RSZ(rb));
    switch (*(PINT)ROW(df, i)) {
    case OPR_UPDATE:
      if ((j = SearchKey(tb, rb)) >= 0) {
        memcpy(ROW(tb, j), ROW(df, i) + 2 * sizeof(int), RSZ(tb));
      }
      break;
    case OPR_INSERT:
      if ((j = SearchKey(tb, rb)) < 0) {
        memcpy(NewTableRowX(tb), ROW(df, i) + 2 * sizeof(int), RSZ(tb));
      }
      break;
    case OPR_DELETE:
      if ((j = SearchKey(tb, rb)) >= 0) {
        DeleteTableRowX(tb, j);
      }
      break;
    }
  }
  DeleteRowBuf(rb);
  return tb;
}

HTBL LOCALF DIFTableTrigger(HTBL tb, HTBL tx, HTBL df)
{ // \ɂgK
  int i, j, k, ln = LEN(df);
  HBUF rb;

  rb = CreateRowBuf(tb); if (!rb) return tb;
  for (i = 0; i < ln; i++) {
    memcpy(PTR(rb), ROW(df, i) + 2 * sizeof(int), RSZ(rb));
    switch (*(PINT)ROW(df, i)) {
    case OPR_UPDATE:
      if ((j = SearchKey(tb, rb)) >= 0 && (k = SearchKey(tx, rb)) >= 0) {
        TableTrigger(tb, TRGM_UPDATERECORD, j, ROW(tx, k));
      }
      break;
    case OPR_INSERT:
      if ((j = SearchKey(tb, rb)) >= 0) {
        TableTrigger(tb, TRGM_INSERTRECORD, j, ROW(tb, j));
      }
      break;
    case OPR_DELETE:
      if ((k = SearchKey(tx, rb)) >= 0) {
        TableTrigger(tb, TRGM_DELETERECORD, 0, ROW(tx, k));
      }
      break;
    }
  }
  DeleteRowBuf(rb);
  return tb;
}

BOOL WINAPI IsConflict(HTBL tb, HTBL tx)
{ // ̃`FbN
  int i, j, ln = LEN(tb), re = TRUE;
  HBUF rb;

  if (!IsCompatible(tb, tx)) { ierr(E_CMP); return TRUE;}
  rb = CreateRowBuf(tb); if (!rb) return TRUE;
  for (i = 0; i < ln; i++) {
    GetTableRowX(rb, tb, i);
    if ((j = SearchKey(tx, rb)) >= 0) {
      if (memcmp(ROW(tx, j), PTR(rb), RSZ(rb))) goto _L1;
    }
  }
  re = FALSE;
 _L1: DeleteRowBuf(rb);
  return re;
}

BOOL WINAPI IsDependent(HTBL tb, int i1, int i2, PCVOID p1, PCVOID p2)
{ // ]֌W̃`FbN
  int i, ln = LEN(tb);
  PCCOLI c1, c2;

  if (i1 < 0 || i1 >= NCO(tb) || i2 < 0 || i2 >= NCO(tb)) return (BOOL)ierr(E_ICO);
  c1 = &COL(tb)[i1]; c2 = &COL(tb)[i2];
  if (i1 == i2 || SIZ(c1) != SIZ(c2)) return (BOOL)ierr(E_PAR);
  for (i = 0; i < ln; i++) {
    if (!memcmp(ROW(tb, i) + OFS(c1), p1, SIZ(c1))) {
      if (!memcmp(ROW(tb, i) + OFS(c2), p2, SIZ(c1))) return TRUE;
    }
  }
  for (i = 0; i < ln; i++) {
    if (!memcmp(ROW(tb, i) + OFS(c1), p1, SIZ(c1))) {
      if (IsDependent(tb, i1, i2, ROW(tb, i) + OFS(c2), p2)) return TRUE;
    }
  }
  return FALSE;
}

  // \`Zbg
static PCSTR SVUD[] = { "VXe", "[U[" };
static ENMS esVUD = { SVUD, NELEM(SVUD) };

static COLI ciVIW[] = {
  { STR(32),  0, "nam", "\`",   NULL, CF_KEY, },
  { TID_E1B,  0, "ud",  "`",         NULL, 0, NULL, NULL, (UINT)&esVUD, },
  { TID_U1B,  0, "us",  "I",         },
  { TID_U2B,  0, "fc",  "Œ",     },
  { STR(510), 0, "arr", "\",     },
  { STR(320), 0, "cnd", "i荞ݏ", },
  { STR(320), 0, "srt", "בւ", },
};
static COLS csVIW = { ciVIW, NELEM(ciVIW) };
static TBLI tiVIW = { &csVIW, NULL, "BOLVIW", NULL, NULL, 0, NULL, NULL, 0, sizeof(VIWE) };

HTBL WINAPI CreateVIWTable(int cap, PCVIWS vs)
{ // \`Zbg̍쐬
  int i;
  HTBL tv;
  VIWE dat;

  if (vs && cap < vs->ni) cap = vs->ni;
  tv = CreateTable(cap, &tiVIW); if (!tv) return NULL;
  if (!vs) return tv;
  for (i = 0; i < vs->ni; i++) {
    strcpyx(dat.nam, vs->vi[i].nam? vs->vi[i].nam: format("_%03d", i + 1), sizeof(dat.nam) - 1);
    dat.ud = dat.us = 0;
    dat.fc = vs->vi[i].fc;
    strcpyx(dat.arr, vs->vi[i].arr? vs->vi[i].arr: "", sizeof(dat.arr) - 1);
    strcpyx(dat.cnd, vs->vi[i].cnd? vs->vi[i].cnd: "", sizeof(dat.cnd) - 1);
    strcpyx(dat.srt, vs->vi[i].srt? vs->vi[i].srt: "", sizeof(dat.srt) - 1);
    *(VIWE *)NewTableRowX(tv) = dat;
  }
  return tv;
}

PVIWI WINAPI SetVIWInfo(PVIWI vi, HBUF bv)
{ // \`
  PVIWE pv = (PVIWE)PTR(bv);

  vi->nam = pv->nam;
  vi->fc  = pv->fc;
  vi->arr = pv->arr;
  vi->cnd = pv->cnd;
  vi->srt = pv->srt;
  return vi;
}

int  WINAPI SearchVIWTableRow(HTBL tv, HBUF bv)
{ // \`̃T[`
  PVIWE pb, pe, pv = (PVIWE)PTR(bv);

  for (pb = (PVIWE)PTR(tv), pe = pb + LEN(tv); pb < pe; pb++) {
    if (pb->fc == pv->fc && !strcmp(pb->arr, pv->arr) && !strcmp(pb->cnd, pv->cnd) && !strcmp(pb->srt, pv->srt)) {
      return pb - (PVIWE)PTR(tv);
    }
  }
  return -1;
}

int  WINAPI SearchVIWTableRowByName(HTBL tv, PCSTR nam)
{ // \`ɂT[`
  PVIWE pb, pe;

  for (pb = (PVIWE)PTR(tv), pe = pb + LEN(tv); pb < pe; pb++) {
    if (!strcmp(pb->nam, nam)) {
      return pb - (PVIWE)PTR(tv);
    }
  }
  return -1;
}

void WINAPI SetLastVIW(HTBL tv, HBUF bv)
{ // ŌɑIꂽ\`ݒ
  int ir;

  if ((ir = SearchVIWTableRow(tv, bv)) >= 0) ((PVIWE)ROW(tv, ir))->us = 1;
}

int  WINAPI GetLastVIW(HTBL tv)
{ // ŌɑIꂽ\`擾ăNA
  PVIWE pb, pe;

  for (pb = (PVIWE)PTR(tv), pe = pb + LEN(tv); pb < pe; pb++) {
    if (pb->us) { pb->us = 0; return pb - (PVIWE)PTR(tv);}
  }
  return -1;
}

BOOL LOCALF fselVIW(PVIWE pb, UINT pa)
{ // [U[`
  return pb->ud == 1;
}

void WINAPI CopyUserVIWTable(HTBL tv, HTBL tx)
{ // [U[`ڂ̂݃Rs[
  SelectCopyTableX(tv, tx, (FSEL)fselVIW, 0);
}

// ---------------------------------------------------------------------- //

HVIW LOCALF CreateViewO(HTBL tb)
{ // r[̍쐬
  PINT pi;
  PIDXS vr, vc;
  PTBLE vw;

  vw = halloc(sizeof(TBLE) + 2 * sizeof(IDXS) + NCO(tb) * sizeof(int), FALSE); if (!vw) return ierr(E_MEM);
  vr = (PVOID)((PBYTE)vw + sizeof(TBLE));
  vc = (PVOID)((PBYTE)vr + sizeof(IDXS));
  pi = halloc(CAP(tb) * sizeof(int), FALSE); if (!pi) { hfree(vw); return ierr(E_MEM);}
  *vw = *(TBLE *)tb;
  vw->vr = SetIDXS(vr, pi, 0);
  vw->vc = SetIDXS(vc, (PINT)((PBYTE)vc + sizeof(IDXS)), 0);
  vw->otb = tb;
  vw->flg = FLG(tb) | TF_VIW;
  return (HVIW)vw;
}

HVIW WINAPI CreateViewX(HTBL tb, PCIDXS pa, FSEL fsel, UINT ps, FSRT fcmp, UINT pc)
{ // r[̍쐬
  HVIW vw;

  vw = CreateViewO(tb); if (!vw) return NULL;
  ArrangeViewColumnsX(vw, pa);
  SelectViewRowsX(vw, fsel, ps);
  SortViewRowsX(vw, fcmp, pc);
  return vw;
}

int  LOCALF SelectViewRowsXB(HVIW vw, FSEL fsel, UINT pa);
void LOCALF SortViewRowsXB(HVIW vw, FSRT fcmp, UINT pa);

HVIW LOCALF CreateViewXB(HTBL tb, PCIDXS pa, FSEL fsel, UINT ps, FSRT fcmp, UINT pc)
{ // r[̍쐬
  HVIW vw;

  vw = CreateViewO(tb); if (!vw) return NULL;
  ArrangeViewColumnsX(vw, pa);
  SelectViewRowsXB(vw, fsel, ps);
  SortViewRowsXB(vw, fcmp, pc);
  return vw;
}

HVIW WINAPI CreateView(HTBL tb, PCSTR arr, PCSTR cnd, PCSTR srt)
{ // r[̍쐬
  HTBL ta, tc, ts;
  HVIW vw = NULL;

  ta = CreateARRTable(0, tb);      if (!ta) goto _L3;
  tc = CreateCNDTable(VIWCAP, tb); if (!tc) goto _L2;
  ts = CreateSRTTable(VIWCAP, tb); if (!ts) goto _L1;
  ScanARRTable(ta, arr);
  ScanCNDTable(tc, cnd);
  ScanSRTTable(ts, srt);
  vw = CreateViewX(tb, (PCIDXS)MBK(ta), fselCND, (UINT)tc, fcmpSRT, (UINT)ts);
  DeleteTable(ts); _L1:
  DeleteTable(tc); _L2:
  DeleteTable(ta); _L3:
  return vw;
}

void WINAPI DeleteView(HVIW vw)
{ // r[̍폜
  DeleteTable((HTBL)vw);
}

HTBL WINAPI ViewHTBL(HVIW vw)
{ // ̕\
  return OTB(vw);
}

int  WINAPI NViewRows(HVIW vw)
{ // s
  return VNR(vw);
}

PVOID WINAPI ViewRow(HVIW vw, int ir)
{ // s̃AhX
  if (ir < 0 || ir >= VNR(vw)) { ierr(E_IRO); return valloc(RSZ(vw));}
  return ROW(vw, VIR(vw)[ir]);
}

int  WINAPI ViewRowIndex(HVIW vw, int ir)
{ // r[̍sCfbNX\̍sCfbNX߂
  return VIR(vw)[ir];
}

int  WINAPI NViewColumns(HVIW vw)
{ // 
  return VNC(vw);
}

PCCOLI WINAPI ViewColumnInfo(HVIW vw, int ic)
{ // 
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return valloc(sizeof(COLI));}
  return &COL(vw)[VIC(vw)[ic]];
}

void WINAPI SetViewColumnWidth(HVIW vw, int ic, int wd)
{ // 񕝂̐ݒ
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return;}
  WID(&COL(vw)[VIC(vw)[ic]]) = (BYTE)wd;
}

int  WINAPI ViewColumnWidth(HVIW vw, int ic)
{ // 
  if (ic < 0 || ic >= VNC(vw)) return (int)ierr(E_ICO);
  return WID(&COL(vw)[VIC(vw)[ic]]);
}

int  WINAPI ViewColumnWidthF(HVIW vw, int ic)
{ // 
  int wd;

  if (!vw || ic < 0 || ic >= VNC(vw)) return DEFCWID;
  wd = WID(&COL(vw)[VIC(vw)[ic]]); return wd? wd: DEFCWID;
}

void WINAPI SetViewColumnTextAlign(HVIW vw, int ic, int al)
{ // ̕R[h̐ݒ
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return;}
  ALN(&COL(vw)[VIC(vw)[ic]]) = (BYTE)al;
}

int  WINAPI ViewColumnTextAlign(HVIW vw, int ic)
{ // ̕R[h
  if (ic < 0 || ic >= VNC(vw)) return (int)ierr(E_ICO);
  return ALN(&COL(vw)[VIC(vw)[ic]]);
}

int  WINAPI ViewColumnTextAlignF(HVIW vw, int ic)
{ // ̕R[h
  if (!vw || ic < 0 || ic >= VNC(vw)) return ALN_RGT;
  return ALN(&COL(vw)[VIC(vw)[ic]]);
}

PCSTR WINAPI ViewColumnName(HVIW vw, int ic)
{ // 
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return "";}
  return COL(vw)[VIC(vw)[ic]].nam;
}

int  WINAPI ViewColumnIndex(HVIW vw, int ic)
{ // r[̗CfbNX\̗CfbNX߂
  return VIC(vw)[ic];
}

void WINAPI SetViewColumnTitle(HVIW vw, int ic, PCSTR tit)
{ // ^Cg̐ݒ
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return;}
  COL(vw)[VIC(vw)[ic]].tit = tit? tit: COL(vw)[VIC(vw)[ic]].nam;
}

PCSTR WINAPI ViewColumnTitle(HVIW vw, int ic)
{ // ^Cg
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return "";}
  return COL(vw)[VIC(vw)[ic]].tit;
}

void WINAPI SetViewColumnDescription(HVIW vw, int ic, PCSTR dsc)
{ // ̐ݒ
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return;}
  COL(vw)[VIC(vw)[ic]].dsc = dsc? dsc: COL(vw)[VIC(vw)[ic]].tit;
}

PCSTR WINAPI ViewColumnDescription(HVIW vw, int ic)
{ // 
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return "";}
  return COL(vw)[VIC(vw)[ic]].dsc;
}

PCSTR WINAPI ViewColumnDescriptionR(HVIW vw, int ic)
{ // 
  int ln;
  PCSTR st;

  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return "";}
  st = COL(vw)[VIC(vw)[ic]].dsc;
  if ((ln = strlen(st)) >= 4 && st[ln-4] == '(' && st[ln-3] == '&' && isaln(st[ln-2]) && st[ln-1] == ')') {
    st = strcpyn(talloc(ln - 3), st, ln - 4);
  }
  return st;
}

void WINAPI SetViewColumnFlags(HVIW vw, int ic, int flg)
{ // 񑮐̐ݒ
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return;}
  COL(vw)[VIC(vw)[ic]].flg = flg;
}

int  WINAPI ViewColumnFlags(HVIW vw, int ic)
{ // 񑮐
  if (ic < 0 || ic >= VNC(vw)) return (int)ierr(E_ICO);
  return COL(vw)[VIC(vw)[ic]].flg;
}

int  WINAPI ViewColumnFlagsF(HVIW vw, int ic)
{ // 񑮐
  if (!vw || ic < 0 || ic >= VNC(vw)) return 0;
  return COL(vw)[VIC(vw)[ic]].flg;
}

void WINAPI SetViewColumnExtra(HVIW vw, int ic, UINT pa)
{ // ̕t̐ݒ
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return;}
  COX(&COL(vw)[VIC(vw)[ic]]) = pa;
}

UINT WINAPI ViewColumnExtra(HVIW vw, int ic)
{ // ̕t
  if (ic < 0 || ic >= VNC(vw)) return (UINT)ierr(E_ICO);
  return COX(&COL(vw)[VIC(vw)[ic]]);
}

BOOL LOCALF SetViewCellValueX(HVIW vw, int ir, int ic, PCVOID pv)
{ // l̐ݒ
  return SetTableCellValueX((HTBL)vw, VIR(vw)[ir], VIC(vw)[ic], pv);
}

BOOL WINAPI SetViewCellValue(HVIW vw, int ir, int ic, PCVOID pv)
{ // l̐ݒ
  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ir < 0 || ir >= VNR(vw)) return (BOOL)ierr(E_IRO);
  if (ic < 0 || ic >= VNC(vw)) return (BOOL)ierr(E_ICO);
  if (ISCAL(&COL(vw)[VIC(vw)[ic]])) return (BOOL)ierr(E_CAL);
  return SetTableCellValueX((HTBL)vw, VIR(vw)[ir], VIC(vw)[ic], pv);
}

PVOID LOCALF GetViewCellValueX(PVOID pv, HVIW vw, int ir, int ic)
{ // l̎擾
  return GetTableCellValueX(pv, (HTBL)vw, VIR(vw)[ir], VIC(vw)[ic]);
}

PVOID WINAPI GetViewCellValue(PVOID pv, HVIW vw, int ir, int ic)
{ // l̎擾
  if (ir < 0 || ir >= VNR(vw)) { ierr(E_IRO); return pv;}
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return pv;}
  return GetTableCellValueX(pv, (HTBL)vw, VIR(vw)[ir], VIC(vw)[ic]);
}

BOOL LOCALF ScanViewCellValueX(HVIW vw, int ir, int ic, PCSTR st)
{ // 񂩂Ǎ
  return ScanTableCellValueX((HTBL)vw, VIR(vw)[ir], VIC(vw)[ic], st);
}

BOOL WINAPI ScanViewCellValue(HVIW vw, int ir, int ic, PCSTR st)
{ // 񂩂Ǎ
  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ir < 0 || ir >= VNR(vw)) return (BOOL)ierr(E_IRO);
  if (ic < 0 || ic >= VNC(vw)) return (BOOL)ierr(E_ICO);
  if (ISCAL(&COL(vw)[VIC(vw)[ic]])) return (BOOL)ierr(E_CAL);
  return ScanTableCellValueX((HTBL)vw, VIR(vw)[ir], VIC(vw)[ic], st);
}

BOOL WINAPI ScanViewCellValueF(HVIW vw, int ir, int ic, PCSTR st)
{ // 񂩂Ǎ
  if (!vw || (FLG(vw) & TF_RDO) || ir < 0 || ir >= VNR(vw) || ic < 0 || ic >= VNC(vw)) return FALSE;
  if (COL(vw)[VIC(vw)[ic]].flg & (CF_HCH|CF_RDO|CF_DED)) return FALSE;
  return ScanTableCellValueX((HTBL)vw, VIR(vw)[ir], VIC(vw)[ic], st);
}

PSTR LOCALF PrintViewCellValueX(PSTR st, HVIW vw, int ir, int ic)
{ // ɏo
  return PrintTableCellValueX(st, (HTBL)vw, VIR(vw)[ir], VIC(vw)[ic]);
}

PSTR WINAPI PrintViewCellValue(PSTR st, HVIW vw, int ir, int ic)
{ // ɏo
  if (ir < 0 || ir >= VNR(vw)) { ierr(E_IRO); st[0] = '\0'; return st;}
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); st[0] = '\0'; return st;}
  return PrintTableCellValueX(st, (HTBL)vw, VIR(vw)[ir], VIC(vw)[ic]);
}

PSTR WINAPI PrintViewCellValueF(PSTR st, HVIW vw, int ir, int ic, int flg)
{ // ɏo
  st[0] = '\0';
  if (!vw || ir >= VNR(vw) || ic >= VNC(vw)) return st;
  switch ((ir >= 0) * 2 + (ic >= 0)) {
  case 0:
    break;
  case 1:
    if      (flg & PVF_TIT) strcpy(st, ViewColumnTitle(vw, ic));
    else if (flg & PVF_IDX) sprintf(st, "%d", VIC(vw)[ic] + (flg & PVF_OBI));
    else                    strcpy(st, ViewColumnName(vw, ic));
    break;
  case 2:
    sprintf(st, "%d", VIR(vw)[ir] + (flg & PVF_OBI));
    break;
  default:
    PrintViewCellValueX(st, vw, ir, ic);
    break;
  }
  return st;
}

BOOL WINAPI ClearViewRow(HVIW vw, int ir)
{ // s̃NA
  return ClearViewRows(vw, ir, 1);
}

BOOL WINAPI ClearViewRows(HVIW vw, int ir, int nr)
{ // ͈͂̃NA
  int i, sz = RSZ(vw), nv = VNR(vw), re = TRUE;
  PCINT vi = VIR(vw);
  PVOID pb, bk;

  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (ir < 0 || ir > nv || nr < 0) return (BOOL)ierr(E_IRO);
  if (ir + nr > nv) nr = nv - ir;
  bk = ualloc(sz);
  for (i = ir; i < ir + nr; i++) {
    memcpy(bk, pb = ROW(vw, vi[i]), sz);
    TableTrigger(OTB(vw), TRGM_DEFAULT, vi[i], pb);
    if (!TableTrigger(OTB(vw), TRGM_BEFOREUPDATE, vi[i], pb)) {
      memcpy(pb, bk, sz); re = FALSE;
    } else {
      TableTrigger(OTB(vw), TRGM_AFTERUPDATE, vi[i], pb);
    }
  }
  return re;
}

BOOL WINAPI InsertViewRow(HVIW vw, int ir)
{ // s̑}
  return InsertViewRows(vw, ir, 1);
}

BOOL WINAPI InsertViewRows(HVIW vw, int ir, int nr)
{ // ͈͂̑}
  int i, k, ln = LEN(vw), sz = RSZ(vw), nv = VNR(vw);
  PINT vi;

  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(vw) & TF_FIX) return (BOOL)ierr(E_FIX);
  if (ir < 0 || ir > nv || nr < 0) return (BOOL)ierr(E_IRO);
  if (ln + nr > CAP(vw)) {
    if (!ChangeTableCapacityX((HTBL)vw, ln + nr)) return FALSE;
  }
  vi = VIR(vw);
  if (ir < nv) {
    k = vi[ir];
    memmove(ROW(vw, k + nr), ROW(vw, k), (ln - k) * sz);
  } else {
    k = ln;
  }
  for (i = 0; i < nv; i++) {
    if (vi[i] >= k) vi[i] += nr;
  }
  if (ir < nv) {
    memmove(vi + ir + nr, vi + ir, (nv - ir) * sizeof(int));
  }
  for (i = ir; i < ir + nr; i++) {
    vi[i] = k + i - ir;
  }
  LEN(vw) += nr;
  VNR(vw) += nr;
  for (i = k; i < k + nr; i++) {
    TableTrigger(OTB(vw), TRGM_DEFAULT, i, ROW(vw, i));
  }
  return TRUE;
}

BOOL WINAPI DeleteViewRow(HVIW vw, int ir)
{ // s̍폜
  return DeleteViewRows(vw, ir, 1);
}

BOOL WINAPI DeleteViewRows(HVIW vw, int ir, int nr)
{ // ͈͂̍폜
  int i, j, di, ln = LEN(vw), sz = RSZ(vw), nv = VNR(vw);
  PINT vi = VIR(vw);

  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(vw) & TF_FIX) return (BOOL)ierr(E_FIX);
  if (ir < 0 || ir > nv || nr < 0) return (BOOL)ierr(E_IRO);
  if (ir == nv) return TRUE;
  if (ir + nr > nv) nr = nv - ir;
  for (i = ir; i < ir + nr; i++) {
    if (!TableTrigger(OTB(vw), TRGM_BEFOREDELETE, vi[i], ROW(vw, vi[i]))) return FALSE;
  }
  di = 0;
  for (j = 0; j < ln; j++) {
    for (i = 0; i < nv; i++) {
      if (vi[i] == j) {
        if (i >= ir && i < ir + nr) { di++; goto _LC;}
        vi[i] -= di; break;
      }
    }
    if (di > 0) {
      memcpy(ROW(vw, j - di), ROW(vw, j), sz);
    }
   _LC:;
  }
  if (ir + nr < nv) {
    memmove(vi + ir, vi + ir + nr, (nv - ir - nr) * sizeof(int));
  }
  VNR(vw) -= nr;
  LEN(vw) -= di;
  return TRUE;
}

BOOL WINAPI AddViewRow(HVIW vw)
{ // s̒ǉ
  return InsertViewRow(vw, VNR(vw));
}

PVOID WINAPI NewViewRow(HVIW vw)
{ // ǉs
  return AddViewRow(vw)? ROW(vw, VIR(vw)[VNR(vw) - 1]): valloc(RSZ(vw));
}

void WINAPI ArrangeViewColumnsX(HVIW vw, PCIDXS pa)
{ // \̐ݒ
  int i, n, nc;
  PINT vc = VIC(vw);
  PCCOLI co;

  if (!pa) {
    co = COL(vw); nc = NCO(vw);
    for (n = i = 0; i < nc; i++) {
      if (WID(&co[i]) && !ISCAL(&co[i])) vc[n++] = i;
    }
  } else {
    for (n = i = 0; i < pa->ni; i++) {
      vc[n++] = pa->pi[i];
    }
  }
  VNC(vw) = n;
}

int  WINAPI SearchViewRowX(HVIW vw, int i0, FSEL fsel, UINT pa)
{ // T[`
  int i, nv = VNR(vw);
  PCINT vi = VIR(vw);

  if (i0 < 0 || i0 > nv) { ierr(E_IRO); return -1;}
  if (!fsel) return i0;
  for (i = i0; i < nv; i++) {
    if (fsel(ROW(vw, vi[i]), pa)) return i;
  }
  return -1;
}

int  LOCALF SearchViewRowXB(HVIW vw, int i0, FSEL fsel, UINT pa)
{ // T[`
  int i, nv = VNR(vw);
  PCINT vi = VIR(vw);

  if (i0 < 0 || i0 > nv) { ierr(E_IRO); return -1;}
  if (!fsel) return i0;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return i0;}
  for (i = i0; i < nv; i++) {
    if (fselBCD((int)fsel, ROW(vw, vi[i]), pa)) return i;
  }
  return -1;
}

int  WINAPI CountViewRowsX(HVIW vw, FSEL fsel, UINT pa)
{ // JEg
  int i, n, nv = VNR(vw);
  PCINT vi = VIR(vw);

  if (!fsel) return nv;
  for (n = i = 0; i < nv; i++) {
    if (fsel(ROW(vw, vi[i]), pa)) n++;
  }
  return n;
}

int  LOCALF CountViewRowsXB(HVIW vw, FSEL fsel, UINT pa)
{ // JEg
  int i, n, nv = VNR(vw);
  PCINT vi = VIR(vw);

  if (!fsel) return nv;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return nv;}
  for (n = i = 0; i < nv; i++) {
    if (fselBCD((int)fsel, ROW(vw, vi[i]), pa)) n++;
  }
  return n;
}

int  WINAPI SelectViewRowsX(HVIW vw, FSEL fsel, UINT pa)
{ // i荞
  int i, n, ln = LEN(vw);
  PINT vi = VIR(vw);

  if (!fsel) {
    for (n = i = 0; i < ln; i++) vi[n++] = i;
    return VNR(vw) = n;
  }
  for (n = i = 0; i < ln; i++) {
    if (fsel(ROW(vw, i), pa)) vi[n++] = i;
  }
  return VNR(vw) = n;
}

int  LOCALF SelectViewRowsXB(HVIW vw, FSEL fsel, UINT pa)
{ // i荞
  int i, n, ln = LEN(vw);
  PINT vi = VIR(vw);

  if (!fsel) { _L0:
    for (n = i = 0; i < ln; i++) vi[n++] = i;
    return VNR(vw) = n;
  }
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); goto _L0;}
  for (n = i = 0; i < ln; i++) {
    if (fselBCD((int)fsel, ROW(vw, i), pa)) vi[n++] = i;
  }
  return VNR(vw) = n;
}

void WINAPI SortViewRowsX(HVIW vw, FSRT fcmp, UINT pa)
{ // בւ
  int g, i, j, s, wk, nv = VNR(vw);
  PINT vi = VIR(vw);

  if (!fcmp || nv <= 1) return;
  g = nv;
  do {
    switch (g = g * 10 / 13) {
    case 0: g = 1; break;
    case 9: case 10: g = 11; break;
    }
    s = 0;
    for (i = 0, j = g; j < nv; i++, j++) {
      if (fcmp(ROW(vw, vi[i]), ROW(vw, vi[j]), pa) > 0) {
        wk = vi[i];
        vi[i] = vi[j];
        vi[j] = wk;
        s = 1;
      }
    }
  } while (s != 0 || g > 1);
}

void LOCALF SortViewRowsXB(HVIW vw, FSRT fcmp, UINT pa)
{ // בւ
  int g, i, j, s, wk, nv = VNR(vw);
  PINT vi = VIR(vw);

  if (!fcmp || nv <= 1) return;
  if (!(hbAct = hbAddIn? hbAddIn: hbMain)) { ierr(E_NOA); return;}
  g = nv;
  do {
    switch (g = g * 10 / 13) {
    case 0: g = 1; break;
    case 9: case 10: g = 11; break;
    }
    s = 0;
    for (i = 0, j = g; j < nv; i++, j++) {
      if (fcmpBCD((int)fcmp, ROW(vw, vi[i]), ROW(vw, vi[j]), pa) > 0) {
        wk = vi[i];
        vi[i] = vi[j];
        vi[j] = wk;
        s = 1;
      }
    }
  } while (s != 0 || g > 1);
}

void WINAPI ArrangeViewColumns(HVIW vw, PCSTR arr)
{ // \̐ݒ
  HTBL ta;

  ta = CreateARRTable(0, (HTBL)vw); if (!ta) return;
  ScanARRTable(ta, arr);
  ArrangeViewColumnsX(vw, (PCIDXS)MBK(ta));
  DeleteTable(ta);
}

int  WINAPI SearchViewRow(HVIW vw, int i0, PCSTR cnd)
{ // i荞ݏɂT[`
  int re;
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, (HTBL)vw); if (!tc) return -1;
  ScanCNDTable(tc, cnd);
  re = SearchViewRowX(vw, i0, fselCND, (UINT)tc);
  DeleteTable(tc);
  return re;
}

int  WINAPI CountViewRows(HVIW vw, PCSTR cnd)
{ // i荞ݏɂJEg
  int re;
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, (HTBL)vw); if (!tc) return 0;
  ScanCNDTable(tc, cnd);
  re = CountViewRowsX(vw, fselCND, (UINT)tc);
  DeleteTable(tc);
  return re;
}

int  WINAPI SelectViewRows(HVIW vw, PCSTR cnd)
{ // i荞ݏɂi荞
  int re;
  HTBL tc;

  tc = CreateCNDTable(VIWCAP, (HTBL)vw); if (!tc) return LEN(vw);
  ScanCNDTable(tc, cnd);
  re = SelectViewRowsX(vw, fselCND, (UINT)tc);
  DeleteTable(tc);
  return re;
}

void WINAPI SortViewRows(HVIW vw, PCSTR srt)
{ // בւ
  HTBL ts;

  ts = CreateSRTTable(VIWCAP, (HTBL)vw); if (!ts) return;
  ScanSRTTable(ts, srt);
  SortViewRowsX(vw, fcmpSRT, (UINT)ts);
  DeleteTable(ts);
}

void WINAPI SortTableRowsByView(HVIW vw)
{ // r[̕яɂבւ
  int i, j, k, sz = RSZ(vw), nv = VNR(vw);
  PINT vi = VIR(vw);
  PVOID bf;

  if (FLG(vw) & TF_RDO) { ierr(E_RDO); return;}
  bf = ualloc(sz);
  for (i = 0; i < nv; i++) {
    k = vi[i]; if (k == i) continue;
    memcpy(bf, ROW(vw, i), sz);
    memcpy(ROW(vw, i), ROW(vw, k), sz);
    memcpy(ROW(vw, k), bf, sz);
    vi[i] = i;
    for (j = i + 1; j < nv; j++) {
      if (vi[j] == i) { vi[j] = k; break;}
    }
  }
}

  // Wvڃf[^
typedef struct {
  PCCOLI co;  // -+
  I4B   iv;   //  |
  I8B   lv;   //  |
  F8B   dv;   //  |= AGGP
  int   cn;   // -+
  FAGG  fagg;
  int   df;
} AGGX;

HTBL LOCALF CreateSummaryX(HVIW vw, HTBL tg)
{ // Wv\̍쐬
  int i, j, g, id, sz, wd, nv = VNR(vw);
  PCINT vi = VIR(vw);
  PCBYTE pb, pl;
  PCGRPM pg = (PCGRPM)MBK(tg);
  PCCOLI co;
  AGGX *ax;
  HTBL tr;
  HBUF rb;
  static TBLI tbi = { NULL, NULL, "BOLAGG", "Wv\", NULL, TF_NOA|TF_DTR, };
  char bf[512];

  tbi.cs = halloc(sizeof(COLS) + pg->ni * sizeof(COLI), FALSE); if (!tbi.cs) return ierr(E_MEM);
  tbi.cs->co = (PVOID)((PBYTE)tbi.cs + sizeof(COLS));
  ax = halloc(pg->ni * sizeof(AGGX), FALSE); if (!ax) { ierr(E_MEM); goto _L5;}
  g = -1;
  for (i = 0; i < pg->ni; i++) {
    if (pg->ge[i].ic < 0) break;
    ax[i].co = co = &COL(vw)[pg->ge[i].ic];
    wd = WID(co);
    switch (pg->ge[i].sw) {
    case AGG_SUM:
    case AGG_AVG: ax[i].fagg = (FAGG)faggSUM;
      id = (TIDOF(co) == TID_M8B)? TID_M8B: TID_F8B;
      goto _L2;
    case AGG_MAX: ax[i].fagg = (FAGG)faggMAX; goto _L1;
    case AGG_MIN: ax[i].fagg = (FAGG)faggMIN; _L1:
      switch (BTP(co)) {
      case TID_I1B:
      case TID_U1B:
      case TID_I2B:
      case TID_U2B: id = TID_I4B; break;
      case TID_I4B: id = (TIDOF(co) == TID_M4B)? TID_M4B: TID_I4B; break;
      case TID_U4B: id = TID_U4B; break;
      case TID_I8B: id = TID_I8B; break;
      case TID_U8B: id = TID_U8B; break;
      case TID_F4B: id = TID_F8B; break;
      case TID_F8B: id = (TIDOF(co) == TID_M8B)? TID_M8B: TID_F8B; break;
      default:      id = TID_I4B; break;
      }
      goto _L2;
    case AGG_COU: ax[i].fagg = (FAGG)faggCOU;
      id = TID_I4B;
     _L2:
      sz = btpsiz(BTP(&TIE[id]));
      switch (pg->ge[i].sb) {
      case FMT_DEC:
        if (id == TID_M4B) id = TID_I4B;  else if (id == TID_M8B) id = TID_F8B;
        break;
      case FMT_CMA:
        if (id == TID_I4B) id = TID_M4B;  else if (id == TID_F8B) id = TID_M8B;
        break;
      }
      if (pg->ge[i].wd > 0) {
        wd = pg->ge[i].wd + (pg->ge[i].sb == FMT_CMA) * 2 + (pg->ge[i].sc > 0) + strlen(pg->ge[i].unt);
      }
      break;
    default: ax[i].fagg = NULL;
      id = TID_STR;
      sz = wd + 4;
      if (pg->ge[i].sw == AGG_GRP) g = i;
      break;
    }
    tbi.cs->co[i] = *co;
    tbi.cs->co[i].itp = MAKEUINT(id, sz);
    tbi.cs->co[i].atr = ATR(wd, ALN(co));
    tbi.cs->co[i].nam = "";
    if (pg->ge[i].tit[0] != '\0') {
      tbi.cs->co[i].tit = stostr(pg->ge[i].tit);
    }
    if (pg->ge[i].sb != 0 || id != TIDOF(co)) {
      tbi.cs->co[i].pa0 = (UINT)decfmt(id, &pg->ge[i]);
    }
    tbi.cs->co[i].flg &=~(CF_DDL|CF_DDN|CF_LNK);
  }
  tbi.cs->nc = i;
  tr = CreateTable(0, &tbi); if (!tr) goto _L4;
  rb = CreateRowBuf(tr); if (!rb) { DeleteTable(tr); tr = NULL; goto _L4;}
  for (i = 0; i <= nv; i++) {
    if (i > 0) pl = pb;
    if (i < nv) pb = ROW(vw, vi[i]);
    if (i == 0) goto _L3;
    if (i == nv || (g >= 0 && cmpval(pl + OFS(ax[g].co), pb + OFS(ax[g].co), ax[g].co) != 0)) {
      for (j = 0; j < tbi.cs->nc; j++) {
        bf[0] = '\0';
        switch (pg->ge[j].sw) {
        case AGG_SUM:
          *(F8B *)bf = ax[j].dv; break;
        case AGG_AVG:
          *(F8B *)bf = (ax[j].cn > 0)? ax[j].dv / ax[j].cn: 0.0; break;
        case AGG_MAX:
        case AGG_MIN:
          switch (BTP(ax[j].co)) {
          case TID_I4B: case TID_U4B: *(I4B *)bf = ax[j].iv; break;
          case TID_I8B: case TID_U8B: *(I8B *)bf = ax[j].lv; break;
          case TID_F8B:               *(F8B *)bf = ax[j].dv; break;
          }
          break;
        case AGG_COU:
          *(I4B *)bf = ax[j].cn; break;
        default:
          if (ax[j].df == 0) PrintTableCellValueX(bf, (HTBL)vw, vi[i-1], pg->ge[j].ic);
          break;
        }
        SetRowBufCellValueX(rb, j, bf);
      }
      SetNewTableRowX(tr, rb); if (i == nv) break;
     _L3:
      for (j = 0; j < tbi.cs->nc; j++) {
        ax[j].iv = 0; ax[j].lv = 0LL; ax[j].dv = 0.0; ax[j].cn = ax[j].df = 0;
      }
    } else {
      for (j = 0; j < tbi.cs->nc; j++) {
        if (pg->ge[j].sw == 0 && ax[j].df == 0) {
          ax[j].df = cmpval(pl + OFS(ax[j].co), pb + OFS(ax[j].co), ax[j].co);
        }
      }
    }
    for (j = 0; j < tbi.cs->nc; j++) {
      if (ax[j].fagg) ax[j].fagg(pb, (UINT)&ax[j]);
    }
  }
  DeleteRowBuf(rb);
 _L4: hfree(ax);
 _L5: hfree(tbi.cs);
  return tr;
}

HTBL WINAPI CreateSummary(HVIW vw, PCSTR grp)
{ // Wv\̍쐬
  HTBL tg, tr;

  tg = CreateGRPTable(VIWCAP, (HTBL)vw); if (!tg) return NULL;
  ScanGRPTable(tg, grp);
  tr = CreateSummaryX(vw, tg);
  DeleteTable(tg);
  return tr;
}

int  WINAPI SearchViewCellValue(HVIW vw, int i0, int ic, PCVOID pv)
{ // l̃T[`
  int i, nv = VNR(vw);
  PCINT vi = VIR(vw);
  PCCOLI co;
  BYTE rv[512];

  if (i0 < 0 || i0 > nv) { ierr(E_IRO); return -1;}
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return -1;}
  co = &COL(vw)[VIC(vw)[ic]];
  for (i = i0; i < nv; i++) {
    if (!memcmp(getval(rv, ROW(vw, vi[i]), co), pv, SIZ(co))) return i;
  }
  return -1;
}

int  WINAPI SearchViewCellText(HVIW vw, int i0, int ic, PCSTR st, int flg)
{ // ̃T[`
  int i, nv = VNR(vw);
  PCINT vi = VIR(vw);
  PCCOLI co;
  FSTX fstx;
  char bf[512], wk[512];

  if (i0 < 0 || i0 > nv) { ierr(E_IRO); return -1;}
  if (ic < 0 || ic >= VNC(vw)) { ierr(E_ICO); return -1;}
  co = &COL(vw)[VIC(vw)[ic]];
  stxprep(&fstx, wk, &st, flg);
  for (i = i0; i < nv; i++) {
    if (fstx(prnval(bf, ROW(vw, vi[i]) + OFS(co), co), st) == 0) return i;
  }
  return -1;
}

int  LOCALF readval(PSTR wk, PCSTR pt, PCCSVI cv)
{ // ڂ̓Ǎ
  int d;
  PCSTR p1, p2, p3;

  p1 = pt;
  if (cv->dlm == ' ') while (*p1 == ' ') p1++;
  if (cv->quo && *p1 == cv->quo) {
    p1++;
    d = cv->quo;
  } else {
    d = cv->dlm;
  }
  p2 = p1;
  while (*p2 != '\0' && *p2 != d) p2++;
  p3 = p2;
  if (d == cv->quo && *p2 == d) {
    p3++;
    d = cv->dlm;
  }
  while (*p3 != '\0' && *p3 != d) p3++;
  if (cv->quo == 0) {
    if (*p1 == '\"' && p2 > p1 + 1 && *(p2-1) == '\"') {
      p1++; p2--;
    }
  }
  spncpy(wk, p1, p2);
  return p3 - pt;
}

#define  LBSZ  16384

BOOL WINAPI ReadCSV(HVIW vw, PCSTR nam, PCCSVI cv)
{ // bruǍ
  int i, n, nc, ir, sw, re = FALSE;
  PINT vi;
  PSTR bf, pt, pe;
  HBUF rb;
  HANDLE hf;
  char wk[512];

  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(vw) & TF_FIX) return (BOOL)ierr(E_FIX);
  bf = halloc(LBSZ, FALSE); if (!bf) return (BOOL)ierr(E_MEM);
  rb = CreateRowBuf((HTBL)vw); if (!rb) goto _L3;
  hf = open_file(nam, OP_RDO); if (!hf) { ferr(E_FIR, nam); goto _L2;}
  if (cv->tsw != TSW_NON) {
    read_line(hf, bf, LBSZ);
    pe = bf + strlen(bf);
  }
  if (cv->tsw == TSW_NAM) {
    nc = NCO(vw); if (nc < 64) nc = 64;
    vi = halloc(nc * sizeof(int), FALSE); if (!vi) { ierr(E_MEM); goto _L1;}
    for (i = 0, pt = bf; i < nc && pt < pe; i++, pt += (n + 1)) {
      n = readval(wk, pt, cv);
      vi[i] = TableColumnIndex((HTBL)vw, wk);
    }
    for ( ; i < nc; i++) vi[i] = -1;
  } else {
    nc = VNC(vw);
  }
  while (read_line(hf, bf, LBSZ)) {
    pe = bf + strlen(bf);
    ClearRowBufX(rb);
    sw = 0;
   _L0:
    for (i = 0, pt = bf; i < nc && pt < pe; i++, pt += (n + 1)) {
      n = readval(wk, pt, cv);
      if (cv->tsw == TSW_NAM) {
        if (vi[i] >= 0) ScanRowBufCellValueX(rb, vi[i], wk);
      } else {
        ScanRowBufCellValueX(rb, ViewColumnIndex(vw, i), wk);
      }
    }
    if (sw == 0) {
      if ((ir = SearchKey((HTBL)vw, rb)) >= 0) {
        GetTableRowX(rb, (HTBL)vw, ir);
        sw = 1; goto _L0;
      } else {
        ir = TableRowIndex((HTBL)vw, NewViewRow(vw));
      }
    }
    SetTableRowX((HTBL)vw, ir, rb);
  }
  if (cv->tsw == TSW_NAM) hfree(vi);
  re = TRUE;
 _L1: close_file(hf);
 _L2: DeleteRowBuf(rb);
 _L3: hfree(bf);
  return re;
}

BOOL WINAPI WriteCSV(HVIW vw, PCSTR nam, PCCSVI cv)
{ // bruo
  int i, j, op, nv = VNR(vw), nc = VNC(vw), sw, re = FALSE;
  PSTR bf, pt;
  HANDLE hf;
  char wk[512];

  bf = halloc(LBSZ, FALSE); if (!bf) return (BOOL)ierr(E_MEM);
  hf = open_file(nam, OP_WRI); if (!hf) { ferr(E_FIW, nam); goto _L1;}
  op = (cv->tsw == TSW_NAM)? PVF_NAM: PVF_TIT;
  for (i = -(cv->tsw != TSW_NON); i < nv; i++) {
    pt = bf;
    for (j = 0; j < nc; j++) {
      if (ViewColumnWidth(vw, j) == 0) continue;
      PrintViewCellValueF(wk, vw, i, j, op);
      sw = (strspn(wk, "-.0123456789") != strlen(wk));
      if (cv->quo && sw) *pt++ = cv->quo;
      pt += sprintf(pt, "%s", wk);
      if (cv->quo && sw) *pt++ = cv->quo;
      if (cv->dlm && j < nc - 1) *pt++ = cv->dlm;
    }
    *pt = '\0';
    write_line(hf, bf);
  }
  re = TRUE;
  close_file(hf);
 _L1: hfree(bf);
  return re;
}

BOOL WINAPI ReadINI(PVOID pb, PCTBLI ti)
{ // t@CǍ
  int ic, n, re = FALSE;
  HBUF rb;
  HANDLE hf;
  char bf[512];

  rb = CreateRowBufX(pb, ti); if (!rb) return FALSE;
  hf = open_file(ti->imp, OP_RDO); if (!hf) { ferr(E_FIR, ti->imp); goto _L2;}
  n = 0;
  while (read_line(hf, bf, sizeof(bf))) {
    start(bf);
    if (token_is(TKN_IDN)) {
      if ((ic = TableColumnIndex((HTBL)rb, buf())) >= 0) {
        if (token_is(BOP_LEQ)) {
          ScanRowBufCellValueX(rb, ic, cpos());
          n++;
        }
      }
    }
  }
  if (n == 0) { ferr(E_FIR, ti->imp); goto _L1;}
  re = TRUE;
 _L1: close_file(hf);
 _L2: DeleteRowBuf(rb);
  return re;
}

BOOL WINAPI WriteINI(PVOID pb, PCTBLI ti)
{ // t@Cɏo
  int i, re = FALSE;
  HBUF rb;
  HANDLE hf;
  char bf[512];

  rb = CreateRowBufX(pb, ti); if (!rb) return FALSE;
  hf = open_file(ti->imp, OP_WRI); if (!hf) { ferr(E_FIW, ti->imp); goto _L1;}
  for (i = 0; i < ti->cs->nc; i++) {
    strcpy(bf, TableColumnTitle((HTBL)rb, i));
    if (bf[0] == '[') {
      write_line(hf, bf);
    }
    if (TableColumnFlags((HTBL)rb, i) & CF_DED) continue;
    sprintf(bf, "%s=", TableColumnName((HTBL)rb, i)); PrintRowBufCellValueX(bf + strlen(bf), rb, i);
    write_line(hf, bf);
  }
  re = TRUE;
  close_file(hf);
 _L1: DeleteRowBuf(rb);
  return re;
}

BOOL WINAPI ReadATR(PVOID pb, PCTBLI ti, PCSTR st)
{ // Ǎ
  int ic;
  HBUF rb;

  rb = CreateRowBufX(pb, ti); if (!rb) return FALSE;
  start(st);
  while (token_is(TKN_IDN)) {
    if ((ic = TableColumnIndex((HTBL)rb, buf())) >= 0) {
      if (token_is(BOP_LEQ)) {
        if (token_is(TKN_U4B)) {
          ScanRowBufCellValueX(rb, ic, format("%d", *(I4B *)buf()));
        } else if (token_is(TKN_F8B)) {
          ScanRowBufCellValueX(rb, ic, format("%.15G", *(F8B *)buf()));
        } else if (token_is(TKN_STR) || token_is(TKN_IDN)) {
          ScanRowBufCellValueX(rb, ic, buf());
        } else break;
      } else break;
    } else break;
  }
  DeleteRowBuf(rb);
  return cpos() > st;
}

int  WINAPI RowBlkSize(HVIW vw, int nr)
{ // subÑTCY
  return (NCO(vw) + 2) * sizeof(int) + nr * RSZ(vw);
}

void WINAPI CopyRowBlk(PVOID pv, HVIW vw, int i0, int nr)
{ // subÑRs[
  int i, sz = RSZ(vw), nv = VNR(vw), nc = NCO(vw);
  PBYTE pb = pv;
  PCINT vi = VIR(vw);
  PCCOLI co = COL(vw);

  if (i0 < 0 || i0 > nv || nr < 0) { ierr(E_IRO); return;}
  if (i0 + nr > nv) nr = nv - i0;
  *((PINT)pb)++ = nc;
  for (i = 0; i < nc; i++) {
    *((PINT)pb)++ = co[i].itp;
  }
  *((PINT)pb)++ = nr;
  for (i = 0; i < nr; i++) {
    memcpy(pb, ROW(vw, vi[i0 + i]), sz);
    pb += sz;
  }
}

BOOL WINAPI InsertRowBlk(HVIW vw, int i0, PCVOID pv)
{ // subN̑}
  int i, nr, nv = VNR(vw), nc = NCO(vw);
  PCBYTE pb = pv;
  PCCOLI co = COL(vw);

  if (FLG(vw) & TF_RDO) return (BOOL)ierr(E_RDO);
  if (FLG(vw) & TF_FIX) return (BOOL)ierr(E_FIX);
  if (i0 < 0 || i0 > nv) return (BOOL)ierr(E_IRO);
  if (*((PINT)pb)++ != nc) return FALSE;
  for (i = 0; i < nc; i++) {
    if (*((PINT)pb)++ != co[i].itp) return FALSE;
  }
  nr = *((PINT)pb)++;
  if (!InsertViewRows(vw, i0, nr)) return FALSE;
  memcpy(ROW(vw, VIR(vw)[i0]), pb, nr * RSZ(vw));
  return TRUE;
}

// ---------------------------------------------------------------------- //

#define  PRGNAM  "BOLYAI"

static char SNAM[16] = PRGNAM;
static char STIT[32] = PRGNAM;
static char SDSC[64] = PRGNAM;

static char SLOG[20] = PRGNAM".LOG";

static REAL RTAX = 0.10;

static int  FYMN =  4;
static int  NMFY = 12;

static char UDIR[512] = "C:\\NFILES\\";

static int  CYMD;

void WINAPI SetSiteVariables(PCSITI sv)
{ // TCgϐ̐ݒ
  if (sv->nam && strlen(sv->nam) < sizeof(SNAM) && isidn(sv->nam)) {
    strcpy(SNAM, sv->nam);
    strcpy(SLOG, addext(sv->nam, ".LOG"));
  }
  if (sv->tit && strlen(sv->tit) < sizeof(STIT)) strcpy(STIT, sv->tit);
  if (sv->dsc && strlen(sv->dsc) < sizeof(SDSC)) strcpy(SDSC, sv->dsc);
  if (sv->dir && strlen(sv->dir) < sizeof(UDIR)) strcpy(UDIR, sv->dir);
  if (sv->tax > 0.0 && sv->tax < 1.0) RTAX = sv->tax;
  if (sv->fym >= 1 && sv->fym <= 12)  FYMN = sv->fym;
  if (sv->nmf >= 1 && sv->nmf <= 18)  NMFY = sv->nmf;
}

PCSTR WINAPI SiteName(void)
{ // TCg
  return SNAM;
}

PCSTR WINAPI SiteTitle(void)
{ // TCg^Cg
  return STIT;
}

PCSTR WINAPI SiteDescription(void)
{ // TCg
  return SDSC;
}

REAL WINAPI TaxRate(void)
{ // ŗ
  return RTAX;
}

int  WINAPI FYearMonth(void)
{ // ƔNxJn
  return FYMN;
}

int  WINAPI NMonthFYear(void)
{ // ƔNx
  return NMFY;
}

void WINAPI SetUserPath(PCSTR dir)
{ // [U[tH_̐ݒ
  if (dir && strlen(dir) < sizeof(UDIR)) strcpy(UDIR, dir);
}

PCSTR WINAPI UserPath(void)
{ // [U[tH_
  return UDIR;
}

void WINAPI SetCurDate(int sr)
{ // vZ̐ݒ
  if (sr) CYMD = sr;
}

int  WINAPI CurDate(void)
{ // vZ
  return CYMD;
}

int  WINAPI BFYear(void)
{ // ƔNxJn
  return date_serial(year(CYMD) - (month(CYMD) < FYMN), FYMN, 1);
}

int  WINAPI EFYear(void)
{ // ƔNxI
  return date_serial(year(BFYear()), FYMN + NMFY, 0);
}

int  WINAPI BMonth(void)
{ // 
  return date_serial(year(CYMD), month(CYMD), 1);
}

int  WINAPI EMonth(void)
{ // 
  return date_serial(year(CYMD), month(CYMD) + 1, 0);
}

// ---------------------------------------------------------------------- //

PCSTR WINAPI BCDExt(int pro)
{ // oCgR[h̊gq
  switch (pro) {
  case PRO_DEF: return ".BCF";
  case PRO_OPR: return ".BCO";
  case PRO_REP: return ".BCR";
  }
  return ".BCD";
}

PCSTR WINAPI BCDMain(int pro)
{ // Gg֐錾
  switch (pro) {
  case PRO_DEF: return "BOOL ConnectMain(void);";
  case PRO_OPR: return "void CommandMain(HWND hwnd);";
  case PRO_REP: return "BOOL ReportMain(HREP rp, int msg, int pg, UINT pa);";
  }
  return "void main(void);";
}

HBLK WINAPI CreateTMP(PCPROI pi)
{ // ev[g̍쐬
  HBLK xb;
  PCSTR tmpstr1a =
    "COLI ciTMP[1] = {\r\n"
    "  { STR(64),  0, \"cnam\", \"^Cg\", \"\", CF_KEY, },\r\n"
    "};\r\n"
    "COLS csTMP = { ciTMP, NELEM(ciTMP) };\r\n"
    "\r\n"
    "TBLI tiTMP[1] = {\r\n"
    "  { &csTMP, NULL, \"TNAM\",  \"\^Cg\", \"\\", },\r\n"
    "};\r\n"
    "TBLS tsTMP = { tiTMP, NELEM(tiTMP) };\r\n"
    "\r\n"
    "BDBI dbTMP = { &tsTMP, ";
  PCSTR tmpstr1b =
    "};\r\n"
    "\r\n"
    "BOOL ConnectMain(void)\r\n"
    "{ // Tv\r\n"
    "  int re;\r\n"
    "\r\n"
    "  re = ConnectDBX(&dbTMP);\r\n"
    "  if (re) NewDBFiles();\r\n"
    "  return re;\r\n"
    "}\r\n";
  PCSTR tmpstr2 =
    "void CommandMain(HWND hwnd)\r\n"
    "{ // Tv\r\n"
    "  OkBox(hwnd, \"hello, world\", NULL);\r\n"
    "}\r\n";
  PCSTR tmpstr3 =
    "BOOL ReportMain(HREP rp, int msg, int pg, UINT pa)\r\n"
    "{ // Tv\r\n"
    "  static CELL cel = { 20.0, 80.0, 190.0, 100.0 };\r\n"
    "\r\n"
    "  if (msg == REPM_DRAWPAGE) {\r\n"
    "    SetTextFont(rp, NULL, 15.0, 0, 0);\r\n"
    "    CellText(rp, &cel, \"hello, world\", DT_CEN);\r\n"
    "  }\r\n"
    "  return TRUE;\r\n"
    "}\r\n";

  xb = CreateTXT(256); if (!xb) return NULL;
  if (pi->nam[0]) {
    AddStr(xb, format("// info  nam=\"%s\"", pi->nam));
    if (pi->tit[0]) AddStr(xb, format("  tit=\"%s\"", pi->tit));
    if (pi->dsc[0]) AddStr(xb, format("  dsc=\"%s\"", pi->dsc));
    if (pi->pro)    AddStr(xb, format("  pro=%d", pi->pro));
    AddStr(xb, "\r\n\r\n");
  }
  switch (pi->pro) {
  case PRO_DEF:
    AddStr(xb, tmpstr1a);
    AddStr(xb, format("\"%s\", ", (pi->nam[0] != '\0')? pi->nam: "ca"));
    AddStr(xb, format("\"%s\", ", (pi->tit[0] != '\0')? pi->tit: "ca^Cg"));
    AddStr(xb, format("\"%s\" ",  (pi->dsc[0] != '\0')? pi->dsc: "ca"));
    AddStr(xb, tmpstr1b);
    break;
  case PRO_OPR:
    AddStr(xb, tmpstr2);
    break;
  case PRO_REP:
    AddStr(xb, tmpstr3);
    break;
  }
  return xb;
}

static COLI ciPRO[] = {
  { TID_U4B,  0, "pro", },
  { STR(16),  0, "nam", },
  { STR(32),  0, "tit", },
  { STR(64),  0, "dsc", },
};
static COLS csPRO = { ciPRO, NELEM(ciPRO) };
static TBLI tiPRO = { &csPRO, };

void WINAPI ScanProcInfo(PPROI pi, HBLK xb)
{ // vV[W̎擾
  PCSTR pt, st = (PCSTR)xb->ptr;

  memset(pi, 0, sizeof(PROI));
  if (!!(pt = strfind(st, "info "))) {
    ReadATR(pi, &tiPRO, pt + 5);
  }
  if (pi->pro <= 0 || pi->pro > 3) {
    if      (strfind(st, "ConnectMain")) pi->pro = PRO_DEF;
    else if (strfind(st, "CommandMain")) pi->pro = PRO_OPR;
    else if (strfind(st, "ReportMain"))  pi->pro = PRO_REP;
    else                                 pi->pro = 0;
  }
}

BOOL LOCALF ftrgBSA(HTBL tb, int msg, int ir, PBSAI pb)
{ // [U[Ǘ\gK֐
  switch (msg) {
  case MAKEUINT(TRGM_BEFOREUPDATEOF, 0):
    if (pb->usr[0] == '\0') return (BOOL)terr(E_NUS, ir, 0);
    break;
  case MAKEUINT(TRGM_BEFOREUPDATEOF, 1):
    if (pb->pwd[0] == '\0') return (BOOL)terr(E_NPW, ir, 1);
    break;
  case TRGM_BEFOREUPDATE:
    if (pb->usr[0] == '\0') return (BOOL)terr(E_NUS, ir, 0);
    if (pb->pwd[0] == '\0') return (BOOL)terr(E_NPW, ir, 1);
    break;
  }
  return DefaultTableTrigger(tb, msg, ir, (PVOID)pb);
}

static PCSTR SLEV[] = { "", "{", "ҏW", "caǗ", "TCgǗ" };
static ENMS esLEV = { SLEV, NELEM(SLEV) };

static COLI ciBSA[] = {
  { STR(32),  0, "usr", "[U[",   NULL, CF_KEY, },
  { STR(32),  0, "pwd", "pX[h",   NULL, CF_DSP, },
  { TID_E4B,  0, "lev", "",         NULL, CF_DDL, NULL, NULL, (UINT)&esLEV, },
};
static COLS csBSA = { ciBSA, NELEM(ciBSA) };
static TBLI tiBSA = { &csBSA, NULL, "BOLBSA", "[U[Ǘ\", NULL, TF_CYP, (FTRG)ftrgBSA, NULL, 0, sizeof(BSAI) };

HTBL WINAPI CreateBSATable(int cap, BOOL ld)
{ // [U[Ǘ\̍쐬
  HTBL tb;

  tiBSA.imp = addext(SNAM, ".BSA");
  tb = CreateTable(cap, &tiBSA); if (!tb) return NULL;
  if (ld) LoadBTB(tb);
  return tb;
}

int  LOCALF srchbsa(HTBL tb, PCSTR usr)
{ // [U[Ǘ\̃T[`
  int i, ln = LEN(tb);

  for (i = 0; i < ln; i++) {
    if (!stricmp(usr, ((PBSAI)ROW(tb, i))->usr)) return i;
  }
  return -1;
}

BOOL LOCALF readbhd(PBCDH ph, PCSTR nam)
{ // oCgR[ht@Cwb_Ǎ
  int re;
  HANDLE hf;

  hf = open_file(nam, OP_RDO); if (!hf) return FALSE;
  re = read_file(hf, ph, sizeof(BCDH));
  close_file(hf);
  return re;
}

int  LOCALF EnumBCD(HTBL tb, PCSTR nam, int app, int pro)
{ // oCgR[h̃Xg쐬
  HANDLE hf;
  FFDI ffd;
  BCDH bhd;
  BSDI dat;

  hf = find_first_file(nam, &ffd); if (!hf) return 0;
  do {
    if (!readbhd(&bhd, ffd.nam)) continue;
    if (app != 0 && LOWORD(bhd.app) != LOWORD(app)) continue;
    if (pro != 0 && bhd.pro != pro) continue;
    strcpyx(dat.nam, basnamx(ffd.nam), sizeof(dat.nam) - 1);
    strcpyx(dat.tit, bhd.tit, sizeof(dat.tit) - 1);
    strcpyx(dat.dsc, bhd.dsc, sizeof(dat.dsc) - 1);
    *(BSDI *)NewTableRowX(tb) = dat;
  } while (find_next_file(hf, &ffd));
  find_close(hf);
  return LEN(tb);
}

static COLI ciBSD[] = {
  { STR(16), 10, "nam", "O",     NULL, CF_KEY, },
  { STR(32), 20, "tit", "^Cg", },
  { STR(64), 22, "dsc", "",     },
};
static COLS csBSD = { ciBSD, NELEM(ciBSD) };
static TBLI tiBSD = { &csBSD, NULL, "BOLBSD", NULL, NULL, 0, NULL, NULL, 0, sizeof(BSDI) };

HTBL WINAPI CreateBSDTable(int cap, int pro)
{ // oCgR[hXg̍쐬
  HTBL tb;

  tiBSD.imp = addext(SNAM, ".BSD");
  tb = CreateTable(cap, &tiBSD); if (!tb) return NULL;
  if (pro) EnumBCD(tb, addext("*", BCDExt(pro)), IAPP, pro);
  return tb;
}

static COLI ciBSU[] = {
  { STR(32),  0, "usr", "[U[", NULL, CF_KEY, },
};
static COLS csBSU = { ciBSU, NELEM(ciBSU) };
static TBLI tiBSU = { &csBSU, NULL, "BOLBSU", NULL, NULL, 0, NULL, NULL, 0, sizeof(BSUI) };

HTBL WINAPI CreateBSUTable(int cap, BOOL ld)
{ // OC[U[Xg̍쐬
  HTBL tb;

  tiBSU.imp = addext(SNAM, ".BSU");
  tb = CreateTable(cap, &tiBSU); if (!tb) return NULL;
  if (ld) LoadBTB(tb);
  return tb;
}

BOOL LOCALF fselBSU(PBSUI pb, PBSUI pa)
{ // I֐
  return !strcmp(pb->usr, pa->usr);
}

BOOL LOCALF addusr(HTBL tb, PCSTR usr)
{ // [U[ǉ
  BSUI dat;

  new_file_if_not_exists(FNM(tb));
  if (!OpenBTB(tb)) return FALSE;
  strcpyx(dat.usr, usr, sizeof(dat.usr) - 1);
  if (SearchTableRowX(tb, 0, (FSEL)fselBSU, (UINT)&dat) < 0) {
    *(BSUI *)NewTableRowX(tb) = dat;
  }
  return CloseBTB(tb, TRUE);
}

BOOL LOCALF delusr(HTBL tb, PCSTR usr)
{ // [U[폜
  int ir;
  BSUI dat;

  if (file_size(FNM(tb)) == 0) return FALSE;
  if (!OpenBTB(tb)) return FALSE;
  strcpyx(dat.usr, usr, sizeof(dat.usr) - 1);
  if ((ir = SearchTableRowX(tb, 0, (FSEL)fselBSU, (UINT)&dat)) >= 0) {
    DeleteTableRowX(tb, ir);
  }
  return CloseBTB(tb, TRUE);
}

BOOL LOCALF loglog(BOOL sw, PCSTR usr)
{ // OCOo
  HANDLE hf;

  hf = open_file(SLOG, OP_APD); if (!hf) return FALSE;
  set_file_ptr(hf, 0, FILE_END);
  write_line(hf, strconc(dtformat("yyyy/mm/dd hh:mm:ss", now()), format(" %1d %s", sw, usr)));
  close_file(hf);
  return TRUE;
}

  // ca̕\
typedef struct {
  HTBL  tb;
  HTBL  tc;
  HTBL  tx;
  BOOL  rw;
  PVIWS vs;
} BDBE;
typedef BDBE * PBDBE;

static BDBE deBSA;
#define  hBSA  deBSA.tb
static HTBL hBSU;

static HTBL hBDU;
static HTBL hREF;
static HTBL hLCK;

static char CUSR[32];
static int  CLEV;

static char CNAM[16];
static char CTIT[32];
static char CDSC[64];
static int  CSTA;

static PBDBE CDE;
static int   NDE;

#define  ciBDD  ciBSD
static COLS csBDD = { ciBDD, NELEM(ciBDD) };
static TBLI tiBDD = { &csBDD, NULL, "BOLBDD", NULL, NULL, 0, NULL, NULL, 0, sizeof(BDDI) };

HTBL WINAPI CreateBDDTable(int cap, BOOL ld)
{ // ca̕\Xg̍쐬
  int i;
  HTBL tb;
  BDDI dat;

  tiBDD.imp = addext(CNAM, ".BDD");
  tb = CreateTable(CDE? max(cap, NDE): cap, &tiBDD); if (!tb) return NULL;
  if (ld && CDE) {
    for (i = 0; i < NDE; i++) {
      strcpyx(dat.nam, NAM(CDE[i].tb), sizeof(dat.nam) - 1);
      strcpyx(dat.tit, TIT(CDE[i].tb), sizeof(dat.tit) - 1);
      strcpyx(dat.dsc, DSC(CDE[i].tb), sizeof(dat.dsc) - 1);
      *(BDDI *)NewTableRowX(tb) = dat;
    }
  }
  return tb;
}

static TBLI tiBDU = { &csBSU, NULL, "BOLBDU", NULL, NULL, 0, NULL, NULL, 0, sizeof(BDUI) };

HTBL WINAPI CreateBDUTable(int cap, BOOL ld)
{ // caڑ[U[Xg̍쐬
  HTBL tb;

  tiBDU.imp = addext(CNAM, ".BDU");
  tb = CreateTable(cap, &tiBDU); if (!tb) return NULL;
  if (ld && CDE) LoadBTB(tb);
  return tb;
}

  // QƊ֌WǗ\
typedef struct {
  int   id1;
  int   id2;
} REFE;
typedef REFE * PREFE;
typedef const REFE * PCREFE;

static COLI ciREF[] = {
  { TID_I4B,  0, "id1", "Qƌ", NULL, CF_KEY, },
  { TID_I4B,  0, "id2", "QƐ", NULL, CF_KEY, },
};
static COLS csREF = { ciREF, NELEM(ciREF) };
static TBLI tiREF = { &csREF, NULL, "BOLREF", NULL, NULL, 0, NULL, NULL, 0, sizeof(REFE) };

HTBL LOCALF CreateREFTable(int cap)
{ // QƊ֌WǗ\̍쐬
  tiREF.imp = addext(CNAM, ".REF");
  return CreateTable(cap, &tiREF);
}

BOOL LOCALF fselREF(PCREFE pb, PCREFE pa)
{ // I֐
  return pb->id1 == pa->id1 && pb->id2 == pa->id2;
}

void LOCALF setref(HTBL tb, int id1, int id2)
{ // \̎QƊ֌Wo^
  REFE dat;

  dat.id1 = id1; dat.id2 = id2;
  if (SearchTableRowX(tb, 0, (FSEL)fselREF, (UINT)&dat) < 0) {
    *(REFE *)NewTableRowX(tb) = dat;
  }
}

BOOL LOCALF isref(HTBL tb, int id1, int id2)
{ // \̎QƊ֌W̃`FbN
  return IsDependent(tb, 0, 1, &id1, &id2);
}

static COLI ciLCK[] = {
  { TID_I4B,  0, "id",  "\ID",       NULL, CF_KEY, },
  { STR(32),  0, "usr", "[U[", },
};
static COLS csLCK = { ciLCK, NELEM(ciLCK) };
static TBLI tiLCK = { &csLCK, NULL, "BOLLCK", NULL, NULL, 0, NULL, NULL, 0, sizeof(LCKI) };

HTBL WINAPI CreateLCKTable(int cap, BOOL ld)
{ // bNǗ\̍쐬
  HTBL tb;

  tiLCK.imp = addext(CNAM, ".LCK");
  tb = CreateTable(cap, &tiLCK); if (!tb) return NULL;
  if (ld && CDE) LoadBTB(tb);
  return tb;
}

BOOL LOCALF fselLCK(PLCKI pb, PLCKI pa)
{ // I֐
  return pb->id == pa->id;
}

BOOL LOCALF lock(HTBL tb, PCSTR usr, PCIDXS pt)
{ // bN
  int i, ir, re = FALSE;
  LCKI dat;

  new_file_if_not_exists(FNM(tb));
  if (!OpenBTB(tb)) return FALSE;
  strcpyx(dat.usr, usr, sizeof(dat.usr) - 1);
  for (i = 0; i < pt->ni; i++) {
    dat.id = pt->pi[i];
    if ((ir = SearchTableRowX(tb, 0, (FSEL)fselLCK, (UINT)&dat)) >= 0) {
      if (strcmp(((PLCKI)ROW(tb, ir))->usr, usr)) { ierr(E_LCK); goto _L1;}
    } else {
      *(LCKI *)NewTableRowX(tb) = dat;
    }
  }
  re = TRUE; _L1:
  return CloseBTB(tb, re);
}

BOOL LOCALF unlock(HTBL tb, PCSTR usr, PCIDXS pt)
{ // AbN
  int i, ir, re = FALSE;
  LCKI dat;

  if (file_size(FNM(tb)) == 0) return FALSE;
  if (!OpenBTB(tb)) return FALSE;
  strcpyx(dat.usr, usr, sizeof(dat.usr) - 1);
  for (i = 0; i < pt->ni; i++) {
    dat.id = pt->pi[i];
    if ((ir = SearchTableRowX(tb, 0, (FSEL)fselLCK, (UINT)&dat)) >= 0) {
      if (strcmp(((PLCKI)ROW(tb, ir))->usr, usr)) { ierr(E_LCK); goto _L1;}
      DeleteTableRowX(tb, ir);
    }
  }
  re = TRUE; _L1:
  return CloseBTB(tb, re);
}

BOOL LOCALF fselFUN(PLCKI pb, PLCKI pa)
{ // I֐
  return !!strcmp(pb->usr, pa->usr);
}

BOOL LOCALF forceunlock(HTBL tb, PCSTR usr)
{ // AbN
  int n1, n2;
  LCKI dat;

  if (file_size(FNM(tb)) == 0) return FALSE;
  if (!OpenBTB(tb)) return FALSE;
  strcpyx(dat.usr, usr, sizeof(dat.usr) - 1);
  n1 = LEN(tb);
  n2 = SelectTableRowsX(tb, (FSEL)fselFUN, (UINT)&dat);
  return CloseBTB(tb, n1 > n2);
}

BOOL WINAPI LoginSite(PCSTR usr, PCSTR pwd)
{ // OC
  int ir;
  PBSAI pb;

  if (CLEV > 0) return (BOOL)ierr(E_DUL);
  hBSA = CreateBSATable( 0, FALSE); if (!hBSA) return FALSE;
  hBSU = CreateBSUTable(32, FALSE); if (!hBSU) goto _L2;
  if (!LoadBTB(hBSA)) goto _L1;
  ir = srchbsa(hBSA, usr); if (ir < 0) goto _L1;
  pb = (PBSAI)ROW(hBSA, ir);
  if (stricmp(pwd, pb->pwd) || pb->lev <= 0) goto _L1;
  strcpy(CUSR, pb->usr);
  CLEV = pb->lev;
  loglog(TRUE, CUSR);
  addusr(hBSU, CUSR);
  return TRUE;

 _L1: DeleteTable(hBSU);
 _L2: DeleteTable(hBSA);
  return FALSE;
}

void WINAPI LogoutSite(void)
{ // OAEg
  if (CLEV == 0) return;
  DisconnectDB();
  delusr(hBSU, CUSR);
  loglog(FALSE, CUSR);
  DeleteTable(hBSU);
  DeleteTable(hBSA);
  CUSR[0] = '\0';
  CLEV = 0;
}

void WINAPI ForceLogoutSite(PCSTR usr)
{ // OAEg
  int i, ln;
  PCSTR nam;
  HTBL tb, td, tl;

  if (CLEV < 3) { ierr(E_BSD); return;}
  if (!!(tb = CreateBSDTable(32, PRO_DEF)) && (ln = LEN(tb)) > 0) {
    td = CreateBDUTable(32, FALSE); if (!td) goto _L2;
    tl = CreateLCKTable(32, FALSE); if (!tl) goto _L1;
    for (i = 0; i < ln; i++) {
      nam = ((PBSDI)ROW(tb, i))->nam;
      SetTableFileName(td, addext(nam, ".BDU"));
      delusr(td, usr);
      SetTableFileName(tl, addext(nam, ".LCK"));
      forceunlock(tl, usr);
    }
    DeleteTable(tl); _L1:
    DeleteTable(td); _L2:;
  } else if (CurDBName()[0] != '\0') {
    delusr(hBDU, usr);
    forceunlock(hLCK, usr);
  }
  delusr(hBSU, usr);
  DeleteTable(tb);
}

PCSTR WINAPI CurUser(void)
{ // [U[
  return CUSR;
}

int  WINAPI CurAuth(void)
{ // 
  return CLEV;
}

BOOL LOCALF connectDBX(PCBDBI db, BOOL sw)
{ // ca֐ڑ
  int i, j, f;
  HTBL tx;
  PCTBLI ti;
  PCCOLI co, cx;

  if (CLEV == 0) return (BOOL)ierr(E_NOL);
  if (CDE) return (BOOL)ierr(E_DUC);
  if (!db->nam || strlen(db->nam) >= sizeof(CNAM) || !isidn(db->nam)) return (BOOL)ierr(E_DBN);
  if (db->tit && strlen(db->tit) >= sizeof(CTIT)) return (BOOL)ierr(E_DBT);
  if (db->dsc && strlen(db->dsc) >= sizeof(CDSC)) return (BOOL)ierr(E_DBD);
  strcpy(CNAM, db->nam);
  strcpy(CTIT, db->tit? db->tit: db->nam);
  strcpy(CDSC, db->dsc? db->dsc: db->tit);
  CSTA = 2;
  if (!db->ts || !db->ts->ti || db->ts->ni <= 0) { ierr(E_MIS); goto _L5;}
  CDE = halloc(db->ts->ni * sizeof(BDBE), TRUE); if (!CDE) { ierr(E_MEM); goto _L5;}
  NDE = db->ts->ni;
  hBDU = CreateBDUTable(32, FALSE); if (!hBDU) goto _L4;
  hREF = CreateREFTable(32); if (!hREF) goto _L3;
  hLCK = CreateLCKTable(32, FALSE); if (!hLCK) goto _L2;
  for (i = 0; i < NDE; i++) {
    ti = &db->ts->ti[i];
    if (!ti->nam || strlen(ti->nam) >= 16 || !isidn(ti->nam)) { ierr(E_TBN); goto _L1;}
    if (ti->tit && strlen(ti->tit) >= 32) { ierr(E_TBT); goto _L1;}
    if (ti->dsc && strlen(ti->dsc) >= 64) { ierr(E_TBD); goto _L1;}
    f = FALSE;
    for (j = 0; j < ti->cs->nc; j++) {
      co = &ti->cs->co[j];
      if (co->flg & CF_REF) {
        if (RTI(co) >= i) { ierr(E_ITB); goto _L1;}
        tx = CDE[RTI(co)].tb;
        if (RCI(co) >= NCO(tx)) { ierr(E_ICO); goto _L1;}
        cx = &COL(tx)[RCI(co)];
        if (colsiz(co) != SIZ(cx) && !ISCAL(co)) { ierr(E_CSZ); goto _L1;}
      }
      if (ISCAL(co)) {
        if (co->flg & CF_KEY) { ierr(E_CKY); goto _L1;}
        if (co->flg & CF_REF) {
          if (!co->fcal) {
            if (!isref(hREF, i, RTI(co))) { ierr(E_NRF); goto _L1;}
          } else {
            setref(hREF, i, RTI(co));
          }
        }
      } else {
        if (co->flg & CF_KEY) f = TRUE;
        if (co->flg & CF_REF) {
          if (!(cx->flg & CF_KEY)) { ierr(E_RKY); goto _L1;}
          if (NTableKeys(tx) > 1) { ierr(E_NUN); goto _L1;}
          setref(hREF, i, RTI(co));
        }
      }
    }
    if (!f) { ierr(E_NKY); goto _L1;}
    CDE[i].tb = sw? CreateTableB(0, ti): CreateTable(0, ti); if (!CDE[i].tb) goto _L1;
    if (!(FLG(CDE[i].tb) & TF_RDO)) {
      CDE[i].tc = sw? CreateTableB(0, ti): CreateTable(0, ti); if (!CDE[i].tc) goto _L1;
      CDE[i].tx = sw? CreateTableB(0, ti): CreateTable(0, ti); if (!CDE[i].tx) goto _L1;
    }
    CDE[i].vs = ti->vs;
  }
  addusr(hBDU, CUSR);
  return TRUE;

 _L1:
  for ( ; i >= 0; i--) {
    DeleteTable(CDE[i].tx);
    DeleteTable(CDE[i].tc);
    DeleteTable(CDE[i].tb);
  }
  DeleteTable(hLCK); _L2:
  DeleteTable(hREF); _L3:
  DeleteTable(hBDU); _L4:
  hfree(CDE); CDE = NULL; NDE = 0; _L5:
  CNAM[0] = CTIT[0] = CDSC[0] = '\0';
  CSTA = 0;
  return FALSE;
}

BOOL WINAPI ConnectDBX(PCBDBI db)
{ // ca֐ڑ
  return connectDBX(db, FALSE);
}

BOOL LOCALF ConnectDBXB(PCBDBI db)
{ // ca֐ڑ
  return connectDBX(db, TRUE);
}

BOOL WINAPI ConnectDB(PCSTR nam)
{ // ca֐ڑ(ca`oCgR[h̎s)
  BYTE ar[4], rv[4];

  if (CLEV == 0) return (BOOL)ierr(E_NOL);
  if (CDE) return (BOOL)ierr(E_DUC);
  hbCur = hbMain = LoadBCD(addext(nam, ".BCF"), IAPP, PRO_DEF, 0); if (!hbMain) return FALSE;
  ExecBCD(rv, hbMain, ar);
  return *(I4B *)rv;
}

void WINAPI DisconnectDB(void)
{ // caւ̐ڑ
  int i;

  if (!CDE) return;
  if (CSTA > 0) {
    forceunlock(hLCK, CUSR);
    delusr(hBDU, CUSR);
  }
  for (i = NDE-1; i >= 0; i--) {
    DeleteTable(CDE[i].tx);
    DeleteTable(CDE[i].tc);
    DeleteTable(CDE[i].tb);
  }
  DeleteTable(hLCK);
  DeleteTable(hREF);
  DeleteTable(hBDU);
  if (hbMain) {
    UnloadBCD(hbMain); hbMain = NULL; hbCur = hbAddIn;
  }
  hfree(CDE); CDE = NULL; NDE = 0;
  CNAM[0] = CTIT[0] = CDSC[0] = '\0';
  CSTA = 0;
}

PCSTR WINAPI CurDBName(void)
{ // ca
  return CNAM;
}

PCSTR WINAPI CurDBTitle(void)
{ // ca^Cg
  return CTIT;
}

PCSTR WINAPI CurDBDescription(void)
{ // ca
  return CDSC;
}

int  WINAPI CurDBStatus(void)
{ // ca
  return CSTA;
}

int  WINAPI NDBTables(void)
{ // caɑ\̐
  return NDE;
}

HTBL WINAPI DBTable(int id)
{ // \CfbNX\nh߂
  if (!CDE) return ierr(E_NOC);
  if (id < 0 || id >= NDE) return ierr(E_ITB);
  return CDE[id].tb;
}

PCSTR WINAPI DBTableName(int id)
{ // \CfbNX\߂
  if (!CDE) { ierr(E_NOC); return "";}
  if (id < 0 || id >= NDE) { ierr(E_ITB); return "";}
  return NAM(CDE[id].tb);
}

PCSTR WINAPI DBTableTitle(int id)
{ // \CfbNX\^Cg߂
  if (!CDE) { ierr(E_NOC); return "";}
  if (id < 0 || id >= NDE) { ierr(E_ITB); return "";}
  return TIT(CDE[id].tb);
}

PCSTR WINAPI DBTableDescription(int id)
{ // \CfbNX\߂
  if (!CDE) { ierr(E_NOC); return "";}
  if (id < 0 || id >= NDE) { ierr(E_ITB); return "";}
  return DSC(CDE[id].tb);
}

PCSTR WINAPI DBTableFileName(int id)
{ // \CfbNX\t@C߂
  if (!CDE) { ierr(E_NOC); return "";}
  if (id < 0 || id >= NDE) { ierr(E_ITB); return "";}
  return FNM(CDE[id].tb);
}

PVIWS WINAPI DBTableVIWS(int id)
{ // \CfbNXVXe`̃r[Zbg߂
  if (!CDE) return ierr(E_NOC);
  if (id < 0 || id >= NDE) return ierr(E_ITB);
  return CDE[id].vs;
}

int  WINAPI DBTableIndex(PCSTR nam)
{ // \\CfbNX߂
  int i;

  if (!CDE) return -1;
  for (i = 0; i < NDE; i++) {
    if (!stricmp(NAM(CDE[i].tb), nam)) return i;
  }
  return -1;
}

HTBL WINAPI DBHTBL(PCSTR nam)
{ // \\nh߂
  int i;

  if (!CDE) return ierr(E_NOC);
  for (i = 0; i < NDE; i++) {
    if (!stricmp(NAM(CDE[i].tb), nam)) return CDE[i].tb;
  }
  return ierr(E_TBN);
}

  // \I[v(P)
typedef struct {
  int   md;
  PBDBE de;
} OPNI;
typedef OPNI * POPNI;

HOPN LOCALF OpenTableI(PBDBE de, BOOL rw)
{ // \J(P)
  POPNI op;

  op = halloc(sizeof(OPNI), FALSE); if (!op) return ierr(E_MEM);
  if (rw) {
    if (de->rw) { ierr(E_ORW); goto _L1;}
    new_file_if_not_exists(FNM(de->tb));
    if (!LoadBTB(de->tb)) goto _L1;
    de->tc = DuplicateTable(de->tb); if (!de->tc) goto _L1;
    de->rw = TRUE;
    op->md = (OM_IND|OM_RDW);
  } else {
    if (!de->rw) {
      if (!LoadBTB(de->tb)) goto _L1;
    }
    op->md = (OM_IND|OM_RDO);
  }
  op->de = de;
  return (HOPN)op;

 _L1:
  hfree(op);
  return NULL;
}

HOPN WINAPI CreateHOPN(HTBL tb, BOOL rw)
{ // \I[v̍쐬
  POPNI op;
  PBDBE de;

  op = halloc(sizeof(OPNI) + sizeof(BDBE), FALSE); if (!op) ierr(E_MEM);
  de = (PVOID)((PBYTE)op + sizeof(OPNI));
  de->tb = tb;
  de->tx = NULL;
  if (rw) {
    de->tc = DuplicateTable(de->tb); if (!de->tc) { hfree(op); return NULL;}
    de->rw = TRUE;
    op->md = (OM_IND|OM_RDW);
  } else {
    de->tc = NULL;
    de->rw = FALSE;
    op->md = (OM_IND|OM_RDO);
  }
  op->de = de;
  return (HOPN)op;
}

HOPN WINAPI OpenBSATable(BOOL rw)
{ // [U[Ǘ\J
  if (CLEV == 0) return ierr(E_NOL);
  if (CLEV < 4)  return ierr(E_BSA);
  return OpenTableI(&deBSA, rw);
}

  // \I[v
typedef struct {
  int   md;
  PIDXS pt;
  PIDXS pr;
} OPNE;
typedef OPNE * POPNE;

HOPN WINAPI OpenTableX(PCIDXS pt, int md)
{ // \J
  int i, j, i1, i2;
  POPNE op;
  PIDXS pw, pr;

  if (!CDE) return ierr(E_NOC);
  switch (md) {
  case OM_RDO: case OM_RDW: case OM_LCK: case OM_RDO|OM_LCK: case OM_RDW|OM_LCK: break;
  default: return ierr(E_PAR);
  }
  if (CLEV < 2 && (md & (OM_RDW|OM_LCK))) return ierr(E_RDW);
  if (md & OM_RDW) {
    for (i = 0; i < pt->ni; i++) {
      if (FLG(CDE[pt->pi[i]].tb) & TF_RDO) return ierr(E_ORO);
      if (CDE[pt->pi[i]].rw) return ierr(E_ORW);
    }
  }
  op = halloc(sizeof(OPNE) + 2 * sizeof(IDXS) + NDE * sizeof(int), FALSE); if (!op) return ierr(E_MEM);
  pw = (PVOID)((PBYTE)op + sizeof(OPNE));
  pr = (PVOID)((PBYTE)pw + sizeof(IDXS));
  pw->pi = (PVOID)((PBYTE)pr + sizeof(IDXS));
  memcpy(pw->pi, pt->pi, pt->ni * sizeof(int));
  pw->ni = pt->ni;
  pr->pi = pw->pi + pw->ni;
  pr->ni = 0;
  op->md = md;
  op->pt = pw;
  op->pr = pr;
  if (md & (OM_RDO|OM_RDW)) {
    for (i = 0; i < pt->ni; i++) {
      i1 = pt->pi[i];
      for (i2 = 0; i2 < NDE; i2++) {
        if (i1 != i2 && isref(hREF, i1, i2)) {
          for (j = 0; j < pw->ni + pr->ni; j++) {
            if (pw->pi[j] == i2) goto _LC;
          }
          pr->pi[pr->ni++] = i2;
        }
       _LC:;
      }
    }
  }
  if (md & (OM_RDW|OM_LCK)) {
    if (!lock(hLCK, CUSR, pw)) goto _L2;
  }
  if (md & OM_RDW) {
    for (i = 0; i < pw->ni; i++) {
      if (!LoadBTB(CDE[pw->pi[i]].tb)) goto _LX;
      CDE[pw->pi[i]].rw = TRUE;
      CopyTable(CDE[pw->pi[i]].tc, CDE[pw->pi[i]].tb);
    }
    for (i = 0; i < pr->ni; i++) {
      if (CDE[pr->pi[i]].rw) continue;
      if (!LoadBTB(CDE[pr->pi[i]].tb)) goto _LY;
    }
  } else if (md & OM_RDO) {
    for (i = 0; i < pw->ni + pr->ni; i++) {
      if (!LoadBTB(CDE[pw->pi[i]].tb)) goto _L1;
    }
  }
  if ((md & (OM_RDW|OM_LCK)) == OM_RDW) unlock(hLCK, CUSR, pw);
  return (HOPN)op;

 _LX:
  for ( ; i >= 0; i--) {
    CDE[pw->pi[i]].rw = FALSE;
  }
  goto _L1;
 _LY:
  for (i = 0; i < pw->ni; i++) {
    CDE[pw->pi[i]].rw = FALSE;
  }
 _L1: if (md & (OM_RDW|OM_LCK)) unlock(hLCK, CUSR, pw);
 _L2: hfree(op);
  return NULL;
}

BOOL LOCALF scntbs(PIDXS pt, PCSTR st)
{ // \XgǍ
  int i, n, id;

  n = 0;
  start(st);
  switch (token()) {
  case TKN_END:
  case BOP_AST:
    for (i = 0; i < NDE; i++) {
      pt->pi[n++] = i;
    }
    break;
  case TKN_IDN:
    goto _L2;
  }
  goto _L4;
 _L1:
  if (token_is(TKN_IDN)) {
   _L2:
    if ((id = DBTableIndex(buf())) >= 0) {
      for (i = 0; i < n; i++) {
        if (pt->pi[i] == id) goto _L3;
      }
      pt->pi[n++] = id;
    }
   _L3:
    if (token_is(BOP_CMA)) goto _L1;
  }
 _L4:
  pt->ni = n;
  return n > 0;
}

HOPN WINAPI OpenTable(PCSTR tbs, int md)
{ // \J
  HOPN op;
  PIDXS pt;

  pt = halloc(sizeof(IDXS) + NDE * sizeof(int), FALSE); if (!pt) return ierr(E_MEM);
  pt->pi = (PVOID)((PBYTE)pt + sizeof(IDXS));
  scntbs(pt, tbs); if (pt->ni <= 0) { hfree(pt); return ierr(E_TBN);}
  op = OpenTableX(pt, md);
  hfree(pt);
  return op;
}

BOOL WINAPI SaveTable(HOPN op)
{ // \̕ۑ
  int i, md = ((POPNE)op)->md, re = FALSE;
  PIDXS pw;
  HTBL d1, d2;

  if (md & OM_RDO) return FALSE;
  if (md & OM_IND) {
    re = SaveBTB(((POPNI)op)->de->tb);
    if (re) CopyTable(((POPNI)op)->de->tc, ((POPNI)op)->de->tb);
    return re;
  }
  pw = ((POPNE)op)->pt;
  if ((md & (OM_RDW|OM_LCK)) == OM_RDW) lock(hLCK, CUSR, pw);
  for (i = 0; i < pw->ni; i++) {
    d1 = CreateDIFTable(CDE[pw->pi[i]].tb, CDE[pw->pi[i]].tc); if (!d1) goto _L0;
    re = LoadBTB(CDE[pw->pi[i]].tx); if (!re) goto _L2;
    d2 = CreateDIFTable(CDE[pw->pi[i]].tx, CDE[pw->pi[i]].tc); if (!d2) goto _L2;
    if (LEN(d2) > 0) {
      if (IsConflict(d1, d2)) { re = (BOOL)ierr(E_CNF); goto _L1;}
      MergeDIFTable(CDE[pw->pi[i]].tb, d2);
    }
    DIFTableTrigger(CDE[pw->pi[i]].tb, CDE[pw->pi[i]].tc, d1);
    re = SaveBTB(CDE[pw->pi[i]].tb); if (!re) goto _L1;
    DeleteTable(d2);
    DeleteTable(d1);
    CopyTable(CDE[pw->pi[i]].tc, CDE[pw->pi[i]].tb);
  }
 _L0:
  if ((md & (OM_RDW|OM_LCK)) == OM_RDW) unlock(hLCK, CUSR, pw);
  return re;

 _L1: DeleteTable(d2);
 _L2: DeleteTable(d1);
  goto _L0;
}

BOOL WINAPI CloseTable(HOPN op, BOOL sv)
{ // \
  int i, md, re;
  PIDXS pw;

  if (!op) return FALSE;
  re = sv? SaveTable(op): TRUE;
  md = ((POPNE)op)->md;
  if (md & OM_IND) {
    if (md & OM_RDW) {
      ((POPNI)op)->de->rw = FALSE;
      DeleteTable(((POPNI)op)->de->tc);
    }
    hfree(op);
    return re;
  }
  pw = ((POPNE)op)->pt;
  if (md & OM_RDW) {
    for (i = 0; i < pw->ni; i++) {
      CDE[pw->pi[i]].rw = FALSE;
    }
  }
  if (md & OM_LCK) unlock(hLCK, CUSR, pw);
  hfree(op);
  return re;
}

HTBL WINAPI OHTBL(HOPN op)
{ // J\
  if (((POPNE)op)->md & OM_IND) return ((POPNI)op)->de->tb;
  return CDE[((POPNE)op)->pt->pi[0]].tb;
}

int  WINAPI NOTables(HOPN op)
{ // J\̐
  if (((POPNE)op)->md & OM_IND) return 1;
  return ((POPNE)op)->pt->ni + ((POPNE)op)->pr->ni;
}

HTBL WINAPI OTable(HOPN op, int i)
{ // J\iԖ
  if (((POPNE)op)->md & OM_IND) return (i == 0)? ((POPNI)op)->de->tb: ierr(E_PAR);
  if (i < 0 && i >= ((POPNE)op)->pt->ni + ((POPNE)op)->pr->ni) return ierr(E_PAR);
  return CDE[((POPNE)op)->pt->pi[i]].tb;
}

BOOL WINAPI IsReadOnly(HOPN op)
{ // ǎp
  return (((POPNE)op)->md & OM_RDO) != 0;
}

BOOL WINAPI IsLocked(HOPN op)
{ // bN
  return (((POPNE)op)->md & OM_LCK) != 0;
}

BOOL WINAPI IsModified(HOPN op)
{ // \XVĂ
  int i, md = ((POPNE)op)->md;
  PIDXS pw;

  if (!(md & OM_RDW)) return FALSE;
  if (md & OM_IND) return !!CompareTable(((POPNI)op)->de->tb, ((POPNI)op)->de->tc);
  pw = ((POPNE)op)->pt;
  for (i = 0; i < pw->ni; i++) {
    if (CompareTable(CDE[pw->pi[i]].tb, CDE[pw->pi[i]].tc)) return TRUE;
  }
  return FALSE;
}

BOOL WINAPI NewDBFiles(void)
{ // ̕\t@C쐬
  int i;

  if (CLEV < 3) return (BOOL)ierr(E_BSD);
  if (!CDE) return (BOOL)ierr(E_NOC);
  for (i = 0; i < NDE; i++) {
    new_file_if_not_exists(DBTableFileName(i));
  }
  return TRUE;
}

BOOL WINAPI BackupDBFiles(PCSTR dir)
{ // caɑt@C̈ꊇRs[
  int i, re = TRUE;

  if (CLEV < 3) return (BOOL)ierr(E_BSD);
  if (!CDE) return (BOOL)ierr(E_NOC);
  if (!new_path_if_not_exists(dir)) return (BOOL)ierr(E_DIR);
  for (i = 0; i < NDE; i++) {
    re &= copy_file_to(dir, DBTableFileName(i));
  }
  re &= copy_file_to(dir, addext(CNAM, ".BCF"));
  return re;
}

BOOL WINAPI TrashDBFiles(PCSTR dir)
{ // caɑt@C̈ꊇړ
  int i, re = TRUE;

  if (CLEV < 3) return (BOOL)ierr(E_BSD);
  if (!CDE) return (BOOL)ierr(E_NOC);
  if (!new_path_if_not_exists(dir)) return (BOOL)ierr(E_DIR);
  for (i = 0; i < NDE; i++) {
    if (TableFlags(DBTable(i)) & TF_IMP) continue;
    re &= move_file_to(dir, DBTableFileName(i));
  }
  re &= move_file_to(dir, addext(CNAM, ".BCF"));
  move_file_to(dir, addext(CNAM, ".BDU"));
  move_file_to(dir, addext(CNAM, ".LCK"));
  return re;
}

BOOL WINAPI CallCommandMain(PCSTR nam, HWND hwnd)
{ // ꊇoCgR[h̎s
  BYTE ar[4], rv[4];

  if (hbAddIn) UnloadBCD(hbAddIn);
  hbCur = hbAddIn = LoadBCD(addext(nam, ".BCO"), IAPP, PRO_OPR, 0); if (!hbAddIn) return FALSE;
  *(P4B *)ar = hwnd;
  ExecBCD(rv, hbAddIn, ar);
  UnloadBCD(hbAddIn); hbCur = hbAddIn = NULL;
  return TRUE;
}

BOOL WINAPI LoadReportBCD(PCSTR nam)
{ // [쐬oCgR[ht@CǍ
  if (hbAddIn) UnloadBCD(hbAddIn);
  hbCur = hbAddIn = LoadBCD(addext(nam, ".BCR"), IAPP, PRO_REP, 0); if (!hbAddIn) return FALSE;
  return TRUE;
}

void WINAPI UnloadReportBCD(void)
{ // [쐬oCgR[h̍폜
  UnloadBCD(hbAddIn); hbCur = hbAddIn = NULL;
}

BOOL WINAPI CallReportMain(PVOID rp, int msg, int pg, UINT pa)
{ // [쐬oCgR[h̎s
  BYTE ar[16], rv[4];

  if (!hbAddIn) return (BOOL)ierr(E_NOA);
  *(P4B *)ar = rp; *(I4B *)(ar + 4) = msg; *(I4B *)(ar + 8) = pg; *(U4B *)(ar + 12) = pa;
  ExecBCD(rv, hbAddIn, ar);
  return *(I4B *)rv;
}

// ---------------------------------------------------------------------- //

void LOCALF fi_I4BBox(PBYTE sp)
{ // I4BBox
  *(P4B *)sp = (P4B)I4BBox(*(I4B *)sp);
}

void LOCALF fi_I8BBox(PBYTE sp)
{ // I8BBox
  *(P4B *)(sp + 4) = (P4B)I8BBox(*(I8B *)sp);
}

void LOCALF fi_F4BBox(PBYTE sp)
{ // F4BBox
  *(P4B *)sp = (P4B)F4BBox(*(F4B *)sp);
}

void LOCALF fi_F8BBox(PBYTE sp)
{ // F8BBox
  *(P4B *)(sp + 4) = (P4B)F8BBox(*(F8B *)sp);
}

void LOCALF fi_RegisterColumnType(PBYTE sp)
{ // RegisterColumnType(B)
  *(I4B *)sp = RegisterColumnTypeB(*(P4B *)sp);
}

void LOCALF fi_ColumnScan(PBYTE sp)
{ // ColumnScan
  *(P4B *)(sp + 8) = ColumnScan(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_ColumnPrint(PBYTE sp)
{ // ColumnPrint
  *(P4B *)(sp + 8) = ColumnPrint(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_ColumnList(PBYTE sp)
{ // ColumnList
  *(I4B *)(sp + 4) = ColumnList(*(I4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_VPtr(PBYTE sp)
{ // VPtr
  *(P4B *)(sp + 4) = (P4B)VPtr(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CHTBL(PBYTE sp)
{ // CHTBL
  *(P4B *)sp = CHTBL(*(P4B *)sp);
}

void LOCALF fi_CreateTableX(PBYTE sp)
{ // CreateTableX(B)
  *(P4B *)(sp + 12) = CreateTableXB(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_CreateTable(PBYTE sp)
{ // CreateTable(B)
  *(P4B *)(sp + 4) = CreateTableB(*(I4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_DeleteTable(PBYTE sp)
{ // DeleteTable
  DeleteTable(*(P4B *)sp);
}

void LOCALF fi_NTableKeys(PBYTE sp)
{ // NTableKeys
  *(I4B *)sp = NTableKeys(*(P4B *)sp);
}

void LOCALF fi_NTableRefs(PBYTE sp)
{ // NTableRefs
  *(I4B *)(sp + 4) = NTableRefs(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CreateCompatibleTable(PBYTE sp)
{ // CreateCompatibleTable
  *(P4B *)(sp + 4) = CreateCompatibleTable(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_IsCompatible(PBYTE sp)
{ // IsCompatible
  *(I4B *)(sp + 4) = IsCompatible(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_DuplicateTable(PBYTE sp)
{ // DuplicateTable
  *(P4B *)sp = DuplicateTable(*(P4B *)sp);
}

void LOCALF fi_TableRowSize(PBYTE sp)
{ // TableRowSize
  *(I4B *)sp = TableRowSize(*(P4B *)sp);
}

void LOCALF fi_NTableRows(PBYTE sp)
{ // NTableRows
  *(I4B *)sp = NTableRows(*(P4B *)sp);
}

void LOCALF fi_TablePtr(PBYTE sp)
{ // TablePtr
  *(P4B *)sp = TablePtr(*(P4B *)sp);
}

void LOCALF fi_TableRow(PBYTE sp)
{ // TableRow
  *(P4B *)(sp + 4) = TableRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableRowIndex(PBYTE sp)
{ // TableRowIndex
  *(I4B *)(sp + 4) = TableRowIndex(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_TableCapacity(PBYTE sp)
{ // TableCapacity
  *(I4B *)sp = TableCapacity(*(P4B *)sp);
}

void LOCALF fi_ChangeTableCapacity(PBYTE sp)
{ // ChangeTableCapacity
  *(I4B *)(sp + 4) = ChangeTableCapacity(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableName(PBYTE sp)
{ // TableName
  *(P4B *)sp = (P4B)TableName(*(P4B *)sp);
}

void LOCALF fi_SetTableTitle(PBYTE sp)
{ // SetTableTitle
  SetTableTitle(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_TableTitle(PBYTE sp)
{ // TableTitle
  *(P4B *)sp = (P4B)TableTitle(*(P4B *)sp);
}

void LOCALF fi_SetTableDescription(PBYTE sp)
{ // SetTableDescription
  SetTableDescription(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_TableDescription(PBYTE sp)
{ // TableDescription
  *(P4B *)sp = (P4B)TableDescription(*(P4B *)sp);
}

void LOCALF fi_SetTableFlags(PBYTE sp)
{ // SetTableFlags
  SetTableFlags(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableFlags(PBYTE sp)
{ // TableFlags
  *(I4B *)sp = TableFlags(*(P4B *)sp);
}

void LOCALF fi_SetTableFileName(PBYTE sp)
{ // SetTableFileName
  SetTableFileName(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_TableFileName(PBYTE sp)
{ // TableFileName
  *(P4B *)sp = (P4B)TableFileName(*(P4B *)sp);
}

void LOCALF fi_SetTableExtra(PBYTE sp)
{ // SetTableExtra
  SetTableExtra(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableExtra(PBYTE sp)
{ // TableExtra
  *(I4B *)sp = TableExtra(*(P4B *)sp);
}

void LOCALF fi_DefaultTableTrigger(PBYTE sp)
{ // DefaultTableTrigger
  *(I4B *)(sp + 12) = DefaultTableTrigger(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_TableTrigger(PBYTE sp)
{ // TableTrigger
  *(I4B *)(sp + 12) = TableTrigger(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_EnableTableTrigger(PBYTE sp)
{ // EnableTableTrigger
  *(I4B *)sp = EnableTableTrigger(*(P4B *)sp);
}

void LOCALF fi_DisableTableTrigger(PBYTE sp)
{ // DisableTableTrigger
  *(I4B *)sp = DisableTableTrigger(*(P4B *)sp);
}

void LOCALF fi_NTableColumns(PBYTE sp)
{ // NTableColumns
  *(I4B *)sp = NTableColumns(*(P4B *)sp);
}

void LOCALF fi_TableColumnInfo(PBYTE sp)
{ // TableColumnInfo
  *(P4B *)(sp + 4) = (P4B)TableColumnInfo(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTableColumnWidth(PBYTE sp)
{ // SetTableColumnWidth
  SetTableColumnWidth(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_TableColumnWidth(PBYTE sp)
{ // TableColumnWidth
  *(I4B *)(sp + 4) = TableColumnWidth(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTableColumnTextAlign(PBYTE sp)
{ // SetTableColumnTextAlign
  SetTableColumnTextAlign(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_TableColumnTextAlign(PBYTE sp)
{ // TableColumnTextAlign
  *(I4B *)(sp + 4) = TableColumnTextAlign(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableColumnOffset(PBYTE sp)
{ // TableColumnOffset
  *(I4B *)(sp + 4) = TableColumnOffset(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableColumnName(PBYTE sp)
{ // TableColumnName
  *(P4B *)(sp + 4) = (P4B)TableColumnName(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_TableColumnIndex(PBYTE sp)
{ // TableColumnIndex
  *(I4B *)(sp + 4) = TableColumnIndex(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SetTableColumnTitle(PBYTE sp)
{ // SetTableColumnTitle
  SetTableColumnTitle(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_TableColumnTitle(PBYTE sp)
{ // TableColumnTitle
  *(P4B *)(sp + 4) = (P4B)TableColumnTitle(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTableColumnDescription(PBYTE sp)
{ // SetTableColumnDescription
  SetTableColumnDescription(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_TableColumnDescription(PBYTE sp)
{ // TableColumnDescription
  *(P4B *)(sp + 4) = (P4B)TableColumnDescription(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTableColumnFlags(PBYTE sp)
{ // SetTableColumnFlags
  SetTableColumnFlags(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_TableColumnFlags(PBYTE sp)
{ // TableColumnFlags
  *(I4B *)(sp + 4) = TableColumnFlags(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTableColumnExtra(PBYTE sp)
{ // SetTableColumnExtra
  SetTableColumnExtra(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_TableColumnExtra(PBYTE sp)
{ // TableColumnExtra
  *(I4B *)(sp + 4) = TableColumnExtra(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTableCellValue(PBYTE sp)
{ // SetTableCellValue
  *(I4B *)(sp + 12) = SetTableCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_GetTableCellValue(PBYTE sp)
{ // GetTableCellValue
  *(P4B *)(sp + 12) = GetTableCellValue(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_ScanTableCellValue(PBYTE sp)
{ // ScanTableCellValue
  *(I4B *)(sp + 12) = ScanTableCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_PrintTableCellValue(PBYTE sp)
{ // PrintTableCellValue
  *(P4B *)(sp + 12) = PrintTableCellValue(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_ClearTableRow(PBYTE sp)
{ // ClearTableRow
  *(I4B *)(sp + 4) = ClearTableRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ClearTableRows(PBYTE sp)
{ // ClearTableRows
  *(I4B *)(sp + 8) = ClearTableRows(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_InsertTableRow(PBYTE sp)
{ // InsertTableRow
  *(I4B *)(sp + 4) = InsertTableRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_InsertTableRows(PBYTE sp)
{ // InsertTableRows
  *(I4B *)(sp + 8) = InsertTableRows(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_DeleteTableRow(PBYTE sp)
{ // DeleteTableRow
  *(I4B *)(sp + 4) = DeleteTableRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_DeleteTableRows(PBYTE sp)
{ // DeleteTableRows
  *(I4B *)(sp + 8) = DeleteTableRows(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_AddTableRow(PBYTE sp)
{ // AddTableRow
  *(I4B *)sp = AddTableRow(*(P4B *)sp);
}

void LOCALF fi_NewTableRow(PBYTE sp)
{ // NewTableRow
  *(P4B *)sp = NewTableRow(*(P4B *)sp);
}

void LOCALF fi_CopyTable(PBYTE sp)
{ // CopyTable
  *(P4B *)(sp + 4) = CopyTable(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_MergeTableX(PBYTE sp)
{ // MergeTableX
  *(P4B *)(sp + 4) = MergeTableX(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CompareTable(PBYTE sp)
{ // CompareTable
  *(I4B *)(sp + 4) = CompareTable(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SearchTableRowX(PBYTE sp)
{ // SearchTableRowX(B)
  *(I4B *)(sp + 12) = SearchTableRowXB(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_CountTableRowsX(PBYTE sp)
{ // CountTableRowsX(B)
  *(I4B *)(sp + 8) = CountTableRowsXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_SelectTableRowsX(PBYTE sp)
{ // SelectTableRowsX(B)
  *(I4B *)(sp + 8) = SelectTableRowsXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_SelectCopyTableX(PBYTE sp)
{ // SelectCopyTableX(B)
  *(P4B *)(sp + 12) = SelectCopyTableXB(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_SelectMergeTableX(PBYTE sp)
{ // SelectMergeTableX(B)
  *(P4B *)(sp + 12) = SelectMergeTableXB(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_AggregateTableX(PBYTE sp)
{ // AggregateTableX(B)
  *(I4B *)(sp + 16) = AggregateTableXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12), *(I4B *)(sp + 16));
}

void LOCALF fi_SortTableRowsX(PBYTE sp)
{ // SortTableRowsX(B)
  SortTableRowsXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_SearchTableCellValue(PBYTE sp)
{ // SearchTableCellValue
  *(I4B *)(sp + 12) = SearchTableCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_SearchTableCellText(PBYTE sp)
{ // SearchTableCellText
  *(I4B *)(sp + 16) = SearchTableCellText(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12), *(I4B *)(sp + 16));
}

void LOCALF fi_SearchAlt(PBYTE sp)
{ // SearchAlt
  *(I4B *)(sp + 8) = SearchAlt(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_CheckTable(PBYTE sp)
{ // CheckTable
  *(I4B *)sp = CheckTable(*(P4B *)sp);
}

void LOCALF fi_LoadBTB(PBYTE sp)
{ // LoadBTB
  *(I4B *)sp = LoadBTB(*(P4B *)sp);
}

void LOCALF fi_SaveBTB(PBYTE sp)
{ // SaveBTB
  *(I4B *)sp = SaveBTB(*(P4B *)sp);
}

void LOCALF fi_CreateRowBufX(PBYTE sp)
{ // CreateRowBufX(B)
  *(P4B *)(sp + 4) = CreateRowBufXB(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CreateRowBuf(PBYTE sp)
{ // CreateRowBuf
  *(P4B *)sp = CreateRowBuf(*(P4B *)sp);
}

void LOCALF fi_DeleteRowBuf(PBYTE sp)
{ // DeleteRowBuf
  DeleteRowBuf(*(P4B *)sp);
}

void LOCALF fi_DuplicateRowBuf(PBYTE sp)
{ // DuplicateRowBuf
  *(P4B *)sp = DuplicateRowBuf(*(P4B *)sp);
}

void LOCALF fi_RowBufHTBL(PBYTE sp)
{ // RowBufHTBL
  *(P4B *)sp = RowBufHTBL(*(P4B *)sp);
}

void LOCALF fi_RowBufPtr(PBYTE sp)
{ // RowBufPtr
  *(P4B *)sp = RowBufPtr(*(P4B *)sp);
}

void LOCALF fi_MakeRowBuf(PBYTE sp)
{ // MakeRowBuf
  *(P4B *)(sp + 4) = MakeRowBuf(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_TableRowBuf(PBYTE sp)
{ // TableRowBuf
  *(P4B *)(sp + 4) = TableRowBuf(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_NewTableRowBuf(PBYTE sp)
{ // NewTableRowBuf
  *(P4B *)sp = NewTableRowBuf(*(P4B *)sp);
}

void LOCALF fi_SetRowBufCellValue(PBYTE sp)
{ // SetRowBufCellValue
  *(I4B *)(sp + 8) = SetRowBufCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_GetRowBufCellValue(PBYTE sp)
{ // GetRowBufCellValue
  *(P4B *)(sp + 8) = GetRowBufCellValue(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ScanRowBufCellValue(PBYTE sp)
{ // ScanRowBufCellValue
  *(I4B *)(sp + 8) = ScanRowBufCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_PrintRowBufCellValue(PBYTE sp)
{ // PrintRowBufCellValue
  *(P4B *)(sp + 8) = PrintRowBufCellValue(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ClearRowBuf(PBYTE sp)
{ // ClearRowBuf
  *(I4B *)sp = ClearRowBuf(*(P4B *)sp);
}

void LOCALF fi_CopyRowBuf(PBYTE sp)
{ // CopyRowBuf
  *(P4B *)(sp + 4) = CopyRowBuf(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SetTableRow(PBYTE sp)
{ // SetTableRow
  *(I4B *)(sp + 8) = SetTableRow(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_GetTableRow(PBYTE sp)
{ // GetTableRow
  *(P4B *)(sp + 8) = GetTableRow(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_SetNewTableRow(PBYTE sp)
{ // SetNewTableRow
  *(I4B *)(sp + 4) = SetNewTableRow(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CopyValues(PBYTE sp)
{ // CopyValues
  *(P4B *)(sp + 4) = CopyValues(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CopyKey(PBYTE sp)
{ // CopyKey
  *(P4B *)(sp + 4) = CopyKey(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_CompareRowBuf(PBYTE sp)
{ // CompareRowBuf
  *(I4B *)(sp + 4) = CompareRowBuf(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SearchKey(PBYTE sp)
{ // SearchKey
  *(I4B *)(sp + 4) = SearchKey(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_MergeTable(PBYTE sp)
{ // MergeTable
  *(P4B *)(sp + 4) = MergeTable(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_UniqueKey(PBYTE sp)
{ // UniqueKey
  *(I4B *)(sp + 12) = UniqueKey(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_CreateSummaryV(PBYTE sp)
{ // CreateSummaryV
  *(P4B *)(sp + 12) = CreateSummaryV(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_IsConflict(PBYTE sp)
{ // IsConflict
  *(I4B *)(sp + 4) = IsConflict(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_IsDependent(PBYTE sp)
{ // IsDependent
  *(I4B *)(sp + 16) = IsDependent(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12), *(P4B *)(sp + 16));
}

void LOCALF fi_CreateViewX(PBYTE sp)
{ // CreateViewX(B)
  *(P4B *)(sp + 20) = CreateViewXB(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12), *(P4B *)(sp + 16), *(I4B *)(sp + 20));
}
void LOCALF fi_CreateView(PBYTE sp)
{ // CreateView
  *(P4B *)(sp + 12) = CreateView(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_DeleteView(PBYTE sp)
{ // DeleteView
  DeleteView(*(P4B *)sp);
}

void LOCALF fi_ViewHTBL(PBYTE sp)
{ // ViewHTBL
  *(P4B *)sp = ViewHTBL(*(P4B *)sp);
}

void LOCALF fi_NViewRows(PBYTE sp)
{ // NViewRows
  *(I4B *)sp = NViewRows(*(P4B *)sp);
}

void LOCALF fi_ViewRow(PBYTE sp)
{ // ViewRow
  *(P4B *)(sp + 4) = ViewRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewRowIndex(PBYTE sp)
{ // ViewRowIndex
  *(I4B *)(sp + 4) = ViewRowIndex(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_NViewColumns(PBYTE sp)
{ // NViewColumns
  *(I4B *)sp = NViewColumns(*(P4B *)sp);
}

void LOCALF fi_ViewColumnInfo(PBYTE sp)
{ // ViewColumnInfo
  *(P4B *)(sp + 4) = (P4B)ViewColumnInfo(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewColumnWidth(PBYTE sp)
{ // SetViewColumnWidth
  SetViewColumnWidth(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ViewColumnWidth(PBYTE sp)
{ // ViewColumnWidth
  *(I4B *)(sp + 4) = ViewColumnWidth(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewColumnWidthF(PBYTE sp)
{ // ViewColumnWidthF
  *(I4B *)(sp + 4) = ViewColumnWidthF(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewColumnTextAlign(PBYTE sp)
{ // SetViewColumnTextAlign
  SetViewColumnTextAlign(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ViewColumnTextAlign(PBYTE sp)
{ // ViewColumnTextAlign
  *(I4B *)(sp + 4) = ViewColumnTextAlign(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewColumnTextAlignF(PBYTE sp)
{ // ViewColumnTextAlignF
  *(I4B *)(sp + 4) = ViewColumnTextAlignF(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewColumnName(PBYTE sp)
{ // ViewColumnName
  *(P4B *)(sp + 4) = (P4B)ViewColumnName(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewColumnIndex(PBYTE sp)
{ // ViewColumnIndex
  *(I4B *)(sp + 4) = ViewColumnIndex(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewColumnTitle(PBYTE sp)
{ // SetViewColumnTitle
  SetViewColumnTitle(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_ViewColumnTitle(PBYTE sp)
{ // ViewColumnTitle
  *(P4B *)(sp + 4) = (P4B)ViewColumnTitle(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewColumnDescription(PBYTE sp)
{ // SetViewColumnDescription
  SetViewColumnDescription(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_ViewColumnDescription(PBYTE sp)
{ // ViewColumnDescription
  *(P4B *)(sp + 4) = (P4B)ViewColumnDescription(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewColumnDescriptionR(PBYTE sp)
{ // ViewColumnDescriptionR
  *(P4B *)(sp + 4) = (P4B)ViewColumnDescriptionR(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewColumnFlags(PBYTE sp)
{ // SetViewColumnFlags
  SetViewColumnFlags(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ViewColumnFlags(PBYTE sp)
{ // ViewColumnFlags
  *(I4B *)(sp + 4) = ViewColumnFlags(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ViewColumnFlagsF(PBYTE sp)
{ // ViewColumnFlagsF
  *(I4B *)(sp + 4) = ViewColumnFlagsF(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewColumnExtra(PBYTE sp)
{ // SetViewColumnExtra
  SetViewColumnExtra(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ViewColumnExtra(PBYTE sp)
{ // ViewColumnExtra
  *(I4B *)(sp + 4) = ViewColumnExtra(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetViewCellValue(PBYTE sp)
{ // SetViewCellValue
  *(I4B *)(sp + 12) = SetViewCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_GetViewCellValue(PBYTE sp)
{ // GetViewCellValue
  *(P4B *)(sp + 12) = GetViewCellValue(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_ScanViewCellValue(PBYTE sp)
{ // ScanViewCellValue
  *(I4B *)(sp + 12) = ScanViewCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_ScanViewCellValueF(PBYTE sp)
{ // ScanViewCellValueF
  *(I4B *)(sp + 12) = ScanViewCellValueF(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_PrintViewCellValue(PBYTE sp)
{ // PrintViewCellValue
  *(P4B *)(sp + 12) = PrintViewCellValue(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_PrintViewCellValueF(PBYTE sp)
{ // PrintViewCellValueF
  *(P4B *)(sp + 16) = PrintViewCellValueF(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12), *(I4B *)(sp + 16));
}

void LOCALF fi_ClearViewRow(PBYTE sp)
{ // ClearViewRow
  *(I4B *)(sp + 4) = ClearViewRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ClearViewRows(PBYTE sp)
{ // ClearViewRows
  *(I4B *)(sp + 8) = ClearViewRows(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_InsertViewRow(PBYTE sp)
{ // InsertViewRow
  *(I4B *)(sp + 4) = InsertViewRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_InsertViewRows(PBYTE sp)
{ // InsertViewRows
  *(I4B *)(sp + 8) = InsertViewRows(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_DeleteViewRow(PBYTE sp)
{ // DeleteViewRow
  *(I4B *)(sp + 4) = DeleteViewRow(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_DeleteViewRows(PBYTE sp)
{ // DeleteViewRows
  *(I4B *)(sp + 8) = DeleteViewRows(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_AddViewRow(PBYTE sp)
{ // AddViewRow
  *(I4B *)sp = AddViewRow(*(P4B *)sp);
}

void LOCALF fi_NewViewRow(PBYTE sp)
{ // NewViewRow
  *(P4B *)sp = NewViewRow(*(P4B *)sp);
}

void LOCALF fi_ArrangeViewColumnsX(PBYTE sp)
{ // ArrangeViewColumnsX
  ArrangeViewColumnsX(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SearchViewRowX(PBYTE sp)
{ // SearchViewRowX(B)
  *(I4B *)(sp + 12) = SearchViewRowXB(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_CountViewRowsX(PBYTE sp)
{ // CountViewRowsX(B)
  *(I4B *)(sp + 8) = CountViewRowsXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_SelectViewRowsX(PBYTE sp)
{ // SelectViewRowsX(B)
  *(I4B *)(sp + 8) = SelectViewRowsXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_SortViewRowsX(PBYTE sp)
{ // SortViewRowsX(B)
  SortViewRowsXB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_ArrangeViewColumns(PBYTE sp)
{ // ArrangeViewColumns
  ArrangeViewColumns(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SearchViewRow(PBYTE sp)
{ // SearchViewRow
  *(I4B *)(sp + 8) = SearchViewRow(*(P4B *)sp, *(I4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_CountViewRows(PBYTE sp)
{ // CountViewRows
  *(I4B *)(sp + 4) = CountViewRows(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SelectViewRows(PBYTE sp)
{ // SelectViewRows
  *(I4B *)(sp + 4) = SelectViewRows(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SortViewRows(PBYTE sp)
{ // SortViewRows
  SortViewRows(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SortTableRowsByView(PBYTE sp)
{ // SortTableRowsByView
  SortTableRowsByView(*(P4B *)sp);
}

void LOCALF fi_CreateSummary(PBYTE sp)
{ // CreateSummary
  *(P4B *)(sp + 4) = CreateSummary(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SearchViewCellValue(PBYTE sp)
{ // SearchViewCellValue
  *(I4B *)(sp + 12) = SearchViewCellValue(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12));
}

void LOCALF fi_SearchViewCellText(PBYTE sp)
{ // SearchViewCellText
  *(I4B *)(sp + 16) = SearchViewCellText(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(P4B *)(sp + 12), *(I4B *)(sp + 16));
}

void LOCALF fi_ReadCSV(PBYTE sp)
{ // ReadCSV
  *(I4B *)(sp + 8) = ReadCSV(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_WriteCSV(PBYTE sp)
{ // WriteCSV
  *(I4B *)(sp + 8) = WriteCSV(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_SiteName(PBYTE sp)
{ // SiteName
  *(P4B *)(sp - 4) = (P4B)SiteName();
}

void LOCALF fi_SiteTitle(PBYTE sp)
{ // SiteTitle
  *(P4B *)(sp - 4) = (P4B)SiteTitle();
}

void LOCALF fi_SiteDescription(PBYTE sp)
{ // SiteDescription
  *(P4B *)(sp - 4) = (P4B)SiteDescription();
}

void LOCALF fi_TaxRate(PBYTE sp)
{ // TaxRate
  *(F8B *)(sp - 8) = TaxRate();
}

void LOCALF fi_FYearMonth(PBYTE sp)
{ // FYearMonth
  *(I4B *)(sp - 4) = FYearMonth();
}

void LOCALF fi_NMonthFYear(PBYTE sp)
{ // NMonthFYear
  *(I4B *)(sp - 4) = NMonthFYear();
}

void LOCALF fi_UserPath(PBYTE sp)
{ // UserPath
  *(P4B *)(sp - 4) = (P4B)UserPath();
}

void LOCALF fi_SetCurDate(PBYTE sp)
{ // SetCurDate
  SetCurDate(*(I4B *)sp);
}

void LOCALF fi_CurDate(PBYTE sp)
{ // CurDate
  *(I4B *)(sp - 4) = CurDate();
}

void LOCALF fi_BFYear(PBYTE sp)
{ // BFYear
  *(I4B *)(sp - 4) = BFYear();
}

void LOCALF fi_EFYear(PBYTE sp)
{ // EFYear
  *(I4B *)(sp - 4) = EFYear();
}

void LOCALF fi_BMonth(PBYTE sp)
{ // BMonth
  *(I4B *)(sp - 4) = BMonth();
}

void LOCALF fi_EMonth(PBYTE sp)
{ // EMonth
  *(I4B *)(sp - 4) = EMonth();
}

void LOCALF fi_CurUser(PBYTE sp)
{ // CurUser
  *(P4B *)(sp - 4) = (P4B)CurUser();
}

void LOCALF fi_CurAuth(PBYTE sp)
{ // CurAuth
  *(I4B *)(sp - 4) = CurAuth();
}

void LOCALF fi_ConnectDBX(PBYTE sp)
{ // ConnectDBX(B)
  *(I4B *)sp = ConnectDBXB(*(P4B *)sp);
}

void LOCALF fi_ConnectDB(PBYTE sp)
{ // ConnectDB
  *(I4B *)sp = ConnectDB(*(P4B *)sp);
}

void LOCALF fi_DisconnectDB(PBYTE sp)
{ // DisconnectDB
  DisconnectDB();
}

void LOCALF fi_CurDBName(PBYTE sp)
{ // CurDBName
  *(P4B *)(sp - 4) = (P4B)CurDBName();
}

void LOCALF fi_CurDBTitle(PBYTE sp)
{ // CurDBTitle
  *(P4B *)(sp - 4) = (P4B)CurDBTitle();
}

void LOCALF fi_CurDBDescription(PBYTE sp)
{ // CurDBDescription
  *(P4B *)(sp - 4) = (P4B)CurDBDescription();
}

void LOCALF fi_CurDBStatus(PBYTE sp)
{ // CurDBStatus
  *(I4B *)(sp - 4) = CurDBStatus();
}

void LOCALF fi_NDBTables(PBYTE sp)
{ // NDBTables
  *(I4B *)(sp - 4) = NDBTables();
}

void LOCALF fi_DBTable(PBYTE sp)
{ // DBTable
  *(P4B *)sp = DBTable(*(I4B *)sp);
}

void LOCALF fi_DBTableName(PBYTE sp)
{ // DBTableName
  *(P4B *)sp = (P4B)DBTableName(*(I4B *)sp);
}

void LOCALF fi_DBTableTitle(PBYTE sp)
{ // DBTableTitle
  *(P4B *)sp = (P4B)DBTableTitle(*(I4B *)sp);
}

void LOCALF fi_DBTableDescription(PBYTE sp)
{ // DBTableDescription
  *(P4B *)sp = (P4B)DBTableDescription(*(I4B *)sp);
}

void LOCALF fi_DBTableFileName(PBYTE sp)
{ // DBTableFileName
  *(P4B *)sp = (P4B)DBTableFileName(*(I4B *)sp);
}

void LOCALF fi_DBTableVIWS(PBYTE sp)
{ // DBTableVIWS
  *(P4B *)sp = (P4B)DBTableVIWS(*(I4B *)sp);
}

void LOCALF fi_DBTableIndex(PBYTE sp)
{ // DBTableIndex
  *(I4B *)sp = DBTableIndex(*(P4B *)sp);
}

void LOCALF fi_DBHTBL(PBYTE sp)
{ // DBHTBL
  *(P4B *)sp = DBHTBL(*(P4B *)sp);
}

void LOCALF fi_OpenTableX(PBYTE sp)
{ // OpenTableX
  *(P4B *)(sp + 4) = OpenTableX(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_OpenTable(PBYTE sp)
{ // OpenTable
  *(P4B *)(sp + 4) = OpenTable(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SaveTable(PBYTE sp)
{ // SaveTable
  *(I4B *)sp = SaveTable(*(P4B *)sp);
}

void LOCALF fi_CloseTable(PBYTE sp)
{ // CloseTable
  *(I4B *)(sp + 4) = CloseTable(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_OHTBL(PBYTE sp)
{ // OHTBL
  *(P4B *)sp = OHTBL(*(P4B *)sp);
}

void LOCALF fi_NOTables(PBYTE sp)
{ // NOTables
  *(I4B *)sp = NOTables(*(P4B *)sp);
}

void LOCALF fi_OTable(PBYTE sp)
{ // OTable
  *(P4B *)(sp + 4) = OTable(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_IsReadOnly(PBYTE sp)
{ // IsReadOnly
  *(I4B *)sp = IsReadOnly(*(P4B *)sp);
}

void LOCALF fi_IsLocked(PBYTE sp)
{ // IsLocked
  *(I4B *)sp = IsLocked(*(P4B *)sp);
}

void LOCALF fi_IsModified(PBYTE sp)
{ // IsModified
  *(I4B *)sp = IsModified(*(P4B *)sp);
}

void LOCALF fi_NewDBFiles(PBYTE sp)
{ // NewDBFiles
  *(I4B *)(sp - 4) = NewDBFiles();
}

void LOCALF fi_BackupDBFiles(PBYTE sp)
{ // BackupDBFiles
  *(I4B *)sp = BackupDBFiles(*(P4B *)sp);
}

void LOCALF fi_TrashDBFiles(PBYTE sp)
{ // TrashDBFiles
  *(I4B *)sp = TrashDBFiles(*(P4B *)sp);
}

static BFNC fiDBE[] = {
  // 220-223
  fi_I4BBox,                   fi_I8BBox,                   fi_F4BBox,                   fi_F8BBox,
  // 224-255
  fi_I4BBox,                   fi_I8BBox,                   fi_F4BBox,                   fi_F8BBox,
  fi_0, /* FSCN */             fi_0, /* FPRN */             fi_0, /* FCMP */             fi_0, /* FLST */
  fi_RegisterColumnType,       fi_0, /* FCAL */             fi_0, /* FCHK */             fi_ColumnScan,
  fi_ColumnPrint,              fi_ColumnList,               fi_VPtr,                     fi_CHTBL,
  fi_0, /* FTRG */             fi_CreateTableX,             fi_CreateTable,              fi_DeleteTable,
  fi_NTableKeys,               fi_NTableRefs,               fi_CreateCompatibleTable,    fi_IsCompatible,
  fi_DuplicateTable,           fi_TableRowSize,             fi_NTableRows,               fi_TablePtr,
  fi_TableRow,                 fi_TableRowIndex,            fi_TableCapacity,            fi_ChangeTableCapacity,
  // 256-287
  fi_TableName,                fi_SetTableTitle,            fi_TableTitle,               fi_SetTableDescription,
  fi_TableDescription,         fi_SetTableFlags,            fi_TableFlags,               fi_SetTableFileName,
  fi_TableFileName,            fi_SetTableExtra,            fi_TableExtra,               fi_DefaultTableTrigger,
  fi_TableTrigger,             fi_EnableTableTrigger,       fi_DisableTableTrigger,      fi_NTableColumns,
  fi_TableColumnInfo,          fi_SetTableColumnWidth,      fi_TableColumnWidth,         fi_SetTableColumnTextAlign,
  fi_TableColumnTextAlign,     fi_TableColumnOffset,        fi_TableColumnName,          fi_TableColumnIndex,
  fi_SetTableColumnTitle,      fi_TableColumnTitle,         fi_SetTableColumnDescription,fi_TableColumnDescription,
  fi_SetTableColumnFlags,      fi_TableColumnFlags,         fi_SetTableColumnExtra,      fi_TableColumnExtra,
  // 288-319
  fi_SetTableCellValue,        fi_GetTableCellValue,        fi_ScanTableCellValue,       fi_PrintTableCellValue,
  fi_ClearTableRow,            fi_ClearTableRows,           fi_InsertTableRow,           fi_InsertTableRows,
  fi_DeleteTableRow,           fi_DeleteTableRows,          fi_AddTableRow,              fi_NewTableRow,
  fi_CopyTable,                fi_MergeTableX,              fi_CompareTable,             fi_0, /* FSEL */
  fi_SearchTableRowX,          fi_CountTableRowsX,          fi_SelectTableRowsX,         fi_SelectCopyTableX,
  fi_SelectMergeTableX,        fi_0, /* FAGG */             fi_AggregateTableX,          fi_0, /* FSRT */
  fi_SortTableRowsX,           fi_SearchTableCellValue,     fi_SearchTableCellText,      fi_SearchAlt,
  fi_CheckTable,               fi_LoadBTB,                  fi_SaveBTB,                  fi_0, /* 319 */
  // 320-351
  fi_CreateRowBufX,            fi_CreateRowBuf,             fi_DeleteRowBuf,             fi_DuplicateRowBuf,
  fi_RowBufHTBL,               fi_RowBufPtr,                fi_MakeRowBuf,               fi_TableRowBuf,
  fi_NewTableRowBuf,           fi_SetRowBufCellValue,       fi_GetRowBufCellValue,       fi_ScanRowBufCellValue,
  fi_PrintRowBufCellValue,     fi_ClearRowBuf,              fi_CopyRowBuf,               fi_SetTableRow,
  fi_GetTableRow,              fi_SetNewTableRow,           fi_CopyValues,               fi_CopyKey,
  fi_CompareRowBuf,            fi_SearchKey,                fi_MergeTable,               fi_UniqueKey,
  fi_CreateSummaryV,           fi_IsConflict,               fi_IsDependent,              fi_0, /* 347 */
  fi_CreateViewX,              fi_CreateView,               fi_DeleteView,               fi_ViewHTBL,
  // 352-383
  fi_NViewRows,                fi_ViewRow,                  fi_ViewRowIndex,             fi_NViewColumns,
  fi_ViewColumnInfo,           fi_SetViewColumnWidth,       fi_ViewColumnWidth,          fi_ViewColumnWidthF,
  fi_SetViewColumnTextAlign,   fi_ViewColumnTextAlign,      fi_ViewColumnTextAlignF,     fi_ViewColumnName,
  fi_ViewColumnIndex,          fi_SetViewColumnTitle,       fi_ViewColumnTitle,          fi_SetViewColumnDescription,
  fi_ViewColumnDescription,    fi_ViewColumnDescriptionR,   fi_SetViewColumnFlags,       fi_ViewColumnFlags,
  fi_ViewColumnFlagsF,         fi_SetViewColumnExtra,       fi_ViewColumnExtra,          fi_SetViewCellValue,
  fi_GetViewCellValue,         fi_ScanViewCellValue,        fi_ScanViewCellValueF,       fi_PrintViewCellValue,
  fi_PrintViewCellValueF,      fi_ClearViewRow,             fi_ClearViewRows,            fi_InsertViewRow,
  // 384-415
  fi_InsertViewRows,           fi_DeleteViewRow,            fi_DeleteViewRows,           fi_AddViewRow,
  fi_NewViewRow,               fi_ArrangeViewColumnsX,      fi_SearchViewRowX,           fi_CountViewRowsX,
  fi_SelectViewRowsX,          fi_SortViewRowsX,            fi_ArrangeViewColumns,       fi_SearchViewRow,
  fi_CountViewRows,            fi_SelectViewRows,           fi_SortViewRows,             fi_SortTableRowsByView,
  fi_CreateSummary,            fi_SearchViewCellValue,      fi_SearchViewCellText,       fi_ReadCSV,
  fi_WriteCSV,                 fi_0, /* 405 */              fi_0, /* 406 */              fi_0, /* 407 */
  fi_SiteName,                 fi_SiteTitle,                fi_SiteDescription,          fi_TaxRate,
  fi_FYearMonth,               fi_NMonthFYear,              fi_UserPath,                 fi_SetCurDate,
  // 416-447
  fi_CurDate,                  fi_BFYear,                   fi_EFYear,                   fi_BMonth,
  fi_EMonth,                   fi_0, /* 421 */              fi_0, /* 422 */              fi_0, /* 423 */
  fi_CurUser,                  fi_CurAuth,                  fi_ConnectDBX,               fi_ConnectDB,
  fi_DisconnectDB,             fi_CurDBName,                fi_CurDBTitle,               fi_CurDBDescription,
  fi_CurDBStatus,              fi_NDBTables,                fi_DBTable,                  fi_DBTableName,
  fi_DBTableTitle,             fi_DBTableDescription,       fi_DBTableFileName,          fi_DBTableVIWS,
  fi_DBTableIndex,             fi_DBHTBL,                   fi_OpenTableX,               fi_OpenTableX,
  fi_OpenTable,                fi_OpenTable,                fi_SaveTable,                fi_SaveTable,
  // 448-463
  fi_CloseTable,               fi_CloseTable,               fi_OHTBL,                    fi_NOTables,
  fi_OTable,                   fi_IsReadOnly,               fi_IsLocked,                 fi_IsModified,
  fi_NewDBFiles,               fi_BackupDBFiles,            fi_TrashDBFiles,             fi_0, /* 459 */
  fi_0, /* 460 */              fi_0, /* 461 */              fi_0, /* 462 */              fi_0, /* 463 */
};
static BFNS fsDBE = { fiDBE, NELEM(fiDBE) };

UINT WINAPI BOLDBEVer(void)
{ // o[W
  static BYTE ver[4] = { MODVER }; return *(PUINT)ver;
}

static HLEX BLE;

BOOL WINAPI InitBOLDBE(UINT pa)
{ // Jn
  register_error_descriptions(&emDBE);
  BLE = CreateParsEnv(&liBOL);
  SelectParsEnv(BLE);
  RegisterColumnType(&tpICO);
  RegisterColumnType(&tpLOP);
  RegisterColumnType(&tpFMT);
  CYMD = today();
  RegisterAPIs(&fsDBE);
  return TRUE;
}

void WINAPI TermBOLDBE(void)
{ // I
  if (hbAddIn) UnloadBCD(hbAddIn);
  if (hbMain) UnloadBCD(hbMain);
  DeleteParsEnv(BLE);
}

// ---------------------------------------------------------------------- //
