/* ---------------------------------------------------------------------- //
    bolfro.c
// ---------------------------------------------------------------------- */

#define  MODNAM  "BOLFRO"
#define  MODVER   2,0,0,0

#include <windows.h>
#include <commctrl.h>

#define  _USE_MATH_DEFINES
#include <math.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#pragma warning(disable:4996)

#include <bolbas.h>
#include "bolfro.h"

// ---------------------------------------------------------------------- //

UINT WINAPI DIB_PALETTE_SIZE(HDIB bm)
{ // pbgTCY
  int nc, bc;

  if ((nc = DIB_COLOR_USED(bm)) == 0) {
    switch (bc = DIB_BITS(bm)) {
    case 1: case 4: case 8: nc = 1 << bc; break;
    }
  }
  return nc * sizeof(int);
}

HDIB WINAPI CreateDIBX(int w, int h, int flg, int xppm, int yppm)
{ // foCXƗrbg}bv̍쐬
  void *bi;
  HDIB bm;
  static BITMAPINFOHEADER bih = { sizeof(BITMAPINFOHEADER), 0, 0, 1, 0, BI_RGB, };
  static HDIB_ dib = { &bih };

  if (w <= 0 || h <= 0) return ierr(E_PAR);
  bm = (HDIB)malloc(sizeof(HDIB_)); if (!bm) return ierr(E_MEM);
  bih.biWidth = w;
  bih.biHeight = (flg & DIB_TDN)? -h: h;
  bih.biXPelsPerMeter = xppm;
  bih.biYPelsPerMeter = yppm;
  switch (flg & 0x3f) {
  default:      bih.biBitCount = 24; break;
  case DIB_32B: bih.biBitCount = 32; break;
  }
  bih.biSizeImage = DIB_IMAGE_SIZE(&dib);
  bi = calloc(DIB_SIZE(&dib), 1); if (!bi) return ierr(E_MEM);
  memcpy(bi, &bih, sizeof(BITMAPINFOHEADER));
  bm->bi = bi;
  return bm;
}

HDIB WINAPI CreateDIB(int w, int h, int flg)
{ // foCXƗrbg}bv̍쐬
  return CreateDIBX(w, h, flg, DIB_300, DIB_300);
}

HDIB WINAPI CreateCompatibleDIB(HDIB bm)
{ // ݊̂foCXƗrbg}bv̍쐬
  int w, h, flg;

  switch (DIB_BITS(bm)) {
  case 24: flg = DIB_24B; break;
  case 32: flg = DIB_32B; break;
  default: return ierr(E_DAT);
  }
  w = DIB_WIDTH(bm);
  h = DIB_HEIGHT(bm); if (h < 0) { h = -h; flg |= DIB_TDN;}
  return CreateDIBX(w, h, flg, DIB_XPPM(bm), DIB_YPPM(bm));
}

HDIB WINAPI DuplicateDIB(HDIB bm)
{ // foCXƗrbg}bv̕
  HDIB bx;

  bx = CreateCompatibleDIB(bm); if (!bx) return NULL;
  memcpy(DIB_INFO(bx), DIB_INFO(bm), DIB_SIZE(bm));
  return bx;
}

void WINAPI DeleteDIB(HDIB bm)
{ // foCXƗrbg}bv̍폜
  if (!bm) return;
  free(DIB_INFO(bm));
  free(bm);
}

HDIB WINAPI MoveDIB(HDIB bm, HDIB bx)
{ // foCXƗrbg}bv̈ړ
  free(DIB_INFO(bm));
  DIB_INFO(bm) = DIB_INFO(bx);
  free(bx);
  return bm;
}

PSIZE WINAPI GetDIBSize(PSIZE sz, HDIB bm)
{ // 摜TCY̎擾
  sz->cx = DIB_WIDTH(bm);
  sz->cy = abs(DIB_HEIGHT(bm));
  return sz;
}

HDIB WINAPI LoadDIB(HDIB bm, PCSTR nam)
{ // BMPt@CǍ
  int sz, re = FALSE;
  void *bf;
  HDIB_ *bx;
  HANDLE hf;

  bx = malloc(sizeof(HDIB_)); if (!bx) return ierr(E_MEM);
  hf = open_file(nam, OP_RDO); if (!hf) { ferr(E_FIR, nam); goto _L3;}
  sz = get_file_size(hf); if (sz < sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER)) { ferr(E_FIR, nam); goto _L3;}
  bf = calloc(sz, 1); if (!bf) { ierr(E_MEM); goto _L2;}
  if (!read_file(hf, bf, sz)) { ferr(E_FIR, nam); goto _L1;}
  if (((BITMAPFILEHEADER *)bf)->bfType != 0x4d42) { ferr(E_DAT, nam); goto _L1;}
  bx->bi = (PVOID)((PBYTE)bf + sizeof(BITMAPFILEHEADER));
  if (DIB_SIZE(bx) > sz - sizeof(BITMAPFILEHEADER)) { bx->bi = NULL; ferr(E_DAT, nam); goto _L1;}
  bx->bi = malloc(sz - sizeof(BITMAPFILEHEADER)); if (!bx->bi) { ierr(E_MEM); goto _L1;}
  memcpy(bx->bi, (PBYTE)bf + sizeof(BITMAPFILEHEADER), sz - sizeof(BITMAPFILEHEADER));
  re = TRUE; _L1:
  free(bf); _L2:
  close_file(hf); _L3:
  if (!re) { free(bx->bi); free(bx); bx = NULL;}
  return bm? MoveDIB(bm, (HDIB)bx): (HDIB)bx;
}

BOOL WINAPI SaveDIB(HDIB bm, PCSTR nam)
{ // BMPt@Co
  int sz, re = FALSE;
  void *bf;
  HANDLE hf;

  sz = DIB_SIZE(bm);
  bf = malloc(sizeof(BITMAPFILEHEADER) + sz); if (!bf) return (BOOL)ierr(E_MEM);
  ((BITMAPFILEHEADER *)bf)->bfType = 0x4d42;
  ((BITMAPFILEHEADER *)bf)->bfSize = sizeof(BITMAPFILEHEADER) + sz;
  ((BITMAPFILEHEADER *)bf)->bfReserved1 = 0;
  ((BITMAPFILEHEADER *)bf)->bfReserved2 = 0;
  ((BITMAPFILEHEADER *)bf)->bfOffBits = sizeof(BITMAPFILEHEADER) + DIB_IMAGE_OFFSET(bm);
  memcpy((PBYTE)bf + sizeof(BITMAPFILEHEADER), DIB_INFO(bm), sz);
  hf = open_file(nam, OP_WRI); if (!hf) { ferr(E_FIW, nam); goto _L1;}
  re = write_file(hf, bf, sizeof(BITMAPFILEHEADER) + sz);
  close_file(hf); _L1:
  free(bf);
  return re;
}

// ---------------------------------------------------------------------- //

#define  Wr  0.299
#define  Wg  0.587
#define  Wb  0.114
#define  Mb  ((Wr + Wg) / 0.5)
#define  Mr  ((Wg + Wb) / 0.5)
#define  Ur  (Wr / Mb)
#define  Ug  (Wg / Mb)
#define  Ub  0.5
#define  Vr  0.5
#define  Vg  (Wg / Mr)
#define  Vb  (Wb / Mr)

BYTE LOCALF fc1bVAL(RGBC cr)
{ // Px
  return (int)(Wr * ((RGBQ *)&cr)->R + Wg * ((RGBQ *)&cr)->G + Wb * ((RGBQ *)&cr)->B + 0.5);
}

BYTE LOCALF fc1bCDB(RGBC cr)
{ // F()
  return (int)(128.0 - Ur * ((RGBQ *)&cr)->R - Ug * ((RGBQ *)&cr)->G + Ub * ((RGBQ *)&cr)->B);
}

BYTE LOCALF fc1bCDR(RGBC cr)
{ // F()
  return (int)(128.0 + Vr * ((RGBQ *)&cr)->R - Vg * ((RGBQ *)&cr)->G - Vb * ((RGBQ *)&cr)->B);
}

BYTE LOCALF fc1bSAT(RGBC cr)
{ // ʓx
  REAL db, dr;

  db = fc1bCDB(cr) / 255.0 - 0.5;
  dr = fc1bCDR(cr) / 255.0 - 0.5;
  return (int)(sqrt(db * db + dr * dr) * 255.0 + 0.5);
}

BYTE LOCALF fc1bHUE(RGBC cr)
{ // F
  REAL db, dr;

  db = fc1bCDB(cr) / 255.0 - 0.5;
  dr = fc1bCDR(cr) / 255.0 - 0.5;
  if (db == 0.0 && dr == 0.0) return 0;
  return (int)((atan2(dr, db) + M_PI) * 128.0 / M_PI + 0.5);
}

BYTE LOCALF fc1bAVG(RGBC cr)
{ // 邳
  return (((RGBQ *)&cr)->R + ((RGBQ *)&cr)->G + ((RGBQ *)&cr)->B) / 3;
}

typedef struct {
  PINT  hs;
  int   hx;
  FC1B  fext;
} HISX;

RGBC LOCALF fc1pHIS(RGBC cr, UINT pa);

typedef struct {
  PINT  hs;
  int   hx;
} HISP;

BYTE LOCALF fchcHIS(BYTE i, UINT pa);

RGBC LOCALF fxypHIS(int x, int y, UINT pa);

HDIB WINAPI CreateDIBHistgram(HDIB bx, FC1B fext)
{ // qXgO쐬
  int i;
  HDIB bm;
  BYTE ct[256];
  static int hs[256];
  static HISX par = { hs, 0, NULL };

  if (DIB_BITS(bx) != 32) return ierr(E_DAT);
  bm = CreateDIB(256, 256, DIB_32B|DIB_TDN); if (!bm) return NULL;
  par.fext = fext;
  memset(hs, 0, 256 * sizeof(int));
  ChangeDIBColor(bx, fc1pHIS, (UINT)&par);
  for (i = 0; i < 256; i++) {
    if (hs[i] > par.hx) par.hx = hs[i];
  }
  SetCharacteristicCurve(ct, fchcHIS, (UINT)&par);
  PaintDIB(bm, fxypHIS, (UINT)ct);
  return bm;
}

BYTE LOCALF fc2bEUC(RGBC c1, RGBC c2)
{ // [Nbh
  int r, g, b;

  r = ((RGBQ *)&c2)->R - ((RGBQ *)&c1)->R;
  g = ((RGBQ *)&c2)->G - ((RGBQ *)&c1)->G;
  b = ((RGBQ *)&c2)->B - ((RGBQ *)&c1)->B;
  return (int)(sqrt((r * r + g * g + b * b) / 3.0) + 0.5);
}

BYTE LOCALF fc2bMAN(RGBC c1, RGBC c2)
{ // }nb^
  int r, g, b;

  r = ((RGBQ *)&c2)->R - ((RGBQ *)&c1)->R; if (r < 0) r = -r;
  g = ((RGBQ *)&c2)->G - ((RGBQ *)&c1)->G; if (g < 0) g = -g;
  b = ((RGBQ *)&c2)->B - ((RGBQ *)&c1)->B; if (b < 0) b = -b;
  return (r + g + b) / 3;
}

BYTE LOCALF fc2bCHE(RGBC c1, RGBC c2)
{ // `FrVFt
  int r, g, b, t;

  r = ((RGBQ *)&c2)->R - ((RGBQ *)&c1)->R; if (r < 0) r = -r;
  g = ((RGBQ *)&c2)->G - ((RGBQ *)&c1)->G; if (g < 0) g = -g;
  b = ((RGBQ *)&c2)->B - ((RGBQ *)&c1)->B; if (b < 0) b = -b;
  return t = r > g? r: g, t > b? t: b;
}

BYTE LOCALF fc2bQUA(RGBC c1, RGBC c2)
{ // [Nbh
  int r, g, b;

  r = ((RGBQ *)&c2)->R - ((RGBQ *)&c1)->R;
  g = ((RGBQ *)&c2)->G - ((RGBQ *)&c1)->G;
  b = ((RGBQ *)&c2)->B - ((RGBQ *)&c1)->B;
  return (r * r + g * g + b * b) / (3 * 255);
}

BOOL WINAPI QuantizeDIB(HDIB bm, FC2B fdst, int nc)
{ // F
  int i, k, d, m, w, h, sw;
  RGBQ *qd, qw;
  static RGBQ ct[256];
  static int n[256], r[256], g[256], b[256];

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  if (nc < 1 || nc > 256) nc = 32;  else if (nc == 1) nc = 256;
  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  if (w * h > INT_MAX / 256) return (BOOL)ierr(E_DAT);
  qd = (RGBQ *)DIB_IMAGE(bm);
  for (k = 0; k < nc; k++) {
    m = w * h * k / nc;
    ct[k] = qd[m];
    qd[m].A = k;
  }
  do {
    for (i = 0; i < w * h; i++) {
      m = INT_MAX;
      for (k = 0; k < nc; k++) {
        d = fdst(*(RGBC *)&qd[i], *(RGBC *)&ct[k]);
        if (d < m) {
          qd[i].A = k;
          m = d;
        }
      }
    }
    for (i = 0; i < w * h; i++) {
      k = qd[i].A;
      n[k]++;
      r[k] += qd[i].R;
      g[k] += qd[i].G;
      b[k] += qd[i].B;
    }
    sw = 0;
    for (k = 0; k < nc; k++) {
      if (n[k] == 0) continue;
      qw.R = r[k] / n[k];
      qw.G = g[k] / n[k];
      qw.B = b[k] / n[k];
      qw.A = 0;
      if (*(RGBC *)&ct[k] != *(RGBC *)&qw) {
        ct[k] = qw;
        sw = 1;
      }
      n[k] = r[k] = g[k] = b[k] = 0;
    }
  } while (sw);
  for (i = 0; i < w * h; i++) {
    k = qd[i].A;
    qd[i] = ct[k];
  }
  return TRUE;
}

BYTE LOCALF fchcGAM(BYTE i, UINT pa)
{ // K}␳(pa:1`255)
  if (pa == 0) return 0;
  return (int)(pow(i / 255.0, 127.0 / pa) * 255.0 + 0.5);
}

typedef struct {
  BYTE  i1;
  BYTE  i2;
  BYTE  i3;
  BYTE  o1;
  BYTE  o2;
  BYTE  o3;
  WORD  xx;
} LVLP;

BYTE LOCALF fchcLVL(BYTE i, UINT pa)
{ // x␳
  LVLP *pl = (LVLP *)pa;

  if      (i < pl->i1) return pl->o1;
  else if (i < pl->i2) return pl->o1 + (i - pl->i1) * (pl->o2 - pl->o1) / (pl->i2 - pl->i1);
  else if (i < pl->i3) return pl->o2 + (i - pl->i2) * (pl->o3 - pl->o2) / (pl->i3 - pl->i2);
  else                 return pl->o3;
}

BYTE LOCALF fchcPOS(BYTE i, UINT pa)
{ // |X^[[V(pa:2`255)
  int k, t;

  if (pa < 2) return 0;
  k = i * (pa - 1) / 128;
  t = 128 * (k + (k % 2)) / (pa - 1);
  return (t < 256)? t: 255;
}

BYTE LOCALF fchcHIS(BYTE i, UINT pa)
{ // qXgŐKi
  HISP *ph = (HISP *)pa;

  if (ph->hx == 0) return 0;
  return (int)(255.0 * ph->hs[i] / ph->hx + 0.5);
}

void WINAPI SetCharacteristicCurve(BYTE ct[256], FCHC fchc, UINT pa)
{ // J[u̐ݒ
  int i;

  for (i = 0; i < 256; i++) {
    ct[i] = fchc(i, pa);
  }
}

RGBC LOCALF fc1pGRS(RGBC cr, UINT pa);

RGBC LOCALF fc1cVAL(RGBC cr)
{ // PxO[XP[()ŕ\
  return fc1pGRS(cr, (UINT)fc1bVAL);
}

typedef struct {
  RGBC  c1;
  RGBC  c2;
  FC1B  fext;
} GRAP;

RGBC LOCALF fc1pGRA(RGBC cr, UINT pa);

RGBC LOCALF fc1cCDB(RGBC cr)
{ // F()Of[V()ŕ\
  static GRAP par = { 0xffff00, 0x0000ff, fc1bCDB };

  return fc1pGRA(cr, (UINT)&par);
}

RGBC LOCALF fc1cCDR(RGBC cr)
{ // F()Of[V(VA)ŕ\
  static GRAP par = { 0x00ffff, 0xff0000, fc1bCDR };

  return fc1pGRA(cr, (UINT)&par);
}

RGBC LOCALF fc1cSAT(RGBC cr)
{ // ʓxO[XP[()ŕ\
  return fc1pGRS(cr, (UINT)fc1bSAT);
}

RGBC LOCALF fc1cHUE(RGBC cr)
{ // FOf[V(}[^ԁ΁VA)ŕ\
  int t;

  t = fc1bHUE(cr) * 8;
  ((RGBQ *)&cr)->R = t < 256? t: t < 1021? 255: t < 1276? 1275 - t: 0;
  ((RGBQ *)&cr)->G = t < 511? 0: t < 1021? (t - 510) / 2: t < 1531? 255: (1530 - t) / 2;
  ((RGBQ *)&cr)->B = t < 256? 255: t < 511? 510 - t: t < 1276? 0: t < 1531? t - 1275: 255;
  return cr;
}

RGBC LOCALF fc1cAVG(RGBC cr)
{ // 邳O[XP[()ŕ\
  return fc1pGRS(cr, (UINT)fc1bAVG);
}

RGBC LOCALF fc1cNOT(RGBC cr)
{ // ]F
  return ~cr & 0xffffff;
}

RGBC LOCALF fc1cBRI(RGBC cr)
{ // F
  ((RGBQ *)&cr)->R = (((RGBQ *)&cr)->R + 255) / 2;
  ((RGBQ *)&cr)->G = (((RGBQ *)&cr)->G + 255) / 2;
  ((RGBQ *)&cr)->B = (((RGBQ *)&cr)->B + 255) / 2;
  return cr;
}

RGBC LOCALF fc1cDRK(RGBC cr)
{ // ÐF
  ((RGBQ *)&cr)->R = ((RGBQ *)&cr)->R / 2;
  ((RGBQ *)&cr)->G = ((RGBQ *)&cr)->G / 2;
  ((RGBQ *)&cr)->B = ((RGBQ *)&cr)->B / 2;
  return cr;
}

RGBC LOCALF fc1cRBX(RGBC cr)
{ // RBF(COLORREFRGBQUADϊ)
  int t;

  t = ((RGBQ *)&cr)->R;
  ((RGBQ *)&cr)->R = ((RGBQ *)&cr)->B;
  ((RGBQ *)&cr)->B = t;
  return cr;
}

RGBC LOCALF fc1cCYC(RGBC cr)
{ // RG,GB,BRF
  int t;

  t = ((RGBQ *)&cr)->R;
  ((RGBQ *)&cr)->R = ((RGBQ *)&cr)->G;
  ((RGBQ *)&cr)->G = ((RGBQ *)&cr)->B;
  ((RGBQ *)&cr)->B = t;
  return cr;
}

typedef struct {
  FC1B  fext;
  BYTE  th;
  BYTE  xx[3];
} BINP;

RGBC LOCALF fc1pBIN(RGBC cr, UINT pa);

RGBC LOCALF fc1cTXT(RGBC cr)
{ // wiFɍF
  static BINP bin = { fc1bVAL, 128, };

  return fc1cNOT(fc1pBIN(cr, (UINT)&bin));
}

RGBC WINAPI BGR2RGB(BGRC cr)
{ // COLORREFRGBQUADϊ
  return fc1cRBX(cr);
}

BGRC WINAPI RGB2BGR(RGBC cr)
{ // RGBQUADCOLORREFϊ
  return fc1cRBX(cr);
}

BGRC WINAPI BKG2TXT(BGRC cr)
{ // wiFɍF
  return fc1cTXT(fc1cRBX(cr));
}

RGBC LOCALF fc1pCVT(RGBC cr, UINT pa)
{ // FC1C^R[obN֐Ă
  return ((FC1C)pa)(cr);
}

RGBC LOCALF fc1pGRS(RGBC cr, UINT pa)
{ // FO[XP[()ŕ\
  ((RGBQ *)&cr)->R = ((RGBQ *)&cr)->G = ((RGBQ *)&cr)->B = ((FC1B)pa)(cr);
  return cr;
}

RGBC LOCALF fc1pBRI(RGBC cr, UINT pa)
{ // 邳␳
  int r, g, b, t;
  PBYTE ct = (PBYTE)pa;

  t = fc1bVAL(cr);
  if (t == 0) return 0;
  ((RGBQ *)&cr)->R = ((r = ((RGBQ *)&cr)->R * ct[t] / t) < 256)? r: 255;
  ((RGBQ *)&cr)->G = ((g = ((RGBQ *)&cr)->G * ct[t] / t) < 256)? g: 255;
  ((RGBQ *)&cr)->B = ((b = ((RGBQ *)&cr)->B * ct[t] / t) < 256)? b: 255;
  return cr;
}

RGBC LOCALF fc1pLGT(RGBC cr, UINT pa)
{ // Ò(pa:0`255ō)
  if (pa < 128) {
    ((RGBQ *)&cr)->R = ((RGBQ *)&cr)->R * pa / 128;
    ((RGBQ *)&cr)->G = ((RGBQ *)&cr)->G * pa / 128;
    ((RGBQ *)&cr)->B = ((RGBQ *)&cr)->B * pa / 128;
  } else if (pa < 256) {
    ((RGBQ *)&cr)->R = (((RGBQ *)&cr)->R * (255 - pa) + 255 * (pa - 127)) / 128;
    ((RGBQ *)&cr)->G = (((RGBQ *)&cr)->G * (255 - pa) + 255 * (pa - 127)) / 128;
    ((RGBQ *)&cr)->B = (((RGBQ *)&cr)->B * (255 - pa) + 255 * (pa - 127)) / 128;
  }
  return cr;
}

RGBC LOCALF fc1pGRY(RGBC cr, UINT pa)
{ // O[AEg(pa:wiF)
  if (cr != pa) {
    ((RGBQ *)&cr)->R = ((RGBQ *)&cr)->G = ((RGBQ *)&cr)->B = (fc1bAVG(cr) + fc1bAVG(pa) * 2) / 3;
  }
  return cr;
}

RGBC LOCALF fc2pMIX(RGBC c1, RGBC c2, UINT pa);

RGBC LOCALF fc1pGRA(RGBC cr, UINT pa)
{ // FOf[V(F1F2)ŕ\
  return fc2pMIX(((GRAP *)pa)->c1, ((GRAP *)pa)->c2, ((GRAP *)pa)->fext(cr));
}

typedef struct {
  BYTE  fr;
  BYTE  lv;
  WORD  xx;
} NOIP;

RGBC LOCALF fc1pNOI(RGBC cr, UINT pa)
{ // _mCY
  int r, g, b;
  NOIP *pn = (NOIP *)pa;

  if ((int)(255.0 * rand() / RAND_MAX + 0.5) < pn->fr) {
    r = ((RGBQ *)&cr)->R;
    if      (r <= pn->lv / 2)      r = 0;
    else if (r < 255 - pn->lv / 2) r = r - pn->lv / 2;
    else                           r = 255 - pn->lv;
    ((RGBQ *)&cr)->R = r + (int)((REAL)pn->lv * rand() / RAND_MAX + 0.5);
    g = ((RGBQ *)&cr)->G;
    if      (g <= pn->lv / 2)      g = 0;
    else if (g < 255 - pn->lv / 2) g = g - pn->lv / 2;
    else                           g = 255 - pn->lv;
    ((RGBQ *)&cr)->G = g + (int)((REAL)pn->lv * rand() / RAND_MAX + 0.5);
    b = ((RGBQ *)&cr)->B;
    if      (b <= pn->lv / 2)      b = 0;
    else if (b < 255 - pn->lv / 2) b = b - pn->lv / 2;
    else                           b = 255 - pn->lv;
    ((RGBQ *)&cr)->B = b + (int)((REAL)pn->lv * rand() / RAND_MAX + 0.5);
  }
  return cr;
}

RGBC LOCALF fc1pBIN(RGBC cr, UINT pa)
{ // l
  return ((BINP *)pa)->fext(cr) <= ((BINP *)pa)->th? 0: 0xffffff;
}

RGBC LOCALF fc2cDIF(RGBC c1, RGBC c2);

typedef struct {
  RGBC  c1;
  RGBC  c2;
  FC2B  fdst;
  BYTE  th;
  BYTE  xx[3];
} REPP;

RGBC LOCALF fc1pREP(RGBC cr, UINT pa)
{ // F̒u
  RGBC cd;
  REPP *pr = (REPP *)pa;

  if (cr == pr->c1) return pr->c2;
  if (pr->fdst(cr, pr->c1) <= pr->th) {
    cd = fc2cDIF(pr->c1, cr);
    cr = fc2cDIF(pr->c2, cd);
  }
  return cr;
}

RGBC LOCALF fc1pHIS(RGBC cr, UINT pa)
{ // qXgOo
  ((HISX *)pa)->hs[((HISX *)pa)->fext(cr)]++;
  return cr;
}

BOOL WINAPI ChangeDIBColor(HDIB bm, FC1P fcvt, UINT pa)
{ // Fϊ
  int i, w, h;
  RGBC *qd;

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  qd = (RGBC *)DIB_IMAGE(bm);
  for (i = 0; i < w * h; i++) {
    qd[i] = fcvt(qd[i], pa);
  }
  return TRUE;
}

RGBC LOCALF fc2cADD(RGBC c1, RGBC c2)
{ // Z
  int t;

  ((RGBQ *)&c1)->R = ((t = ((RGBQ *)&c1)->R + ((RGBQ *)&c2)->R) < 256)? t: 255;
  ((RGBQ *)&c1)->G = ((t = ((RGBQ *)&c1)->G + ((RGBQ *)&c2)->G) < 256)? t: 255;
  ((RGBQ *)&c1)->B = ((t = ((RGBQ *)&c1)->B + ((RGBQ *)&c2)->B) < 256)? t: 255;
  return c1;
}

RGBC LOCALF fc2cMUL(RGBC c1, RGBC c2)
{ // Z
  ((RGBQ *)&c1)->R = ((RGBQ *)&c1)->R * ((RGBQ *)&c2)->R / 255;
  ((RGBQ *)&c1)->G = ((RGBQ *)&c1)->G * ((RGBQ *)&c2)->G / 255;
  ((RGBQ *)&c1)->B = ((RGBQ *)&c1)->B * ((RGBQ *)&c2)->B / 255;
  return c1;
}

RGBC LOCALF fc2cSCR(RGBC c1, RGBC c2)
{ // XN[
  int r1, r2, g1, g2, b1, b2;

  r1 = ((RGBQ *)&c1)->R; r2 = ((RGBQ *)&c2)->R;
  g1 = ((RGBQ *)&c1)->G; g2 = ((RGBQ *)&c2)->G;
  b1 = ((RGBQ *)&c1)->B; b2 = ((RGBQ *)&c2)->B;
  ((RGBQ *)&c1)->R = r1 + r2 - r1 * r2 / 255;
  ((RGBQ *)&c1)->G = g1 + g2 - g1 * g2 / 255;
  ((RGBQ *)&c1)->B = b1 + b2 - b1 * b2 / 255;
  return c1;
}

RGBC LOCALF fc2cOVR(RGBC c1, RGBC c2)
{ // I[o[C
  int r1, r2, g1, g2, b1, b2;

  r1 = ((RGBQ *)&c1)->R; r2 = ((RGBQ *)&c2)->R;
  g1 = ((RGBQ *)&c1)->G; g2 = ((RGBQ *)&c2)->G;
  b1 = ((RGBQ *)&c1)->B; b2 = ((RGBQ *)&c2)->B;
  ((RGBQ *)&c1)->R = r1 < 128? 2 * r1 * r2 / 255: 2 * (r1 + r2 - r1 * r2 / 255) - 255;
  ((RGBQ *)&c1)->G = g1 < 128? 2 * g1 * g2 / 255: 2 * (g1 + g2 - g1 * g2 / 255) - 255;
  ((RGBQ *)&c1)->B = b1 < 128? 2 * b1 * b2 / 255: 2 * (b1 + b2 - b1 * b2 / 255) - 255;
  return c1;
}

RGBC LOCALF fc2cAVG(RGBC c1, RGBC c2)
{ // ϒl
  ((RGBQ *)&c1)->R = (((RGBQ *)&c1)->R + ((RGBQ *)&c2)->R) / 2;
  ((RGBQ *)&c1)->G = (((RGBQ *)&c1)->G + ((RGBQ *)&c2)->G) / 2;
  ((RGBQ *)&c1)->B = (((RGBQ *)&c1)->B + ((RGBQ *)&c2)->B) / 2;
  return c1;
}

RGBC LOCALF fc2cDIF(RGBC c1, RGBC c2)
{ // (c1c2߂F̂Ƃ)
  ((RGBQ *)&c1)->R = 128 + ((RGBQ *)&c1)->R - ((RGBQ *)&c2)->R;
  ((RGBQ *)&c1)->G = 128 + ((RGBQ *)&c1)->G - ((RGBQ *)&c2)->G;
  ((RGBQ *)&c1)->B = 128 + ((RGBQ *)&c1)->B - ((RGBQ *)&c2)->B;
  return c1;
}

RGBC LOCALF fc2cALF(RGBC c1, RGBC c2)
{ // At@lɂ鍬F(c2.A:c2̔䗦A02550%100%)
  int w1 = 255 - ((RGBQ *)&c2)->A, w2 = ((RGBQ *)&c2)->A;

  ((RGBQ *)&c1)->R = (((RGBQ *)&c1)->R * w1 + ((RGBQ *)&c2)->R * w2) / 255;
  ((RGBQ *)&c1)->G = (((RGBQ *)&c1)->G * w1 + ((RGBQ *)&c2)->G * w2) / 255;
  ((RGBQ *)&c1)->B = (((RGBQ *)&c1)->B * w1 + ((RGBQ *)&c2)->B * w2) / 255;
  return c1;
}

RGBC LOCALF fc2pOPR(RGBC c1, RGBC c2, UINT pa)
{ // FC2C^R[obN֐Ă
  return ((FC2C)pa)(c1, c2);
}

RGBC LOCALF fc2pMIX(RGBC c1, RGBC c2, UINT pa)
{ // F(pa:c2̔䗦A02550%100%)
  int w1 = 255 - pa, w2 = pa;

  ((RGBQ *)&c1)->R = (((RGBQ *)&c1)->R * w1 + ((RGBQ *)&c2)->R * w2) / 255;
  ((RGBQ *)&c1)->G = (((RGBQ *)&c1)->G * w1 + ((RGBQ *)&c2)->G * w2) / 255;
  ((RGBQ *)&c1)->B = (((RGBQ *)&c1)->B * w1 + ((RGBQ *)&c2)->B * w2) / 255;
  return c1;
}

RGBC LOCALF fc2pALF(RGBC c1, RGBC c2, UINT pa)
{ // At@ltF(pa:c2̔䗦A02550%100%)
  int w1 = 255 - pa, w2 = pa;

  ((RGBQ *)&c1)->R = (((RGBQ *)&c1)->R * w1 + ((RGBQ *)&c2)->R * w2) / 255;
  ((RGBQ *)&c1)->G = (((RGBQ *)&c1)->G * w1 + ((RGBQ *)&c2)->G * w2) / 255;
  ((RGBQ *)&c1)->B = (((RGBQ *)&c1)->B * w1 + ((RGBQ *)&c2)->B * w2) / 255;
  ((RGBQ *)&c1)->A = (((RGBQ *)&c1)->A * w1 + ((RGBQ *)&c2)->A * w2) / 255;
  return c1;
}

BOOL WINAPI SuperposeDIB(HDIB bm, HDIB bx, FC2P fopr, UINT pa)
{ // dˍ킹
  int i, w, h;
  RGBC *q1, *q2;

  if (DIB_BITS(bm) != 32 || DIB_BITS(bx) != 32) return (BOOL)ierr(E_DAT);
  w = DIB_WIDTH(bm); if (DIB_WIDTH(bx) != w) return (BOOL)ierr(E_DAT);
  h = abs(DIB_HEIGHT(bm)); if (abs(DIB_HEIGHT(bx)) != h) return (BOOL)ierr(E_DAT);
  q1 = (RGBC *)DIB_IMAGE(bm);
  q2 = (RGBC *)DIB_IMAGE(bx);
  for (i = 0; i < w * h; i++) {
    q1[i] = fopr(q1[i], q2[i], pa);
  }
  return TRUE;
}

RGBC LOCALF fxypCLR(int x, int y, UINT pa)
{ // hԂ
  return pa;
}

RGBC LOCALF fxypTIL(int x, int y, UINT pa)
{ // ^CO
  int w, h;
  HDIB bm = (HDIB)pa;

  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  return ((RGBC *)DIB_IMAGE(bm))[(y % h) * w + (x % w)];
}

RGBC LOCALF fxypHIS(int x, int y, UINT pa)
{ // qXgO}
  return (x >= 0 && x < 256 && y > (255 - ((PBYTE)pa)[x]))? 0: 0xffffff;
}

typedef struct {
  RGBC  c1;
  RGBC  c2;
  RGBC  c3;
  RGBC  c4;
  int   w;
  int   h;
} SQRP;

RGBC LOCALF fxypGRA(int x, int y, UINT pa)
{ // `Of[V
  int rx, ry;
  SQRP *pg = (SQRP *)pa;

  rx = (int)(255.0 * x / pg->w + 0.5);
  ry = (int)(255.0 * y / pg->h + 0.5);
  return fc2pMIX(fc2pMIX(pg->c1, pg->c3, ry), fc2pMIX(pg->c2, pg->c4, ry), rx);
}

typedef struct {
  RGBC  c1;
  RGBC  c2;
  int   xc;
  int   yc;
  int   rc;
} RADP;

RGBC LOCALF fxypRAD(int x, int y, UINT pa)
{ // ˏOf[V
  int d;
  RADP *pr = (RADP *)pa;

  d = (int)(hypot(x - pr->xc, y - pr->yc) + 0.5);
  return (d >= pr->rc)? pr->c2: fc2pMIX(pr->c1, pr->c2, (int)(255.0 * d / pr->rc + 0.5));
}

typedef struct {
  RGBC  cr;
  BYTE  fr;
  BYTE  lv;
  WORD  xx[3];
} NOIX;

RGBC LOCALF fxypNOI(int x, int y, UINT pa)
{ // mCY
  NOIX *pn = (NOIX *)pa;

  return fc1pNOI(pn->cr, (UINT)&pn->fr);
}

BOOL WINAPI PaintDIB(HDIB bm, FXYP fpnt, UINT pa)
{ // hԂ
  int i, j, w, h;
  RGBC *qd;

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  qd = (RGBC *)DIB_IMAGE(bm);
  for (i = 0; i < h; i++) {
    for (j = 0; j < w; j++) {
      qd[i * w + j] = fpnt(j, i, pa);
    }
  }
  return TRUE;
}

PCWINS LOCALF fwin3x3(const RGBC *qd, int x, int y, int w, int h)
{ // 3x3ߖTf
  int s, t, u, v;
  static RGBC wk[3*3];
  static WINS ws = { wk, NELEM(wk) };

  s = (x > 0)? x - 1: x; t = (x < w - 1)? x + 1: x;
  u = (y > 0)? y - 1: y; v = (y < h - 1)? y + 1: y;
  wk[0] = qd[u * w + s]; wk[1] = qd[u * w + x]; wk[2] = qd[u * w + t];
  wk[3] = qd[y * w + s]; wk[4] = qd[y * w + x]; wk[5] = qd[y * w + t];
  wk[6] = qd[v * w + s]; wk[7] = qd[v * w + x]; wk[8] = qd[v * w + t];
  return &ws;
}

PCWINS LOCALF fwin5x5(const RGBC *qd, int x, int y, int w, int h)
{ // 5x5ߖTf
  int o, p, q, r, s, t, u, v;
  static RGBC wk[5*5];
  static WINS ws = { wk, NELEM(wk) };

  o = (x > 1)? x - 2: x; p = (x > 0)? x - 1: x; q = (x < w - 1)? x + 1: x; r = (x < w - 2)? x + 2: x;
  s = (y > 1)? y - 2: y; t = (y > 0)? y - 1: y; u = (y < h - 1)? y + 1: y; v = (y < h - 2)? y + 2: y;
  wk[ 0] = qd[s * w + o]; wk[ 1] = qd[s * w + p]; wk[ 2] = qd[s * w + x]; wk[ 3] = qd[s * w + q]; wk[ 4] = qd[s * w + r];
  wk[ 5] = qd[t * w + o]; wk[ 6] = qd[t * w + p]; wk[ 7] = qd[t * w + x]; wk[ 8] = qd[t * w + q]; wk[ 9] = qd[t * w + r];
  wk[10] = qd[y * w + o]; wk[11] = qd[y * w + p]; wk[12] = qd[y * w + x]; wk[13] = qd[y * w + q]; wk[14] = qd[y * w + r];
  wk[15] = qd[u * w + o]; wk[16] = qd[u * w + p]; wk[17] = qd[u * w + x]; wk[18] = qd[u * w + q]; wk[19] = qd[u * w + r];
  wk[20] = qd[v * w + o]; wk[21] = qd[v * w + p]; wk[22] = qd[v * w + x]; wk[23] = qd[v * w + q]; wk[24] = qd[v * w + r];
  return &ws;
}

RGBC LOCALF ffilAVG(PCWINS ws, UINT pa)
{ // ϒltB^
  int i, r, g, b, q;

  r = g = b = q = 0;
  for (i = 0; i < ws->ni; i++) {
    r += ((RGBQ *)&ws->wk[i])->R;
    g += ((RGBQ *)&ws->wk[i])->G;
    b += ((RGBQ *)&ws->wk[i])->B;
  }
  ((RGBQ *)&q)->R = r / ws->ni;
  ((RGBQ *)&q)->G = g / ws->ni;
  ((RGBQ *)&q)->B = b / ws->ni;
  return q;
}

RGBC LOCALF ffilNEA(PCWINS ws, UINT pa)
{ // ł߂F
  int i, k, d, f;

  k = 0; f = 255;
  for (i = 0; i < ws->ni; i++) {
    d = fc2bEUC(ws->wk[i], (RGBC)pa);
    if (d < f) { k = i; f = d;}
  }
  return ws->wk[k];
}

RGBC LOCALF ffilMAX(PCWINS ws, UINT pa)
{ // őltB^
  return ffilNEA(ws, 0xffffff);
}

RGBC LOCALF ffilMIN(PCWINS ws, UINT pa)
{ // ŏltB^
  return ffilNEA(ws, 0);
}

RGBC LOCALF ffilMED(PCWINS ws, UINT pa)
{ // ltB^
  int i, j, k, t, w[256];

  for (i = 0; i < ws->ni; i++) {
    w[i] = MAKEWORD(fc2bEUC(ws->wk[i], 0), i);
  }
  for (k = ws->ni - 1; k >= 0; k = j) {
    for (i = 1, j = -1; i <= k; i++) {
      if (LOBYTE(w[i - 1]) > LOBYTE(w[i])) {
        j = i - 1; t = w[i]; w[i] = w[j]; w[j] = t;
      }
    }
  }
  return ws->wk[HIBYTE(w[ws->ni / 2])];
}

RGBC LOCALF ffilMEA(PCWINS ws, UINT pa)
{ // ϒlɍł߂F
  return ffilNEA(ws, ffilAVG(ws, 0));
}

RGBC LOCALF ffilCNV(PCWINS ws, UINT pa)
{ // ϘaZ
  int i, r, g, b, q;
  RGBC *op = (RGBC *)pa;

  r = g = b = q = 0;
  for (i = 0; i < ws->ni; i++) {
    r += ((RGBQ *)&ws->wk[i])->R * ((RGBQ *)&op[i])->R;
    g += ((RGBQ *)&ws->wk[i])->G * ((RGBQ *)&op[i])->G;
    b += ((RGBQ *)&ws->wk[i])->B * ((RGBQ *)&op[i])->B;
  }
  ((RGBQ *)&q)->R = r / 255;
  ((RGBQ *)&q)->G = g / 255;
  ((RGBQ *)&q)->B = b / 255;
  return q;
}

RGBC LOCALF ffilGAU(PCWINS ws, UINT pa)
{ // KEVAtB^
  static RGBC op[5*5] = {
    0x010101, 0x040404, 0x060606, 0x040404, 0x010101,
    0x040404, 0x101010, 0x181818, 0x101010, 0x040404,
    0x060606, 0x181818, 0x232323, 0x181818, 0x060606,
    0x040404, 0x101010, 0x181818, 0x101010, 0x040404,
    0x010101, 0x040404, 0x060606, 0x040404, 0x010101,
  };

  return ffilCNV(ws, (UINT)op);
}

BOOL WINAPI FilterDIB(HDIB bm, FWIN fwin, FFIL ffil, UINT pa)
{ // tB^
  int i, j, w, h, sw = 0;
  RGBC *q1, *q2;
  HDIB bx;

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w = DIB_WIDTH(bm);
  h = DIB_HEIGHT(bm); if (h < 0) { h = -h; sw = 1;}
  bx = CreateDIBX(w, h, DIB_32B | (sw? DIB_TDN: 0), DIB_XPPM(bm), DIB_YPPM(bm)); if (!bx) return FALSE;
  q1 = (RGBC *)DIB_IMAGE(bm);
  q2 = (RGBC *)DIB_IMAGE(bx);
  for (i = 0; i < h; i++) {
    for (j = 0; j < w; j++) {
      q2[i * w + j] = ffil(fwin(q1, j, i, w, h), pa);
    }
  }
  MoveDIB(bm, bx);
  return TRUE;
}

BOOL WINAPI TrimDIB(HDIB bm, int x, int y, int w, int h, RGBC cb)
{ // g~O
  int i, j, k, l, w1, h1, sw = 0;
  RGBC *q1, *q2;
  HDIB bx;

  if (w <= 0 || h <= 0) return (BOOL)ierr(E_PAR);
  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w1 = DIB_WIDTH(bm);
  h1 = DIB_HEIGHT(bm); if (h1 < 0) { h1 = -h1; sw = 1;}
  bx = CreateDIBX(w, h, DIB_32B | (sw? DIB_TDN: 0), DIB_XPPM(bm), DIB_YPPM(bm)); if (!bx) return FALSE;
  q1 = (RGBC *)DIB_IMAGE(bm);
  q2 = (RGBC *)DIB_IMAGE(bx);
  for (i = 0; i < h; i++) {
    l = i + y;
    for (j = 0; j < w; j++) {
      k = j + x;
      if (l >= 0 && l < h1 && k >= 0 && k < w1) {
        q2[i * w + j] = q1[l * w1 + k];
      } else {
        q2[i * w + j] = cb;
      }
    }
  }
  MoveDIB(bm, bx);
  return TRUE;
}

BOOL WINAPI PasteDIB(HDIB bm, HDIB bx, int x, int y)
{ // \t
  int i, j, k, l, w1, w2, h1, h2;
  RGBC *q1, *q2;

  if (DIB_BITS(bm) != 32 || DIB_BITS(bx) != 32) return (BOOL)ierr(E_DAT);
  w1 = DIB_WIDTH(bm);
  h1 = abs(DIB_HEIGHT(bm));
  w2 = DIB_WIDTH(bx);
  h2 = abs(DIB_HEIGHT(bx));
  q1 = (RGBC *)DIB_IMAGE(bm);
  q2 = (RGBC *)DIB_IMAGE(bx);
  for (i = 0; i < h2; i++) {
    l = i + y;
    if (l < 0 || l >= h1) continue;
    for (j = 0; j < w2; j++) {
      k = j + x;
      if (k < 0 || k >= w1) continue;
      q1[l * w1 + k] = q2[i * w2 + j];
    }
  }
  return TRUE;
}

BOOL WINAPI ResizeDIBA(HDIB bm, int w, int h)
{ // gk(ʐϕ)
  int i, j, k, k1, k2, l, l1, l2, w1, w2, h1, h2, sw = 0;
  int n, r, g, b, m1, m2, n1, n2, fl, fk;
  RGBQ *q1, *q2;
  HDIB bx;

  if (w == 0 || h == 0) return (BOOL)ierr(E_PAR);
  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w1 = DIB_WIDTH(bm);
  h1 = DIB_HEIGHT(bm); if (h1 < 0) { h1 = -h1; sw = 1;}
  w2 = abs(w);
  h2 = abs(h);
  bx = CreateDIBX(w2, h2, DIB_32B | (sw? DIB_TDN: 0), DIB_XPPM(bm), DIB_YPPM(bm)); if (!bx) return FALSE;
  q1 = (RGBQ *)DIB_IMAGE(bm);
  q2 = (RGBQ *)DIB_IMAGE(bx);
  for (i = 0; i < h2; i++) {
    l1 = (i * h1) / h2; l2 = ((i + 1) * h1) / h2;
    n1 = (i * h1) % h2; n2 = ((i + 1) * h1) % h2;
    for (j = 0; j < w2; j++) {
      k1 = (j * w1) / w2; k2 = ((j + 1) * w1) / w2;
      m1 = (j * w1) % w2; m2 = ((j + 1) * w1) % w2;
      n = r = g = b = 0;
      for (l = l1; l < l2; l++) {
        fl = 256 * ((l < l2-1) * h2 - (l == l1) * n1 + (l == l2-1) * n2) / h2;
        for (k = k1; k < k2; k++) {
          fk = fl * ((k < k2-1) * w2 - (k == k1) * m1 + (k == k2-1) * m2) / w2;
          n += fk;
          r += q1[l * w1 + k].R * fk;
          g += q1[l * w1 + k].G * fk;
          b += q1[l * w1 + k].B * fk;
        }
      }
      q2[i * w2 + j].R = n? r / n: q1[l1 * w1 + k1].R;
      q2[i * w2 + j].G = n? g / n: q1[l1 * w1 + k1].G;
      q2[i * w2 + j].B = n? b / n: q1[l1 * w1 + k1].B;
    }
  }
  if (w < 0 || h < 0) InvertDIB(bx, (w < 0) * DIB_HRZ | (h < 0) * DIB_VRT);
  MoveDIB(bm, bx);
  return TRUE;
}

BOOL WINAPI ResizeDIBB(HDIB bm, int w, int h)
{ // gk(`⊮)
  XFMQ xfm;

  w = sign(w) * (abs(w) - 1);
  h = sign(h) * (abs(h) - 1);
  SetXFMQ(&xfm, 0, 0, w, 0, 0, h, w, h);
  return TransformDIB(bm, &xfm, 0);
}

BOOL WINAPI ResizeDIBX(HDIB bm, int w, int h, int sw)
{ // gk
  int w1, w2, h1, h2;

  if (w == 0 || h == 0) return (BOOL)ierr(E_PAR);
  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w1 = DIB_WIDTH(bm);
  h1 = abs(DIB_HEIGHT(bm));
  w2 = abs(w);
  h2 = abs(h);
  switch (sw) {
  default: _L1:
    return ResizeDIBA(bm, w, h);
  case DIB_LIN: _L2:
    return ResizeDIBB(bm, w, h);
  case DIB_SMO:
    if (w2 * h2 <= w1 * h1) goto _L1;  else goto _L2;
  case DIB_SHA:
    if (w2 * h2 <= w1 * h1) goto _L2;  else goto _L1;
  }
}

BOOL WINAPI InvertDIB(HDIB bm, int sw)
{ // f]
  int w, h;
  XFMQ xfm;

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  xfm.x1 = xfm.x3 = (sw & DIB_HRZ)? w-1: 0;
  xfm.y1 = xfm.y2 = (sw & DIB_VRT)? h-1: 0;
  xfm.x2 = xfm.x4 = (sw & DIB_HRZ)? 0: w-1;
  xfm.y3 = xfm.y4 = (sw & DIB_VRT)? 0: h-1;
  return TransformDIB(bm, &xfm, 0);
}

BOOL WINAPI RotateDIB(HDIB bm, REAL dg, RGBC cb)
{ // Cӊpx](dg:xAv萳)
  int w, h, xs, ys, xc, yc;
  REAL sn, cs;
  XFMQ xfm;

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  sn = sin(dg * RPD);
  cs = cos(dg * RPD);
  xs = iround((w-1) * sn);
  ys = iround((h-1) * sn);
  xc = iround((w-1) * cs);
  yc = iround((h-1) * cs);
  SetXFMQ(&xfm, 0, 0, xc, -xs, ys, yc, xc + ys, yc - xs);
  return TransformDIB(bm, &xfm, cb);
}

void WINAPI SetXFMQ(PXFMQ q, int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4)
{ // l_̎w
  q->x1 = x1; q->y1 = y1; q->x2 = x2; q->y2 = y2; q->x3 = x3; q->y3 = y3; q->x4 = x4; q->y4 = y4;
}

typedef struct {
  REAL  t0;
  REAL  t1;
  REAL  t2;
  REAL  t3;
  REAL  t4;
  REAL  t5;
  REAL  t6;
  REAL  t7;
} PRSP;

void LOCALF fxfmPRS(REAL *px, REAL *py, REAL ix, REAL iy, UINT pa)
{ // ϊ
  REAL hw;
  PRSP *pp = (PRSP *)pa;

  hw  =  pp->t6 * ix + pp->t7 * iy + 1.0;
  *px = (pp->t0 * ix + pp->t1 * iy + pp->t2) / hw;
  *py = (pp->t3 * ix + pp->t4 * iy + pp->t5) / hw;
}

BOOL WINAPI TransformDIB(HDIB bm, PCXFMQ q, RGBC cb)
{ // Rό`(l_(0,0),(w-1,0),(0,h-1),(w-1,h-1)̈ړw)
  int i, w1, w2, h1, h2, u1, u2, v1, v2, u[4], v[4];
  REAL a[8*8], b[8], t[8];

  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w1 = DIB_WIDTH(bm);
  h1 = abs(DIB_HEIGHT(bm));
  b[0] = b[4] = 0.0;
  b[1] = b[3] = 0.0;
  b[2] = b[6] = (REAL)(w1-1);
  b[5] = b[7] = (REAL)(h1-1);
  u[0] = q->x1; v[0] = q->y1;
  u[1] = q->x2; v[1] = q->y2;
  u[2] = q->x3; v[2] = q->y3;
  u[3] = q->x4; v[3] = q->y4;
  u1 = u2 = u[0];
  v1 = v2 = v[0];
  for (i = 1; i < 4; i++) {
    if (u[i] < u1) u1 = u[i];  else if (u[i] > u2) u2 = u[i];
    if (v[i] < v1) v1 = v[i];  else if (v[i] > v2) v2 = v[i];
  }
  for (i = 0; i < 4; i++) {
    u[i] -= u1;
    v[i] -= v1;
  }
  w2 = u2 - u1 + 1;
  h2 = v2 - v1 + 1;
  a[ 0] = u[0]; a[ 1] = v[0]; a[ 2] = 1.0; a[ 3] = a[ 4] = a[ 5] = 0.0; a[ 6] = -u[0]*b[0]; a[ 7] = -v[0]*b[0];
  a[ 8] = a[ 9] = a[10] = 0.0; a[11] = u[0]; a[12] = v[0]; a[13] = 1.0; a[14] = -u[0]*b[1]; a[15] = -v[0]*b[1];
  a[16] = u[1]; a[17] = v[1]; a[18] = 1.0; a[19] = a[20] = a[21] = 0.0; a[22] = -u[1]*b[2]; a[23] = -v[1]*b[2];
  a[24] = a[25] = a[26] = 0.0; a[27] = u[1]; a[28] = v[1]; a[29] = 1.0; a[30] = -u[1]*b[3]; a[31] = -v[1]*b[3];
  a[32] = u[2]; a[33] = v[2]; a[34] = 1.0; a[35] = a[36] = a[37] = 0.0; a[38] = -u[2]*b[4]; a[39] = -v[2]*b[4];
  a[40] = a[41] = a[42] = 0.0; a[43] = u[2]; a[44] = v[2]; a[45] = 1.0; a[46] = -u[2]*b[5]; a[47] = -v[2]*b[5];
  a[48] = u[3]; a[49] = v[3]; a[50] = 1.0; a[51] = a[52] = a[53] = 0.0; a[54] = -u[3]*b[6]; a[55] = -v[3]*b[6];
  a[56] = a[57] = a[58] = 0.0; a[59] = u[3]; a[60] = v[3]; a[61] = 1.0; a[62] = -u[3]*b[7]; a[63] = -v[3]*b[7];
  if (!Equ1dNu(t, a, b, 8)) return (BOOL)ierr(E_DAT);
  return TransformDIBX(bm, w2, h2, fxfmPRS, (UINT)t, cb);
}

typedef struct {
  REAL  k1;
  REAL  k2;
  REAL  x0;
  REAL  y0;
} DISP;

void LOCALF fxfmDIS(REAL *px, REAL *py, REAL ix, REAL iy, UINT pa)
{ // ˘c
  REAL rd;
  DISP *pd = (DISP *)pa;

  ix -= pd->x0;
  iy -= pd->y0;
  rd = pd->k1 + pd->k2 * (ix * ix + iy * iy);
  *px = rd * ix + pd->x0;
  *py = rd * iy + pd->y0;
}

BOOL WINAPI TransformDIBX(HDIB bm, int w, int h, FXFM fxfm, UINT pa, RGBC cb)
{ // Rό`
  int i, j, k, l, w1, w2, h1, h2, rx, ry, sw = 0;
  RGBC c1, c2, c3, c4, *q1, *q2;
  HDIB bx;
  REAL x, y;

  if (w == 0 || h == 0) return (BOOL)ierr(E_PAR);
  if (DIB_BITS(bm) != 32) return (BOOL)ierr(E_DAT);
  w1 = DIB_WIDTH(bm);
  h1 = DIB_HEIGHT(bm); if (h1 < 0) { h1 = -h1; sw = 1;}
  w2 = abs(w);
  h2 = abs(h);
  bx = CreateDIBX(w2, h2, DIB_32B | (sw? DIB_TDN: 0), DIB_XPPM(bm), DIB_YPPM(bm)); if (!bx) return FALSE;
  q1 = (RGBC *)DIB_IMAGE(bm);
  q2 = (RGBC *)DIB_IMAGE(bx);
  for (i = 0; i < h2; i++) {
    for (j = 0; j < w2; j++) {
      fxfm(&x, &y, j, i, pa);
      k = (x >= 0.0)? (int)x: (int)(x - 1.0);
      l = (y >= 0.0)? (int)y: (int)(y - 1.0);
      if (k >= -1 && k < w1 && l >= -1 && l < h1) {
        c1 = (l >= 0   && k >= 0  )? q1[l * w1 + k]      : cb;
        c2 = (l >= 0   && k < w1-1)? q1[l * w1 + k+1]    : cb;
        c3 = (l < h1-1 && k >= 0  )? q1[(l+1) * w1 + k]  : cb;
        c4 = (l < h1-1 && k < w1-1)? q1[(l+1) * w1 + k+1]: cb;
        rx = (int)(255.0 * (x - k) + 0.5);
        ry = (int)(255.0 * (y - l) + 0.5);
        q2[i * w2 + j] = fc2pALF(fc2pALF(c1, c3, ry), fc2pALF(c2, c4, ry), rx);
      } else {
        q2[i * w2 + j] = cb;
      }
    }
  }
  MoveDIB(bm, bx);
  return TRUE;
}

BOOL WINAPI ConvertDIB(HDIB bm, int flg)
{ // foCXƗrbg}bṽtH[}bgϊ
  int i, j, k, w, h, n, sw, bc1, bc2;
  BYTE *p1, *p2;
  RGBC *q1, *q2, *c1;
  HDIB bx;

  bc1 = DIB_BITS(bm);
  switch (flg & 0x3f) {
  default:      bc2 = 24; break;
  case DIB_32B: bc2 = 32; break;
  }
  switch (bc1) {
  case  1:
  case  4:
  case  8:
    if (bc2 != 32) return (BOOL)ierr(E_DAT);
    break;
  case 24:
  case 32:
    if (bc2 != 24 && bc2 != 32) return (BOOL)ierr(E_DAT);
    break;
  default:
    return (BOOL)ierr(E_DAT);
  }
  w = DIB_WIDTH(bm);
  h = abs(DIB_HEIGHT(bm));
  bx = CreateDIBX(w, h, flg, DIB_XPPM(bm), DIB_YPPM(bm)); if (!bx) return FALSE;
  sw = (DIB_HEIGHT(bm) < 0) != ((flg & DIB_TDN) != 0);
  switch (MAKEUINT(bc1, bc2)) {
  case MAKEUINT(32, 32):
    q1 = (RGBC *)DIB_IMAGE(bm);
    q2 = (RGBC *)DIB_IMAGE(bx);
    n  = DIB_LINE_SIZE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      memcpy(&q2[k * w], &q1[i * w], n);
    }
    break;
  case MAKEUINT(32, 24):
    q1 = (RGBC *)DIB_IMAGE(bm);
    p2 = DIB_IMAGE(bx);
    n  = DIB_LINE_SIZE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      for (j = 0; j < w; j++) {
        memcpy(&p2[k * n + j * 3], &q1[i * w + j], 3);
      }
    }
    break;
  case MAKEUINT(24, 32):
    p1 = DIB_IMAGE(bm);
    n  = DIB_LINE_SIZE(bm);
    q2 = (RGBC *)DIB_IMAGE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      for (j = 0; j < w; j++) {
        memcpy(&q2[k * w + j], &p1[i * n + j * 3], 3);
      }
    }
    break;
  case MAKEUINT(24, 24):
    p1 = DIB_IMAGE(bm);
    n  = DIB_LINE_SIZE(bm);
    p2 = DIB_IMAGE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      memcpy(&p2[k * n], &p1[i * n], n);
    }
    break;
  case MAKEUINT( 8, 32):
    c1 = (RGBC *)DIB_PALETTE(bm);
    p1 = DIB_IMAGE(bm);
    n  = DIB_LINE_SIZE(bm);
    q2 = (RGBC *)DIB_IMAGE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      for (j = 0; j < w; j++) {
        q2[k * w + j] = c1[p1[i * n + j]];
      }
    }
    break;
  case MAKEUINT( 4, 32):
    c1 = (RGBC *)DIB_PALETTE(bm);
    p1 = DIB_IMAGE(bm);
    n  = DIB_LINE_SIZE(bm);
    q2 = (RGBC *)DIB_IMAGE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      for (j = 0; j < w; j++) {
        q2[k * w + j] = c1[(j % 2)? p1[i * n + j / 2] & 0x0f: p1[i * n + j / 2] >> 4];
      }
    }
    break;
  case MAKEUINT( 1, 32):
    c1 = (RGBC *)DIB_PALETTE(bm);
    p1 = DIB_IMAGE(bm);
    n  = DIB_LINE_SIZE(bm);
    q2 = (RGBC *)DIB_IMAGE(bx);
    for (i = 0; i < h; i++) {
      k = sw? h - 1 - i: i;
      for (j = 0; j < w; j++) {
        q2[k * w + j] = c1[(p1[i * n + j / 8] >> (7 - (j % 8))) & 1];
      }
    }
    break;
  }
  MoveDIB(bm, bx);
  return TRUE;
}

HDIB WINAPI LoadBMP(HDIB bm, PCSTR nam)
{ // BMPt@CǍ
  bm = LoadDIB(bm, nam); if (!bm) return NULL;
  if (!ConvertDIB(bm, DIB_32B|DIB_TDN)) { DeleteDIB(bm); bm = NULL;}
  return bm;
}

BOOL WINAPI SaveBMP(HDIB bm, PCSTR nam)
{ // BMPt@Co
  int re = FALSE;
  HDIB bx;

  bx = DuplicateDIB(bm); if (!bx) return FALSE;
  if (ConvertDIB(bx, DIB_24B)) re = SaveDIB(bx, nam);
  DeleteDIB(bx);
  return re;
}

HDIB WINAPI CaptureDIB(HDIB bm, HDC hdc, PCRECT pr)
{ // rbg}bv̎擾
  int x, y, w, h;
  HDIB bx;
  HDC hmem;
  HBITMAP hbmp, horg;
  BITMAP bmp;

  if (!pr) {
    hbmp = GetCurrentObject(hdc, OBJ_BITMAP);
    GetObject(hbmp, sizeof(BITMAP), &bmp);
    x = y = 0;
    w = bmp.bmWidth;
    h = bmp.bmHeight;
  } else {
    if (IsRectEmpty(pr)) return ierr(E_DAT);
    x = pr->lft; y = pr->top;
    w = pr->rgt - pr->lft;
    h = pr->btm - pr->top;
  }
  bx = CreateDIB(w, h, DIB_32B|DIB_TDN); if (!bx) return NULL;
  hmem = CreateCompatibleDC(hdc);
  horg = SelectObject(hmem, hbmp = CreateCompatibleBitmap(hdc, w, h));
  BitBlt(hmem, 0, 0, w, h, hdc, x, y, SRCCOPY);
  SelectObject(hmem, horg);
  GetDIBits(hmem, hbmp, 0, h, DIB_IMAGE(bx), DIB_BMI(bx), DIB_RGB_COLORS);
  DeleteObject(hbmp);
  DeleteDC(hmem);
  return bm? MoveDIB(bm, bx): bx;
}

HDIB WINAPI CreateDIBFromDDB(HBITMAP hbmp)
{ // ʕ\prbg}bvfoCXƗrbg}bv쐬
  HDIB bm;
  HDC hdc;
  BITMAP bmp;

  GetObject(hbmp, sizeof(BITMAP), &bmp);
  bm = CreateDIB(bmp.bmWidth, bmp.bmHeight, DIB_32B|DIB_TDN); if (!bm) return NULL;
  hdc = CreateIC("DISPLAY", NULL, NULL, NULL);
  GetDIBits(hdc, hbmp, 0, bmp.bmHeight, DIB_IMAGE(bm), DIB_BMI(bm), DIB_RGB_COLORS);
  DeleteDC(hdc);
  return bm;
}

HBITMAP WINAPI CreateDDBFromDIB(HDIB bm)
{ // foCXƗrbg}bvʕ\prbg}bv쐬
  HDC hdc;
  HBITMAP hbmp;

  hdc = CreateIC("DISPLAY", NULL, NULL, NULL);
  hbmp = CreateDIBitmap(hdc, DIB_INFO(bm), CBM_INIT, DIB_IMAGE(bm), DIB_BMI(bm), DIB_RGB_COLORS);
  DeleteDC(hdc);
  return hbmp;
}

BOOL WINAPI DrawDIB(HDC hdc, PRECT pr, HDIB bm, int fmt)
{ // rbg}bv̕`
  int xd, yd, wd, hd, ws, hs, wt, ht, re;
  HDIB bx;
  HRGN hrgn;
  RECT rct;

  if (fmt & DT_GRY) {
    bx = DuplicateDIB(bm); if (!bx) return FALSE;
    ChangeDIBColor(bx, fc1pGRY, BGR2RGB(AppColor(CID_3DF)));
    re = DrawDIB(hdc, pr, bx, fmt &~DT_GRY);
    DeleteDIB(bx);
    return re;
  }
  ws = DIB_WIDTH(bm);
  hs = abs(DIB_HEIGHT(bm));
  xd = pr->lft;
  yd = pr->top;
  wd = pr->rgt - pr->lft; if (wd <= 0) return FALSE;
  hd = pr->btm - pr->top; if (hd <= 0) return FALSE;
  switch (fmt & (DT_AJW|DT_AJH)) {
  case 0:
    if (fmt & DT_RGT) xd += (wd - ws);  else if (fmt & DT_CEN) xd += (wd - ws) / 2;
    if (fmt & DT_BTM) yd += (hd - hs);  else if (DTisMID(fmt)) yd += (hd - hs) / 2;
    wd = ws;
    hd = hs;
    break;
  case DT_AJH:
    wt = hd * ws / hs;
    if (fmt & DT_RGT) xd += (wd - wt);  else if (fmt & DT_CEN) xd += (wd - wt) / 2;
    wd = wt;
    break;
  case DT_AJW:
    ht = wd * hs / ws;
    if (fmt & DT_BTM) yd += (hd - ht);  else if (DTisMID(fmt)) yd += (hd - ht) / 2;
    hd = ht;
    break;
  }
  if (fmt & DT_CAL) {
    SetRect(&rct, xd, yd, xd + wd, yd + hd);
    if (fmt & DT_CLP) IntersectRect(&rct, pr, &rct);
    CopyRect(pr, &rct);
    return TRUE;
  }
  if (fmt & DT_CLP) {
    SelectClipRgn(hdc, hrgn = CreateRectRgnIndirect(pr));
  }
  re = StretchDIBits(hdc, xd, yd, wd, hd, 0, 0, ws, hs, DIB_IMAGE(bm), DIB_BMI(bm), DIB_RGB_COLORS, SRCCOPY) > 0;
  if (fmt & DT_CLP) {
    SelectClipRgn(hdc, NULL); DeleteObject(hrgn);
  }
  return re;
}

BOOL WINAPI DrawDDB(HDC hdc, PRECT pr, HBITMAP hbmp, int fmt)
{ // rbg}bv̕`
  int re;
  HDIB bm;

  bm = CreateDIBFromDDB(hbmp); if (!bm) return FALSE;
  re = DrawDIB(hdc, pr, bm, fmt);
  DeleteDIB(bm);
  return re;
}

// ---------------------------------------------------------------------- //

typedef struct {
  BYTE  R;
  BYTE  G;
  BYTE  B;
  BYTE  A;
} PALI;
typedef PALI * PPALI;
  // ̃pbg
static PALI PAL[] = {
  { 0x00, 0x00, 0x00, 'K' }, { 0x00, 0x00, 0xff, 'B' }, { 0xff, 0x00, 0x00, 'R' }, { 0xff, 0x00, 0xff, 'F' },
  { 0x00, 0xff, 0x00, 'L' }, { 0x00, 0xff, 0xff, 'A' }, { 0xff, 0xff, 0x00, 'Y' }, { 0xff, 0xff, 0xff, 'W' },
  { 0xa0, 0xa0, 0xa0, 's' }, { 0x00, 0x00, 0xc0, 'b' }, { 0xc0, 0x00, 0x00, 'r' }, { 0xc0, 0x00, 0xc0, 'f' },
  { 0x00, 0xc0, 0x00, 'l' }, { 0x00, 0xc0, 0xc0, 'a' }, { 0xc0, 0xc0, 0x00, 'y' }, { 0xf0, 0xf0, 0xf0, ' ' },
  { 0x69, 0x69, 0x69, 'D' }, { 0x00, 0x00, 0x80, 'N' }, { 0x80, 0x00, 0x00, 'M' }, { 0x80, 0x00, 0x80, 'P' },
  { 0x00, 0x80, 0x00, 'G' }, { 0x00, 0x80, 0x80, 'T' }, { 0x80, 0x80, 0x00, 'O' }, { 0xff, 0xff, 0xff, 'H' },
  { 0xd0, 0xff, 0xe0, 'd' }, { 0x00, 0x00, 0x40, 'n' }, { 0x40, 0x00, 0x00, 'm' }, { 0x40, 0x00, 0x40, 'p' },
  { 0x00, 0x40, 0x00, 'g' }, { 0x00, 0x40, 0x40, 't' }, { 0x40, 0x40, 0x00, 'o' }, { 0xd0, 0xd0, 0xd0, 'h' },
  { 0x00, 0x78, 0xd7, 'E' }, { 0xc0, 0xd0, 0xff, 'U' }, { 0xff, 0xc0, 0xd0, 'I' }, { 0xff, 0xd0, 0xff, 'V' },
  { 0xd0, 0xff, 0xd0, 'J' }, { 0xd0, 0xff, 0xff, 'C' }, { 0xff, 0xff, 0xd0, 'Z' }, { 0xff, 0xe0, 0xc0, 'Q' },
  { 0xff, 0xff, 0xff, 'e' }, { 0x90, 0xa0, 0xff, 'u' }, { 0xff, 0x90, 0xa0, 'i' }, { 0xff, 0xa0, 0xff, 'v' },
  { 0xa0, 0xff, 0xa0, 'j' }, { 0xa0, 0xff, 0xff, 'c' }, { 0xff, 0xff, 0xa0, 'z' }, { 0xff, 0xb0, 0x90, 'q' },
  { 0xe3, 0xe3, 0xe3, 'S' }, { 0x00, 0x00, 0x00, '0' }, { 0x20, 0x20, 0x20, '1' }, { 0x40, 0x40, 0x40, '!' },
  { 0x50, 0x50, 0x50, '2' }, { 0x60, 0x60, 0x60, '#' }, { 0x70, 0x70, 0x70, '3' }, { 0x80, 0x80, 0x80, '$' },
  { 0x90, 0x90, 0x90, '4' }, { 0xa0, 0xa0, 0xa0, '%' }, { 0xb0, 0xb0, 0xb0, '5' }, { 0xc0, 0xc0, 0xc0, '6' },
  { 0xd0, 0xd0, 0xd0, '7' }, { 0xe0, 0xe0, 0xe0, '8' }, { 0xf0, 0xf0, 0xf0, '9' }, { 0xff, 0xff, 0xff, 'w' },
};

  // ynh
static HPEN PEN[NELEM(PAL)];
  // uVnh
static HBRUSH BRS[NELEM(PAL)];

int  WINAPI NAppColors(void)
{ // ̃pbg̐F
  return NELEM(PAL);
}

void WINAPI SetAppColor(int cid, BGRC col)
{ // pbgFݒ
  int bk;

  if ((UINT)cid >= NELEM(PAL)) { ierr(E_CAP); return;}
  bk = *(BGRC *)&PAL[cid];
  *(BGRC *)&PAL[cid] = (bk & 0xff000000) | (col & 0xffffff);
  if (PEN[cid]) { DeleteObject(PEN[cid]); PEN[cid] = NULL;}
  if (BRS[cid]) { DeleteObject(BRS[cid]); BRS[cid] = NULL;}
}

BGRC WINAPI AppColor(int cid)
{ // F(COLORREF)
  if ((UINT)cid >= NELEM(PAL)) return 0;
  return *(BGRC *)&PAL[cid] & 0xffffff;
}

char WINAPI AppColorChar(int cid)
{ // F\
  if ((UINT)cid >= NELEM(PAL)) return '*';
  return PAL[cid].A;
}

int  WINAPI AppColorIndex(char ch)
{ // \F̃CfbNX
  int i;

  for (i = 0; i < NELEM(PAL); i++) {
    if (PAL[i].A == ch) return i;
  }
  return 0;
}

int  WINAPI NearestAppColorIndex(BGRC col)
{ // ł߂F̃CfbNX
  int i, k, d, f;

  k = 0; f = 255;
  for (i = 0; i < NELEM(PAL); i++) {
    d = fc2bEUC((RGBC)col, *(RGBC *)&PAL[i] & 0xffffff);
    if (d < f) { k = i; f = d;}
  }
  return k;
}

HDIB WINAPI CreateDIBFromSTR(int w, int h, const char bi[])
{ // zɂfoCXƗrbg}bv̍쐬
  int i, j;
  RGBC *qd;
  HDIB bm;

  bm = CreateDIB(w, h, DIB_32B|DIB_TDN); if (!bm) return NULL;
  if (bi) {
    qd = (RGBC *)DIB_IMAGE(bm);
    for (i = 0; i < w * h; i++) {
      for (j = 0; j < NELEM(PAL); j++) {
        if (PAL[j].A == bi[i]) goto _L1;
      }
      j = 0;
     _L1:
      qd[i] = BGR2RGB(*(BGRC *)&PAL[j] & 0xffffff);
    }
  }
  return bm;
}

HBITMAP WINAPI CreateDDBFromSTR(int w, int h, const char bi[])
{ // zɂʕ\prbg}bv̍쐬
  HDIB bm;
  HBITMAP hbmp;

  bm = CreateDIBFromSTR(w, h, bi); if (!bm) return NULL;
  hbmp = CreateDDBFromDIB(bm);
  DeleteDIB(bm);
  return hbmp;
}

HPEN WINAPI AppPen(int cid)
{ // y
  if ((UINT)cid >= NELEM(PEN)) return PEN[0];
  if (!PEN[cid]) PEN[cid] = CreatePen(PS_SOLID, 0, AppColor(cid));
  return PEN[cid];
}

HBRUSH WINAPI AppBrush(int cid)
{ // uV
  if ((UINT)cid >= NELEM(BRS)) return BRS[0];
  if (!BRS[cid]) BRS[cid] = CreateSolidBrush(AppColor(cid));
  return BRS[cid];
}

PLOGFONT WINAPI SetLOGFONT(PLOGFONT lf, PCSTR face, int ch, int flg)
{ // _tHg̐ݒ
  lf->lfHeight = -ch;
  lf->lfWidth = 0;
  lf->lfEscapement = ((flg & TFF_VRT) != 0) * -900;
  lf->lfOrientation = lf->lfEscapement;
  lf->lfWeight = ((flg & 0x00f0) >> 4) * 100;
  lf->lfItalic = ((flg & TFF_ITA) != 0);
  lf->lfUnderline = ((flg & TFF_UND) != 0);
  lf->lfStrikeOut = ((flg & TFF_STO) != 0);
  lf->lfCharSet = DEFAULT_CHARSET;
  lf->lfOutPrecision = 0;
  lf->lfClipPrecision = 0;
  lf->lfQuality = 0;
  lf->lfPitchAndFamily = 0;
  strcpyx(lf->lfFaceName, face? face: "", sizeof(lf->lfFaceName) - 1);
  return lf;
}

void WINAPI GetTextSize(PSIZE sz, HDC hdc, PCLOGFONT lf, PCSTR st, int cb)
{ // ̃TCY擾
  int sw = FALSE;
  HFONT hfnt;

  if (!hdc) {
    hdc = CreateIC("DISPLAY", NULL, NULL, NULL);
    sw = TRUE;
  }
  if (lf) hfnt = SelectObject(hdc, CreateFontIndirect(lf));
  GetTextExtentPoint32(hdc, st, (cb > 0)? cb: strlen(st), sz);
  if (lf) DeleteObject(SelectObject(hdc, hfnt));
  if (sw) DeleteDC(hdc);
}

#define  AVESTR  "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"

#define  AVEWID(cx)  (((cx) / 26 + 1) / 2)

void WINAPI GetAveCharSize(PSIZE sz, HDC hdc, PCLOGFONT lf)
{ // ϕTCY擾
  SIZE siz;

  GetTextSize(&siz, hdc, lf, AVESTR, -1);
  sz->cx = AVEWID(siz.cx);
  sz->cy = siz.cy;
}

void WINAPI GetZenCharSize(PSIZE sz, HDC hdc, PCLOGFONT lf)
{ // SpTCY擾
  SIZE siz;

  GetTextSize(&siz, hdc, lf, "", -1);
  sz->cx = siz.cx / 2;
  sz->cy = siz.cy;
}

  // tHgnh
static HFONT FNT[64];

int  WINAPI NAppFonts(void)
{ // ̃tHg̐
  return NELEM(FNT);
}

void WINAPI SetAppFont(int fid, HFONT hfnt)
{ // tHg̓o^
  if ((UINT)fid >= NELEM(FNT)) { ierr(E_CAP); return;}
  if (FNT[fid]) DeleteObject(FNT[fid]);
  FNT[fid] = hfnt;
}

HFONT WINAPI AppFont(int fid)
{ // tHg
  if ((UINT)fid >= NELEM(FNT) || !FNT[fid]) return FNT[0];
  return FNT[fid];
}

  // ʕ\prbg}bvnh
static HBITMAP BMP[64];

int  WINAPI NAppDDBs(void)
{ // ̉ʕ\prbg}bv̐
  return NELEM(BMP);
}

void WINAPI SetAppDDB(int bid, HBITMAP hbmp)
{ // ʕ\prbg}bv̓o^
  if ((UINT)bid >= NELEM(BMP)) { ierr(E_CAP); return;}
  if (BMP[bid]) DeleteObject(BMP[bid]);
  BMP[bid] = hbmp;
}

HBITMAP WINAPI AppDDB(int bid)
{ // ʕ\prbg}bv
  if ((UINT)bid >= NELEM(BMP) || !BMP[bid]) return BMP[0];
  return BMP[bid];
}

typedef struct {
  int   idm;
  HBITMAP hbmp;
} CBMI;
  // j[prbg}bv
static CBMI CBI[64];

void WINAPI SetMenuItemDDB(int idm, HBITMAP hbmp)
{ // j[prbg}bv̐ݒ
  int i;

  for (i = 0; i < NELEM(CBI); i++) {
    if (CBI[i].idm == idm) { CBI[i].hbmp = hbmp; return;}
  }
  for (i = 0; i < NELEM(CBI); i++) {
    if (CBI[i].idm == 0) { CBI[i].idm = idm; CBI[i].hbmp = hbmp; return;}
  }
  ierr(E_CAP);
}

HBITMAP WINAPI MenuItemDDB(int idm)
{ // j[prbg}bv
  int i;

  for (i = 0; i < NELEM(CBI); i++) {
    if (CBI[i].idm == idm) return CBI[i].hbmp;
  }
  return NULL;
}

  // 16x16rbg}bvC[W
static char MBI[][MNUBMPW * MNUBMPH] = {
  //  0 BLANK
    "                " "                " "                " "                "
    "                " "                " "                " "                "
    "                " "                " "                " "                "
    "                " "                " "                " "                "
  ,
  //  1 NEW
    "                " "  $$$$$$$$$5    " "  $wwwwwww$!5   " "  $wwwwwww$9!5  "
    "  $wwwwwww$!!!  " "  $wwwwwww888!  " "  $wwwwwwwww8!  " "  $wwwwwwmmm8!  "
    "  $wwwwwwmQm8!  " "  $wwwwwwmQm8!  " "  $wwwwwwmQmmm  " "  $wwwwwmqQqqqm "
    "  $wwwwwmQQQQQQm" "  $wwwwwmQQQQQQm" "  $98888mQQQQQQm" "  $!!!!!!mQQQQm "
  ,
  //  2 OPEN
    "                " "                " "                " "OOOOOO5         "
    "OYYYYyO5        " "OYYYYYyOOOOOO   " "OYYYYYYYYYYY!   " "OYYYOOOOOOOOOOOO"
    "OYYyOYYYYYYYYYy!" "OYYOYYYYYYYYYY!5" "OYyOYYYYYYYYYy! " "OYOYYYYYYYYYY!5 "
    "OyOYYYYYYYYYy!  " "OOYYYYYYYYYY!5  " "O!!!!!!!!!!!!   " "                "
  ,
  //  3 CLOSE
    "                " "                " "                " "   15      51   "
    "   505    505   " "    505  505    " "     505505     " "      5005      "
    "      5005      " "     505505     " "    505  505    " "   505    505   "
    "   15      51   " "                " "                " "                "
  ,
  //  4 SAVE
    "                " " ####333333###u " " #uuu666666uuu# " " #uuu6666!6uuu! "
    " #uuu6666!6uuu! " " #uuu666666uuu! " " #uuuuuuuuuuuu! " " #uu########uu! "
    " #u#wwwwwwww#u! " " #u#wwwwwwww#u! " " #u#wwwwwwww#u! " " #u#wwwwwwww#u! "
    " #!#wwwwwwww#u! " " #u#wwwwwwww#u! " " #!!########!!! " "                "
  ,
  //  5 SAVEAS
    "                " " ####333333###u " " #uuu666666uuu# " " #uuu6666!6uuu! "
    " #uuu6666!6uuu! " " #uuu666666uuu! " " #uuuuuuuuuuuu! " " #uu#####mmmuu! "
    " #u#wwwwwmQm#u! " " #u#wwwwwmQm#u! " " #u#wwwwwmQmmm! " " #u#wwwwmqQqqqm "
    " #!#wwwwmQQQQQQm" " #u#wwwwmQQQQQQm" " #!!####mQQQQQQm" "         mQQQQm "
  ,
  //  6 PRINT
    "    %%%%%%%%    " "    %9999994    " "    %9999994    " "    %wwwwww4    "
    "    %wwwwww4    " " 53$$$$$$$$$$34 " "%37$$$$$$$$$$73$" "377##########77!"
    "366222222222266!" "35522222222225j!" "344888888888844!" "39914%#$22%$199!"
    "4!!0%wB83Tw40!!#" "    %wB5!Nw4    " "    %wwwwww4    " "    %4444444    "
  ,
  //  7 SETUP
    "                " "0  00000000000  " "                " "                "
    "0  00000000000  " "                " "                " "0  000000mmm00  "
    "         mQm    " "         mQm    " "0  000000mQm00  " "        mqQqqqm "
    "        mQQQQQQm" "        mQQQQQQm" "        mQQQQQQm" "         mQQQQm "
  ,
  //  8 CUT
    "   746    647   " "   6$4    4$6   " "   6$$6  6$$6   " "    5$$  $$5    "
    "     4$66$4     " "     5$$$$5     " "      4$$4      " "      5$#5      "
    "      63#6      " "     BB##BB     " "   ubBBBBBBbu   " "  BBBBBuuBBBBB  "
    " uB  Bb  bB  Bu " " uB uBu  uB uBu " "  BBBB    BBBB  " "                "
  ,
  //  9 COPY
    "                " " $$$$$$5        " " $wwww$!5       " " $wwww$9!5      "
    " $w%%7$NNNNNN5  " " $wwwwwNwwwwNn5 " " $w%%%%NwwwwN9n5" " $wwwwwNwuuUNnnn"
    " $w%%%%Nwwwwwwwn" " $wwwwwNwuuuuuwn" " $!!!!!Nwwwwwwwn" "       Nwuuuuuwn"
    "       Nwwwwwwwn" "       Nnnnnnnnn" "                " "                "
  ,
  // 10 PASTE
    "                " "     !11!       " " OOOO1OO1OOOO   " "Oyyy17!!71yyy!  "
    "Oyy17777771yy!  " "Oyy!111111!yy!  " "Oyyyyyyyyyyyy!  " "OyyyyyNNNNNNN!  "
    "OyyyyyNwwwwwNn5 " "OyyyyyNwwwwwN9n5" "OyyyyyNwuuuUNnnn" "OyyyyyNwwwwwwwwn"
    "OyyyyyNwuuuuuuwn" " !!!!!Nwwwwwwwwn" "      Nnnnnnnnnn" "                "
  ,
  // 11 SEARCH
    "                " "   !!!   !!!    " "   !$0   !$0    " "  !!!!! !!!!!   "
    "  !w430 !w430   " " !!!!!01!!!!!!  " " !%w4301!%w430  " " !%w430 !%w430  "
    "!!!!!0111!!!!!! " "!%w430   !%w430 " "!%w430   !%w430 " "!%w430   !%w430 "
    "!%w430   !%w430 " "!00000   !00000 " "                " "                "
  ,
  // 12 SORT
    "                " "             0  " "  NNN        0  " " NN NN       0  "
    "NN   NN      0  " "NNNNNNN      0  " "NN   NN      0  " "NN   NN      0  "
    "             0  " "MMMMMMM      0  " "    MM       0  " "   MM        0  "
    "  MM       05050" " MM         000 " "MMMMMMM      0  " "                "
  ,
  // 13 FILTER
    "                " "                " " !!!###!!!!!!!! " " !5788875555550 "
    "  !57887555550  " "   !578855550   " "    !5785550    " "     !68550     "
    "      !850      " "      !850      " "      !850      " "      !850      "
    "      !850      " "      !850      " "      !000      " "                "
  ,
  // 14 SUMMARY
    "                " "                " "   00000000000  " "   5005     50  "
    "    5005        " "     5005       " "      5005      " "       500      "
    "      5005      " "     5005       " "    5005        " "   5005     50  "
    "   00000000000  " "                " "                " "                "
  ,
  // 15 CHECK
    "                " "                " "              II" "             IMI"
    "            IMMI" "           IMMI " "          IMMI  " "  I      IMMI   "
    " IMI    IMMI    " "IMMMI  IMMI     " " IMMMIIMMI      " "  IMMMMMI       "
    "   IMMMI        " "    IMI         " "     I          " "                "
  ,
  // 16 PREV
    "                " "       44       " "      4nn4      " "     4nBBn4     "
    "    4nBBBBn4    " "   4nBBBBBBn4   " "  4nBBBBBBBBn4  " " 40000BBBB00004 "
    "     0BBBB0     " "     0BBBB0     " "     0BBBB0     " "     0BBBB0     "
    "     0BBBB0     " "     000000     " "                " "                "
  ,
  // 17 NEXT
    "                " "                " "     000000     " "     0BBBB0     "
    "     0BBBB0     " "     0BBBB0     " "     0BBBB0     " "     0BBBB0     "
    " 40000BBBB00004 " "  4nBBBBBBBBn4  " "   4nBBBBBBn4   " "    4nBBBBn4    "
    "     4nBBn4     " "      4nn4      " "       44       " "                "
  ,
  // 18 INVERT
    "                " "    bb          " "    BB      70  " "  bBBBBb   707  "
    "  bBBBBb  707   " "    BB   707    " "    bb  707     " "       707      "
    "      707       " "     707        " "    707         " "   707  bBBBBb  "
    "  707   bBBBBb  " "  07            " "                " "                "
  ,
  // 19 ZOOMIN
    "   5!11!5       " "  !4    4!      " " !7      7!     " "54   bb   45    "
    "!    BB    !    " "1  bBBBBb  1    " "1  bBBBBb  1    " "!    BB    !    "
    "54   bb   45    " " !7      7!     " "  !4    4!13    " "   5!11!5 303   "
    "           303  " "            303 " "             303" "              36"
  ,
  // 20 ZOOMOUT
    "   5!11!5       " "  !4    4!      " " !7      7!     " "54        45    "
    "!          !    " "1  bBBBBb  1    " "1  bBBBBb  1    " "!          !    "
    "54        45    " " !7      7!     " "  !4    4!13    " "   5!11!5 303   "
    "           303  " "            303 " "             303" "              36"
  ,
  // 21 SAME
    "   5!11!5       " "  !4wwww4!      " " !7wwwwww7!     " "54wwwwwwww45    "
    "!ww000000ww!    " "1wwwwwwwwww1    " "1wwwwwwwwww1    " "!ww000000ww!    "
    "54wwwwwwww45    " " !7wwwwww7!     " "  !4wwww4!13    " "   5!11!5 303   "
    "           303  " "            303 " "             303" "              36"
  ,
  // 22 WHOLE
    "                " " 00000000000000 " " 0wwwww55wwwww0 " " 0wwww0ww0wwww0 "
    " 0wwwwwwwwwwww0 " " 0wwwwwwwwwwww0 " " 0w0wwwwwwww0w0 " " 05wwwwwwwwww50 "
    " 05wwwwwwwwww50 " " 0w0wwwwwwww0w0 " " 0wwwwwwwwwwww0 " " 0wwwwwwwwwwww0 "
    " 0wwww0ww0wwww0 " " 0wwwww55wwwww0 " " 00000000000000 " "                "
  ,
  // 23 PREVWIN
    "      8!8       " "     817        " "    817         " "   817          "
    "  817           " " 817            " "817             " "100000000000001 "
    "817             " " 817            " "  817           " "   817          "
    "    817         " "     817        " "      8!8       " "                "
  ,
  // 24 NEXTWIN
    "      8!8       " "       718      " "        718     " "         718    "
    "          718   " "           718  " "            718 " "100000000000001 "
    "            718 " "           718  " "          718   " "         718    "
    "        718     " "       718      " "      8!8       " "                "
  ,
  // 25 VIEW
    "                " "wwwwwwwwwww  0  " "w0000000000  0  " "w0AA0ww0www  0  "
    "w00000000ww  0  " "w0ww0ww0www  0  " "w0ww0wwwwww  0  " "w!!##!!!!!w  0  "
    "w!57875550w  0  " "  !577550    0  " "   !6750     0  " "    !60      0  "
    "    !60    05050" "    !60     000 " "    !00      0  " "                "
  ,
  // 26 ARRANGE
    "                " "                " "wwwwwwwwwwwwwwww" "w000000000000000"
    "w0AAAA0wwww0wwww" "w0AAAA0wwww0wwww" "w000000000000www" "w0wwww0wwww0wwww"
    "w0wwww0wwwwwwwww" "w0wwww0wwwwwwwww" "w0wwww0wwwwwwwww" "w0wwwwwwwwwwwwww"
    "w0wwwwwwwwwwwwww" "w0wwwwwwwwwwwwww" "                " "                "
  ,
  // 27 EDIT
    "  !             " "  !!!!!!!!!!!!!!" "  !             " "  !             "
    "  00000000000000" "  0AAAAAAAAAAAAA" "  0AAAAAAAAAAAAA" "  0000000mmm0000"
    "  !      mQm    " "  !      mQm    " "  !!!!!!!mQmmm!!" "  !     mqQqqqm "
    "  !     mQQQQQQm" "  !!!!!!mQQQQQQm" "  !     mQQQQQQm" "  !      mQQQQm "
  ,
  // 28 ADD
    "  !             " "  !!!!!!!!!!!!!!" "  !             " "  !             "
    "  !!!!!!!!!!!!!!" "  !             " "  !      r      " "  !!!!!!rRr!!!!!"
    "  !    rRiRr    " "  !   rRiiiRr   " "  !!!rrrrirrrr!!" "        rir     "
    "00000000rir000  " "AAAAAAAArrrAA0  " "AAAAAAAAAAAAA0  " "00000000000000  "
  ,
  // 29 INSERT
    "  !             " "  !!!!!!!!!!!!!!" "  !             " "  !             "
    "  !!!!!!!!!!!!!!" "                " "0000000r000000  " "AAAAAAArrAAAA0  "
    "AAAAAAArRrAAA0  " "0000rrrriRr000  " "    riiiiiRr    " "  !!rrrriRr!!!!!"
    "  !    rRr      " "  !    rr       " "  !!!!!r!!!!!!!!" "  !             "
  ,
  // 30 DELETE
    "  !             " "  !!!!!!!!!!!!!!" "  ! rR    Rr    " "  ! RrR  RrR    "
    "  000RrRRrR00000" "  0AAARrrRAAAAAA" "  0AAARrrRAAAAAA" "  000RrRRrR00000"
    "  ! RrR  RrR    " "  ! rR    Rr    " "  !!!!!!!!!!!!!!" "  !             "
    "  !             " "  !!!!!!!!!!!!!!" "  !             " "  !             "
  ,
  // 31 COMPILE
    "                " "     000000     " "     0BBBB0     " "     0BBBB0     "
    "     0BBBB0     " "     0BBBB0     " "  4000BBBB0004  " "   4nBBBBBBn4   "
    "    4nBBBBn4    " "$$$$$$nBBn$$$$$!" "$wwwww%nn%wwwww!" "$wwwwww%%wwwwww!"
    "$wwwwwwwwwwwwww!" "$wwwwwwwwwwwwww!" "$!!!!!!!!!!!!!!!" "                "
};

  // 32x32rbg}bvC[W
static char OBI[][MNDBMPW * MNDBMPH] = {
  //  0 DUMMY
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                " "                                "
    "                                " "                                "
  ,
  //  1 INPUT
    "    $$$$$$$$$$$$$$$$$$$         " "    $wwwwwwwwwwwwwwwww$0        " "    $wwwwwwwwwwwwwwwww$$0       "
    "    $wwwwwwwwwwwwwwwww$6$0      " "    $wwwwwwwwYwwwwwwww$w6$0     " "    $wwwwwwwwqwwwwwwww$ww6$0    "
    "    $wwwYwwwwYwwwwYwww$000000   " "    $wwwwqwwzqzwwqwwwwwwwww60   " "    $wwwwwqzqYqzqwwwwwwwwww60   "
    "    $wwwwwzqYqYqzwwwwwwwwww60   " "    $wwwwzqYmmqYqzwwwwwwwww60   " "    $wYqYqYmQQmqYqYqYwwwwww60   "
    "    $wwwwzqmQQmYqzwwwwwwwww60   " "    $wwwwwzmQQmqzwwwwwwwwww60   " "    $wwwwwqmQQmzqwwwwwwwwww60   "
    "    $wwwwqwmQQmmmqwwwwwwwww60   " "    $wwwYwwmQQmQQmmmwwwwwww60   " "    $wwwwwwmQQmQQmQQmmwwwww60   "
    "    $wwwwwwmQQmQQmQQmQmwwww60   " "    $wwmmmwmQQmQQmQQmQQmwww60   " "    $wwmQQmmQQQQQQQQmQQmwww60   "
    "    $wwmQQQmQQQQQQQQQQQmwww60   " "    $wwwmQQmQQQQQQQQQQQmwww60   " "    $wwwwmQmQQQQQQQQQQQmwww60   "
    "    $wwwwmQQQQQQQQQQQQQmwww60   " "    $wwwwwmQQQQQQQQQQQQmwww60   " "    $wwwwwmQQQQQQQQQQQmwwww60   "
    "    $wwwwwwmQQQQQQQQQQmwwww60   " "    $wwwwwwmQQQQQQQQQQmwwww60   " "    $wwwwwwwmQQQQQQQQmwwwww60   "
    "    $6666666mQQQQQQQQm6666660   " "    00000000mQQQQQQQQm0000000   "
  ,
  //  2 TABLE
    "    $$$$$$$$$$$$$$$$$$$         " "    $wwwwwwwwwwwwwwwww$0        " "    $wwwwwwwwwwwwwwwww$$0       "
    "    $wwwwwwwwwwwwwwwww$6$0      " "    $wwwwwwwwwwwwwwwww$w6$0     " "    $wwwwwwwwwwwwwwwww$ww6$0    "
    "    $wwwwwwwwwwwwwwwww$000000   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   "
    "    $wwbbbbbbbbbbbbbbbbbbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   "
    "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   "
    "    $wwbbbbbbbbbbbbbbbbbbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   "
    "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   "
    "    $wwbbbbbbbbbbbbbbbbbbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   "
    "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   " "    $wwbwwwwwwwbwwwwwwwwbww60   "
    "    $wwbbbbbbbbbbbbbbbbbbww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   "
    "    $666666666666666666666660   " "    0000000000000000000000000   "
  ,
  //  3 EXECUTE
    "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" "%wwwwwwwwwwwwwwwwwwwwwwwwwwwwww%" "%wwwwwwwwwwwwwwwwwwwwwwwwwwwwww%"
    "%wwwwwwwwwwwwwwwwww%%%wwwwwwwww%" "%wwwwwwwwwwwwwwwww%ww9owwwwwwww%" "%wwwwwwwwwwwwwwyy%%9%%o%y%wwwww%"
    "%wwwwwwwwwwwwwywYY%w9%oywYowwww%" "%wwwwwwwwwwwwwoyww%w%%owYyowwww%" "%wwwwwwwwwwwyyyyw%%w9%o%Y9oowww%"
    "%wwwwwwwwwwwywywY%%w%%oywYwYoww%" "%wwwwwwwwwwwoyyywYooooo9Yoyyoww%" "%wwwwwwwwwwwoyyoywwYYwYYyoyyoww%"
    "%wwwwwwwwwww%ooYYoyy9yoyw9oo9ww%" "%wwwwwwwwwwwwwyYoyyywoYyyyowwww%" "%wwwwwwwwwwwwwyYoyoyyoooyyowwww%"
    "%wwwwwwwww%%%w9oo9woYow9oowwwww%" "%wwwwwwww%ww9owwwwwooowwwwwwwww%" "%wwwwwyy%%9%%o%y%wwwwwwwwwwwwww%"
    "%wwwwywYY%w9%oywYowwwwwwwwwwwww%" "%wwwwoyww%w%%owYyowwwwwwwwwwwww%" "%wwyyyyw%%w9%o%Y9oowwwwwwwwwwww%"
    "%wwywywY%%w%%oywYwYowwwwwwwwwww%" "%wwoyyywYooooo9Yoyyowwwwwwwwwww%" "%wwoyyoywwYYwYYyoyyowwwwwwwwwww%"
    "%ww%ooYYoyy9yoyw9oo9wwwwwwwwwww%" "%wwwwyYoyyywoYyyyowwwwwwwwwwwww%" "%wwwwyYoyoyyoooyyowwwwwwwwwwwww%"
    "%wwww9oo9woYow9oowwwwwwwwwwwwww%" "%wwwwwwwwwooowwwwwwwwwwwwwwwwww%" "%wwwwwwwwwwwwwwwwwwwwwwwwwwwwww%"
    "%wwwwwwwwwwwwwwwwwwwwwwwwwwwwww%" "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
  ,
  //  4 REPORT
    "              3333              " "            33333333            " "       %%%%%%%%%%%%%%%%%%       "
    "       %wwwwwwwwwwwwwwww%       " "       %wwwwwwwwwwwwwwww%       " "       %wwwwwwwwwwwwwwww%       "
    "       %wwwwwwwwwwwwwwww%       " "       %wwwwwwwwwwwwwwww%       " "       %wwwwwwwwwwwwwwww%       "
    "       %wwwwwwwwwwwwwwww%       " "   5553%wwwwwwwwwwwwwwww%3555   " "   497$%9999999999999999%$794   "
    "   49%$344444444444444443$%94   " "  559$3$$$$$$$$$$$$$$$$$$3$955  " "  4883#222222222222222222#3884  "
    "  497#!!!!!!!!!!!!!!!!!!!!#794  " "  4972111111111111111111112794  " " 5597$#222222222222222222#$7955 "
    " 489987777777777777777777789984 " " 489999999999999999999999999984 " " 499999999999999999999999999994 "
    " 488888888888888888888888888884 " " 477777777777777777777777777774 " " 477777777777777777777777777774 "
    " 477775555555555555555555577774 " " 477757888888888888888888757774 " " 477758999999999999999999857774 "
    " 477758999999999999999999857774 " " 477758888888888888888888857774 " " 557757877777777777777778757755 "
    "  4444444444444444444444444444  " "                                "
  ,
  //  5 TEXT
    "    $$$$$$$$$$$$$$$$$$$         " "    $wwwwwwwwwwwwwwwww$0        " "    $wwwwwwwwwwwwwwwww$$0       "
    "    $wwwwwwwwwwwwwwwww$6$0      " "    $wwwwwwwwwwwwwwwww$w6$0     " "    $wwwwwwwwwwwwwwwww$ww6$0    "
    "    $wwwwwwwwwwwwwwwww$000000   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www000000000000wwwwwww60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www0000000000000000www60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www0000000000000000www60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www0000000000000000www60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www0000000000000000www60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www000000000000wwwwwww60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $www000000000000wwwwwww60   "
    "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   " "    $wwwwwwwwwwwwwwwwwwwwww60   "
    "    $666666666666666666666660   " "    0000000000000000000000000   "
  ,
  //  6 SYSTEM
    "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%"
    "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%"
    "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaCwwCaaaaaaaaaaaaaaaaaaaa%" "%aaaacwwwwwcaaaaaaaaaaaaaaaaaaa%"
    "%aaaCwwwwwwwaaaaaaaaaaaaaaaaaaa%" "%aacwwwwwwwwwaaaaaaaaaaaaaaaaaa%" "%aaaaaaawwwwwaaaaaaaaaaaaaaaaaa%"
    "%aaaaaaawwwwwwaaaaaaaaaaaaaaaaa%" "%aaaaaaawaatwwwaaaaaaaaaaaaaaaa%" "%aaaaaaawtaawwwwaaaaaaaaaaaaaaa%"
    "%aacwwwwwaatwwwwwaaaaaaaaaaaaaa%" "%aaaCwwwwtaawwwwwwwaaaaaaaaaaaa%" "%aaaacwwwwwwwwwwwwwwwaaaaaaaaaa%"
    "%aaaaacwwwaaaawwwwwwwwwaaaaaaaa%" "%aaaaaaaaaaaaaaawwwwwwwwwaaaaaa%" "%aaaaaaaaaaaaaaaaawwwwwwwwwcaaa%"
    "%aaaaaaaaaaaaaaaaaaawwwwwwCwCaa%" "%aaaaaaaaaaaaaaaaaaaaawwwCaCwaa%" "%aaaaaaaaaaaaaaaaaaaaaacwwCwCaa%"
    "%aaaaaaaaaaaaaaaaaaaaaaaaCwCaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%"
    "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%"
    "%aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa%" "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"
  ,
  //  7 EXIT
    "      RRRRRRRRRRRRRRRRRRRR      " "     RRRRRRRRRRRRRRRRRRRRRR     " "    RRRRRRRRRRRRRRRRRRRRRRRR    "
    "   RRRRRRRRRRRRRRRRRRRRRRRRRR   " "  RRRRRRRRRRRRRRRRRRRRRRRRRRRR  " " RRRRRRRRRRRRRRRRRRRRRRRRRRRRRR "
    "RRRRRRRiwiRRRRRRRRRRRRiwiRRRRRRR" "RRRRRRiwwwiRRRRRRRRRRiwwwiRRRRRR" "RRRRRiwwwwwiRRRRRRRRiwwwwwiRRRRR"
    "RRRRRRiwwwwwiRRRRRRiwwwwwiRRRRRR" "RRRRRRRiwwwwwiRRRRiwwwwwiRRRRRRR" "RRRRRRRRiwwwwwiRRiwwwwwiRRRRRRRR"
    "RRRRRRRRRiwwwwwiiwwwwwiRRRRRRRRR" "RRRRRRRRRRiwwwwwwwwwwiRRRRRRRRRR" "RRRRRRRRRRRiwwwwwwwwiRRRRRRRRRRR"
    "RRRRRRRRRRRRiwwwwwwiRRRRRRRRRRRR" "RRRRRRRRRRRRiwwwwwwiRRRRRRRRRRRR" "RRRRRRRRRRRiwwwwwwwwiRRRRRRRRRRR"
    "RRRRRRRRRRiwwwwwwwwwwiRRRRRRRRRR" "RRRRRRRRRiwwwwwiiwwwwwiRRRRRRRRR" "RRRRRRRRiwwwwwiRRiwwwwwiRRRRRRRR"
    "RRRRRRRiwwwwwiRRRRiwwwwwiRRRRRRR" "RRRRRRiwwwwwiRRRRRRiwwwwwiRRRRRR" "RRRRRiwwwwwiRRRRRRRRiwwwwwiRRRRR"
    "RRRRRRiwwwiRRRRRRRRRRiwwwiRRRRRR" "RRRRRRRiwiRRRRRRRRRRRRiwiRRRRRRR" " RRRRRRRRRRRRRRRRRRRRRRRRRRRRRR "
    "  RRRRRRRRRRRRRRRRRRRRRRRRRRRR  " "   RRRRRRRRRRRRRRRRRRRRRRRRRR   " "    RRRRRRRRRRRRRRRRRRRRRRRR    "
    "     RRRRRRRRRRRRRRRRRRRRRR     " "      RRRRRRRRRRRRRRRRRRRR      "
  ,
  //  8 BACK
    "      llllllllllllllllllll      " "     llllllllllllllllllllll     " "    llllllllllllllllllllllll    "
    "   llllllllllllllllllllllllll   " "  llllllllllllllllllllllllllll  " " llllllllllllllllllllllllllllll "
    "llllllllllllllllllllllllllllllll" "llllllllllllllwwwlllllllllllllll" "lllllllllllllwwwwlllllllllllllll"
    "llllllllllllwwwwwlllllllllllllll" "lllllllllllwwwwwllllllllllllllll" "llllllllllwwwwwlllllllllllllllll"
    "lllllllllwwwwwllllllllllllllllll" "llllllllwwwwwlllllllllllllllllll" "lllllllwwwwwwwwwwwwwwwwwwwllllll"
    "llllllwwwwwwwwwwwwwwwwwwwwllllll" "llllllwwwwwwwwwwwwwwwwwwwwllllll" "lllllllwwwwwwwwwwwwwwwwwwwllllll"
    "llllllllwwwwwlllllllllllllllllll" "lllllllllwwwwwllllllllllllllllll" "llllllllllwwwwwlllllllllllllllll"
    "lllllllllllwwwwwllllllllllllllll" "llllllllllllwwwwwlllllllllllllll" "lllllllllllllwwwwlllllllllllllll"
    "llllllllllllllwwwlllllllllllllll" "llllllllllllllllllllllllllllllll" " llllllllllllllllllllllllllllll "
    "  llllllllllllllllllllllllllll  " "   llllllllllllllllllllllllll   " "    llllllllllllllllllllllll    "
    "     llllllllllllllllllllll     " "      llllllllllllllllllll      "
};

static PCSTR SYSFACE = DLGFACE;
static int   SYSPTSZ = DLGPTSZ;
static PCSTR TMPFACE = DLGFACE;
static int   TMPPTSZ = DLGPTSZ;

void LOCALF InitGraphicObjects(void)
{ // GDIIuWFNg̍쐬
  int i;
  LOGFONT lof;
  OSVERSIONINFO osvi;

  SetAppColor(CID_TXT, GetSysColor(COLOR_WINDOWTEXT));
  SetAppColor(CID_WIN, GetSysColor(COLOR_WINDOW));
  SetAppColor(CID_3DS, GetSysColor(COLOR_3DSHADOW));
  SetAppColor(CID_3DF, GetSysColor(COLOR_3DFACE));
  SetAppColor(CID_3DD, GetSysColor(COLOR_3DDKSHADOW));
  SetAppColor(CID_3DH, GetSysColor(COLOR_3DHILIGHT));
  SetAppColor(CID_HIL, GetSysColor(COLOR_HIGHLIGHT));
  SetAppColor(CID_HIT, GetSysColor(COLOR_HIGHLIGHTTEXT));
  SetAppColor(CID_3DL, GetSysColor(COLOR_3DLIGHT));
  PEN[0] = CreatePen(PS_SOLID, 0, AppColor(0));
  BRS[0] = CreateSolidBrush(AppColor(0));
  osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
  GetVersionEx(&osvi);
  if      (osvi.dwMajorVersion >=10) SYSFACE = TMPFACE = "Yu Gothic UI";
  else if (osvi.dwMajorVersion >= 6) SYSFACE = TMPFACE = "Meiryo UI";
  SetAppFont(FID_DLG, CreateFontIndirect(SetLOGFONT(&lof, DLGFACE,     PT2DOTS(DLGPTSZ), 0)));
  SetAppFont(FID_SYS, CreateFontIndirect(SetLOGFONT(&lof, SYSFACE,     PT2DOTS(SYSPTSZ), 0)));
  SetAppFont(FID_DEF, CreateFontIndirect(SetLOGFONT(&lof, DEFFACE,     PT2DOTS(DEFPTSZ), 0)));
  SetAppFont(FID_MON, CreateFontIndirect(SetLOGFONT(&lof, MONFACE,     PT2DOTS(MONPTSZ), 0)));
  SetAppFont(FID_WEB, CreateFontIndirect(SetLOGFONT(&lof, "Webdings",  PT2DOTS(SYSPTSZ), 0)));
  SetAppFont(FID_WIN, CreateFontIndirect(SetLOGFONT(&lof, "WingDings", PT2DOTS(SYSPTSZ), 0)));
  for (i = 0; i < NELEM(MBI); i++) {
    SetAppDDB(BID_BLANK + i, CreateDDBFromSTR(MNUBMPW, MNUBMPH, MBI[i]));
  }
  for (i = 0; i < NELEM(OBI); i++) {
    SetAppDDB(BID_DUMMY + i, CreateDDBFromSTR(MNDBMPW, MNDBMPH, OBI[i]));
  }
}

void LOCALF TermGraphicObjects(void)
{ // GDIIuWFNg̍폜
  int i;

  for (i = 0; i < NELEM(PEN); i++) {
    if (PEN[i]) DeleteObject(PEN[i]);
  }
  for (i = 0; i < NELEM(BRS); i++) {
    if (BRS[i]) DeleteObject(BRS[i]);
  }
  for (i = 0; i < NELEM(FNT); i++) {
    if (FNT[i]) DeleteObject(FNT[i]);
  }
  for (i = 0; i < NELEM(BMP); i++) {
    if (BMP[i]) DeleteObject(BMP[i]);
  }
}

// ---------------------------------------------------------------------- //

  // ޔ̈
typedef struct {
  HPEN  hpen;
  HFONT hfnt;
  int   bkm;
  BGRC  tco;
  int   tal;
  int   tcx;
} CVSP;
typedef CVSP * PCVSP;

  // `ReLXg
typedef struct {
  HDC   hdc;
  int   dpi;
  REAL  Dx, Dy;
  REAL  Mx, My;
  int   xorg, yorg;
  int   xscl, yscl;
  int   lst;
  BGRC  lco;
  char  tfa[32];
  int   tcw, tch;
  int   tcd;
  int   tst;
  BGRC  tco;
  int   hcm, vcm;
  UINT  rsv;
  HDC   bak;
  HDC   hic;
  CVSP  org;
  CVSP  inf;
} CVSE;
typedef CVSE * PCVSE;

#define  hDC(cv)  (((PCVSE)cv)->hdc)
#define  hIC(cv)  (((PCVSE)cv)->hic)
#define  hBK(cv)  (((PCVSE)cv)->bak)

#define  iW(cv, w)  iround(fabs(((PCVSE)cv)->Mx) * (w))
#define  iH(cv, h)  iround(fabs(((PCVSE)cv)->My) * (h))
#define  iX(cv, x)  iround(((PCVSE)cv)->Mx * (x) + ((PCVSE)cv)->Dx)
#define  iY(cv, y)  iround(((PCVSE)cv)->My * (y) + ((PCVSE)cv)->Dy)

#define  rW(cv, w)  ((w) / fabs(((PCVSE)cv)->Mx))
#define  rH(cv, h)  ((h) / fabs(((PCVSE)cv)->My))
#define  rX(cv, x)  (((x) - ((PCVSE)cv)->Dx) / ((PCVSE)cv)->Mx)
#define  rY(cv, y)  (((y) - ((PCVSE)cv)->Dy) / ((PCVSE)cv)->My)

#define  PENSTY(cv)  ((((PCVSE)cv)->lst & 0x0f)? PS_SOLID: (((PCVSE)cv)->lst == 0)? PS_NULL: ((PCVSE)cv)->lst >> 4)
#define  PENWID(cv)  ((int)((((PCVSE)cv)->lst & 0x0f) * 0.1 * ((PCVSE)cv)->dpi / MMPI))
#define  PENCOL(cv)  ((PCVSE)cv)->lco)

PLOGFONT LOCALF canvaslof(PLOGFONT lf, PCVSE cv)
{ // _tHg
  SetLOGFONT(lf, cv->tfa, iH(cv, cv->tch * 0.001), cv->tst);
  lf->lfWidth = iW(cv, cv->tcw * 0.001);
  return lf;
}

void LOCALF saveparams(PCVSE cv)
{ // p[^ޔ
  LOGFONT lof;

  if (cv->hdc) {
    cv->org.bkm = SetBkMode(cv->hdc, TRANSPARENT);
    cv->org.tco = SetTextColor(cv->hdc, cv->tco);
    cv->org.tal = SetTextAlign(cv->hdc, TA_LEFT|TA_TOP|TA_NOUPDATECP);
    cv->org.tcx = SetTextCharacterExtra(cv->hdc, iW(cv, cv->tcd * 0.001));
    cv->org.hpen = SelectObject(cv->hdc, CreatePen(PENSTY(cv), PENWID(cv), cv->lco));
    cv->org.hfnt = SelectObject(cv->hdc, CreateFontIndirect(canvaslof(&lof, cv)));
  }
  if (cv->hic) {
    cv->inf.tal = SetTextAlign(cv->hic, TA_LEFT|TA_TOP|TA_NOUPDATECP);
    cv->inf.tcx = SetTextCharacterExtra(cv->hic, iW(cv, cv->tcd * 0.001));
    cv->inf.hfnt = SelectObject(cv->hic, CreateFontIndirect(canvaslof(&lof, cv)));
  }
}

void LOCALF restoreparams(PCVSE cv)
{ // p[^A
  if (cv->hdc) {
    DeleteObject(SelectObject(cv->hdc, cv->org.hfnt));
    DeleteObject(SelectObject(cv->hdc, cv->org.hpen));
    SetTextCharacterExtra(cv->hdc, cv->org.tcx);
    SetTextAlign(cv->hdc, cv->org.tal);
    SetTextColor(cv->hdc, cv->org.tco);
    SetBkMode(cv->hdc, cv->org.bkm);
  }
  if (cv->hic) {
    DeleteObject(SelectObject(cv->hdc, cv->inf.hfnt));
    SetTextCharacterExtra(cv->hdc, cv->inf.tcx);
    SetTextAlign(cv->hdc, cv->inf.tal);
  }
}

HCVS WINAPI CreateCanvas(HDC hdc, UINT xsz)
{ // `ReLXg̍쐬
  PCVSE cv;

  cv = halloc(sizeof(CVSE) + xsz, TRUE); if (!cv) return ierr(E_MEM);
  cv->hdc = hdc;
  cv->dpi = hdc? GetDeviceCaps(hdc, LOGPIXELSX): DEFDPI;
  cv->Mx = cv->My = cv->dpi / MMPI;
  cv->xscl = cv->yscl = 1000;
  cv->lst = LST_REG;
  strcpyx(cv->tfa, DEFFACE, sizeof(cv->tfa) - 1);
  cv->tch = iround(DEFPTSZ * MMPI * 1000.0 / PTPI);
  cv->hcm = cv->tch / 6;
  cv->hic = CreateIC("DISPLAY", NULL, NULL, NULL);
  saveparams(cv);
  return (HCVS)cv;
}

void WINAPI DeleteCanvas(HCVS cv)
{ // `ReLXg̍폜
  if (!cv) return;
  restoreparams((PCVSE)cv);
  DeleteDC(hIC(cv));
  hDC(cv) = NULL;
  hfree(cv);
}

HDC  WINAPI SetCanvasHDC(HCVS cv, HDC hdc, int dpi)
{ // foCXReLXg̐ݒ
  HDC pre = hDC(cv);

  restoreparams((PCVSE)cv);
  hDC(cv) = hdc;
  ((PCVSE)cv)->dpi = dpi? dpi: hdc? GetDeviceCaps(hdc, LOGPIXELSX): DEFDPI;
  ((PCVSE)cv)->Dx = ((PCVSE)cv)->xorg * 0.001 * ((PCVSE)cv)->dpi / MMPI;
  ((PCVSE)cv)->Dy = ((PCVSE)cv)->yorg * 0.001 * ((PCVSE)cv)->dpi / MMPI;
  ((PCVSE)cv)->Mx = ((PCVSE)cv)->xscl * 0.001 * ((PCVSE)cv)->dpi / MMPI;
  ((PCVSE)cv)->My = ((PCVSE)cv)->yscl * 0.001 * ((PCVSE)cv)->dpi / MMPI;
  saveparams((PCVSE)cv);
  return pre;
}

HDC  WINAPI CanvasHDC(HCVS cv)
{ // foCXReLXg
  return hDC(cv);
}

HDC  WINAPI CanvasHIC(HCVS cv)
{ // ReLXg
  return hIC(cv);
}

BOOL WINAPI EnableCanvas(HCVS cv)
{ // `̗L
  int pre = !!hDC(cv);

  if (!hDC(cv) && hBK(cv)) hDC(cv) = hBK(cv);
  return pre;
}

BOOL WINAPI DisableCanvas(HCVS cv)
{ // `̖
  int pre = !!hDC(cv);

  if (hDC(cv)) { hBK(cv) = hDC(cv); hDC(cv) = NULL;}
  return pre;
}

PLOGFONT WINAPI CanvasLOGFONT(PLOGFONT lf, HCVS cv)
{ // _tHg
  return canvaslof(lf, (PCVSE)cv);
}

void WINAPI SetOrigin(HCVS cv, REAL xorg, REAL yorg)
{ // _̐ݒ
  ((PCVSE)cv)->xorg = iround(xorg * 1000.0);
  ((PCVSE)cv)->yorg = iround(yorg * 1000.0);
  ((PCVSE)cv)->Dx = ((PCVSE)cv)->xorg * 0.001 * ((PCVSE)cv)->dpi / MMPI;
  ((PCVSE)cv)->Dy = ((PCVSE)cv)->yorg * 0.001 * ((PCVSE)cv)->dpi / MMPI;
}

REAL WINAPI OriginX(HCVS cv)
{ // _XW
  return ((PCVSE)cv)->xorg * 0.001;
}

REAL WINAPI OriginY(HCVS cv)
{ // _YW
  return ((PCVSE)cv)->yorg * 0.001;
}

void WINAPI SetScale(HCVS cv, REAL xscl, REAL yscl)
{ // {̐ݒ
  if (xscl == 0.0) xscl = 1.0;
  if (yscl == 0.0) yscl = xscl;
  ((PCVSE)cv)->xscl = iround(xscl * 1000.0);
  ((PCVSE)cv)->yscl = iround(yscl * 1000.0);
  ((PCVSE)cv)->Mx = ((PCVSE)cv)->xscl * 0.001 * ((PCVSE)cv)->dpi / MMPI;
  ((PCVSE)cv)->My = ((PCVSE)cv)->yscl * 0.001 * ((PCVSE)cv)->dpi / MMPI;
}

REAL WINAPI ScaleX(HCVS cv)
{ // X{
  return ((PCVSE)cv)->xscl * 0.001;
}

REAL WINAPI ScaleY(HCVS cv)
{ // Y{
  return ((PCVSE)cv)->yscl * 0.001;
}

int  WINAPI c2dW(HCVS cv, REAL w)
{ // W̕sNZW̕
  return iW(cv, w);
}

int  WINAPI c2dH(HCVS cv, REAL h)
{ // W̍sNZW̍
  return iH(cv, h);
}

int  WINAPI c2dX(HCVS cv, REAL x)
{ // WXWsNZWXW
  return iX(cv, x);
}

int  WINAPI c2dY(HCVS cv, REAL y)
{ // WYWsNZWYW
  return iY(cv, y);
}

REAL WINAPI d2cW(HCVS cv, int w)
{ // sNZW̕W̕
  return rW(cv, w);
}

REAL WINAPI d2cH(HCVS cv, int h)
{ // sNZW̍W̍
  return rH(cv, h);
}

REAL WINAPI d2cX(HCVS cv, int x)
{ // sNZWXWWXW
  return rX(cv, x);
}

REAL WINAPI d2cY(HCVS cv, int y)
{ // sNZWYWWYW
  return rY(cv, y);
}

PCELL WINAPI SetCell(PCELL pc, REAL x1, REAL y1, REAL x2, REAL y2)
{ // Z`̐ݒ
  pc->x1 = x1; pc->y1 = y1; pc->x2 = x2; pc->y2 = y2;
  return pc;
}

PRECT WINAPI c2dRect(PRECT pr, HCVS cv, PCCELL pc)
{ // W̃Z`ɑΉsNZWRECT`
  int t;

  SetRect(pr, iX(cv, pc->x1), iY(cv, pc->y1), iX(cv, pc->x2), iY(cv, pc->y2));
  if (pr->lft > pr->rgt) { t = pr->lft; pr->lft = pr->rgt; pr->rgt = t;}
  if (pr->top > pr->btm) { t = pr->top; pr->top = pr->btm; pr->btm = t;}
  return pr;
}

PCELL WINAPI d2cCell(PCELL pc, HCVS cv, PCRECT pr)
{ // sNZWRECT`ɑΉW̃Z`
  REAL t;

  SetCell(pc, rX(cv, pr->lft), rY(cv, pr->top), rX(cv, pr->rgt), rY(cv, pr->btm));
  if (pc->x1 > pc->x2) { t = pc->x1; pc->x1 = pc->x2; pc->x2 = t;}
  if (pc->y1 > pc->y2) { t = pc->y1; pc->y1 = pc->y2; pc->y2 = t;}
  return pc;
}

PCELL WINAPI MoveCell(PCELL pc, REAL dx, REAL dy)
{ // Z`̈ړ
  pc->x1 += dx; pc->y1 += dy;
  pc->x2 += dx; pc->y2 += dy;
  return pc;
}

PCELL WINAPI ResizeCell(PCELL pc, REAL dx, REAL dy)
{ // Z`̃TCYύX
  pc->x2 += dx;
  pc->y2 += dy;
  return pc;
}

PCELL WINAPI ReshapeCell(PCELL pc, REAL lm, REAL tm, REAL rm, REAL bm)
{ // Z`̕ό`
  pc->x1 += lm; pc->y1 += tm;
  pc->x2 -= rm; pc->y2 -= bm;
  return pc;
}

void WINAPI SetCellMargin(HCVS cv, REAL hcmg, REAL vcmg)
{ // ZpfBO̐ݒ
  ((PCVSE)cv)->hcm = iround(hcmg * 1000.0);
  ((PCVSE)cv)->vcm = iround(vcmg * 1000.0);
}

REAL WINAPI CellMarginH(HCVS cv)
{ // ZEpfBO
  return ((PCVSE)cv)->hcm * 0.001;
}

REAL WINAPI CellMarginV(HCVS cv)
{ // Z㉺pfBO
  return ((PCVSE)cv)->vcm * 0.001;
}

int  WINAPI SetLineStyle(HCVS cv, int lst)
{ // ݒ
  int bst = ((PCVSE)cv)->lst;

  ((PCVSE)cv)->lst = lst;
  if (hDC(cv)) DeleteObject(SelectObject(hDC(cv), CreatePen(PENSTY(cv), PENWID(cv), PENCOL(cv)));
  return bst;
}

BGRC WINAPI SetLineColor(HCVS cv, BGRC col)
{ // Fݒ
  int lco = ((PCVSE)cv)->lco;

  ((PCVSE)cv)->lco = col;
  if (hDC(cv)) DeleteObject(SelectObject(hDC(cv), CreatePen(PENSTY(cv), PENWID(cv), PENCOL(cv)));
  return lco;
}

void WINAPI SetTextFont(HCVS cv, PCSTR face, REAL ch, int flg, BGRC col)
{ // eLXgtHgݒ
  LOGFONT lof;

  if (face) strcpyx(((PCVSE)cv)->tfa, face, sizeof(((PCVSE)cv)->tfa) - 1);
  ((PCVSE)cv)->tcw = 0;
  if (ch > 0.0) ((PCVSE)cv)->tch = iround(ch * 1000.0);
  ((PCVSE)cv)->tcd = 0;
  ((PCVSE)cv)->tst = flg;
  ((PCVSE)cv)->tco = col;
  if (hDC(cv)) {
    DeleteObject(SelectObject(hDC(cv), CreateFontIndirect(CanvasLOGFONT(&lof, cv))));
    SetTextCharacterExtra(hDC(cv), iW(cv, ((PCVSE)cv)->tcd * 0.001));
    SetTextColor(hDC(cv), ((PCVSE)cv)->tco);
  }
  if (hIC(cv)) {
    DeleteObject(SelectObject(hIC(cv), CreateFontIndirect(CanvasLOGFONT(&lof, cv))));
    SetTextCharacterExtra(hIC(cv), iW(cv, ((PCVSE)cv)->tcd * 0.001));
  }
}

void WINAPI SetTextStyle(HCVS cv, REAL cw, REAL ch, REAL cd, PCSTR face)
{ // eLXgTCYAtHgݒ
  LOGFONT lof;

  if (face) strcpyx(((PCVSE)cv)->tfa, face, sizeof(((PCVSE)cv)->tfa) - 1);
  ((PCVSE)cv)->tcw = (cw > 0.0)? iround(cw * 1000.0): 0;
  if (ch > 0.0) ((PCVSE)cv)->tch = iround(ch * 1000.0);
  ((PCVSE)cv)->tcd = (cd > 0.0)? iround(cd * 1000.0): 0;
  if (hDC(cv)) {
    DeleteObject(SelectObject(hDC(cv), CreateFontIndirect(CanvasLOGFONT(&lof, cv))));
    SetTextCharacterExtra(hDC(cv), iW(cv, ((PCVSE)cv)->tcd * 0.001));
  }
  if (hIC(cv)) {
    DeleteObject(SelectObject(hIC(cv), CreateFontIndirect(CanvasLOGFONT(&lof, cv))));
    SetTextCharacterExtra(hIC(cv), iW(cv, ((PCVSE)cv)->tcd * 0.001));
  }
}

PWHSZ WINAPI TextSize(PWHSZ sz, HCVS cv, PCSTR st, int cb)
{ // ̃TCY
  SIZE siz;

  GetTextSize(&siz, hDC(cv)? hDC(cv): hIC(cv), NULL, st, cb);
  sz->w = d2cW(cv, siz.cx);
  sz->h = d2cH(cv, siz.cy);
  return sz;
}

PSIZE WINAPI TextSizeD(PSIZE sz, HCVS cv, PCSTR st, int cb)
{ // ̃TCY
  GetTextSize(sz, hDC(cv)? hDC(cv): hIC(cv), NULL, st, cb); return sz;
}

PWHSZ WINAPI AveCharSize(PWHSZ sz, HCVS cv)
{ // ϕTCY
  SIZE siz;

  GetAveCharSize(&siz, hDC(cv)? hDC(cv): hIC(cv), NULL);
  sz->w = d2cW(cv, siz.cx);
  sz->h = d2cH(cv, siz.cy);
  return sz;
}

PSIZE WINAPI AveCharSizeD(PSIZE sz, HCVS cv)
{ // ϕTCY
  GetAveCharSize(sz, hDC(cv)? hDC(cv): hIC(cv), NULL); return sz;
}

PWHSZ WINAPI ZenCharSize(PWHSZ sz, HCVS cv)
{ // SpTCY
  SIZE siz;

  GetZenCharSize(&siz, hDC(cv)? hDC(cv): hIC(cv), NULL);
  sz->w = d2cW(cv, siz.cx);
  sz->h = d2cH(cv, siz.cy);
  return sz;
}

PSIZE WINAPI ZenCharSizeD(PSIZE sz, HCVS cv)
{ // SpTCY
  GetZenCharSize(sz, hDC(cv)? hDC(cv): hIC(cv), NULL); return sz;
}

void WINAPI DrawLineD(HCVS cv, int x1, int y1, int x2, int y2)
{ // ̕`
  if (!hDC(cv)) return;
  MoveTo(hDC(cv), x1, y1); LineTo(hDC(cv), x2, y2);
}

void WINAPI DrawLine(HCVS cv, REAL x1, REAL y1, REAL x2, REAL y2)
{ // ̕`
  if (!hDC(cv)) return;
  MoveTo(hDC(cv), iX(cv, x1), iY(cv, y1)); LineTo(hDC(cv), iX(cv, x2), iY(cv, y2));
}

void WINAPI DrawCirc(HCVS cv, REAL xc, REAL yc, REAL rc, REAL t1, REAL t2)
{ // ~(~)̕`
  int cx, cy, rx, ry, sx, sy, ex, ey;

  if (!hDC(cv)) return;
  cx = iX(cv, xc); cy = iY(cv, yc);
  rx = iW(cv, rc); ry = iH(cv, rc);
  sx = iX(cv, xc + rc * cos(t1 * RPD));
  sy = iY(cv, yc - rc * sin(t1 * RPD));
  ex = iX(cv, xc + rc * cos(t2 * RPD));
  ey = iY(cv, yc - rc * sin(t2 * RPD));
  Arc(hDC(cv), cx - rx, cy - ry, cx + rx + 1, cy + ry + 1, sx, sy, ex, ey);
}

void WINAPI DrawCellD(HCVS cv, PCRECT pr, int rst)
{ // `̕`
  int lst;

  if (!hDC(cv)) return;
  lst = ((PCVSE)cv)->lst;
  if (rst == RST_DEF) rst = RST(lst, lst, lst, lst);
  SetLineStyle(cv, ((PBYTE)&rst)[0]); DrawLineD(cv, pr->lft, pr->top, pr->lft, pr->btm);
  SetLineStyle(cv, ((PBYTE)&rst)[1]); DrawLineD(cv, pr->lft, pr->top, pr->rgt, pr->top);
  SetLineStyle(cv, ((PBYTE)&rst)[2]); DrawLineD(cv, pr->rgt, pr->btm, pr->rgt, pr->top);
  SetLineStyle(cv, ((PBYTE)&rst)[3]); DrawLineD(cv, pr->lft, pr->btm, pr->rgt, pr->btm);
  SetLineStyle(cv, lst);
}

void WINAPI DrawCell(HCVS cv, PCCELL pc, int rst)
{ // `̕`
  RECT rct; DrawCellD(cv, c2dRect(&rct, cv, pc), rst);
}

void WINAPI FillCellD(HCVS cv, PCRECT pr, int rst, BGRC col)
{ // `̓hԂ
  HBRUSH hbrs;
  RECT rct;

  if (!hDC(cv)) return;
  SetRect(&rct, pr->lft, pr->top, pr->rgt + 1, pr->btm + 1);
  hbrs = CreateSolidBrush(col);
  FillRect(hDC(cv), &rct, hbrs);
  DeleteObject(hbrs);
  if (rst) DrawCellD(cv, pr, rst);
}

void WINAPI FillCell(HCVS cv, PCCELL pc, int rst, BGRC col)
{ // `̓hԂ
  RECT rct; FillCellD(cv, c2dRect(&rct, cv, pc), rst, col);
}

void WINAPI FillPolyD(HCVS cv, POINT pt[], int np, BGRC col)
{ // p`̓hԂ
  HBRUSH hbrs;

  if (!hDC(cv) || np < 3) return;
  hbrs = SelectObject(hDC(cv), CreateSolidBrush(col));
  Polygon(hDC(cv), pt, np);
  DeleteObject(SelectObject(hDC(cv), hbrs));
}

void WINAPI FillPoly(HCVS cv, XYPT pt[], int np, BGRC col)
{ // p`̓hԂ
  int i;
  POINT ap[256];

  if (np > NELEM(ap)) return;
  for (i = 0; i < np; i++) {
    ap[i].x = iX(cv, pt[i].x);
    ap[i].y = iY(cv, pt[i].y);
  }
  FillPolyD(cv, ap, np, col);
}

void WINAPI FillCirc(HCVS cv, REAL xc, REAL yc, REAL rc, REAL t1, REAL t2, BGRC col)
{ // ~(`)̓hԂ
  int cx, cy, rx, ry, sx, sy, ex, ey;
  HBRUSH hbrs;

  if (!hDC(cv)) return;
  cx = iX(cv, xc); cy = iY(cv, yc);
  rx = iW(cv, rc); ry = iH(cv, rc);
  sx = iX(cv, xc + rc * cos(t1 * RPD));
  sy = iY(cv, yc - rc * sin(t1 * RPD));
  ex = iX(cv, xc + rc * cos(t2 * RPD));
  ey = iY(cv, yc - rc * sin(t2 * RPD));
  hbrs = SelectObject(hDC(cv), CreateSolidBrush(col));
  Pie(hDC(cv), cx - rx, cy - ry, cx + rx + 1, cy + ry + 1, sx, sy, ex, ey);
  DeleteObject(SelectObject(hDC(cv), hbrs));
}

void LOCALF stext(HCVS cv, PRECT pr, PCSTR st, int fmt)
{ // ̕`
  DrawText(hDC(cv), st, -1, pr, fmt);
}

void LOCALF atext(HCVS cv, PRECT pr, PCSTR st, int fmt)
{ // ̕`(kđŜ\)
  int tcx;
  RECT rct = *pr;
  SIZE siz;
  LOGFONT lof;

  DrawText(hDC(cv), st, -1, &rct, fmt | DT_CAL);
  if (rct.rgt - rct.lft <= pr->rgt - pr->lft) {
    stext(cv, pr, st, fmt); return;
  }
  tcx = SetTextCharacterExtra(hDC(cv), 0);
  GetAveCharSize(&siz, hDC(cv), CanvasLOGFONT(&lof, cv));
  for (lof.lfWidth = siz.cx; lof.lfWidth > 2; lof.lfWidth--) {
    DeleteObject(SelectObject(hDC(cv), CreateFontIndirect(&lof)));
    DrawText(hDC(cv), st, -1, &rct, fmt | DT_CAL);
    if (rct.rgt - rct.lft <= pr->rgt - pr->lft) break;
  }
  DrawText(hDC(cv), st, -1, pr, fmt);
  DeleteObject(SelectObject(hDC(cv), CreateFontIndirect(CanvasLOGFONT(&lof, cv))));
  SetTextCharacterExtra(hDC(cv), tcx);
}

void LOCALF mtext(HCVS cv, PRECT pr, PCSTR st, int fmt)
{ // ̕`(s)
  int tcx;
  RECT rct = *pr;
  SIZE siz;
  LOGFONT lof;

  DrawText(hDC(cv), st, -1, &rct, fmt | DT_CAL);
  if (rct.btm - rct.top <= pr->btm - pr->top) {
    OffsetRect(&rct, 0, (fmt & 0x0c) * (pr->btm - pr->top - rct.btm + rct.top) / 8);
    DrawText(hDC(cv), st, -1, &rct, fmt); if (fmt & DT_CAL) *pr = rct;
    return;
  }
  tcx = SetTextCharacterExtra(hDC(cv), 0);
  GetAveCharSize(&siz, hDC(cv), CanvasLOGFONT(&lof, cv));
  for ( ; lof.lfHeight < -8; lof.lfHeight++) {
    lof.lfWidth = 0;
    DeleteObject(SelectObject(hDC(cv), CreateFontIndirect(&lof)));
    DrawText(hDC(cv), st, -1, &rct, fmt | DT_CAL);
    rct.lft = pr->lft; rct.rgt = pr->rgt;
    if (rct.btm - rct.top <= pr->btm - pr->top) break;
  }
  OffsetRect(&rct, 0, (fmt & 0x0c) * (pr->btm - pr->top - rct.btm + rct.top) / 8);
  DrawText(hDC(cv), st, -1, &rct, fmt); if (fmt & DT_CAL) *pr = rct;
  DeleteObject(SelectObject(hDC(cv), CreateFontIndirect(CanvasLOGFONT(&lof, cv))));
  SetTextCharacterExtra(hDC(cv), tcx);
}

void LOCALF jtext(HCVS cv, PRECT pr, PCSTR st, int fmt)
{ // ̕`(ϓt)
  int nc, tcx;
  RECT rct = *pr;

  if ((nc = mbslen(st)) < 2) {
    stext(cv, pr, st, DT_CEN); return;
  }
  DrawText(hDC(cv), st, -1, &rct, fmt | DT_CAL);
  if (rct.rgt - rct.lft > pr->rgt - pr->lft) {
    atext(cv, pr, st, fmt); return;
  }
  tcx = SetTextCharacterExtra(hDC(cv), (pr->rgt - pr->lft - rct.rgt + rct.lft) / (nc - 1));
  DrawText(hDC(cv), st, -1, pr, fmt);
  SetTextCharacterExtra(hDC(cv), tcx);
}

int  LOCALF DT2DT(int fmt)
{ // `tO̕ϊ
  if (!(fmt & DT_PRE)) fmt |= DT_NOPREFIX;
  if (fmt & DT_MUL) fmt |= (DT_WORDBREAK|DT_EDITCONTROL);  else fmt |= DT_SINGLELINE;
  if (fmt & DT_FRC) fmt &=~DT_FRC;  else if (!(fmt & DT_BTM)) fmt |= DT_VCENTER;
  if (!(fmt & DT_CLP)) fmt |= DT_NOCLIP;
  return fmt &~0xff000000;
}

void WINAPI CellTextD(HCVS cv, PRECT pc, PCSTR st, int fmt)
{ // ̕`
  RECT rct = *pc;

  if (!hDC(cv) || st[0] == '\0') return;
  InflateRect(&rct, -CellMarginHD(cv), -CellMarginVD(cv)); if (IsRectEmpty(&rct)) return;
  switch (fmt & 0xff000003) {
  case DT_LFT: case DT_CEN: case DT_RGT:
    stext(cv, &rct, st, DT2DT(fmt)); break;
  case DT_AUT: case DT_AUT|DT_CEN: case DT_AUT|DT_RGT:
    atext(cv, &rct, st, DT2DT(fmt)); break;
  case DT_MUL: case DT_AUT|DT_MUL:
    mtext(cv, &rct, st, DT2DT(fmt)); break;
  case DT_JST: case DT_JST|DT_CEN: case DT_JST|DT_RGT:
  case DT_AUT|DT_JST: case DT_AUT|DT_JST|DT_CEN: case DT_AUT|DT_JST|DT_RGT:
    jtext(cv, &rct, st, DT2DT(fmt)); break;
  }
  if (fmt & DT_CAL) *pc = rct;
}

void WINAPI CellText(HCVS cv, PCELL pc, PCSTR st, int fmt)
{ // ̕`
  RECT rct; CellTextD(cv, c2dRect(&rct, cv, pc), st, fmt); if (fmt & DT_CAL) d2cCell(pc, cv, &rct);
}

void LOCALF vtext(HCVS cv, PRECT pr, PCSTR st, int fmt)
{ // c̕`
  int n;
  SIZE siz;
  RECT rct;

  n = mbslen(st);
  GetZenCharSize(&siz, hDC(cv), NULL);
  rct.lft = pr->lft + ((fmt & VT_RGT)? 2: (fmt & VT_LFT)? 0: 1) * (pr->rgt - pr->lft - siz.cx) / 2;
  rct.top = pr->top + ((fmt & VT_BTM)? 2: (fmt & VT_MID)? 1: 0) * (pr->btm - pr->top - n * siz.cy) / 2;
  rct.rgt = rct.lft + siz.cx;
  rct.btm = rct.top + n * siz.cy;
  if (rct.btm - rct.top > pr->btm - pr->top) {
    rct.top = pr->top; rct.btm = pr->btm;
  }
  if (fmt & VT_CAL) { *pr = rct; return;}
  SetRect(&rct, rct.rgt, rct.top, rct.rgt + rct.btm - rct.top, rct.top + rct.rgt - rct.lft);
  atext(cv, &rct, st, DT2DT(DT_CEN));
}

void WINAPI VCellTextD(HCVS cv, PRECT pc, PCSTR st, int fmt)
{ // c̕`
  RECT rct = *pc;

  if (!hDC(cv) || st[0] == '\0') return;
  InflateRect(&rct, -CellMarginHD(cv), -CellMarginVD(cv)); if (IsRectEmpty(&rct)) return;
  vtext(cv, &rct, st, fmt); if (fmt & VT_CAL) *pc = rct;
}

void WINAPI VCellText(HCVS cv, PCELL pc, PCSTR st, int fmt)
{ // c̕`
  RECT rct; VCellTextD(cv, c2dRect(&rct, cv, pc), st, fmt); if (fmt & VT_CAL) d2cCell(pc, cv, &rct);
}

void WINAPI SetGrid0(PGRID gr, REAL x0, REAL y0, int nc, int nr, REAL dcw, REAL drh)
{ // Obh̐ݒ
  gr->x0 = x0; gr->y0 = y0; gr->dcw = dcw; gr->drh = drh; gr->cw = NULL; gr->nc = nc; gr->rh = NULL; gr->nr = nr;
}

void WINAPI SetGrid1(PGRID gr, REAL x0, REAL y0, int nc, int nr, REAL *cw, REAL drh)
{ // Obh̐ݒ
  gr->x0 = x0; gr->y0 = y0; gr->dcw = 0.0; gr->drh = drh; gr->cw = cw; gr->nc = nc; gr->rh = NULL; gr->nr = nr;
}

void WINAPI SetGrid2(PGRID gr, REAL x0, REAL y0, int nc, int nr, REAL dcw, REAL *rh)
{ // Obh̐ݒ
  gr->x0 = x0; gr->y0 = y0; gr->dcw = dcw; gr->drh = 0.0; gr->cw = NULL; gr->nc = nc; gr->rh = rh; gr->nr = nr;
}

void WINAPI SetGrid3(PGRID gr, REAL x0, REAL y0, int nc, int nr, REAL *cw, REAL *rh)
{ // Obh̐ݒ
  gr->x0 = x0; gr->y0 = y0; gr->dcw = 0.0; gr->drh = 0.0; gr->cw = cw; gr->nc = nc; gr->rh = rh; gr->nr = nr;
}

PGRID WINAPI AdjustGrid(HCVS cv, PGRID gr)
{ // Obh̒
  int i;

  if (gr->cw) {
    for (i = 0; i < gr->nc; i++) {
      gr->cw[i] = rW(cv, iW(cv, gr->cw[i]));
    }
  } else {
    gr->dcw = rW(cv, iW(cv, gr->dcw));
  }
  if (gr->rh) {
    for (i = 0; i < gr->nr; i++) {
      gr->rh[i] = rH(cv, iH(cv, gr->rh[i]));
    }
  } else {
    gr->drh = rH(cv, iH(cv, gr->drh));
  }
  return gr;
}

PCELL WINAPI GridCell(PCELL pc, PCGRID gr, int ir, int ic)
{ // Obh̃Z`
  int i;

  if (gr->cw) {
    pc->x1 = gr->x0;
    for (i = 0; i < ic; i++) {
      pc->x1 += gr->cw[i];
    }
    pc->x2 = pc->x1 + gr->cw[i];
  } else {
    pc->x1 = gr->x0 + ic * gr->dcw;
    pc->x2 = pc->x1 + gr->dcw;
  }
  if (gr->rh) {
    pc->y1 = gr->y0;
    for (i = 0; i < ir; i++) {
      pc->y1 += gr->rh[i];
    }
    pc->y2 = pc->y1 + gr->rh[i];
  } else {
    pc->y1 = gr->y0 + ir * gr->drh;
    pc->y2 = pc->y1 + gr->drh;
  }
  return pc;
}

#define  RST2(gr, ir, ic, s1, s2) \
  RST((ic == 0)? s2: 0, (ir == 0)? s2: 0, (ic < gr->nc-1)? s1: s2, (ir < gr->nr-1)? s1: s2)

int  LOCALF GridRST(PCGRID gr, int ir, int ic, int rst)
{ // Obh̃Z`̐
  switch (rst) {
  case RST_I_R: rst = RST2(gr, ir, ic, lstI, lstR); break;
  case RST_I_M: rst = RST2(gr, ir, ic, lstI, lstM); break;
  case RST_I_B: rst = RST2(gr, ir, ic, lstI, lstB); break;
  case RST_R_M: rst = RST2(gr, ir, ic, lstR, lstM); break;
  case RST_R_B: rst = RST2(gr, ir, ic, lstR, lstB); break;
  case RST_R_X: rst = RST2(gr, ir, ic, lstR, lstX); break;
  }
  return rst;
}

void WINAPI DrawGridCell(HCVS cv, PCGRID gr, int ir, int ic, int rst)
{ // Obh̃Z`̕`
  CELL cel; GridCell(&cel, gr, ir, ic); DrawCell(cv, &cel, GridRST(gr, ir, ic, rst));
}

void WINAPI GridCellText(HCVS cv, PCGRID gr, int ir, int ic, int rst, PCSTR st, int fmt)
{ // Obh̃Z`ƕ̕`
  CELL cel; GridCell(&cel, gr, ir, ic); DrawCell(cv, &cel, GridRST(gr, ir, ic, rst)); CellText(cv, &cel, st, fmt);
}

void WINAPI SetStamp0(PSTMP ps, REAL dc, PCSTR st)
{ // e̐ݒ
  ps->sty = 0; ps->st1 = st; ps->st2 = NULL; ps->st3 = NULL; ps->dc = dc;
}

void WINAPI SetStamp1(PSTMP ps, REAL dc, PCSTR st)
{ // e̐ݒ
  ps->sty = 1; ps->st1 = st; ps->st2 = NULL; ps->st3 = NULL; ps->dc = dc;
}

void WINAPI SetStamp2(PSTMP ps, REAL dc, PCSTR st1, PCSTR st2)
{ // e̐ݒ
  ps->sty = 2; ps->st1 = st1; ps->st2 = st2; ps->st3 = NULL; ps->dc = dc;
}

void WINAPI SetStamp3(PSTMP ps, REAL dc, PCSTR st1, PCSTR st2, PCSTR st3)
{ // e̐ݒ
  ps->sty = 3; ps->st1 = st1; ps->st2 = st2; ps->st3 = st3; ps->dc = dc;
}

void LOCALF stmp0(HCVS cv, REAL xc, REAL yc, REAL rc, PCSTR st)
{ // e̕`(c)
  RECT rct;
  CELL cel;

  DrawCirc(cv, xc, yc, rc, 0.0, 0.0);
  SetCell(&cel, xc - 0.5 * rc, yc - rc, xc + 0.5 * rc, yc + rc);
  vtext(cv, c2dRect(&rct, cv, &cel), st, VT_MID);
}

void LOCALF stmp1(HCVS cv, REAL xc, REAL yc, REAL rc, PCSTR st)
{ // e̕`()
  RECT rct;
  CELL cel;

  DrawCirc(cv, xc, yc, rc, 0.0, 0.0);
  SetCell(&cel, xc - rc, yc - 0.5 * rc, xc + rc, yc + 0.5 * rc);
  atext(cv, c2dRect(&rct, cv, &cel), st, DT2DT(DT_CEN));
}

void LOCALF stmp2(HCVS cv, REAL xc, REAL yc, REAL rc, PCSTR st1, PCSTR st2)
{ // e̕`(i)
  RECT rct;
  CELL cel;

  DrawCirc(cv, xc, yc, rc, 0.0, 0.0);
  DrawLine(cv, xc - rc, yc, xc + rc, yc);
  SetCell(&cel, xc - 0.9 * rc, yc - 0.75 * rc, xc + 0.9 * rc, yc);
  atext(cv, c2dRect(&rct, cv, &cel), st1, DT2DT(DT_CEN));
  SetCell(&cel, xc - 0.9 * rc, yc, xc + 0.9 * rc, yc + 0.75 * rc);
  atext(cv, c2dRect(&rct, cv, &cel), st2, DT2DT(DT_CEN));
}

void LOCALF stmp3(HCVS cv, REAL xc, REAL yc, REAL rc, PCSTR st1, PCSTR st2, PCSTR st3)
{ // e̕`(Oi)
  RECT rct;
  CELL cel;

  DrawCirc(cv, xc, yc, rc, 0.0, 0.0);
  DrawLine(cv, xc - 0.95 * rc, yc - 0.3 * rc, xc + 0.95 * rc, yc - 0.3 * rc);
  DrawLine(cv, xc - 0.95 * rc, yc + 0.3 * rc, xc + 0.95 * rc, yc + 0.3 * rc);
  SetCell(&cel, xc - 0.8 * rc, yc - 0.9 * rc, xc + 0.8 * rc, yc - 0.3 * rc);
  atext(cv, c2dRect(&rct, cv, &cel), st1, DT2DT(DT_CEN));
  SetCell(&cel, xc - 0.95 * rc, yc - 0.3 * rc, xc + 0.95 * rc, yc + 0.3 * rc);
  atext(cv, c2dRect(&rct, cv, &cel), st2, DT2DT(DT_CEN));
  SetCell(&cel, xc - 0.8 * rc, yc + 0.3 * rc, xc + 0.85 * rc, yc + 0.9 * rc);
  atext(cv, c2dRect(&rct, cv, &cel), st3, DT2DT(DT_CEN));
}

void WINAPI CellStampD(HCVS cv, PCRECT pr, PCSTMP ps)
{ // e̕`
  CELL cel; CellStamp(cv, d2cCell(&cel, cv, pr), ps);
}

void WINAPI CellStamp(HCVS cv, PCCELL pc, PCSTMP ps)
{ // e̕`
  int tcw, tch, tcd, tst, tco, lst, lco;
  HFONT hfnt;
  REAL xc, yc, rc;
  char tfa[32];

  if (!hDC(cv)) return;
  xc = (pc->x1 + pc->x2) / 2;
  yc = (pc->y1 + pc->y2) / 2;
  rc = ps->dc / 2;
  strcpyx(tfa, ((PCVSE)cv)->tfa, sizeof(tfa) - 1);
  tcw = ((PCVSE)cv)->tcw;
  tch = ((PCVSE)cv)->tch;
  tcd = ((PCVSE)cv)->tcd; ((PCVSE)cv)->tcd = 0;
  tst = ((PCVSE)cv)->tst;
  tco = ((PCVSE)cv)->tco;
  hfnt = GetCurrentObject(hDC(cv), OBJ_FONT);
  lst = SetLineStyle(cv, 0x06);
  lco = SetLineColor(cv, tco);
  switch (ps->sty) {
  case 0: SetTextFont(cv, strconc("@", tfa), rc, TFF_BLD|TFF_VRT, tco); break;
  case 1: SetTextFont(cv, NULL, rc, TFF_BLD, tco); break;
  case 2: SetTextFont(cv, NULL, 0.54 * rc, TFF_BLD, tco); break;
  case 3: SetTextFont(cv, NULL, 0.40 * rc, TFF_BLD, tco); break;
  }
  switch (ps->sty) {
  case 0: stmp0(cv, xc, yc, rc, ps->st1); break;
  case 1: stmp1(cv, xc, yc, rc, ps->st1); break;
  case 2: stmp2(cv, xc, yc, rc, ps->st1, ps->st2); break;
  case 3: stmp3(cv, xc, yc, rc, ps->st1, ps->st2, ps->st3); break;
  }
  SetLineColor(cv, lco);
  SetLineStyle(cv, lst);
  SetTextFont(cv, tfa, tch * 0.001, tst, tco);
  DeleteObject(SelectObject(hDC(cv), hfnt)); ((PCVSE)cv)->tcw = tcw;
  SetTextCharacterExtra(hDC(cv), iW(cv, tcd * 0.001)); ((PCVSE)cv)->tcd = tcd;
}

void WINAPI CellImageD(HCVS cv, PRECT pc, HDIB bm, int fmt)
{ // 摜̓\t
  RECT rct = *pc;

  if (!hDC(cv) || !bm) return;
  InflateRect(&rct, -CellMarginHD(cv), -CellMarginVD(cv)); if (IsRectEmpty(&rct)) return;
  DrawDIB(hDC(cv), &rct, bm, fmt);
  if (fmt & DT_CAL) *pc = rct;
}

void WINAPI CellImage(HCVS cv, PCELL pc, HDIB bm, int fmt)
{ // 摜̓\t
  RECT rct; CellImageD(cv, c2dRect(&rct, cv, pc), bm, fmt); if (fmt & DT_CAL) d2cCell(pc, cv, &rct);
}

// ---------------------------------------------------------------------- //

PCSTR WINAPI WindowText(HWND hwnd)
{ // EBhEeLXg
  static char bf[512]; GetWindowText(hwnd, bf, sizeof(bf)); return bf;
}

PCSTR WINAPI ClassName(HWND hwnd)
{ // EBhENX
  static char bf[512]; GetClassName(hwnd, bf, sizeof(bf)); return bf;
}

void WINAPI CenterWindow(HWND hwnd, HWND hown)
{ // EBhE𒆉ɒu
  int x1, y1, w1, h1, w2, h2;
  RECT rct;

  GetWindowRect(hown, &rct);
  x1 = rct.lft;
  y1 = rct.top;
  w1 = rct.rgt - rct.lft;
  h1 = rct.btm - rct.top;
  GetWindowRect(hwnd, &rct);
  w2 = rct.rgt - rct.lft;
  h2 = rct.btm - rct.top;
  MoveWindow(hwnd, x1 + (w1 - w2) / 2, y1 + (h1 - h2) / 2, w2, h2, FALSE);
}

void WINAPI AdjustWindow(HWND hwnd, PCRECT pr)
{ // NCAg̈̃TCYŃEBhẼTCYݒ
  int mnu, sty;
  RECT rct = *pr;

  sty = WindowStyle(hwnd);
  mnu = (!(sty & WS_CHILD) && !!GetMenu(hwnd));
  AdjustWindowRectEx(&rct, sty, mnu, WindowExStyle(hwnd));
  if (sty & WS_VSCROLL) rct.rgt += GetSystemMetrics(SM_CXVSCROLL);
  if (sty & WS_HSCROLL) rct.btm += GetSystemMetrics(SM_CYHSCROLL);
  ResizeWindow(hwnd, rct.rgt - rct.lft, rct.btm - rct.top);
}

int  WINAPI SetHScrollBar(HWND hwnd, int min, int max, int psz, int pos)
{ // XN[o[̐ݒ
  static SCROLLINFO scr = { sizeof(SCROLLINFO), SIF_ALL|SIF_DISABLENOSCROLL, };

  if (!(WindowStyle(hwnd) & WS_HSCROLL)) return 0;
  scr.nMin = min; scr.nMax = max; scr.nPage = psz; scr.nPos = pos;
  return SetScrollInfo(hwnd, SB_HORZ, &scr, TRUE);
}

int  WINAPI SetVScrollBar(HWND hwnd, int min, int max, int psz, int pos)
{ // XN[o[̐ݒ
  static SCROLLINFO scr = { sizeof(SCROLLINFO), SIF_ALL|SIF_DISABLENOSCROLL, };

  if (!(WindowStyle(hwnd) & WS_VSCROLL)) return 0;
  scr.nMin = min; scr.nMax = max; scr.nPage = psz; scr.nPos = pos;
  return SetScrollInfo(hwnd, SB_VERT, &scr, TRUE);
}

// ---------------------------------------------------------------------- //

#define  NPOP  32

BOOL LOCALF insmenuitems(HMENU hmnu, int pos, PCMNUS ms)
{ // j[̍쐬
  int n, po[NPOP];
  PCMNUI mi, me;
  HMENU hm[NPOP];
  PCSTR tx[NPOP];
  static MENUITEMINFO mni = { sizeof(MENUITEMINFO), };

  n = 0;
  hm[0] = hmnu;
  po[0] = pos;
  for (mi = ms->mi, me = mi + ms->ni; mi < me; mi++) {
    if (mi->flg & MF_POPUP) {
      n++; if (n >= NPOP) return (BOOL)ierr(E_CAP);
      po[n] = 0;
      hm[n] = CreatePopupMenu();
      tx[n] = mi->txt? mi->txt: "";
    } else {
      if (mi->idm) {
        mni.fMask = MIIM_STATE|MIIM_ID|MIIM_STRING;
        mni.fState = (mi->flg & mfG)? MFS_GRAYED: (mi->flg & mfC)? MFS_CHECKED: MFS_ENABLED;
        mni.wID = mi->idm;
        mni.dwTypeData = (LPTSTR)(mi->txt? mi->txt: "");
        mni.cch = strlen(mni.dwTypeData);
        if (!!(mni.hbmpItem = MenuItemDDB(mi->idm))) mni.fMask |= MIIM_BITMAP;
        InsertMenuItem(hm[n], po[n]++, TRUE, &mni);
      } else {
        mni.fMask = MIIM_FTYPE;
        mni.fType = MFT_SEPARATOR;
        InsertMenuItem(hm[n], po[n]++, TRUE, &mni);
      }
      if (mi->flg & MF_END) {
        if (n <= 0) return (BOOL)ierr(E_DAT);
        mni.fMask = MIIM_SUBMENU|MIIM_STRING;
        mni.hSubMenu = hm[n];
        mni.dwTypeData = (LPTSTR)tx[n];
        mni.cch = strlen(mni.dwTypeData);
        InsertMenuItem(hm[n-1], po[n-1]++, TRUE, &mni);
        n--;
      }
    }
  }
  if (n != 0) return (BOOL)ierr(E_DAT);
  return TRUE;
}

HMENU WINAPI CreateMenuBar(PCMNUS ms)
{ // j[̍쐬
  HMENU hmnu; return insmenuitems(hmnu = CreateMenu(), 0, ms)? hmnu: NULL;
}

BOOL WINAPI ChangeMenuBar(HMENU hmnu, int pos, PCMNUS ms)
{ // j[̕ύX
  if (!DeleteMenu(hmnu, pos, MF_BYPOSITION)) return FALSE;
  if (!insmenuitems(hmnu, pos, ms)) return FALSE;
  return TRUE;
}

void WINAPI MenuSlice(PINT p1, PINT p2, PCMNUS ms, int pos)
{ // j[͈̔
  int c, i, i1, i2, n;

  i1 = 0; i2 = ms->ni;
  for (c = n = i = 0; i < ms->ni; i++) {
    if (ms->mi[i].flg & mfP) {
      if (c == pos) i1 = i;  else if (c == pos + 1) i2 = i;
      if (n == 0) c++;
      n++;
    }
    if (ms->mi[i].flg & mfE) {
      n--;
    }
  }
  *p1 = i1; *p2 = i2;
}

// ---------------------------------------------------------------------- //

LRESULT LOCALF TIP_paint(HWND hwnd)
{ // c[`bv̕`
  int bkm, tco;
  HDC hdc;
  HBRUSH hbrs;
  HFONT hfnt;
  RECT rct;
  PAINTSTRUCT ps;

  GetClientRect(hwnd, &rct);
  hdc = BeginPaint(hwnd, &ps);
  bkm = SetBkMode(hdc, TRANSPARENT);
  FillRect(hdc, &rct, hbrs = CreateSolidBrush(GetSysColor(COLOR_INFOBK))); DeleteObject(hbrs);
  tco = SetTextColor(hdc, GetSysColor(COLOR_INFOTEXT));
  hfnt = SelectObject(hdc, AppFont(FID_SYS));
  OffsetRect(&rct, 1, 1);
  DrawText(hdc, WindowText(hwnd), -1, &rct, DT_NOPREFIX|DT_SINGLELINE|DT_VCENTER|DT_CENTER);
  SelectObject(hdc, hfnt);
  SetTextColor(hdc, tco);
  SetBkMode(hdc, bkm);
  EndPaint(hwnd, &ps);
  return 0;
}

LRESULT LOCALF TIP_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // c[`bṽEBhEvV[W
  switch (umsg) {
  case WM_ERASEBKGND:
    return 1;
  case WM_PAINT:
    return TIP_paint(hwnd);
  }
  return DefWindowProc(hwnd, umsg, wpa, lpa);
}

ATOM LOCALF RegisterBOLTIPClass(HINSTANCE hinst)
{ // c[`bvEBhENX̓o^
  WNDCLASSEX wcx;

  wcx.cbSize        = sizeof(WNDCLASSEX);
  wcx.style         = 0;
  wcx.lpfnWndProc   = TIP_WndProc;
  wcx.cbClsExtra    = 0;
  wcx.cbWndExtra    = 0;
  wcx.hInstance     = hinst;
  wcx.hIcon         = NULL;
  wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wcx.lpszMenuName  = NULL;
  wcx.lpszClassName = "BOLTIP";
  wcx.hIconSm       = wcx.hIcon;
  return RegisterClassEx(&wcx);
}

HWND WINAPI CreateToolTip(HWND hwnd, PCTIPI pi)
{ // c[`bv̍쐬
  HWND htip;
  HDC hdc;
  HFONT hfnt;
  SIZE siz;

  hdc = CreateIC("DISPLAY", NULL, NULL, NULL);
  hfnt = SelectObject(hdc, AppFont(FID_SYS));
  GetTextExtentPoint32(hdc, pi->txt, strlen(pi->txt), &siz);
  SelectObject(hdc, hfnt);
  DeleteDC(hdc);
  htip = CreateWindowEx(
    0,
    "BOLTIP",
    pi->txt,
    WS_POPUP|WS_BORDER,
    pi->x, pi->y,
    siz.cx + 7, siz.cy + 7,
    hwnd,
    NULL,
    WindowInstance(hwnd),
    NULL
  );
  ShowWindow(htip, SW_SHOWNA);
  return htip;
}

#define  IDHOVER  101

  // c[o[
typedef struct {
  PTOBI pi;
  int   ni;
  int   wh;
  int   ht;
  TIPI  tip;
  HWND  htip;
} TOBE;
typedef TOBE * PTOBE;

static WNDPROC OrgBtnProc;

LRESULT LOCALF AltBtnProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // I[i[`{^EBhEvV[W
  HWND hown;
  POINT pnt;

  switch (umsg) {
  case WM_MOUSEMOVE:
    pnt.x = LOWORD(lpa); pnt.y = HIWORD(lpa);
    ClientToScreen(hwnd, &pnt);
    ScreenToClient(hown = GetParent(hwnd), &pnt);
    SendMessage(hown, umsg, wpa, MAKEUINT(pnt.x, pnt.y));
    break;
  }
  return CallWindowProc(OrgBtnProc, hwnd, umsg, wpa, lpa);
}

void LOCALF ctlpos(PINT px, PINT py, PINT pw, PINT ph, PTOBE te, int i)
{ // Rg[̈ʒu
  int x, j, w, h;
  PTOBI pi, pe;

  x = TOBMGNW;
  for (pi = te->pi, pe = pi + i + 1; pi < pe; pi++) {
    j = 0;
    switch (LOWORD(pi->flg)) {
    case TOBI_SPACE:
      w = (short)HIWORD(pi->flg); h = 0; break;
    case TOBI_VLINE:
      x += TOBSEPW; w = TOBSEPW; h = te->wh - 4; break;
    case TOBI_BUTTON:
      x += TOBSEPW; w = TOBBTNW; h = TOBBTNH; break;
    case TOBI_SLEFT:   j = TOBMGNW; goto _L1;
    case TOBI_SCENTER: goto _L1;
    case TOBI_SRIGHT:  j = -TOBMGNW; _L1:
      x += TOBSEPW; w = HIWORD(pi->flg); h = TOBSTAH; break;
    }
    *px = x + j; x += w;
  }
  *py = (te->wh - h) / 2 + 1; *pw = w; *ph = h;
}

void LOCALF createctls(HWND hwnd, PTOBE te)
{ // VK쐬
  int x, y, w, h, sty;
  PCSTR cls;
  PTOBI pi, pe;
  HWND hctl;

  for (pi = te->pi, pe = pi + te->ni; pi < pe; pi++) {
    switch (LOWORD(pi->flg)) {
    case TOBI_BUTTON:  cls = "button"; sty = BS_OWNERDRAW;             goto _L1;
    case TOBI_SLEFT:   cls = "static"; sty = SS_CENTERIMAGE|SS_LEFT;   goto _L1;
    case TOBI_SCENTER: cls = "static"; sty = SS_CENTERIMAGE|SS_CENTER; goto _L1;
    case TOBI_SRIGHT:  cls = "static"; sty = SS_CENTERIMAGE|SS_RIGHT;  _L1:
      ctlpos(&x, &y, &w, &h, te, pi - te->pi); break;
    default:
      continue;
    }
    hctl = CreateWindowEx(
      0,
      cls,
      pi->txt,
      WS_CHILD|WS_VISIBLE|sty,
      x, y,
      w, h,
      hwnd,
      (HMENU)pi->idm,
      WindowInstance(hwnd),
      NULL
    );
    switch (LOWORD(pi->flg)) {
    case TOBI_BUTTON:
      OrgBtnProc = SubclassWindow(hctl, AltBtnProc); break;
    }
    SendMessage(hctl, WM_SETFONT, (WPARAM)AppFont(FID_SYS), FALSE);
  }
}

void LOCALF drawitem(HWND hwnd, int id, UINT typ, UINT sta)
{ // I[i[`
  HWND hctl;
  DRAWITEMSTRUCT dri;

  hctl = GetDlgItem(hwnd, id);
  dri.CtlType = typ;
  dri.CtlID = id;
  dri.itemID = 0;
  dri.itemAction = ODA_DRAWENTIRE;
  dri.itemState = IsWindowEnabled(hctl)? sta: ODS_DISABLED;
  dri.hwndItem = hctl;
  dri.hDC = GetDC(hctl);
  GetClientRect(hctl, &dri.rcItem);
  dri.itemData = 0;
  SendMessage(hwnd, WM_DRAWITEM, id, (LPARAM)&dri);
  ReleaseDC(hctl, dri.hDC);
}

LRESULT LOCALF TOB_create(HWND hwnd, LPARAM lpa)
{ // c[o[EBhEJn
  PTOBS ts = (PTOBS)((LPCREATESTRUCT)lpa)->lpCreateParams;
  PTOBE te;

  te = halloc(sizeof(TOBE) + ts->ni * sizeof(TOBI), TRUE); if (!te) { ierr(E_MEM); return -1;}
  SetWindowLong(hwnd, 0, (LONG)te);
  te->pi = (PVOID)((PBYTE)te + sizeof(TOBE));
  te->ni = ts->ni;
  te->wh = TOBWINH;
  memcpy(te->pi, ts->pi, ts->ni * sizeof(TOBI));
  createctls(hwnd, te);
  return 0;
}

LRESULT LOCALF TOB_resetitems(HWND hwnd, PTOBS ts, BOOL rd)
{ // Đݒ
  PTOBE te = (PTOBE)GetWindowLong(hwnd, 0), tx;
  PTOBI pi, pe;

  tx = halloc(sizeof(TOBE) + ts->ni * sizeof(TOBI), TRUE); if (!tx) { ierr(E_MEM); return -1;}
  *(TOBE *)tx = *(TOBE *)te;
  if (IsWindow(te->htip)) DestroyWindow(te->htip);
  for (pi = te->pi, pe = pi + te->ni; pi < pe; pi++) {
    switch (LOWORD(pi->flg)) {
    case TOBI_BUTTON:
    case TOBI_SLEFT:
    case TOBI_SCENTER:
    case TOBI_SRIGHT:
      DestroyWindow(GetDlgItem(hwnd, pi->idm)); break;
    default:
      continue;
    }
  }
  hfree(te);
  SetWindowLong(hwnd, 0, (LONG)tx);
  tx->pi = (PVOID)((PBYTE)tx + sizeof(TOBE));
  tx->ni = ts->ni;
  memcpy(tx->pi, ts->pi, ts->ni * sizeof(TOBI));
  createctls(hwnd, tx);
  if (rd) RedrawWindow(hwnd, NULL, NULL, RDW_INVALIDATE|RDW_ERASE|RDW_UPDATENOW);
  return 0;
}

LRESULT LOCALF TOB_size(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // TCYݒ
  MoveWindow(hwnd, 0, 0, LOWORD(lpa), ((PTOBE)GetWindowLong(hwnd, 0))->wh, TRUE);
  return 0;
}

LRESULT LOCALF TOB_paint(HWND hwnd)
{ // `
  PTOBE te = (PTOBE)GetWindowLong(hwnd, 0);
  int x, y, w, h;
  PTOBI pi, pe;
  HDC hdc;
  RECT rct;
  PAINTSTRUCT ps;

  hdc = BeginPaint(hwnd, &ps);
  for (pi = te->pi, pe = pi + te->ni; pi < pe; pi++) {
    switch (LOWORD(pi->flg)) {
    case TOBI_VLINE:
      ctlpos(&x, &y, &w, &h, te, pi - te->pi);
      SetRect(&rct, x + w / 2 - 1, y, x + w, y + h);
      DrawEdge(hdc, &rct, EDGE_ETCHED, BF_LEFT);
      break;
    }
  }
  EndPaint(hwnd, &ps);
  return 0;
}

LRESULT LOCALF TOB_drawitem(HWND hwnd, int id, LPDRAWITEMSTRUCT lp)
{ // I[i[`
  PTOBE te = (PTOBE)GetWindowLong(hwnd, 0);
  HBITMAP hbmp;
  RECT rct;

  switch (lp->CtlType) {
  case ODT_BUTTON:
    rct = lp->rcItem;
    FillRect(lp->hDC, &rct, GetSysColorBrush(COLOR_3DFACE));
    if (lp->itemState & ODS_HOTLIGHT) {
      DrawEdge(lp->hDC, &rct, BDR_RAISEDOUTER, BF_RECT);
    } else if (lp->itemState & ODS_SELECTED) {
      DrawEdge(lp->hDC, &rct, BDR_SUNKENOUTER, BF_RECT);
      OffsetRect(&rct, 1, 1);
      te->ht = 0;
    }
    if (!!(hbmp = MenuItemDDB(id))) {
      if (lp->itemState & ODS_DISABLED) {
        DrawDDB(lp->hDC, &rct, hbmp, DT_GRY|DT_CEN);
      } else {
        DrawDDB(lp->hDC, &rct, hbmp, DT_CEN);
      }
    }
    return TRUE;
  }
  return FALSE;
}

LRESULT LOCALF TOB_mousemove(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // }EXړ
  PTOBE te = (PTOBE)GetWindowLong(hwnd, 0);
  int x, y, w, h, ht = 0;
  PTOBI pi, pe;
  POINT pnt = { LOWORD(lpa), HIWORD(lpa) };

  for (pi = te->pi, pe = pi + te->ni; pi < pe; pi++) {
    ctlpos(&x, &y, &w, &h, te, pi - te->pi);
    if (pnt.x >= x && pnt.x < x + w && pnt.y >= y && pnt.y < y + h) {
      ht = MAKEUINT(LOWORD(pi->flg), pi - te->pi); break;
    }
  }
  if (ht != te->ht) {
    if (LOWORD(te->ht) == TOBI_BUTTON) {
      pi = &te->pi[HIWORD(te->ht)];
      drawitem(hwnd, pi->idm, ODT_BUTTON, 0);
    }
    te->tip.txt = NULL;
    if (LOWORD(ht) == TOBI_BUTTON) {
      pi = &te->pi[HIWORD(ht)];
      drawitem(hwnd, pi->idm, ODT_BUTTON, ODS_HOTLIGHT);
      te->tip.txt = stostr(WindowText(GetDlgItem(hwnd, pi->idm)));
    }
    te->ht = ht;
  }
  ClientToScreen(hwnd, &pnt);
  pnt.y += GetSystemMetrics(SM_CYCURSOR) / 2 + 2;
  if (te->tip.x != pnt.x || te->tip.y != pnt.y) {
    te->tip.x = pnt.x;
    te->tip.y = pnt.y;
    SetTimer(hwnd, IDHOVER, 500, NULL);
  }
  return 0;
}

LRESULT LOCALF TOB_timer(HWND hwnd, WPARAM wpa)
{ // ^C}[
  PTOBE te = (PTOBE)GetWindowLong(hwnd, 0);

  if (wpa == IDHOVER) {
    KillTimer(hwnd, IDHOVER);
    if (IsWindow(te->htip)) DestroyWindow(te->htip);
    if (te->tip.txt) te->htip = CreateToolTip(hwnd, &te->tip);
  }
  return 0;
}

LRESULT LOCALF TOB_command(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // R}h
  PTOBE te = (PTOBE)GetWindowLong(hwnd, 0);
  HWND hown;

  if (IsWindow(te->htip)) DestroyWindow(te->htip);
  te->tip.txt = NULL;
  SetFocus(hown = GetParent(hwnd));
  SendMessage(hown, WM_COMMAND, wpa, lpa);
  return 0;
}

LRESULT LOCALF TOB_destroy(HWND hwnd)
{ // c[o[EBhEI
  hfree((PTOBE)GetWindowLong(hwnd, 0));
  return 0;
}

LRESULT LOCALF TOB_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // c[o[̃EBhEvV[W
  switch (umsg) {
  case WM_CREATE:
    return TOB_create(hwnd, lpa);
  case TOBM_GETNITEMS:
    return ((PTOBE)GetWindowLong(hwnd, 0))->ni;
  case TOBM_GETITEMINFO:
    return (LRESULT)&((PTOBE)GetWindowLong(hwnd, 0))->pi[wpa];
  case TOBM_RESETITEMS:
    return TOB_resetitems(hwnd, (PTOBS)wpa, lpa);
  case WM_SIZE:
    return TOB_size(hwnd, wpa, lpa);
  case WM_PAINT:
    return TOB_paint(hwnd);
  case WM_DRAWITEM:
    return TOB_drawitem(hwnd, wpa, (LPDRAWITEMSTRUCT)lpa);
  case WM_MOUSEMOVE:
    return TOB_mousemove(hwnd, wpa, lpa);
  case WM_TIMER:
    return TOB_timer(hwnd, wpa);
  case WM_COMMAND:
    return TOB_command(hwnd, wpa, lpa);
  case WM_DESTROY:
    return TOB_destroy(hwnd);
  }
  return DefWindowProc(hwnd, umsg, wpa, lpa);
}

ATOM LOCALF RegisterBOLTOBClass(HINSTANCE hinst)
{ // c[o[EBhENX̓o^
  WNDCLASSEX wcx;

  wcx.cbSize        = sizeof(WNDCLASSEX);
  wcx.style         = 0;
  wcx.lpfnWndProc   = TOB_WndProc;
  wcx.cbClsExtra    = 0;
  wcx.cbWndExtra    = sizeof(LONG);
  wcx.hInstance     = hinst;
  wcx.hIcon         = NULL;
  wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wcx.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
  wcx.lpszMenuName  = NULL;
  wcx.lpszClassName = "BOLTOB";
  wcx.hIconSm       = wcx.hIcon;
  return RegisterClassEx(&wcx);
}

HWND WINAPI CreateToolBar(HWND hwnd, int id, PCTOBS ts)
{ // c[o[̍쐬
  return CreateWindowEx(
    0,
    "BOLTOB",
    "",
    WS_CHILD|WS_VISIBLE,
    0, 0,
    0, 0,
    hwnd,
    (HMENU)id,
    WindowInstance(hwnd),
    (LPVOID)ts
  );
}

LRESULT LOCALF STB_create(HWND hwnd, LPARAM lpa)
{ // Xe[^Xo[EBhEJn
  PTOBS ss = (PTOBS)((LPCREATESTRUCT)lpa)->lpCreateParams;
  PTOBE te;

  te = halloc(sizeof(TOBE) + ss->ni * sizeof(TOBI), TRUE); if (!te) { ierr(E_MEM); return -1;}
  SetWindowLong(hwnd, 0, (LONG)te);
  te->pi = (PVOID)((PBYTE)te + sizeof(TOBE));
  te->ni = ss->ni;
  te->wh = STBWINH;
  memcpy(te->pi, ss->pi, ss->ni * sizeof(TOBI));
  createctls(hwnd, te);
  return 0;
}

LRESULT LOCALF STB_size(HWND hwnd, WPARAM wpa, LPARAM lpa)
{ // TCYݒ
  MoveWindow(hwnd, 0, HIWORD(lpa) - ((PTOBE)GetWindowLong(hwnd, 0))->wh, LOWORD(lpa), HIWORD(lpa), TRUE);
  return 0;
}

LRESULT LOCALF STB_WndProc(HWND hwnd, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // Xe[^Xo[̃EBhEvV[W
  switch (umsg) {
  case WM_CREATE:
    return STB_create(hwnd, lpa);
  case WM_SIZE:
    return STB_size(hwnd, wpa, lpa);
  }
  return TOB_WndProc(hwnd, umsg, wpa, lpa);
}

ATOM LOCALF RegisterBOLSTBClass(HINSTANCE hinst)
{ // Xe[^Xo[EBhENX̓o^
  WNDCLASSEX wcx;

  wcx.cbSize        = sizeof(WNDCLASSEX);
  wcx.style         = 0;
  wcx.lpfnWndProc   = STB_WndProc;
  wcx.cbClsExtra    = 0;
  wcx.cbWndExtra    = sizeof(LONG);
  wcx.hInstance     = hinst;
  wcx.hIcon         = NULL;
  wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wcx.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
  wcx.lpszMenuName  = NULL;
  wcx.lpszClassName = "BOLSTB";
  wcx.hIconSm       = wcx.hIcon;
  return RegisterClassEx(&wcx);
}

HWND WINAPI CreateStatBar(HWND hwnd, int id, PCTOBS ss)
{ // Xe[^Xo[̍쐬
  return CreateWindowEx(
    0,
    "BOLSTB",
    "",
    WS_CHILD|WS_VISIBLE,
    0, 0,
    0, 0,
    hwnd,
    (HMENU)id,
    WindowInstance(hwnd),
    (LPVOID)ss
  );
}

// ---------------------------------------------------------------------- //

void WINAPI SetEINT(HWND hdlg, int id, int va)
{ // GfBbgRg[f[^ݒ()
  SetESTR(hdlg, id, format("%d", va));
}

int  WINAPI GetEINT(HWND hdlg, int id)
{ // GfBbgRg[f[^擾()
  char bf[256];

  GetESTR(hdlg, id, bf, sizeof(bf) - 1);
  return cztoi(bf);
}

void WINAPI SetEDBL(HWND hdlg, int id, REAL va)
{ // GfBbgRg[f[^ݒ()
  SetESTR(hdlg, id, format("%.15G", va));
}

REAL WINAPI GetEDBL(HWND hdlg, int id)
{ // GfBbgRg[f[^擾()
  char bf[256];

  GetESTR(hdlg, id, bf, sizeof(bf) - 1);
  return cztof(bf);
}

void WINAPI SetLSEL(HWND hdlg, int id, int ir, PCENMS ls)
{ // Xg{bNXf[^ݒ
  int i;

  SendDlgItemMessage(hdlg, id, WM_SETREDRAW, FALSE, 0);
  SendDlgItemMessage(hdlg, id, LB_RESETCONTENT, 0, 0);
  for (i = 0; i < ls->ni; i++) {
    SendDlgItemMessage(hdlg, id, LB_ADDSTRING, 0, (LPARAM)ls->ps[i]);
  }
  SendDlgItemMessage(hdlg, id, LB_SETCURSEL, ir, 0);
  SendDlgItemMessage(hdlg, id, WM_SETREDRAW, TRUE, 0);
  InvalidateRect(GetDlgItem(hdlg, id), NULL, TRUE);
}

int  WINAPI GetLSEL(HWND hdlg, int id)
{ // Xg{bNXf[^擾
  int i;

  i = SendDlgItemMessage(hdlg, id, LB_GETCURSEL, 0, 0);
  if (i < 0) i = 0;
  return i;
}

void WINAPI SetCSEL(HWND hdlg, int id, int ir, PCENMS ls)
{ // hbv_EXgf[^ݒ
  int i;

  SendDlgItemMessage(hdlg, id, CB_RESETCONTENT, 0, 0);
  for (i = 0; i < ls->ni; i++) {
    SendDlgItemMessage(hdlg, id, CB_ADDSTRING, 0, (LPARAM)ls->ps[i]);
  }
  SendDlgItemMessage(hdlg, id, CB_SETCURSEL, ir, 0);
}

int  WINAPI GetCSEL(HWND hdlg, int id)
{ // hbv_EXgf[^擾
  int i;

  i = SendDlgItemMessage(hdlg, id, CB_GETCURSEL, 0, 0);
  if (i < 0) i = 0;
  return i;
}

void WINAPI SetCCOD(HWND hdlg, int id, int va, PCCODS ls)
{ // hbv_EXgf[^ݒ(O/lyAgp)
  int i, i0 = 0;

  SendDlgItemMessage(hdlg, id, CB_RESETCONTENT, 0, 0);
  for (i = 0; i < ls->ni; i++) {
    if (ls->pv[i].va == va) i0 = i;
    SendDlgItemMessage(hdlg, id, CB_ADDSTRING, 0, (LPARAM)ls->pv[i].st);
  }
  SendDlgItemMessage(hdlg, id, CB_SETCURSEL, i0, 0);
}

int  WINAPI GetCCOD(HWND hdlg, int id, PCCODS ls)
{ // hbv_EXgf[^擾(O/lyAgp)
  int i;

  i = SendDlgItemMessage(hdlg, id, CB_GETCURSEL, 0, 0);
  if (i < 0) i = 0;
  return ls->pv[i].va;
}

void WINAPI SetCSTR(HWND hdlg, int id, PCSTR st, PCENMS ls)
{ // R{{bNXf[^ݒ
  int i;

  SendDlgItemMessage(hdlg, id, CB_RESETCONTENT, 0, 0);
  for (i = 0; i < ls->ni; i++) {
    SendDlgItemMessage(hdlg, id, CB_ADDSTRING, 0, (LPARAM)ls->ps[i]);
  }
  SetESTR(hdlg, id, st);
}

void WINAPI SetDLGI(PDLGI di, PCSTR cls, int sty, WORD x, WORD y, WORD w, WORD h, int id, PCSTR txt)
{ // _CAO{bNXڂ̐ݒ
  di->cls = cls; di->sty = sty; di->x = x; di->y = y; di->w = w; di->h = h; di->id = id; di->txt = txt;
}

PVOID LOCALF mkdlgtmp(PCDLGS ds, PCSTR cls, UINT sty)
{ // _CAO{bNXev[g̍쐬
  int n, f1, f2, f3, ni = ds->ni, sz, ptsz = TMPPTSZ;
  PCDLGI di, di0 = ds->di;
  PVOID lp, lp0;
  PCSTR tx, face = TMPFACE;

  f1 = (cls && cls[0] != '\0');
  f2 = (ds->tit && ds->tit[0] != '\0');
  f3 = (face[0] != '\0');
  sz = 20;
  if (f1) {
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, cls, -1, NULL, 0);
    sz += 2 * n;
  } else {
    sz += 2;
  }
  if (f2) {
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, ds->tit, -1, NULL, 0);
    sz += 2 * n;
  } else {
    sz += 2;
  }
  if (f3) {
    sz += 2;
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, face, -1, NULL, 0);
    sz += 2 * n;
  }
  if (sz & 2) sz += 2;
  for (di = di0; di < di0 + ni; di++) {
    tx = di->txt; if (!tx) tx = "";
    sz += 18;
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, di->cls, -1, NULL, 0);
    sz += 2 * n;
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, tx, -1, NULL, 0);
    sz += 2 * n;
    sz += 2;
    if (sz & 2) sz += 2;
  }
  lp = halloc(sz, FALSE); if (!lp) return ierr(E_MEM);
  lp0 = lp;
  *((PUINT)lp)++= sty | (f3? DS_SETFONT: 0) | DS_3DLOOK;
  *((PUINT)lp)++= 0;
  *((PWORD)lp)++ = (WORD)ni;
  *((PWORD)lp)++ = ds->x; *((PWORD)lp)++ = ds->y;
  *((PWORD)lp)++ = ds->w; *((PWORD)lp)++ = ds->h;
  *((PWORD)lp)++ = 0;
  if (f1) {
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, cls, -1, lp, 256);
    ((PSTR)lp) += 2 * n;
  } else {
    *((PWORD)lp)++ = 0;
  }
  if (f2) {
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, ds->tit, -1, lp, 256);
    ((PSTR)lp) += 2 * n;
  } else {
    *((PWORD)lp)++ = 0;
  }
  if (f3) {
    *((PWORD)lp)++ = (WORD)ptsz;
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, face, -1, lp, 256);
    ((PSTR)lp) += 2 * n;
  }
  if ((UINT)lp & 2) *((PWORD)lp)++ = 0;
  for (di = di0; di < di0 + ni; di++) {
    tx = di->txt; if (!tx) tx = "";
    *((PUINT)lp)++= di->sty;
    *((PUINT)lp)++= 0;
    *((PWORD)lp)++ = di->x; *((PWORD)lp)++ = di->y;
    *((PWORD)lp)++ = di->w; *((PWORD)lp)++ = di->h;
    *((PWORD)lp)++ = (WORD)di->id;
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, di->cls, -1, lp, 256);
    ((PSTR)lp) += 2 * n;
    n = MultiByteToWideChar(CP_OEMCP, MB_PRECOMPOSED, tx, -1, lp, 256);
    ((PSTR)lp) += 2 * n;
    *((PWORD)lp)++ = 0;
    if ((UINT)lp & 2) *((PWORD)lp)++ = 0;
  }
  return lp0;
}

int  WINAPI DlgBoxInput(HWND hwnd, PCDLGS ds, DLGPROC lpfn, LPARAM lpa)
{ // [__CAO{bNX
  int re;
  PVOID lp;

  lp = mkdlgtmp(ds, NULL, wsDlg); if (!lp) return -1;
  re = DialogBoxIndirectParam(WindowInstance(hwnd), lp, hwnd, lpfn, lpa);
  UpdateWindow(hwnd);
  hfree(lp);
  return re;
}

HWND WINAPI CreateDlgBox(HWND hwnd, PCDLGS ds, DLGPROC lpfn, LPARAM lpa)
{ // [hX_CAO{bNX
  PVOID lp;
  HWND hdlg;

  lp = mkdlgtmp(ds, NULL, wsMls); if (!lp) return NULL;
  hdlg = CreateDialogIndirectParam(WindowInstance(hwnd), lp, hwnd, lpfn, lpa);
  hfree(lp);
  return hdlg;
}

int  WINAPI PropSheetInput(HWND hwnd, PCPSHS ps, int ip)
{ // vpeBV[g
  int i, re;
  PPSHI pp;
  PVOID lp, pa[32];

  for (i = 0, pp = ps->pp; i < ps->np; i++, pp++) {
    if (pp->psz) {
      pa[i] = halloc(pp->psz, FALSE); if (!pa[i]) { ierr(E_MEM); re = -1; goto _L1;}
      memcpy(pa[i], (PVOID)pp->lpa, pp->psz);
    } else {
      *(LPARAM *)&pa[i] = pp->lpa;
    }
  }
 _L0:
  pp = &ps->pp[ip];
  lp = mkdlgtmp(pp->ds, NULL, wsDlg); if (!lp) { re = -1; goto _L1;}
  re = DialogBoxIndirectParam(WindowInstance(hwnd), lp, hwnd, pp->lpfn, (LPARAM)pa[ip]);
  hfree(lp);
  if (re >= IDPSH && re < IDPSH + ps->np) { ip = re - IDPSH; goto _L0;}
 _L1:
  for (i--, pp = &ps->pp[i]; i >= 0; i--, pp--) {
    if (re == IDOK) {
      if (pp->psz) {
        memcpy((PVOID)pp->lpa, pa[i], pp->psz);
      } else {
        pp->lpa = *(LPARAM *)&pa[i];
      }
    }
    if (pp->psz) hfree(pa[i]);
  }
  UpdateWindow(hwnd);
  return re;
}

void LOCALF SetMBTN(PDLGI di, int x, int y, int id)
{ // bZ[W{bNX̃{^ݒ
  static DLGI btn[] = {                                    // id
    { C_BDEF|wsGT, 0, 0, 48, 14, IDOK,     "OK" },         //  1
    { C_BPSH|wsT,  0, 0, 48, 14, IDCANCEL, "LZ" }, //  2
    { C_BDEF|wsGT, 0, 0, 48, 14, IDABORT,  "~(&A)" },   //  3
    { C_BPSH|wsT,  0, 0, 48, 14, IDRETRY,  "Ďs(&R)" }, //  4
    { C_BPSH|wsT,  0, 0, 48, 14, IDIGNORE, "(&I)" },   //  5
    { C_BDEF|wsGT, 0, 0, 48, 14, IDYES,    "͂(&Y)" },   //  6
    { C_BPSH|wsT,  0, 0, 48, 14, IDNO,     "(&N)" }, //  7
  };

  *di = btn[id - 1]; di->x = x; di->y = y;
}

BOOL LOCALF MSG_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // bZ[W{bNX_CAOvV[W
  switch (umsg) {
  case WM_INITDIALOG:
    if (lpa) SendDlgItemMessage(hdlg, 101, STM_SETIMAGE, IMAGE_ICON, lpa);
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    switch (wpa) {
    case IDOK:
    case IDCANCEL:
    case IDABORT:
    case IDRETRY:
    case IDIGNORE:
    case IDYES:
    case IDNO:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

int  WINAPI MsgBox(HWND hwnd, PCSTR st, PCSTR ca, int flg)
{ // bZ[W{bNX
  int re;
  HICON hico;
  PDLGI di;
  static DLGI dit[5];
  static DLGS dlg = { dit, };

  if (!hwnd) return MessageBox(NULL, st, ca, flg);
  switch (flg & 0xf0) {
  default:
    hico = NULL; break;
  case MB_ICONERROR:
    hico = LoadIcon(NULL, IDI_ERROR); break;
  case MB_ICONQUESTION:
    hico = LoadIcon(NULL, IDI_QUESTION); break;
  case MB_ICONWARNING:
    hico = LoadIcon(NULL, IDI_WARNING); break;
  case MB_ICONINFORMATION:
    hico = LoadIcon(NULL, IDI_INFORMATION); break;
  }
  dlg.w = 208;
  dlg.h =  80;
  dlg.tit = ca? ca: WindowText(hwnd);
  di = dlg.di;
  if (hico) {
    SetDLGI(di++, C_SICO|wsG,  8, 10, 24, 24, 101, "");
    SetDLGI(di++, C_SMUL|wsG, 32, 14, dlg.w - 40, 40, -1, st);
  } else {
    SetDLGI(di++, C_SMUL|wsG,  8, 14, dlg.w - 16, 40, -1, st);
  }
  switch (flg & 0x0f) {
  default:
    SetMBTN(di++, dlg.w - 54, dlg.h - 20, 1);
    break;
  case MB_OKCANCEL:
    SetMBTN(di++, dlg.w -106, dlg.h - 20, 1);
    SetMBTN(di++, dlg.w - 54, dlg.h - 20, 2);
    break;
  case MB_ABORTRETRYIGNORE:
    SetMBTN(di++, dlg.w -158, dlg.h - 20, 3);
    SetMBTN(di++, dlg.w -106, dlg.h - 20, 4);
    SetMBTN(di++, dlg.w - 54, dlg.h - 20, 5);
    break;
  case MB_YESNOCANCEL:
    SetMBTN(di++, dlg.w -158, dlg.h - 20, 6);
    SetMBTN(di++, dlg.w -106, dlg.h - 20, 7);
    SetMBTN(di++, dlg.w - 54, dlg.h - 20, 2);
    break;
  case MB_YESNO:
    SetMBTN(di++, dlg.w -106, dlg.h - 20, 6);
    SetMBTN(di++, dlg.w - 54, dlg.h - 20, 7);
    break;
  }
  dlg.ni = di - dlg.di;
  re = DlgBoxInput(hwnd, &dlg, MSG_DlgProc, (LPARAM)hico);
  if (re == IDCANCEL) {
    switch (flg & 0x0f) {
    case MB_OK:
      re = IDOK; break;
    case MB_ABORTRETRYIGNORE:
      re = IDABORT; break;
    case MB_YESNO:
      re = IDNO; break;
    }
  }
  return re;
}

int  WINAPI OkBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_OK);
}

int  WINAPI OkCanBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_OKCANCEL);
}

int  WINAPI YesNoBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_YESNO);
}

int  WINAPI YesNoCanBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_YESNOCANCEL);
}

int  WINAPI ErrorBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_ICONERROR|MB_OK);
}

int  WINAPI WarningBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_ICONWARNING|MB_YESNO);
}

int  WINAPI AlertBox(HWND hwnd, PCSTR st, PCSTR ca)
{ // bZ[W{bNX
  return MsgBox(hwnd, st, ca, MB_ICONWARNING|MB_ABORTRETRYIGNORE);
}

int  WINAPI ResultBox(HWND hwnd, PCSTR st, PCSTR ca, BOOL re)
{ // bZ[W{bNX
  return (re? OkBox: ErrorBox)(hwnd, format(re? "%s܂B": "%sɎs܂B", st), ca);
}

BOOL LOCALF AltErrorBox(PCSTR em, UINT er, PCSTR fn, UINT lo)
{ // G[bZ[W\
  HWND hwnd = error_message_box_owner();
  char msg[512];

  return MsgBox(hwnd, error_reporting_message(msg, em, er, fn, lo), NULL, MB_ICONERROR|MB_OKCANCEL) == IDOK;
}

BOOL WINAPI OpenFileDlgBox(HWND hwnd, POFNS os)
{ // J_CAO{bNX
  int re;
  OPENFILENAME ofn;

  memset(&ofn, 0, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = hwnd;
  ofn.lpstrFilter = os->fil;
  ofn.nFilterIndex = os->idx;
  ofn.lpstrFile = os->nam;
  ofn.nMaxFile = 256;
  ofn.Flags = os->flg;
  re = GetOpenFileName(&ofn);
  os->idx = ofn.nFilterIndex;
  os->flg = ofn.Flags;
  UpdateWindow(hwnd);
  return re;
}

BOOL WINAPI SaveFileDlgBox(HWND hwnd, POFNS os)
{ // ۑ_CAO{bNX
  int re;
  OPENFILENAME ofn;

  memset(&ofn, 0, sizeof(OPENFILENAME));
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = hwnd;
  ofn.lpstrFilter = os->fil;
  ofn.nFilterIndex = os->idx;
  ofn.lpstrFile = os->nam;
  ofn.nMaxFile = 256;
  ofn.Flags = os->flg;
  re = GetSaveFileName(&ofn);
  os->idx = ofn.nFilterIndex;
  os->flg = ofn.Flags;
  UpdateWindow(hwnd);
  return re;
}

BOOL WINAPI PrintDlgBox(HWND hwnd, PPRDS ps)
{ // _CAO{bNX
  int re, fi;
  LPDEVMODE dm;
  PRINTDLG prd;

  memset(&prd, 0, sizeof(PRINTDLG));
  prd.lStructSize = sizeof(PRINTDLG);
  prd.hwndOwner = hwnd;
  prd.Flags = PD_RETURNDEFAULT;
  prd.nFromPage = ps->nf;
  prd.nToPage = ps->nt;
  prd.nMinPage = 1;
  prd.nMaxPage = ps->np;
  prd.nCopies = ps->nc;
  re = PrintDlg(&prd); if (!re) goto _L1;
  if (prd.hDevMode && !!(dm = GlobalLock(prd.hDevMode))) {
    fi = dm->dmFields;
    if (fi & DM_PAPERSIZE)   dm->dmPaperSize   = ps->psz;
    if (fi & DM_ORIENTATION) dm->dmOrientation = ps->ori;
    if (fi & DM_PAPERWIDTH)  dm->dmPaperWidth  = ps->wid;
    if (fi & DM_PAPERLENGTH) dm->dmPaperLength = ps->len;
    GlobalUnlock(prd.hDevMode);
  }
  prd.Flags = ps->flg;
  re = PrintDlg(&prd); if (!re) goto _L1;
  ps->hdc = prd.hDC;
  ps->flg = prd.Flags;
  ps->nf = prd.nFromPage;
  ps->nt = prd.nToPage;
  ps->nc = prd.nCopies;
  if (prd.hDevMode && !!(dm = GlobalLock(prd.hDevMode))) {
    fi = dm->dmFields;
    if (fi & DM_PAPERSIZE)   ps->psz = dm->dmPaperSize;
    if (fi & DM_ORIENTATION) ps->ori = dm->dmOrientation;
    if (fi & DM_PAPERWIDTH)  ps->wid = dm->dmPaperWidth;
    if (fi & DM_PAPERLENGTH) ps->len = dm->dmPaperLength;
    GlobalUnlock(prd.hDevMode);
  }
 _L1:
  UpdateWindow(hwnd);
  return re;
}

typedef struct {
  PCSTR st;
  int   wid;
  int   hei;
  int   hmg;
  int   vmg;
} PAPI;
  // pTCY
static PAPI PAP[] = {
  { "`R (297 x 420 mm)", 297, 420, 20, 25 },
  { "aS (257 x 364 mm)", 257, 364, 20, 25 },
  { "`S (210 x 297 mm)", 210, 297, 20, 25 },
  { "aT (182 x 257 mm)", 182, 257, 20, 25 },
  { "`T (148 x 210 mm)", 148, 210, 20, 25 },
  { "aU (128 x 182 mm)", 128, 182, 20, 25 },
  { "`U (105 x 148 mm)", 105, 148, 20, 25 },
};

  // pݒ
typedef struct {
  int   SZ, PO, EA, AJ;
  REAL  SC;
  REAL  OW, AW;
  REAL  LM, TM, RM, BM;
} PSDP;
typedef PSDP * PPSDP;
typedef const PSDP * PCPSDP;

void LOCALF getPSD(PPSDP pa, PCPSDS ps)
{ // pݒ̎擾
  int i, w;

  pa->SZ = 2;
  pa->PO = (ps->oph >= ps->opw);
  w = (pa->PO)? ps->opw / 1000: ps->oph / 1000;
  for (i = 0; i < NELEM(PAP); i++) {
    if (PAP[i].wid == w) { pa->SZ = i; break;}
  }
  pa->EA = (ps->apw > 0);
  pa->AJ = ps->adj;
  if (pa->EA && (pa->AJ & RSW_AUT)) {
    pa->SC = (REAL)ps->opw / (REAL)(ps->lpm + ps->apw + ps->rpm);
  } else {
    pa->SC = (REAL)ps->opw / (REAL)ps->ppw;
  }
  pa->SC = iround(pa->SC * 1000.0) * 0.001;
  if (pa->SC <= 0.01 || pa->SC >= 100.0) pa->SC = 1.0;
  pa->OW = ps->opw * 0.001;
  pa->AW = ps->apw * 0.001;
  pa->LM = ps->lpm * 0.001;
  pa->TM = ps->tpm * 0.001;
  pa->RM = ps->rpm * 0.001;
  pa->BM = ps->bpm * 0.001;
}

void LOCALF setPSD(PPSDS ps, PCPSDP pa)
{ // pݒ̊i[
  if (pa->PO) {
    ps->opw = PAP[pa->SZ].wid * 1000;
    ps->oph = PAP[pa->SZ].hei * 1000;
  } else {
    ps->opw = PAP[pa->SZ].hei * 1000;
    ps->oph = PAP[pa->SZ].wid * 1000;
  }
  ps->adj = pa->AJ;
  ps->ppw = iround(ps->opw / pa->SC);
  ps->pph = iround(ps->oph / pa->SC);
  ps->lpm = iround(pa->LM * 1000.0);
  ps->tpm = iround(pa->TM * 1000.0);
  ps->rpm = iround(pa->RM * 1000.0);
  ps->bpm = iround(pa->BM * 1000.0);
}

void LOCALF SetCPAP(HWND hdlg, int id, int sz)
{ // hbv_EXgf[^ݒ(pTCY)
  int i;

  SendDlgItemMessage(hdlg, id, CB_RESETCONTENT, 0, 0);
  for (i = 0; i < NELEM(PAP); i++) {
    SendDlgItemMessage(hdlg, id, CB_ADDSTRING, 0, (LPARAM)PAP[i].st);
  }
  SendDlgItemMessage(hdlg, id, CB_SETCURSEL, sz, 0);
}

BOOL LOCALF PSD_DlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // pݒ_CAOvV[W
  PSDP *pa;
  REAL sc, lm, rm;

  switch (umsg) {
  case WM_INITDIALOG:
    SetWindowLong(hdlg, DWL_USER, (LONG)(pa = (PSDP *)lpa));
    SetCPAP(hdlg, 101, pa->SZ);
    SetBSEL(hdlg, 102, pa->PO);
    SetBSEL(hdlg, 103, !GetBSEL(hdlg, 102));
    SetEDBL(hdlg, 104, pa->TM);
    SetEDBL(hdlg, 105, pa->LM);
    SetEDBL(hdlg, 106, pa->RM);
    SetEDBL(hdlg, 107, pa->BM);
    SetBSEL(hdlg, 108, pa->AJ & RSW_AUT);
    SetBSEL(hdlg, 109, !GetBSEL(hdlg, 108));
    SetEDBL(hdlg, 110, (REAL)iround(pa->SC * 100.0));
    EnableDlgItem(hdlg, 108, pa->EA);
    EnableDlgItem(hdlg, 110, GetBSEL(hdlg, 109));
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    pa = (PSDP *)GetWindowLong(hdlg, DWL_USER);
    switch (wpa) {
    case 108:
    case 109:
      if (GetBSEL(hdlg, 108)) {
        lm = GetEDBL(hdlg, 105); rm = GetEDBL(hdlg, 106);
        sc = pa->OW / (lm + pa->AW + rm);
        SetEDBL(hdlg, 110, (REAL)iround(sc * 100.0));
      }
      EnableDlgItem(hdlg, 110, GetBSEL(hdlg, 109));
      break;
    case MAKEUINT(110, EN_KILLFOCUS):
      sc = GetEDBL(hdlg, 110) * 0.01; if (sc <= 0.01 || sc >= 100.0) sc = 1.0;
      SetEDBL(hdlg, 110, (REAL)iround(sc * 100.0));
      break;
    case IDOK:
      pa->SZ = GetCSEL(hdlg, 101);
      pa->PO = GetBSEL(hdlg, 102);
      pa->TM = GetEDBL(hdlg, 104);
      pa->LM = GetEDBL(hdlg, 105);
      pa->RM = GetEDBL(hdlg, 106);
      pa->BM = GetEDBL(hdlg, 107);
      if (GetBSEL(hdlg, 108)) pa->AJ |= RSW_AUT;  else pa->AJ &=~RSW_AUT;
      pa->SC = GetEDBL(hdlg, 110) * 0.01; if (pa->SC <= 0.01 || pa->SC >= 100.0) pa->SC = 1.0;
      // fall through
    case IDCANCEL:
      EndDialog(hdlg, wpa);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

BOOL WINAPI PageSetupDlgBox(HWND hwnd, PPSDS ps)
{ // pݒ_CAO{bNX
  int re = TRUE;
  PSDP par;
  static DLGI dit[] = {
    { C_BGRP|wsG,   6,  6,212, 44,  -1, "p" },
    { C_SLFT|wsG,  14, 18, 40,  8,  -1, "TCY(&Z):" },
    { C_CSEL|wsT,  54, 16,112,128, 101, "" },
    { C_SLFT|wsG,  14, 34, 40,  8,  -1, "@:" },
    { C_BSEL|wsGT, 54, 33, 48, 10, 102, "c(&P)" },
    { C_BSEL|ws_, 102, 33, 48, 10, 103, "(&A)" },
    { C_BGRP|wsG,   6, 54,212, 44,  -1, "](mm)" },
    { C_SLFT|wsG,  82, 66, 28,  8,  -1, "(&T):" },
    { C_ENUM|wsT, 110, 64, 28, 12, 104, "" },
    { C_SLFT|wsG,  14, 74, 28,  8,  -1, "(&L):" },
    { C_ENUM|wsT,  42, 72, 28, 12, 105, "" },
    { C_SLFT|wsG, 150, 74, 28,  8,  -1, "E(&R):" },
    { C_ENUM|wsT, 178, 72, 28, 12, 106, "" },
    { C_SLFT|wsG,  82, 82, 28,  8,  -1, "(&B):" },
    { C_ENUM|wsT, 110, 80, 28, 12, 107, "" },
    { C_BGRP|wsG,   6,102,212, 44,  -1, "gk" },
    { C_BSEL|wsGT, 14,113, 80, 10, 108, "ɍ킹(&J)" },
    { C_BSEL|ws_,  14,129, 50, 10, 109, "{@(&S):" },
    { C_ENUM|wsT,  64,128, 32, 12, 110, "" },
    { C_SLFT|wsG,  97,130, 16,  8,  -1, "" },
    { C_BDEF|wsGT,118,172, 48, 14, IDOK, "OK" },
    { C_BPSH|wsT, 170,172, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 224, 192, "pݒ" };

  getPSD(&par, ps);
  if (!(ps->adj & RSW_SKP)) re = (DlgBoxInput(hwnd, &dlg, PSD_DlgProc, (LPARAM)&par) == IDOK);
  if (re) setPSD(ps, &par);
  return re;
}

// ---------------------------------------------------------------------- //

  // |[g
typedef struct {
  CVSE  cvse;
  HWND  hown;
  int   npg;
  FREP  frep;
  UINT  par;
  UINT  ext;
  UINT  rsv;
  int   adj;  // -+
  int   apw;  //  |
  int   opw;  //  |
  int   oph;  //  |
  int   ppw;  //  |
  int   pph;  //  |
  int   lpm;  //  |
  int   tpm;  //  |
  int   rpm;  //  |= PSDS
  int   bpm;  // -+
  int   phh;
  int   pfh;
  int   csf, lsf;
  int   pid, cid;
  int   bph, aph;
  int   tal, fiw;
  int   liw, riw;
  int   sta;
  int   rsr;
  int   rtm;
  char  tit[32];
  char  usr[32];
} REPE;
typedef REPE * PREPE;

HREP WINAPI CreateReport(PCREPI ri)
{ // |[g쐬
  int flg;
  PREPE rp;

  if (!ri->frep) return NULL;
  rp = (PREPE)CreateCanvas(NULL, sizeof(REPE) - sizeof(CVSE)); if (!rp) return NULL;
  rp->npg = 1;
  rp->frep = ri->frep;
  rp->par = ri->pa;
  flg = ri->flg;
  if (!(flg & 0x08)) {
    rp->opw = PAP[flg & 0x07].wid * 1000;
    rp->oph = PAP[flg & 0x07].hei * 1000;
  } else {
    rp->opw = PAP[flg & 0x07].hei * 1000;
    rp->oph = PAP[flg & 0x07].wid * 1000;
  }
  rp->ppw = rp->opw;
  rp->pph = rp->oph;
  rp->lpm = rp->rpm = (PAP[flg & 0x07].hmg + (1 - ((flg & 0x80)>>6))*((flg & 0x70)>>3)) * 1000;
  rp->tpm = rp->bpm = (PAP[flg & 0x07].vmg + (1 - ((flg & 0x80)>>6))*((flg & 0x70)>>3)) * 1000;
  rp->phh = (rp->tpm > 5000)? rp->tpm - 5000: 0;
  rp->pfh = (rp->bpm > 5000)? rp->bpm - 5000: 0;
  rp->csf = 250;
  rp->lsf = 1300;
  if (ri->tit) strcpyn(rp->tit, ri->tit, sizeof(rp->tit) - 1);
  if (!rp->frep((HREP)rp, REPM_CREATE, 0, rp->par)) { DeleteCanvas((HREP)rp); return NULL;}
  return (HREP)rp;
}

void WINAPI DeleteReport(HREP rp)
{ // |[g폜
  if (!rp) return;
  ((PREPE)rp)->frep(rp, REPM_DESTROY, 0, ((PREPE)rp)->par);
  DeleteCanvas(rp);
}

HWND WINAPI hWND(HREP rp)
{ // eEBhẼnh
  return ((PREPE)rp)->hown;
}

void WINAPI SetReportInfo(HREP rp, PCSTR tit, PCSTR usr, int sr, int tm)
{ // ^CgA쐬ҁA쐬A쐬̐ݒ
  if (tit) strcpyx(((PREPE)rp)->tit, tit, sizeof(((PREPE)rp)->tit) - 1);
  if (usr) strcpyx(((PREPE)rp)->usr, usr, sizeof(((PREPE)rp)->usr) - 1);
  if (sr) ((PREPE)rp)->rsr = sr;
  if (tm) ((PREPE)rp)->rtm = tm;
}

PCSTR WINAPI ReportTitle(HREP rp)
{ // ^Cg
  return ((PREPE)rp)->tit;
}

PCSTR WINAPI ReportAuthor(HREP rp)
{ // 쐬
  return ((PREPE)rp)->usr;
}

int  WINAPI ReportDate(HREP rp)
{ // 쐬
  return ((PREPE)rp)->rsr;
}

int  WINAPI ReportTime(HREP rp)
{ // 쐬
  return ((PREPE)rp)->rtm;
}

void WINAPI SetReportExtra(HREP rp, UINT pa)
{ // |[g̕tݒ
  ((PREPE)rp)->ext = pa;
}

UINT WINAPI ReportExtra(HREP rp)
{ // |[g̕t
  return ((PREPE)rp)->ext;
}

void WINAPI SetNPages(HREP rp, int npg)
{ // y[Wݒ
  if (npg > 0) ((PREPE)rp)->npg = npg;
}

int  WINAPI NPages(HREP rp)
{ // y[W
  return ((PREPE)rp)->npg;
}

void WINAPI SetPaperSize(HREP rp, REAL w, REAL h, REAL scl)
{ // o͗pTCYƔ{̐ݒ
  if (scl <= 0.01 || scl >= 100.0) scl = 1.0;
  ((PREPE)rp)->opw = iround(w * 1000.0);
  ((PREPE)rp)->oph = iround(h * 1000.0);
  ((PREPE)rp)->ppw = iround((w / scl) * 1000.0);
  ((PREPE)rp)->pph = iround((h / scl) * 1000.0);
}

REAL WINAPI PaperWidth(HREP rp)
{ // o͗pTCY
  return ((PREPE)rp)->opw * 0.001;
}

REAL WINAPI PaperHeight(HREP rp)
{ // o͗pcTCY
  return ((PREPE)rp)->oph * 0.001;
}

void WINAPI SetPageSize(HREP rp, REAL w, REAL h)
{ // epTCYݒ
  SetPaperSize(rp, w, h, 1.0);
}

REAL WINAPI PageWidth(HREP rp)
{ // epTCY
  return ((PREPE)rp)->ppw * 0.001;
}

REAL WINAPI PageHeight(HREP rp)
{ // epcTCY
  return ((PREPE)rp)->pph * 0.001;
}

REAL WINAPI PageLeft(HREP rp)
{ // ep[
  return -OriginX(rp);
}

REAL WINAPI PageTop(HREP rp)
{ // ep[
  return -OriginY(rp);
}

REAL WINAPI PageRight(HREP rp)
{ // epE[
  return (((PREPE)rp)->ppw * 0.001) - OriginX(rp);
}

REAL WINAPI PageBottom(HREP rp)
{ // ep[
  return (((PREPE)rp)->pph * 0.001) - OriginY(rp);
}

void WINAPI SetPageMargin(HREP rp, REAL lm, REAL tm, REAL rm, REAL bm)
{ // p̗]TCYݒ
  ((PREPE)rp)->lpm = iround(lm * 1000.0); ((PREPE)rp)->tpm = iround(tm * 1000.0);
  ((PREPE)rp)->rpm = iround(rm * 1000.0); ((PREPE)rp)->bpm = iround(bm * 1000.0);
  ((PREPE)rp)->phh = (((PREPE)rp)->tpm > 500)? ((PREPE)rp)->tpm - 500: 0;
  ((PREPE)rp)->pfh = (((PREPE)rp)->bpm > 500)? ((PREPE)rp)->bpm - 500: 0;
}

REAL WINAPI BodyWidth(HREP rp)
{ // {̈扡TCY
  return (((PREPE)rp)->ppw - ((PREPE)rp)->lpm - ((PREPE)rp)->rpm) * 0.001;
}

REAL WINAPI BodyHeight(HREP rp)
{ // {̈cTCY
  return (((PREPE)rp)->pph - ((PREPE)rp)->tpm - ((PREPE)rp)->bpm) * 0.001;
}

REAL WINAPI BodyLeft(HREP rp)
{ // {̈捶[
  return ((PREPE)rp)->lpm * 0.001 - OriginX(rp);
}

REAL WINAPI BodyTop(HREP rp)
{ // {̈[
  return ((PREPE)rp)->tpm * 0.001 - OriginY(rp);
}

REAL WINAPI BodyRight(HREP rp)
{ // {̈E[
  return (((PREPE)rp)->ppw - ((PREPE)rp)->rpm) * 0.001 - OriginX(rp);
}

REAL WINAPI BodyBottom(HREP rp)
{ // {̈扺[
  return (((PREPE)rp)->pph - ((PREPE)rp)->bpm) * 0.001 - OriginY(rp);
}

void WINAPI SetHeaderHeight(HREP rp, REAL hh)
{ // wb_̈捂ݒ
  ((PREPE)rp)->phh = iround(hh * 1000.0);
}

void WINAPI SetFooterHeight(HREP rp, REAL fh)
{ // tb^̈捂ݒ
  ((PREPE)rp)->pfh = iround(fh * 1000.0);
}

REAL WINAPI HeaderHeight(HREP rp)
{ // wb_̈捂
  return ((PREPE)rp)->phh * 0.001;
}

REAL WINAPI HeaderTop(HREP rp)
{ // wb_̈[
  return BodyTop(rp) - ((PREPE)rp)->phh * 0.001;
}

REAL WINAPI FooterHeight(HREP rp)
{ // tb^̈捂
  return ((PREPE)rp)->pfh * 0.001;
}

REAL WINAPI FooterBottom(HREP rp)
{ // tb^̈扺[
  return BodyBottom(rp) + ((PREPE)rp)->phh * 0.001;
}

void WINAPI SetReqBodyWidth(HREP rp, REAL w, int sw)
{ // 킹lݒ
  ((PREPE)rp)->adj = sw;
  ((PREPE)rp)->apw = iround(w * 1000.0);
}

REAL WINAPI ReqBodyWidth(HREP rp)
{ // 킹l
  return ((PREPE)rp)->apw * 0.001;
}

PCELL WINAPI PageCell(PCELL pc, HREP rp)
{ // ep`
  return SetCell(pc, PageLeft(rp), PageTop(rp), PageRight(rp), PageBottom(rp));
}

PCELL WINAPI BodyCell(PCELL pc, HREP rp)
{ // {̈`
  return SetCell(pc, BodyLeft(rp), BodyTop(rp), BodyRight(rp), BodyBottom(rp));
}

PCELL WINAPI HeaderCell(PCELL pc, HREP rp)
{ // wb_̈`
  return SetCell(pc, HeaderLeft(rp), HeaderTop(rp), HeaderRight(rp), HeaderBottom(rp));
}

PCELL WINAPI FooterCell(PCELL pc, HREP rp)
{ // tb^̈`
  return SetCell(pc, FooterLeft(rp), FooterTop(rp), FooterRight(rp), FooterBottom(rp));
}

#define  CRLF  0x0a0d

static char LTAG[4] = "";
static char PTAG[4] = "";
static char LBRA[4] = "";
static char RBRA[4] = "";

void WINAPI SetLineBreakTag(PCSTR lbt)
{ // s^O̐ݒ
  *(WORD *)LTAG = *(WORD *)lbt;
}

PCSTR WINAPI LineBreakTag(void)
{ // s^O
  return LTAG;
}

void WINAPI SetPageBreakTag(PCSTR pbt)
{ // y[W^O̐ݒ
  *(WORD *)PTAG = *(WORD *)pbt;
}

PCSTR WINAPI PageBreakTag(void)
{ // y[W^O
  return PTAG;
}

void WINAPI SetBrackets(PCSTR lbr, PCSTR rbr)
{ // ^Oʂ̐ݒ
  *(WORD *)LBRA = *(WORD *)lbr;
  *(WORD *)RBRA = *(WORD *)rbr;
}

PCSTR WINAPI BracketL(void)
{ // ^O
  return LBRA;
}

PCSTR WINAPI BracketR(void)
{ // ^OE
  return RBRA;
}

#define  KINSTR  "BACDjlnprtvxz"

BOOL LOCALF IsKinsoku(PCSTR pt)
{ // s֑
  PCSTR st = KINSTR;

  while (*st != '\0') {
    if (iszen(st)) {
      if (*(WORD *)pt == *((WORD *)st)++) return TRUE;
    } else {
      if ((BYTE)*pt == (BYTE)*st++) return TRUE;
    }
  }
  return *(WORD *)pt == CRLF || *(WORD *)pt == *(WORD *)LTAG || *(WORD *)pt == *(WORD *)PTAG;
}

void WINAPI CloseBrackets(PCSTR *pp, BOOL sw)
{ // ^ȌI܂ŃXLbv
  PCSTR st = *pp;

  while (*st != '\0') {
    if (*(WORD *)st == *(WORD *)RBRA) { st += 2; goto _L1;}
    else if (iszen(st)) st += 2;
    else st++;
  }
  ierr(E_DAT); goto _L2;
 _L1: if (sw && *(WORD *)st == CRLF) st += 2;
 _L2: *pp = st;
}

void WINAPI SetSpacingFactor(HREP rp, REAL csf, REAL lsf)
{ // Ԓ{Assb`{̐ݒ
  if (csf < 0.0 || csf > 2.0) csf = 0.0;  else if (csf > 1.0) csf -= 1.0;
  if (lsf < 0.0 || lsf > 2.0) lsf = 1.0;  else if (lsf < 1.0) lsf += 1.0;
  ((PREPE)rp)->csf = iround(csf * 1000.0);
  ((PREPE)rp)->lsf = iround(lsf * 1000.0);
}

REAL WINAPI SpacingFactorC(HREP rp)
{ // Ԓ{
  return ((PREPE)rp)->csf * 0.001;
}

REAL WINAPI SpacingFactorL(HREP rp)
{ // ssb`{
  return ((PREPE)rp)->lsf * 0.001;
}

PWHSZ WINAPI SpaceSize(PWHSZ sz, HREP rp)
{ // ԒAssb`
  sz->w = (((PCVSE)rp)->tch * ((PREPE)rp)->csf * 0.001) * 0.001;
  sz->h = (((PCVSE)rp)->tch * ((PREPE)rp)->lsf * 0.001) * 0.001;
  return sz;
}

typedef struct {
  char  tag[4];
  char  tfa[32];
  int   tch, tst;
  BGRC  tco;
  int   bph, aph;
  int   tal, fiw;
  int   liw, riw;
} PFME;
typedef PFME * PPFME;
  // iAtHg
typedef struct {
  PPFME pf;
  int   ni;
} PFMM;
typedef PFMM * PPFMM;

static PFME FMTI[32];
static PFMM FMTS = { FMTI, NELEM(FMTI) };

int  LOCALF PFmtID(PCSTR tag)
{ // iT[`
  int i;

  for (i = 0; i < FMTS.ni; i++) {
    if (*(WORD *)tag == *(WORD *)FMTS.pf[i].tag) return i;
  }
  return -1;
}

BOOL WINAPI RegisterParagraphFormat(int id, PCSTR tag, PCPFMI fi)
{ // i̓o^
  PPFME pf;

  if ((UINT)id >= (UINT)FMTS.ni) {
    if (tag) id = PFmtID(tag);
    if (id < 0) return FALSE;
  }
  pf = &FMTS.pf[id];
  if (tag) *(WORD *)&pf->tag = *(WORD *)tag;
  if (fi) {
    if (fi->face) strcpyx(pf->tfa, fi->face, sizeof(pf->tfa) - 1);
    if (fi->ch > 0.0) pf->tch = iround(fi->ch * 1000.0);
    pf->tst = fi->flg &~0x0f;
    pf->tco = fi->col;
    pf->bph = iround(fi->bph * 1000.0);
    pf->aph = iround(fi->aph * 1000.0);
    pf->tal = fi->flg & 0x0f;
    pf->fiw = iround(fi->fiw * 1000.0);
    pf->liw = iround(fi->liw * 1000.0);
    pf->riw = iround(fi->riw * 1000.0);
  }
  return TRUE;
}

REAL WINAPI ParagraphSpacingB(HREP rp)
{ // iOXy[X
  return ((PREPE)rp)->bph * 0.001;
}

REAL WINAPI ParagraphSpacingA(HREP rp)
{ // iXy[X
  return ((PREPE)rp)->aph * 0.001;
}

int  WINAPI ParagraphAlignment(HREP rp)
{ // 
  return ((PREPE)rp)->tal;
}

REAL WINAPI ParagraphIndentationF(HREP rp)
{ // ŏ̍s̃Cfg
  return ((PREPE)rp)->fiw * 0.001;
}

REAL WINAPI ParagraphIndentationL(HREP rp)
{ // Cfg
  return ((PREPE)rp)->liw * 0.001;
}

REAL WINAPI ParagraphIndentationR(HREP rp)
{ // ECfg
  return ((PREPE)rp)->riw * 0.001;
}

void WINAPI SetFlowTextStatus(HREP rp, int sta)
{ // ԃtOݒ
  ((PREPE)rp)->sta = sta;
}

int  WINAPI FlowTextStatus(HREP rp)
{ // ԃtO
  return ((PREPE)rp)->sta;
}

void WINAPI StartFlowText(HREP rp)
{ // Jn
  memset(FMTS.pf, 0, FMTS.ni * sizeof(PFME));
  strcpyx(FMTS.pf[0].tfa, MONFACE, sizeof(FMTS.pf[0].tfa) - 1);
  FMTS.pf[0].tch = iround(PT2MM(DLGPTSZ) * 1000.0);
  ((PREPE)rp)->pid = ((PREPE)rp)->cid = 0;
  ((PREPE)rp)->sta = STA_PAR|STA_LIN;
}

  // ^Ovf
static FTEI TAGI[32];
static FTES TAGS = { TAGI, NELEM(TAGI) };

BOOL WINAPI RegisterFlowTextTags(PCFTES ps)
{ // ݃eLXg̃^Ovf̓o^
  int i;

  for (i = 0; i < TAGS.ni; i++) {
    if (!TAGS.pi[i].nam) break;
  }
  if (ps->ni >= TAGS.ni - i) return (BOOL)ierr(E_CAP);
  memcpy(&TAGS.pi[i], ps->pi, ps->ni * sizeof(FTEI));
  return TRUE;
}

BOOL LOCALF ReadPTag(HREP rp, PCSTR *pp)
{ // i^OǍ
  int i;

  if (*(WORD *)*pp != *(WORD *)LBRA) return FALSE;
  start(*pp + 2);
  if (token_is(TKN_IDN)) {
    for (i = 0; i < TAGS.ni; i++) {
      if (!strcmp(TAGS.pi[i].nam, buf()) && TAGS.pi[i].fpar) {
        *pp = cpos(); TAGS.pi[i].fpar(rp, pp); return TRUE;
      }
    }
  }
  CloseBrackets(pp, TRUE);
  return TRUE;
}

void LOCALF SetPFmt(HREP rp, int id)
{ // iݒ
  PPFME pf = &FMTS.pf[id];

  ((PREPE)rp)->pid = ((PREPE)rp)->cid = id;
  SetTextFont(rp, pf->tfa, pf->tch * 0.001, pf->tst, pf->tco);
  ((PREPE)rp)->bph = pf->bph; ((PREPE)rp)->aph = pf->aph;
  ((PREPE)rp)->tal = pf->tal; ((PREPE)rp)->fiw = pf->fiw;
  ((PREPE)rp)->liw = pf->liw; ((PREPE)rp)->riw = pf->riw;
}

void LOCALF ReadPFmt(HREP rp, PCSTR *pp)
{ // iwǍ
  int id;
  PCSTR pt = *pp;

  if (*pt == '\0' || *(WORD *)pt == CRLF || *(WORD *)pt == *(WORD *)LTAG || *(WORD *)pt == *(WORD *)PTAG) return;
  while (ReadPTag(rp, &pt)) ;
  if ((id = PFmtID(pt)) >= 0) {
    pt += 2;
  } else {
    id = 0;
  }
  SetPFmt(rp, id);
  *pp = pt;
}

BOOL LOCALF ReadCTag(HREP rp, PCSTR *pp, PCCELL pc, PWHSZ sz)
{ // ^OǍ
  int i;
  RECT rct;

  if (*(WORD *)*pp != *(WORD *)LBRA) return FALSE;
  sz->w = sz->h = 0.0;
  start(*pp + 2);
  if (token_is(TKN_IDN)) {
    for (i = 0; i < TAGS.ni; i++) {
      if (!strcmp(TAGS.pi[i].nam, buf()) && TAGS.pi[i].fchr) {
        *pp = cpos(); TAGS.pi[i].fchr(rp, pp, pc, sz); return TRUE;
      }
    }
  } else if (token_is(TKN_STR)) {
    if (pc && hDC(rp)) DrawText(hDC(rp), buf(), -1, c2dRect(&rct, rp, pc), DT2DT(((PREPE)rp)->tal &~0x03));
    TextSize(sz, rp, buf(), -1);
    *pp = cpos();
  }
  CloseBrackets(pp, FALSE);
  return TRUE;
}

void LOCALF SetCFmt(HREP rp, int id)
{ // tHgݒ
  PPFME pf = &FMTS.pf[id];

  ((PREPE)rp)->cid = id;
  SetTextFont(rp, pf->tfa, pf->tch * 0.001, pf->tst, pf->tco);
}

void LOCALF ReadCFmt(HREP rp, PCSTR *pp, PCCELL pc, PWHSZ sz)
{ // teLXgǍ^o
  int id;
  PCSTR st, pt = *pp;
  RECT rct;

  sz->w = sz->h = 0.0;
  if (*pt == '\0') {
    ((PREPE)rp)->sta = STA_END|STA_PAR|STA_LIN;
  } else if (*(WORD *)pt == CRLF || *(WORD *)pt == *(WORD *)LTAG) {
    pt += 2;
    ((PREPE)rp)->sta = STA_PAR|STA_LIN;
  } else if (*(WORD *)pt == *(WORD *)PTAG) {
    pt += 2;
    if (*(WORD *)pt == CRLF) pt += 2;
    ((PREPE)rp)->sta = STA_END|STA_PAR|STA_LIN;
  } else if (ReadCTag(rp, &pt, pc, sz)) {
    ;
  } else if ((id = PFmtID(pt)) >= 0) {
    pt += 2;
    SetCFmt(rp, id);
    SpaceSize(sz, rp);
  } else if (iszen(pt)) {
    st = pt;
    pt += 2;
    if (pc && hDC(rp)) DrawText(hDC(rp), st, 2, c2dRect(&rct, rp, pc), DT2DT(((PREPE)rp)->tal &~0x03));
    TextSize(sz, rp, st, 2);
  } else {
    st = isprn(*pt)? pt: "?";
    pt++;
    if (pc && hDC(rp)) DrawText(hDC(rp), st, 1, c2dRect(&rct, rp, pc), DT2DT(((PREPE)rp)->tal &~0x03));
    TextSize(sz, rp, st, 1);
  }
  *pp = pt;
}

void WINAPI FlowText(HREP rp, PCSTR *pp, PCCELL pc)
{ // `̈ւ̏teLXg
  int sw;
  PCSTR pr, pt = *pp;
  REAL xl, xr, yt, yb, wl, wr, rh;
  CELL cel;
  WHSZ c, r;

  xl = pc->x1 + CellMarginH(rp);
  xr = pc->x2 - CellMarginH(rp);
  yt = pc->y1 + CellMarginV(rp);
  yb = pc->y2 - CellMarginV(rp);
  for (((PREPE)rp)->sta &=~STA_END, cel.y1 = yt; !(((PREPE)rp)->sta & STA_END); cel.y1 = cel.y2) {
    pr = pt;
    sw = ((((PREPE)rp)->sta & STA_PAR) != 0);
    if (sw) ReadPFmt(rp, &pr);  else ((PREPE)rp)->pid = ((PREPE)rp)->cid;
    wl = xl + (sw? ((PREPE)rp)->fiw: ((PREPE)rp)->liw) * 0.001;
    wr = xr - ((PREPE)rp)->riw * 0.001;
    SpaceSize(&r, rp); rh = r.h;
    r.w = 0.0;
    ((PREPE)rp)->sta = 0;
    while (!(((PREPE)rp)->sta & STA_LIN)) {
      ReadCFmt(rp, &pr, NULL, &c);
      r.w += c.w; if (c.h > r.h) r.h = c.h;
      if (wl + r.w > wr - c.w && !IsKinsoku(pr)) ((PREPE)rp)->sta |= STA_LIN;
    }
    if (sw) ReadPFmt(rp, &pt);  else SetCFmt(rp, ((PREPE)rp)->pid);
    cel.x1 = wl;
    if      (((PREPE)rp)->tal & DT_RGT) cel.x1 += (wr - wl - r.w);
    else if (((PREPE)rp)->tal & DT_CEN) cel.x1 += (wr - wl - r.w) / 2;
    if (sw) cel.y1 += ((PREPE)rp)->bph * 0.001;
    cel.x2 = cel.x1 + r.h;
    cel.y2 = cel.y1 + r.h;
    ((PREPE)rp)->sta = 0;
    while (!(((PREPE)rp)->sta & STA_LIN)) {
      ReadCFmt(rp, &pt, &cel, &c);
      if (cel.x1 + c.w > wr - c.w && !IsKinsoku(pt)) ((PREPE)rp)->sta |= STA_LIN;
      else MoveCell(&cel, c.w, 0.0);
    }
    if (cel.y2 > yb - rh * 0.8) ((PREPE)rp)->sta |= STA_END;
    else if (((PREPE)rp)->sta & STA_PAR) cel.y2 += ((PREPE)rp)->aph * 0.001;
  }
  *pp = pt;
}

PPSDS WINAPI PageSetupInfo(HREP rp)
{ // pݒ
  return (PPSDS)&((PREPE)rp)->adj;
}

void WINAPI StartPrint(HREP rp, HDC hdc, int dpi)
{ // `Jn
  REAL sc, tm;

  SetCanvasHDC(rp, hdc, dpi);
  if (((PREPE)rp)->rsr == 0) {
    tm = now();
    ((PREPE)rp)->rsr = (int)tm;
    ((PREPE)rp)->rtm = (int)((tm - (int)tm) * 86400);
  }
  sc = (REAL)((PREPE)rp)->opw / (REAL)((PREPE)rp)->ppw;
  SetScale(rp, sc, sc);
  DisableCanvas(rp);
  ((PREPE)rp)->frep(rp, REPM_STARTPRINT, 0, ((PREPE)rp)->par);
  EnableCanvas(rp);
}

void WINAPI EndPrint(HREP rp)
{ // `I
  SetCanvasHDC(rp, NULL, 0);
  ((PREPE)rp)->frep(rp, REPM_ENDPRINT, 0, ((PREPE)rp)->par);
}

void WINAPI DrawPage(HREP rp, int pg)
{ // y[W`
  ((PREPE)rp)->frep(rp, REPM_DRAWPAGE, pg, ((PREPE)rp)->par);
}

void WINAPI SkipPage(HREP rp, int pg)
{ // y[WXLbv
  DisableCanvas(rp);
  ((PREPE)rp)->frep(rp, REPM_SKIPPAGE, pg, ((PREPE)rp)->par);
  EnableCanvas(rp);
}

BOOL WINAPI ReportSetup(HWND hwnd, HREP rp)
{ // f[^ݒ
  ((PREPE)rp)->hown = hwnd;
  return ((PREPE)rp)->frep(rp, REPM_SETUP, 0, ((PREPE)rp)->par);
}

BOOL WINAPI PageSetup(HWND hwnd, HREP rp)
{ // pݒ
  int re;

  re = PageSetupDlgBox(hwnd, (PPSDS)&((PREPE)rp)->adj);
  if (re) ((PREPE)rp)->frep(rp, REPM_PAGESETUP, 0, ((PREPE)rp)->par);
  return re;
}

static BOOL UBrk;
static HWND hAbortDlg;

BOOL LOCALF AbortDlgProc(HWND hdlg, UINT umsg, WPARAM wpa, LPARAM lpa)
{ // ~_CAOvV[W
  switch (umsg) {
  case WM_INITDIALOG:
    CenterWindow(hdlg, GetWindow(hdlg, GW_OWNER));
    return TRUE;
  case WM_COMMAND:
    switch (wpa) {
    case IDCANCEL:
      UBrk = TRUE;
      hAbortDlg = NULL;
      DestroyWindow(hdlg);
      return TRUE;
    }
    break;
  }
  return FALSE;
}

BOOL LOCALF AbortProc(HDC hdc, int er)
{ // ~֐
  MSG msg;

  while (!UBrk && PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
    if (!hAbortDlg || !IsDialogMessage(hAbortDlg, &msg)) {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }
  return !UBrk;
}

void LOCALF dmpaper(PPRDS ps, HREP rp)
{ // p̃TCYƌ
  int i, w, sz = 2;

  ps->ori = (((PREPE)rp)->oph >= ((PREPE)rp)->opw)? DMORIENT_PORTRAIT: DMORIENT_LANDSCAPE;
  w = (ps->ori == DMORIENT_PORTRAIT)? ((PREPE)rp)->opw / 1000: ((PREPE)rp)->oph / 1000;
  for (i = 0; i < NELEM(PAP); i++) {
    if (PAP[i].wid == w) { sz = i; break;}
  }
  switch (sz) {
  case 0: ps->psz = DMPAPER_A3; break;
  case 1: ps->psz = DMPAPER_B4; break;
  case 2: ps->psz = DMPAPER_A4; break;
  case 3: ps->psz = DMPAPER_B5; break;
  case 4: ps->psz = DMPAPER_A5; break;
  case 5: ps->psz = DMPAPER_B6_JIS; break;
  case 6: ps->psz = DMPAPER_A6; break;
  }
  ps->wid = (ps->ori == DMORIENT_PORTRAIT)? ((PREPE)rp)->opw / 100: ((PREPE)rp)->oph / 100;
  ps->len = (ps->ori == DMORIENT_PORTRAIT)? ((PREPE)rp)->oph / 100: ((PREPE)rp)->opw / 100;
}

BOOL WINAPI PrintReport(HWND hwnd, HREP rp)
{ // 
  int pg, i1, i2, ox, oy;
  PRDS prd;
  char bf[256];
  static DOCINFO dci = { sizeof(DOCINFO), };
  static DLGI dit[] = {
    { C_SCEN|wsG,   6, 20,148,  8, 101, "..." },
    { C_BDEF|wsGT,106, 44, 48, 14, IDCANCEL, "LZ" },
  };
  static DLGS dlg = { dit, NELEM(dit), 0, 0, 160, 64, "" };

  prd.flg = PD_NOSELECTION|PD_RETURNDC;
  prd.nf = prd.nc = 1;
  prd.np = prd.nt = (WORD)((PREPE)rp)->npg;
  dmpaper(&prd, rp);
  if (!PrintDlgBox(hwnd, &prd)) return FALSE;
  if (prd.flg & PD_PAGENUMS) {
    i1 = prd.nf; i2 = prd.nt;
  } else {
    i1 = 1; i2 = ((PREPE)rp)->npg;
  }
  dci.lpszDocName = ((PREPE)rp)->tit;
  UBrk = FALSE;
  hAbortDlg = CreateDlgBox(hwnd, &dlg, AbortDlgProc, 0);
  EnableWindow(hwnd, FALSE);
  SetAbortProc(prd.hdc, AbortProc);
  StartPrint(rp, prd.hdc, 0);
  if (StartDoc(prd.hdc, &dci) <= 0) goto _L1;
  ox = GetDeviceCaps(prd.hdc, PHYSICALOFFSETX);
  oy = GetDeviceCaps(prd.hdc, PHYSICALOFFSETY);
  for (pg = 1; pg <= i2; pg++) {
    if (pg >= i1) {
      if (StartPage(prd.hdc) <= 0) { AbortDoc(prd.hdc); goto _L1;}
      sprintf(bf, "%s   %d / %d y[W", ((PREPE)rp)->tit, pg, ((PREPE)rp)->npg);
      SetSSTR(hAbortDlg, 101, bf);
      SetWindowOrgEx(prd.hdc, 0, 0, NULL);
      SetViewportOrgEx(prd.hdc, -ox, -oy, NULL);
      DrawPage(rp, pg);
      if (EndPage(prd.hdc) <= 0 || !!UBrk) { AbortDoc(prd.hdc); goto _L1;}
    } else {
      SkipPage(rp, pg);
    }
  }
  EndDoc(prd.hdc); _L1:
  EndPrint(rp);
  DeleteDC(prd.hdc);
  EnableWindow(hwnd, TRUE);
  if (hAbortDlg) { DestroyWindow(hAbortDlg); hAbortDlg = NULL;}
  return TRUE;
}

// ---------------------------------------------------------------------- //

void LOCALF fi_DIB_BITS(PBYTE sp)
{ // DIB_BITS
  *(I4B *)sp = DIB_BITS(*(HDIB *)sp);
}

void LOCALF fi_DIB_WIDTH(PBYTE sp)
{ // DIB_WIDTH
  *(I4B *)sp = DIB_WIDTH(*(HDIB *)sp);
}

void LOCALF fi_DIB_HEIGHT(PBYTE sp)
{ // DIB_HEIGHT
  *(I4B *)sp = DIB_HEIGHT(*(HDIB *)sp);
}

void LOCALF fi_DIB_IMAGE(PBYTE sp)
{ // DIB_IMAGE
  *(P4B *)sp = DIB_IMAGE(*(HDIB *)sp);
}

void LOCALF fi_CreateDIB(PBYTE sp)
{ // CreateDIB
  *(P4B *)(sp + 8) = CreateDIB(*(I4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_CreateCompatibleDIB(PBYTE sp)
{ // CreateCompatibleDIB
  *(P4B *)sp = CreateCompatibleDIB(*(P4B *)sp);
}

void LOCALF fi_DuplicateDIB(PBYTE sp)
{ // DuplicateDIB
  *(P4B *)sp = DuplicateDIB(*(P4B *)sp);
}

void LOCALF fi_DeleteDIB(PBYTE sp)
{ // DeleteDIB
  DeleteDIB(*(P4B *)sp);
}

void LOCALF fi_MoveDIB(PBYTE sp)
{ // MoveDIB
  *(P4B *)(sp + 4) = MoveDIB(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_GetDIBSize(PBYTE sp)
{ // GetDIBSize
  *(P4B *)(sp + 4) = GetDIBSize(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_LoadDIB(PBYTE sp)
{ // LoadDIB
  *(P4B *)(sp + 4) = LoadDIB(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SaveDIB(PBYTE sp)
{ // SaveDIB
  *(I4B *)(sp + 4) = SaveDIB(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_TrimDIB(PBYTE sp)
{ // TrimDIB
  *(I4B *)(sp + 20) = TrimDIB(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12), *(I4B *)(sp + 16), *(U4B *)(sp + 20));
}

void LOCALF fi_PasteDIB(PBYTE sp)
{ // PasteDIB
  *(I4B *)(sp + 12) = PasteDIB(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_ResizeDIBX(PBYTE sp)
{ // ResizeDIBX
  *(I4B *)(sp + 12) = ResizeDIBX(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_ResizeDIB(PBYTE sp)
{ // ResizeDIB
  *(I4B *)(sp + 8) = ResizeDIB(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_InvertDIB(PBYTE sp)
{ // InvertDIB
  *(I4B *)(sp + 4) = InvertDIB(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_RotateDIB(PBYTE sp)
{ // RotateDIB
  *(I4B *)(sp + 12) = RotateDIB(*(P4B *)sp, *(F8B *)(sp + 4), *(U4B *)(sp + 12));
}

void LOCALF fi_SetXFMQ(PBYTE sp)
{ // SetXFMQ
  SetXFMQ(*(P4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12), *(I4B *)(sp + 16),
                    *(I4B *)(sp + 20), *(I4B *)(sp + 24), *(I4B *)(sp + 28), *(I4B *)(sp + 32));
}

void LOCALF fi_TransformDIB(PBYTE sp)
{ // TransformDIB
  *(I4B *)(sp + 8) = TransformDIB(*(P4B *)sp, *(P4B *)(sp + 4), *(U4B *)(sp + 8));
}

void LOCALF fi_ConvertDIB(PBYTE sp)
{ // ConvertDIB
  *(I4B *)(sp + 4) = ConvertDIB(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_LoadBMP(PBYTE sp)
{ // LoadBMP
  *(P4B *)(sp + 4) = LoadBMP(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SaveBMP(PBYTE sp)
{ // SaveBMP
  *(I4B *)(sp + 4) = SaveBMP(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_SetOrigin(PBYTE sp)
{ // SetOrigin
  SetOrigin(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12));
}

void LOCALF fi_OriginX(PBYTE sp)
{ // OriginX
  *(F8B *)(sp - 4) = OriginX(*(P4B *)sp);
}

void LOCALF fi_OriginY(PBYTE sp)
{ // OriginY
  *(F8B *)(sp - 4) = OriginY(*(P4B *)sp);
}

void LOCALF fi_SetScale(PBYTE sp)
{ // SetScale
  SetScale(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12));
}

void LOCALF fi_ScaleX(PBYTE sp)
{ // ScaleX
  *(F8B *)(sp - 4) = ScaleX(*(P4B *)sp);
}

void LOCALF fi_ScaleY(PBYTE sp)
{ // ScaleY
  *(F8B *)(sp - 4) = ScaleY(*(P4B *)sp);
}

void LOCALF fi_SetCell(PBYTE sp)
{ // SetCell
  *(P4B *)(sp + 32) = SetCell(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(F8B *)(sp + 28));
}

void LOCALF fi_MoveCell(PBYTE sp)
{ // MoveCell
  *(P4B *)(sp + 16) = MoveCell(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12));
}

void LOCALF fi_ResizeCell(PBYTE sp)
{ // ResizeCell
  *(P4B *)(sp + 16) = ResizeCell(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12));
}

void LOCALF fi_ReshapeCell(PBYTE sp)
{ // ReshapeCell
  *(P4B *)(sp + 32) = ReshapeCell(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(F8B *)(sp + 28));
}

void LOCALF fi_SetCellMargin(PBYTE sp)
{ // SetCellMargin
  SetCellMargin(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12));
}

void LOCALF fi_CellMarginH(PBYTE sp)
{ // CellMarginH
  *(F8B *)(sp - 4) = CellMarginH(*(P4B *)sp);
}

void LOCALF fi_CellMarginV(PBYTE sp)
{ // CellMarginV
  *(F8B *)(sp - 4) = CellMarginV(*(P4B *)sp);
}

void LOCALF fi_SetLineStyle(PBYTE sp)
{ // SetLineStyle
  *(I4B *)(sp + 4) = SetLineStyle(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetLineColor(PBYTE sp)
{ // SetLineColor
  *(I4B *)(sp + 4) = SetLineColor(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_SetTextFont(PBYTE sp)
{ // SetTextFont
  SetTextFont(*(P4B *)sp, *(P4B *)(sp + 4), *(F8B *)(sp + 8), *(I4B *)(sp + 16), *(I4B *)(sp + 20));
}

void LOCALF fi_SetTextStyle(PBYTE sp)
{ // SetTextStyle
  SetTextStyle(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(P4B *)(sp + 28));
}

void LOCALF fi_TextSize(PBYTE sp)
{ // TextSize
  *(P4B *)(sp + 12) = TextSize(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_AveCharSize(PBYTE sp)
{ // AveCharSize
  *(P4B *)(sp + 4) = AveCharSize(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_ZenCharSize(PBYTE sp)
{ // ZenCharSize
  *(P4B *)(sp + 4) = ZenCharSize(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_DrawLine(PBYTE sp)
{ // DrawLine
  DrawLine(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(F8B *)(sp + 28));
}

void LOCALF fi_DrawCirc(PBYTE sp)
{ // DrawCirc
  DrawCirc(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(F8B *)(sp + 28), *(F8B *)(sp + 36));
}

void LOCALF fi_RST(PBYTE sp)
{ // RST
  *(I4B *)(sp + 12) = RST(*(I4B *)sp, *(I4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_DrawCell(PBYTE sp)
{ // DrawCell
  DrawCell(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8));
}

void LOCALF fi_FillCell(PBYTE sp)
{ // FillCell
  FillCell(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_FillPoly(PBYTE sp)
{ // FillPoly
  FillPoly(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_FillCirc(PBYTE sp)
{ // FillCirc
  FillCirc(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(F8B *)(sp + 28), *(F8B *)(sp + 36), *(I4B *)(sp + 44));
}

void LOCALF fi_CellText(PBYTE sp)
{ // CellText
  CellText(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_VCellText(PBYTE sp)
{ // VCellText
  VCellText(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_SetGrid0(PBYTE sp)
{ // SetGrid0
  SetGrid0(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(I4B *)(sp + 20), *(I4B *)(sp + 24), *(F8B *)(sp + 28), *(F8B *)(sp + 36));
}

void LOCALF fi_SetGrid1(PBYTE sp)
{ // SetGrid1
  SetGrid1(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(I4B *)(sp + 20), *(I4B *)(sp + 24), *(P4B *)(sp + 28), *(F8B *)(sp + 32));
}

void LOCALF fi_SetGrid2(PBYTE sp)
{ // SetGrid2
  SetGrid2(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(I4B *)(sp + 20), *(I4B *)(sp + 24), *(F8B *)(sp + 28), *(P4B *)(sp + 36));
}

void LOCALF fi_SetGrid3(PBYTE sp)
{ // SetGrid3
  SetGrid3(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(I4B *)(sp + 20), *(I4B *)(sp + 24), *(P4B *)(sp + 28), *(P4B *)(sp + 32));
}

void LOCALF fi_GridCell(PBYTE sp)
{ // GridCell
  *(P4B *)(sp + 12) = GridCell(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_DrawGridCell(PBYTE sp)
{ // DrawGridCell
  DrawGridCell(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12), *(I4B *)(sp + 16));
}

void LOCALF fi_GridCellText(PBYTE sp)
{ // GridCellText
  GridCellText(*(P4B *)sp, *(P4B *)(sp + 4), *(I4B *)(sp + 8), *(I4B *)(sp + 12), *(I4B *)(sp + 16), *(P4B *)(sp + 20), *(I4B *)(sp + 24));
}

void LOCALF fi_SetStamp0(PBYTE sp)
{ // SetStamp0
  SetStamp0(*(P4B *)sp, *(F8B *)(sp + 4), *(P4B *)(sp + 12));
}

void LOCALF fi_SetStamp1(PBYTE sp)
{ // SetStamp1
  SetStamp1(*(P4B *)sp, *(F8B *)(sp + 4), *(P4B *)(sp + 12));
}

void LOCALF fi_SetStamp2(PBYTE sp)
{ // SetStamp2
  SetStamp2(*(P4B *)sp, *(F8B *)(sp + 4), *(P4B *)(sp + 12), *(P4B *)(sp + 16));
}

void LOCALF fi_SetStamp3(PBYTE sp)
{ // SetStamp3
  SetStamp3(*(P4B *)sp, *(F8B *)(sp + 4), *(P4B *)(sp + 12), *(P4B *)(sp + 16), *(P4B *)(sp + 20));
}

void LOCALF fi_CellStamp(PBYTE sp)
{ // CellStamp
  CellStamp(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_CellImage(PBYTE sp)
{ // CellImage
  CellImage(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12));
}

void LOCALF fi_OkBox(PBYTE sp)
{ // OkBox
  *(I4B *)(sp + 8) = OkBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_OkCanBox(PBYTE sp)
{ // OkCanBox
  *(I4B *)(sp + 8) = OkCanBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_YesNoBox(PBYTE sp)
{ // YesNoBox
  *(I4B *)(sp + 8) = YesNoBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_YesNoCanBox(PBYTE sp)
{ // YesNoCanBox
  *(I4B *)(sp + 8) = YesNoCanBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_ErrorBox(PBYTE sp)
{ // ErrorBox
  *(I4B *)(sp + 8) = ErrorBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_WarningBox(PBYTE sp)
{ // WarningBox
  *(I4B *)(sp + 8) = WarningBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_AlertBox(PBYTE sp)
{ // AlertBox
  *(I4B *)(sp + 8) = AlertBox(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8));
}

void LOCALF fi_hWND(PBYTE sp)
{ // hWND
  *(P4B *)sp = hWND(*(P4B *)sp);
}

void LOCALF fi_SetReportInfo(PBYTE sp)
{ // SetReportInfo
  SetReportInfo(*(P4B *)sp, *(P4B *)(sp + 4), *(P4B *)(sp + 8), *(I4B *)(sp + 12), *(I4B *)(sp + 16));
}

void LOCALF fi_ReportTitle(PBYTE sp)
{ // ReportTitle
  *(P4B *)sp = (P4B)ReportTitle(*(P4B *)sp);
}

void LOCALF fi_ReportAuthor(PBYTE sp)
{ // ReportAuthor
  *(P4B *)sp = (P4B)ReportAuthor(*(P4B *)sp);
}

void LOCALF fi_ReportDate(PBYTE sp)
{ // ReportDate
  *(I4B *)sp = ReportDate(*(P4B *)sp);
}

void LOCALF fi_ReportTime(PBYTE sp)
{ // ReportTime
  *(I4B *)sp = ReportTime(*(P4B *)sp);
}

void LOCALF fi_SetReportExtra(PBYTE sp)
{ // SetReportExtra
  SetReportExtra(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_ReportExtra(PBYTE sp)
{ // ReportExtra
  *(I4B *)sp = ReportExtra(*(P4B *)sp);
}

void LOCALF fi_SetNPages(PBYTE sp)
{ // SetNPages
  SetNPages(*(P4B *)sp, *(I4B *)(sp + 4));
}

void LOCALF fi_NPages(PBYTE sp)
{ // NPages
  *(I4B *)sp = NPages(*(P4B *)sp);
}

void LOCALF fi_SetPaperSize(PBYTE sp)
{ // SetPaperSize
  SetPaperSize(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20));
}

void LOCALF fi_PaperWidth(PBYTE sp)
{ // PaperWidth
  *(F8B *)(sp - 4) = PaperWidth(*(P4B *)sp);
}

void LOCALF fi_PaperHeight(PBYTE sp)
{ // PaperHeight
  *(F8B *)(sp - 4) = PaperHeight(*(P4B *)sp);
}

void LOCALF fi_SetPageSize(PBYTE sp)
{ // SetPageSize
  SetPageSize(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12));
}

void LOCALF fi_PageWidth(PBYTE sp)
{ // PageWidth
  *(F8B *)(sp - 4) = PageWidth(*(P4B *)sp);
}

void LOCALF fi_PageHeight(PBYTE sp)
{ // PageHeight
  *(F8B *)(sp - 4) = PageHeight(*(P4B *)sp);
}

void LOCALF fi_PageLeft(PBYTE sp)
{ // PageLeft
  *(F8B *)(sp - 4) = PageLeft(*(P4B *)sp);
}

void LOCALF fi_PageTop(PBYTE sp)
{ // PageTop
  *(F8B *)(sp - 4) = PageTop(*(P4B *)sp);
}

void LOCALF fi_PageRight(PBYTE sp)
{ // PageRight
  *(F8B *)(sp - 4) = PageRight(*(P4B *)sp);
}

void LOCALF fi_PageBottom(PBYTE sp)
{ // PageBottom
  *(F8B *)(sp - 4) = PageBottom(*(P4B *)sp);
}

void LOCALF fi_SetPageMargin(PBYTE sp)
{ // SetPageMargin
  SetPageMargin(*(P4B *)sp, *(F8B *)(sp + 4), *(F8B *)(sp + 12), *(F8B *)(sp + 20), *(F8B *)(sp + 28));
}

void LOCALF fi_BodyWidth(PBYTE sp)
{ // BodyWidth
  *(F8B *)(sp - 4) = BodyWidth(*(P4B *)sp);
}

void LOCALF fi_BodyHeight(PBYTE sp)
{ // BodyHeight
  *(F8B *)(sp - 4) = BodyHeight(*(P4B *)sp);
}

void LOCALF fi_BodyLeft(PBYTE sp)
{ // BodyLeft
  *(F8B *)(sp - 4) = BodyLeft(*(P4B *)sp);
}

void LOCALF fi_BodyTop(PBYTE sp)
{ // BodyTop
  *(F8B *)(sp - 4) = BodyTop(*(P4B *)sp);
}

void LOCALF fi_BodyRight(PBYTE sp)
{ // BodyRight
  *(F8B *)(sp - 4) = BodyRight(*(P4B *)sp);
}

void LOCALF fi_BodyBottom(PBYTE sp)
{ // BodyBottom
  *(F8B *)(sp - 4) = BodyBottom(*(P4B *)sp);
}

void LOCALF fi_SetHeaderHeight(PBYTE sp)
{ // SetHeaderHeight
  SetHeaderHeight(*(P4B *)sp, *(F8B *)(sp + 4));
}

void LOCALF fi_SetFooterHeight(PBYTE sp)
{ // SetFooterHeight
  SetFooterHeight(*(P4B *)sp, *(F8B *)(sp + 4));
}

void LOCALF fi_HeaderHeight(PBYTE sp)
{ // HeaderHeight
  *(F8B *)(sp - 4) = HeaderHeight(*(P4B *)sp);
}

void LOCALF fi_HeaderTop(PBYTE sp)
{ // HeaderTop
  *(F8B *)(sp - 4) = HeaderTop(*(P4B *)sp);
}

void LOCALF fi_FooterHeight(PBYTE sp)
{ // FooterHeight
  *(F8B *)(sp - 4) = FooterHeight(*(P4B *)sp);
}

void LOCALF fi_FooterBottom(PBYTE sp)
{ // FooterBottom
  *(F8B *)(sp - 4) = FooterBottom(*(P4B *)sp);
}

void LOCALF fi_SetReqBodyWidth(PBYTE sp)
{ // SetReqBodyWidth
  SetReqBodyWidth(*(P4B *)sp, *(F8B *)(sp + 4), *(I4B *)(sp + 12));
}

void LOCALF fi_ReqBodyWidth(PBYTE sp)
{ // ReqBodyWidth
  *(F8B *)(sp - 4) = ReqBodyWidth(*(P4B *)sp);
}

void LOCALF fi_PageCell(PBYTE sp)
{ // PageCell
  *(P4B *)(sp + 4) = PageCell(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_BodyCell(PBYTE sp)
{ // BodyCell
  *(P4B *)(sp + 4) = BodyCell(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_HeaderCell(PBYTE sp)
{ // HeaderCell
  *(P4B *)(sp + 4) = HeaderCell(*(P4B *)sp, *(P4B *)(sp + 4));
}

void LOCALF fi_FooterCell(PBYTE sp)
{ // FooterCell
  *(P4B *)(sp + 4) = FooterCell(*(P4B *)sp, *(P4B *)(sp + 4));
}

static BFNC fiFRO[] = {
  fi_DIB_BITS,
  fi_DIB_WIDTH,
  fi_DIB_HEIGHT,
  fi_DIB_IMAGE,
  fi_CreateDIB,
  fi_CreateCompatibleDIB,
  fi_DuplicateDIB,
  fi_DeleteDIB,
  fi_MoveDIB,
  fi_GetDIBSize,

  fi_LoadDIB,
  fi_SaveDIB,
  fi_TrimDIB,
  fi_PasteDIB,
  fi_ResizeDIBX,
  fi_ResizeDIB,
  fi_InvertDIB,
  fi_RotateDIB,
  fi_SetXFMQ,
  fi_TransformDIB,
  fi_ConvertDIB,

  fi_LoadBMP,
  fi_SaveBMP,

  fi_SetOrigin,
  fi_OriginX,
  fi_OriginY,
  fi_SetScale,
  fi_ScaleX,
  fi_ScaleY,
  fi_SetCell,
  fi_MoveCell,
  fi_ResizeCell,
  fi_ReshapeCell,
  fi_SetCellMargin,
  fi_CellMarginH,
  fi_CellMarginV,
  fi_SetLineStyle,
  fi_SetLineColor,
  fi_SetTextFont,
  fi_SetTextStyle,
  fi_TextSize,
  fi_AveCharSize,
  fi_ZenCharSize,
  fi_DrawLine,
  fi_DrawCirc,
  fi_RST,
  fi_DrawCell,
  fi_FillCell,
  fi_FillPoly,
  fi_FillCirc,
  fi_CellText,
  fi_VCellText,
  fi_SetGrid0,
  fi_SetGrid1,
  fi_SetGrid2,
  fi_SetGrid3,
  fi_GridCell,
  fi_DrawGridCell,
  fi_GridCellText,
  fi_SetStamp0,
  fi_SetStamp1,
  fi_SetStamp2,
  fi_SetStamp3,
  fi_CellStamp,
  fi_CellImage,

  fi_OkBox,
  fi_OkCanBox,
  fi_YesNoBox,
  fi_YesNoCanBox,
  fi_ErrorBox,
  fi_WarningBox,
  fi_AlertBox,

  fi_hWND,
  fi_SetReportInfo,
  fi_ReportTitle,
  fi_ReportAuthor,
  fi_ReportDate,
  fi_ReportTime,
  fi_SetReportExtra,
  fi_ReportExtra,
  fi_SetNPages,
  fi_NPages,
  fi_SetPaperSize,
  fi_PaperWidth,
  fi_PaperHeight,
  fi_SetPageSize,
  fi_PageWidth,
  fi_PageHeight,
  fi_PageLeft,
  fi_PageTop,
  fi_PageRight,
  fi_PageBottom,
  fi_SetPageMargin,
  fi_BodyWidth,
  fi_BodyHeight,
  fi_BodyLeft,
  fi_BodyTop,
  fi_BodyRight,
  fi_BodyBottom,
  fi_SetHeaderHeight,
  fi_SetFooterHeight,
  fi_BodyWidth, // HeaderWidth
  fi_HeaderHeight,
  fi_BodyLeft,  // HeaderLeft
  fi_HeaderTop,
  fi_BodyRight, // HeaderRight
  fi_BodyTop,   // HeaderBottom
  fi_BodyWidth, // FooterWidth
  fi_FooterHeight,
  fi_BodyLeft,  // FooterLeft
  fi_BodyBottom,// FooterTop
  fi_BodyRight, // FooterRight
  fi_FooterBottom,
  fi_SetReqBodyWidth,
  fi_ReqBodyWidth,
  fi_PageCell,
  fi_BodyCell,
  fi_HeaderCell,
  fi_FooterCell,
};
static BFNS fsFRO = { fiFRO, NELEM(fiFRO) };

UINT WINAPI BOLFROVer(void)
{ // o[W
  static BYTE ver[4] = { MODVER }; return *(PUINT)ver;
}

BOOL WINAPI InitBOLFRO(UINT pa)
{ // Jn
  override_error_handler(AltErrorBox, NULL);
  InitGraphicObjects();
  RegisterBOLTIPClass(NULL);
  RegisterBOLTOBClass(NULL);
  RegisterBOLSTBClass(NULL);
  RegisterAPIs(&fsFRO);
  return TRUE;
}

void WINAPI TermBOLFRO(void)
{ // I
  TermGraphicObjects();
}

// ---------------------------------------------------------------------- //
